@echo off
REM
REM BEGIN COPYRIGHT
REM *************************************************************************
REM Licensed Materials - Property of IBM 
REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
REM (C) Copyright IBM Corporation 2006.2008, 2009. All rights reserved. 
REM US Government Users Restricted Rights - Use, duplication, or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.
REM *************************************************************************
REM END COPYRIGHT

setlocal

@REM echo.
@REM echo Start Business Space Converting Server To Cluster Script
@REM echo.

GOTO Loop

:USAGE
  echo.
  echo  convertServerToCluster -dmgrHome ^<dmgr home path^> -nodeName ^<node name^>
  echo                    -serverName ^<server name^> -clusterName ^<cluster name^>
  echo.
  echo  where:  
  echo.
  echo   -dmgrHome ^<dmgr home path^>:
  echo       The dmgr profile path
  echo.
  echo   -nodeName ^<node name^>:
  echo       The name of node
  echo.
  echo   -serverName ^<server name^>:
  echo      The name of server
  echo.
  echo   -clusterName ^<cluster name^>:
  echo      the name of cluster
  echo.    
  GOTO DONE  
  
  
@REM #######################################################
@REM #                                                     #
@REM # Read command line options                           #
@REM #                                                     #
@REM #######################################################
:Loop
IF "%1" == "" GOTO Continue
IF "%1" == "-dmgrHome" (
  set dmgrHome=%2
  GOTO Forward
)
IF "%1" == "-nodeName" (
  set nodeName=%2
  GOTO Forward
)
IF "%1" == "-serverName" (
  set serverName=%2
  GOTO Forward
)
IF "%1" == "-clusterName" (
  set clusterName=%2
  GOTO Forward
)

echo ERROR: Invalid parameter: %1
GOTO USAGE

:Forward
shift /1
shift /1
GOTO Loop
:Continue

@REM #######################################################
@REM #                                                     #
@REM # Validate parameters                                 #
@REM #                                                     #
@REM #######################################################

IF %dmgrHome%. == . (
  echo ERROR: Missing or invalid parameter: dmgrHome
  echo Command example : 
  echo convertServerToCluster.bat -dmgrHome DMGRProfile01 -nodeName node1 -serverName server1 -clusterName cluster1
  GOTO DONE
)
@REM echo dmgrHome=%dmgrHome%

IF %serverName%. == . (
  echo ERROR: Missing or invalid parameter: serverName
  echo Command example : 
  echo convertServerToCluster.bat -dmgrHome DMGRProfile01 -nodeName node1 -serverName server1 -clusterName cluster1
  GOTO DONE
)
  
IF %nodeName%. == . (
  echo ERROR: Missing or invalid parameter: nodeName
  echo Command example : 
  echo convertServerToCluster.bat -dmgrHome DMGRProfile01 -nodeName node1 -serverName server1 -clusterName cluster1
  GOTO DONE
)

IF %clusterName%. == . (
  echo ERROR: Missing or invalid parameter: clusterName
  echo Command example : 
  echo convertServerToCluster.bat -dmgrHome DMGRProfile01 -nodeName node1 -serverName server1 -clusterName cluster1
  GOTO DONE
)

set CUR_DIR=%cd%
cd /d "%~dp0\..\.."
set WASHOME=%cd%
set WASHOME=%WASHOME:\=/%
cd /d "%CUR_DIR%"

call "%dmgrHome%\bin\setupCmdLine.bat"

call "%dmgrHome%\bin\wsadmin.bat" -connType NONE -f "%CUR_DIR%\convertServerToCluster.py" %dmgrHome% %nodeName% %serverName% %clusterName%

REM For WPS/WESB only
REM call "%dmgrHome%\bin\wsadmin.bat" -connType NONE -f "%CUR_DIR%\updateBPMAdministrationWidgets.py" %dmgrHome% %nodeName% %serverName% %clusterName%

echo Business Space Converting Server To Cluster was completed.

endlocal
:DONE
@REM echo "Done"
endlocal
@echo on

