#!/bin/sh

#############################################################################
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2009. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#############################################################################

echo ""
echo "Start Business Space Converting Server To Cluster Script"
echo ""

#######################################################
#                                                     #
# Subroutine: Usage                                   #
#                                                     #
#######################################################
usage () {
  echo  ""
  echo  "convertServerToCluster -dmgrHome <dmgr home path> -nodeName <node name>"
  echo 	"                  -serverName <server name> -clusterName  <clusterName name>"
  echo  ""
  echo  "where: " 
  echo  ""
  echo  "-dmgrHome <dmgr home path>:"
  echo  "    The dmgr profile path"
  echo  ""
  echo  "-nodeName <node name>:"
  echo  "	   The name of node"
  echo  ""
  echo  "-serverName <server name>:"
  echo  "    The name of server"
  echo  ""
  echo  "-clusterName <cluster name>:"
  echo  "    The name of cluster"
  exit
 }   
  

#######################################################
#                                                     #
# Read command line options                           #
#                                                     #
#######################################################

if [ $# -ne 8 ]; then
  usage  
fi
  
while [ $# -gt 0 ]; do
  case $1 in
    -dmgrHome) dmgrHome=$2; shift; shift;;
	  -nodeName) nodeName=$2; shift; shift;;
	  -serverName) serverName=$2; shift; shift;;
	  -clusterName) clusterName=$2; shift; shift;;
    -h) usage;;
    -help) usage;;
    *) echo "Invalid parameter: $1"; usage;;
  esac;
done

#######################################################
#                                                     #
# call convertServerToCluster.py                      #
#                                                     #
#######################################################

"$dmgrHome/bin/wsadmin.sh" -connType NONE -f "$CUR_DIR/upgradeBSpaceProfile.py" "$dmgrHome" $nodeName $serverName $clusterName

echo "Business Space Converting Server To Cluster was completed."
