# Licensed Materials - Property of IBM                              
#                                                                   
# 5724-M24                                                         
#                                                                   
# Copyright IBM Corp. 2009,2010  All Rights Reserved.                    
#                                                                   
# US Government Users Restricted Rights - Use, duplication or       
# disclosure restricted by GSA ADP Schedule Contract with           
# IBM Corp.                          
#

security = AdminConfig.list('Security')
if (AdminConfig.showAttribute(security,"enabled") != 'true'):
	print "Failed to create super user, for administrative security was not enabled."
	sys.exit(0)

try:	

	if ((len(sys.argv) != 2)):
        	raise ValueError, "Invalid parameters. This script requires 2 parameters: userId and password\n" \
        	"e.g.: createSuperUser.py userId password"

	if ((len(sys.argv[0]) < 1)):
        	raise ValueError, "Invalid userId.\n" \
        	"Please, make sure userId does not contain special characters."    
	if ((len(sys.argv[1]) < 1)):
        	raise ValueError, "Invalid password.\n" \
        	"Please, make sure password does not contain special characters."    

except ValueError, target:
	print target
	sys.exit(0)
	
userId = sys.argv[0]
password = sys.argv[1]

try:
	AdminTask.getUser('[-uniqueName uid=' + userId + ',o=defaultWIMFileBasedRealm]')
except:
	AdminTask.createUser('[-uid ' + userId + ' -password ' + password + ' -cn ' + userId + ' -sn ' + userId + ']')

try:
	AdminTask.getGroup('[-uniqueName cn=administrators,o=defaultWIMFileBasedRealm]')
except:
	AdminTask.createGroup('[-cn administrators -description "Business Space Administrators Group"]')

AdminTask.addMemberToGroup('[-memberUniqueName uid=' + userId + ',o=defaultWIMFileBasedRealm -groupUniqueName cn=administrators,o=defaultWIMFileBasedRealm]')

print 'assigned super user authority to ' + userId + ' successfully'
