@echo off
REM
REM BEGIN COPYRIGHT
REM *************************************************************************
REM Licensed Materials - Property of IBM 
REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
REM (C) Copyright IBM Corporation 2006.2008, 2009. All rights reserved. 
REM US Government Users Restricted Rights - Use, duplication, or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.
REM *************************************************************************
REM END COPYRIGHT

setlocal

@REM echo.
@REM echo Start Business Space Profile Upgrading Script
@REM echo.

GOTO Loop

:USAGE
  echo.
  echo  upgradeBSpaceProfile -profileName ^<profile name^> -nodeName ^<node name^>
  echo                    -serverName ^<server name^> -clusterName ^<cluster name^>
  echo.
  echo  where:  
  echo.
  echo   -profileName ^<profile name^>:
  echo       The name of profile you intend to upgrade
  echo.
  echo   -nodeName ^<node name^>:
  echo       The name of node
  echo.
  echo   -serverName ^<server name^>:
  echo      The name of server
  echo.
  echo   -clusterName ^<cluster name^>:
  echo      the name of cluster
  echo.    
  GOTO DONE  
  
  
@REM #######################################################
@REM #                                                     #
@REM # Read command line options                           #
@REM #                                                     #
@REM #######################################################
:Loop
IF "%1" == "" GOTO Continue
IF "%1" == "-profileName" (
  set profileName=%2
  GOTO Forward
)
IF "%1" == "-nodeName" (
  set nodeName=%2
  GOTO Forward
)
IF "%1" == "-serverName" (
  set serverName=%2
  GOTO Forward
)
IF "%1" == "-clusterName" (
  set clusterName=%2
  GOTO Forward
)

echo ERROR: Invalid parameter: %1
GOTO USAGE

:Forward
shift /1
shift /1
GOTO Loop
:Continue

@REM #######################################################
@REM #                                                     #
@REM # Validate parameters                                 #
@REM #                                                     #
@REM #######################################################

IF %profileName%. == . (
  echo ERROR: Missing or invalid parameter: profileName
  echo Command example : 
  echo upgradeBSpaceProfile.bat -profileName Profile01 -nodeName node1 -serverName server1
  echo Or
  echo upgradeBSpaceProfile.bat -profileName Profile01 -clusterName cluster1
  GOTO DONE
)
@REM echo profileName=%profileName%

IF %clusterName%. == . (
  IF %serverName%. == . (
    echo ERROR: Missing or invalid parameter: serverName, nodeName or clusterName
    echo Command example : 
    echo upgradeBSpaceProfile.bat -profileName Profile01 -nodeName node1 -serverName server1
    echo Or
    echo upgradeBSpaceProfile.bat -profileName Profile01 -clusterName cluster1
    GOTO DONE
  )
  IF %nodeName%. == . (
    echo ERROR: Missing or invalid parameter: serverName, nodeName or clusterName
    echo Command example : 
    echo upgradeBSpaceProfile.bat -profileName Profile01 -nodeName node1 -serverName server1
    echo Or
    echo upgradeBSpaceProfile.bat -profileName Profile01 -clusterName cluster1
    GOTO DONE
  )
)

IF %serverName%. == . (
  IF %clusterName%. == . (
    echo ERROR: Missing or invalid parameter: serverName, nodeName or clusterName
    echo Command example : 
    echo upgradeBSpaceProfile.bat -profileName Profile01 -nodeName node1 -serverName server1
    echo Or
    echo upgradeBSpaceProfile.bat -profileName Profile01 -clusterName cluster1
    GOTO DONE
  )
)

set CUR_DIR=%cd%
cd /d "%~dp0\..\.."
set WASHOME=%cd%
set WASHOME=%WASHOME:\=/%
cd /d "%CUR_DIR%"


IF NOT EXIST "%WASHOME%\bin\setupCmdLine.bat" set /p WASHOME=Please enter WAS home directory :

@REM echo "current dir is %CUR_DIR%" 

call "%WASHOME%\bin\setupCmdLine.bat"

IF %serverName%. == . (
  call "%WASHOME%\bin\wsadmin.bat" -connType NONE -profileName %profileName% -f "%CUR_DIR%\upgradeBSpaceProfile.py" "%WASHOME%" %clusterName%
)

IF %clusterName%. == . (
  call "%WASHOME%\bin\wsadmin.bat" -connType NONE -profileName %profileName% -f "%CUR_DIR%\upgradeBSpaceProfile.py" "%WASHOME%" %nodeName% %serverName%   
)

echo Business Space Profile Upgrading was completed.

endlocal
:DONE
@REM echo "Done"
endlocal
@echo on

