#!/bin/sh

#############################################################################
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2009. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#############################################################################

echo ""
echo "Start Business Space Profile Upgrading Script"
echo ""

#######################################################
#                                                     #
# Subroutine: Usage                                   #
#                                                     #
#######################################################
usage () {
  echo  ""
  echo  "upgradeBSpaceProfile -profileName <profile name> -nodeName <node name>"
  echo 	"                  -serverName <server name> -clusterName  <clusterName name>"
  echo  ""
  echo  "where: " 
  echo  ""
  echo  "-profileName <profile name>:"
  echo  "    The name of profile you intend to upgrade"
  echo  ""
  echo  "-nodeName <node name>:"
  echo  "	   The name of node"
  echo  ""
  echo  "-serverName <server name>:"
  echo  "    The name of server"
  echo  ""
  echo  "-clusterName <cluster name>:"
  echo  "    The name of cluster"
  exit
 }   
  

#######################################################
#                                                     #
# Read command line options                           #
#                                                     #
#######################################################

if [ $# -ne 6 ]; then
  if [ $# -ne 4 ]; then
    usage
  fi
fi
  
while [ $# -gt 0 ]; do
  case $1 in
    -profileName) profileName=$2; shift; shift;;
	  -nodeName) nodeName=$2; shift; shift;;
	  -serverName) serverName=$2; shift; shift;;
	  -clusterName) clusterName=$2; shift; shift;;
    -h) usage;;
    -help) usage;;
    *) echo "Invalid parameter: $1"; usage;;
  esac;
done

#######################################################
#                                                     #
# Set WAS environment                                 #
#                                                     #
#######################################################
CUR_DIR=`pwd`
SH_R_DIR=`dirname ${0}`
cd "$SH_R_DIR/../../"
WASHOME=`pwd`

cd $CUR_DIR

if [ -f $WASHOME/bin/setupCmdLine.sh ];then
	. "$WASHOME/bin/setupCmdLine.sh"
else
	echo "Please enter WAS Home directory: "
    read WASHOME
	. "$WASHOME/bin/setupCmdLine.sh"
fi


#######################################################
#                                                     #
# call upgradeBSpaceProfile.xml                       #
#                                                     #
#######################################################

if [ -z "$clusterName" ] ; then
  "$WASHOME/bin/wsadmin.sh" -connType NONE -profileName $profileName -f "$CUR_DIR/upgradeBSpaceProfile.py" "$WASHOME" $nodeName $serverName
fi

if [ -z "$serverName" ] ; then
  "$WASHOME/bin/wsadmin.sh" -connType NONE -profileName $profileName -f "$CUR_DIR/upgradeBSpaceProfile.py" "$WASHOME" $clusterName
fi

echo "Business Space Profile Upgrading was completed."
