-- Licensed Materials - Property of IBM
-- 5724-M24
-- Copyright IBM Corporation 2007, 2009.  All Rights Reserved.
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
----------------------------------------------------------------------
--
-- Script file to create tables for Business Space 7.0
--
-- Customize the following variables before running this script:
--   @STOGRP@ = DB2 Storage group name
--   @DB_NAME@ = DB2 Database name
--   @TSPRE@ = the prefix for tablespace names, e.g. BSP
--   @SCHEMA@ = DB2 Schema qualifier
--
-- BP8K0, BP16K0, and BP32 may require Grants as well as tailoring
-- BufferPool Names
-- Storage Group may require Grants 
--

------------- Tablespaces for Business Space

CREATE TABLESPACE @TSPRE@BS
  IN @DB_NAME@
  USING STOGROUP @STOGRP@
  SEGSIZE 32
  DEFINE NO
  LOCKSIZE ANY
  BUFFERPOOL @BPTABLE8K@
  CCSID UNICODE;

----------------------------------------------------------------------

CREATE LOB TABLESPACE @TSPRE@BB
 IN @DB_NAME@
 USING STOGROUP @STOGRP@
 LOCKSIZE LOB
 BUFFERPOOL @BPLOB4K@;


------------- Tables

	CREATE TABLE @SCHEMA@.BSP_USER_DATA_T
	(
	  USER_DN                   VARCHAR(1024)  NOT NULL ,
	  EXTENSION                 BLOB(10K) ,	
	  PRIMARY KEY ( USER_DN )
	) IN @DB_NAME@.@TSPRE@BS;
	
	-- Auxiliary table for BLOB column EXTENSION
	CREATE AUX TABLE @SCHEMA@.@TSPRE@BSBLOB2_T
   	IN @DB_NAME@.@TSPRE@BB
   	STORES @SCHEMA@.BSP_USER_DATA_T COLUMN
 	EXTENSION;
	-- Auxiliary index for BLOB column EXTENSION
	CREATE UNIQUE INDEX @SCHEMA@.@TSPRE@BSBLOB2_I
	  ON @SCHEMA@.@TSPRE@BSBLOB2_T
	   USING STOGROUP @STOGRP@
              BUFFERPOOL @BPINDEX@;
	
	-- Primary key for Table @SCHEMA@.BSP_USER_DATA_T
	CREATE UNIQUE INDEX
  	@SCHEMA@.BSP_USER_DATA_P ON
  	@SCHEMA@.BSP_USER_DATA_T
	( 
  	USER_DN
	) 
	USING STOGROUP @STOGRP@
              DEFINE NO
              BUFFERPOOL @BPINDEX@
              NOT PADDED;
