-- ***************************************************************** 
--                                                                   
-- Licensed Materials - Property of IBM                              
--                                                                   
-- 5724-U69                                                          
--                                                                   
-- Copyright IBM Corp. 2010  All Rights Reserved.                    
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
--                                                                   
-- ***************************************************************** 

CREATE BUFFERPOOL MASHUPS32KBP IMMEDIATE SIZE 8000 PAGESIZE 32K;
    
CREATE SYSTEM TEMPORARY TABLESPACE @TSPRE@TMPTP
    PAGESIZE 32K MANAGED BY SYSTEM 
    USING ( '@TSDIR@TMPTP' ) 
    EXTENTSIZE 16
    BUFFERPOOL MASHUPS32KBP
    FILE SYSTEM CACHING
;

CREATE REGULAR TABLESPACE @TSPRE@REGTP
    PAGESIZE 32K MANAGED BY SYSTEM
    USING ( '@TSDIR@REGTP' )
    EXTENTSIZE 16
    BUFFERPOOL MASHUPS32KBP
    NO FILE SYSTEM CACHING
;

----------------------------------------------------------------------------------
-- For improved performance on DB2 v9.x, you can instead use the following blocks:
----------------------------------------------------------------------------------
-- CREATE BUFFERPOOL MASHUPS32KBP IMMEDIATE SIZE 8000 AUTOMATIC PAGESIZE 32K;
--    
-- CREATE SYSTEM TEMPORARY TABLESPACE @TSPRE@TMPTP
--     PAGESIZE 32K MANAGED BY SYSTEM 
--     USING ( '@TSDIR@TMPTP' ) 
--     EXTENTSIZE 16
--     PREFETCHSIZE AUTOMATIC
--     BUFFERPOOL MASHUPS32KBP
--     FILE SYSTEM CACHING
-- ;
--
-- CREATE REGULAR TABLESPACE @TSPRE@REGTP
--     PAGESIZE 32K MANAGED BY SYSTEM
--     USING ( '@TSDIR@REGTP' )
--     EXTENTSIZE 16
--     PREFETCHSIZE AUTOMATIC
--     BUFFERPOOL MASHUPS32KBP
--     NO FILE SYSTEM CACHING
-- ;

