-- ***************************************************************** 
--                                                                   
-- Licensed Materials - Property of IBM                              
--                                                                   
-- 5724-U69                                                          
--                                                                   
-- Copyright IBM Corp. 2010  All Rights Reserved.                    
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
--                                                                   
-- ***************************************************************** 


-- MS SQL Script for creating Lotus Mashups database

-- Must input values for the datacontainers. For example, 
-- @DATAFILESPEC@ = <filepath>\MASHUPS_DATA1.mdf
-- @LOGFILESPEC@  = <fileath>\MASHUPS_LOG

CREATE DATABASE @DB_NAME@
  ON PRIMARY
  (NAME=MASHUPS_DATA, FILENAME='@TSDIR@DATAFILESPEC', SIZE=50MB, MAXSIZE=UNLIMITED, FILEGROWTH=10MB)
  LOG ON
  (NAME=MASHUPS_LOG, FILENAME='@TSDIR@LOGFILESPEC', SIZE=5MB, MAXSIZE=200MB, FILEGROWTH=5MB)
  --collate SQL_Latin1_General_BIN
  collate SQL_Latin1_General_CP1_CS_AS 
;

GO

-- could tokenize

-- CREATE DATABASE @LOTUSMASHUPS_DB@
--  ON PRIMARY
--  (NAME=MASHUPS_DATA, FILENAME='@DATAFILESPEC@', SIZE=50MB, MAXSIZE=UNLIMITED, FILEGROWTH=10MB)
--  LOG ON
--  (NAME=MASHUPS_LOG, FILENAME='@LOGFILESPEC@', SIZE=5MB, MAXSIZE=200MB, FILEGROWTH=5MB)
--  collate SQL_Latin1_General_BIN
--  --collate SQL_Latin1_General_CP1_CS_AS 

-- change transaction isolation level
USE @DB_NAME@;

ALTER DATABASE @DB_NAME@ SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
ALTER DATABASE @DB_NAME@ SET READ_COMMITTED_SNAPSHOT ON;
ALTER DATABASE @DB_NAME@ SET ALLOW_SNAPSHOT_ISOLATION ON;
ALTER DATABASE @DB_NAME@ SET MULTI_USER;
GO

-- could tokenize with MASHUPS replaced by @LOTUSMASHUPS_DB@
