/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.require("com.ibm.mashups.enabler.model");
dojo.require("com.ibm.mm.builder.utils.acModelUtil");
dojo.require("com.ibm.mm.builder.dnd.ACLSource");
dojo.require("com.ibm.mm.builder.dialog.ACLReassignDialog");
dojo.require("com.ibm.mm.builder.widget.OpenSearchDropdownMenu");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");


dojo.declare("com.ibm.mm.builder.accessControl",null,{

	iconImageUrl:      builderConfig.builderPath + "/images/sharepage/share_heading_icon.png",

	pageUpImageUrl:    builderConfig.builderPath + "/images/sharepage/page_up_control.png",
	pageDownImageUrl:  builderConfig.builderPath + "/images/sharepage/page_down_control.png",
	jumpUpImageUrl:    builderConfig.builderPath + "/images/sharepage/jump_to_top_control.png",
	jumpDownImageUrl:  builderConfig.builderPath + "/images/sharepage/jump_to_bottom_control.png",

	disabledPageUpImageUrl:    builderConfig.builderPath + "/images/sharepage/page_up_control_disabled.png",
	disabledPageDownImageUrl:  builderConfig.builderPath + "/images/sharepage/page_down_control_disabled.png",
	disabledJumpUpImageUrl:    builderConfig.builderPath + "/images/sharepage/jump_to_top_control_disabled.png",
	disabledJumpDownImageUrl:  builderConfig.builderPath + "/images/sharepage/jump_to_bottom_control_disabled.png",

	userModel:null,
	accessLevel:null,

	bottomDivId:null,
	searchInputId:null,
	filterInputId:null,

	viewList:null,
	personalizeList:null,
	editList:null,
	searchUsers:null,

	searchSource:null,
	
	highlightedColor:"#FFFFFF",
	selectedColor:"#0f4c9b",
	itemColor:"#252525",

	searchOption:"user",
	isOddOptionCick: false,
	searchOptionDiv: null,
	pageId:null,
	spaceId:null,
	searchDropDownMenu:null,
	searchType:com.ibm.mm.builder.ACLopenSearchType,
	tMenu:null,
	initialKeyword: "",
	
	_inPersonalSpace: true,
	_viewBlockCheckbox:null,
	_editBlockCheckbox:null,
	
	_pageSwitched: true,
	_currentContentPageID: null,
	_shareType: null,
	_shareTypeId: null,
	
	SHARE_PAGE:1,
	SHARE_SPACE:2,
	
	MAX_LEN:160,
	
	messageBox: null,
	
	cws: com.ibm.mm.builder.coreWidgetsStrings,
	
	constructor:function(){
		this.acModelUtil = com.ibm.mm.builder.utils.acModelUtil;
		this.searchUsers = new Array();
		dojo.subscribe(com.ibm.mm.builder.eventTopics.UpdateViewPageControl,   this, "updateViewPageControl"),
		//dojo.subscribe(com.ibm.mm.builder.eventTopics.UpdatePersonalizePageControl,   this, "updatePersonalizePageControl"),
		dojo.subscribe(com.ibm.mm.builder.eventTopics.UpdateEditPageControl,   this, "updateEditPageControl"),
		dojo.subscribe(com.ibm.mm.builder.eventTopics.UpdateSearchPageControl, this, "updateSearchPageControl"),
		dojo.subscribe(com.ibm.mm.builder.eventTopics.UpdateAllPageControl,    this, "updateAllPageControl")
		dojo.subscribe(com.ibm.mm.builder.eventTopics.AclDialogHide,this,"onACLDialogHide");
		this._connects = [];
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.accessControl");
	},
	
	onACLDialogHide:function(){
	},
	
	handleSharePage:function(iEvent) {
		var pageId = iEvent.payload;
		if (!pageId) {
			return;
		}
		//add logic here so if user click the share page at the second time, no request is needed
		this.pageId = pageId;
//		if (this._pageSwitched || this._shareType != this.SHARE_PAGE ) {
			this._shareType = this.SHARE_PAGE;
			this._shareTypeId = pageId;			
			this._currentContentPageID = pageId;
			this._inPersonalSpace = !com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId);
			this._pageSwitched = false;
			this.initContent(pageId);
//		}
	},

	handleShareSpace:function(iEvent) {
		var spaceId = iEvent.payload;
		if(spaceId){
			this._shareType = this.SHARE_SPACE;
			this._shareTypeId = spaceId;
			this.spaceId = spaceId;
			this.initContent(spaceId);
		}
	},
	
	onSwitchPage:function(iEvent){
		var newPageId = iEvent.payload;
		if (!newPageId) { return; }
		this._pageSwitched = (this._currentContentPageID != newPageId); 
		var htmlUtil = com.ibm.mm.builder.utils.htmlUtil;
		if(this.viewListNode){ htmlUtil[((!this._pageSwitched) ? "show" : "hide")+"Nodes"](this.viewListNode.childNodes); }
		if(this.editListNode){ htmlUtil[((!this._pageSwitched) ? "show" : "hide")+"Nodes"](this.editListNode.childNodes); }
	},
	
	initContent:function(){
		if(this.viewListNode){this.viewListNode.innerHTML = ""}
		if(this.editListNode){this.editListNode.innerHTML = ""}
		var ac =  this;
		var rootNode = this.iContext.getRootElement();
		this._hideMessage();
		this._hideMessageBox();
		//Restore the UI to init status
		if(this.searchType != "user") {
			this.searchType = "user";
			com.ibm.mm.builder.ACLopenSearchType = "user";
			for(var i = 0,len = this.tMenu.entrys.length; i < len; i++) {
            	var item = this.tMenu.entrys[i];
            	if (com.ibm.mm.builder.ACLopenSearchType == item.type) {
                    this.tMenu.setCurrentSearchType(item.domNode);
                    this._currentSearchType = item;
                }
            }
		}
		var searchInput = dojo.byId(this.searchInputId);
		if(dojo.hasClass(searchInput,"ACLSearchInput")){
    		dojo.removeClass(searchInput,"ACLSearchInput");
    		dojo.addClass(searchInput, "initACLSearchInput"); 
    	}
		searchInput.value = com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_USER;
		
		var bottomDiv = dojo.byId(this.bottomDivId);
		
		var noSearchDiv = dojo.query(".aclNoSearchDiv", bottomDiv);
		if (builderConfig.isBidi && dojo.isIE === 6) {
			noSearchDiv[0].style.width="500px";			
		}
		var searchList = dojo.query(".accessControlSearchList", bottomDiv);
		searchList[0].innerHTML = "";
		this.searchSource = this._createSource(this.searchSource,[searchList[0],["none"],this,"aclSearch",15,0]);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateSearchPageControl);
		
		//init the view,edit,personalize user list
		this.viewList = [];
		this.personalizeList= [];
		this.editList= [];
		// init all the model api, and get initial access control data
		this.initACLData();
		//create View List
		var viewList = dojo.query(".accessControlViewList", bottomDiv)[0];
		this.viewListNode = viewList;
		viewList.innerHTML = "";
		var nodesPerPage = 15;

		if(this._shareType == this.SHARE_PAGE && !this._inPersonalSpace){ nodesPerPage = nodesPerPage -2;}
		com.ibm.mm.builder.dnd.viewSource = this._createSource(com.ibm.mm.builder.dnd.viewSource,[viewList,["acluser"],this,"aclView",nodesPerPage,0]);
		this._addItem(com.ibm.mm.builder.dnd.viewSource,viewList,this.viewList,"aclView");

		//create Edit List
		var editList = dojo.query(".accessControlEditList", bottomDiv)[0];
		this.editListNode = editList;
		editList.innerHTML = "";
		com.ibm.mm.builder.dnd.editSource = this._createSource(com.ibm.mm.builder.dnd.editSource,[editList,["acluser"],this,"aclEdit",nodesPerPage,0]);
		this._addItem(com.ibm.mm.builder.dnd.editSource,editList,this.editList,"aclEdit");
		
		//add addition action when sharePage in space
		if(this._shareType == this.SHARE_PAGE && !this._inPersonalSpace){
			if(this._viewBlockCheckbox && this._editBlockCheckbox){
				this._viewBlockCheckbox.domNode.style.display = "";
				this._editBlockCheckbox.domNode.style.display = "";
			}else {
				this._viewBlockCheckbox = new com.ibm.mm.builder.widget.includeBox({
					type:"view",
					includeContent: com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INCLUDE_VIEWER
				});
				var viewListDiv = dojo.query(".accessControlViewListDiv",bottomDiv)[0];
				var theWholeViewList = dojo.query(".viewList",viewListDiv)[0];
				viewListDiv.insertBefore(this._viewBlockCheckbox.domNode,theWholeViewList);
				this._editBlockCheckbox = new com.ibm.mm.builder.widget.includeBox({
					type:"edit",
					includeContent: com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INCLUDE_EDITOR
				});
				var editListDiv = dojo.query(".accessControlEditListDiv",bottomDiv)[0];
				var theWholeEditList = dojo.query(".editList",editListDiv)[0];
				editListDiv.insertBefore(this._editBlockCheckbox.domNode,theWholeEditList);		
			}
			this._viewBlockCheckbox.setCheck(!this.acModel.isInheritanceBlock(com.ibm.mashups.enabler.ac.RoleType.USER)) //update the checkbox status
			this._editBlockCheckbox.setCheck(!this.acModel.isInheritanceBlock(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) //update the checkbox status
		}else{ 
			this._viewBlockCheckbox ? this._viewBlockCheckbox.domNode.style.display = "none" : null;
			this._editBlockCheckbox ? this._editBlockCheckbox.domNode.style.display = "none" : null;
		}
		
		//dynamically set the height of the list div
		dojo.forEach([
						{ id:"acl_search_list_div",className:".accessControlSearchList"},
						{ id:"acl_view_list_div", className:".accessControlViewList"},
						{ id:"acl_edit_list_div", className:".accessControlEditList"}
					 ],function(obj){
					 	var listDiv = dojo.byId(obj.id);
					 	this.setListHeight(listDiv);
						this.setListHeight(dojo.query(obj.className,listDiv)[0]);
		},this);
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(rootNode);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateViewPageControl);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateEditPageControl);
	},
	
	setListHeight:function(listDiv,offset){
		if(!offset){offset = 0;}
		var tempNode = listDiv.previousSibling;
		var h = 0;
		while(tempNode){
			if(tempNode.nodeType === 1 && (dojo.style(tempNode, "display") != "none")){
				h += dojo.marginBox(tempNode).h;
			}
			tempNode = tempNode.previousSibling;	
		}
		var height = dojo.marginBox(listDiv.parentNode).h - h - offset - dojo.style(listDiv,"marginTop") -  dojo.style(listDiv,"marginBottom");
		dojo.style(listDiv,"height",height+"px");
		return height;
	},
	
		
    onLoad: function(){
		var rootNode = this.iContext.getRootElement();
		dojo.parser.parse(rootNode);
		this.wid = "_"+this.iContext.widgetId+"_";
		
		dojo.query(".accessControlDesp", rootNode)[0].innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_ACL_DIALOG_DESC
		this._addTip(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_ADD_TO_VIEW,dojo.query(".addToViewBtnMiddle", rootNode)[0]);
//		this._addTip(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_ADD_TO_PERSONALIZE,dojo.query(".addToPersonalizeBtnMiddle", rootNode)[0],18);
		this._addTip(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_ADD_TO_EDIT,dojo.query(".addToEditBtnMiddle", rootNode)[0]);
		this._addTip(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SEARCH_RESULT,dojo.query(".searchResultHeaderMiddle", rootNode)[0]);
		
		this._addTipForInput(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REMOVE,dojo.query(".accessControlRemove", rootNode)[0]);
		this._addTipForInput(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_ADD_TO_VIEW,dojo.query(".addToViewBtnA11y_button", rootNode)[0],this.MAX_LEN);
		this._addTipForInput(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_ADD_TO_EDIT,dojo.query(".addToEditBtnA11y_button", rootNode)[0],this.MAX_LEN);

		/*
		dojo.query(".accessControlSave", rootNode)[0].value = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE
		dojo.query(".common_cancel", rootNode)[0].innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL
		*/
		
		dojo.query(".initACLSearchInput", rootNode)[0].value = com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_USER;

		this.bottomDivId   = this.wid+"bottomDiv";
		this.searchInputId = this.wid+"search";
		this.filterInputId = this.wid+"filter";
		
		com.ibm.mm.builder.utils.htmlUtil.setNodeTitle((this.cws.I_SEARCH_INDICATE || "Searching..."),dojo.query(".searchIndicatorText",rootNode)[0],170);
		
		//init Search Options
		this.searchType = "user";
		com.ibm.mm.builder.ACLopenSearchType = "user";		
		if(!this.searchDropDownMenu){
			this.searchDropDownMenu = dojo.byId(this.wid + "showSearchScope");
			this.renderMenu(this.searchDropDownMenu);
			dojo.subscribe("com.ibm.mm.catalog.Topics.SearchType_Change",this,"changeSearchType");
		}
		this._searchHint = {
			"user":com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_USER,
			"group":com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_GROUP
		};
		var searchInput = dojo.byId(this.searchInputId);
		var onfocusFun = function() {
			if (dojo.hasClass(searchInput, "initACLSearchInput")) {
				dojo.removeClass(searchInput, "initACLSearchInput");
				dojo.addClass(searchInput, "ACLSearchInput");
				searchInput.value = "";
			}
		};
		var onblurFun = dojo.hitch(this,function(){
		  var searchInput = dojo.byId(this.searchInputId); 
		  var value = searchInput.value;
      	  if (value=="") {
        	if(dojo.hasClass(searchInput,"ACLSearchInput")){
        		dojo.removeClass(searchInput,"ACLSearchInput");
        	}
       	    dojo.addClass(searchInput, "initACLSearchInput");     
       	    searchInput.value = this._getSearchHint();      
      	  }
		});
		
		var onkeydownFun = dojo.hitch(this, function(evt) {
			evt = evt || window.event;
			if (evt && evt.keyCode == 13) {	//enter key to trigger
	              this.showSearchResult();
	        }
		});
		
		this._connects.push(dojo.connect(searchInput, "onfocus",null,onfocusFun));
		this._connects.push(dojo.connect(searchInput, "onblur",null,onblurFun));
		this._connects.push(dojo.connect(searchInput, "onkeydown",null,onkeydownFun));

		var searchScopeNode = dojo.byId(this.wid+"showSearchScope");
		dojo.attr(searchScopeNode,"alt",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SEARCHSCOPE);
		dojo.attr(searchScopeNode,"title",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SEARCHSCOPE);
		var searchResultNode = dojo.byId(this.wid+"showResultImg");
		dojo.attr(searchResultNode,"alt",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SEARCH_RESULT);
		dojo.attr(searchResultNode,"title",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SEARCH_RESULT);
		dojo.attr(dojo.byId(this.wid+"search"),"title",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SEARCHINPUT);
		if(builderConfig.isBidi){
			dojo.attr(searchResultNode,"src",builderConfig.builderPath + "/images/search_button_gray_rtl.png");
		}
	},
	
	_createSource: function(source,param){
		if (source) {
			source.destroy();
			source = null;
		}		
		return com.ibm.mm.builder.dnd.ACLSource.createSource(param[0],param[1],param[2],param[3],param[4],param[5]);
	},
	
	_addTip:function(mesg,node){
		var tNode = node;
		dojo.attr(node,"title",mesg);
		tNode.innerHTML = mesg;
	},
	_addTipForInput:function(mesg,node,maxLen){
		var tNode = node;
		dojo.attr(node,"title",mesg);
		tNode.value = maxLen ? com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(mesg,tNode,maxLen) : mesg;
	},
	
	initModels:function(){
		if (!this.userModel){ this.userModel = com.ibm.mashups.enabler.model.Factory.getUserModel(); }
		if(this._shareType == this.SHARE_PAGE) {
			this.acModel = this.acModelUtil.getPageAC(this._shareTypeId);
		}else {
			this.acModel = this.acModelUtil.getSpaceAC(this._shareTypeId);
		}
	},

	initACLData:function(){
		this.initModels();
		this.viewList = this.acModelUtil.getViewers(this.acModel);
		this.editList = this.acModelUtil.getEditors(this.acModel);
	},
	
	onview:function(){
	},

	_addItem:function(source,parent,itemList,type){
		var currentId = com.ibm.mm.builder.utils.userUtil.getCurrentUserID();
		var self = this;
		for(var i = 0; i < itemList.length; i++) {
			var item = itemList[i];
			if (item.getID() != currentId) {
				var itemId = self._shareTypeId + type + item.getEntityType() + item.getID();
				var itemNode = new com.ibm.mm.builder.aclUserItem({
					displayName: item.getDisplayName(),
					entityType: item.getEntityType(),
					type: type,
					id: itemId,
					userId:item.getID()
				});
				source.container.push(itemNode);				
				source.allStayedUsers[self._shareTypeId+item.getID()] = item.getEntityType();
				parent.appendChild(itemNode.domNode);
				if(i >= source.listLengthPerPage){
					itemNode.domNode.style.display = "none";
				}
			}
		}
		
		var totalPage = source.node.childNodes.length / source.listLengthPerPage;
		totalPage = Math.ceil(totalPage);
		source.totalPage = totalPage == 0 ? 1 : totalPage;
	},
	
	transferNode:function(source,target,nodeId,anchor,/*boolean*/copy){
		for(var i = 0,len = source.container.length;i < len;i++){
			var item = source.container[i];
			if(item.domNode.id === nodeId){ 
				//check anonymous user
				if(this.isAnonymousUserByUserId(item.userId) && target.name == "aclEdit"){ return; }
				var newID = nodeId.replace(source.name,target.name);
				var newItem = new com.ibm.mm.builder.aclUserItem({
						displayName: item.displayName,
						entityType: item.entityType,
						type: target.name,
						id: newID,
						userId:item.userId
					});
				target.container.push(newItem);
				target.allStayedUsers[newID.replace(target.name,"").replace(item.entityType,"")] = item.entityType;
				target.node.insertBefore(newItem.domNode,anchor);
				if(!copy){
					source.container.splice(i,1);
					delete source.allStayedUsers[nodeId.replace(source.name,"").replace(item.entityType,"")];
					item.destroy();
				}
				return;
			}
		}
	},
	
	//temporary function,to invoke api to check if the user is anonymous
	isAnonymousUserByUserId: function(id){
		if(!this.searchItems){return false;}
		var userItem;
		for(var i=0,len = this.searchItems.length;i<len;i++){
			userItem = this.searchItems[i];
			if(userItem.getID() === id && userItem.isVirtual() && userItem.getVirtualType() === com.ibm.mashups.enabler.user.VirtualType.ANONYMOUS_USER ){ return true; }
		}
		return false;
	},
	
	isAnonymousUserByNodeId:function(source,nodeId){
		var result = false;
		dojo.forEach(source.container,function(item){
			if (item.domNode.id == nodeId) { result=this.isAnonymousUserByUserId(item.userId); return; }
		},this);
		return result;
	},
	
	checkDraggedNode: function(source,target,draggedNodes){
		var restNodes = [];
		var reassignList = [];
		var _self = this;
		dojo.forEach(draggedNodes,function(item,index){
			var isAnonymousUser = false;
			var id = item.id.replace(source.name,"");
			var reassignNode = null;
			switch (target.name) {
				case com.ibm.mm.builder.dnd.viewSource.name:
					reassignNode = _self.getSpeceficNode(com.ibm.mm.builder.dnd.editSource, id) ||
									_self.getSpeceficNode(com.ibm.mm.builder.dnd.personalizeSource, id);
					break;
				case com.ibm.mm.builder.dnd.editSource.name:
					if(_self.isAnonymousUserByNodeId(source,item.id)){ reassignNode = null; isAnonymousUser=true; break; }
					reassignNode = _self.getSpeceficNode(com.ibm.mm.builder.dnd.viewSource, id) ||
									_self.getSpeceficNode(com.ibm.mm.builder.dnd.personalizeSource, id);
					break;
				case com.ibm.mm.builder.dnd.personalizeSource.name:
					reassignNode = _self.getSpeceficNode(com.ibm.mm.builder.dnd.viewSource, id) ||
									_self.getSpeceficNode(com.ibm.mm.builder.dnd.editSource, id);
					break;
			}
			if (reassignNode) { reassignList.push(reassignNode); } else {
				if( !isAnonymousUser && !(_self.getSpeceficNode(target, id, item.id))){restNodes.push(item)}
			}
		});
		
		if(reassignList.length){
			var ACLReassignDialog=new com.ibm.mm.builder.dialog.ACLReassignDialog(_self,target,reassignList);
			ACLReassignDialog.show();
		}
		return restNodes;
	},

	getSpeceficNode:function(source,specificNodeId){
		if( !source ){ return null; };
		var container = source.container;
		for(var i = 0,len = container.length;i < len;i++){
			var item = container[i];
			if((item.id).replace(source.name,"") === specificNodeId){ 
				return {id:item.id,name:item.displayName,perm:item.type};
			}
		}
		return null;
	},

	changeSearchType:function(type){
	    this.searchType = type;
	    com.ibm.mm.builder.ACLOpenSearchType = type;
	    var searchInput = dojo.byId(this.searchInputId);
		if (dojo.hasClass(searchInput, "initACLSearchInput")) { searchInput.value = this._getSearchHint(); }
	},
	 _getSearchHint: function(){
        return this._searchHint[this.searchType] || "Search";
    },
	renderMenu:function(parentNode){
		this.tMenu = new com.ibm.mm.builder.widget.OpenSearchDropdownMenu({
            targetNodeIds: [parentNode],
            leftClickToOpen: true
        });
        var user = new com.ibm.mm.builder.widget.OpenSearchDropdownMenuItem({
            type: "user",
            label: com.ibm.mm.builder.coreWidgetsStrings.I_ACL_USER_SEARCH,
            onClick: dojo.hitch(this,this._onMenuItemClick,"user")
        });
        this.tMenu.addChild(user);
        this.tMenu.entrys.push(user);
        
        var group = new com.ibm.mm.builder.widget.OpenSearchDropdownMenuItem({
            type: "group",
            label: com.ibm.mm.builder.coreWidgetsStrings.I_ACL_GROUP_SEARCH,
            onClick: dojo.hitch(this,this._onMenuItemClick,"group")
        });
        this.tMenu.addChild(group);
        this.tMenu.entrys.push(group);            
        this.tMenu.startup();
        
        for(var i = 0; i < this.tMenu.entrys.length; i++) {
        	var item = this.tMenu.entrys[i];
        	if (com.ibm.mm.builder.ACLopenSearchType == item.type) {
                this.tMenu.setCurrentSearchType(item.domNode);
                this._currentSearchType = item;
            }
        }         
	},
	
	_onMenuItemClick:function(type){
		dojo.publish("com.ibm.mm.catalog.Topics.SearchType_Change", [type]);
	},
	
	onOverActions: function(e) {
		var target = e.target || e.srcElement;

		if(target.tagName=="TD"){
			target = target.parentNode;//TR
			dojo.addClass(target,"searchOption_item_highlighted");
			dojo.removeClass(target.firstChild,"modeSelector_check");
			target.style.color = this.highlightedColor;
		}
		if(dojo.isIE)
			this._mouseOverSearchOptions();
		
	},
	
	onOutActions: function(e) {
		var target = e.target || e.srcElement;
		if(target.tagName=="TD"){
			target = target.parentNode; //TR
			dojo.removeClass(target,"searchOption_item_highlighted");
			dojo.addClass(target.firstChild,"modeSelector_check");
			if(dojo.hasClass(target.firstChild,"check")){
				target.style.color = this.selectedColor;
			}else{
				target.style.color = this.itemColor;
			}
		}
		if(dojo.isIE)
			this._mouseOutSearchOptions();
	},
	
	setUserSearch:function(){
		
		var searchInput = dojo.query(".initACLSearchInput", this.iContext.getRootElement())[0];
		if(searchInput&&(searchInput.value==com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_GROUP||dojo.trim(searchInput.value)=="")){
			searchInput.value = com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_USER;
		}
		
	},
	setGroupSearch:function(){
		
		var searchInput = dojo.query(".initACLSearchInput", this.iContext.getRootElement())[0];	
		if(searchInput&&(searchInput.value==com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_USER||dojo.trim(searchInput.value)=="")){
			searchInput.value = com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_GROUP;
		}
		
	},
	
	_getSearchOptionDiv:function() {
		if(!this.searchOptionDiv) {
			var tags = dojo.query(".accessControl_searchOptions", dojo.byId(this.bottomDivId));
			this.searchOptionDiv = tags[0];
		}
		return this.searchOptionDiv;
	},
	
	_mouseOutSearchOptions : function() {
		var optionTable = this._getSearchOptionDiv();
		if(optionTable && optionTable.style.display == "block") //user click the icon again
		{
			dojo.byId(this.wid + "showResultImg").focus();
		}
	},
	
	_mouseOverSearchOptions : function() {
		//var optionTable = dojo.query(".searchOptionTable", dojo.byId(this.bottomDivId))[0];
		var optionTable = this._getSearchOptionDiv();
		if(optionTable && optionTable.style.display == "block") //user click the icon again
		{
			optionTable.focus();
		}
	},
	
	_displaySearchOptions:function(show){
		var tags = dojo.query(".accessControl_searchOptions", dojo.byId(this.bottomDivId));
		var optionTable = this._getSearchOptionDiv();
		if(show){
			if(optionTable.style.display == "block")
				optionTable.style.display="none";
			else {
				optionTable.style.display = "block";
				//if(!dojo.isIE){
					optionTable.focus();
				//}
			}
		}else{
			optionTable.style.display="none";
		}
	},
	
	 _onBlur: function(e){
	 	var optionTable = this._getSearchOptionDiv();
	 	if(optionTable.style.display == "none")
	 		return;
	 	window.setTimeout(dojo.hitch(this,function() {
	 		this._displaySearchOptions(false);
	 	}),300);
    },

	/*
	 * summary:
	 * 			show search people results in the search div
	 */
	showSearchResult:function() {
    	this._hideMessage();
    	var tags = dojo.query(".accessControlSearchListDiv", dojo.byId(this.bottomDivId));
		var searchList = dojo.query(".accessControlSearchList", dojo.byId(this.bottomDivId));
		searchList[0].style.display = "";
		//get the input and do the search
		var searchInput = dojo.byId(this.searchInputId);
		var searchingIndi = dojo.query(".searchIndicatorContainer",dojo.byId(this.bottomDivId))[0];
		if (searchInput != null && searchInput.value!="") {
			searchingIndi.style.display = "block";
			searchList[0].innerHTML = "";
			if(dojo.hasClass(searchInput, "initACLSearchInput")){
				this.searchItems = this.searchOutUsers("*");
			}else {
				this.searchItems = this.searchOutUsers(searchInput.value);
			}
			searchingIndi.style.display = "none";
		}
		if(this.searchItems!=null && this.searchItems.length>0 &&
		   !(this.searchItems.length==1&&this.searchItems[0].getID() == com.ibm.mm.builder.utils.userUtil.getCurrentUserID())){
			//init the searchSource
			try{
				this.searchSource = this._createSource(this.searchSource,[searchList[0],["none"],this,"aclSearch",15,0]);
				this._addItem(this.searchSource,searchList[0], this.searchItems, "aclSearch");
				//update search list's page control
				dojo.publish(com.ibm.mm.builder.eventTopics.UpdateSearchPageControl);
			}catch(e){
				this.LOGGER.severe("showSearchResult",
					dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_COLUMN_DND_1,[e.message])
				)
			}
			//new search result,reshow the search list
			tags[0].style.display = "none";
			dojo.fx.wipeIn({node: tags[0],	duration: 1000 }).play();
			//TODO:temp style for without personalize
//			if(!dojo.isIE){
//				var noSearchDiv = dojo.query(".aclNoSearchDiv", dojo.byId(this.bottomDivId));
//				noSearchDiv[0].style.width="738px";
//			}
		}else{
			searchList[0].style.display = "none";
			var msg = null;
			if(this.searchType =="user")
				msg = com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_NO_RESULT_TEXT_USER || "No user found, try another search item";
			else
				msg = com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_NO_RESULT_TEXT_GROUP || "No group found, try another search item";
			this._showMessage(msg, "info", "search_msg")
		}
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(searchList[0]);
	},

	searchOutUsers:function(keyword){
		var searchResult =new Array();
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var wildcardDisabled = cs.getValue(cs.AUTO_WILDCARD_DISABLED);
		if (keyword!=""){
			if (keyword != "*") {
				keyword = keyword.replace(/(^\**)|(\**$)/g, "");
				if ((wildcardDisabled != true) && (wildcardDisabled != "true")) {
					keyword = "*" + keyword + "*";
				}				
			}
			if(this.searchType =="user"){
			
                var virtualUsersFound = this.userModel.getVirtualUsers().start();
                for (var i = 0; i < virtualUsersFound.length; i++) {
                    this.searchUsers.push(virtualUsersFound[i]);
                    searchResult.push(virtualUsersFound[i]);
                }
				
				var usersFound = this.userModel.findUsersByAttribute(cs.getValue(cs.CLIENT_USER_ID_KEY), keyword).start();
				for (var i = 0; i < usersFound.length; i++) {
					this.searchUsers.push(usersFound[i]);
					searchResult.push(usersFound[i]);
				}
			}else{
                var virtualGroupsFound = this.userModel.getVirtualGroups().start();
                for (var i = 0; i < virtualGroupsFound.length; i++) {
                    this.searchUsers.push(virtualGroupsFound[i]);
                    searchResult.push(virtualGroupsFound[i]);
                }
				
				var usersFound = this.userModel.findGroupsByAttribute(cs.getValue(cs.CLIENT_GROUP_CN_KEY), keyword).start();
				for (var i = 0; i < usersFound.length; i++) {
					this.searchUsers.push(usersFound[i]);
					searchResult.push(usersFound[i]);
				}
			}
		}
		return searchResult;
	},

	/**
	 * TODO: Defer this apply function
	 */
	applyACL:function(){


	},

	addToView:function(){
		/*
		 *  summary:
		 * 	add all checked entries in personalize list, edit list, search list into view list
		 */
		this.collectNodes(com.ibm.mm.builder.dnd.personalizeSource,com.ibm.mm.builder.dnd.viewSource,false);
		this.collectNodes(com.ibm.mm.builder.dnd.editSource,com.ibm.mm.builder.dnd.viewSource,false);
		this.collectNodes(this.searchSource,com.ibm.mm.builder.dnd.viewSource,true);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateAllPageControl);
	},
	
	collectNodes:function(source,target,/*boolean*/ needCheck){
		if(!source || !target){ return; }
		var selectedNodes = com.ibm.mm.builder.utils.htmlUtil.getAllCheckedNodes(source.node);
		selectedNodes = needCheck ? (this.checkDraggedNode(source,target,selectedNodes)) : selectedNodes;
		var _self = this;
		dojo.forEach(selectedNodes,function(item){				
			_self.transferNode(source,target,item.id,null,(source.name === "aclSearch"));
		});
		com.ibm.mm.builder.utils.htmlUtil.uncheckAll(source.node.childNodes);
	},
	
	addToViewClick:function(event) {
		event = dojo.fixEvent(event);
		if (event.keyCode === dojo.keys.ENTER) {
			this.addToView();
		}
	},

	// defer to next release
	addToPersonalize:function(){
		/*
		 *  summary:
		 * 	add all checked entries in view list, edit list, search list into personalize list
		 */
		this.collectNodes(com.ibm.mm.builder.dnd.viewSource,com.ibm.mm.builder.dnd.personalizeSource,false);
		this.collectNodes(com.ibm.mm.builder.dnd.editSource,com.ibm.mm.builder.dnd.personalizeSource,false);
		this.collectNodes(this.searchSource,com.ibm.mm.builder.dnd.personalizeSource,true);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateAllPageControl);
	},

	addToEdit:function(){
		/*
		 *  summary:
		 * 	add all checked entries in view list, personalize list, search list into edit list
		 */
		this.collectNodes(com.ibm.mm.builder.dnd.viewSource,com.ibm.mm.builder.dnd.editSource,false);
		this.collectNodes(com.ibm.mm.builder.dnd.personalizeSource,com.ibm.mm.builder.dnd.editSource,false);
		this.collectNodes(this.searchSource,com.ibm.mm.builder.dnd.editSource,true);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateAllPageControl);
	},
	
	addToEditClick:function(event){
        event = dojo.fixEvent(event);
        if (event.keyCode === dojo.keys.ENTER) {
            this.addToEdit();
        }
	},

	removeAllSelectedEntries:function(){
		/*
		 *  summary:
		 * 	remove all selected entries in View List, Personalize List, Edit List
		 */
		this.removeSelectedNodes(com.ibm.mm.builder.dnd.viewSource);
		this.removeSelectedNodes(com.ibm.mm.builder.dnd.editSource);
		this.removeSelectedNodes(com.ibm.mm.builder.dnd.personalizeSource);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateAllPageControl);
	},
	
	
	removeSelectedNodes: function(source){
		if(!source){ return;}
		var isRemoved = false;
		var selectedNodes = com.ibm.mm.builder.utils.htmlUtil.getAllCheckedNodes(source.node);
		dojo.forEach(selectedNodes,function(item){
			for (var i = 0, len = source.container.length; i < len; i++) {
				var sourceItem = source.container[i];
				if (sourceItem.id === item.id) {
					delete source.allStayedUsers[item.id.replace(source.name,"").replace(sourceItem.entityType,"")];
					sourceItem.destroy();
					source.container.splice(i, 1);
					isRemoved = true;
					break;
				}
			}
		});
//		
//		if(isRemoved){dojo.publish(source.name)}
	},
	

	// defer this feature
	showApplyOptions:function(){

	},

	/**
	 * save ACL operations
	 */
	saveACL:function(){
		var viewResultIds = com.ibm.mm.builder.dnd.viewSource.allStayedUsers;
//		var personalizeResultIds = com.ibm.mm.builder.dnd.personalizeSource.allStayedUsers;
		var editResultIds = com.ibm.mm.builder.dnd.editSource.allStayedUsers;
		
		var modified = false;
		//update the block setting if page is not in personal space
		if(!this._inPersonalSpace && this._shareType == this.SHARE_PAGE) {
			if (!this._viewBlockCheckbox.isChecked() != this.acModel.isInheritanceBlock(com.ibm.mashups.enabler.ac.RoleType.USER)) {
				this.acModel.setInheritanceBlock(com.ibm.mashups.enabler.ac.RoleType.USER, !this._viewBlockCheckbox.isChecked());
				modified = true;
			}
			if (!this._editBlockCheckbox.isChecked() != this.acModel.isInheritanceBlock(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) {
				this.acModel.setInheritanceBlock(com.ibm.mashups.enabler.ac.RoleType.EDITOR, !this._editBlockCheckbox.isChecked());
				modified = true;
			}
		}
		var viewIdList = this.getUserIdList(viewResultIds);
		var editIdList = this.getUserIdList(editResultIds);
		
		var removedViewers = this.getRemoveIdList(viewIdList,this.viewList);
		var removedEditors = this.getRemoveIdList(editIdList,this.editList);
		var insertedViewers = this.getInsertIdList(viewIdList,this.viewList);
		var insertedEditors = this.getInsertIdList(editIdList,this.editList);
		this.acModelUtil.removeViewers(this.acModel,removedViewers);
		this.acModelUtil.removeEditors(this.acModel,removedEditors);
		this.acModelUtil.addViewers(this.acModel,insertedViewers);
		this.acModelUtil.addEditors(this.acModel,insertedEditors);
		
		modified = (modified || removedViewers || removedEditors || insertedViewers || insertedEditors );
		
		if(!modified){
			com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
			return;
		}
		//8245 failure message
		var deferred = this.acModel.commit();
		deferred.setOperationCallback(dojo.hitch(this, function(newNode){
			if (newNode) {
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
			}
			else {
				this._showShareErrorMessage(com.ibm.mm.builder.coreWidgetsMessages.E_SHARE_PAGE_NO_PERMISSION_0, "error");
			}
		}));
		deferred.start();
	},

	/**
	 * cancel the operation, hide the ACL dialog
	 */
	cancelACL:function(){
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},
	
	getRemoveIdList: function(allListIds,initList){
		var removeIdList = {}
		var hasRemoveId = false;
		dojo.forEach(initList,function(entity){
			var id = entity.getID();
			var type = allListIds[id];
			if(!type || (type && (type != entity.getEntityType()))){ 
				removeIdList[id] = entity.getEntityType();
				hasRemoveId = true;
			}
		});
		return (hasRemoveId ? removeIdList : null);
	},
	
	getInsertIdList: function(allListIds,initList){
		var insertIdList = {}
		var hasRemoveId = false;
		for(var id in allListIds){
			var found = false;
			for(var i = 0,len = initList.length; i<len; i++){
				var entity = initList[i];
				if((id == entity.getID()) && (allListIds[id] == entity.getEntityType())){
					found = true;
					break;
				}
			}
			if(!found){
				insertIdList[id] = allListIds[id]
				hasRemoveId = true;
			}
		}
		return (hasRemoveId ? insertIdList : null)
	},
	
	
	getUserIdList:function(/*json*/userIds){
		var idList = {}
		for(userId in userIds){ idList[userId.replace(this._shareTypeId,"")] = userIds[userId]; }
		return idList;
	},
	
	adjustUserList:function(source){
		var totalPage = source.node.childNodes.length / source.listLengthPerPage;
		totalPage = Math.ceil(totalPage) == 0 ? 1 : Math.ceil(totalPage);
		
		source.totalPage = totalPage;
		if(source.currentPage > totalPage){
			source.currentPage = totalPage;
		}
		if(source.currentPage < 1){
			source.currentPage = 1;
		}
		//hide the previous users
		var i = 0;
		for(;i < source.listLengthPerPage*(source.currentPage-1); i++){
			source.node.childNodes[i].style.display = "none"
		}
		for(;i < source.listLengthPerPage*source.currentPage && i < source.node.childNodes.length; i++){
			source.node.childNodes[i].style.display = ""
		}
		for(;i < source.node.childNodes.length; i++){
			source.node.childNodes[i].style.display = "none"
		}
	},
	
	getProperSource:function(list){
		var scrollList;
		switch(list){
			case "search":
				return this.searchSource;
			case "view":
				return com.ibm.mm.builder.dnd.viewSource;
			case "personalize":
				return com.ibm.mm.builder.dnd.personalizeSource;
			case "edit":
				return com.ibm.mm.builder.dnd.editSource;
		}
		return null;
	},
	
	updateProperControl:function(list){
		switch(list){
			case "search":
				this.updateSearchPageControl();
				break;
			case "view":
				this.updateViewPageControl();
				break;
			case "personalize":
				this.updatePersonalizePageControl();
				break;
			case "edit":
				this.updateEditPageControl();
				break;
		}
	},
	
	pageDown:function(list){
		var source = this.getProperSource(list);
		if (source) {
			source.currentPage++;
			this.updateProperControl(list);
		}
		
	},
	pageUp:function(list){
		var source = this.getProperSource(list);
		if (source) {
			if(source.currentPage == 1) {
				return;
			}
			source.currentPage--;
			this.updateProperControl(list);
		}
	},
	jumpDown:function(list){
		var source = this.getProperSource(list);
		if (source){
			if(source.currentPage != source.totalPage){
				source.currentPage = source.totalPage;
				this.updateProperControl(list);
			}
		}
	},
	jumpUp:function(list){
		var source = this.getProperSource(list);
		if (source){
			if(source.currentPage != 1){
				source.currentPage = 1;
				this.updateProperControl(list);
			}
		}
	},
	_disableUpPageControls:function(list){
		if(list){
			var pageUpDiv = dojo.query(".accessControlPageUpDiv",list);
			pageUpDiv[0].innerHTML="<img src="+this.disabledPageUpImageUrl+" alt=''>";

			var jumpUpDiv = dojo.query(".accessControlJumpUpDiv",list);
			jumpUpDiv[0].innerHTML="<img src="+this.disabledJumpUpImageUrl+" alt=''>";
		}

	},
	_disableDownPageControls:function(list){
		if(list){
			var pageDownDiv = dojo.query(".accessControlPageDownDiv",list);
			pageDownDiv[0].innerHTML="<img src="+this.disabledPageDownImageUrl+" alt=''>";

			var jumpDownDiv = dojo.query(".accessControlJumpDownDiv",list);
			jumpDownDiv[0].innerHTML="<img src="+this.disabledJumpDownImageUrl+" alt=''>";
		}

	},
	_enableUpPageControls:function(list){
		if(list){
			var pageUpDiv = dojo.query(".accessControlPageUpDiv",list);
			pageUpDiv[0].innerHTML="<img src="+this.pageUpImageUrl+" alt=''>";

			var jumpUpDiv = dojo.query(".accessControlJumpUpDiv",list);
			jumpUpDiv[0].innerHTML="<img src="+this.jumpUpImageUrl+" alt=''>";
		}

	},
	_enableDownPageControls:function(list){
		if(list){
			var pageDownDiv = dojo.query(".accessControlPageDownDiv",list);
			pageDownDiv[0].innerHTML="<img src="+this.pageDownImageUrl+" alt=''>";

			var jumpDownDiv = dojo.query(".accessControlJumpDownDiv",list);
			jumpDownDiv[0].innerHTML="<img src="+this.jumpDownImageUrl+" alt=''>";
		}

	},
	_hidePageControls:function(list){
		if(list){
			list.style.display = "none";
		}
	},
	_showPageControls:function(list){
		if(list){
			list.style.display = "block";
		}
	},
	updateAllPageControl:function(){
		this.updateViewPageControl();
		//this.updatePersonalizePageControl();
		this.updateEditPageControl();
	},
	updateViewPageControl:function(){
		this.updageSpecificPageControl(com.ibm.mm.builder.dnd.viewSource);
	},
	updatePersonalizePageControl:function(){
		this.updageSpecificPageControl(com.ibm.mm.builder.dnd.personalizeSource);
	},
	updateEditPageControl:function(){
		this.updageSpecificPageControl(com.ibm.mm.builder.dnd.editSource);
	},	
	
	updageSpecificPageControl: function(source){
		this.adjustUserList(source);
		var heightBox = !this._inPersonalSpace && this._shareType != this.SHARE_SPACE ? {h:"350px",hWithArrow:"300px"} : {h:"393px",hWithArrow:"347px"};
		var type = source.name.replace("acl","");
		var upDiv = dojo.query(".accessControl"+type+"ListUpDiv", dojo.byId(this.bottomDivId))[0];
		var downDiv = dojo.query(".accessControl"+type+"ListDownDiv", dojo.byId(this.bottomDivId))[0];
		this._updateControl(upDiv,downDiv,source);
	},
	
	updateSearchPageControl:function(){
		this.adjustUserList(this.searchSource);
		var upDiv = dojo.query(".accessControlSearchListUpDiv", dojo.byId(this.bottomDivId))[0];
		var downDiv = dojo.query(".accessControlSearchListDownDiv", dojo.byId(this.bottomDivId))[0];
		this._updateControl(upDiv,downDiv,this.searchSource);
	},
	
	_updateControl:function(upDiv,downDiv,source){
		if(source.totalPage == 1){
			//hide page control divs
			this._hidePageControls(upDiv);
			this._hidePageControls(downDiv);
			this._disableUpPageControls(upDiv);
			this._disableDownPageControls(downDiv);
		}else {
			this._showPageControls(upDiv);
			this._showPageControls(downDiv);
			
			if(source.currentPage > 1){
				this._enableUpPageControls(upDiv);
			}else{
				this._disableUpPageControls(upDiv);
			}
			
			if(source.currentPage < source.totalPage){
				this._enableDownPageControls(downDiv);
			}else{
				this._disableDownPageControls(downDiv);
			}
			this.setListHeight(source.node,23);
		}
	},
	
	
	//new msg mechanism
	_showMessage : function(message, type, nodeId) {
		if(!this.messageControl) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			var wid = "_"+ this.iContext.widgetId + "_";
			var node = dojo.byId(wid+nodeId);
		   	this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: type}, node);
		}
		this.messageControl.attr(
			{
			"message" : message,
			"messageType" : type || "error"
			}
		);
		this.messageControl.show();
	},
	
	_hideMessage : function() {
		if (this.messageControl) {
			this.messageControl.hide();
			var searchList = dojo.query(".accessControlSearchList", dojo.byId(this.bottomDivId));
			searchList[0].style.display = "";
		}
	},
	
	/**
	 * Display message in message box
     * @param {Object} message
	 * @param {Object} type Optional. Type of message, includes 'info', 'error', 'warning'
	 */
	_showShareErrorMessage: function(message, type) {
		if(!this.messageBox) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			var wid = "_"+ this.iContext.widgetId + "_";
			var node = dojo.byId(wid+"messageBox");
		   	this.messageBox = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: type}, node);
		}
		this.messageBox.attr(
			{
			"message" : message,
			"messageType" : type || "error"
			}
		);
		this.messageBox.show();
		dojo.removeClass(dojo.byId(this.bottomDivId),"accessControlBottomDiv");
		dojo.addClass(dojo.byId(this.bottomDivId), "accessControlBottomDivWithError");
	},
	
	_hideMessageBox: function(){
		if(dojo.hasClass(dojo.byId(this.bottomDivId), "accessControlBottomDivWithError")){
			dojo.removeClass(dojo.byId(this.bottomDivId),"accessControlBottomDivWithError");
			dojo.addClass(dojo.byId(this.bottomDivId), "accessControlBottomDiv")
		}
		if(this.messageBox) {
			this.messageBox.hide();
		}
	},
	
	onUnload:function(){
		if(this.searchSource){
			this.searchSource.destroy();
			this.searchSource = null;
		}
		if(com.ibm.mm.builder.dnd.viewSource){
			com.ibm.mm.builder.dnd.viewSource.destroy();
			com.ibm.mm.builder.dnd.viewSource = null;
		}
		if(com.ibm.mm.builder.dnd.personalizeSource){
			com.ibm.mm.builder.dnd.personalizeSource.destroy();
			com.ibm.mm.builder.dnd.personalizeSource = null;
		}
		if(com.ibm.mm.builder.dnd.editSource){
			com.ibm.mm.builder.dnd.editSource.destroy();
			com.ibm.mm.builder.dnd.editSource = null;
		}
		dojo.forEach(this._connects, dojo.disconnect, dojo);
	}
});

dojo.declare("com.ibm.mm.builder.aclUserItem",[dijit._Widget, dijit._Templated],{
	displayName:null,
	entityType:null,
	type:null,
	id:null,
	userId:null,
	templateString: "<div class='aclUserItem dojoDndItem' style='white-space: nowrap;' dojoAttachEvent='onmouseover:_onHover,onmouseout:_onUnHover,onmousedown:_onMouseDown,onmouseup:_onMouseUp,keydown:_onKeyDown'>"+
						"<div class='aclUserItemFloater'>"+
						"	<input dojoAttachPoint='itemCheckBox' type='checkbox' name='itemCheck' role='checkbox' id='${id}_itemCheck'></input>" +
						"</div>"+
						"<div>"+
						"	<label class='aclUserItemContent truncatedLabel' widthlimit='160' dojoAttachPoint='aclUserItemContent' for='${id}_itemCheck'></label>" +
						"</div>"+
					 "</div>",
					 
	
	postCreate: function(){
		if(this.entityType == "group"){ this.aclUserItemContent.style.fontWeight ="bold"; }
		if((this.displayName != null) && (this.displayName != "")){
			this.aclUserItemContent.innerHTML = this.displayName;
		}
		this.itemCheckBox.setAttribute("value",this.id);
		dojo.connect(this.itemCheckBox, "onclick", this, "_checkBoxClick");
		this.domNode.id =  this.id;
	},
	
	_checkBoxClick: function(evt){
		dojo.stopEvent(evt);
	},
	
	setItemID: function(newId){
		this.id = newId
		this.domNode.id = newId;
		this.itemCheckBox.setAttribute("value",this.id);
	},
	
	_onHover: function(){
		dojo.addClass(this.domNode,this.type+"ItemHover");
	},
	
	_onUnHover: function(){
		dojo.removeClass(this.domNode,this.type+"ItemHover");
	},
	
	_onMouseDown: function(evt){
		this.setChecked = !this.itemCheckBox.checked;
		if (!this.itemCheckBox.checked) { this.itemCheckBox.checked = true; }
	    dijit.setWaiState(this.itemCheckBox,"checked",this.itemCheckBox.checked);
	},
	_onMouseUp: function(){ 
		if(this.itemCheckBox.checked && (!this.setChecked)){this.itemCheckBox.checked = false;}
		dijit.setWaiState(this.itemCheckBox,"checked",this.itemCheckBox.checked);
	},
	
	_onKeyDown: function(evt){
		if (evt.keyCode == 32) {
			this.setChecked = !this.itemCheckBox.checked;
			if (!this.itemCheckBox.checked) { 
				this.itemCheckBox.checked = true; 
			} else if(this.itemCheckBox.checked && (!this.setChecked)){
				this.itemCheckBox.checked = false;
			}
		}
	dijit.setWaiState(this.itemCheckBox,"checked",this.itemCheckBox.checked);
	}
});

dojo.declare("com.ibm.mm.builder.widget.includeBox",[dijit._Widget, dijit._Templated],{
	templateString: "<div class='includeBox'>" + 
					   "<div class='includeInside'>" +
						 "<input type='checkbox' dojoAttachPoint = 'blockCheckbox'  />" +
						 "<label dojoAttachPoint = 'includeContentNode' class='includeContent'>${includeContent}</label>" +
					   "</div>" +
					"</div>",
					
	type:null,
	includeContent:null,
	checked:true,
	
	setCheck:function(checked){
		this.blockCheckbox.checked = checked;
	},
	
	isChecked:function(){
		return this.blockCheckbox.checked;
	},
	
	getType:function(){
		return this.type;
	},
	
	postCreate: function(){
		dojo.addClass(this.domNode,this.type+"IncludeBox");
		this.blockCheckbox.checked = this.checked;
		dojo.attr(this.blockCheckbox,"id",this.type+"CheckBox");
		dojo.attr(this.includeContentNode,"for",this.blockCheckbox.id);
	}
});

com.ibm.mm.builder.dnd.viewSource        = null;
com.ibm.mm.builder.dnd.personalizeSource = null;
com.ibm.mm.builder.dnd.editSource      = null;
