dojo.require("com.ibm.mm.builder.navigationHelper");
dojo.require("com.ibm.widgets.NavigationWidget");
dojo.require("com.ibm.domUtilities");

dojo.declare("com.ibm.mm.builder.systemwidget.BannerNavigation", null, {
	onLoad: function(){
		// required to initialize models if not already loaded
		if(!com.ibm.mm.builder.navigationHelper.loaded)	com.ibm.mm.builder.navigationHelper.init();
	
		var startBannerNavLevel = this.iContext.getiWidgetAttributes().getItemValue('startLevel');
		var levelsToDisplay = parseInt(this.iContext.getiWidgetAttributes().getItemValue('levels'));
		
		this.bannerNav = new com.ibm.widgets.NavigationWidget({
							model: com.ibm.mm.builder.navigationHelper.getTreeModel(),
							selectionModel: com.ibm.mm.builder.navigationHelper.getSelectionModel(),
							tiedToSelection: true,
							openDelay: 0,
							level: startBannerNavLevel,
							levels: levelsToDisplay,
							closeDelay: 500,
							dndEnabled: false,
							showInlineEditor: false,
							baseClass: "",
							tabListClass: "lotusInlinelist lotusLinks",
							tabClass: "",
							selectedClass: "lotusSelected",
							onModelItemClick: function(widget, item) {
								
								var cb = dojo.hitch(this, function(){
									var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
									com.ibm.mm.builder.navigationHelper.getSelectionModel().changeSelection(item);
									es.broadcastEvent("com.ibm.mashups.builder.switchPage", this.model.getIdentity(item));
								});
								
								com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
							}
					
							}, "topNavLinks");
		
		dojo.connect(this.bannerNav, "onLoad", this.bannerNav, function(){
			var ch = this.getChildren();
			if(ch.length > 0) {
				dojo.addClass(ch[0].domNode, "lotusFirst");
			}
		});
		
		this.bannerNav.startup();
		
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.BannerNavigation");
	},
	onRefreshNavigation:function(iEvent){
		try{
			this.refresh(iEvent.payload);
		}catch(e){
			var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_REFRESH_NAVIGATION_1,[e.message]);
			this.LOGGER.severe("onRefreshNavigation",msg);
		}
	},
	refresh: function(pid){	
		this.bannerNav.reload();
	},
	onUnLoad: function(){
	    if (this.bannerNav != null) {
			this.bannerNav.destroy();
	        this.bannerNav = null;
	    } 
	}
});