dojo.require("com.ibm.mm.builder.navigationHelper");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("com.ibm.widgets.Breadcrumbs");

dojo.declare("com.ibm.mm.builder.systemwidget.Breadcrumb", null, {
	onLoad: function(){
		// required to initialize models if not already loaded
		if(!com.ibm.mm.builder.navigationHelper.loaded)	com.ibm.mm.builder.navigationHelper.init();
	
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
		var mmBundle = dojo.i18n.getLocalization("com.ibm.mm.builder", "coreWidgetsMessages");
		this.startBreadcrumbLevel = parseInt(this.iContext.getiWidgetAttributes().getItemValue('startLevel'));
		
		this.breadcrumb = new com.ibm.widgets.Breadcrumbs({
			model: com.ibm.mm.builder.navigationHelper.getSelectionModel(),
			startLevel: this.startBreadcrumbLevel,
			newSiblingText: bundle["breadcrumb_new_page_label"],
			newSiblingDefaultValue: bundle["nav_new_page_default_value"],
			listDOM: "span",
			allowNew: false,
			renderSiblings: false,
			siblingSeparator: "",
			itemDOM: "span",
			listClass: "lotusBreadcrumbs",
			containerClass: "ibmPortalBreadcrumbs",
			embeddedEditorWidget: "dijit.form.ValidationTextBox",
			embeddedEditorParams: {
				required: true,
				regExp: '[^\\\\@/:*?"<>|]+',
				tooltipPosition: ["above", "below", "after", "before"],
				invalidMessage: mmBundle["E_PAGE_UTIL_INVALID_NAME_CHAR_0"],
				promptMessage: mmBundle["E_PAGE_UTIL_INVALID_NAME_BLANK_0"],
				maxLength: 20
			},
			createDomLink: function(item, className, separator, node){
				var domItem = document.createElement(this.itemDOM);
				dojo.addClass(domItem, className);
				var link = document.createElement("a");
				domItem.appendChild(link);
				domItem.appendChild(document.createTextNode(separator));
				link.innerHTML = this.treeModel.getLabel(item);
				link.href = "javascript:void();";
				
				dojo.connect(link, "onclick", dojo.hitch(this, function(){ 
					var cb = dojo.hitch(this, function(){
						var es = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
						com.ibm.mm.builder.navigationHelper.getSelectionModel().changeSelection(item);
						es.broadcastEvent("com.ibm.mashups.builder.switchPage", this.treeModel.store.getIdentity(item));
					});
					com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
				}));
				this.trail.insertBefore(domItem, node);
				return domItem;
			}
		}, "navSelectionCrumbs");
		this.breadcrumb.startup();

		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.Breadcrumb");
	},
	onRefreshNavigation:function(iEvent){
		try{
			this.refresh(iEvent.payload);
		}catch(e){
			var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_REFRESH_NAVIGATION_1,[e.message]);
			this.LOGGER.severe("onRefreshNavigation",msg);
		}
	},
	onPageSwitched:function(iEvent){
		try{
			var oldLevel = this.breadcrumb.startLevel;
			this.breadcrumb.startLevel = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId() ? this.startBreadcrumbLevel+1 : this.startBreadcrumbLevel;
			if(this.breadcrumb.startLevel != oldLevel) this.refresh(iEvent.payload);
		}catch(e){
			var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAVIGATION_SWITCH_PAGE_1,[e.message]);
			this.LOGGER.severe("onRefreshNavigation",msg);
		}
	},
	refresh: function(pid){
		this.breadcrumb.redraw(); 
	},
	onUnLoad: function(){
	    if (this.breadcrumb != null) {
			this.breadcrumb.destroy();
	        this.breadcrumb = null;
	    } 
	}
});
