/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author 
 * @author 
 */
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.require("com.ibm.mm.catalog.hubUtil");
dojo.require("com.ibm.mashups.enabler.model");
dojo.require("com.ibm.mm.builder.utils.userUtil");

dojo.declare("com.ibm.mm.builder.changeOwner",com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {	
	
	searchInputId:null,
	
	userModel:null,
	
	searchUsers:null,
	
	userSearchResultId:null,
	
	space_acModel:null,
	
	pageId:null,
	
	user:null,
	
	spacePage_acModel:null,
	
	preOwnerId: null,
	
	constructor:function(){
		this.searchUsers = new Array();
		this.preOwnerId = com.ibm.mm.builder.utils.userUtil.getCurrentUserID();
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.changeOwner");
	},
	
	onLoad:function(){
				
		var rootNode = this.iContext.getRootElement();		
		this.wid = "_"+this.iContext.widgetId+"_";
		
		this.searchInputId = (this.wid+"changeOwnerUserSearchInput");
		this.userSearchResultId = (this.wid+"userSearchResult");	
		var searchInput = dojo.byId(this.searchInputId);
		
		if (dojo.isIE) {
			var searchInput = dojo.byId(this.wid + "changeOwnerUserSearchInput"); 
			searchInput.value = this.cws.I_SEARCH_USER;
			dojo.attr(searchInput,"widthLimit","80");
		}
		dojo.query(".searchIndicatorText",rootNode)[0].innerHTML = com.ibm.mm.builder.coreWidgetsMessages.I_SEARCH_INDICATE || "Searching...";
		
	},
	
	onView: function(){
		this.inherited(arguments);
	},

	onChangeOwner:function(iEvent){
		if(iEvent.payload) {
			this.pageId = iEvent.payload;
		}
		this._hideMessage();
		this._clearOptions(dojo.byId(this.userSearchResultId));		
		this._composeHeader();		
		
		dojo.doc.getElementsByName("ownershipOpt")[0].click();
	},
	
	_composeHeader:function(){
		
		var navigationModel = com.ibm.mashups.enabler.model.Factory.getNavigationModel();
    	navigationModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(2));
    	var selectedNode = navigationModel.getRoot().start();		

		var pu = com.ibm.mm.builder.utils.pageUtil;		
		var pageName = pu.getPageTitle(this.pageId);

		this.spacePage_acModel = com.ibm.mm.builder.utils.acModelUtil.getPageAC(this.pageId);
		var owner = this.spacePage_acModel.getOwner().getDisplayName();

		//todo: move ${1} to coreWidgetsStr...
		this.changeOwnerCurrentOwner.innerHTML = 
		dojo.string.substitute(this.cws.I_CHANGE_PAGE_OWNER_HEADER_COMBO, [owner, pageName]);
	
	},
	
	changeOwner_searchUser:function(){
		var searchInput = dojo.byId(this.searchInputId);
		var searchItems;
		
		var searchingIndi = dojo.query(".searchIndicatorContainer",this.iContext.getRootElement())[0];
		this._hideMessage();
		
		if (searchInput != null && searchInput.value!="") {
			searchingIndi.style.display = "block";
			if (dojo.hasClass(searchInput, "initCOSearchInput")) {
				searchItems = this.searchOutUsers("*");
			}else{
				searchItems = this.searchOutUsers(searchInput.value);
			}
			searchItems = this._filterSearchItems(searchItems);
			searchingIndi.style.display = "none";
			var searchResultSelect = dojo.byId(this.userSearchResultId);
			if(searchItems.length == 0) {
				this._clearOptions(searchResultSelect);
				this._showMessage(com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_NO_RESULT_TEXT_USER || "No user found, try another search item","info","messageBox");
			}else {
				var searchResultSelect = dojo.byId(this.userSearchResultId);
				this._populateOptionList(searchItems, searchResultSelect);			
				
				for (var x = 0; x < searchResultSelect.length; x++) {
					dojo.addClass(searchResultSelect[x], "changeOwner_searchResultOptions");
				}
			}
		}
	},
	
	searchOutUsers:function(keyword){
		if (this.userModel==null){
			this.userModel = com.ibm.mashups.enabler.model.Factory.getUserModel();
		}

		var searchResult =new Array();
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var wildcardDisabled = cs.getValue(cs.AUTO_WILDCARD_DISABLED);
		
		if (keyword!=""){
			if (keyword != "*") {
				keyword = keyword.replace(/(^\**)|(\**$)/g, "");
				if ((wildcardDisabled != true) && (wildcardDisabled != "true")) {
					keyword = "*" + keyword + "*";
				}				
			}
			var usersFound = this.userModel.findUsersByAttribute(cs.getValue(cs.CLIENT_USER_ID_KEY),keyword).start();
			
			//empty the searchUsers
			this.searchUsers = [];
			for (var i = 0; i < usersFound.length; i++) {
				this.searchUsers.push(usersFound[i]);
				searchResult.push(usersFound[i]);
			}
			//console.debug(keyword + " users found: " + usersFound.length);
		}
		
		return searchResult;
	},
	
	_showMessage : function(message, type, nodeId) {
		if(!this.messageControl) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			var wid = "_"+ this.iContext.widgetId + "_";
			var node = dojo.byId(wid+nodeId);
		   	this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: type}, node);
		}
		this.messageControl.attr(
			{
			"message" : message,
			"messageType" : type || "error"
			}
		);
		this.messageControl.show();
	},
	
	_hideMessage : function() {
		if (this.messageControl) {
			this.messageControl.hide();
		}
	},
	
	onfocusInput:function() {

		var searchInput = dojo.byId(this.searchInputId); 
		if (dojo.hasClass(searchInput, "initCOSearchInput")) {
			dojo.removeClass(searchInput, "initCOSearchInput");
			dojo.addClass(searchInput, "coSearchInput");
			searchInput.value = "";
		}
		
	},
	
	onblurInput:function() {
		
		var searchInput = dojo.byId(this.searchInputId); 
		var value = searchInput.value;
		
      	if (value=="") {
			if(dojo.hasClass(searchInput,"coSearchInput")){
        		dojo.removeClass(searchInput,"coSearchInput");
        	}
			dojo.addClass(searchInput, "initCOSearchInput");     
			searchInput.value = this._getSearchHint();      
		}		
	},
	
	hide:function() {
		this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
		
	},
	
	save:function(){

		//getting ownership option
		var permOpt = "";
		var newOwner = null;
        var radioOwnershipOpt = document.getElementsByName("ownershipOpt");
        for (var i = 0; i < radioOwnershipOpt.length; i++) {
            if (radioOwnershipOpt[i].checked == true) {
                permOpt = radioOwnershipOpt[i].value;
            }
        }
		
		//getting user selected to be the new owner
		var searchResultSelect = dojo.byId(this.userSearchResultId);					
		for (var i = 0; i < searchResultSelect.length; i++) {
			if(searchResultSelect[i].selected){
				newOwner = this.searchUsers[i];

			}
		}
		//if no user selected, return
		if(newOwner == null || newOwner == ""){
			alert("Change user aborted, select user first");
			return;
		}
		
		this._setPermission(permOpt);
		this._setOwner(newOwner);		

		this.hide();
		this.eventService.broadcastEvent("com.ibm.mashups.builder.pageOwnerChanged", newOwner.getID());
	},	
	
	_setOwner: function(user){
		this.spacePage_acModel.setOwner(user);
		this.spacePage_acModel.commit().start();
		
		var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(this.pageId);
		var spaceAC = com.ibm.mm.builder.utils.acModelUtil.getSpaceAC(spaceId);
		
		if(spaceAC.getOwner() != null && spaceAC.getOwner().getID() == user.getID()){
			//console.debug(user.getID() + " owner of space no new permission needed.");
			return;
		}
		//console.debug(user.getID() + " not owner of space new permission may be needed.");
		var allMembers = com.ibm.mm.builder.utils.acModelUtil.getAllMembersInModel(spaceAC);

		var addSpaceViewPerm = true;
		for(var i = 0, n = allMembers.length; i < n; i++){
			var userId = allMembers[i].getID();
			if(userId == user.getID()){
				addSpaceViewPerm = false;
				break;
			}			
		}
		if(addSpaceViewPerm){
			//console.debug("giving space view permission to " + user.getID());
			var userIdList = {};
			userIdList[user.getID()]= "user";
			var space_acModel = com.ibm.mm.builder.utils.acModelUtil.getSpaceAC(spaceId);
			com.ibm.mm.builder.utils.acModelUtil.addViewers(space_acModel,userIdList);
			space_acModel.commit().start();
		}		
	},
	
	_setPermission: function(permOpt){
		//console.debug("setting ownership: " + permOpt + " for " + this.spacePage_acModel.getOwner().getID());
		var roleType = null;
		if (permOpt === "same") {
			
			//this is default behavior no need to do anything
			return;

			var pageNode = com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode(); 
			var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceByNavigation(pageNode);
			if(space == null){
				//console.debug("space is null");
				return;
			}
			this.space_acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
			
			//console.debug("user: " + space.hasRole("USER"));
			//console.debug("editor: " + space.hasRole("EDITOR"));
			if(space.hasRole("USER")){
				roleType = com.ibm.mashups.enabler.ac.RoleType.USER;
			}
			if(space.hasRole("EDITOR")){
				roleType = com.ibm.mashups.enabler.ac.RoleType.EDITOR;
			}
			
		}else if (permOpt === "edit") {
			roleType = com.ibm.mashups.enabler.ac.RoleType.EDITOR;
		}else if (permOpt === "view") {
			roleType = com.ibm.mashups.enabler.ac.RoleType.USER;			
		}
		if(roleType == null){
			//console.debug("roleType: " + roleType + "...this shouldn't happen and because of this Save aborted");
			return;
		}
		//console.debug("roleType: " + roleType);
		
		var memberIdList = {};
		memberIdList[this.spacePage_acModel.getOwner().getID()]= "user";
		com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType(this.spacePage_acModel, memberIdList, roleType);
		this.spacePage_acModel.commit().start();
		//console.debug("permission option updated");
	},
	
	_getSearchHint: function(){
        //return "Search User";
		return com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_USER;
    },
	
	_populateOptionList:function(searchItems,searchResultSelect){
		
		this._clearOptions(searchResultSelect);
		for (var i = 0; i < searchItems.length; i++) {
			this._addToOptionList(searchResultSelect,searchItems[i].getID(), searchItems[i].getDisplayName());
		}
	},
	
	_filterSearchItems:function(searchItems){
		var retVal = new Array();
		for (var i = 0, j = 0; i < searchItems.length; i++) {
			if(this.preOwnerId !=  searchItems[i].getID())
				retVal[j++] = searchItems[i];
		}
		return retVal;
	},
	
	_addToOptionList:function (OptionList, OptionValue, OptionText) {
		OptionList[OptionList.length] = new Option(OptionText, OptionValue);
	},
	
	_clearOptions:function(optionList) {
		for (i = optionList.length; i >= 0; i = i - 1) {
			optionList[i] = null;
		}
	}

});
