/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Erik (bizheng@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.iwidget.GenericLayout");
dojo.require("com.ibm.mm.builder.dnd.ColumnSource");
dojo.require("com.ibm.mm.builder.dnd.QuickWireTarget")
dojo.require("com.ibm.mm.builder.iwidget.columnlayout.defaultSettings");
dojo.require("com.ibm.mm.builder.widgetLoader");
dojo.require("com.ibm.mm.builder.widget.MumColorPalette");
dojo.require("com.ibm.mm.builder.iwidget.columnlayout.configHelper");
dojo.require("com.ibm.mm.builder.iwidget.columnlayout.columnUtil");
dojo.require("com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil");
dojo.require("com.ibm.mm.builder.widget.mumHeightResizer");
dojo.require("com.ibm.mm.builder.widget.columnLayoutResizeWidget");
dojo.require("com.ibm.mm.builder.widget.columnLayoutMoveWidget");
dojo.require("com.ibm.mm.builder.utils.PageWidthChanger");
dojo.require("com.ibm.mm.builder.personalize");
dojo.require("com.ibm.mm.builder.widget.WidgetEditBar");

dojo.declare("com.ibm.mm.builder.systemwidget.ColumnLayout",com.ibm.mm.builder.iwidget.GenericLayout,{	

	WID:null,	
	configHelper:null,
	LAYOUT_DATA:"layout:columnlayout;",
	currentPageMode: "view",
    setting: null,
    pageId: null,
	widgetSkinParams: {},
	_widgetLoadedConnects: [],
	
	//======================================iWidget event=========================================
	/**
	 * onLoad is the event which will be called when the column layout widget is loading
	 */
	onLoad: function(){
    	this.layoutWidgetId = this.iContext.widgetId;
		this.widgetContainerId = this.iContext.widgetId;
		this.WID = "_" + this.iContext.widgetId + "_";
		this.sourceContainer = [];
		this.iWidgetAttributes = this.iContext.getiWidgetAttributes();
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.ColumnLayout");
		this.eventService = serviceManager.getService("eventService");
		
		this.disableQuickWiring = (this.iWidgetAttributes.getItemValue("disableQuickWiring") === "true");
		
		this.configHelper = new com.ibm.mm.builder.iwidget.columnlayout.configHelper(this.iContext);
		this.configHelper.layoutdata = this.LAYOUT_DATA;
		this.configHelper.layoutObject = this;
		
		com.ibm.mm.builder.columnLayoutBean = new com.ibm.mm.builder.iwidget.columnlayout.defaultSettings();
		com.ibm.mm.builder.columnLayoutBean.setWidgetId(this.iContext.widgetId);
		
		this.configHelper.initContainerWidget();
		
		var configIconNode = dojo.byId(this.WID + "configIcon");
		configIconNode.src = builderConfig.builderPath + (builderConfig.isBidi ? 
			"/images/layoutwidget_settings_button_rtl.png" : "/images/layoutwidget_settings_button.png");
		configIconNode.alt = configIconNode.title = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_ICON_HOVERTEXT;
		
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().registerLayout(this.iContext.widgetId);
        this._cacheInitSetting();
		    	
		dojo.subscribe(com.ibm.mm.builder.eventTopics.Widget_Column_AddOrDel, this, "adjustColumnHeight");
		this.widgetUnloadedHandle = this.eventService.subscribeEvent(
			com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED, this, this.onOldWidgetsUnloaded);
	},
	
	/**
	 * onview event will be called when user switch the widget mode to view 
	 */
	onview:function(){
		//dojo.parser.parse(this.iContext.getRootElement());
		com.ibm.mm.builder.utils.htmlUtil.showScrollBar(this.iContext.widgetId);
		this.configHelper.applyStyleConfiguration();
		com.ibm.mm.builder.utils.layoutUtil.stretchHeight(this.iContext.widgetId);
		
		//adjust the position style of freeform view root node so that 
		//it will not cover the scroll bar when the page is embeded
		if (dojo.isIE < 8 && window.location.pathname.indexOf("myembedding") >= 0) {
			dojo.style(this.WID + "view", "position", "");
			dojo.style(this.WID + "container", "position", "static"); 
		}
	},

	/**
	 * onedit event will be called when user switch the widget mode to edit 
	 */
	onedit:function(){
		//dojo.parser.parse(this.iContext.getRootElement());
		this.configHelper.initConfiguration();
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil.createSkinConfigUI(this.WID+"skinConfig",this.iContext.widgetId);
		var att = this.iContext.getiWidgetAttributes();	
		var skin = "";	
		if (att != null) {
			skin = att.getItemValue("skin");			
		}
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin(skin,this.iContext.widgetId);		
		this.configHelper.fillInTheText();
	},	
	//======================================end iWidget event=========================================

	//======================================iEvent handler=========================================

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.changePageMode'
	 * @param {Object} iEvent payload
	 */
	onPageModeChanged: function(iEvent){
		var mode = iEvent.payload;
		if(mode === "view" || mode === "edit") {
			this.currentPageMode = mode;
			this.configHelper.currentPageMode = mode;
			this.configHelper.toChangeColumnMode();		
			if (mode === "view") {
				this._hideWidgetEditbar();
			} else if (this.initialEdit){
				dojo.forEach(this.getWidgets(),  function(widgetId){
					if (dojo.byId(widgetId).getAttribute("internalwidget") != "true" && dojo.byId(widgetId).getAttribute("widgetInTab") != "true") {
						this.attachWidgetEditHandle(widgetId);
					}
				}, this);
				this.initialEdit = false;
			}
		}
	},
	
	_filterColumnLayoutAttr : function(pageAttr){
		var layoutWidgetAttributes = {};
		var columnAttributes = {};
		var pageAttributes = {};
		
		for(var key in pageAttr){
			if (key.indexOf("columnattributes") >= 0)
				columnAttributes[key.substring(key.indexOf("_") + 1)] = dojo.fromJson(pageAttr[key]);
			else
				if(key.indexOf("pageattributes") >= 0) 
					pageAttributes[key.substring(key.indexOf("_") + 1)] = pageAttr[key];
				else
					layoutWidgetAttributes[key] = pageAttr[key];				
		}
		
		var jsonColumnAttributes = dojo.toJson(columnAttributes);
		if(jsonColumnAttributes != "{}")
			layoutWidgetAttributes["columnattributes"] = jsonColumnAttributes;
		
		var jsonPageAttributes = dojo.toJson(pageAttributes);
		if( jsonPageAttributes!= "{}")
			layoutWidgetAttributes["pageattributes"] = jsonPageAttributes;
		
		return dojo.toJson(layoutWidgetAttributes) == "{}" ? null : layoutWidgetAttributes;
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.pageSwitched'
	 * @param {Object} iEvent payload
	 */
    onPageSwitched: function(iEvent){
		this.initialEdit = true;
        this.pageId = iEvent.payload;
		if (this.pageId == "com.ibm.mm.builder.embedPageFailErrMsg"){
			this.loadMsgToLayout(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_PAGEACCESS_ERROR_0); 
			return;
		}
        if (!this.pageId) {
			com.ibm.mm.builder.utils.themeUtil.unloadAllWidgets(false);
			this.loadMsgToLayout(com.ibm.mm.builder.coreWidgetsStrings.W_NO_PAGE_TO_SHOW); 
			return;
		} else {
			var pageContent = com.ibm.mm.builder.utils.layoutUtil.getPageContent(this.pageId);
			if (pageContent == null){
				com.ibm.mm.builder.utils.themeUtil.unloadAllWidgets(false);
				this.loadNullToLayout(); 
				return;
			}			
			this.content = pageContent.content;
			
			var pageAttributes = this._filterColumnLayoutAttr(pageContent.pageAttributes);
			pageAttributes = !pageAttributes ? this.defaultInitialSettings : 
				com.ibm.mm.builder.iwidget.columnlayout.columnUtil.validatePageMetaData(pageAttributes);
			
			com.ibm.mm.builder.columnLayoutBean.setSelectedSkin(pageAttributes.skin);
			this.iWidgetAttributes.setItemValue("skin", pageAttributes.skin, false);
			
			com.ibm.mm.builder.columnLayoutBean.setColumnsJSONObject(dojo.fromJson(pageAttributes.columns));
			this.iWidgetAttributes.setItemValue("columns", pageAttributes.columns, false);
			
			com.ibm.mm.builder.columnLayoutBean.setColumnAttrJSONObject(dojo.fromJson(pageAttributes.columnattributes));
			this.iWidgetAttributes.setItemValue("columnattributes", pageAttributes.columnattributes, false);
			
			com.ibm.mm.builder.columnLayoutBean.setPageAttrJSONObject(dojo.fromJson(pageAttributes.pageattributes));
			this.iWidgetAttributes.setItemValue("pageattributes", pageAttributes.pageattributes, false);
			this.iWidgetAttributes.save();
			
			//Set page level auto-wiring enable info
			var autoWiringEnabled = pageAttributes[com.ibm.mm.builder.constant.autoWiringEnabled];
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setAutoWiringEnablement(autoWiringEnabled);
		}
		// Note: this is a temporary solution for defect 7971.
		com.ibm.mm.builder.utils.themeUtil.unloadWidgetsInLayout(this.iContext.widgetId);
    },
	
    _cacheInitSetting: function(){
		this.defaultInitialSettings = {
			version: this.iWidgetAttributes.getItemValue("version"),
	        skin: com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId(),
	        columns: this.iWidgetAttributes.getItemValue("columns"),
	        columnattributes: this.iWidgetAttributes.getItemValue("columnattributes"),
	        pageattributes: this.iWidgetAttributes.getItemValue("pageattributes")
		};
    },		
	
	loadMsgToLayout:function(msg){
		this.applyPageWidthMode();
		this.configHelper.applyPageAttributes(dojo.fromJson(this.defaultInitialSettings.pageattributes));
		var containerNode = dojo.byId(this.WID + "container"); 
		containerNode.innerHTML = com.ibm.mm.builder.utils.pageUtil.getEmptyPageMessage(msg);
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(containerNode);
	},
	
	loadNullToLayout:function(){
		this.applyPageWidthMode();
		this.configHelper.applyPageAttributes(dojo.fromJson(this.defaultInitialSettings.pageattributes));
		var containerNode = dojo.byId(this.WID + "container"); 
		containerNode.innerHTML = "";
	},	
	
	onOldWidgetsUnloaded: function(){
		if (this.pageId && !com.ibm.mm.builder.utils.pageUtil.isEmptyPage(this.pageId)){
			var handler = this._widgetLoadedConnects.pop();
			while(handler){
				com.ibm.mashups.services.ServiceManager.getService("eventService").unsubscribeEvent(handler,null);
				handler = null;
				handler = this._widgetLoadedConnects.pop();
			}
			this.loadWidgets();
			this.applyPageWidthMode();
			this.getFirstWidget();
		} 
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.addWidget'
	 * @param {Object} please refer to onWidgetAdded method in freeform layout.
	 */
	onWidgetAdded:function(iEvent){
		var payload  = iEvent.payload;
		if(typeof(payload) === "string" ){
			this.createWidget(payload);
		} else if(typeof(payload) == "object" && payload.widgetMetadata){
			this.createWidgetByMetaData(payload.widgetMetadata,payload.itemSet);
		}else{
			this.createWidget(payload.id,null,payload.itemSet);
		}
	},

	/**
	 * Publish function for iEvent 'com.ibm.mashups.builder.defXMLUrlPublished'
	 * This iEvent is mainly published to embedding page widget
	 * @param {Object} iEvent payload
	 */
	publishColumnXMLUrl:function(){
		this.iContext.iEvents.publishEvent("com.ibm.mashups.builder.defXMLUrlPublished", this.getWidgetDefURL());
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetResized:function(iEvent){
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.widgetId || widgetInfo.id;
		if (com.ibm.mashups.builder.Personalize.isWidgetInLayout(widgetId,this.iContext.widgetId)) {
			var widgetSkinNode = com.ibm.mashups.builder.Personalize.getWidgetSkinNode(widgetId);
			var skinBox = dojo.marginBox(widgetSkinNode);
			skinBox.h = parseInt(widgetInfo.height);
			
			com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, "normal");
			com.ibm.mashups.builder.Personalize.setPersonalizeSize(widgetId,skinBox);
			com.ibm.mashups.builder.Personalize.resetWidgetSkin(widgetId, skinBox);
			com.ibm.mashups.builder.Personalize.resetWidgetContent(widgetId, skinBox); 		
			com.ibm.mashups.builder.Personalize.publicResizeEvent(widgetId);
		}
	},	
	
	onStateChanged:function(iEvent){		
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.iwidgetId;
		var state = widgetInfo.state;
		if (state == null)
			return;
		if (com.ibm.mashups.builder.Personalize.isWidgetInLayout(widgetId,this.iContext.widgetId)){				
			// Get the size of widget skin
			var widgetSkinNode = com.ibm.mashups.builder.Personalize.getWidgetSkinNode(widgetId);
			var skinBox = dojo.marginBox(widgetSkinNode);					
			var size;
			var contentSize;
			com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, state);
			if (state == "max"){
				// set the widget original size information to the navigation state.			
				com.ibm.mashups.builder.Personalize.setPersonalizeSize(widgetId,skinBox);				
				size = dojo.marginBox(this.iContext.getRootElement());
				size.l = 0;
				size.t = 0;
				contentSize = size;;
			}
			else if (state == "min"){
				com.ibm.mashups.builder.Personalize.setPersonalizeSize(widgetId,skinBox);
				var bodyPadTop = 36;
				size = {t:skinBox.t, l:skinBox.l, h:bodyPadTop*2, w:skinBox.w};
				contentSize =  {t:skinBox.t, l:skinBox.l, h:bodyPadTop, w:skinBox.w};				
			}			
			else{
				size = com.ibm.mashups.builder.Personalize.getPersonalizeSize(widgetId);
				contentSize = size;
			}
			
			com.ibm.mashups.builder.Personalize.resetWidgetSkin(widgetId, size);
			com.ibm.mashups.builder.Personalize.resetWidgetContent(widgetId, contentSize); 		
			com.ibm.mashups.builder.Personalize.publicResizeEvent(widgetId);					
		}	
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeAction'
	 * @param {Object} iEvent payload
	 */	
    onResizeDialogShow: function(iEvent){
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.iwidgetId;
		var widgetType = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_RESIZE_WIDGET_PROMPT, [widgetType]);
		var skinMinSize = com.ibm.mm.builder.utils.skinUtil.getMinSize(dojo.byId(widgetId).getAttribute("skin"));
				
		var dialogParam = {
	 		nodeWidth: "395px",
	 		containerBackgroundColor: "white",
			requestRefresh:true
	 	}
		this.resizeDialog = this.resizeDialog || new com.ibm.mm.builder.widget.columnLayoutResizeWidget({
			dlgPara: dialogParam,
			layoutContext: this.iContext
		});
		this.resizeDialog.setTitle(title);
		this.resizeDialog.minHeight = skinMinSize;
		this.resizeDialog.updateProperty(widgetId);
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.moveAction'
	 * @param {Object} iEvent payload
	 */
    onMoveDialogShow: function(iEvent){
        var widgetInfo = iEvent.payload;
        var widgetId = widgetInfo.iwidgetId;
		var widgetType = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MOVE_WIDGET_PROMPT, [widgetType]);
		
        var dialogParam = {
            title: title,
	 		nodeWidth: "395px",
	 		containerBackgroundColor: "white"
        };
        this.moveDialog = this.moveDialog || new com.ibm.mm.builder.widget.columnLayoutMoveWidget({
            dlgPara: dialogParam,
            layoutContext: this.iContext,
            layoutData: this.LAYOUT_DATA
        });
		this.moveDialog.setTitle(title);
		this.moveDialog.updateProperty(widgetId);
    },

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.displayWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetDisplayed: function(iEvent){
		this.displayWidget(iEvent.payload);
	},	
	//======================================end iEvent handler=========================================
	
	//======================================Layout widget function=======================		
	getWidgetDefURL:function(){
		return com.ibm.mm.builder.utils.iwidgetUtil.getWidgetXMLURL(this.iContext.widgetId);
	},

	getWidgets:function(){
		return dojo.map(
			dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,dojo.byId(this.WID + "container")), 
			function(widget){ return widget.id });
	},	
	
	getFirstWidget:function(){
		var widgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.WID + "container"),
            anchor = widgets.length > 0 ? "#" + com.ibm.mm.builder.constant.skinIdPrefix + widgets[0].id : "#content-main",
            skipAnchors = dojo.query("div.skip a");
        
		if (skipAnchors.length > 0) {
			dojo.attr(skipAnchors[0], "href", anchor);
		} else {
			var a = dojo.create("a", {
				"href": anchor,
				"innerHTML": com.ibm.mm.builder.coreWidgetsStrings.I_MAIN_CONTENT
			}, dojo.create("div", {
				"class": "skip"
			}, dojo.body(), "first"));
			
			var func = function() {
				var as = dojo.query(anchor);
				if(as.length > 0) {
					window.location.hash=anchor;
					as[0].focus();
				}
				return false;
			};
			
			dojo.connect(a,'onkeypress',function(e) {
				if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
					func();
				}
			});
			dojo.connect(a,'onclick',func);
			
		}
	},

	transformMarkup:function(pageSource){
		var transformed = pageSource;
		if (pageSource!=""){
			if (pageSource.indexOf(this.LAYOUT_DATA) > 0){ 
			    // already a column layout, no need to transform
				return transformed;
			};
			var tmp = document.createElement("div");
			tmp.innerHTML = pageSource;
			var widgets = dojo.query("[visible='true']",tmp);
			for (var x=0;x<widgets.length;x++){
				if (dojo.hasClass(widgets[x],com.ibm.mm.builder.constant.mmIWidget)){
					var locationStyle = widgets[x].getAttribute("locationstyle");
					var height = com.ibm.mm.builder.utils.skinUtil.getValueFromStyle("height",locationStyle);
					if (height!=null){
						height = parseInt(height);				
					}else{
						height = 100;
					}
					
					widgets[x].setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getLayoutData("1",x+1));
					//TODO: replace the hardcoded string with default column setting
					widgets[x].setAttribute("locationstyle","margin-top:10px;margin-left:0px;margin-right:0px;height:"+height+"px;");
				}
			}
			transformed = tmp.innerHTML;
			delete tmp;
		}
		return transformed;
	},
	
	/**
	 * show widget instnace
	 * @param {Object} message
	 */
	//todo refactor code with createwidget to clean the skin part.
	displayWidget: function(widgetId, columnId){
		//insert widget node
		var draggedNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		columnId = columnId || this.getFirstColumnId();
		var columnDiv = dojo.byId(columnId);
		var colNumIndex = parseInt(columnId.slice(-1));
		var indicator = this.sourceContainer[colNumIndex].dropIndicator;
		indicator ? columnDiv.insertBefore(draggedNode,indicator.domNode) : columnDiv.appendChild(draggedNode);
		draggedNode.style.display = "";
		
		//disconnect the event handlers to avoid memory leak in IE
		var wireIcon = dojo.byId(widgetId + "_wireIcon");
    	var editIcon = dojo.byId(widgetId + "_editIcon");
		if(editIcon )editIcon.onclick = editIcon.onkeypress = null;
		if(wireIcon) wireIcon.onclick = wireIcon.onkeypress = null;
		
		//set skin
		var widgetSpan = dojo.byId(widgetId);
		var nvaSkin = com.ibm.mm.builder.utils.skinUtil.getNVANode();
		var typeOfSkin = widgetSpan.getAttribute("skin") == nvaSkin.getID() ? //if widget is from nva then apply the current skin setting of columnlayout
			com.ibm.mm.builder.columnLayoutBean.getSelectedSkin() : widgetSpan.getAttribute("skin");
        widgetSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, typeOfSkin);
		
		//set location style
		var pageAttrJson = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
		var widgetHeight = dojo.style(draggedNode, "height");
		var locationStyle = dojo.string.substitute(
			"margin-top:${widthBetweenWidgets}px;margin-left:${widgetLeftRightMargin}px;margin-right:${widgetLeftRightMargin}px;",
			pageAttrJson) + "height:" + (dojo.isIE === 6 ? "120" : widgetHeight) + "px;";
        widgetSpan.setAttribute("locationstyle", locationStyle);
		
		//set layout data
        widgetSpan.setAttribute("layoutdata", dojo.string.substitute("${0}column:${1}", [this.LAYOUT_DATA, colNumIndex]));
        widgetSpan.setAttribute("visible", "true");
        this.updateLayoutData(columnDiv);
		com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(widgetSpan);
		
		//update widget content height		
		var widgetContentNode = dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetContent);
		var widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(widgetId 
			+ com.ibm.mm.builder.constant.widgetBody),"paddingTop");
		widgetBodyPadTop = widgetBodyPadTop ? parseInt(widgetBodyPadTop) : 0;
		
		if (builderConfig.isBidi && dojo.isIE &&
				com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.adjustWidgetContent(widgetContentNode,widgetHeight,0)) {
		} else {				
			dojo.marginBox(widgetContentNode, {
				h: widgetHeight - widgetBodyPadTop
			});
		}			
		
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	},
	
	updateLayoutData: function(theColumn) {
		var targetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, theColumn);
		var len = targetColWidgets.length;
		var count = 1;
		for (var i=0;i<len;i++){			
			var layoutAttr = targetColWidgets[i].getAttribute("layoutdata");
			if (layoutAttr){
				targetColWidgets[i].setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(layoutAttr,count));
				count = count + 1;					
			}		
		}
	}, 
	
	getFirstColumnId: function(){
		return this.WID + "Column1";
	},
	
    createWidget: function(id, columnId,itemset){
        var widgetSpan = com.ibm.mm.builder.utils.iwidgetUtil.createWidgetSpan(id,itemset);
        dojo.addClass(widgetSpan, "iWidgetSkin");
        widgetSpan.setAttribute("visible", "true");
        var pageAttrJson = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
		
		columnId = columnId || this.getFirstColumnId()
        var columnDiv = dojo.byId(columnId);
        try {
            var locationStyle = dojo.string.substitute(
	            	"margin-top:${widthBetweenWidgets}px; margin-left:${widgetLeftRightMargin}px; margin-right:${widgetLeftRightMargin}px;",
	            	pageAttrJson) + (dojo.isIE===6 ? "height:120px;" : "");
			
            widgetSpan.setAttribute("locationstyle", locationStyle);
            var targetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, columnDiv);
            var colNumIndex = columnDiv.id.substr(columnDiv.id.length - 1);
            widgetSpan.setAttribute("layoutdata", dojo.string.substitute("${0}column:${1};row:${2};", [this.LAYOUT_DATA, colNumIndex, targetColWidgets.length + 1]));
			
            var indicator = this.sourceContainer[(parseInt(columnId.slice(-1)))].dropIndicator;
            indicator ? columnDiv.insertBefore(widgetSpan, indicator.domNode) : columnDiv.appendChild(widgetSpan);
            
			com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(widgetSpan, id);
			var handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(widgetSpan.id, function(){
	        	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.autoWiringWidget", widgetSpan.id);
	        });
			if(handler){
				this._widgetLoadedConnects.push(handler);
			}
            com.ibm.mm.builder.utils.skinUtil.markIWidgetInstanceAsDraggable(widgetSpan.id);
			com.ibm.mm.builder.utils.skinUtil.updateDefaultSize(widgetSpan.id);
            com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
        } 
        catch (e) {
            this.LOGGER.severe("createWidget", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_COLUMN_CREATE_WIDGET_1, [e.message]))
        }
        
        //who need it?
        window.setTimeout(function(){
            dojo.publish(com.ibm.mm.builder.eventTopics.Widget_Column_AddOrDel, []);
        }, 500);
    },
	
	createWidgetByMetaData: function(widgetMetadata,itemset,params){
		var widgetSpan = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetSpanByMetadata(widgetMetadata,itemset);
		dojo.addClass(widgetSpan, "iWidgetSkin");
		widgetSpan.setAttribute("visible", "true");
        var pageAttrJson = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
		columnId = widgetMetadata["columnId"] || this.getFirstColumnId()
		var columnDiv = dojo.byId(columnId);
		try {
            var locationStyle = dojo.string.substitute(
            	"margin-top:${widthBetweenWidgets}px; margin-left:${widgetLeftRightMargin}px; margin-right:${widgetLeftRightMargin}px;",
            	pageAttrJson);
            widgetSpan.setAttribute("locationstyle", locationStyle);
            var targetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, columnDiv);
            var colNumIndex = columnDiv.id.substr(columnDiv.id.length - 1);
            widgetSpan.setAttribute("layoutdata", dojo.string.substitute("${0}column:${1};row:${2};", [this.LAYOUT_DATA, colNumIndex, targetColWidgets.length + 1]));
			
            var indicator = this.sourceContainer[(parseInt(columnId.slice(-1)))].dropIndicator;
            indicator ? columnDiv.insertBefore(widgetSpan, indicator.domNode) : columnDiv.appendChild(widgetSpan);
            
			com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(widgetSpan, widgetMetadata["id"]);
			var handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(widgetSpan.id, function(){
	        	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.autoWiringWidget", widgetSpan.id);
	        });
			if(handler){
				this._widgetLoadedConnects.push(handler);
			}
            com.ibm.mm.builder.utils.skinUtil.markIWidgetInstanceAsDraggable(widgetSpan.id);
			com.ibm.mm.builder.utils.skinUtil.updateDefaultSize(widgetSpan.id);
            com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
        } 
        catch (e) {
            this.LOGGER.severe("createWidget", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_COLUMN_CREATE_WIDGET_1, [e.message]))
        }
        
        //who need it?
        window.setTimeout(function(){
            dojo.publish(com.ibm.mm.builder.eventTopics.Widget_Column_AddOrDel, []);
        }, 500);
	},
	
	//todo return source?
	getSourceByIndex:function(Index){
		return this.sourceContainer[Index];
	},
	
	/**
	 * loadWidgets will init the column layout widget
	 * create the drop target, load widgets, add skin.
	 */
	loadWidgets: function(){
		var transformed = this.transformMarkup(this.content);
		this.configHelper.initContainerWidget();
		this.configHelper.applyStyleConfiguration();
		try {	//create the drop target. by default, the column number is 3
			var num = com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum();
			this.columnNum = num;
			var x = 0;
			var widgetId = this.iContext.widgetId;
			var root = document.getElementById(widgetId);
			var widgetLoader = com.ibm.mm.builder.initWidgetLoader();
			var haveWidget = false;
			this.configHelper.destroyAllTargets();
			if (transformed != "") {
				haveWidget = true;
			}
			//load widgets		
			// separate widget fragments according to attr: layoutdata="column:x;row:y;" in widget fragment
			var widgetsString = widgetLoader.getColumnWidgets(transformed, num);
			for (var x = 1; x <= num; x++) {
				var onecolumn = dojo.byId(this.WID + "Column" + x);
				this.sourceContainer[x] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.createColumnSource(onecolumn,this);
				if (haveWidget) {
					if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartApplicationWidgets()) {
						var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
						mpHandler.startTransaction();
					}
					widgetLoader.loadWidgets(onecolumn, widgetsString[x + ""]);
					if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartApplicationWidgets()) {
						mpHandler.endTransaction(true);
					}
				}
			}
		} catch (ex) {
			this.LOGGER.severe("loadWidgets", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_COLUMN_LAYOUT_LOAD_1, [ex.message]));
		}	
		window.setTimeout(dojo.hitch(this, function(){	
			this.configHelper.adjustContainerMinHeight();
			this.configHelper.fitScreenHeight();
		}),0);
	},
	
	_onGetMarkup:function(){
		this.preSaveAction();
	},
	
    preSaveAction:function(){
		dojo.forEach(this.getWidgets(), function(widgetId){
			var widgetSpan = dojo.byId(widgetId);
		    var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		    if (skinDiv) {
		        var coposH = dojo.contentBox(skinDiv).h;
		        var locationStyle = widgetSpan.getAttribute("locationstyle");
		        if (locationStyle.indexOf("height:") != -1) {
		            locationStyle = locationStyle.substr(0, locationStyle.indexOf("height:"));
		        }
		        locationStyle = locationStyle + "height:" + coposH + "px;";
		        widgetSpan.setAttribute("locationstyle", locationStyle);
		    }
		});
		
		var attr=this.iContext.getiWidgetAttributes();
		this.configHelper.initWidthOfColumn(com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum());
		var columns = {
			columnNumber: com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum(),
			widths: this.configHelper.widthOfColumn
		};
		attr.setItemValue("columns",dojo.toJson(columns),false);
		attr.save();
		
		var jsonStr=com.ibm.mm.builder.utils.iwidgetUtil.dumpItemSetsToJSON(this.iContext.getiWidgetAttributes());
		var layoutWidgetAttributes = dojo.fromJson(jsonStr);
		var metadata = {};
		
		var columnAttributes = dojo.fromJson(layoutWidgetAttributes.columnattributes);
		var pageAttributes = dojo.fromJson(layoutWidgetAttributes.pageattributes);
		var columns = dojo.fromJson(layoutWidgetAttributes.columns);
		
		for (var key in columnAttributes) {
			if (key == "all" || eval(key) <= eval(columns.columnNumber)) {
				metadata["columnattributes_" + key] = dojo.toJson(columnAttributes[key]);
			}
		}
		
		for(var key in pageAttributes){
			metadata["pageattributes_" + key] = pageAttributes[key];
		}
		
		for(var key in layoutWidgetAttributes){
			if(key != "columnattributes" && key != "pageattributes")
				metadata[key] = layoutWidgetAttributes[key];
		}
		
		var allColumnAttributes = [];
		for(var i = 1; i <= 4; i++){
			allColumnAttributes.push("columnattributes_" + i);
		}
		com.ibm.mm.builder.utils.enablerUtil.removePageMetaData(allColumnAttributes);
		com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData(metadata);
	},
	
	_hideWidgetEditbar : function(mode){
		dojo.forEach(this.getWidgets(), function(widgetId){
			var editbar = dijit.byId(widgetId + com.ibm.mm.builder.constant.dragHandler + "_editbar");
			editbar && editbar.hide();
		});
	},
	
	_createResizeHandler: function(widgetId, minHeight){
		var resizeHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHandlerExt);
		resizeHandler && resizeHandler.destroy();
		
		var resizeHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHeightExt);
		resizeHandler && resizeHandler.destroy();
		resizeHandler = new com.ibm.mm.builder.widget.mumHeightResizer({
			id: 				widgetId + com.ibm.mm.builder.constant.resizeHeightExt,
			targetElmId: 		com.ibm.mm.builder.constant.skinIdPrefix + widgetId,
			contentElmId: 		widgetId + com.ibm.mm.builder.constant.widgetContent,
			widgetBodyElmId: 	widgetId + com.ibm.mm.builder.constant.widgetBody,
			minHeight: 			minHeight
		});
		var resizeBar = dojo.byId(widgetId+com.ibm.mm.builder.constant.resizeHandler);
		resizeBar.appendChild(resizeHandler.domNode);
		
		return resizeHandler;
	},
	
	_createEditbar: function(widgetId, iconUrl, widgetSkinNode){
		widgetSkinNode = widgetSkinNode || dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		
		var editBar = dijit.byId(widgetId + com.ibm.mm.builder.constant.editbarDragHandler);
		editBar && editBar.destroy();
		editBar = new com.ibm.mm.builder.widget.WidgetEditBar({
			id: 		widgetId + com.ibm.mm.builder.constant.editbarDragHandler,
			widgetId: 	widgetId,
			iconUrl: 	iconUrl
		});
		var skinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		skinNode.insertBefore(editBar.domNode, skinNode.firstChild);
		
		if(!this.disableQuickWiring){
			
			var quickWireTarget = com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
			if(quickWireTarget){
				quickWireTarget.destroy();
				delete com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
			}
		
			com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId] = 
				new com.ibm.mm.builder.dnd.QuickWireTarget(editBar.domNode, {
					targetId: widgetId,
					layout: this
				});
		}
		return editBar;
	},
	
	attachWidgetEditHandle: function(widgetId, widgetSkinNode){
		widgetSkinNode = widgetSkinNode || dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		
		var skinParam = this.widgetSkinParams[widgetId];
		var editBar = this._createEditbar(widgetId, skinParam.iconUrl, widgetSkinNode);
		var resizeHandler = this._createResizeHandler(widgetId, skinParam.minHeight);
		
		dojo.connect(editBar, "show", resizeHandler, "show");
		dojo.connect(editBar, "hide", resizeHandler, "hide");
		dojo.connect(widgetSkinNode, "onmouseout", editBar, "hide", true);
		dojo.connect(widgetSkinNode, "onkeypress", editBar, "onKeyPress");
		
		if (dojo.isIE == 6 || (builderConfig.isBidi && dojo.isIE)) { // 2622
			dojo.hasClass(widgetSkinNode, "mumWidgetTitleBar") && dojo.connect(widgetSkinNode, "onmousemove", editBar, "keep");
		}
		
		var widgetBody = dojo.query(".widgetBody",widgetSkinNode)[0];
		if(widgetBody) {
			dojo.connect(widgetBody, "onmouseover", editBar, "show", true);
			if(dojo.isSafari || dojo.isIE) { // 2797
				widgetBody.onselectstart = function() {
					event.cancelBubble=true;
					return true;
				};
			}
		}
		com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(widgetId);
	},
	
	postAttachSkin:function(message){
		var skinParam = message.skinParam;
		var widgetId = message.widgetId;
		var widgetSpan = dojo.byId(widgetId);
		var skinNode = dojo.byId(message.skinNodeId);	
		dojo.attr(skinNode,"tabindex","0");
		var skinId = widgetSpan.getAttribute("skin");
		var skinUtil = com.ibm.mm.builder.utils.skinUtil;
		skinUtil.skinMinSize[skinId] = skinUtil.skinMinSize[skinId] || skinParam.minHeight; 
		if(dojo.isIE==6 && skinId != "NoSkin"){
			dojo.byId(widgetId+com.ibm.mm.builder.constant.widgetContent).style.marginTop=0;
		}
		
		if (builderConfig.isBidi) {
			com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.overrideStyle(dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetBody));			
			com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.overrideStyle(dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetContent));
		}
		
		this.widgetSkinParams[widgetId] = skinParam;
		if (!dojo.isIE || (dojo.isIE && this.currentPageMode === "edit")) {
			this.initialEdit = false;
			this.attachWidgetEditHandle(widgetId, skinNode);
		}

		//init the height and width of div
		var locationStyle = widgetSpan.getAttribute("locationstyle");
		var height = parseInt(com.ibm.mm.builder.utils.skinUtil.getValueFromStyle("height",locationStyle));
		// 6783: make skin and body same size to fix bug with auto height sizing in IE & rtl
		// 9696: IE7,IE8 bidi doesn't need this
		if (!height && dojo.isIE===6){ height = 120; }	
		if (height){	// 2733: the minimun skin size is registed in skinUtil
			var skinMinSize = com.ibm.mm.builder.utils.skinUtil.getMinSize(widgetSpan.getAttribute("skin"));
            height = Math.max(height, skinMinSize);
            dojo.style(skinNode, "height", height + "px");
			
			var widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetBody), "paddingTop");
            widgetBodyPadTop = widgetBodyPadTop ? parseInt(widgetBodyPadTop) : 0;
			
			var contentHeight = height - widgetBodyPadTop;
			var contentDiv = dojo.byId(widgetId+com.ibm.mm.builder.constant.widgetContent);	

			if (builderConfig.isBidi && dojo.isIE){
				com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.adjustWidgetContent(
					contentDiv, height, skinMinSize);
			} else {				
				dojo.marginBox(contentDiv, {h: contentHeight});
			}			
		}
		com.ibm.mm.builder.utils.skinUtil.markIWidgetInstanceAsDraggable(widgetId);	
		com.ibm.mm.builder.utils.layoutUtil.publishWidgetSize(message.widgetId);
	},
	
	adjustColumnHeight:function(){
		this.configHelper.adjustContainerMinHeight();
	},
	
	//======================================end Layout widget function=======================
	
	//======================= User Action in the configuration UI of column layout ====================
	showConfiguration:function(){
		this.configHelper.showConfiguration();
	},

	showPageBgColorPicker:function(){
		this.configHelper.showPageBgColorPicker();
	},	
	
	showPageBgColorPickerWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) return true;		
		this.configHelper.showPageBgColorPicker();		
	},
	
	showPageBorderColorPickerWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) return true;		
		this.configHelper.showPageBorderColorPicker();		
	},

	showMorePageProperty:function(){
		this.configHelper.showMorePageProperty();
	},
	
	showMorePagePropertyWithKey:function(event){
		this.configHelper.showMorePagePropertyWithKey(event);		
	},
	
	showPageBorderColorPicker:function(){
		this.configHelper.showPageBorderColorPicker();
	},
	
	selectBGINone:function(){
		this.configHelper.selectBGINone();
	},
	
	selectBGIURL:function(){
		this.configHelper.selectBGIURL();
	},
	
	selectDSApllyToExisting:function(){
		this.configHelper.selectDSApllyToExisting();
	},
		
	selectDSApllyToAll:function(){
		this.configHelper.selectDSApllyToAll();
	},
		
	restoreDefaultPageConfiguration:function(){
		this.configHelper.restoreDefaultPageConfiguration();
	},	

	changeColumnNumber:function(){
		this.configHelper.changeColumnNumber(this.configHelper.columnAttrRestoreJsonObj);
	},
	
	showMoreColumnProperty:function(){
		this.configHelper.showMoreColumnProperty();
	},
	
	showMoreColumnPropertyWithKey:function(event){
		this.configHelper.showMoreColumnPropertyWithKey(event);		
	},
	
	changeColumn:function(){
		this.configHelper.changeColumn();
	},
	
	showColBorderColorPicker:function(){
		this.configHelper.showColBorderColorPicker();
	},
	
	showAllColBgColorPicker:function(){
		this.configHelper.showAllColBgColorPicker();
	},
	
	showAllColBorderColorPicker:function(){
		this.configHelper.showAllColBorderColorPicker();
	},
		
	showAllColBgColorPickerWithKey:function(event){
		var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) return true;
		this.configHelper.showAllColBgColorPicker();
	},
	
	showAllColBorderColorPickerWithKey:function(event){
		var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) return true;
		this.configHelper.showAllColBorderColorPicker();
	},
	
	restoreDefaultColConfiguration:function(){
		this.configHelper.restoreDefaultColConfiguration();
	},
	
	showMoreWidgetProperty:function(){
		this.configHelper.showMoreWidgetProperty();
	},
	
	showMoreWidgetPropertyWithKey:function(event){
		this.configHelper.showMoreWidgetPropertyWithKey(event);		
	},
	
	restoreDefaultWidgetConfiguration:function(){
		this.configHelper.restoreDefaultWidgetConfiguration();
	},	
					
	cancelInput:function(){
		this.configHelper.cancelInput();
	},	

	saveInput:function(){
		this.configHelper.saveInput();
	},
	//======================= End of User Action =================================================	
	
	processLocationWhenChangeSkin: function(widgetId) {
		var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		var widgetSpan = dojo.byId(widgetId);
		var height = dojo._getContentBox(widgetSkin).h;
		var locationStyle = widgetSpan.getAttribute("locationstyle");
		if(locationStyle.indexOf("height")>=0) {
			locationStyle = locationStyle.replace(/height:.*;/, "height:"+height+"px;");
		} else {
			locationStyle += "height:"+height+"px;";
		}
		widgetSpan.setAttribute("locationstyle",locationStyle);
	},

	createPageWidthModeProvider : function() {
		return {
			getPageWidthMode : dojo.hitch(this, function() {
				var att = this.iContext.getiWidgetAttributes();
				return this.configHelper.getPageWidthMode(att);
			})
		};
	},

	createDynamicWidthRangeProvider : function(width) {
		var self = this;
		return {
			getMinimum : function() {
				return Math.max(800, width);
			},
			
			getMaximum : function() {
				return 2000;
			}
		};
	},
	
	createFixedWidthRangeProvider : function(width) {
	   return {
	      getMinimum : function() {
		     return width;
		  },
		  getMaximum : function() {
		     return width;
		  }
	   };
	},
	
	switchToPageMode : function(newPageMode) {
	    var pageWidthChanger = com.ibm.mm.builder.utils.pageWidthChanger;
		pageWidthChanger.setPageWidthModeProvider(this.createPageWidthModeProvider());
		pageWidthChanger.setWidgetListProvider({
			   getWidgetIds : function() {
				  return [];
			   }
		});
		if (newPageMode.mode == "fixed") {
			pageWidthChanger.setWidthRangeProvider(this.createFixedWidthRangeProvider(newPageMode.width));
			pageWidthChanger.changeWidth(newPageMode.width);
			this.configHelper._resizeColumns();
		}
		else {
		   pageWidthChanger.setWidthRangeProvider(this.createDynamicWidthRangeProvider(newPageMode.width));
		   pageWidthChanger.changeWidthToFitViewport(newPageMode.width);
		   this.configHelper._resizeColumns();
		}
	},
	
	applyPageWidthMode : function() {
		var pageWidthChanger = com.ibm.mm.builder.utils.pageWidthChanger;
		pageWidthChanger.setPageWidthModeProvider(this.createPageWidthModeProvider());
		pageWidthChanger.addPageWidthModeChangedListener(dojo.hitch(this, function(payload) {
		   var newPwm = payload.summary["new"];
		   this.configHelper.savePageWidthMode(newPwm);
		   this.switchToPageMode(newPwm);
		}));
		var storedPwm = pageWidthChanger.getPageWidthMode();
		this.switchToPageMode(storedPwm);
	},
	
	onUnload: function(){
		dojo.forEach(this.sourceContainer, function(item){
			if(item && item.destroy) item.destroy();
		});
		dojo.unsubscribe(this.widgetUnloadedHandle);
		dojo.forEach(this.getWidgets(), function(widgetId){
			com.ibm.mm.builder.commonActions.removeWidget(widgetId);
		});		
	},
	
	_resetOldStyle : function(excludedProperties) {
        excludedProperties = excludedProperties || [];
        var container = dojo.byId(this.WID + "container");
        var oldStyle = {};
        dojo.forEach(excludedProperties, function(prop) {
            oldStyle[prop] = dojo.style(container, prop);
        });
        
        dojo.attr(container, "style", "");
		// fix for 11834, IE seems can't change the style by the above code,while FF works fine.
		if (dojo.isIE){
			container.style.background = "";
		}
        for (prop in oldStyle) {
            if (oldStyle.hasOwnProperty(prop)) {
                var value = oldStyle[prop];
                if (typeof value === "number") {
                    value += "px";
                }
                dojo.style(container, prop, value);
            }
        }
    },
	
	onStyleReset: function(iEvent){
		this._resetOldStyle(["width", "minHeight"]);
		
		var pageAttrJSONObj = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
		pageAttrJSONObj.pageBgColor = "transparent";
		pageAttrJSONObj.pageBgImageType = "None";
		pageAttrJSONObj.pageBorder = "none";
		com.ibm.mm.builder.columnLayoutBean.setPageAttrJSONObject(pageAttrJSONObj);

		var att = this.iContext.getiWidgetAttributes();
		att.setItemValue("pageattributes", dojo.toJson(pageAttrJSONObj), false);
		att.save();
		
		com.ibm.mm.builder.utils.enablerUtil.setPageMetaData("pageattributes_pageBgColor", "transparent");
		com.ibm.mm.builder.utils.enablerUtil.setPageMetaData("pageattributes_pageBgImageType", "None");
		com.ibm.mm.builder.utils.enablerUtil.setPageMetaData("pageattributes_pageBorder", "none");
	},
	
	onStyleChanged: function(iEvent){
		var styleObject = iEvent.payload;
		
		var pageAttrJSONObj = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
		for (key in styleObject) {
			dojo.style(this.WID + "container", key, styleObject[key]);
			if (key.indexOf("background") >= 0 || key == "opacity") {
				switch (key) {
					case "backgroundColor":
						pageAttrJSONObj.pageBgColor = styleObject[key];
						break;
					case "backgroundImage":
						pageAttrJSONObj.pageBgImage = styleObject[key];
						pageAttrJSONObj.pageBgImageType = styleObject[key] === "none" ? "None" : "URL";
						break;
					case "backgroundRepeat":
						switch (styleObject[key]) {
							case "no-repeat":
								pageAttrJSONObj.backgroundimageproperty = "Center";
								break;
							case "repeat-x":
								pageAttrJSONObj.backgroundimageproperty = "RepeatX";
								break;
							case "repeat-y":
								pageAttrJSONObj.backgroundimageproperty = "RepeatY";
								break;
							case "repeat":
								pageAttrJSONObj.backgroundimageproperty = "Repeat";
								break;
						}
						break;
					case "opacity":
						pageAttrJSONObj.bgImageOpacity = 100 - 100 * parseInt(styleObject[key]);
						break;
				}
			} else if (key === "border") {
					var borderStyle = styleObject[key];
					var subBorderStyles = borderStyle.split(" ");
					pageAttrJSONObj.pageBorder = subBorderStyles[0] + " " + subBorderStyles[1];
					pageAttrJSONObj.pageBorderColor = subBorderStyles[2];
				}
		}
		com.ibm.mm.builder.columnLayoutBean.setPageAttrJSONObject(pageAttrJSONObj);
		this.iWidgetAttributes.setItemValue("pageattributes", dojo.toJson(pageAttrJSONObj), false);
		this.iWidgetAttributes.save();
		
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	}
});
