/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("dojo.cookie");
/**
 * @author Erik (bizheng@cn.ibm.com)
 */
dojo.declare("com.ibm.mm.builder.CommonActions",com.ibm.mm.builder.iwidget.SystemTemplatedWidget,{
	
	onView: function(){
		this.inherited(arguments);
		this.cws = com.ibm.mm.builder.coreWidgetsStrings;
		this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		this.user.innerHTML = com.ibm.mashups.enabler.model.Factory.getUserModel().findCurrentUser().start().getDisplayName();
		
		if (!com.ibm.mm.builder.utils.userUtil.isLookasideEnabled()) {
			this.settings.style.display = "none";
			this.setting_spliter.style.display = "none";
		}
		
		if (com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
			this.user.style.display = "none";
			this.user_spliter.style.display = "none";
			this.settings.style.display = "none";
			this.setting_spliter.style.display = "none";
		}		
		
		var anonymousUser = this.cs.getValue("anonymousUser");
		var securityOff = this.cs.getValue("securityOff");
		if (!anonymousUser || securityOff){
			this.logout.style.display = "";
			this.logout_spliter.style.display = "";
		}
		
		if (com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
			this.logout.style.display = "none";
			this.logout_spliter.style.display = "none";
			this.login.style.display = "";
			this.login_spliter.style.display = "";
			this.login.href = this.cs.getValue(this.cs.LOGIN_URL);			
		}
						
        this.logout.href = this.cs.getValue(this.cs.LOGOUT_URL);	// read logout URL from config service
		
		if (builderConfig.isBidi) {//fix Hebrew (iw), Arabic (ar) does not need this
			this.user.dir = "rtl";
			this.settings.dir = "rtl";
			this.help.dir = "rtl";
			this.logout.dir = "rtl";		
			this.login.dir = "rtl";		
		}
		
		this.iWidgetAttributes = this.iContext.getiWidgetAttributes();
		this._cacheInitSetting();
		this._initConfiguration();
	},
	
	_settingsActionWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE) {
			this.settingsAction(e);
		}		
	},
	
	settingsAction: function(evt){
		com.ibm.mm.builder.commonActions.accountSettings();
	},
	
	_logoutActionWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE) {
			this.logoutAction(e);
		}
	},

	logoutAction: function(evt){
		//remove the cookie WASReqURL by setting it expired
		var d=new Date();
        d.setTime(d.getTime()-10000);
		if(!com.ibm.mm.builder.utils.spaceUtil.isPersonalSpace()) dojo.cookie("inPersonalSpace", null);
        window.document.cookie= "WASReqURL=/mm/enabler; expires="+ d.toGMTString() +";";

		var changed = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty();
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")) {
			var user = com.ibm.mm.builder.utils.userUtil.getCurrentUser();
			if (!com.ibm.mm.builder.utils.navigationUtil.isLastPageWhenLogin()) {
				var navigationStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
				navigationStateModel.dispose();
			}
		}
		var _cs = this.cs;
		var self = this;
		if(changed){
			//if in edit mode and page is changed
			dojo.stopEvent(evt);
			new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
				contentWarning: this.cws.I_PAGE_SAVE_WARNING,
				contentQuestion: this.cws.I_PAGE_SAVE_SUGGEST,
				btnSaveText: this.cws.I_COMMON_SAVE,
				btnNotSaveText: this.cws.I_PAGE_SAVE_NO_SAVE,
				btnCancelText: this.cws.I_PAGE_SAVE_KEEP_EDIT,
				charLimit: 50,
				callbackSave: function(){
					self._doLogout();
				},
				callbackNotSave: function(){
					self._doLogout();
				}
			}).show();
		}
		else {
			this._doLogout();
		}
	},
	
	_doLogout : function() {
		com.ibm.mm.builder.utils.themeUtil.unloadAllWidgets(false);
		var _cs = this.cs;
		location.href = _cs.getValue(_cs.LOGOUT_URL);  
	},
	
	_loginActionWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE) {
			this.loginAction(e);
		}
	},	
	
	loginAction: function(){
		location.href = this.cs.getValue(this.cs.LOGIN_URL);
	},
	
	_cacheInitSetting: function(){
        this.defaultInitialSettings = {
        	helpurl: this.iWidgetAttributes.getItemValue("helpurl"),
        	helptooltip: this.iWidgetAttributes.getItemValue("helptooltip")
        };
	},
	
	_initConfiguration: function(){
		dojo.attr(this.help,"href",this.defaultInitialSettings.helpurl);
		// add title for href			
		var coreWidgetStringTitle = com.ibm.mm.builder.coreWidgetsStrings[this.defaultInitialSettings.helptooltip];
		if (coreWidgetStringTitle) dojo.attr(this.help,"title",coreWidgetStringTitle);
		else dojo.attr(this.help,"title",this.defaultInitialSettings.helptooltip);		
	}
});
