dojo.registerModulePath("com.ibm","/mum/js/com/ibm");
dojo.require("com.ibm.customize.TabbedController");
dojo.require("com.ibm.customize.MashupsAddContentController");
dojo.require("com.ibm.customize.AddContentPaletteContainer");
dojo.extend(com.ibm.customize.AddContentPaletteContainer, com.ibm.customize.MashupsAddContentController);  // extension added here so a different extension can be added in Portal
dojo.require("com.ibm.customize.MashupsChangeStyleController");
dojo.require("com.ibm.customize.ChangeStylePaletteContainer");
dojo.extend(com.ibm.customize.ChangeStylePaletteContainer, com.ibm.customize.MashupsChangeStyleController);  // extension added here so a different extension can be added in Mashups
dojo.require("com.ibm.data.MashupFileDataStore");

dojo.declare("com.ibm.mm.builder.systemwidget.customizationShelf", null, {
	defaultTheme: "defaultTheme/framework/layoutTheme",
	onLoad: function(){
		var themeId = com.ibm.mm.builder.utils.themeUtil.getCurrentThemeId();
		var themeNode = com.ibm.mm.builder.utils.themeUtil.getThemeNode(themeId);
		ibmConfig.themeBasePath = themeNode.getBaseUrl();
		var imagePath = ibmConfig.themeBasePath + "css/images";
		this.eventService = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
	
		var addContent = new com.ibm.customize.AddContentPaletteContainer(
				{
					size:12,
					numRows:3,
					smallWidget:true,
					jsonFile:ibmConfig.themeBasePath + "addContent.json",
					imagePath:imagePath,
					createProxyURI:this.iContext.io.rewriteURI,
					eventService: this.eventService
				},document.createElement("div"));
		
		this.changeStyle = new com.ibm.customize.ChangeStylePaletteContainer(
				{
					imagePath:imagePath,
					set:com.ibm.mm.builder.utils.enablerUtil.getPageMetaData("com/ibm/customize/changeStyleController/style") || this.defaultTheme,
					jsonFile:ibmConfig.themeBasePath + "changeStyle.json",
					baseCssPath:ibmConfig.themeBasePath + "css/",
					eventService: this.eventService
				},document.createElement("div"));
		
		this.shelf = new com.ibm.customize.TabbedController(
				{
					imagePath:imagePath,
					transitions: false,
					eventService: this.eventService,
					templateString: 
						'<div class="lotusui ibmPortalCustomizeShelf lotusPalette" style="display: none;">' +
							'<div class="lotusPaletteHeader">' +
								'<ul dojoAttachPoint="tabs" class="lotusTabs"></ul>' +
								'<a class="lotusAction lotusRight" dojoAttachPoint="cancel" href="javascript:void(0)">${cancelText}</a>' +
								'<form><input class="lotusFormButton lotusRight" dojoAttachPoint="save" type="submit" value="${okText}"/></form>' +
							'</div>' +
							'<div dojoAttachPoint="containerDivs"></div>' +
						'</div>', 
					onFirstOpen: function(){
						this.fillTabs();
					},
					goToViewMode: function(){
						this.eventService.broadcastEvent("com.ibm.mashups.builder.changePageMode","view");
						com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setPageMode("view");
						dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change",["View"]); 
						com.ibm.mm.builder.commonActions.changePageMode("view");
					},
					postCreate: function(){
						this.cancel.onclick = dojo.hitch(this, function(){
							com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
							this.toggleDisplay(); 
							this.undoChildren();
							return false; 
						});
						this.save.onclick = dojo.hitch(this, function(){
							this.toggleDisplay();
							this.goToViewMode();
							this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
							return false; 
						});
					},
					children:[
					          {tabName:"Add Content",controller:addContent},
					          {tabName:"Change Style",controller:this.changeStyle}
					         ]
				},"customizationShelfContainer");
		this.save = dojo.hitch(this.shelf,this.shelf.saveChildren);
	},
	    
	onPageModeChanged: function(iEvent){
		var mode = iEvent.payload;
	    if (mode == "view" && this.shelf.displayState == "open" || mode == "edit" && this.shelf.displayState == "closed"){
			this.shelf.toggleDisplay();
		}
	},
	
	onSavePage: function(){
		this.save();
	},
	
	onPageSwitched: function(iEvent){
		var style = com.ibm.mm.builder.utils.enablerUtil.getPageMetaData("com/ibm/customize/changeStyleController/style") || this.defaultTheme;
		this.changeStyle.set = style;
		this.changeStyle.undo();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
    },
		
	onUnLoad: function(){
	    if (this.shelf != null) {
			this.shelf.destroy();
	        this.shelf = null;
	    } 
	}
});