dojo.registerModulePath("com.ibm","/mum/js/com/ibm");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Theme");

dojo.declare("com.ibm.mm.builder.systemwidget.customizeButtonModeSelector", null, {
	onLoad: function(){
		this.eventService = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		dojo.subscribe("com.ibm.mm.catalog.Topics.Mode_Change",this,"setCurrentMode");
		this.customizeButton = dojo.byId("customizeShelfButton");
		var customizeButtonText = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["theme_customize"];
		this.customizeButton.innerHTML = customizeButtonText;
		this.customizeButton.title = customizeButtonText;
	},
	
	onPageCreated: function(iEvent){
        this.newPage = true;
    },
	
	setCurrentMode: function(mode){
		this.currentMode = mode;
	},
	
	onPageSwitched: function(iEvent){
        var pageId = iEvent.payload;
        if(pageId) {
	        //Default, Go to 'View" mode when switching page   
	        if(!this.newPage) {
	        	var accessLevel = com.ibm.mm.builder.utils.acModelUtil.getUserPermission(pageId); 
				this.updatePermissionWithLevel(accessLevel);
				this.goToViewMode();
	        }
	        // Go to 'Edit" mode if it's a newly created page  
	        else {
	        	this.updatePermissionWithLevel(com.ibm.mm.builder.utils.acModelUtil.OWNER);
	        	this.goToEditMode();
	        	this.newPage = false;
	        }
        }
        else {
        	this.updatePermissionWithLevel(com.ibm.mm.builder.utils.acModelUtil.VIEW);
        	this.goToViewMode();
        }
    },
    
    updatePermissionWithLevel:function(permissionLevel){
		switch(permissionLevel){
			case com.ibm.mm.builder.utils.acModelUtil.VIEW:
				if(this.events){
					dojo.forEach(this.events,dojo.disconnect);
				}
				dojo.addClass(this.customizeButton,"lotusBtnDisabled");
				break;
			case com.ibm.mm.builder.utils.acModelUtil.EDIT:case com.ibm.mm.builder.utils.acModelUtil.OWNER:
				if(this.events){
					dojo.forEach(this.events,dojo.disconnect);
				}
				this.events = [dojo.connect(this.customizeButton,"onclick",this,"onTitleClick"),dojo.connect(this.customizeButton,"onkeypress",this,"onKeyPress")];
				dojo.removeClass(this.customizeButton,"lotusBtnDisabled");
				break;
			default:
				dojo.addClass(this.customizeButton,"lotusBtnDisabled");
				break;
		}
	},
	
	onKeyPress:function(evt){
		if(evt && evt.type === "keypress" && evt.keyCode == dojo.keys.ENTER){
			this.onTitleClick();
		}
	},
	
	onTitleClick: function(){
		if(this.currentMode == "Edit"){ 
			this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
			dojo.publish(com.ibm.mm.builder.eventTopics.Save_Icon_Change,[false]);
			this.goToViewMode();
		}
		else if(this.currentMode == "View"){
			this.goToEditMode();
		}
	},
	
	goToViewMode: function(){
		this.eventService.broadcastEvent("com.ibm.mashups.builder.changePageMode","view");
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setPageMode("view");
		dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change",["View"]);
		com.ibm.mm.builder.commonActions.changePageMode("view");
	},
	
	goToEditMode: function(){
		this.eventService.broadcastEvent("com.ibm.mashups.builder.changePageMode","edit");
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setPageMode("edit");
		dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change",["Edit"]);
		com.ibm.mm.builder.commonActions.changePageMode("edit");
	},
		
	onUnLoad: function(){
	}
});