/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.declare("com.ibm.mm.builder.systemwidget.displayHelper", null, {
	
	dialogContent:null,
	
	uniDialog:null,
	
	widgetDialogMap:null,
	
	idMap:null,
	
    onLoad: function(){
		this.widgetDialogMap = {};
		this.idMap = this.iContext.getiWidgetAttributes();
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.displayHelper");
    },
    
    
    onCloseDialog:function(iEvent){
    	var widgetId = iEvent.payload;
    	if(widgetId)
    		this.closeDialog(widgetId);
    },
    
    closeDialog:function(widgetId) {
    	if(this.widgetDialogMap[widgetId])
    		this.widgetDialogMap[widgetId].hide();
    },
	displayWidgetInDialog:function(widgetTypeId,eventName,payload,dialogParam,requestRefresh) {
    	if(widgetTypeId == null)
    		return;
    	
		var connectResize = false;
		
    	//The widget instance id in theme.html
    	var idInTheme = this.idMap.getItemValue(widgetTypeId);
    	if(!idInTheme) {
    		//TODO: need g18n the message here
    		this.LOGGER.severe("displayWidgetInDialog","Can not find the widget in theme to display");
    		return;
    	}
    	
    	if(this.widgetDialogMap[idInTheme] == null) {
    		
	    	//this.initContent(widgetId);
	    	var contentDiv = document.createElement("div");
	    	contentDiv.appendChild(dojo.byId(idInTheme));
	    	var uniDialog = null;
	    	if(dialogParam != null) { // User need to define the UI of dialog
	    		if(!dialogParam.id)
	    			dialogParam.id = idInTheme + "_uniDialog";
		    	uniDialog = new com.ibm.mm.builder.widget.CustomDialog(dialogParam,	contentDiv);
	    	}else {
	    		uniDialog = new com.ibm.mm.builder.widget.CustomDialog(
					{
						id: idInTheme + "_uniDialog"
					},
					contentDiv
				);
	    	}
	    	dojo.removeClass(dojo.byId(idInTheme), "mumHiddenWidget");
	    	if(dojo.isIE && dojo.isIE == 6) //dojo.removeClass has problem in IE6
	    		dojo.byId(idInTheme).style.display = "";
	    	this.widgetDialogMap[idInTheme] = uniDialog;
			
			connectResize = true;
			
    	}else if(requestRefresh == true) {
    		//TODO: need to modify the custom dialog to refresh the UI
			
			// refresh the dialog title
			if(dialogParam.title)
			{
				this.widgetDialogMap[idInTheme].setTitle(dialogParam.title);
			}
    	}
    	
    	//internal hidden var, make the widget can get the outer dialog instance
    	var targetWidgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(idInTheme);
		
		var cb = function(wrapper,displayHelper,widgetTypeId,id,eventName,payload){
				var dialogContainer = displayHelper.widgetDialogMap[id]
				wrapper.iScope.iContext.dialogContainer = dialogContainer;
				if(eventName) {
					serviceManager.getService("eventService").fireEvent(id, eventName, payload);
				}
				com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(dojo.byId(widgetTypeId));
				
				// hook up resize event
				if (connectResize && wrapper.iScope.onDialogResize) {
					dojo.connect(dialogContainer, "onResize", wrapper.iScope, "onDialogResize");
				}
				
				try{
				displayHelper.widgetDialogMap[id].show();
				} catch(e){}
		}
		if (targetWidgetWrapper.isLoaded() == false){
				var me = this;
				serviceManager.getService("eventService").subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + idInTheme, null, dojo.partial(cb, targetWidgetWrapper,me,widgetTypeId,idInTheme,eventName, payload));
		}else{
			cb(targetWidgetWrapper,this,widgetTypeId,idInTheme,eventName,payload);	
		}
    },    
    handleDisplayInDialog:function(iEvent) {
    	var payload = iEvent.payload;
    	/*
    	 * The payload passed by should be a JSON object like
    	 * {
    	 *     widgetTypeId:   //id of widget which will be displayed in dialog
    	 *     eventName:  //name of the event of target widget which will be invoked, no need to invoke if this is null 
    	 *     eventPayload:    //payload which will be passed to the iEvent(option)
    	 *     dialogParam:  // parameter to configure the dialog
    	 *     requestRefresh: // whether it's needed to refresh the UI,default false(currently, only refreshing the title)
    	 * }
    	 */
    	var widgetTypeId = payload.widgetTypeId;
    	var eventName = payload.eventName;
    	var eventPayload = payload.eventPayload;
    	var dialogParam = payload.dialogParam;
    	var requestRefresh = payload.requestRefresh;
    	this.displayWidgetInDialog(widgetTypeId,eventName,eventPayload,dialogParam,requestRefresh);
    }

});
