/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");

dojo.declare("com.ibm.mm.builder.embedPage", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {	
		 
	previewContent: 
		'<div class="embedPreviewTxt">'+
        	'<span class="embedPreviewTxtLeft">'+
				'<input accesskey="A" title="${I_EMBED_PREVIEW_BYDEFAULT}" ${checked} id="${pageId}_checkBox" type="checkbox">'+
            	'<label class="truncatedLabel">${I_EMBED_PREVIEW_BYDEFAULT}</label>'+
        	'</span>'+
        	'<span class="embedPreviewTxtRight">'+
        		'<a accesskey="C" title="${I_EMBED_PREVIEW_CLOSE}" href="javascript:void(0)" '+
					'id="${pageId}_closeLink" class="embedPgPreviewLink truncatedLabel">${I_EMBED_PREVIEW_CLOSE}</a>'+
			'</span>'+
    	'</div>'+
    	'<div style="clear: both;"></div>'+
    	'<iframe marginheight="0" marginwidth="0" style="height:${height};width:${width};" title="${I_EMBED_PREVIEW_FRAME}" '+
				'name="${iframeId}" id="${iframeId}" scrolling="no" frameborder="0"></iframe>',
	
	_domID: null,
	pageId: null,
	previewDlgId: null,
	layoutUrl: null,
	
    onLoad: function() {
		this.openEmbedPagePreview = eval(dojo.cookie("open_embed_page_preview"));
	},
	
	onView: function(){
		this.inherited(arguments);
		if (dojo.isSafari) {	//Setting radio checked in embedPage.xml doesn't work on Safari
			this.emdPgWidth.click();
			this.emdPgScrollOn.click();
		}
		// check the anonymous mode
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var anon_enabled = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.ANON_MODE_ENABLED);
		if (anon_enabled == false){
			this.anonymousMsg.style.display = "none";
		}
	},
	
	onEmbedPage: function(iEvent) {
		this.pageId = iEvent.payload;
		this.previewDlgId = this.pageId + "_embeddingPreview";
		this.update();
	},
	
	onLayoutDefXMLUrlPublished:function(iEvent){
		// iEvent.payload is the layout widget xml url
		this.layoutUrl = iEvent.payload;
	},
	
    update: function(){
		this.openEmbedPagePreview ? this.preview() : this.updateMarkup();
    },
	
	onWidthRadioClicked: function(evt){
		this.inputWidth.disabled = evt.target.value == "autoWidth";
	},
	
	hide:function(){
		this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},
	
	/**
	 * show the preview dlg
	 */	
	preview:function(){
		if(!this.updateMarkup()) return;
		
		this.closePreview();
		
		this.previewDlg = new com.ibm.mm.builder.widget.CustomDialog({
			id: this.previewDlgId,
			containerBackgroundColor: "white",
			nodeWidth: dojo.isIE ? "520px" : '515px',
			nodeHeight: dojo.isIE ? (dojo.isIE == 6 ? "488px" : "512px") : "516px",
			initLeftPosition: "700px",
			initTopPosition: "100px",
			modelDialog: false,
			needUnderLay: false,
			scrollEnabled: true
			// 8143: if bidi, CustomDialog will not add the 'custom_dialog_nomodel'
			// class which interferes with the left/right movement of the dialog
			// 9637: removed rtl version of custom_dialog_nomodel so removed param isEmbedPageBidi
		});	
		this.previewDlg.setTitle(dojo.string.substitute(
			this.cws.I_EMBED_PAGE_PREVIEW_TITLE, [com.ibm.mm.builder.utils.pageUtil.getPageTitle(this.pageId)]));
		
		this.iContext.dialogContainer.registerSubDialog(this.previewDlgId);		
		
		var iframeUID = com.ibm.mm.builder.utils.iwidgetUtil._getUid()
		this.previewDlg.containerNode.innerHTML = dojo.string.substitute(this.previewContent, dojo.mixin({ 
			pageId: this.pageId,
			iframeId: iframeUID,
			width: document.getElementsByName("emdPgWidth")[0].checked ? this.inputWidth.value + "px" : "100%",
			height: parseInt(this.inputHeight.value) + 25 + "px",
			checked: this.openEmbedPagePreview ? "checked" : "" 
		}, this.cws)); 
		
		var iframeDoc = window.frames[iframeUID].document;
		iframeDoc.write('<html><body>'+ this.textareaMarkup.value +'</body></html>');
		if (!dojo.isIE) iframeDoc.close();
		
		dojo.connect(dojo.byId(this.pageId +"_checkBox"), "onclick", this, "reverseDefaultPreview");
		dojo.connect(dojo.byId(this.pageId +"_closeLink"), "onclick", this, "closePreview");

		//Add ellipsis to the label texts if they are too long.
		dojo.query(".truncatedLabel").forEach(function(d){
			com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(d);
		});

		this.previewDlg.show();
		
	},
	
	validateInput: function(){
	    // validate width
		if (dojo.attr(this.emdPgWidth, "checked")) {
			if (!dojox.validate.isInRange(this.inputWidth.value, {
				min: 50,
				max: 2000
			})) {
				alert(this.cwm.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR1_0);
				return false;
			}
			if ((parseInt(this.inputWidth.value) + "") != this.inputWidth.value) {
				alert(this.cwm.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR2_0);
				return false;
			}
		}
	    // validate height
	    if (!dojox.validate.isInRange(this.inputHeight.value, {min: 50, max: 2000})) {
	        alert(this.cwm.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR1_0);
	        return false;
	    }
	    if ((parseInt(this.inputHeight.value) + "") != this.inputHeight.value) {
	        alert(this.cwm.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR2_0);
	        return false;
	    }
	    return true;
	},
	
	/**
	 * call enabler embedding generator to get the embeddable url
	 */
    generateURL:function() {
        if (!this.validateInput()) return null;
		// TODO: add wire to get the widget def url from free form or column, also need to get widget def url from nva
		// enabler or server need to be updated in order to support user customized layout or nva
		var widgetXmlUrl = this.layoutUrl;
		var width = document.getElementsByName("emdPgWidth")[0].checked ? this.inputWidth.value : "auto";
		var height = this.inputHeight.value;
		var haveScroll = document.getElementsByName("emdPgScroll")[0].checked;
		
		return com.ibm.mm.builder.utils.embedUtil.generateURL(widgetXmlUrl, this.pageId, width, height, haveScroll);
    },	
	
	
	_updateMarkupWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.updateMarkup();
		}
	},
	
	/**
	 * action method when user click "Update Markup" in embedding UI.
	 * It will update the markup in the textarea 
	 */
	updateMarkup:function(){
		var url = this.generateURL();
		if (url){
			this.textareaMarkup.value = dojo.string.substitute('<script src="${0}"></script>', [url]);
			return true;
		}
		return false;
	},
	
	/**
	 * action method when user click "close" in preview UI
	 */
	closePreview:function(){
		var embeddingPreviewDialog = dijit.byId(this.previewDlgId); 
		if (embeddingPreviewDialog){
			embeddingPreviewDialog.destroy();
			this.previewDlg = null;
		}
	},
	
	/**
	 * action method when check the checkbox "show preview by default"
	 */
	reverseDefaultPreview:function(){
		this.openEmbedPagePreview = !this.openEmbedPagePreview;
		dojo.cookie("open_embed_page_preview", this.openEmbedPagePreview)
	},
	
	byId: function(id) {
		if(this._domID == null){
			this._domID = "_" + this.iContext.widgetId + "_";
		}
        return dojo.byId(this._domID + id) || dojo.byId(id);
    },
		
	onDialogResize: function(width, height)
	{
		var contentNode = this.byId("contentNode");
		var dialogContainerCB = dojo.contentBox(this.iContext.dialogContainer.containerNode);
		var containerMB = dojo.marginBox(contentNode);
		var footerHeight = dojo.marginBox(this.byId("footer")).h;
		
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		
		dojo.marginBox(contentNode, containerMB);
	}
});

