/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.iwidget.GenericLayout");
dojo.require("com.ibm.mm.builder.dnd.FreeformSource");
dojo.require("com.ibm.mm.builder.dnd.QuickWireTarget");
dojo.require("com.ibm.mm.builder.widgetLoader");
dojo.require("com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings");
dojo.require("com.ibm.mm.builder.widget.MumColorPalette");
dojo.require("com.ibm.mm.builder.iwidget.freeformlayout.configHelper");
dojo.require("com.ibm.mm.builder.widget.mumResizeHandler");
dojo.require("com.ibm.mm.builder.widget.resizeWidget");
dojo.require("com.ibm.mm.builder.widget.moveWidget");
dojo.require("com.ibm.mm.builder.utils.PageWidthChanger");
dojo.require("com.ibm.mm.builder.personalize");
dojo.require("com.ibm.mm.builder.widget.WidgetEditBar");

dojo.declare("com.ibm.mm.builder.systemwidget.FreeFormLayout",com.ibm.mm.builder.iwidget.GenericLayout,{
	
	//WID equals "_"+widgetId+"_". 
	WID:null,	
	configHelper:null,
	layoutData:"layout:freeForm;",
	metadata_key_height:"actualheight",
	pageMode:"view",
	setting: null,
	pageId: null,
	WIDGET_OFFSET: 50,
	widgetCounter: 0,
	widgetSkinParams: {},
	
	_widgetLoadedConnects: [],
	
	//======================================iWidget event=========================================
	/**
	 * onLoad is the event which will be called when the free form layout widget is loading
	 */    
	onLoad: function(){
		this.needResizer = true;
		this.layoutWidgetId = this.iContext.widgetId;
		this.widgetContainerId = this.iContext.widgetId;
		this.WID = "_" + this.iContext.widgetId + "_";
		this.container = dojo.byId(this.WID + "container");
		this.iWidgetAttributes = this.iContext.getiWidgetAttributes();
		this.eventService = serviceManager.getService("eventService");
		this.iwidgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		
		com.ibm.mm.builder.freeLayOutBean = new com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings();
		com.ibm.mm.builder.freeLayOutBean.setWidgetId(this.iContext.widgetId);
		
		var configIconNode = dojo.byId(this.WID + "configIcon");
		configIconNode.src = builderConfig.builderPath + (builderConfig.isBidi ? 
			"/images/layoutwidget_settings_button_rtl.png" : "/images/layoutwidget_settings_button.png");
		configIconNode.alt = configIconNode.title = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_ICON_HOVERTEXT;
		
		this.configHelper = new com.ibm.mm.builder.iwidget.freeformlayout.configHelper(this.iContext, this.WID);
		
		window.onresize = dojo.hitch(this, "resize"); 	
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().registerLayout(this.iContext.widgetId);
	
		this._cacheInitSetting();
		
        dojo.subscribe("/freeform/internalTopics/updateContainerSize",this,"updateContainerSize");
		this.widgetUnloadedHandle = this.eventService.subscribeEvent(
			com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED, this, this.onOldWidgetsUnloaded);
		
		this.dndsource = new com.ibm.mm.builder.dnd.FreeformSource(
			this.container, {
				layout: this,
				creator: function(item, hint){
					if (hint === "avatar") { //create avatar
						var n = dojo.doc.createElement("div");
						n.id = dojo.dnd.getUniqueId();
						n.setAttribute("widgetId", item);
						n.className = "dojoDndItem";
						//TODO: the prefix mm_ibm_skin_ is in skins.js, can't hard code it here.
						var widgetSkinNode = dojo.byId("mm_ibm_skin_"+item);
						var node = widgetSkinNode.cloneNode(true);
						node.id = "";
						com.ibm.mm.builder.utils.htmlUtil.removeIframe(node);
						node.style.position = "relative"; 	
						node.style.top = "0";
						node.style.left =  "0";
						n.appendChild(node)
						return { node: n, data: item, type: ["iWidgetInstance"] };
					}
				}
			}
		);
	},
	
	/**
	 * onview event will be called when user switch the widget mode to view 
	 */
	onview:function(){
		com.ibm.mm.builder.utils.htmlUtil.showScrollBar(this.iContext.widgetId);
		// update current configuration UI
		this.applySettings();
		com.ibm.mm.builder.utils.layoutUtil.stretchHeight(this.iContext.widgetId);
		
		//adjust the position style of freeform view root node so that 
		//it will not cover the scroll bar when the page is embeded
		if (dojo.isIE < 8 && window.location.pathname.indexOf("myembedding") >= 0) {
			dojo.style(this.WID + "view", "position", "");
		}
	},
	
	/**
	 * onedit event will be called when user switch the widget mode to edit 
	 */	
	onedit:function(){
		com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.createSkinConfigUI(this.WID+"skinConfig",this.iContext.widgetId);
		this.fillInTheText();
		this.configHelper.setPageProperties(true, this.configHelper.getPageProperties(this.iWidgetAttributes));
		this.configHelper.setWidgetProperties(true, this.configHelper.getWidgetProperties(this.iWidgetAttributes));
	},

	/**
	 * onUnload event will be called when user leave free form layout 
	 */
	onUnload: function(){
		if(this.dndSource) this.dndSource.destroy();
		dojo.unsubscribe(this.widgetUnloadedHandle);
		dojo.forEach(this.getWidgets(), function(widgetId){
			com.ibm.mm.builder.commonActions.removeWidget(widgetId);
		});	
	},
	//======================================end iWidget event=========================================
	
	//======================================iEvent handler==============================================
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.changePageMode'
	 * @param {Object} iEvent payload
	 */
	onPageModeChanged: function(iEvent){
		var mode = iEvent.payload;
		if(mode === "view" || mode === "edit") {
			this.pageMode = mode;
			this.configHelper.currentPageMode = mode;
			this.configHelper.toChangeFreeFormMode();
			if(mode === "view"){ 
				this._hideWidgetEditbar();
			} else if(this.initialEdit){
				dojo.forEach(this.getWidgets(),  function(widgetId){
					if (dojo.byId(widgetId).getAttribute("internalwidget") != "true" && dojo.byId(widgetId).getAttribute("widgetInTab") != "true") {
						this.attachWidgetEditHandle(widgetId);					
					}
				}, this);
				this.initialEdit = false;
			}
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.pageSwitched'
	 * @param {Object} iEvent payload
	 */
	onPageSwitched: function(iEvent){
		this.initialEdit = true;	
		this.widgetSkinParams = {};	
		this.widgetCounter = 0;

        this.pageId = iEvent.payload;
		var pageContent = null;
		if (this.pageId == "com.ibm.mm.builder.embedPageFailErrMsg"){
			this.loadMsgToLayout(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_PAGEACCESS_ERROR_0); 
			return;
		}
        if (!this.pageId) {
			com.ibm.mm.builder.utils.themeUtil.unloadAllWidgets(false);
			this.loadMsgToLayout(com.ibm.mm.builder.coreWidgetsStrings.W_NO_PAGE_TO_SHOW);
			return;
		} else {
			pageContent = com.ibm.mm.builder.utils.layoutUtil.getPageContent(this.pageId);
			if (pageContent == null){
				com.ibm.mm.builder.utils.themeUtil.unloadAllWidgets(false);
				this.loadNullToLayout(); 
				return;
			}
			this.content = pageContent.content;
		}
		var pageAttributes = pageContent ? this._filterFreeFormLayoutAttr(pageContent.pageAttributes) : null;
		pageAttributes = !pageAttributes ? this.defaultInitialSettings : 
			com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.validatePageMetaData(pageAttributes);
		
		this.iwidgetUtil.loadItemSetsFromJSONObject(this.iWidgetAttributes, pageAttributes);
		// in case the page metadata is old format
        if (!this.iWidgetAttributes.getItemValue("applyDefaultSkinToAll")) this.iWidgetAttributes.setItemValue("applyDefaultSkinToAll", "0", false);
		this.iWidgetAttributes.save();
		
		if (this.pageId) {
			//Set the auto-wiring to page model
			var autoWiringEnabled = pageAttributes[com.ibm.mm.builder.constant.autoWiringEnabled];
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setAutoWiringEnablement(autoWiringEnabled);
		}
		// Note: this is a temporary solution for defect 7971.
		com.ibm.mm.builder.utils.themeUtil.unloadWidgetsInLayout(this.iContext.widgetId);
    },
    
	onOldWidgetsUnloaded: function(){
		if (this.pageId && !com.ibm.mm.builder.utils.pageUtil.isEmptyPage(this.pageId)){
			var handler = this._widgetLoadedConnects.pop();
			while(handler){
				com.ibm.mashups.services.ServiceManager.getService("eventService").unsubscribeEvent(handler,null);
				handler = null;
				handler = this._widgetLoadedConnects.pop();
			}
			this.loadWidgets();
			this.applySettings();
			this.getFirstWidget();
			this.applyPageWidthMode();
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.addWidget', 
	 * the method will handle adding widget from Toolbox by clicking the "Add to current page" menu item.
	 * @param {Object} iEvent has three kinds of payload:
	 * 	- String: It is the widget definition id. For example: "feedReader".
	 *  - Json Object: It includes widget definition id and itemset as preference. For example:
	 *  	{id: "feedReader", itemset: {feedUrl:"http://www.ibm.com/feed.rss"} }.
	 *  	The itemset enable developer set/change perference of widget instnace during widget rendering.
	 *  - Json Ojbect: It includes widget definition metadata and itemset as preference. For example:
	 *  	{
	 *  		widgetMetadata: 
	 *  		{
	 *  			id:"feedReader",
	 *  			definition:"/feedReader/feedReader.xml",
	 *  			icon: "/feedReader/feedreader.png",
	 *  			title:{en:"FeedReader", zh_CN:"yueduqi"},
	 *  			onNewWire: "",
	 *  			widgetParam: "[]",
	 *  			sandbox_definition: "true"
	 * 			}, 
	 *  		itemset: {feedURL:"http://www.ibm.com/feed.rss"} 
	 *  	}
	 *  	The keys in widgetMetadata should be same as enabler api.
	 */
	onWidgetAdded:function(iEvent){
		var payload = iEvent.payload;
		var params = {
			position: {x: this.WIDGET_OFFSET * this.widgetCounter, y: this.WIDGET_OFFSET * this.widgetCounter}
		}
		if (typeof(payload) === "string") {
			this.createWidget(payload, params);
		} else if (typeof(payload) == "object" && payload.widgetMetadata) {
			this.createWidgetByMetaData(payload.widgetMetadata, payload.itemSet, params);
		} else {
			this.createWidget(payload.id, params, payload.itemSet);
		}
		this.widgetCounter++;
	},

	/**
	 * Publish function for iEvent 'com.ibm.mashups.builder.defXMLUrlPublished'
	 * This iEvent is mainly published to embedding page widget
	 * @param {Object} iEvent payload
	 */
	publishFreeFormXMLUrl:function(){
		this.iContext.iEvents.publishEvent("com.ibm.mashups.builder.defXMLUrlPublished", this.getWidgetDefURL());
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetResized:function(iEvent){
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.widgetId || widgetInfo.id;
		if (com.ibm.mashups.builder.Personalize.isWidgetInLayout(widgetId,this.iContext.widgetId)) {
			var widgetSkinNode = com.ibm.mashups.builder.Personalize.getWidgetSkinNode(widgetId);
			var skinBox = dojo.marginBox(widgetSkinNode);
            skinBox.w = parseInt(widgetInfo.width);
            skinBox.h = parseInt(widgetInfo.height);
            
			com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, "normal");
			com.ibm.mashups.builder.Personalize.setPersonalizeSize(widgetId,skinBox);
			com.ibm.mashups.builder.Personalize.resetWidgetSkin(widgetId, skinBox);
			com.ibm.mashups.builder.Personalize.resetWidgetContent(widgetId, skinBox); 		
			com.ibm.mashups.builder.Personalize.publicResizeEvent(widgetId);
		}	
	},	
	
	onStateChanged:function(iEvent){		
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.iwidgetId;
		var state = widgetInfo.state;
		if (com.ibm.mashups.builder.Personalize.isWidgetInLayout(widgetId, this.iContext.widgetId)){	
			// Get the size of widget skin
			var widgetSkinNode = com.ibm.mashups.builder.Personalize.getWidgetSkinNode(widgetId);
			var skinBox = dojo.marginBox(widgetSkinNode);					
			var size;
			var contentSize;
			// Store the widget's state.
			com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, state);
			// Resize the widget's size.
			if (state == "normal"){
				size = com.ibm.mashups.builder.Personalize.getPersonalizeSize(widgetId);
				contentSize = size;
			}
			else{
				// set the widget original size information to the navigation state.
				com.ibm.mashups.builder.Personalize.setPersonalizeSize(widgetId, skinBox);
				if (state == "max"){								
					size = dojo.marginBox(this.iContext.getRootElement());
					size.l = 0;
					size.t = 0;
					contentSize = size;;
				}
				else if (state == "min"){				
					var bodyPadTop = 36;
					size = {t:skinBox.t, l:skinBox.l, h:bodyPadTop*2, w:skinBox.w};
					contentSize =  {t:skinBox.t, l:skinBox.l, h:bodyPadTop, w:skinBox.w};				
				}	
			}			
			com.ibm.mashups.builder.Personalize.resetWidgetSkin(widgetId, size);
			com.ibm.mashups.builder.Personalize.resetWidgetContent(widgetId, contentSize); 		
			com.ibm.mashups.builder.Personalize.publicResizeEvent(widgetId);						
		}	
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeAction'
	 * @param {Object} iEvent payload
	 */
	onResizeDialogShow:function(iEvent){
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.iwidgetId;
		var widgetType = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_RESIZE_WIDGET_PROMPT, [widgetType]);
		var skinMinSize = com.ibm.mm.builder.utils.skinUtil.getMinSize(dojo.byId(widgetId).getAttribute("skin"));

		var dialogParam = {
			title: title,
			nodeWidth: "395px",
	 		containerBackgroundColor: "white",
			requestRefresh:true
	 	}
		this.resizeDialog = this.resizeDialog || new com.ibm.mm.builder.widget.resizeWidget({
			dlgPara: dialogParam,
			layoutContext: this.iContext
		});
		this.resizeDialog.minHeight = skinMinSize;
		this.resizeDialog.setTitle(title);
		this.resizeDialog.updateProperty(widgetId);
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.moveAction'
	 * @param {Object} iEvent payload
	 */
    onMoveDialogShow: function(iEvent){
        var widgetInfo = iEvent.payload;
        var widgetId = widgetInfo.iwidgetId;
		var widgetType = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MOVE_WIDGET_PROMPT, [widgetType]);
		
        var dialogParam = {
			title: title,
			nodeWidth: "395px",
	 		containerBackgroundColor: "white"
        }
        this.moveDialog = this.moveDialog || new com.ibm.mm.builder.widget.moveWidget({
            dlgPara: dialogParam,
            layoutContext: this.iContext
        });
        this.moveDialog.updateProperty(widgetId);
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.displayWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetDisplayed: function(iEvent){
		this.displayWidget({id:iEvent.payload});
	},
	
	_hideWidgetEditbar : function(mode){
		dojo.forEach(this.getWidgets(), function(widgetId){
			var editbar = dijit.byId(widgetId + com.ibm.mm.builder.constant.dragHandler + "_editbar");
			editbar && editbar.hide();
		});
	},
	//======================================end iEvent handler=========================================
	
	//======================================Layout widget function=====================================	
	createWidget: function(iWidgetDefinitionId, params, itemset){
		var widgetSpan = this.createWidgetSpan(iWidgetDefinitionId, itemset);
		dojo.addClass(widgetSpan, "iWidgetSkin");
		
		var locStyle = this._getLocationStyle(params) + (dojo.isIE===6 ? "height:120px;" : "");
		widgetSpan.setAttribute("locationstyle", locStyle);
		widgetSpan.setAttribute("visible", "true");
		widgetSpan.setAttribute("layoutdata", this.layoutData);
		this.container.appendChild(widgetSpan);
		this.iwidgetUtil.updateWidgetInstance(widgetSpan, iWidgetDefinitionId);
		var handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(widgetSpan.id, function(){
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        	eventService.broadcastEvent("com.ibm.mashups.builder.autoWiringWidget", widgetSpan.id);
        });
		if(handler){
			this._widgetLoadedConnects.push(handler);
		}
		com.ibm.mm.builder.utils.skinUtil.updateDefaultSize(widgetSpan.id);
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		return widgetSpan.id;
	},
	
	createWidgetByMetaData: function(widgetMetadata, itemset, params){
		if (!widgetMetadata) {
			//add the error message when there is no widget definition in catalog
			com.ibm.mm.enabler.debug.error("fails to get widget medadata from catalog api.");
			return;
		}
		var widgetSpan = this.iwidgetUtil.getWidgetSpanByMetadata(widgetMetadata, itemset);
		dojo.addClass(widgetSpan, "iWidgetSkin");
		widgetSpan.setAttribute("locationstyle", this._getLocationStyle(params));
		widgetSpan.setAttribute("visible", "true");
		widgetSpan.setAttribute("layoutdata", this.layoutData);
		this.container.appendChild(widgetSpan);
		this.iwidgetUtil.updateWidgetInstance(widgetSpan, widgetMetadata["id"]);
		var handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(widgetSpan.id, function(){		
        	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.autoWiringWidget", widgetSpan.id);
        });
		if(handler){
			this._widgetLoadedConnects.push(handler);
		}
		com.ibm.mm.builder.utils.skinUtil.updateDefaultSize(widgetSpan.id);
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		return widgetSpan.id;
	},	
	
	_getLocationStyle: function(params){
		var defaultWidgetWidth = com.ibm.mm.builder.constant.defaultWidgetWidth;
		var locationStyle = "position:absolute;width:" + defaultWidgetWidth + "px;";
		params && params.position && (locationStyle += 
				dojo.string.substitute("top:${y}px;left:${x}px;", params.position));
		var maxZIndex = com.ibm.mm.builder.skinHelper.getMaxZOrder(this.iContext.widgetId);
		locationStyle += dojo.string.substitute("z-Index:${0};", [maxZIndex]); 
		
		return locationStyle;
	},

	//todo simplify the process
	createWidgetSpan: function(widgetDefinitionId,itemset){
		var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefinitionId);
		if(!widgetMD){
			//add the error message when there is no widget definition in toolbox
			com.ibm.mm.enabler.debug.error(com.ibm.mm.builder.coreWidgetsMessages.E_DND_CREATEWIDGET_0);
			return;
		}
		var uid = this.iwidgetUtil._getUid();
		var widgetcreator = new com.ibm.mm.builder.widgetCreator(uid, widgetMD,itemset);
		widgetcreator.setWidgetSkin(com.ibm.mm.builder.freeLayOutBean.getSelectedSkin());
		return widgetcreator.getWidget();
	},
	
	updatePageHeight:function(){
		//freeform: replace freeform height with an actual height
		var freeFormDiv = dojo.byId(this.iContext.widgetId);
		freeFormDiv.style.height = "100%";
		this.defaultPageHeight = Math.max(dojo.coords(freeFormDiv).h, 768);
		var actualHeight = com.ibm.mm.builder.utils.enablerUtil.getPageMetaData(this.metadata_key_height,this.pageId);
		if(actualHeight){
			freeFormDiv.style.height = this.defaultPageHeight > parseInt(actualHeight) ? (this.defaultPageHeight + "px") : (actualHeight + "px");
		} else {
			freeFormDiv.style.height = this.defaultPageHeight +"px";
		}
	},
	
	resize:function(){
		var freeFormDiv = dojo.byId(this.iContext.widgetId);
		var oldHeight = freeFormDiv.style.height;
		if(oldHeight!="100%"){
			freeFormDiv.style.height = "100%";
			var newHeight = dojo.coords(freeFormDiv).h;
			freeFormDiv.style.height = (newHeight>  parseInt(oldHeight)) ? (newHeight + "px") : oldHeight;
		}else{
			freeFormDiv.style.height = dojo.coords(freeFormDiv).h +"px";
		}				
	},
	
	getWidgets:function(){
		var widgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.container);

		var gadgets = dojo.query("." + com.ibm.mm.builder.constant.mmGGadget, this.container);
		var ss = widgets.concat(gadgets);

		return dojo.map(ss,
			function(widget){ return widget.id; })

	},	
	
	updateContainerSize:function(widgetId){
		// update canvas height when moving a widget via MoveWidget dialog
		if (widgetId){
			var ffPos = dojo.coords(this.container);
			var skin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
			var wPos = dojo.coords(skin);
			if (ffPos.h + ffPos.y < wPos.h + wPos.y){
				dojo.style(this.container, "height", (wPos.h + wPos.y - ffPos.y + 15) + "px");
				//Also change the freeform div height to fix defect 8342
				dojo.style(dojo.byId(this.iContext.widgetId), "height", (wPos.h + wPos.y - ffPos.y + 15) + "px");
			}			
		}
	},
	
	getFirstWidget:function(){
        var widgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.container),
            anchor = widgets.length > 0 ? "#" + com.ibm.mm.builder.constant.skinIdPrefix + widgets[0].id : "#content-main",
	        skipAnchors = dojo.query("div.skip a");
		
		if (skipAnchors.length > 0) {
		    dojo.attr(skipAnchors[0], "href", anchor);
		} else {
			var a = dojo.create("a", {
				"href": anchor,
				"innerHTML": com.ibm.mm.builder.coreWidgetsStrings.I_MAIN_CONTENT
			}, dojo.create("div", {
				"class": "skip"
			}, dojo.body(), "first"));
			
			var func = function() {
				var as = dojo.query(anchor);
				if(as.length > 0) {
					window.location.hash=anchor;
					as[0].focus();
				}
				return false;
			};
			
			dojo.connect(a,'onkeypress',function(e) {
				if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
					func();
				}
			});
			dojo.connect(a,'onclick',func);
						
		}
	},
	
	transformMarkup: function(pageSource){
		var transformed = pageSource;
		if (pageSource != "" && pageSource.indexOf(this.layoutData) < 0) {
			var tmp = document.createElement("div");
			tmp.innerHTML = pageSource;
			var widgets = dojo.query("[visible='true']", tmp);
			
			var mainDivId = this.iContext.widgetId;
			var sourceBox = dojo.coords(dojo.byId(mainDivId));
			var canvasRight = sourceBox.w;
			var canvasBottom = sourceBox.h - 40; // leave 40px margin for buffer	
			var horizontal_delta = 50;
			var vertical_delta = 50;
			var originPos_left = 30;
			var originPos_top = 30;
			var defaultSkinWidth = com.ibm.mm.builder.constant.defaultWidgetWidth;
			
			var leftPos = originPos_left - horizontal_delta;
			var topPos = originPos_top - vertical_delta;
			var zIndex = 50;
			var layoutData = this.layoutData;
			dojo.forEach(widgets, function(widget){
				var locationStyle = widget.getAttribute("locationstyle");
				var height = com.ibm.mm.builder.utils.skinUtil.getValueFromStyle("height", locationStyle);
				if (height != null) {
					height = parseInt(height);
				}
				else {
					height = 100;
				}
				leftPos = Math.min(leftPos + horizontal_delta, canvasRight - defaultSkinWidth - originPos_left);
				topPos = Math.min(topPos + vertical_delta, canvasBottom - 100 - originPos_top);
				height = Math.min(height, canvasBottom - topPos - originPos_top);
				widget.setAttribute("layoutdata", layoutData);
				widget.setAttribute("locationstyle", "position:absolute;left:" + leftPos + "px;top:" + topPos + "px;width:" + defaultSkinWidth + "px;z-Index:" + zIndex + ";height:" + height + "px;");
				zIndex += 1;
			})
			transformed = tmp.innerHTML;
			delete tmp;
		}
		return transformed;
	},
	
	/**
	 * display a widget from NVA
	 * @param {Object} message
	 * //todo shiwei refactory
	 */
	displayWidget: function(message){
		var widgetId = message.id;
		var draggedNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		this.container.appendChild(draggedNode);
		
		//disconnect the event handlers to avoid memory leak in IE
		var wireIcon = dojo.byId(widgetId + "_wireIcon");
    	var editIcon = dojo.byId(widgetId + "_editIcon");
		if(editIcon )editIcon.onclick = editIcon.onkeypress = null;
		if(wireIcon) wireIcon.onclick = wireIcon.onkeypress = null;
		
		//change the skin
		var widgetSpan = dojo.byId(widgetId);
		widgetSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, com.ibm.mm.builder.freeLayOutBean.getSelectedSkin());
		
		var maxOrder = com.ibm.mm.builder.skinHelper.getMaxZOrder(this.iContext.widgetId);
		var defaultWidgetWidth = com.ibm.mm.builder.constant.defaultWidgetWidth;
		var locStyle = dojo.string.substitute(
			"position:absolute;width:" + defaultWidgetWidth + "px;left:${left}px;top:${top}px;z-Index:${zIndex};",
		 	{
				left: message.position ? message.position.x : 50,
				top: message.position ? message.position.y : 50,
				zIndex: maxOrder
			});
		if(dojo.isIE===6) locStyle += "height:120px;";
		widgetSpan.setAttribute("locationstyle", locStyle);
		widgetSpan.setAttribute("visible", "true");
		widgetSpan.setAttribute("layoutdata",this.layoutData);
		
		this.iwidgetUtil.updateWidgetInstance(widgetSpan);
	},
	
	/**
	 * loadWidgets will init the free form layout widget
	 * create the drop target, load widgets, add skin
	 */	
	loadWidgets:function(){
		this.updatePageHeight();
		this.content = this.transformMarkup(this.content);
		dojo.setSelectable(this.container, false);
		
		var widgetId = this.iContext.widgetId;
		var root = document.getElementById(widgetId);
		
		var skinFromAttr = this.iWidgetAttributes.getItemValue("skin");
		var theSkin = "";
		// add skin
		if (this.iWidgetAttributes != null) {
			if (skinFromAttr == null){
				theSkin = com.ibm.mm.builder.freeLayOutBean.getSelectedSkin();
				this.iWidgetAttributes.setItemValue("skin",theSkin,false);
				this.iWidgetAttributes.save();
			}else{
				theSkin = skinFromAttr;
			}
		}
		if (theSkin){
			com.ibm.mm.builder.freeLayOutBean.setSelectedSkin(theSkin);
		}
		var widgetLoader = com.ibm.mm.builder.initWidgetLoader();
		var widgetString = widgetLoader.getFreeFormWidgets(this.content);
		// clean the widgets in previous page
		this.container.innerHTML = "";
		if (widgetString) {
			if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartApplicationWidgets()) {
				var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
				mpHandler.startTransaction();
			}
			widgetLoader.loadWidgets(this.container, widgetString);
			if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartApplicationWidgets()) {
                mpHandler.endTransaction(true);
            }
		}
		this.updatePageHeight();
		com.ibm.mm.builder.utils.pageWidthChanger.setMinimumWidth(this.getPageMinimumWidth());
	},
	
	widgetClickAction:function(widgetId){
		if (this.pageMode == "edit")
			this.focusWidget(widgetId);
	},
	
	/**
	 * Ajust the zIndex of the widget designated above the others
	 * @param {String} widgetId
	 */
	focusWidget: function(widgetId){
		var selectedWidgetSkinId = com.ibm.mm.builder.constant.skinIdPrefix + widgetId;
		var selectedWidgetZIndex = dojo.style(selectedWidgetSkinId, "zIndex") - 0;
		var maxZIndex = com.ibm.mm.builder.skinHelper.getMaxZOrder(this.iContext.widgetId);

		//no update,if the selected widget is the top one
		if(selectedWidgetZIndex + 1 != maxZIndex)      
	        dojo.style(selectedWidgetSkinId, "zIndex", maxZIndex);
	},
	
	_onGetMarkup:function(){
		this.preSaveAction();
	},
	
    preSaveAction: function(){
        var zIndex = 50;
        var maxWidgetHeight = 0;
       	
		dojo.forEach(this.getWidgets().sort(
			dojo.hitch(this, function(a, b){
            	return this._getZIndexFromSkin(a) - this._getZIndexFromSkin(b)
        	})), 
			function(widgetId){
            var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
			if(widgetSkinNode != null){
            widgetSkinNode.style.zIndex = zIndex;
			var widgetSkinBox = dojo.contentBox(widgetSkinNode);
			widgetSkinBox.l = parseInt(widgetSkinNode.style.left);
			widgetSkinBox.t = parseInt(widgetSkinNode.style.top);
			if (widgetSkinBox.l < 0)  widgetSkinBox.l = 0;
			if (widgetSkinBox.t < 0)  widgetSkinBox.t = 0;
			dojo.contentBox(widgetSkinNode, widgetSkinBox);
            maxWidgetHeight = Math.max(maxWidgetHeight, widgetSkinBox.t + widgetSkinBox.h + 50);
			
			var widgetSpan = dojo.byId(widgetId);
			var locationStyle = dojo.string.substitute(
				"position:absolute;left:${l}px; top:${t}px; width:${w}px; height:${h}px; z-Index:${zIndex};", 
				dojo.mixin({zIndex: zIndex++}, widgetSkinBox));
	        widgetSpan.setAttribute("locationstyle", locationStyle);
			}
        });
		
        var pageHeight = Math.max(maxWidgetHeight, this.defaultPageHeight);
        com.ibm.mm.builder.utils.enablerUtil.setPageMetaData(this.metadata_key_height, pageHeight);
    },
	
	_createResizeHandler: function(widgetId, minHeight, minWidth){
		var resizeHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHandlerExt);
		resizeHandler && resizeHandler.destroy();
		
		var resizeHeightHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHeightExt);
		resizeHeightHandler && resizeHeightHandler.destroy();
		
		resizeHandler = new com.ibm.mm.builder.widget.mumResizeHandler({
			id: 				widgetId + com.ibm.mm.builder.constant.resizeHandlerExt,
			targetElmId: 		com.ibm.mm.builder.constant.skinIdPrefix + widgetId,
			contentElmId: 		widgetId + com.ibm.mm.builder.constant.widgetContent,
			widgetBodyElmId: 	widgetId + com.ibm.mm.builder.constant.widgetBody,
			minHeight: 			minHeight,
			minWidth: 			minWidth,
			parentNode:			this.container
		});
		var resizeNode = dojo.byId(widgetId + com.ibm.mm.builder.constant.resizeHandler);
		resizeNode.appendChild(resizeHandler.domNode);
		
		return resizeHandler;
	},
	
	_createEditbar: function(widgetId, iconUrl, widgetSkinNode){
		widgetSkinNode = widgetSkinNode || dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		
		var editBar = dijit.byId(widgetId + com.ibm.mm.builder.constant.editbarDragHandler);
		editBar && editBar.destroy();
		editBar = new com.ibm.mm.builder.widget.WidgetEditBar({
			id: 		widgetId + com.ibm.mm.builder.constant.editbarDragHandler,
			widgetId: 	widgetId,
			iconUrl: 	iconUrl
		});
		
		widgetSkinNode = widgetSkinNode || dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		widgetSkinNode.insertBefore(editBar.domNode, widgetSkinNode.firstChild);
		
		var quickWireTarget = com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
		if(quickWireTarget){
			quickWireTarget.destroy();
			delete com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
		}
	
		com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId] = 
			new com.ibm.mm.builder.dnd.QuickWireTarget(editBar.domNode, {
	            targetId: widgetId,
	            layout: this
	        });
		return editBar;
	},
	
	attachWidgetEditHandle: function(widgetId, widgetSkinNode){
		widgetSkinNode = widgetSkinNode || dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		
		var skinParam = this.widgetSkinParams[widgetId];
		var editBar = this._createEditbar(widgetId, skinParam.iconUrl, widgetSkinNode);
		var resizeHandler = null;
		if (this.needResizer){
			resizeHandler = this._createResizeHandler(widgetId, skinParam.minHeight, skinParam.minWidth);
			dojo.connect(editBar, "show", resizeHandler, "show");
			dojo.connect(editBar, "hide", resizeHandler, "hide");			
		}

		dojo.connect(widgetSkinNode, "onmouseout", editBar, "hide", true);
		dojo.connect(widgetSkinNode, "onkeypress", editBar, "onKeyPress");
		dojo.connect(widgetSkinNode, "onclick", null, dojo.hitch(this, this.widgetClickAction, widgetId));
		
		if (dojo.isIE == 6 && dojo.hasClass(widgetSkinNode, "mumWidgetTitleBar")) { // 2622
			dojo.connect(widgetSkinNode, "onmousemove", editBar, "keep");
		}
		var widgetBody = dojo.query(".widgetBody", widgetSkinNode)[0];
		if (widgetBody) {
			dojo.connect(widgetBody, "onmouseover", editBar, "show", true);
			if (dojo.isIE || dojo.isSafari) // 2797
				widgetBody.onselectstart = function(){
					event.cancelBubble = true;
					return true;
				}
			if (dojo.isSafari) 
				widgetBody.style.KhtmlUserSelect = 'auto';
		}
		com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(widgetId);
	},
	
	postAttachSkin:function(message){
		var skinParam = message.skinParam;
		var widgetId = message.widgetId;
		var widgetSpan = dojo.byId(widgetId);
		var skinNodeId =  message.skinNodeId;
		var skinNode = dojo.byId(message.skinNodeId);
        dojo.attr(skinNode, "tabindex", "0");
		var skinId = widgetSpan.getAttribute("skin");
		var skinUtil = com.ibm.mm.builder.utils.skinUtil;
		skinUtil.skinMinSize[skinId] = skinUtil.skinMinSize[skinId] || skinParam.minHeight; 
        if (dojo.isIE == 6 && skinId != "NoSkin") 
            dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetContent).style.marginTop = 0;
		
		this.widgetSkinParams[widgetId] = skinParam;
		// performance bug fix 10500
		if (!dojo.isIE || (dojo.isIE && this.pageMode === "edit")) {
			this.initialEdit = false;
			this.attachWidgetEditHandle(widgetId, skinNode);
		}
		// init the height and width of div
        var locationStyle = widgetSpan.getAttribute("locationstyle");
        var height = parseInt(com.ibm.mm.builder.utils.skinUtil.getValueFromStyle("height", locationStyle));
        var width = parseInt(com.ibm.mm.builder.utils.skinUtil.getValueFromStyle("width", locationStyle));
		if (height) {
            // 2733: the minimun skin size is registed in skinUtil
            var skinMinSize = com.ibm.mm.builder.utils.skinUtil.getMinSize(widgetSpan.getAttribute("skin"));
            height = Math.max(height, skinMinSize);
            dojo.style(skinNode, "height", height + "px");
			
			width = width - skinParam.marginWidth;
            var widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetBody), "paddingTop");
            widgetBodyPadTop = widgetBodyPadTop ? parseInt(widgetBodyPadTop) : 0;
            var contentHeight = height - widgetBodyPadTop - skinParam.marginHeight;
			
			dojo.marginBox(widgetId + com.ibm.mm.builder.constant.widgetContent, {
				l:0, t:0, w:width, h:contentHeight
			})
        }
        var zIndex = com.ibm.mm.builder.utils.skinUtil.getValueFromStyle("z-Index", locationStyle);
        zIndex && dojo.style(skinNode, "zIndex", parseInt(zIndex));
		
        com.ibm.mm.builder.utils.skinUtil.markIWidgetInstanceAsDraggable(widgetId);
		// end	

		//TODO: decouple the code to skin service, enabler should provide the call back
		com.ibm.mm.builder.utils.layoutUtil.publishWidgetSize(widgetId);
	},
	
	//======================================end Layout widget function=======================
	
	//======================= User Action in the configuration UI of column layout ====================
		
	selectBGINone:function(){
		this.configHelper.selectBGINone();
	},
	
	selectBGIURL:function(){
		this.configHelper.selectBGIURL();
	},	

	selectDSApllyToExisting:function(){
		this.configHelper.selectDSApllyToExisting();
	},
		
	selectDSApllyToAll:function(){
		this.configHelper.selectDSApllyToAll();
	},
		
	restoreDefaultConfiguration:function(){
		this.configHelper.restoreDefaultConfiguration();
	},
	
	restoreDefaultPageConfiguration:function(){
		this.configHelper.restoreDefaultPageConfiguration();
	},

	restoreDefaultWidgetConfiguration:function(){
		this.configHelper.restoreDefaultWidgetConfiguration();
	},
		
	showMorePageProperty:function(){
		this.configHelper.showMorePageProperty();
	},
	
	showMorePagePropertyWithKey:function(event){
		this.configHelper.showMorePagePropertyWithKey(event);		
	},
	
	showMoreWidgetProperty:function(){
		this.configHelper.showMoreWidgetProperty();
	},	

	/**
	 * toEditMode is called when user click the edit icon
	 */
	showConfiguration:function(){
		this.configHelper.showConfiguration();
	}, 	

	applySettings:function(){
		this.configHelper.applySettings();
	},
	
	/**
	 * show the page background color picker
	 */	
	showPageBgColorPicker:function(){
		this.configHelper.showPageBgColorPicker();
	},
	
	showPageBorderColorPicker:function(){
		this.configHelper.showPageBorderColorPicker();
	},
	
	showPageBgColorPickerWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) return true;		
		this.configHelper.showPageBgColorPicker();		
	},
	
	showPageBorderColorPickerWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) return true;		
		this.configHelper.showPageBorderColorPicker();		
	},
	
	cancelInput:function(){
		this.configHelper.cancelInput();
	},
	
	saveInput: function(){
		this.configHelper.saveInput();
	},
		
	fillInTheText: function(){
		this.configHelper.fillInTheText();
	},
	//======================= End of User Action =================================================	
	
	loadMsgToLayout:function(msg){
		if(dojo.isSafari == 3){
			setTimeout(dojo.hitch(this, dojo.hitch(this, function(){
				content = com.ibm.mm.builder.utils.pageUtil.getEmptyPageMessage(msg);
				this.container.innerHTML = content;
				com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(this.container);
			})), 50);
			return;
		}
		this.applyPageWidthMode();
		
		this.iwidgetUtil.loadItemSetsFromJSONObject(this.iWidgetAttributes, this.defaultInitialSettings);
		this.iWidgetAttributes.save();
		this.applySettings();
		
		this.container.innerHTML = com.ibm.mm.builder.utils.pageUtil.getEmptyPageMessage(msg);
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(this.container);	
	},
	
	loadNullToLayout:function(){
		if(dojo.isSafari == 3){
			setTimeout(dojo.hitch(this, dojo.hitch(this, function(){
				this.container.innerHTML = "";
			})), 50);
			return;
		}
		this.applyPageWidthMode();
		this.iwidgetUtil.loadItemSetsFromJSONObject(this.iWidgetAttributes, this.defaultInitialSettings);
		this.iWidgetAttributes.save();
		this.applySettings();
		this.container.innerHTML = "";
	},	

	_getZIndexFromSkin:function(widgetId){
		try{
			return dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId).style.zIndex;
		}catch(e){
			return 999; //temprary fix
		}
	},
	
	_filterFreeFormLayoutAttr : function(pageAttr){
		var layoutWidgetAttributes = {};
		var keys = ["version", "skin", "backgroundimagetype", "backgroundimage","backgroundimageproperty",
					"backgroundimagetransparency", "pagebgcolor", "pageborderstyle","pagebordercolor",
					"pagemargin", "applyDefaultSkinToAll", "pageWidthMode", "pageWidth", "com.ibm.mashups.builder.autoWiringEnabled"];
		for(var key in pageAttr){
			if (dojo.indexOf(keys, key) >= 0) {
				layoutWidgetAttributes[key] = pageAttr[key];
			}
		}
		return dojo.toJson(layoutWidgetAttributes) == "{}" ? null : layoutWidgetAttributes;
	},
	
	_cacheInitSetting: function(){
        this.defaultInitialSettings = {
			pagebgcolor: this.iWidgetAttributes.getItemValue("pagebgcolor"),
			version: this.iWidgetAttributes.getItemValue("version"),
			skin: com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId(),
			backgroundimagetype: this.iWidgetAttributes.getItemValue("backgroundimagetype"),
			backgroundimage: this.iWidgetAttributes.getItemValue("backgroundimage"),
			backgroundimageproperty: this.iWidgetAttributes.getItemValue("backgroundimageproperty"),
	        backgroundimagetransparency: this.iWidgetAttributes.getItemValue("backgroundimagetransparency"),
	        pageborderstyle: this.iWidgetAttributes.getItemValue("pageborderstyle"),
	        pagebordercolor: this.iWidgetAttributes.getItemValue("pagebordercolor"),
	        pagemargin: this.iWidgetAttributes.getItemValue("pagemargin"),
	        applyDefaultSkinToAll: this.iWidgetAttributes.getItemValue("applyDefaultSkinToAll"),
			pageWidth: this.iWidgetAttributes.getItemValue("pageWidth"),
			pageWidthMode: this.iWidgetAttributes.getItemValue("pageWidthMode")
		};
	},	
	
	processLocationWhenChangeSkin: function(widgetId) {
		var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		var width = dojo._getContentBox(widgetSkin).w;
		var height = dojo._getContentBox(widgetSkin).h;
		var top = widgetSkin.style.top;
		var left = widgetSkin.style.left;
		
		var locationStyle = "position:absolute;width:"+width+"px;height:"+height+"px;left:"+left+";top:"+top+";";
		if ((widgetSkin.style.zIndex!=null) && (widgetSkin.style.zIndex!="")){
			locationStyle = locationStyle + "z-Index:" + widgetSkin.style.zIndex+";";
		}
		dojo.byId(widgetId).setAttribute("locationstyle",locationStyle);
	},
	
	getMinimumWidthForWidgets : function() {
	  var widgets = this.getWidgets();
	  var m = dojo.dnd.manager(), src = this.dndsource, draggingWidgetId = null, draggingBox = null;;
	  var avatar = m.avatar;
	  if (avatar && src.isDragging) {
		var node = avatar.node;
		draggingWidgetId = dojo.attr(dojo.query(".mm_iWidget", node)[0], "id");
		draggingBox = dojo.marginBox(node);
	  }
			var rightPos = dojo.map(widgets, function(widget) {
				if (widget == draggingWidgetId) {
				  return 0;
				}
				var box = dojo.marginBox(dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widget));
				return box.l + box.w;
			});
			if (draggingWidgetId && draggingBox) {
			  rightPos.push(draggingBox.l + draggingBox.w);
			}
			var min = 0;
			dojo.forEach(rightPos, function(value) {
				min = Math.max(min, value);
			});
			return min;
	},
	
	getPageMinimumWidth : function() {
		return Math.max(800, this.getMinimumWidthForWidgets());
	},
	
	createWidthRangeProvider : function(width) {
		var self = this;
		return {
			getMinimum : function() {
				return self.getPageMinimumWidth();
			},
			
			getMaximum : function() {
				return 2000;
			}
		};
	},
	
	createFixedWidthRangeProvider : function(width) {
	   return {
	      getMinimum : function() {
		     return width;
		  },
		  getMaximum : function() {
		     return width;
		  }
	   };
	},

	createWidgetListProvider : function() {
	  return {
	     getWidgetIds : dojo.hitch(this, this.getWidgets)
	  };
	},
	
	createPageWidthModeProvider : function() {
		return {
			getPageWidthMode : dojo.hitch(this, function() {
				var props = {};
                if (this.pageId) {
                  props = this.configHelper.getPageProperties(this.iWidgetAttributes);
                }
				return {
					"mode" : props.pageWidthMode || "fixed",
					"width" : props.pageWidth || 1070
				};
			})
		};
	},
	
	switchToPageMode : function(newPageMode) {
	    var pageWidthChanger = com.ibm.mm.builder.utils.pageWidthChanger;
		pageWidthChanger.setPageWidthModeProvider(this.createPageWidthModeProvider());
		if (newPageMode.mode == "fixed") {
			pageWidthChanger.setWidthRangeProvider(this.createFixedWidthRangeProvider(newPageMode.width));
			pageWidthChanger.setWidgetListProvider({
			   getWidgetIds : function() {
				  return [];
			   }
			});
			pageWidthChanger.changeWidth(newPageMode.width);
			this.moveWidgetsIntoPageBoundary(newPageMode.width);
		}
		else {
		   pageWidthChanger.setWidthRangeProvider(this.createWidthRangeProvider(newPageMode.width));
		   pageWidthChanger.setWidgetListProvider(this.createWidgetListProvider());
		   pageWidthChanger.useFluidLayout(newPageMode.width);
		}
	},
	
	moveWidgetsIntoPageBoundary : function(pageWidth) {
	  var pageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
      if (!pageId) {
        return;
      }
	  var permission = com.ibm.mm.builder.utils.acModelUtil.getUserPermission(pageId);
      if (permission == com.ibm.mm.builder.utils.acModelUtil.VIEW) {
        return;
      }	
		
	  pageWidth = dojo.marginBox(this.container).w;
	  var widgets = this.getWidgets(); 
	  var moved = false;
	  dojo.forEach(widgets, function(widgetId) {
	     var widget = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	     var box = dojo.marginBox(widget);
		 if (box.l + box.w > pageWidth) {
		    dojo.style(widget, "left", (pageWidth - box.w) + "px");
			var widgetInfo = {
				id : widgetId,
				top : box.t + "px",
				left : (pageWidth - box.w) + "px"
			};
			dojo.publish("/freeform/internalTopics/updateContainerSize",[widgetId]);
			this.iContext.iEvents.publishEvent("com.ibm.mashups.builder.widgetMoved", widgetInfo);
			moved = true;
		 }
	  }, this);
	  if (moved) {
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	  }
	},
	
	applyPageWidthMode : function() {
		var pageWidthChanger = com.ibm.mm.builder.utils.pageWidthChanger;
		pageWidthChanger.setPageWidthModeProvider(this.createPageWidthModeProvider());
		pageWidthChanger.init();
		pageWidthChanger.addPageWidthModeChangedListener(dojo.hitch(this, function(payload) {
		   var newPwm = payload.summary["new"];
		   this.configHelper.savePageWidthMode(newPwm);
		   this.switchToPageMode(newPwm);
		}));
		var storedPwm = pageWidthChanger.getPageWidthMode();
		this.switchToPageMode(storedPwm);
	},
	
	onStyleReset: function(iEvent){
		// fix for 11834, IE seems can't change the style by the dojo.attr,while FF works fine.
		if (dojo.isIE){
			this.container.style.backgroundImage = "";
			this.container.style.backgroundRepeat = "";
			this.container.style.backgroundPosition = "";
			this.container.style.filter = "";
			this.container.style.backgroundColor = "";
		}else{
			dojo.attr(this.container, "style", "");
		}
		dojo.attr(this.WID + "freeFormTable", "style", "");
		dojo.style(this.WID + "freeFormTable", "height", "100%");
		dojo.style(this.container, "height", "100%");
		
		var att = this.iContext.getiWidgetAttributes();
		att.setItemValue("backgroundimagetype", "None", false);
		att.setItemValue("pagebgcolor", "transparent", false);
		att.setItemValue("pageborderstyle", "none", false);
		att.setItemValue("backgroundimage", "", false);
		att.save();
	
		var jsonStr=com.ibm.mm.builder.utils.iwidgetUtil.dumpItemSetsToJSON(att);
		com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData(dojo.fromJson(jsonStr));
	},
	
	onStyleChanged: function(iEvent){
		var styleObject = iEvent.payload;
		for(key in styleObject){
			if(key.indexOf("background") >= 0 || key == "opacity"){
				dojo.style(this.container, key, styleObject[key]);
				
				switch(key){
					case "backgroundColor":
						this.iWidgetAttributes.setItemValue("pagebgcolor", styleObject[key], false);
						break;
					case "backgroundImage":
						var backgroundImage = styleObject[key];
						var backgroundimagetype = backgroundImage === "none" ? "None" : "URL";
						this.iWidgetAttributes.setItemValue("backgroundimage", backgroundImage, false);
						this.iWidgetAttributes.setItemValue("backgroundimagetype", backgroundimagetype, false);
						break;
					case "backgroundRepeat":
						bgiproperty = "";
						switch(styleObject[key]){
							case "no-repeat": bgiproperty = "Center"; break;
							case "repeat-x": bgiproperty = "RepeatX"; break;
							case "repeat-y": bgiproperty = "RepeatY"; break;
							case "repeat": bgiproperty = "Repeat"; break;
						}
						this.iWidgetAttributes.setItemValue("backgroundimageproperty", bgiproperty, false);
						break;
					case "opacity": 
						var bgiTransparency = 100 - 100 * parseInt(styleObject[key]);
						this.iWidgetAttributes.setItemValue("backgroundimagetransparency", bgiTransparency, false);
						break;
				}
			} else if(key === "border"){
				var borderStyle = styleObject[key];
				dojo.style(this.WID+"freeFormTable", "border", borderStyle);
				
				var subBorderStyles = borderStyle.split(" ");
				this.iWidgetAttributes.setItemValue("pageborderstyle", subBorderStyles[0] + " " + subBorderStyles[1], false);
				this.iWidgetAttributes.setItemValue("pagebordercolor", subBorderStyles[2], false);
			}
		}
		this.iWidgetAttributes.save();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	}
});
