/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.widgetLoader");
dojo.require("com.ibm.mm.builder.skinHelper");
dojo.require("com.ibm.mm.builder.dnd.QuickWireTarget");
dojo.require("com.ibm.mm.builder.widget.nvaMoveEffect");
dojo.require("com.ibm.mm.builder.dnd.MashupSource");
dojo.require("com.ibm.mm.builder.iwidget.GenericLayout");

dojo.declare("com.ibm.mm.builder.systemwidget.HiddenWidgetsCorral", com.ibm.mm.builder.iwidget.GenericLayout, {
    
	effectConstant: {
		HWCPane:{top: 50, left: 50, width: 90, height: 80}, 
		HWCButton:{top: 10, left:30, width: 25, height: 25}
	},
		
	hwcBtnPos:null,
	pageMode:"view",
	_widgetLoadedConnects: [],
    /**
     * onLoad is the event which will be called when widget is loading
     */
    onLoad: function(){	
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.HiddenWidgetsCorral");
		this.hwcContainerDiv = dojo.query(".nva", this.iContext.getRootElement())[0];
		this.dndSource = new com.ibm.mm.builder.dnd.MashupAutoSource(this.hwcContainerDiv, {
			accept: ["iWidgetDefinition", "iWidgetInstance"],
			onDndStart: function(source, nodes, copy){
				if(this === source){ com.ibm.mm.builder.utils.htmlUtil.hideNodes(nodes); }
				com.ibm.mm.builder.dnd.MashupAutoSource.prototype.onDndStart.call(this, source, nodes, copy);
			},
			
			onDndCancel: function(){
				if( this === dojo.dnd.manager().source ){ 
					com.ibm.mm.builder.utils.htmlUtil.showNodes(dojo.dnd.manager().nodes); 
				}
				com.ibm.mm.builder.dnd.MashupAutoSource.prototype.onDndCancel.call(this);
			},
			
			onDropExternal: dojo.hitch(this, function(source, nodes, copy){
				try {
					var draggedNodeId = nodes[0].id;
					var item = source.getItem(draggedNodeId)
					var type = item && item.type && item.type[0];
					type === "iWidgetDefinition" ? this.createWidget(draggedNodeId) : this.hideWidget(item.data);
				} catch (e) {
					this.LOGGER.severe("dojo.dnd.AutoSource.onDropExternal", e.message);
				}
			})
		});

		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().registerLayout(this.iContext.widgetId);
		this.iwidgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		
		dojo.subscribe(com.ibm.mm.builder.eventTopics.Widget_Hide, this, "hideWidget")
		dojo.subscribe(com.ibm.mm.builder.eventTopics.Widget_Create, this, "createWidget")
		this.widgetUnloadedHandle = serviceManager.getService("eventService").subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGETS_UNLOADED, this,this.loadWidgets);
				
		this._connections = [];
		this.layoutWidgetId = this.iContext.widgetId;
		this.widgetContainerId = this.hwcContainerDiv.id;		
	},
    
	/**
	 * hide widget from visual area
	 */
	hideWidget: function(widgetId) {
		var resizeHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHandlerExt);
		resizeHandler && resizeHandler.destroy();
		
		var resizeHeightHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHeightExt);
		resizeHeightHandler && resizeHeightHandler.destroy();
		
		var editBar = dijit.byId(widgetId + com.ibm.mm.builder.constant.editbarDragHandler);
		editBar && editBar.destroy();
		
		if(dojo.isIE || dojo.isSafari){
			var widgetBody = dojo.query(".widgetBody", com.ibm.mm.builder.constant.skinIdPrefix + widgetId)[0];
			widgetBody && (widgetBody.onselectstart = null);
		}
		this._placeWidget(dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId));
		var widgetSpan = dojo.byId(widgetId);
		this._updateWidgetSkinData(widgetSpan)
		this.iwidgetUtil.updateWidgetInstance(widgetSpan);
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	},
	
	/**
	 * create widget by definition id, for example, feedReader
	 * @param {String} wdid, widget definition id
	 */
	createWidget: function(wdid) {
		var widgetSpan = this.iwidgetUtil.createWidgetSpan(wdid);
		dojo.addClass(widgetSpan,"iWidgetSkin");
		this._updateWidgetSkinData(widgetSpan);
		this._placeWidget(widgetSpan);
		this.iwidgetUtil.updateWidgetInstance(widgetSpan, wdid);
		var handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(widgetSpan.id, function(){
        	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.autoWiringWidget", widgetSpan.id);
        });
		if(handler){
			this._widgetLoadedConnects.push(handler);
		}
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		return widgetSpan.id;
	},
	
    _placeWidget: function(node){
        if (!node) return;
        if (this.hwcContainerDiv.firstChild) {
            this.hwcContainerDiv.insertBefore(node, this.hwcContainerDiv.firstChild);
        } else {
            this.hwcContainerDiv.appendChild(node);
        }
    },
	
	_updateWidgetSkinData: function(widgetSpan){
		//todo save previouse skin and data
		var nvaSkin = com.ibm.mm.builder.utils.skinUtil.getNVANode();
		widgetSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin,nvaSkin.getID());
		widgetSpan.setAttribute("locationstyle","");	
		widgetSpan.setAttribute("visible","false");
		widgetSpan.setAttribute("layoutdata","");
	},
	
    hide: function(){
		var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
		es.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
    },
	
    /**
     * loadWidgets will init this iWidget
     * create the drop target, load widgets, add iWidgetBox object to surround the iWidget.
     */
    loadWidgets: function(){
		var handler = this._widgetLoadedConnects.pop();
		while(handler){
			com.ibm.mashups.services.ServiceManager.getService("eventService").unsubscribeEvent(handler,null);
			handler = null;
			handler = this._widgetLoadedConnects.pop();
		}
		this.hwcContainerDiv.innerHTML = "";	
        var widgetLoader = com.ibm.mm.builder.initWidgetLoader();
        var widgetString = widgetLoader.getInnerNVA(this.content);
		if (widgetString) {
            if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartApplicationWidgets()) {
                var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
                mpHandler.startTransaction();
            }
            widgetLoader.loadWidgets(this.hwcContainerDiv, widgetString);
            if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartApplicationWidgets()) {
                mpHandler.endTransaction(true);
            }
        }
    },
    
    /**
	 * Handle function for iEvent 'com.ibm.mashups.builder.pageSwitched'
	 * @param {Object} iEvent payload
     */
    onPageSwitched: function(iEvent){
		this.initialEdit = true;
        var content = "";
		if (iEvent.payload == "com.ibm.mm.builder.embedPageFailErrMsg"){return;}
        if (iEvent.payload) {
            var pageContent = com.ibm.mm.builder.utils.layoutUtil.getPageContent(iEvent.payload);
			if (pageContent == null) {
				// the layoutNode is null
				return;
			}
            this.content = pageContent.content;
        } else {
			this.content = "";
			// no NVA layout content to show, return
			return;
		}
		com.ibm.mm.builder.utils.themeUtil.unloadWidgetsInLayout(this.iContext.widgetId);
    },
    
    /**
	 * Handle function for iEvent 'com.ibm.mashups.builder.changePageMode'
	 * @param {Object} iEvent payload
     */
    onPageModeChanged: function(iEvent){
		this.pageMode = iEvent.payload;
		if(this.pageMode === "view"){
			this.hide();
		}else{
			if(this.initialEdit){
				var self = this;
				dojo.forEach(this.getWidgets(),  function(widgetId){
					if (dojo.byId(widgetId).getAttribute("internalwidget") != "true"){
						com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId] = new com.ibm.mm.builder.dnd.QuickWireTarget(
						dojo.byId(widgetId + com.ibm.mm.builder.constant.nva_skin_upper), {
				            targetId: widgetId,
				            layout: self
				    	});						
					}
				}, this);
				this.initialEdit = false;
			}	
		}
    },
	
    /**
	 * Handle function for iEvent 'onHWCPositionPublished'
	 * @param {Object} iEvent payload
     */
	onHWCPositionPublished:function(iEvent){
		this.hwcBtnPos = iEvent.payload;
	},
	
	/**
	 * Handle function for iEvent "com.ibm.mashups.builder.quickWireCreated"
	 * @param {Object} iEvent payload
	 */
    onQuickWireCreated: function(iEvent){
        var sourceId = iEvent.payload.sourceWidgetId;
        var targetId = iEvent.payload.targetWidgetId;
        if(!sourceId || !targetId) return;
        
        var effect = new com.ibm.mm.builder.widget.NvaMoveEffect({
            moverId: com.ibm.mm.builder.constant.skinIdPrefix + sourceId
        });
        
        var sourceTitle = this.iwidgetUtil.getWidgetInstanceTitle(sourceId) || "";
		sourceTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(sourceTitle);
        var targetTitle = this.iwidgetUtil.getWidgetInstanceTitle(targetId) || "";
		targetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(targetTitle);
        effect.addCallback(this.LOGGER.info, ["_autoWire", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.I_SUCCESSFUL_AUTO_WIRING_2, [sourceTitle, targetTitle])], this.LOGGER);
        effect.addCallback(this.hideWidget, sourceId, this);
		
        var result = this.prepareMove(com.ibm.mm.builder.constant.skinIdPrefix + targetId, 
			com.ibm.mm.builder.constant.skinIdPrefix + sourceId);
        effect.move(result.from, result.to);
    },
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.highlightWidget'
	 * @param {Object} iEvent payload
	 */
    onWidgetHighlighted: function(iEvent){
        var widgetId = iEvent.payload;
        if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId, this.hwcContainerDiv.id)) {
            // highlight the widget
            var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
            var coords = dojo.coords(skinDiv);
            var scroll = dojo._docScroll();
			
            var highlightDiv = dojo.byId("mmDiv_highlight");
            if (!highlightDiv) {
                highlightDiv = document.createElement("div");
                highlightDiv.id = "mmDiv_highlight";
                document.body.appendChild(highlightDiv);
            }
			dojo.mixin(highlightDiv.style, {
				position: "absolute",
	            backgroundImage: "url('" + builderConfig.builderPath + "/images/widget_highligh_color.png')",
				zIndex: 795,	// zIndex must larger than HWC container
	           	display: ""
			});
			if (this.isOpenHWC()){
				if (dojo.isIE){
					dojo.marginBox(highlightDiv, {l:coords.x + scroll.x, t:coords.y + scroll.y, w:90, h:90});
				}else{
					dojo.marginBox(highlightDiv, {l:coords.x + scroll.x, t:coords.y + scroll.y, w:90, h:94});
				}
			}else{
				dojo.marginBox(highlightDiv, {l:this.hwcBtnPos.x, t:this.hwcBtnPos.y, w:this.hwcBtnPos.w, h:this.hwcBtnPos.h});
			}
        }
    },

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.hideWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetHidden: function(iEvent){
		var widgetId = iEvent.payload;
		if (this.hwcBtnPos || this.isOpenHWC()) {
			var effect = new com.ibm.mm.builder.widget.NvaMoveEffect({
				moverId: com.ibm.mm.builder.constant.skinIdPrefix + widgetId
			});
			effect.addCallback(this.hideWidget, widgetId, this);
			var result = this.prepareMove(com.ibm.mm.builder.constant.skinIdPrefix + widgetId, null);
			effect.move(result.from, result.to);
		} else {
			this.hideWidget(widgetId);
		}
	},
	
    getPageSource: function(){
        var source = "";
		dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.hwcContainerDiv).forEach(function(widget){
			var divsToDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(
				com.ibm.mm.builder.constant.iWidgetContent, widget);
            if (divsToDel.length > 0)
				widget.removeChild(divsToDel[0]);
			source += com.ibm.mm.builder.utils.htmlUtil.getElementString(widget);
		});
        return source;
    },
    
    getWidgets: function(){
        		var widgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.hwcContainerDiv);
		var gadgets = dojo.query("." + com.ibm.mm.builder.constant.mmGGadget, this.hwcContainerDiv);
		var ss = widgets.concat(gadgets);


        //var widgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.hwcContainerDiv);
		return dojo.map(ss, function(widget){
			return widget.id;
		});
    },
    
    isOpenHWC: function(){
        return (this.iContext.dialogContainer) ? this.iContext.dialogContainer.open : false;
    },
    
    postAttachSkin: function(message){
        var skinParam = message.skinParam;
		var widgetId = message.widgetId;
		var widgetSpan = dojo.byId(widgetId);
		
        var wireIcon = dojo.byId(widgetId + "_wireIcon");
        var editIcon = dojo.byId(widgetId + "_editIcon");
        dojo.attr(wireIcon, "src", builderConfig.builderPath + 
			(builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png" : "/images/d_wiring_icon.png"));
		dojo.attr(editIcon, "src", builderConfig.builderPath + 
			(builderConfig.isBidi ? "/images/context_menu_rtl.png" : "/images/context_menu.png"));
        
        wireIcon.title = wireIcon.alt = com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_WIRE_ICON_TITLE;
        editIcon.title = editIcon.alt = com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_EDIT_ICON_TITLE;
        
		if (!dojo.isIE || (dojo.isIE && this.pageMode === "edit")) {
			this.initialEdit = false;
			// create quick wire target
			com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId] = new com.ibm.mm.builder.dnd.QuickWireTarget(
				dojo.byId(widgetId + com.ibm.mm.builder.constant.nva_skin_upper), {
		            targetId: widgetId,
		            layout: this
		   	});
		}
		com.ibm.mm.builder.utils.skinUtil.markIWidgetInstanceAsDraggable(widgetId);
		
        this._connections.push(dojo.connect(editIcon, "onclick", this, function(e){
            com.ibm.mm.builder.skinHelper.createMenu(e, skinParam.menuId, widgetId, true);
        }));
		this._connections.push(dojo.connect(editIcon, "onkeypress", function(e){
            if (e.keyCode == dojo.keys.ENTER)
                com.ibm.mm.builder.skinHelper.createMenu(e, skinParam.menuId, widgetId, true);
        }));
        this._connections.push(dojo.connect(wireIcon, "onclick", function(e){
            com.ibm.mm.builder.skinHelper.launchWiring(widgetId);
        }));
        this._connections.push(dojo.connect(wireIcon, "onkeypress", function(e){
            if (e.keyCode == dojo.keys.ENTER)
                com.ibm.mm.builder.skinHelper.launchWiring(widgetId)
        }));

        var nvaMenuIcon = dojo.query(".nvaMenuIcon", dojo.byId(widgetId + com.ibm.mm.builder.constant.nva_skin_upper));
        this._connections.push(dojo.connect(nvaMenuIcon[0], "onkeypress", 
			this, dojo.partial(this._nvaMenuIconOnKeypress, widgetId)));
    },
    
	_nvaMenuIconOnKeypress: function(widgetId, e){
		if(e.keyCode == dojo.keys.ENTER)
        	com.ibm.mm.builder.skinHelper.displayMenuIcon(widgetId + com.ibm.mm.builder.constant.menuHandler, 
				widgetId + "_icon", widgetId + '_name', widgetId + '_upper');
	},
	
    onUnload: function(){
		if (this.dndSource && this.dndSource.destroy)
			this.dndSource.destroy();
		dojo.unsubscribe(this.widgetUnloadedHandle);
		dojo.forEach(this.getWidgets(), function(widgetId){
			com.ibm.mm.builder.commonActions.removeWidget(widgetId);
		});	
    	this.hwcContainerDiv.innerHTML = "";

		dojo.forEach(this._connections, dojo.disconnect);
	},
    
    prepareMove: function(targetId, moverId){
        var from = dojo.coords(targetId);
		
		var to = this.isOpenHWC() ? dojo.mixin(dojo.coords(this.hwcContainerDiv), {
				w: this.effectConstant.HWCPane.width,
				h: this.effectConstant.HWCPane.height
			}) : dojo.mixin(this.hwcBtnPos, {
				w: this.effectConstant.HWCButton.width,
				h: this.effectConstant.HWCButton.height
			});
		
        return { from: from, to: to };
    }
})
