/* Copyright IBM Corp. 2009  All Rights Reserved.                    */
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.widget.CustomDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.io.iframe");

dojo.declare("com.ibm.mm.builder.importWidget",[dijit._Widget, dijit._Templated],{	
	//todo refactory the style
	widgetsInTemplate: true,    
	templateString: 
		'<div>'+
			'<form style="margin:0" enctype="multipart/form-data" dojoAttachPoint="importForm" id="" name="" accept-charset="UTF-8" method="post" onsubmit="javascript:return false;">' +
			'<div class="importWidget_selection_div">'+
				'<div>'+
					'<span dojoAttachPoint="message"></span>'+
				'</div>'+
				'<div>'+
					'<label dojoAttachPoint="widgetTitleLabel" for="file" class="importWidget_item_title"></label>'+
				'</div>'+
				'<div class="importWidget_item_content">'+
					'<nobr><input dojoAttachPoint="widgetName" name="" id="file" type="file" class="importWidget_input" size="32" dojoAttachEvent="onchange:_hideMessage"></input></nobr>'+
				'</div>'+
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" '+
				'IWID="_IWID_" '+
				'saveText="${I_COMMON_OK}" '+
				'cancelClass="common_cancel importWidget_cancel" '+
				'dojoAttachEvent="onSave:save, onCancel:hide">'+
			'</div>'+			
			/*			
			'<div class="importWidget_btn_line">'+
				'<a class="importWidget_cancel" dojoAttachPoint="cancelBtn" dojoAttachEvent="onclick: hide"></a>'+
				'<input type="button" class="lotusFormButton" dojoAttachPoint="okBtn" dojoAttachEvent="onclick: save"/>'+
			'</div>'+
			*/
			'</form>' +
		'</div>',
	
	I_COMMON_OK: "${I_COMMON_OK}",
		
    onLoad: function() {
		this.es = com.ibm.mashups.services.ServiceManager.getService("eventService");
		var contentDiv = dojo.query("."+com.ibm.mm.builder.constant.iWidgetContent, this.iContext.getRootElement())[0];
		if(contentDiv)
			contentDiv.appendChild(this.domNode);
		else
			this.iContext.getRootElement().appendChild(this.domNode);
	},

	postCreate: function(){	
		this.widgetTitleLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_IMPORT_WIDGET_PROMPT;
		//this.cancelBtn.innerHTML=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL;
		//this.okBtn.value=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK;
	},
	
	/**
	 * hide the page property dialog
	 */		
	hide: function(){
		this.es.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},
	
	/**
	 * reset the theme selection
	 */
	updateProperty: function(payload){
		this._hideMessage();
		this.spaceId = null;
		var formElement = this.importForm;
		var fileInput = this.widgetName;
		if(payload && payload.spaceId) {
			this.spaceId = payload.spaceId;
			formElement.id = "pageForm";
			formElement.name = "pageForm";
			fileInput.name = "xmlPage";
		}
		else {
			formElement.id = "spaceForm";
			formElement.name = "spaceForm";
			fileInput.name = "zip";
		}
	},
		
	save: function(){
		var fileInput = this.widgetName;
		if (fileInput.value == null || fileInput.value == "") {
			this._showMessage(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_FILENAME_IS_REQUIRED_0, "error");
		}
		else 
		{
	       	var spaceModel = com.ibm.mashups.enabler.model.Factory.getSpaceModel();
			var submittableForm;
			var parameters = {};
			if (this.spaceId) {
				// post the spaceId which the page will be added to server.
				if (fileInput.value.match(/.xml$/) || fileInput.value.match(/.data$/)) {
					if (fileInput.value.match(/.xml$/)){
						submittableForm = spaceModel.getSubmittableForm("pageForm", this.spaceId);
						parameters.type = "page";
					}
					else{
						// when we import page .data file came from BSpace old data, we should use the paceForm and post the spaceId to space rest api.
						submittableForm = spaceModel.getSubmittableForm("spacePageForm", this.spaceId, "pageForm");
						parameters.type = "spacePage";
					}					
				}
				else {
					this._showMessage(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_INVALID_FILE_TYPE_0, "error");
				}
			}
			else {
				if (fileInput.value.match(/.zip$/) || fileInput.value.match(/.data$/)) {
					submittableForm = spaceModel.getSubmittableForm("spaceForm");
				}
				else {
					this._showMessage(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_INVALID_FILE_TYPE_0, "error");
				}
			}
			var _self = this;
			var callbackhandler = function(data, status, parameters) {
				var importType = parameters.type;
				if (status == com.ibm.mm.enabler.model.HttpStatusCodes.HTTP_CREATED) {
							
					//parse data
					var embeddedData = data.substring(9,data.length-3);
					var encodedEmbeddedData = embeddedData.replace(/&/g,"&amp;");
					var responseXML = dojox.data.dom.createDocument(encodedEmbeddedData);
					if (!responseXML){
						if (importType == "page") {
							parameters.dialog._showMessage(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PAGE_IMPORT_FAIL_1, [data]), "error");
						}
						else {
							parameters.dialog._showMessage(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_FAIL_1, [data]), "error");
						}
						return;
					}
					
					parameters.dialog.hide();
					var id;
					var entryNodes = responseXML.getElementsByTagName("atom:entry");
					if (entryNodes.length == 0) {
						entryNodes = responseXML.getElementsByTagName("entry");
					}
					
					// if upload the old BSpace .data file, the response feeds is different with normal. Like <atom:feed><atom:id/></atom:feed>
					// so the responseXML.getElementsByTagName("entry") would return empty list. 
					if (entryNodes.length == 0) {
						entryNodes = responseXML.getElementsByTagName("atom:feed");
					}
					
					for (var i = 0; i < entryNodes.length; i++) {
						var childNodes = entryNodes[i].childNodes;
						for (var j=0;j<childNodes.length;j++) {
							var childNode = childNodes[j];
							if (childNode.nodeName == "atom:id") {
								id = childNode.firstChild.data;
								break;
							}
						}
					}
					var payload = id.split(":")[2];
					// Refresh space manager
					if (importType == "page") {
						var newPageId = payload;
						var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);
						var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(newPageId);
						var _constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	           			
						dojo.publish(_constants.Topic.Space.refresh, [_constants.Action.ADD_PAGE, {spaceId: _self.spaceId, parentPageId: parentPageId, page: newPage}]);
						com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshNavigation");						
					}
					else if (importType == "spacePage"){
						// Handle the response about the importing old page data from BSpace.
						var _constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
						dojo.publish(_constants.Topic.Space.refresh,[_constants.Action.EDIT_SPACE, {spaceId: payload}]);
						com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
					}
					else {
						
						var es = com.ibm.mashups.services.ServiceManager.getService("eventService");						
						es.broadcastEvent("com.ibm.mashups.builder.spacemanager.spaceCreated", payload);
					}
				}
				else {
					if (importType == "page") {
						parameters.dialog._showMessage(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PAGE_IMPORT_FAIL_1, [data.message]), "error");
					}
					else {
						parameters.dialog._showMessage(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_IMPORT_FAIL_1, [data.message]), "error");
					}
				}
			};
			if (submittableForm) {
				this._hideMessage();
				var deferred = submittableForm.submit();
				parameters.dialog = this;				
				deferred.setFinishedCallback(callbackhandler, parameters);
				deferred.start();
			}
		}
	},

	_showMessage : function(message, type) {
		if(!this._messageControl){
			var node = dojo.doc.createElement("div");
			this.message.appendChild(node);
			this._messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
			messageType: 'error'}, node);
		}
		this._messageControl.attr({
			"message" : message,
			"type" : type || "info"
		});
		this._messageControl.show();
	},
	
	_hideMessage : function() {
		if(this._messageControl){
			this._messageControl.hide();
		}
	},
		
	onImportWidget: function(iEvent) {
		this.updateProperty(iEvent.payload);
	}

});
