/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.iwidget.ModeSelector");
dojo.require("com.ibm.mm.builder.commonActions");

dojo.declare("com.ibm.mm.builder.systemwidget.ModeSelector", null, {
	
    selector: null,
    
    newPage: false,
    
    onLoad: function(){
        this.selector = new com.ibm.mm.builder.iwidget.ModeSelector({}, dojo.query(".modeSelector", this.iContext.getRootElement())[0], this.iContext)
		this.eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
    },
    
    onview: function(){
    },
    /**
     * OnNewWire function, publish current page mode
     */
    publishPageMode: function(){
       this.eventService.broadcastEvent("com.ibm.mashups.builder.changePageMode", "view");
       com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setPageMode("view");
    },
    
    onPageModeChanged: function(mode){
		if (!com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
			this.selector.updateModeSelector(mode);
		}
    },
    
    onPageSwitched: function(iEvent){
        var pageId = iEvent.payload;
        if(pageId) {
	        //Default, Go to 'View" mode when switching page
	        if(!this.newPage) {
				if (!com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
					var isEmptyPage = com.ibm.mm.builder.utils.pageUtil.isEmptyPage(com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId));
					var accessLevel = com.ibm.mm.builder.utils.acModelUtil.VIEW;
					if (!isEmptyPage) {
						accessLevel = com.ibm.mm.builder.utils.acModelUtil.getUserPermission(pageId);
					}
					this.selector.updatePermissionWithLevel(accessLevel);
					this.selector.updateModeSelector("View");
				}
				com.ibm.mm.builder.commonActions.changePageMode("view");
	        }
	        // Go to 'Edit" mode if it's a new created page
	        else {
				if (!com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
					this.selector.updatePermissionWithLevel(com.ibm.mm.builder.utils.acModelUtil.EDIT);
					this.selector.updateModeSelector("Edit");
				}
				com.ibm.mm.builder.commonActions.changePageMode("edit");
	        	this.newPage = false;
	        }
        }
        else {
			if (!com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
				this.selector.updatePermissionWithLevel(com.ibm.mm.builder.utils.acModelUtil.VIEW);
				this.selector.updateModeSelector("View");
			}
			com.ibm.mm.builder.commonActions.changePageMode("view");
        }
    },
    
    onPageCreated: function(iEvent){
        this.newPage = true;
    },
    
    onUnLoad: function(){
        if (this.selector != null) {
			this.selector.destroy();
            this.selector = null;
        } 
    }
    
})
