dojo.require("com.ibm.mm.builder.widget.ShadowMenu");
dojo.requireLocalization("com.ibm.bundles", "Theme");

dojo.declare("com.ibm.mm.builder.systemwidget.moreActionsMenu", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {

	menu:null,
	
	onView: function(){
		this.inherited(arguments);
		this.moreActionsButton.title = this.buttonText.innerHTML = 
			dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["theme_more_actions"];
		if (com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()){
			//we need a style for disabled button
			this.moreActionsButton.disabled = true;
			dojo.addClass(this.moreActionsButton,"lotusBtnDisabled");
		}
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
				this.renderMenu(evt);
			break;
		}
	},
	
	_onClick: function(evt){
		this.renderMenu(evt);
	},
	
	renderMenu: function(evt){
		!this.menu && this.createMenu();
		
		var pageModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		var currentPageMode = pageModel.getPageMode();
		var pageChanged = pageModel.isDirty();
		
		dojo.forEach(this.menu.getChildren(), function(menuItem){
			switch(menuItem.pageActionType){
				case "tabEditPage":
				case "tabNVA":
					menuItem.attr("disabled", currentPageMode != "edit");
					break;
				case "tabSavePage":
					menuItem.attr("disabled", !pageChanged);
					break;
			}
		}, this);
		
		this.menu._openMyself(evt);
	},
	
	createMenu: function() {
		this.menu = new com.ibm.mm.builder.widget.ShadowMenu({
			targetNodeIds: [this.moreActionsButton],
			offset_y: 9
		});
		
		dojo.addClass(this.menu.domNode,"moreActionMenu");
		
		var contextMenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var moreActionsMenus = contextMenu.getContextMenu("ContextMenu.moreActions", currentPageId, 
			null, { context:this });
		
		for (var i = 0; i < moreActionsMenus.length; ++i) {
			this.menu.addChild(moreActionsMenus[i].isSeparator ? new dijit.MenuSeparator() : 
				new dijit.MenuItem({
					label: moreActionsMenus[i].title,
					iconClass: moreActionsMenus[i].iconClass,
					disabled: moreActionsMenus[i].enabled == "disabled",
					onClick: moreActionsMenus[i].actionCallBackFunction,
					pageActionType: moreActionsMenus[i].id
				})
			);
		}
		this.menu.startup();
	},
	
	onPageSwitched: function(iEvent){
		this.menu && this.menu.destroyRecursive();
		this.createMenu();
	},
		
	onUnLoad: function(){
		if (this.menu != null) {
			this.menu.destroy();
	        this.menu = null;
	    } 
	}
});
