/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.builder.iwidget.navigation.NavigationPanel");

dojo.declare("com.ibm.mm.builder.systemwidget.Navigator", com.ibm.mm.builder.iwidget.SystemWidget, {
	
    onLoad: function(){
    	this.navigator = new com.ibm.mm.builder.iwidget.navigation.NavigationPanel();
		
		this.getViewRootNode().appendChild(this.navigator.domNode);
		this.eventService.subscribeEvent("com.ibm.mashups.enabler.model.state.onNavStateUpdated", this, function(){
			var pu = com.ibm.mm.builder.utils.pageUtil;
			var cid = pu.getCurrentPageId();
			var newId = pu.getPageIdFromSpace();
			
			if (cid !== newId && !this.isSwitching) {
				this.onSwitchPage({ payload: newId });
				if (!pu.isGlobalPage()) {
					dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, cid, {expires:3652});
				}
			}
		});
	},
	
	onSwitchPage: function(iEvent){
		var cb = dojo.hitch(this, function(){
			this.isSwitching = true;
			try {
				this.navigator.render(iEvent.payload);
			} 
			catch (e) {
				var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAVIGATION_SWITCH_PAGE_1, [e.message]);
				this.LOGGER.severe("onSwitchPage", msg);
			}
			this.isSwitching = false;
			this.handleOnSwitchPage(iEvent);
		});
		
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
	},
	
	//callback to extend onSwitchPage method
	handleOnSwitchPage: function(iEvent){
	},
	
	onRefresh: function(iEvent){
		try{
			this.navigator.refresh(iEvent.payload);
		}catch(e){
			var msg = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_REFRESH_NAVIGATION_1,[e.message]);
			this.LOGGER.severe("onRefresh",msg);
		}
	},
	
	onOpenPage: function(iEvent){
		// there are two kinds of payload format for ievent com.ibm.mashups.builder.openPage
		// 1. payload is a string : the page id, just switch to the page.
		// 2. payload is a JSON format : {"pid":"123456",eventsArray:{{"targetEvent": targetEvent1, "payload": payload1, "payloadType": payloadType1},{"targetEvent": targetEvent2, "payload": payload2, "payloadType": payloadType2}}}
		// for 2, need to broadcast the event array first and then switch page.	

		
		var pu = com.ibm.mm.builder.utils.pageUtil;
		
		var cid = pu.getCurrentPageId();
		var targetId = iEvent.payload.pid || iEvent.payload
		
		if (!targetId || !pu.getPageNode(targetId)) { return; }
		
		var cb = dojo.hitch(this, function(){
			com.ibm.mm.builder.utils.pageUtil.changePageMode("view");
			this.eventService.broadcastEvents(iEvent.payload.eventsArray || [], cid, targetId);
		});
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);		
	},
	
	onClosePage: function(iEvent){
		if (!com.ibm.mm.builder.utils.pageUtil.isGlobalPage()) { return; }
		
		if (iEvent.payload != com.ibm.mm.builder.utils.pageUtil.getCurrentPageId()) { return; }
		
		var ppid = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid);
		dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
		this.onSwitchPage({payload: ppid});
	}
});
