/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.widget.OpenSearchDropdownMenu");

dojo.declare("com.ibm.mm.builder.systemwidget.openSearchBox",null,{	
	searchTypeMenu:"",
	eventConnects : [],
	showMenu:false,		
	onLoad:function(){
		
		// Disable openSearch dialog if hub is not configured
		var hubUrl = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.HUB_URL);
		if (!hubUrl) {
			return;
		}
		
		dojo.registerModulePath("com.ibm.mm.catalog", this.iContext.io.rewriteURI("../js/com/ibm/mm/catalog"));
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		dojo.requireLocalization("com.ibm.mm.catalog", "openSearchMessage",cs.getValue("locale"), cs.getValue("availableLocales"));
		var bundle;
		try {
			bundle = dojo.i18n.getLocalization("com.ibm.mm.catalog", "openSearchMessage");
		} catch(e) {
			dojo.requireLocalization("com.ibm.mm.catalog","openSearchMessage",ibmConfig["default.locale"],cs.getValue("availableLocales"));
			bundle = dojo.i18n.getLocalization("com.ibm.mm.catalog", "openSearchMessage", ibmConfig["default.locale"]);
		}
		this._searchHint =  {"all": bundle.SEARCH_ALL_0, "feeds": bundle.SEARCH_FEEDS_0, "widgets": bundle.SEARCH_WIDGETS_0,"pages": bundle.SEARCH_PAGES_0};

		var bannerSearchInput = dojo.byId("bannerSearchKeywordInput");		
		bannerSearchInput.value = this._getSearchHint();
		dojo.attr(bannerSearchInput,"title",bundle.BANNEERSEARCH_INPUT_TITLE_0);
		
		bannerSearchInput.onfocus = function() {
			if (dojo.hasClass(bannerSearchInput, "initBannerSearchInput")) {
				dojo.removeClass(bannerSearchInput, "initBannerSearchInput");
				dojo.addClass(bannerSearchInput, "bannerSearchInput");
				bannerSearchInput.value = "";
			}
		};
		var self = this;
		bannerSearchInput.onkeydown = dojo.hitch(this, function(evt) {
			evt = evt || window.event;
			if (evt && evt.keyCode == 13) {	//enter key to trigger
                self.search();
            }
		});
		
		bannerSearchInput.onblur = function(){
			var value = bannerSearchInput.value;
			if (!value) {
				if (dojo.hasClass(bannerSearchInput, "bannerSearchInput")) {
					dojo.removeClass(bannerSearchInput, "bannerSearchInput");
					dojo.addClass(bannerSearchInput, "initBannerSearchInput");
				}
				bannerSearchInput.value = self._getSearchHint();			
			}
		};
		
		var bannerSearchButton = dojo.byId('bannerSearchButton');
		if(builderConfig.isBidi){
			bannerSearchButton.src = "/mum/images/search_rtl.gif";
		}
		else {
			bannerSearchButton.src = "/mum/images/search.gif";
		}
		bannerSearchButton.title = com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_CATALOG;
		bannerSearchButton.onclick = dojo.hitch(this, this.search);

		setTimeout(dojo.hitch(this,this.createSearchScope,100));
		
		dojo.subscribe("com.ibm.mm.catalog.Topics.SearchType_Change",this,function(type){
			com.ibm.mm.builder.openSearchType = type;
			if(dojo.hasClass(bannerSearchInput, "initBannerSearchInput")){
				bannerSearchInput.value = self._getSearchHint();	
			}
		});
		
//		var openSearchType = dojo.byId("bannerOpenSearchType");
//		
//		this.eventConnects.push(dojo.connect(openSearchType, "onclick", dojo.hitch(this, function(evt) {
//			dojo.stopEvent(evt);
//			var position = dojo.coords(openSearchType);
//			if (!position.l) position.l = 464;
//			if (!position.t) position.t = 38;
//			this.searchTypeMenu.style.top = (position.y + 21) + "px";
//			this.searchTypeMenu.style.left = (position.x) + "px";
//			this.searchTypeMenu.style.position = "absolute";
//			this._showActions(!this.showMenu);
//			this._dropDownMenuConnectionHandler = dojo.connect(document, "onclick", this, "_closeDropDownMenu");
//		})));
	},
	
	search:function(){
		var bannerSearchInput = dojo.byId("bannerSearchKeywordInput");
		if (dojo.hasClass(bannerSearchInput, "initBannerSearchInput")) {
			dojo.removeClass(bannerSearchInput, "initBannerSearchInput");
			dojo.addClass(bannerSearchInput, "bannerSearchInput");
			bannerSearchInput.value = "";
		}
		var kw = dojo.trim(bannerSearchInput.value);
		if (dojo.hasClass(bannerSearchInput, "initBannerSearchInput")) {
			kw = "";
		}
		if (!com.ibm.mm.catalog.openSearchDialog) {
			var openSearchDialogDiv = dojo.doc.createElement("div");
			dojo.body().appendChild(openSearchDialogDiv);
			var openSearchDiv = dojo.doc.createElement("div");
			
			dojo.addClass(openSearchDiv, com.ibm.mm.builder.constant.mmIWidget);
			com.ibm.mm.builder.utils.iWidgetSpecUtil.setWidgetDefXML(openSearchDiv, builderConfig.builderPath + "/widget-catalog/openSearch.xml");
			openSearchDiv.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_id,com.ibm.mm.builder.utils.iwidgetUtil._getUid());
			var itemset = com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
			openSearchDiv.appendChild(itemset);
			com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(itemset, "keyword", kw);
			openSearchDiv.style.height = "575px";
			
			openSearchDialogDiv.appendChild(openSearchDiv);
			this.iContext.processiWidgets(openSearchDiv);
			
			com.ibm.mm.catalog.openSearchDialog = new com.ibm.mm.builder.widget.CustomDialog(
				{
					type: "Search",
					nodeWidth: "660px",
					nodeHeight: "587px",
					containerBackgroundColor: "white",
					displayCloseButton: true,
					hasRightBottomResizer: false,
					titleBarHeight:"13px",
					leftBarWidth:"13px",
					rightBarWidth: "13px",
					sharedWidget: true
				}, 
				openSearchDialogDiv
			);
			
			//add this style for safari overflow
			dojo.addClass(com.ibm.mm.catalog.openSearchDialog.containerNode, "openSearchDialogContainer");
			
		} else {
			com.ibm.mm.catalog.openSearchPane.setKeyword(kw);
		}
		com.ibm.mm.catalog.openSearchDialog.show();
		/*
		 * position modal dialog in center of screen
		 */
		var id = com.ibm.mm.catalog.openSearchDialog.domNode.id;
		var dialogDiv = dojo.byId(id);
		
		var viewport = dijit.getViewport();
	    var mb = dojo.marginBox(dialogDiv);

	    var style = dialogDiv.style;
	    style.left = Math.floor((viewport.l + (viewport.w - mb.w)/2)) + "px";
	    style.top = Math.floor((viewport.t + (viewport.h - mb.h)/2)) + "px";
			
	},
	
  	_getSearchHint: function() {
		return this._searchHint[com.ibm.mm.builder.openSearchType] || "Search"; 
	},
	
	_showActions: function(show) {
		if(show) {
			this.searchTypeMenu.style.display = "block";			
			this.showMenu = true;
		} else {
			this._closeDropDownMenu();			
		}
	},
	
	createSearchScope:function(){
		var message;
		try {
			message = dojo.i18n.getLocalization("com.ibm.mm.catalog", "openSearchMessage");
		} catch(e) {
			message = dojo.i18n.getLocalization("com.ibm.mm.catalog", "openSearchMessage", ibmConfig["default.locale"]);
		}
		var tMenu = new com.ibm.mm.builder.widget.OpenSearchDropdownMenu({targetNodeIds:["bannerOpenSearchType"],leftClickToOpen:true});		
		var all = new com.ibm.mm.builder.widget.OpenSearchDropdownMenuItem({
			type:"all",
			label : message.SEARCH_TYPE_ALL_0,
			onClick: dojo.hitch(this,this._onMenuItemClick,"all")
		});
		tMenu.addChild(all);
		tMenu.addChild(new com.ibm.mm.builder.widget.OpenSearchDropdownMenuSeparator());
		tMenu.entrys.push(all);
		
		var feed = new com.ibm.mm.builder.widget.OpenSearchDropdownMenuItem({
			type:"feeds",
			label :message.SEARCH_TYPE_FEED_0,
			onClick: dojo.hitch(this,this._onMenuItemClick,"feeds")
		});			
		tMenu.addChild(feed);
		tMenu.entrys.push(feed);
		
		var widget = new com.ibm.mm.builder.widget.OpenSearchDropdownMenuItem({
			type:"widgets",
			label : message.SEARCH_TYPE_WIDGET_0,
			onClick: dojo.hitch(this,this._onMenuItemClick,"widgets")
		});
		tMenu.addChild(widget);
		tMenu.entrys.push(widget);
        
		var page = new com.ibm.mm.builder.widget.OpenSearchDropdownMenuItem({
			type:"pages",
			label : message.SEARCH_TYPE_PAGE_0,
			onClick: dojo.hitch(this,this._onMenuItemClick,"pages")
		});
		tMenu.addChild(page);
		tMenu.entrys.push(page);
		
		tMenu.startup();
		tMenu.setCurrentSearchType(all.domNode);

	},
	
	_onMenuItemClick: function(type){
		dojo.publish("com.ibm.mm.catalog.Topics.SearchType_Change", [type]);
	},
	
	_closeDropDownMenu: function() {
		this.searchTypeMenu.style.display = "none";
		dojo.disconnect(this._dropDownMenuConnectionHandler);
		this.showMenu = false;

	},
	
	destroy:function() {
		dojo.byId('bannerSearchButton').onclick = null;
		dojo.byId('bannerSearchKeywordInput').onkeydown = null;
		dojo.byId('bannerSearchKeywordInput').onblur = null;
		dojo.byId('bannerSearchKeywordInput').onfocus = null;
		dojo.forEach(this.eventConnects, dojo.disconnect);
	}	  
});
com.ibm.mm.builder.openSearchType = "all";
