/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.dnd.MashupSource");

dojo.declare("com.ibm.mm.builder.systemwidget.PageIcons", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {
    
	hwcDialogID: null,
	
    onLoad: function(){
		dojo.connect(window, "resize", this, this.publishHWCPosition);
		dojo.subscribe(com.ibm.mm.builder.eventTopics.Save_Icon_Change, this, "saveIconChange");
	},
	
    onView: function(){
    	this.inherited(arguments);
		
		/*
		 * If display is bidi:
		 * 1. set nvaIcon to the rtl widget
		 * 2. enable the rtl icon
		 * 3. disable the ltr icon
		 */
		var isBidi = builderConfig.isBidi;
		this.nvaIcon = isBidi ? this.nvaIconRtl : this.nvaIconLtr;
		this.nvaImgPosition = isBidi ? this.pageIconsViewImgRtl : this.pageIconsViewImg;
		//todo: fix the disappear of nva icon and hub icon in ie6
		if(dojo.isIE === 6){ 
			this.nvaImgPosition.src = builderConfig.builderPath + "/images/toolbox/" + (isBidi ? "corral_button_rtl.png" : "corral_button.png");
			this.pageIconsAddImg = builderConfig.builderPath + "/images/toolbox/add_widget_button.png";
			this.pageIconsAddImgRtl =  builderConfig.builderPath + "/images/toolbox/add_widget_button_rtl.png";
		}
		dojo.style(this.nvaIconRtl, "display", isBidi ? "inline" : "none");
		dojo.style(this.nvaIconLtr, "display", isBidi ? "none" : "inline");
		
		if (!builderConfig.hasHub) {
			dojo.style(this.catalogIconRtl, "display", "none");
			dojo.style(this.catalogIconLtr, "display", "none");
		}else{
			dojo.style(this.catalogIconRtl, "display", isBidi ? "inline" : "none");
			dojo.style(this.catalogIconLtr, "display", isBidi ? "none" : "inline");	
		}
	
		this.nvasource = new com.ibm.mm.builder.dnd.MashupSource(this.nvaIcon, {
			
			accept: ["iWidgetDefinition", "iWidgetInstance"],
			
			onDropExternal: function(source, nodes, copy){
				var draggedNodeId = nodes[0].id;
				var item = source.getItem(draggedNodeId)
				var type = item && item.type && item.type[0];
				if(type === "iWidgetDefinition"){
					//nvaLayout.createWidget(draggedNodeId);
					dojo.publish(com.ibm.mm.builder.eventTopics.Widget_Create, [item.data]);
				}else{
					//nvaLayout.hideWidget(item.data);
					dojo.publish(com.ibm.mm.builder.eventTopics.Widget_Hide, [item.data]);
				}
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
			}
		});
		
		this.pageIconsViewImg.title = com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_NVA_TOOLTIP;
		this.pageIconsAddImg.title = com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_ADD_WIDGET_TOOLTIP;
		this.pageIconsSaveImg.title = com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_SAVE_PAGE_TOOLTIP;
		this.pageIconsViewImgRtl.title = com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_NVA_TOOLTIP;
		this.pageIconsAddImgRtl.title = com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_ADD_WIDGET_TOOLTIP;
		this.pageIconsSaveImgDis.title = com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_SAVE_PAGE_TOOLTIP;
		
		/* begin additions for accessibility */
		dojo.attr(this.nvaIconLtr,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_NVA_TOOLTIP);
		dojo.attr(this.nvaIconRtl,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_NVA_TOOLTIP);
		
		dojo.attr(this.catalogIconLtr,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_ADD_WIDGET_TOOLTIP);
		dojo.attr(this.catalogIconRtl,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_ADD_WIDGET_TOOLTIP);
		
		dojo.attr(this.saveIconEnable,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_SAVE_PAGE_TOOLTIP);		
		dojo.attr(this.saveIconDisable,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_TOOLBOX_SAVE_PAGE_TOOLTIP);			
		/* end additions for accessibility */
				
		this.nvasource.startup();
    },
	
	saveIconChange: function(isChanged){
		dojo.style(this.saveIconEnable, "display", isChanged ? "inline" : "none");
		dojo.style(this.saveIconDisable, "display", isChanged ? "none" : "inline");
	},
	
	onPageModeChanged: function(iEvent){
        var mode = iEvent.payload;
		
		if (mode === "view") {
			dojo.fx.wipeOut({
				node: this.iContext.getRootElement(),
				duration:500
			}).play();
		} 
		
		if(mode === "edit"){
			dojo.fx.wipeIn({ 
				node: this.iContext.getRootElement(), 
				duration:500
			}).play();
			this.publishHWCPosition();
		}
    },

    _showHiddenWidgetsCorrel:function(e){
		if(e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			 this.showHiddenWidgetsCorrel();
		}
	},
	
	showHiddenWidgetsCorrel:function(){
		if(!this.hwdDialogID) {  
	        var coords = dojo.coords(this.nvaIcon);
	        
			var scroll = dojo._docScroll();		
			var width = 770;
			if (builderConfig.isBidi) {
				width = dojo.isIE===6 ? 230 : 180;
			}
			var left = (coords.l + scroll.x + width) + "px"; // width of NVA + closeButton
			var top = (coords.t + scroll.y + 120) + "px"; // height of closeButton
			
			this.hwdDialogID = dojo.dnd.getUniqueId();
			
			var dialogParam = {
	            id: this.hwdDialogID,
	            nodeWidth: "375px",
	            nodeHeight: "360px",
				nodeStyle: "overflowY:auto",
	            title: this.cws.I_NVA_TITLE,
	            displayCloseButton: true,
	            hasRightBottomResizer: false,
	            modelDialog: false,
	            titleBarHeight: 25,
	            endBarHeight: 18,
	            sharedWidget: true,
				initLeftPosition: left,
				initTopPosition: top,
				alwaysCenter: false,
				needUnderLay: false
	        };
			var payload = {
			    	widgetTypeId: "hiddenWidgetCorral",
			        eventName:  null,
			        eventPayload:  null,
			        dialogParam:  dialogParam
			};
			this.eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
		}
		else {
			var dialog = dijit.byId(this.hwdDialogID);
			dialog.open ? dialog.hide() : dialog.show();
		}
		
	},
	
	onHWCOver:function(){
		if(this.nvasource.isDragging){
			this.nvaIcon.title = this.cws.I_TOOLBOX_NVA_DND_TOOLTIP;
			this.nvaIcon.className="corral_button_over_state";
		}
		this._changeImage(this.nvaIcon,"/images/toolbox/corral_button_over_state.png");
	},
	
	onHWCOut:function(){
		this.nvaIcon.className="corral_button";		
		this.nvaIcon.title = this.cws.I_TOOLBOX_NVA_TOOLTIP;
		this._changeImage(this.nvaIcon,"/images/toolbox/corral_button.png");
	},
	
	onCatalogOver:function(){
		this._changeImage(this.catalogIconLtr,"/images/toolbox/add_widget_button_hover.png");
	},
	
	onCatalogOut:function(){
		this._changeImage(this.catalogIconLtr,"/images/toolbox/add_widget_button.png");
	},
	
	onSaveOver:function(){
		this._changeImage(this.saveIconEnable,"/images/toolbox/save_button_hover.png");
	},
	onSaveOut:function(){
		this._changeImage(this.saveIconEnable,"/images/toolbox/save_button_enabled.png");
	},
	
	onSaveDisabledOver:function(){
		this._changeImage(this.saveIconDisable,"/images/toolbox/save_button_disabled_hover.png");
	},
	onSaveDisabledOut:function(){
		this._changeImage(this.saveIconDisable,"/images/toolbox/save_button_disabled.png");
	},
	
	_changeImage:function(imgAttachPoint, imageName){
		var imgNode = dojo.query("img",imgAttachPoint)[0];
		imgNode.src = builderConfig.builderPath + imageName;
	},
	
	_gotoCatalog:function(e){
		if(e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			 this.gotoCatalog();
		}
	},
	
	gotoCatalog:function(){
		com.ibm.mm.builder.commonActions.catalogNewWindow();
	},
	
	_savePage:function(e){
		if(e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.savePage();
		}
	},
	
	savePage:function(){
		if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()){
			this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
			this.LOGGER.info(
				"savePage",
				dojo.string.substitute(this.cwm.I_TOOLBOX_PAGE_SAVED_1,[com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle()])
			);
			this.saveIconChange(false);
		}
	},
	
	publishHWCPosition:function(){
        var coords = dojo.coords(this.nvaImgPosition);
    	this.iContext.iEvents.publishEvent("HWCPositionPublished", coords);
	}
});
