/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.TextBox");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");

dojo.declare("com.ibm.mm.builder.pagePropertyEditor", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {
	
    pageId: "",
    
    pageTitle: "",
    
	pageDesc:"",
	
    pageTheme: "",
	
    pageWidthChanger: null,
    
    autoWiringEnabled: false,
    
	userModel:null,
	
	displayTab:null,
	
	isEditCurrentPage: true,
	
    onLoad: function(){
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
        this.pageWidthChanger = com.ibm.mm.builder.utils.pageWidthChanger;
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.pagePropertyEditor");
	},
	
	onView: function(){
		this.inherited(arguments);

	    this.pagePropertyAdvanceIcon.src = builderConfig.builderPath + "/images/next.gif";	
	    this.pagePropertyAdvanceSection.style.display = "none";
		dojo.style(this.accountSettingsContent, "display", "none");
		dojo.style(this.pagePropertiesContent, "display", "");
	},
	    
	onDisplayPageProperty: function(iEvent){
		if(iEvent.payload && iEvent.payload.pageId){
			this.pageId = iEvent.payload.pageId;
			this.editPageInSpaceManager = iEvent.payload.editPageInSpaceManager;
		}else{
			this.pageId = iEvent.payload;
			this.editPageInSpaceManager = false;
		}
		
		this.isEditCurrentPage = (this.pageId === com.ibm.mm.builder.utils.pageUtil.getCurrentPageId());
		
		if (this.isEditCurrentPage) 
			this.currentPageModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		else {
			this.originPageWidthProvider = this.pageWidthChanger._pwmp;
			this.originPageWidthChangeListener = this.pageWidthChanger._pwmcListener;
			
			this.pageWidthChanger._pwmp = {
				getPageWidthMode: dojo.hitch(this, function(){
					return {
						"mode": this.enablerUtil.getPageMetaData("pageWidthMode", this.pageId) || "fixed",
						"width": this.enablerUtil.getPageMetaData("pageWidth", this.pageId) || 1070
					};
				})
			};
			this.pageWidthChanger._pwmcListener = dojo.hitch(this, function(payload) {
				var newPwm = payload.summary["new"];
				this.enablerUtil.setPageMetaData("pageWidthMode", newPwm.mode, this.pageId);
				this.enablerUtil.setPageMetaData("pageWidth", newPwm.width, this.pageId);
			})
		}
		
		// if page id is specified, only show the page properties tab
        if (this.pageId) {	// show page settings
			dojo.style(this.accountSettingsContent, "display", "none");
			dojo.style(this.pagePropertiesContent, "display", "");
			this.displayTab = "pageProperty";
            this.initPagePropertyDiv();
            this.initThemeSelection();
        } else {			// show account settings
			dojo.style(this.pagePropertiesContent, "display", "none");
			dojo.style(this.accountSettingsContent, "display", "");
			this.displayTab = "accountSettings";
			this.initAccountSetting();
        }
    },
	
	onPageOwnerChanged: function(iEvent){
		//iEvent.payload: userID
		this._displayCurrentOwner();
		this._hideChangeOwner();
	},
	
	initAccountSetting:function(){
    	//The reason why put code here instead of onView is: postpone the request until user display the properties UI
		if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {  //lookaside is enabled
		    this.userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
			var user = com.ibm.mm.builder.utils.userUtil.getCurrentUser();
			var v1 = user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS");
			var v2 = user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS");
			
			this.displaySuccessNotification = eval(v1);
	       	this.displayDisabledNotification = eval(v2);
			
	       	this.displayNotiCheck.checked = this.displaySuccessNotification;
			this.notifyMeCheck.checked =  this.displayDisabledNotification;
		} else {
			//disable the checkbox and radio button so user can not change this.
			this.displayNotiCheck.checked = false;
			this.notifyMeCheck.checked = false;
			this.loginHomeSpaceRadio.checked =  false;
			this.loginLastPageRadio.checked = true;
			this.displayNotiCheck.disabled = true;
			this.notifyMeCheck.disabled = true;
		}
		
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")) {
			var isLast = com.ibm.mm.builder.utils.navigationUtil.isLastPageWhenLogin();
			this.loginHomeSpaceRadio.checked = !isLast;
			this.loginLastPageRadio.checked = isLast;
		} else {
			dojo.style(this.accountSettingsLoginContent, "display", "none");
			this.loginHomeSpaceRadio.disabled =  true;
			this.loginLastPageRadio.disabled = true;
		}
	},
	
    /**
     * create the page property UI elements
     */
    initPagePropertyDiv: function(){
		this.pageTitle = com.ibm.mm.builder.utils.pageUtil.getUnescapedPageTitle(this.pageId);
		this.pageTitleInput.value = this.pageTitle;
		
		var pwm = this.pageWidthChanger.getPageWidthMode();
		var startValueFixed = (pwm.mode == "fixed") ? pwm.width : 1070;
		dojo.mixin(this.fixedSlider, {
		    value: startValueFixed,
		    pageIncrement: 20,
		    minimum: 800,
		    maximum: 2000
		});
		this.fixedInput.attr("value", startValueFixed);
		
		var startValueDynamic = (pwm.mode == "dynamic") ? pwm.width : 800;
		dojo.mixin(this.dynamicSlider, {
		    value: startValueDynamic,
		    pageIncrement: 20,
		    minimum: 800,
		    maximum: 960
		});
		this.dynamicInput.attr("value", startValueDynamic);
		
		var radios = dojo.doc.getElementsByName("PagePropertyDialog_pageWidthMode");
		if (pwm.mode == "fixed") 
		    radios[0].click();
		if (pwm.mode == "dynamic") 
		    radios[1].click();
		
		this._displayCurrentOwner();
		this._hideChangeOwner();
		
		this.pageDesc = com.ibm.mm.builder.utils.pageUtil.getPageDescription(this.pageId)
	    this.pagePropertyDescription.value = this.pageDesc;
		
		if(this.isEditCurrentPage){
			this.autoWiringEnabled = this.currentPageModel.getAutoWiringEnablement();
		}else{
			var _isEnabled = this.enablerUtil.getPageMetaData("com.ibm.mashups.builder.autoWiringEnabled", this.pageId);
			if(_isEnabled != null && (_isEnabled == "true" || _isEnabled == "false" || _isEnabled == true || _isEnabled == false)){
				this.autoWiringEnabled = eval(_isEnabled)
			}else{
				this.autoWiringEnabled = builderConfig.pageAutoWiringDefault;
			}
		}
		
		this.autoWiringEnabled ? this.autoWiringEnableRadio.click() : this.autoWiringDisableRadio.click();
		
		//Add ellipsis to the tab label texts if they are too long
		var i = 0;
        dojo.query(".tabLabel").forEach(function(tabNode){
            var str = tabNode["innerHTML"];
            var widthlimit = 100;
            if (!builderConfig.isBidi) 
                widthlimit = i === 0 ? 100 : 120;
            var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, tabNode, widthlimit);
            tabNode["innerHTML"] = shortStr;
            i++;
        });
    },
	
	_displayCurrentOwner: function(){
		var owner = com.ibm.mm.builder.utils.acModelUtil.getPageOwner(this.pageId);
		if (owner) {
			this.pagePropertyCurrentOwner.innerHTML = owner.getDisplayName();
			this.pageOwnerLabel.style.display = "inline";
			this.noPageOwnerLabel.style.display = "none";
		}else{
			this.pageOwnerLabel.style.display = "none";
			this.noPageOwnerLabel.style.display = "inline";
		}
	},
	
	_hideChangeOwner: function(){

		var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(this.pageId);
		if(space == null || !com.ibm.mm.builder.utils.acModelUtil.isOwner(this.pageId)){
			this.pagePropertyShowChangeOwner.style.display = "none";
		}else{
			this.pagePropertyShowChangeOwner.style.display = "inline";
		}
	},
    
    /**
     * hide the page property dialog
     */
    hide: function(){
		this._hideMessage();
		if (!this.isEditCurrentPage) {
			this.pageWidthChanger._pwmp = this.originPageWidthProvider;
			this.pageWidthChanger._pwmcListener = this.originPageWidthChangeListener;
		}
        this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
    },
    
    getChangedPageWidthMode: function(){
        var mode = null, width = 0;
        dojo.forEach(dojo.doc.getElementsByName("PagePropertyDialog_pageWidthMode"), function(radio){
            if (radio.checked) 
                mode = radio.value;
        });
        if (mode == "fixed") 
            width = parseInt(dojo.number.format(this.fixedSlider.value, { places: 0, pattern: '##.' }));
        if (mode == "dynamic")
			width = parseInt(dojo.number.format(this.dynamicSlider.value, { places: 0, pattern: '##.' }));
		
        return {
            "mode": mode,
            "width": width
        };
    },
	
	_getPageWidthFromInput : function() {
		var pwm = this.getChangedPageWidthMode();
		if (pwm.mode == "fixed") {
		   return {
		  	 width : parseInt(this.fixedInput.attr("value")),
			 min : this.fixedSlider.minimum,
			 max : this.fixedSlider.maximum
		   };
		}
		else if (pwm.mode == "dynamic") {
		   return {
		   	 width : parseInt(this.dynamicInput.attr("value")),
			 min : this.dynamicSlider.minimum,
			 max : this.dynamicSlider.maximum
		   };
		}
	},
    
    /**
     * init the theme selection
     */
    initThemeSelection: function(){
        this.themeSelection.innerHTML = "";
        var curThemeId = com.ibm.mm.builder.utils.themeUtil.getThemeId(this.pageId);
        var themeModel = com.ibm.mm.builder.utils.themeUtil.getThemeModel();
        var index = 0;
        var selectedIndex = 0;
		    var iterator = themeModel.iterator();        
        while (iterator.hasNext()) {
			var theme = iterator.next();
			var themeId = theme.getID();
			var themeTitle = com.ibm.mm.builder.utils.themeUtil.getThemeTitle(theme, builderConfig.locale);
			
			this.themeSelection.options.add(new Option(themeTitle, themeId));
			this.themeSelection.options[this.themeSelection.options.length - 1].title = themeTitle;
			
			if (themeId == curThemeId) {
				selectedIndex = iterator.getCursorPosition() - 1;
				this.pageTheme = theme.getID();
			}
		}
        this.themeSelection.options[selectedIndex].selected = true;
    },
    
    /**
     * save page property action method
     */
    save: function(){
		if (this.displayTab == "pageProperty") {
			var newPageName = dojo.trim(this.pageTitleInput.value);
			var newPageDesc = dojo.trim(this.pagePropertyDescription.value);
			var newTheme = this.themeSelection.value;
			
			if (this._savePageProperty(newPageName, newPageDesc, newTheme)) {
				var constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
				dojo.publish(constants.Topic.Space.refresh,[constants.Action.EDIT_PAGE, {pageId: this.pageId}]);
				this.hide();
			}
		}else if (this.displayTab == "accountSettings"){
			this._saveAccountSettings()
			this.hide();
		}
	},
    
    _restorePageWidthModeMetadata: function(newTheme, pageWidthMode){
		var metadata = null;
        if (newTheme == "defaultTheme" || newTheme == "tabTheme")
            metadata = { 
                "pageWidthMode": pageWidthMode.mode,
                "pageWidth": pageWidthMode.width,
				"com.ibm.mashups.builder.autoWiringEnabled": this.autoWiringEnabled
            };
        if (newTheme == "defaultThemeColumned" || newTheme == "tabThemeColumned") 
            metadata = {
                "pageattributes_pageWidthMode": pageWidthMode.mode,
                "pageattributes_pageWidth": pageWidthMode.width,
				"com.ibm.mashups.builder.autoWiringEnabled": this.autoWiringEnabled.toString()
            };
		this.enablerUtil.setPageJSONMetaData(metadata, this.pageId);
    },
    
	_saveAccountSettings:function(){
		if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled()) {
			var user = this.userModel.findCurrentUser().start();
			var changed = false;
			if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {
				if (this.displaySuccessNotification.toString() != user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {
					user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS", this.displaySuccessNotification.toString());
					changed = true;
				}
			}
			if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
				if (this.displayDisabledNotification.toString() != user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
					user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS", this.displayDisabledNotification.toString());
					changed = true;
				}
			}
			if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")) {
				if (this.onLoginValue && this.onLoginValue != user.getAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")) {
					user.setAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN", this.onLoginValue);
					changed = true;
				}
			}
			if (changed) {
				try {
					this.userModel.commit().start();
				} 
				catch (e) {
					this.LOGGER.severe("_saveAccountSettings",
						dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_ACCOUNT_SETTING_SAVE_FAIL,[e.message])
					)
				}
			}
		}
	},
	
    _savePageProperty: function(newPageName, newPageDesc, newTheme){
        if (!com.ibm.mm.builder.utils.pageUtil.validatePageName(newPageName)) {
			return false;
		}
			
		var widthObj = this._getPageWidthFromInput();
		var width = widthObj.width,
		    min = widthObj.min,
			max = widthObj.max;
		if (isNaN(width)) {
			this._showMessage(this.cws.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE);
			return false;
		}	
		if (width < min || width > max) {
			this._showMessage(dojo.string.substitute(this.cws.E_PAGE_PROPERTIES_WRONG_PAGE_WIDTH, [min, max]));
			return false;
		}
		
		//auto-wiring setting changed,write back the page metadata
		if (this.autoWiringEnabled != this.autoWiringEnableRadio.checked) {
			this.autoWiringEnabled = this.autoWiringEnableRadio.checked;
            if(this.isEditCurrentPage)
				this.currentPageModel.setAutoWiringEnablement(this.autoWiringEnabled);
			this.enablerUtil.setPageMetaData(com.ibm.mm.builder.constant.autoWiringEnabled, this.autoWiringEnabled.toString(), this.pageId);
		}
		
        var pwm = this.getChangedPageWidthMode();
        var pageNameChanged = (newPageName != this.pageTitle);
		var pageDescChanged = (newPageDesc != this.pageDesc);
        if (!pageNameChanged && !pageDescChanged && newTheme == this.pageTheme) {
            this.pageWidthChanger.setPageWidthMode(pwm);
            return true;
        }
        
        var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
        var page = navigationModel.find(this.pageId).start();
		page.setTitle(newPageName, dojo.locale);
		page.setDescription(newPageDesc, dojo.locale);
        this.pageTitle = newPageName;
        if (this.pageTheme != newTheme) {
            themeChanged = true;
            page.setTheme(newTheme);
            this.pageTheme = newTheme;
            
            this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
            var layoutModel =  navigationModel.getLayoutModel(this.pageId);
			if (!layoutModel) {
				this.LOGGER.severe("_savePageProperty", com.ibm.mm.builder.coreWidgetsMessages.E_EDITPAGE_SAVE_ERROR_0);
				return false;
			}
            var lmRoot = layoutModel.getRoot().start();
            var metadataNames = lmRoot.getMetaDataNames();
            this.enablerUtil.removePageMetaData(metadataNames, this.pageId);
            this._restorePageWidthModeMetadata(newTheme, pwm);
			
			if (this.editPageInSpaceManager) {
				this.eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.pageThemeChanged", {
					pageId: this.pageId,
					pageTitle: this.pageTitle,
					pageDesc: newPageDesc
				});
			} else {
				setTimeout(function(){window.location.reload();}, 1000);
			}
        } else {
            this.pageWidthChanger.setPageWidthMode(pwm);
            if (pageDescChanged || pageNameChanged) {
				if(this.isEditCurrentPage && pageNameChanged){
					this.eventService.broadcastEvent("com.ibm.mashups.builder.updatePageTitle", this.pageTitle);
				}
                if(pageNameChanged){
					this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
				}
				
				navigationModel.commit().start();
            }
        }
        return true;
    },
	
	_showMessage : function(message, type) {
		if(!this.messageControl) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			var wid = "_"+ this.iContext.widgetId + "_";
			var node = dojo.byId(wid+"messageBox");
		   	this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: 'error'}, node);
		}
		this.messageControl.attr(
			{
			"message" : message,
			"messageType" : type || "error"
			}
		);
		this.messageControl.show();
	},
	
	_hideMessage : function() {
		if (this.messageControl) {
			this.messageControl.hide();
		}
	},
    
    toggleSlider: function(type, enabled){
        dojo.toggleClass(this[type + "Hint"], "pageProperty_disabled_text", !enabled);
        dojo.toggleClass(this[type + "Hint"], "pageProperty_indented_text", enabled);
        this[type + "Slider"].attr("disabled", !enabled);
        this[type + "Input"].attr("disabled", !enabled);
    },
	
	syncInputValueWithSlider : function(mode) {
		var self = this;
		function transform(value) {
			return dojo.number.format(value, {places: 0, pattern: '##.'});
		}
		
		function fixValue(value) {
			if (value < 800 || value > 2000) {
				var pwm = self.pageWidthChanger.getPageWidthMode();
				value = pwm.width;
			}
			return value;
		}

		if (mode == "fixed") {
			this.fixedInput.attr("value", transform(fixValue(this.fixedSlider.attr("value"))));
		}
		else if (mode == "dynamic") {
			this.dynamicInput.attr("value", transform(fixValue(this.dynamicSlider.attr("value"))));
		}
	},
    
    onPageWidthModeSelected: function(event){
        var isFixedMode = event.target.value == "fixed"
        this.toggleSlider("fixed", isFixedMode);
        this.toggleSlider("dynamic", !isFixedMode);
		this.syncInputValueWithSlider(isFixedMode ? "dynamic" : "fixed");
		this._hideMessage();
    },
    
    onFixedSliderChange: function(newValue){
		this._hideMessage();
        var transformed = dojo.number.format(newValue, {
            places: 0,
            pattern: '##.'
        });
        this.fixedInput.attr("value", transformed);
    },
    
    onFixedInputChange: function(newValue){
        if (newValue < this.fixedSlider.minimum || newValue > this.fixedSlider.maximum) 
            return;
        this.fixedSlider.attr("value", newValue);
    },
    
    onDynamicSliderChange: function(newValue){
		this._hideMessage();
        var transformed = dojo.number.format(newValue, {
            places: 0,
            pattern: '##.'
        });
        this.dynamicInput.attr("value", transformed);
    },
    
    onDynamicInputChange: function(newValue){
        if (newValue < this.dynamicSlider.minimum || newValue > this.dynamicSlider.maximum) 
            return;
        this.dynamicSlider.attr("value", newValue);
    },
	
    onClickAdvance:function(){
    	var sectionBody = this.pagePropertyAdvanceSection;
        if (dojo.style(sectionBody, "display") === "none") {
            dojo.attr(this.pagePropertyAdvanceIcon, "src", builderConfig.builderPath + "/images/nextdown.gif");
            dojo.fx.wipeIn({
				node: sectionBody,
				duration: 500,
				onEnd: function(){
					if (dojo.isIE) {
						dojo.removeClass("pageProperty_section_advance", sectionBody);
						dojo.addClass("pageProperty_section_advance", sectionBody); //hack code to solve the dojo wipe out issue}
					}
				}
			}).play();
        } else {
			dojo.attr(this.pagePropertyAdvanceIcon, "src", builderConfig.builderPath + "/images/next.gif");
            dojo.fx.wipeOut({
                node: sectionBody,
                duration: 500,
				onEnd: dojo.hitch(this, function(){

				})
            }).play();
        }
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesWord(this.pagePropertyAdvanceSection);
    },
    
    onDisplayNotiClicked:function(event){
    	this.displaySuccessNotification = event.target.checked;
    },
    
    onNotifyMeClicked:function(event){
    	this.displayDisabledNotification = event.target.checked;
    },
	
    onLogin:function(event){
    	this.onLoginValue = event.target.value;
    },
	
	showChangeOwner:function(){
		var payload = {
	    	widgetTypeId: "changeOwner",
	        eventName:  "com.ibm.mashups.builder.changeOwner",
	        eventPayload:  this.pageId,
	        dialogParam:  {
				title: this.cws.I_CHANGE_PAGE_OWNER,
				nodeWidth: "400px",
				hasRightBottomResizer: false }
		};
		this.eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
	} 
 
});
