/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("dijit.form.Button");
dojo.require("com.ibm.mm.builder.iwidget.pagesource.CodeEditor");
dojo.require("com.ibm.mm.builder.iwidget.pagesource.PageSource");

dojo.declare("com.ibm.mm.builder.systemwidget.pageSource", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {	
    
    onLoad: function(){
		this.pageSource = new com.ibm.mm.builder.iwidget.pagesource.PageSource({ layoutIds: this.layoutIds });
    },
    
	/**
     * Handle function for event 'onPageSave'
     * @param {Object} iEvent
     */
    onPageSave: function(iEvent){
        this.pageSource.saveToPage();
    },
    
    loadPageSource: function(iEvent){
		if (!this.contentFrame.src) {
			this.contentFrame.src = builderConfig.builderPath + "/js/com/ibm/mm/builder/iwidget/pagesource/htmleditor.html";
			if (dojo.isIE) {
				this.contentFrame.attachEvent("onload", dojo.hitch(this, this._loadPageSource));
			} else{
				dojo.connect(this.contentFrame, "onload", this, "_loadPageSource");
			}
		} else {
			this.pageSource.getSource()
		} 
    },
	
	_loadPageSource: function(){
		if (!this.pageSource.codeEditor) {
			var iframeDoc = dojo.isIE < 8 ? this.contentFrame.contentWindow.document : this.contentFrame.contentDocument;
			this.pageSource.codeEditor = new com.ibm.mm.builder.iwidget.pagesource.CodeEditor(iframeDoc.body);
        } 
		this.pageSource.getSource();
	},
	
	_hideWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.hide();
		}
	},
	
	hide: function(){
		this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},
	
	initPageSource: function() {
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		if(cs.getValue(cs.CLIENT_PAGE_SOURCE_READ_ONLY)){
			return;
		}
		else{
			this.sourceButtons.innerHTML = "";
			var span1 = document.createElement("span");
			sourceButtons.appendChild(span1);
			var btnSourceSave = new dijit.form.Button({label:com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE},span1);
			btnSourceSave.domNode.onclick = dojo.hitch(this, function(){
				this.pageSource.saveSource('source')
			})
			var span2 = document.createElement("span");
			sourceButtons.appendChild(span2);
			var btnEditmode = new dijit.form.Button({label:com.ibm.mm.builder.coreWidgetsStrings.I_PAGE_SOURCE_EDIT_MODE},span2);
			btnEditmode.domNode.onclick = dojo.hitch(this, this.pageSource.editMode);
			
			
			var editButtons = dojo.byId("editButtons");
			var span3 = document.createElement("span");
			editButtons.appendChild(span3);
			var btnEditSave = new dijit.form.Button({label:com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE},span3);
			btnEditSave.domNode.onclick = dojo.hitch(this, function(){
				this.pageSouce.saveSource('edit')
			})
			var span4 = document.createElement("span");
			editButtons.appendChild(span4);
			var btnSourcemode = new dijit.form.Button({label:com.ibm.mm.builder.coreWidgetsStrings.I_PAGE_SOURCE_SOURCE_MODE},span4);
			btnSourcemode.domNode.onclick = dojo.hitch(this, this.pageSource.sourceMode);
		}
	}
});




