/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.declare("com.ibm.mm.builder.pageTitle",null,{	
	
	/**
	 * onEvent callback for iEvent "onPageSwitched"
	 * @param {Object} iEvent
	 */
	onPageSwitched:function(iEvent){
		var title = iEvent.payload ? com.ibm.mm.builder.utils.pageUtil.getPageTitle(iEvent.payload): " ";
		if(dojo.isString(title)){
			this._displayTitle(title);
		}
	},

	/**
	 * onEvent callback for iEvent "onPageTitleUpdated"
	 * @param {Object} iEvent
	 */
	onPageTitleUpdated:function(iEvent){
		var pageTitle=iEvent.payload;
		if(dojo.isString(pageTitle)){
			this._displayTitle(pageTitle);
		}		
	},
	
	/**
	 * Private(Protected) method to change page title in DOM
	 * @param {String} pageTitle
	 */
	_displayTitle:function(pageTitle){
		var titleDiv = this.iContext.getElementByClass("bannerTitle")[0];
		com.ibm.mm.builder.utils.htmlUtil.setNodeTitle(pageTitle, titleDiv, 500);
	}
});
