/* Copyright IBM Corp. 2009  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");
dojo.requireLocalization("com.ibm.bundles", "Theme");

dojo.declare("com.ibm.mm.builder.portalCommonActions",null,{

	onLoad: function(){
		this.cws = com.ibm.mm.builder.coreWidgetsStrings;
		this.cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var selfcare = dojo.byId("common_action_selfcare");
		var userName = dojo.byId("common_action_user_name");
		var help = dojo.byId("common_action_help");
		var settings = dojo.byId("common_action_settings");
		var actionLink = dojo.byId("common_action_link");
		
		var anonymousUser = this.cs.getValue("anonymousUser");
		var securityOff = this.cs.getValue("securityOff");
		if (!anonymousUser || securityOff){
			userName.innerHTML = com.ibm.mashups.enabler.model.Factory.getUserModel().findCurrentUser().start().getDisplayName();

			if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled()) {
				settings.innerHTML = this.cws.I_COMMON_ACTION_SETTINGS;
			}else{
				settings.parentNode.style.display = "none";
			}	
			
			selfcare.innerHTML = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["theme_edit_my_profile"];
			selfcare.href = ibmConfig["com.ibm.mashups.url.selfcare"];
			dojo.connect( selfcare, "onclick", this, "editProfileAction" );
			dojo.connect( selfcare, "onkeypress", this, "_editProfileActionWithKey" );

			help.innerHTML = this.cws.I_COMMON_ACTION_HELP;
			help.href = ibmConfig["com.ibm.mashups.url.help"]+"/help/index.html";
			
			actionLink.innerHTML = this.cws.I_COMMON_ACTION_LOGOUT;
	        actionLink.href = this.cs.getValue(this.cs.LOGOUT_URL);
		}else{
			help.parentNode.style.display = "none";
			settings.parentNode.style.display = "none";
			userName.parentNode.style.display = "none";
			
			selfcare.innerHTML = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["theme_sign_up"];
			dojo.addClass(selfcare.parentNode, "lotusFirst");
			selfcare.href = ibmConfig["com.ibm.mashups.url.signup"];
			dojo.connect( selfcare, "onclick", this, "editProfileAction" );
			dojo.connect( selfcare, "onkeypress", this, "_editProfileActionWithKey" );
			
			actionLink.href = ibmConfig["com.ibm.mashups.url.login"];
			actionLink.innerHTML = this.cws.I_COMMON_ACTION_LOGIN;
		}
		
		if (builderConfig.isBidi) {//fix Hebrew (iw), Arabic (ar) does not need this
			userName.dir = "rtl";
			help.dir = "rtl";
			selfcare.dir = "rtl";
			settings.dir = "rtl";
			actionLink.dir = "rtl";			
		}			

	},

	logoutAction: function(evt){
		//remove the cookie WASReqURL by setting it expired
		var d=new Date();
        d.setTime(d.getTime()-10000);
        window.document.cookie= "WASReqURL=/mm/enabler; expires="+ d.toGMTString() +";";

		var changed = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty();
		if(changed){
			//if in edit mode and page is changed
			dojo.stopEvent(evt);
			new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
				contentWarning: this.cws.I_PAGE_SAVE_WARNING,
				contentQuestion: this.cws.I_PAGE_SAVE_SUGGEST,
				btnSaveText: this.cws.I_COMMON_SAVE,
				btnNotSaveText: this.cws.I_PAGE_SAVE_NO_SAVE,
				btnCancelText: this.cws.I_PAGE_SAVE_KEEP_EDIT,
				charLimit: 50,
				callbackSave: function(){
					location.href = ibmConfig.portalLogoutUrl;
				},
				callbackNotSave: function(){
					location.href = ibmConfig.portalLogoutUrl;
				}
			}).show();
		}
	},
	editProfileAction: function(evt) {
		var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
		var af = com.ibm.mashups.enabler.model.state.AccessorFactory;
		var spaceAccessor = af.getSpaceAccessor( navStateModel );
		var pageAccessor = af.getPageAccessor( navStateModel, spaceAccessor.getSpaceID() );
		
		var form = dojo.byId( "common_action_selfcare_form" );
		form.OCN.value = pageAccessor.getPageID();
		form.action = dojo.byId("common_action_selfcare").href;
		form.submit();
		
		evt.stopPropagation();
		evt.preventDefault();
	},
	_editProfileActionWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.editProfileAction(e);
		}		
	},
	_settingsActionWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.settingsAction(e);
		}		
	},
	settingsAction: function(evt){
		com.ibm.mm.builder.commonActions.accountSettings();
	},
	onUnLoad: function(){
	}
});
