/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.widget.ShadowMenu");

dojo.declare("com.ibm.mm.builder.systemwidget.shareActionsMenu", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {

	menu:null,
	
	onView: function(){
		this.inherited(arguments);
		if (com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()){
			//we need a style for disabled button
			this.shareActionsButton.disabled = true;
			dojo.addClass(this.shareActionsButton,"lotusBtnDisabled");
		}
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
				this.renderMenu(evt);
			break;
		}
	},
	
	_onClick: function(evt){
		this.renderMenu(evt);
	},
	
	renderMenu: function(evt){
		!this.menu && this.createMenu();
		this.menu._openMyself(evt);
	},
	
	createMenu: function() {
		this.menu = new com.ibm.mm.builder.widget.ShadowMenu({
			targetNodeIds: [this.shareActionsButton],
			offset_y: 9
		});
		
		dojo.addClass(this.menu.domNode,"shareActionMenu");
		
		var contextMenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var shareActionsMenus = contextMenu.getContextMenu("ContextMenu.shareActions", currentPageId, 
			null, { context:this });
		
		for (var i = 0; i < shareActionsMenus.length; ++i) {
			var mitem = new dijit.MenuItem({
				label: shareActionsMenus[i].title,
				iconClass: shareActionsMenus[i].iconClass,
				disabled:shareActionsMenus[i].enabled == "disabled",
				onClick: shareActionsMenus[i].actionCallBackFunction
			});
			mitem.pageActionType = shareActionsMenus[i].id;
			this.menu.addChild(mitem);
		}
		this.menu.startup();
	},
	
	onPageSwitched: function(iEvent){
		this.menu && this.menu.destroyRecursive();
		this.createMenu();
	}
});
