dojo.registerModulePath("com.ibm","/mum/js/com/ibm");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Theme");

dojo.declare("com.ibm.mm.builder.systemwidget.sharePageControl", null, {
	onLoad: function(){
		this.sharePageButton = dojo.byId("sharePageControlButton");
		var sharePageButtonText = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["theme_share_page"];
		this.sharePageButton.innerHTML = sharePageButtonText;
		this.sharePageButton.title = sharePageButtonText;
		this.events = [dojo.connect(this.sharePageButton,"onclick",this,"onClick"),dojo.connect(this.sharePageButton,"onkeypress",this,"onKeyPress")];
	},
	
	onKeyPress: function(evt){
		if(evt && evt.type === "keypress" && evt.keyCode == dojo.keys.ENTER){
			this.onClick();
		}
	},
	
	onClick: function(){
		var es = com.ibm.mashups.iwidget.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
		var pageID = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var pageName = com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageID);
		if(!pageName || (pageName == null)){
			pageName = "";
		}
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_DIALOG_TITLE, [pageName]);
		
		var payload = {
		    	widgetTypeId: "sharePage",
		        eventName:  "com.ibm.mashups.builder.sharePage",
		        eventPayload: pageID,
		        dialogParam:  {
					title: title,
					leftBarWidth: "0px",
					rightBarWidth: "0px",
					hasRightBottomResizer: false
				}
			};
		es.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
	},
		
	onUnLoad: function(){
	}
});