/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
  */
 
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.catalog.hubUtil");
dojo.require("com.ibm.mashups.enabler.model");

dojo.declare("com.ibm.mm.builder.spaceChangeOwnerWidget", null, {	
	
	eventService: com.ibm.mashups.services.ServiceManager.getService("eventService"),
	
	WID: null,
	
	resourceBundle:null,
	
	searchInputId:null,
	
	userModel:null,
	
	preOwnerId:null,
	
	searchUsers:null,
	
	userSearchResultId:null,
		
	resourceMessage : null,
		
	userid:null,
	
	username:null,

	spaceId:null,
	
	space_acModel:null,
			
	constructor:function(){
		this.searchUsers = new Array();
		
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.spaceChangeOwner");
	},
	
	onLoad: function(){
		this.resourceBundle = com.ibm.mm.builder.coreWidgetsStrings;	
		this.resourceMessage = com.ibm.mm.builder.coreWidgetsMessages;
		this.messageControl = {};
		this.widgetId = this.iContext.widgetId;
		this.WID = "_"+ this.widgetId + "_";

		this.searchInputId = (this.WID+"input");
		var searchInput = dojo.byId(this.searchInputId);
		
		dojo.byId(this.WID + "userSearchResultLabel").innerHTML = this.resourceBundle.I_CHANGE_PAGE_OWNER_SEARCH_RESULTS;
		dojo.query(".searchIndicatorText",this.iContext.getRootElement())[0].innerHTML = com.ibm.mm.builder.coreWidgetsMessages.I_SEARCH_INDICATE || "Searching...";
		
		this._connections = [];	
		this._connections.push(dojo.connect(searchInput,"onkeypress",this, "_searchOwnerByKey"));
		
	},
	_searchOwnerByKey: function(evt){
		if (evt.keyCode != dojo.keys.ENTER)
			return;	  
		 this.changeOwner_searchUser();
	},
	
	_showMessage : function(message, type, nodeId) {
		if(!this.messageControl[nodeId]) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			var wid = "_"+ this.iContext.widgetId + "_";
			var node = dojo.byId(wid+nodeId);
		   	this.messageControl[nodeId] = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: type}, node);
		}
		this.messageControl[nodeId].attr(
			{
			"message" : message,
			"messageType" : type || "error"
			}
		);
		this.messageControl[nodeId].show();
	},
	
	_hideMessage : function() {
		for(var msg in this.messageControl){
			if (this.messageControl[msg] && this.messageControl[msg].hide) {
				this.messageControl[msg].hide();
			}
		}
	},
	
	
	_verifyInput: function(ownerId){
		if(!ownerId || dojo.trim(ownerId) ==""){	
			this._showMessage(this.resourceMessage.E_SPACE_MANAGER_SPACE_OWNER_IS_REQUIRED_0, "error", "messageBox")
			return false;
		}
		return true;
	},
	
	
	hide: function(){
		this._hideMessage();
		this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},
	
	onview: function(){		
		dojo.parser.parse(this.iContext.getRootElement());
		dojo.byId(this.WID+"input").value = this.resourceBundle.I_SEARCH_USER;
		dojo.byId(this.WID+"input").title = this.resourceBundle.I_SEARCH_USER;
		dojo.byId(this.WID+"SearchButton").value = this.resourceBundle.I_SEARCH_TITLE;
		dojo.byId(this.WID+"SearchButton").title = this.resourceBundle.I_SEARCH_TITLE;
		dojo.attr(dojo.byId(this.WID+"SearchButton"),'aria-label',this.resourceBundle.I_SEARCH_TITLE);
		this.userSearchResultId = (this.WID+"userSearchResult");	
		dojo.attr(this.userSearchResultId, "title",this.resourceBundle.I_CHANGE_PAGE_OWNER_SEARCH_RESULTS);
		dojo.byId(this.WID+"ownername_label").innerHTML = this.resourceBundle.CHANGE_SPACE_OWNERNAME;
		
		dojo.byId(this.WID+"change_type").innerHTML=this.resourceBundle.I_CHANGE_PAGE_OWNER_OWNERSHIP_TYPE;
		dojo.byId(this.WID+"co1Label").innerHTML=this.resourceBundle.I_CHANGE_SPACE_OWNER_EDIT;
		dojo.byId(this.WID+"co2Label").innerHTML=this.resourceBundle.I_CHANGE_SPACE_OWNER_VIEW;
		dojo.byId(this.WID+"co3Label").innerHTML=this.resourceBundle.I_CHANGE_SPACE_OWNER_NONE;
		dojo.byId(this.WID+"change_note").innerHTML=this.resourceBundle.I_CHANGE_SPACE_OWNER_NOTE;
		dojo.byId(this.WID+"co3Radio").checked=true;
			
	},
	
	
	save: function(){	
		
		var searchResultSelect = dojo.byId(this.userSearchResultId);		
		
		for (var i = 0; i < searchResultSelect.length; i++) {
			if(searchResultSelect[i].selected){
				this.userid = searchResultSelect[i].value;
				this.username = searchResultSelect[i].innerHTML;
			}
		}
		
		if(!this._verifyInput(this.userid))
			return;
	   	var radioOwnershipOpt = document.getElementsByName("ownershipOpt");
        for (var i = 0; i < radioOwnershipOpt.length; i++) {
            if (radioOwnershipOpt[i].checked === true) {
                permOpt = radioOwnershipOpt[i].value;
            }
        }
		dojo.publish("com.ibm.mm.builder.spaceEditorWidget.OwnerName", [this.username]);
		dojo.publish("com.ibm.mm.builder.spaceEditorWidget.OwnerId", [this.userid]);
		var permOpt = "";
		var roleType="";
		var radioOwnershipOpt = document.getElementsByName("ownershipOpt");
        for (var i = 0; i < radioOwnershipOpt.length; i++) {
            if (radioOwnershipOpt[i].checked === true) {
                permOpt = radioOwnershipOpt[i].value;
            }
        }
		if (permOpt === "edit") {
			roleType = com.ibm.mashups.enabler.ac.RoleType.EDITOR;
		}else if (permOpt === "view") {
			roleType = com.ibm.mashups.enabler.ac.RoleType.USER;			
		}
		else if (permOpt === "none"){
		    roleType="none";
		}
	    if(roleType !== "none"){
			dojo.publish("com.ibm.mm.builder.spaceEditorWidget.Permission",[roleType]);
		}
		this._hideMessage();	
		this.hide();
	},
	
	onChangeSpaceOwner: function(iEvent){
		this.preOwnerId = iEvent.payload;	
		this.cleanUI();
	},
	
	cleanUI: function(){
		
		var searchInput = dojo.byId(this.searchInputId); 
		if(dojo.hasClass(searchInput,"SearchInput")){
        		dojo.removeClass(searchInput,"SearchInput");
        	}
		dojo.addClass(searchInput, "initSearchInput");     
		searchInput.value = this._getSearchHint();     
		var searchResultSelect = dojo.byId(this.userSearchResultId);
		this._clearOptions(searchResultSelect);
		this.userid = null;
		this.username = null;
		this._hideMessage();
	},
	
	_changeOwner_searchUserWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.changeOwner_searchUser(e);
		}
	},
	
	changeOwner_searchUser:function(){
		var searchInput = dojo.byId(this.searchInputId);
		var searchItems;
		var searchingIndi = dojo.query(".searchIndicatorContainer",this.iContext.getRootElement())[0];
		this._showMessage(com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_NO_RESULT_TEXT_USER || "No user found, try another search item","info","messageBoxSearch");
		this._hideMessage();
		if (searchInput != null && searchInput.value != "") {
			searchingIndi.style.display = "block";
			if (dojo.hasClass(searchInput, "initSearchInput")) {
				searchItems = this.searchOutUsers("*");
			}else{
				searchItems = this.searchOutUsers(searchInput.value);
			}
			searchingIndi.style.display = "none";
			var searchResultSelect = dojo.byId(this.userSearchResultId);
			if(searchItems.length == 0) {
				this._clearOptions(searchResultSelect);
				this._showMessage(com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_NO_RESULT_TEXT_USER || "No user found, try another search item","info","messageBoxSearch");
			}else {
				this._populateOptionList(searchItems, searchResultSelect);			
				for (var x = 0; x < searchResultSelect.length; x++) {
					dojo.addClass(searchResultSelect[x], "changeOwner_searchResultOptions");
				}
			}
		}
	},
	
	searchOutUsers:function(keyword){
		if (this.userModel==null){
			this.userModel = com.ibm.mashups.enabler.model.Factory.getUserModel();
		}

		var searchResult =new Array();
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var wildcardDisabled = cs.getValue(cs.AUTO_WILDCARD_DISABLED);
		
		if (keyword!=""){
			if (keyword != "*") {
				keyword = keyword.replace(/(^\**)|(\**$)/g, "");
				if ((wildcardDisabled != true) && (wildcardDisabled != "true")) {
					keyword = "*" + keyword + "*";
				}				
			}
			var usersFound = this.userModel.findUsersByAttribute(cs.getValue(cs.CLIENT_USER_ID_KEY),keyword).start();
			
			for (var i = 0; i < usersFound.length; i++) {
				this.searchUsers.push(usersFound[i]);
				searchResult.push(usersFound[i]);
			}
		}
		if(searchResult.length == 0){
			dojo.attr(this.userSearchResultId, "title",this.resourceBundle.I_CHANGE_SPACE_OWNER_SEARCH_RESULTS_EMPTY);
		}else{
			dojo.attr(this.userSearchResultId, "title",this.resourceBundle.I_CHANGE_PAGE_OWNER_SEARCH_RESULTS);
		}
		return searchResult;
	},
	
	
	_populateOptionList:function(searchItems,searchResultSelect){
		
		this._clearOptions(searchResultSelect);
		for (var i = 0; i < searchItems.length; i++) {
			if(this.preOwnerId !=  searchItems[i].getID())
				this._addToOptionList(searchResultSelect,searchItems[i].getID(), searchItems[i].getDisplayName());				
		}
	},
	
	_addToOptionList:function (OptionList, OptionValue, OptionText) {
		OptionList[OptionList.length] = new Option(OptionText, OptionValue);
			
	},
	
	_clearOptions:function(optionList) {
		for (i = optionList.length; i >= 0; i = i - 1) {
			optionList[i] = null;
		}
	},
	
	onfocusInput:function() {
		var searchInput = dojo.byId(this.searchInputId); 
		if (dojo.hasClass(searchInput, "initSearchInput")) {
			dojo.removeClass(searchInput, "initSearchInput");
			dojo.addClass(searchInput, "SearchInput");
			searchInput.value = "";
		}
		
	},
	
	_getSearchHint: function(){
        //return "Search User";
		return com.ibm.mm.builder.coreWidgetsStrings.I_SEARCH_USER;
    },
	
	
	onblurInput:function() {
		
		var searchInput = dojo.byId(this.searchInputId); 
		var value = searchInput.value;
		
		
      	if (value=="") {
			if(dojo.hasClass(searchInput,"SearchInput")){
        		dojo.removeClass(searchInput,"SearchInput");
        	}
			dojo.addClass(searchInput, "initSearchInput");     
			searchInput.value = this._getSearchHint();      
		}		
	},
	
	onUnload: function() {
		dojo.forEach(this._connections, dojo.disconnect);
	},
	
	_clearOptions:function(optionList) {
		for (var i = optionList.length; i >= 0; i = i - 1) {
			optionList[i] = null;
		}
	}
});
