/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mm.builder.spaceEditorWidget");

dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl");

dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");

dojo.declare("com.ibm.mm.builder.spaceEditorWidget", null, {	

	WID: null,
	
	SPACE_CREATE_TYPE_EMPTY: "from_empty",
	
	SPACE_CREATE_TYPE_TEMPLATE: "from_template",
	
	resourceBundle:null,
	
	ownerName:null,
	
	ownerId:null,
	
	title:null,
	
	theme:null,
	
	icon:null,
	
	description:null,
	
	spaceModel:null,
	
	space:null,
	
	resourceMessage : null,
	
	user:null,
	
	acModel:null,
	
	eventService: com.ibm.mashups.services.ServiceManager.getService("eventService"),
	
	propChanged: {titleChanged:false, descChanged: false, ownerChanged: false, themeChanged: false, iconChanged: false},
	
	onLoad: function(){

		var widgetId = this.iContext.widgetId;
		this.WID = "_"+ widgetId + "_";

		this.resourceBundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.resourceMessage = com.ibm.mm.builder.coreWidgetsMessages;
		
        var themesNode = dojo.byId(this.WID + "themesContainer");
		
		this.themesListControl = new com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl({
			widgetId: widgetId
		}, themesNode);
		
		var iconsNode = dojo.byId(this.WID + "iconsContainer");
		
		this.iconsListControl = new com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl({
			widgetId: widgetId
		}, iconsNode);

				
        this.spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
		
		dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.OwnerName", dojo.hitch(this, this._setOwnerName));
		dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.OwnerId", dojo.hitch(this, this._changeOwnerId));
		dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.Permission",dojo.hitch(this,this._changePermission));	
			
		dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
		dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
		
	},

	_changePermission:function(roleType){
		var memberIdList = {};
		memberIdList[this.acModel.getOwner().getID()]= "user";
	    com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType(this.acModel, memberIdList, roleType);
		this.acModel.commit().start();
	},
			
	_onLoadChangeOwnerWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.onLoadChangeOwner(e);
		}		
	},
	
	onLoadChangeOwner: function(){

		var payload = {
			widgetTypeId: "changeSpaceOwnerWidget",
			eventName: "com.ibm.mashups.builder.spaceChangeOwner",
			eventPayload: this.ownerId,
			dialogParam: {
				title: this.resourceBundle.CHANGE_SPACE_OWNER_CAPTION,
				nodeWidth: "500px",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
		    	containerBackgroundColor: "white",
		    	hasRightBottomResizer: false
			}
		};
		this.eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
		
	},
	
	onView: function(){
		dojo.parser.parse(this.iContext.getRootElement());
		dojo.byId(this.WID+"space_information_label").innerHTML = this.resourceBundle.EDIT_SPACE_INFORMATION;
		dojo.byId(this.WID+"space_theme_label").innerHTML = this.resourceBundle.EDIT_SPACE_THEME;
		dojo.byId(this.WID+"space_icon_label").innerHTML = this.resourceBundle.EDIT_SPACE_ICON;
		dojo.byId(this.WID+"space_name_label").innerHTML = this.resourceBundle.CREATE_SPACE_NAME;
		dojo.byId(this.WID+"space_desc_label").innerHTML = this.resourceBundle.CREATE_SPACE_DESC;
		dojo.byId(this.WID+"space_owner").innerHTML = this.resourceBundle.EDIT_SPACE_OWNER;
		dojo.byId(this.WID+"choose_theme_label").innerHTML = this.resourceBundle.EDIT_SPACE_CHOOSE_THEME;
		dojo.byId(this.WID+"choose_icon_label").innerHTML = this.resourceBundle.EDIT_SPACE_CHOOSE_ICON;
		dojo.byId(this.WID+"change_text").innerHTML = this.resourceBundle.EDIT_SPACE_CHANGEOWNER;
		
	},
	
	onEditSpace: function(iEvent) {
		
		if(iEvent.payload && iEvent.payload.spaceId){
			this.spaceId = iEvent.payload.spaceId;
			this.editSpaceInSpaceManager = true;
		}else{
			this.spaceId = iEvent.payload;
			this.editSpaceInSpaceManager = false;
		}
		
		this.cleanUI();
		this.space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(this.spaceId);
		this.loadThemes();
		this.loadIcons();
		this.loadSpaceModel();		
		for(var p in this.propChanged){
			this.propChanged[p] = false;
		}
		
		if (!this._canChangeOwner()) {
            dojo.style(dojo.byId(this.WID+"change_text"), "display", "none");
        }else{
			dojo.style(dojo.byId(this.WID+"change_text"), "display", "");
		}
	},
	
	saveSpaceModel: function() {
		this.space.setTitle(this.title, dojo.locale);
		this.space.setDescription(this.description, dojo.locale);	
		com.ibm.mm.builder.utils.spaceUtil.setSpaceIconURL(this.space, this.iconUrlEncode(this.icon));
		
		 // user model, get current user
    	if (this.userModel == null){
			this.userModel = com.ibm.mashups.enabler.model.Factory.getUserModel();
		}

		//set theme begin
		var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;		
		var navigationModel = navigationUtil.getNavigationModel();
		var navRootNode = navigationModel.find(this.space.getRootNavigation()).start();		
		navRootNode.setTheme(this.theme);	
		navigationModel.commit().start();
		
		//owner		
		if (this.ownerId!= null && this.ownerId != ""){
			this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
		
			this.user = this.userModel.find(this.ownerId).start();
			this.acModel.setOwner(this.user);
			var deferredAc = this.acModel.commit();
			deferredAc.start();
		}

		//set theme end		
		var deferred = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel(true).commit().start();

		var spaceId = this.space.getID();
		com.ibm.mm.builder.utils.spaceUtil.getSpaceModel(true);
		
		if(this.propChanged.ownerChanged){
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space["delete"],[spaceId]);
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.CHANGE_OWNER, {spaceId:spaceId}]);
			if(!this.editSpaceInSpaceManager){				
				this.eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace", com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
			}
			else{
				var currentSpaceId = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
				this.eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.spaceOwnerChanged", {spaceId: spaceId, currentSpaceId: currentSpaceId});
			}
			
			return;
		}
		
		if(this.propChanged.themeChanged){
			
			if(this.propChanged.titleChanged){
				this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
			}

		}else if(this.propChanged.titleChanged){
			
			this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");				
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.EDIT_SPACE, {spaceId:spaceId}]);
			if(this.space.isFavorite()){				
				dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.addToFavorite, [this.space]);
				/** remove favorite quick access in 2.0, 14521 **/
				//dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refreshQuickAccess);
			}
			
		}else if(this.propChanged.descChanged || this.propChanged.iconChanged){
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.EDIT_SPACE, {spaceId:spaceId}]);
		}

	},
	
	loadSpaceModel: function() {
		if (!this.space) {
			return;
		}
        
		// find the selected node
		this.acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(this.space);
		
        if (this.space) {

			// titles				
		   this._setTitle(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(this.space)));
		   
			// description
           this._setDescription(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(this.space)));

		   // icon
		   var iconUrl = com.ibm.mm.builder.utils.spaceUtil.getSpaceIconURL(this.space);
		   if (iconUrl) {
				this._setSelectedIcon(this.iconUrlDecode(iconUrl));
		   }
		   
		   // owner
		   if (this.acModel.getOwner() != null && this.acModel.getOwner() != "") {
		   		
				this._setOwnerId(this.acModel.getOwner().getID());
				this._setOwnerName(this.acModel.getOwner().getDisplayName() || this.resourceBundle.I_SPACE_MANAGER_SPACE_INFO_NO_OWNER);
		   } else {
		   		dojo.byId(this.WID+"space_owner").innerHTML = this.resourceBundle.I_SPACE_MANAGER_SPACE_INFO_NO_OWNER;
		   }
		   
        } else {
            return;
        }

	},

	loadThemes: function(){
	
		var navRootNodeId = this.space.getRootNavigation().getID();;			
		var pageUtil = com.ibm.mm.builder.utils.pageUtil;
		var navRootNode = pageUtil.getPageNode(navRootNodeId);	
		
		var theme = navRootNode.getTheme();
		if(!theme) {			
			var themeUtil = com.ibm.mm.builder.utils.themeUtil;
			theme = themeUtil.getDefaultThemeId();
		}
		this.theme = theme;
		this.themesListControl.refresh(theme);
	},
	
	loadIcons: function(){
		this.iconsListControl.refresh();
	},
	
	cleanUI: function(){
		dojo.byId(this.WID+"SpaceName").value = "";
		dojo.byId(this.WID+"SpaceDesc").value = "";
	},
	
	_getTitle: function(){
		return dojo.byId(this.WID+"SpaceName").value;
	},
	
	_getDescription: function(){
		return dojo.byId(this.WID+"SpaceDesc").value;
	},	

	_getSpaceOwner: function(){
		return dojo.byId(this.WID+"space_owner_value").innerHTML;
	},
	
	_getSelectedTheme: function(){
		return this.themesListControl.selectedTheme;
	},
	
	_getSelectedIcon: function(){
		return this.iconsListControl.getSelectedIconId();
	},
	
	_getOwnerId : function(){
		return this.ownerId;
	},
	
	iconUrlDecode: function(iconUrl){
		var indexS = iconUrl.lastIndexOf('/');
		var indexE = iconUrl.lastIndexOf('.');
		return(iconUrl.substring(indexS + 6, indexE));
	},
	
	iconUrlEncode: function(iconId){
		return builderConfig.builderPath + "/images/spaceicons/icon-" + iconId + ".gif";
	},
	
	hide: function(){	
		if (this.messageControl) {
			this.messageControl.hide();
		}		
		this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},

	_verifyInput: function(title, description){
		
		if(!title || dojo.trim(title) ==""){			
			this.messageControl.attr("message", this.resourceMessage.E_SPACE_MANAGER_SPACE_NAME_IS_REQUIRED_0);			
			this.messageControl.show();			
			return false;
		}
		if (!com.ibm.mm.builder.utils.spaceUtil.validateSpaceName(title)) {
			return false;
		}
		
		if (description && dojo.isString(description)) {
			if (description.length >= 512) {
				this.messageControl.attr("message", this.resourceMessage.E_SPACE_MANAGER_SPACE_DESC_HAS_MAX_LIMIT_0);
				this.messageControl.show();
				return false;
			}
		}

		return true;
	},
	
	save: function(){		
		
		//init the error message 
		if(!this.messageControl) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({messageType: 'error'}, this.WID+"messageBox");
			this.messageControl.hide(); 	
		}
		//validation
		if(!this._verifyInput(this._getTitle(), this._getDescription()))
			return;

		//validation
		if(this.title != this._getTitle())
			this.propChanged.titleChanged = true;
		this.title = this._getTitle();
		
		if(this.description != this._getDescription())
			this.propChanged.descChanged = true;
		this.description = this._getDescription();
		
		if(this.theme != this._getSelectedTheme())
			this.propChanged.themeChanged = true;
		this.theme = this._getSelectedTheme();
		
		if(this.icon != this._getSelectedIcon())
			this.propChanged.iconChanged = true;
		this.icon = this._getSelectedIcon();
		
		this.saveSpaceModel();		
		this.messageControl.hide();
		this.hide();
	},
	
	_setOwnerName : function(name) {
		this.ownerName = name;
		dojo.byId(this.WID+"space_owner_value").innerHTML = name;
	},
	
	_setOwnerId : function(id) {
		this.ownerId = id;
	},
	_changeOwnerId: function(id) {
		if(this.ownerId != id)
			this.propChanged.ownerChanged = true;
		this.ownerId = id;
	},
	
	_canChangeOwner : function() {
        if (!this.space) {
            return false;
        }
        return com.ibm.mm.builder.utils.acModelUtil.isSpaceOwner(this.space) || this._canManageSpace(this.space);
    },
	
	_canManageSpace : function(space) {
        var ea = com.ibm.mashups.enabler.ac.AccessFactory.getEffectiveAccess(space);
        return ea.hasRole("manager");
    },
	
	_setSelectedTheme : function(theme) {
		this.theme = theme;
		this.themesListControl.setSelectedTheme(theme);
	},
	
	_setDescription : function(desc) {
		if(!desc)
			desc = "";
			
		this.description = desc;
		dojo.byId(this.WID+"SpaceDesc").value = this.description;
	},
	
	_setTitle : function(name) {
		this.title = name;
		dojo.byId(this.WID+"SpaceName").value = this.title;
	},
	
	_setSelectedIcon : function(iconUrl) {
		this.icon = iconUrl;
		this.iconsListControl.setSelectedIcon(iconUrl);
	}
	
});
