/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.builder.iwidget.SpaceSelector");

dojo.declare("com.ibm.mm.builder.systemwidget.SpaceSelector", com.ibm.mm.builder.iwidget.SystemWidget, {
	//todo make the menu config
	//hide personal space in portal env
    onLoad: function(){
    	this.spaceSelector = new com.ibm.mm.builder.iwidget.SpaceSelector();
		this.getViewRootNode().appendChild(this.spaceSelector.domNode);
		this.firstLoading = true; //aboid refresh model when first loading
	},
	
	onRefresh: function(iEvent){
		if(!this.firstLoading){
			com.ibm.mm.builder.utils.spaceUtil.getSpaceModel(true);
		}
		this.firstLoading = false;
		if(this.spaceSelector) this.spaceSelector.refresh(iEvent.payload);
	},
	
	onPageSwitched: function(iEvent){
		// check if there is a global page opened.
		if (dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId)){
			if (iEvent.payload===dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId)){
				// if current space is the same one as globalPageLoadedSpace, return
				if (com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()===dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId)){
					// not switch space
					return;
				}else{
					// switch space, but first to clear the global page
					this.clearGlobalPage();
				}
			}
		}
		// end check
		this.onRefresh({
			payload: com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(iEvent.payload)
		});
	},
	
	onSwitchSpace: function(iEvent){
		var cb = dojo.hitch(this, function(){
			// check if there is a global page opened.
			if (dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageId)){
				if (iEvent.payload===dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId)){
					//if current space is the same one as globalPageLoadedSpace, not switch space
					return;
				}else{
					//switch space, but first to clear the global page
					this.clearGlobalPage();
				}
			}
			// end check		
			var spaceId = iEvent.payload;
			com.ibm.mm.builder.utils.spaceUtil.setSpaceId(spaceId);
			//switch to last page or first page.
			//todo use getFirstPageNode of navigationUtil
			var pageUtil = com.ibm.mm.builder.utils.pageUtil;
			var pageId;
			if (spaceId) {
				pageId = pageUtil.getPageIdFromSpace(spaceId);
				if (pageId && !pageUtil.getPageNode(pageId)) {
					pageId = null;
				}
				if (!pageId) {
					pageId = pageUtil.getFirstPageInSpace(spaceId);
				}
			}
			else {
				pageId = pageUtil.getFirstRootPageId();
			}
			if(spaceId === null && pageId === null){
				com.ibm.mm.builder.utils.navigationUtil.autoAcceptPagesFromDefaultGroup();
				pageId = pageUtil.getFirstRootPageId();
			}
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(pageId);
			this.eventService.broadcastEvent("com.ibm.mashups.builder.switchPage", pageId);
		});
		
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
	},
	
	clearGlobalPage:function(){
		if (com.ibm.mm.builder.TabbedNavigationDelegate){
			// clear the global page in tabbed navigation
			com.ibm.mm.builder.TabbedNavigationDelegate.onClearGlobalPage();
		}else{
			// clear the global page in other navigations
			dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
		}
		
	}
});


