/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Erik (bizheng@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.widget.ViewMorePage");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");

dojo.declare("com.ibm.mm.builder.viewMorePage", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {	
		
	count:0,
	
	onLoad: function(){
		this.pageItems = [];
	},
	
    onView: function(){
		this.inherited(arguments);
		this.viewMorePage = new com.ibm.mm.builder.widget.ViewMorePage({items:this.pageItems},this.treeContainer);
	},
	
	/**
	 * Handle function for the iEvent "onViewMorePage"
	 */
	onViewMorePage: function(iEvent) {
		this.createSharingPages();
		this.viewMorePage.reGenerate(this.pageItems);
	},
	
	hide: function(){
		this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},
	
	save: function(event){
		//this.saveBtn.disabled = true;
		this.hide();
		
		if(this.viewMorePage.pageList.length > 0){
			var navUtil = com.ibm.mm.builder.utils.navigationUtil;
			//todo hot fix for bug 11342, please remove after the bug is fixed.
			com.ibm.mm.enabler.model.NavigationModelImpl._instance = null;
			navUtil._navModel = null;
			//11342 end
			
			var _navModel = navUtil.getNavigationModel();
			var _sharedNavModel = navUtil.getSharedNavigationModel();
			var parent = _navModel.findDefaultAcceptParent().start();
			for(var i=0; i < this.viewMorePage.pageList.length; i++){
				var pageId = this.viewMorePage.pageList[i];
		        var page = _sharedNavModel.find(pageId).start();
				var template = _navModel.create({"template": page});
		        _navModel.insert(template, parent);
			}
	        _navModel.commit().start();
			
			//todo hot fix for bug 11342, please remove after the bug is fixed.
			com.ibm.mm.enabler.model.NavigationModelImpl._instance = null;
			navUtil._navModel = null;
			//11342 end
			
			this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
		}
		//this.saveBtn.disabled = false;
	},
	
	createSharingPages: function(){
		this.pageItems = [];
		var navUtil = com.ibm.mm.builder.utils.navigationUtil;
		
		//todo hot fix for bug 11342, please remove after the bug is fixed.
		com.ibm.mm.enabler.model.SharedNavigationModelImpl._instance = null;
		navUtil._sharedNavModel = null;
		navUtil._navModel = null;
		//11342 end
		
		var root = navUtil.getSharedNavigationRootNode();
		var sharedNavModel = navUtil.getSharedNavigationModel();
		var iterator = sharedNavModel.getChildren(root);
		//prefix
		var desc = this.splitDesc();
		this.count=0;
		while (iterator.hasNext()) {
			var node = iterator.next();
			if (sharedNavModel.isAccepted(node)) { continue; }
			var title = com.ibm.mm.builder.utils.htmlUtil.getLimitedString(com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(node), 50);
			
			var layoutModel = sharedNavModel.getLayoutModel(node.getID());
			var pageOwner = null;
			if (layoutModel) {  //layoutModel could be null, in this case, owner name is "nobody"
				var layoutNode = layoutModel.getRoot().start();
				var acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
				pageOwner = acModel.getOwner()
			}
			var ownerName = pageOwner ? pageOwner.getDisplayName() : "";
			var subst_desc = (pageOwner && ownerName) ? this.substituteArray(desc, ownerName) : ["", ""];
			this.pageItems.push({
				"title": title,
				"pid": node.getID(),
				"pre": subst_desc[0],
				"end": subst_desc[1]
			});
			this.count++;
		}
	},
	
	substituteArray: function(desc,owner){
		var ret = [];
		var pre = desc[0];
		ret[0] = pre.indexOf("${0}")>0 ? dojo.string.substitute(pre,[owner]):pre;
		var end = desc[1];
		ret[1] = end.indexOf("${0}")>0 ? dojo.string.substitute(end,[owner]):end;
		return ret;
	},
	
	splitDesc: function(){
		var desc = com.ibm.mm.builder.coreWidgetsStrings.I_MORE_PAGE_FROM_WHO;
		if(desc && desc.length<=0){
			return ["",""];
		}
		var index = desc.indexOf("${1}");
		if(index < 0){
			return ["",desc];
		}else{
			return [desc.substring(0,index),desc.substring(index+4)];
		}
	}
});
