/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.WirePane");
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas");
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification");
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip");

dojo.declare("com.ibm.mm.builder.systemwidget.wireInterface", null, {
	
	wirePane: null,
	
	wiringCanvas: null,
	
	layouts: null,
	
	displayDisabledNotification:false,
	
	autoWiringDisabledTip: null,
	
    onLoad: function(){
		this.layouts = new Array();
		var widgetCtx=this.iContext;
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.wireInterface");
    },
	
	publishNewWireAdded:function(){
		
	},
	
	publishWireRemoved:function(){
		
	},
	
	onWireInterfaceDisplay:function(iEvent){
		var widgetId = iEvent.payload;
		if(widgetId)
			this.displayWireInterface(widgetId);
	},
	
	displayWireInterface:function(widgetId) {
		if(this.wirePane){
			this.wirePane.destroy();
		}
		this.wirePane = new com.ibm.mm.builder.iwidget.wiringscreen.WirePane();
		this.wirePane.setContext(this.iContext);
		this.wirePane.display(widgetId);
		//if need to display auto-wiring disabled notification
		var autoWiringEnabled = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getAutoWiringEnablement();
		this.initAutoWiringSettings();
		var lookaside = com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS");
		if(!autoWiringEnabled && lookaside && this.displayDisabledNotification) {
			if(com.ibm.mm.builder.utils.wireUtil.checkAutoWiring(widgetId)) {
				this.autoWiringDisabledTip.show(widgetId);
				if(this.iContext.dialogContainer){
					this.iContext.dialogContainer.registerSubDialog("Mashup_Auto_Wiring_Disable_Tip_Dlg")
				}
			}
		}
	},
	
	initAutoWiringSettings:function(){

		var user = com.ibm.mm.builder.utils.userUtil.getCurrentUser();
		var lookaside = com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")
		
		if (!lookaside) { //lookaside is disabled
			this.displayDisabledNotification = false;
		}
		else {
			var v1 = user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS");
			this.lookaside = true;
			this.displayDisabledNotification = eval(v1);
		}

		if (this.autoWiringDisabledTip == null) {
			this.autoWiringDisabledTip = new com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip();
			this.autoWiringDisabledTip.setOuterWirePaneContext(this.iContext);
		}
	},
	
	handleWidgetUpdated: function(iEvent){
		var widgetList = iEvent.payload;
		if(wirePane)
			this.wirePane.updateWidgetList(widgetList);
	},
	
	onUnload:function(){
		if (this.wirePane) {
			this.wirePane.destroy();
			this.wirePane = null;
		}
		if(this.autoWiringDisabledTip)
			this.autoWiringDisabledTip.destroy();
	}
});
