/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
// globally defines the relative path to all test resources
dojoResourceRelativePath = "../../mashups";
testResourceRelativePath = "../"+dojoResourceRelativePath;

if (dojo.isRhino) {
    // load mockup browser environment
    load(testResourceRelativePath+"/test/base/env.js");
    // now define the default callback handler
    window.XMLHttpRequest.callbackSend = function(absoluteFileLocation, url) {
        var basePath = "/test/enabler/resources";
        var ret = url;
        if (!this._loadStaticContent) {
            var idx = url.indexOf("?uri=");
            if (idx!=-1) url = url.substring(idx+5);
            var uri = url;
            uri = uri.replace(/:/g, "_");
            uri = uri.replace(/\?/g, "_");
            uri = uri.replace(/&/g, "_");
            uri = uri.replace(/\//g, "_");
            ret = uri + ".xml";
        }
        ret = absoluteFileLocation+testResourceRelativePath + basePath + "/" + ret;
        if (ibmConfig.isDebug)
            doh.debug("Returning url '"+ret+"' for '"+url+"'");
        return ret;
    };    
}

ibmConfig = {
    "com.ibm.mashups.proxy.url": "/mum/proxy",
    "com.ibm.mashups.hub.url": "/mashuphub",
    "com.ibm.mashups.contextroot": "/mum",
    "com.ibm.mashups.contextroot.builder": "/mum",
    "com.ibm.mashups.contextroot.theme.temp": "/themes",
    "com.ibm.mashups.contextroot.enabler": "/mum",
    "com.ibm.mashups.contenthandler.private": "/mycontenthandler",
    "com.ibm.mashups.contenthandler.public": "/contenthandler",
    "com.ibm.mashups.theme.defaultThemeId": "defaultTheme",
    isDebug:true,
    traceConfig : [ "com.ibm.mm.enabler.*" ],
    locale:"en",
    availableLocales:"de,en,es,fr,it,he,ja,ko,pt-br,zh,zh-tw,ROOT",
    mappingFunction: null,
    "anonymousUser": true
};

dojo.locale = "ROOT";
dojo.require("dojo._base.xhr");
dojo.require("dojox.xml.parser");

dojo.registerModulePath("mm.tests",dojoResourceRelativePath+"/test");
dojo.registerModulePath("com.ibm.mm.enabler",dojoResourceRelativePath+"/com/ibm/mm/enabler");
dojo.registerModulePath("com.ibm.mashups.enabler",dojoResourceRelativePath+"/com/ibm/mashups/enabler"); 

dojo.registerModulePath("com.ibm.mm.data",dojoResourceRelativePath+"/com/ibm/mm/data");
dojo.registerModulePath("com.ibm.mashups.iwidget",dojoResourceRelativePath+"/com/ibm/mashups/iwidget");
dojo.registerModulePath("com.ibm.mm.iwidget",dojoResourceRelativePath+"/com/ibm/mm/iwidget");
dojo.registerModulePath("com.ibm.mashups.services",dojoResourceRelativePath+"/com/ibm/mashups/services");
dojo.registerModulePath("com.ibm.mm.services",dojoResourceRelativePath+"/com/ibm/mm/services");

dojo.requireLocalization( "com.ibm.mm.enabler","modelMessages");

if ( dojo.isRhino ) {
    ibmConfig.serviceDocumentUrl = "/mum/contenthandler?uri=service_document";
    load( testResourceRelativePath+"/com/ibm/mm/enabler/extensions/mapping.js" );
    load( testResourceRelativePath+"/com/ibm/mm/enabler/extensions/registry.js" );
    load( testResourceRelativePath+"/test/base/init-extension.js" );
}
else if ( dojo.isBrowser ) {
    document.write("<scr"+"ipt type='text/javascript' src='"+testResourceRelativePath+"/com/ibm/mm/enabler/extensions/registry.js'></scr"+"ipt>");
    document.write("<scr"+"ipt type='text/javascript' src='"+testResourceRelativePath+"/com/ibm/mm/enabler/extensions/mapping.js'></scr"+"ipt>");
    document.write("<scr"+"ipt type='text/javascript' src='"+testResourceRelativePath+"/test/base/init-extension.js'></scr"+"ipt>");
}

//dojo.require("com.ibm.mm.enabler.enabler");
//load("../../../mashups/com/ibm/mm/enabler/enabler.js");
dojo.require("com.ibm.mashups.enabler.model");
dojo.require("com.ibm.mm.enabler.model");
