/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("mm.tests.enabler.enabler_extreg");

dojo.require("mm.tests.base.support");
dojo.require("mm.tests.enabler.base");

tests.register("mm.tests.enabler.enabler_extreg", 
	[
        new mm.tests.enabler.BaseTest("testExtensionRegisry", 
            function (doh) {
				var extReg = new ExtensionRegistry();
				
				doh.debug("Checking object definitions...");
				doh.debug("Asserting true, extReg != null");
				doh.assertTrue(extReg != null);
				
				var implTracker = new ImplementationTracker();
				
				doh.debug("Asserting true, implTracker != null" );
				doh.assertTrue(implTracker != null);
				
				doh.debug("Asserting true, ibmConfig.mappingFunction != null");
				doh.assertTrue(ibmConfig.mappingFunction != null);
				
				var extensions = [];
				extensions.push({
					"com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelUrl": {
						type: "around",
						handler: function ( executor, fnArgs ) {
							var urlType = fnArgs[0];
							var retVal = executor( fnArgs );
							return { type: urlType, value: retVal };
						}
					}
				});
				
				var beforeTestValue = null;
				extensions.push({
					"com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelUrl": {
						type: "before",
						handler: function ( fnArgs ) {
							doh.debug( "Asserting true, fnArgs.length == 1" );
							doh.assertTrue( fnArgs.length == 1 );
							beforeTestValue="executed!";
							return fnArgs;
						}
					}
				});
				
				var afterTestValue = null;
				extensions.push({
					"com.ibm.mashups.enabler.model.url.ModelUrlFactory.createModelUrl": {
						type: "after",
						handler: function ( retVal, fnArgs ) {
							doh.debug( "Asserting true, fnArgs.length == 1" );
							doh.assertTrue( fnArgs.length == 1 );
							doh.debug( "Asserting true, retVal != null" );
							doh.assertTrue( retVal != null );
							afterTestValue="executed!";
							return retVal;
						}
					}
				});	
				//Attach the extensions.	
				extReg.process( extensions );
				var modelUrlFactory = com.ibm.mashups.enabler.model.url.ModelUrlFactory;
				var modelUrl = modelUrlFactory.createModelUrl(com.ibm.mashups.enabler.model.url.ModelUrlFactory.CATALOG_URL);
				
				doh.debug("Asserting true, modelUrl.type == com.ibm.mashups.enabler.model.url.ModelUrlFactory.CATALOG_URL");
				doh.assertTrue(modelUrl.type == com.ibm.mashups.enabler.model.url.ModelUrlFactory.CATALOG_URL);
				
				doh.debug("Asserting true, modelUrl.value != null" );
				doh.assertTrue(modelUrl.value != null );
				
				doh.debug("Asserting true, beforeTestValue != null" );
				doh.assertTrue(beforeTestValue != null);
				
				doh.debug("Asserting true, afterTestValue != null" );
				doh.assertTrue(afterTestValue != null);
            }
        )
	]
);
