/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("mm.tests.enabler.enabler_huffmann_decode");

dojo.require("mm.tests.base.support");
dojo.require("mm.tests.enabler.base");
dojo.require("com.ibm.mm.enabler.encode.huffman");

tests.register("mm.tests.enabler.enabler_huffmann_decode", 
    [
        new mm.tests.enabler.BaseTest("testHuffmanDecoder", 
            function (doh) {
				var encodedValue = "TyZncjIB/Z2Fportal/Z2Fwebsphere/Z2Fprod/Z2Fxmlns/.com/.ibm/Z2Fwww/Z20xmlnsZ3AmashupZ3DZ22httpZ3A/Z3CmashupZ3Asitemap/Z2F/Z2FmashupZ3AsitemapZ3E/Z2FZ3EZ3C/Z20modeZ3DZ22downloadZ22/.xmlZ22/Z2Fhtmlmarkup/Z2Fwidget-catalog/Z2Fmum/Z20uriZ3DZ22resZ3A/Z2Fmashup-sitemapZ22Z3EZ3CmashupZ3Aentry/.2/.0/Z2Fv6/4WkqTAj_3bNzzdFbLQ!!";
                var decodedValue = "<mashup:sitemap xmlns:mashup=\"http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.2/mashup-sitemap\"><mashup:entry uri=\"res://mum/widget-catalog/htmlmarkup.xml\" mode=\"download\"/></mashup:sitemap>";
                var result = com.ibm.mm.enabler.encode.huffman.HuffmanURL.getDataFromHuffmanTree(encodedValue);
                
                doh.debug("Asserting equal " + decodedValue + " --- " + result);
                doh.assertEqual(decodedValue, result);                
   
            }
        ),
        new mm.tests.enabler.BaseTest("testBase64Decoder", 
            function (doh) {
				var encodedValue = "TyZncjIB";
                var decodedValue = [79,38,103,114,50,1];
                var result = com.ibm.mm.enabler.encode.huffman.HuffmanURL._decodeBase64(encodedValue);
                
                doh.debug("Asserting equal " + decodedValue + " --- " + result);    
                doh.assertEqual(decodedValue,result);
				
				var base64EncodedValue = "4WkqTAj_3bNzzdFbLQ!!";
				var base64DecodedValue = [225,105,42,76,8,225,221,179,115,205,209,91,45];
				var result2 = com.ibm.mm.enabler.encode.huffman.HuffmanURL._decodeBase64(base64EncodedValue);
				doh.debug("Asserting equal " + base64EncodedValue + " --- " + result2);    
                doh.assertEqual(base64DecodedValue,result2);
            }
        )
    ]
);
