/* Copyright IBM Corp. 2009  All Rights Reserved.                    */
dojo.provide("mm.tests.enabler.enabler_iwidget_properties");

dojo.require("mm.tests.base.support");
dojo.require("mm.tests.enabler.base");

dojo.require("com.ibm.mm.iwidget.widget.properties");

tests.register("mm.tests.enabler.enabler_iwidget_properties", 
    [
        new mm.tests.enabler.BaseTest("testProperties", 
            function (doh) {
                var items = { name1: "value1", name2: "value2", name3: "value3" };
                var properties = new com.ibm.mm.iwidget.widget.PropertiesImpl(items); // no need for name / provider etc
                
                var expVal = "value1";
                var retVal = properties.getItemValue("name1");
                
                doh.debug("Asserting equals: " + expVal + " = " + retVal);
                doh.assertEqual(expVal, retVal);
                
                doh.debug("Asserting name array:");
                var nameArray = [ "name1", "name2", "name3" ];
                
                var names = properties.getAllNames();
                for (var i=0; i<names.length; i++) {
                    doh.debug(" " + nameArray[i] + " = " + names[i]);
                    doh.assertEqual(nameArray[i], names[i]);
                }
            }
        ),
        new mm.tests.enabler.BaseTest("testModifiableProperties", 
            function (doh) {
                doh.debug("Building readonly basis 'default' properties");
                var items = { name1: "value1", name2: "value2", name3: "value3" };
                var defaultProps = new com.ibm.mm.iwidget.widget.PropertiesImpl(items); // no need for name / provider etc
                
                doh.debug("Creating modifiable properties from readonly props");
                var properties = new com.ibm.mm.iwidget.widget.ModifiablePropertiesImpl(null, defaultProps);
                
                doh.debug("Testing default fallback:");
                doh.debug("-------------------------");
                var expVal = "value1";
                var retVal = properties.getItemValue("name1");
                
                doh.debug("Asserting equals: " + expVal + " = " + retVal);
                doh.assertEqual(expVal, retVal);
                
                doh.debug("Asserting name array:");
                var nameArray = [ "name1", "name2", "name3" ];
                
                var names = properties.getAllNames();
                for (var i=0; i<names.length; i++) {
                    doh.debug(" " + nameArray[i] + " = " + names[i]);
                    doh.assertEqual(nameArray[i], names[i]);
                }
                
                
                doh.debug("Testing modifiable features:");
                doh.debug("----------------------------");
                properties.setItemValue("name2", "value2new");
                properties.removeItem("name3");
                properties.setItemValue("newitem", "newvalue")
                
                expVal = "value1";
                retVal = properties.getItemValue("name1");
                
                doh.debug("Asserting equals: " + expVal + " = " + retVal);
                doh.assertEqual(expVal, retVal);
                
                expVal = "value2new";
                retVal = properties.getItemValue("name2");
                
                doh.debug("Asserting equals: " + expVal + " = " + retVal);
                doh.assertEqual(expVal, retVal);
                
                expVal = null;
                retVal = properties.getItemValue("name3");
                
                doh.debug("Asserting equals: " + expVal + " = " + retVal);
                doh.assertEqual(expVal, retVal);
                
                expVal = "newvalue";
                retVal = properties.getItemValue("newitem");
                
                doh.debug("Asserting equals: " + expVal + " = " + retVal);
                doh.assertEqual(expVal, retVal);
                
                doh.debug("Asserting name array:");
                var nameArray = [ "name1", "name2", "newitem" ];
                
                var names = properties.getAllNames();
                for (var i=0; i<names.length; i++) {
                    doh.debug(" " + nameArray[i] + " = " + names[i]);
                    doh.assertEqual(nameArray[i], names[i]);
                }
                
                doh.debug("Asserting dirty flag (true)");
                retVal = properties._isDirty();
                doh.assertTrue(retVal);
                
                properties._setDirty(false);
                
                doh.debug("Asserting dirty flag (false)");
                retVal = properties._isDirty();
                doh.assertFalse(retVal);
            }
        )
    ]
);