/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("mm.tests.enabler.enabler_model_community");

dojo.require("mm.tests.base.support");
dojo.require("mm.tests.enabler.base");
dojo.require("com.ibm.mm.enabler.model.community");

tests.register("mm.tests.enabler.enabler_model_community", 
	[
        new mm.tests.enabler.BaseTest("testCommunityModel", 
            function (doh) {
                ibmConfig.traceConfig = ["com.ibm.mm.enabler.model.*", "com.ibm.mm.enabler.community.*" ];
                
                com.ibm.mashups.enabler.logging.Logger._setTraceConfig(ibmConfig.traceConfig);
                var communityModel = new com.ibm.mm.enabler.model.CommunityModelImpl();
                doh.debug("finding stuff");
                var deferred = communityModel.find(100);
                doh.debug("starting");
                var community = deferred.start();
                
                doh.debug("adding participants");
                var participant = { getID: function() {
                                        return "oliver_unique_ID";
                                    }};
                                    
                // add a user to the new community:
                community.addParticipant(participant, com.ibm.mashups.enabler.AccessLevel.VIEW);
                
                doh.debug("gettingParticipants");
                var participants = community.getParticipants();
                for (var i=0; i < participants.length; i++) {
                    doh.debug("found participant: " + participants[i].getUserID());
                }
                
                var part = participants[0];
                doh.debug("community ID is " + community.getID());
                doh.debug("removing participant");
                community.removeParticipant({getID: function() {return "user1_user_uniqueID";}});
                
                doh.debug("committing participant");
                communityModel.commit().start();
                
                doh.debug("issuing find again, should contain oliver_unique");
                var deferred = communityModel.find(100);
                doh.debug("starting");
                var community = deferred.start();
                doh.debug("gettingParticipants");
                var participants = community.getParticipants();
                for (var i=0; i < participants.length; i++) {
                    doh.debug("found participant: " + participants[i].getUserID());
                }
                
                
                return;
                doh.debug("getting Childs");
                var iterator = communityModel.iterator();
                
                
                while(iterator.hasNext()) {
                    var node = iterator.next();
                    doh.debug("ID: " + node.getID());
                }
                
                doh.debug("Now we try to create a community");
                this.setPhase("create");
                
                // fake page:
                var page ={ getID: function() { return "600"; } };
                
                var communityJSON = { linkedResource : { 
                                        getID: function() { return "600"; },
                                        setCommunity: function(value) { return; }
                                      }
                                    };
                
                var newCommunity = communityModel.create(communityJSON);
                
                doh.debug("inserting community");
                communityModel.insert(newCommunity);
                
                communityModel.commit().start();
                
            }
        )
	]
);
