/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("mm.tests.enabler.enabler_navigation");

dojo.require("mm.tests.base.support");
dojo.require("mm.tests.enabler.base");
dojo.require("com.ibm.mashups.enabler.model");

tests.register("mm.tests.enabler.enabler_navigation", 
    [
        new mm.tests.enabler.BaseTest("testPageMetaData", 
            function (doh) {
                var navigationModel = com.ibm.mashups.enabler.model.Factory.getNavigationModel();
                doh.debug(" Asserting (#1)");
                doh.assertTrue(navigationModel != null);
                navigationModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(10));
                var selectedNode = navigationModel.getRoot().start();
                doh.debug(" Asserting (#2)");
                doh.assertTrue(selectedNode != null);
                var layoutModel = navigationModel.getLayoutModel(selectedNode.getID());
                doh.debug(" Asserting (#3)");
                doh.assertTrue(layoutModel != null);
                var lmRoot = layoutModel.getRoot().start();
                doh.assertTrue(lmRoot != null);
                var key = "LayoutWidgetAttributes";
                var value = "{a:1,b:'x'}";
                doh.debug(" Asserting (#4)");
                lmRoot.setMetaData(key,value);
                doh.assertEqual(value,lmRoot.getMetaData(key));
                navigationModel.commit().start();
                
                // now we go into phase two and verify that the commit has worked
                this.setPhase("phaseTwo");
                
                var navigationModel = com.ibm.mashups.enabler.model.Factory.getNavigationModel();
                doh.debug(" Asserting (#5)");
                doh.assertTrue(navigationModel != null);
                navigationModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(10));
                var selectedNode = navigationModel.getRoot().start();
                doh.debug(" Asserting (#6)");
                doh.assertTrue(selectedNode != null);
                var layoutModel = navigationModel.getLayoutModel(selectedNode.getID());
                doh.debug(" Asserting (#7)");
                doh.assertTrue(layoutModel != null);
                var lmRoot = layoutModel.getRoot().start();
                doh.assertTrue(lmRoot != null);
                doh.debug(" Asserting (#8)");
                doh.assertEqual(value,lmRoot.getMetaData(key));
                
            }
        ),
        new mm.tests.enabler.BaseTest("createPage", 
            function (doh) {
                var navigationModel = com.ibm.mashups.enabler.model.Factory.getNavigationModel();
                doh.debug(" Asserting (#1)");
                doh.assertTrue(navigationModel != null);
                
                navigationModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(10));
                var parent = navigationModel.getRoot().start();
                doh.debug(" Asserting (#2)");
                doh.assertTrue(parent != null);
                var navNode = navigationModel.create();
                doh.debug(" Asserting (#3)");
                doh.assertTrue(navNode != null);
                navNode.setTitle("My New Page","en");
                navNode.setDescription("Description","en");
                navigationModel.insert(navNode, parent, null);
                navigationModel.commit().start();
            }
        ),
        new mm.tests.enabler.BaseTest("test2", 
            function (doh) {
                var navigationModel = com.ibm.mashups.enabler.model.Factory.getNavigationModel();
                doh.debug(" Asserting (#1)");
                doh.assertTrue(navigationModel != null);
            }
        )
    ]
);
