/* Copyright IBM Corp. 2009  All Rights Reserved.                    */
dojo.provide("mm.tests.enabler.enabler_space_export");

dojo.require("mm.tests.base.support");
dojo.require("mm.tests.enabler.base");

/*
 * A new SpaceNode is create from SpaceModel for test. Refer to resources/testSpaceExport/space_collection.post.xml.
 * Note: folder name is name passed to BaseTest; create node is POST to uri: /mum/contenthandler?uri=space:collection
 */
tests.register("mm.tests.enabler.enabler_space_export", 
	[
		new mm.tests.enabler.BaseTest("testSpaceExport", 
			function(doh) {
				doh.debug("Space Export - test starts.");
				var spaceModel = new com.ibm.mm.enabler.model.SpaceModelImpl();
				doh.debug("Assert space model is not null.");
                doh.assertTrue(spaceModel != null);

				doh.debug("Space Export - space model created.");
				var newSpace = spaceModel.create();
				newSpace.setID("091CDB581BF903C0869534CD562934000000");
				doh.debug("Space Export - a new space created witd ID:[" + newSpace.getID() +"]");
                doh.assertTrue(newSpace != null);
	
				var exportSpaceLink = newSpace.getExportSpaceURL();
				doh.debug("Space Export URL:" + exportSpaceLink);
				doh.assertEqual("/mum/contenthandler?uri=space%3aid%3a091CDB581BF903C0869534CD562934000000&mime-type=application%2fzip&rep=instance", exportSpaceLink);
				doh.debug("Space Export - test getExportSpaceURL() success!");
	
				var exportTemplateLink = newSpace.getExportTemplateURL();
				doh.debug("Space Export as template URL:" + exportTemplateLink);
				doh.assertEqual("/mum/contenthandler?uri=space%3aid%3a091CDB581BF903C0869534CD562934000000&mime-type=application%2fzip&rep=template", exportTemplateLink);
				doh.debug("Space Export - test getExportTemplateURL() success!");
			}
		)
	]
);
