/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("mm.tests.enabler.enabler_utilities");

dojo.require("mm.tests.base.support");
dojo.require("mm.tests.enabler.base");
dojo.require("com.ibm.mm.enabler.utilities");
dojo.require("com.ibm.mm.enabler.xml" );

tests.register("mm.tests.enabler.enabler_utilities", 
    [
        new mm.tests.enabler.BaseTest("testHttpUrl", 
            function (doh) {
                var testValue = "http://myhost.com/mypath1/mypath2/file.html?query=value1#param1";
                var httpUrl = new com.ibm.mm.enabler.utilities.HttpUrl(testValue);
                
                doh.debug("Asserting equal " + testValue + " - " + httpUrl.toString());
                doh.assertEqual(testValue, httpUrl.toString());
                
                testValue = "value1";
                
                doh.debug("Asserting equal " + testValue + " - " + httpUrl.getParameter("query"));
                doh.assertEqual(testValue, httpUrl.getParameter("query"));
                
                // test port conversion
                testValue = "http://myhost.com:80/mypath";
                httpUrl = new com.ibm.mm.enabler.utilities.HttpUrl(testValue);
                
                testValue = "http://myhost.com/mypath";
                doh.debug("Asserting equal " + testValue + " - " + httpUrl.toString());
                doh.assertEqual(testValue, httpUrl.toString());
            }
        ),
        new mm.tests.enabler.BaseTest("testXPath", 
            function (doh) {
                var content = this.xhrGetStaticContent("xpath.xml");
                doh.debug("Verifying loaded content.");
                doh.assertTrue(content != null);
            
                var namespaces = {  "atom"  : "http://www.w3.org/2005/Atom",
                                    "app"   : "http://www.w3.org/2007/app",
                                    "model" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
                                    "thr"   : "http://purl.org/syndication/thread/1.0" };
                var expr = "//atom:id";
                var result = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, content, namespaces);
                doh.debug("Asserting result to contain two return values");
                doh.assertTrue(result && result.length == 2);

                var expr = "atom:feed/atom:id";
                var result = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, content, namespaces);
                doh.debug("Asserting result to contain one element");
                doh.assertTrue(result && result.length==1);

                var expr = "atom:feed/atom:entry/atom:link[@thr:count]";
                var result = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, content, namespaces);
                doh.debug("Asserting result to contain one element");
                doh.assertTrue(result && result.length==1);
            }
        )
    ]
);
