/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * Any javascript file that defines the subclass of SpaceExtension has 3 sections in order:
 * section 1: define the constractor of the subclass.
 * section 2: specify the prototype of the suclass.
 * section 3: overwrite all or part of the SpaceExtension methods.
 */
 
/**
 * section 1: define the constractor of the subclass.
 */
function AlertSpaceExtension() {
}

/**
 * section 2: specify the prototype of this suclass. The prototype should be the instance of superclass (SpaceExtension)
 */
AlertSpaceExtension.prototype = new SpaceExtension(); 
 
/**
 * section 3: overwrite all or part of the SpaceExtension methods.
 */
 
AlertSpaceExtension.prototype.onSpaceCreate = function(spaceId, spaceName, spaceDescription, optionalInfo) {
	alert("AlertSpaceExtension.onSpaceCreate \n spaceId = " +  spaceId + "\n spaceName = " + spaceName + "\n spaceDescription = " + spaceDescription);
};

AlertSpaceExtension.prototype.onSpaceCopy = function(sourceSpaceId, targetSpaceId, optionalInfo) {
	alert("AlertSpaceExtension.onSpaceCopy \n sourceSpaceId = " +  sourceSpaceId + "\n targetSpaceId = " + targetSpaceId);
};

AlertSpaceExtension.prototype.onSpaceUpdate = function(spaceId, spaceData, optionalInfo) {
	alert("AlertSpaceExtension.onSpaceUpdate \n spaceId = " +  spaceId + " \n spaceData = " + spaceData);
};

AlertSpaceExtension.prototype.onSpaceDelete = function(spaceId, optionalInfo) {
	alert("AlertSpaceExtension.onSpaceDelete \n spaceId = " +  spaceId);
};

AlertSpaceExtension.prototype.canCopySpace = function(spaceId, optionalInfo) {
	alert("AlertSpaceExtension.canCopySpace \n spaceId = " +  spaceId);
};

// canExportSpace
// create a SpaceExtensionResult object as the return.
AlertSpaceExtension.prototype.canExportSpace = function(spaceId, optionalInfo) {
	alert("AlertSpaceExtension.canExportSpace \n spaceId = " +  spaceId);
};

// canDeleteSpace
// no return in this method. Which means ok.
AlertSpaceExtension.prototype.canDeleteSpace = function(spaceId, optionalInfo) {
	alert("AlertSpaceExtension.canDeleteSpace \n spaceId = " +  spaceId);
};
