/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * Any javascript file that defines the subclass of SpaceExtension has 3 sections in order:
 * section 1: define the constractor of the subclass.
 * section 2: specify the prototype of the suclass.
 * section 3: overwrite all or part of the SpaceExtension methods.
 */
 
/**
 * section 1: define the constractor of the subclass.
 */
function SampleSpaceExtension() {
	this.onSpaceCreateCalled = false;
	this.onSpaceCopyCalled = false;
	this.onSpaceUpdateCalled = false;
	this.onSpaceDeleteCalled = false;
	
}

/**
 * section 2: specify the prototype of this suclass. The prototype should be the instance of superclass (SpaceExtension)
 */
SampleSpaceExtension.prototype = new SpaceExtension(); 
 
/**
 * section 3: overwrite all or part of the SpaceExtension methods.
 */
 
// onSpaceCreate
SampleSpaceExtension.prototype.onSpaceCreate = function(spaceId, spaceName, spaceDescription, optionalInfo) {
	this.onSpaceCreateCalled = true;
	return new SpaceExtensionResult(SpaceExtensionResult.STATE_OK);
};

// onSpaceCopy
SampleSpaceExtension.prototype.onSpaceCopy = function(sourceSpaceId, targetSpaceId, optionalInfo) {
	this.onSpaceCopyCalled = true;
};

SampleSpaceExtension.prototype.onSpaceUpdate = function(spaceId, spaceData, optionalInfo) {
	this.onSpaceUpdateCalled = true;
};

SampleSpaceExtension.prototype.onSpaceDelete = function(spaceId, optionalInfo) {
	this.onSpaceDeleteCalled = true;
};

SampleSpaceExtension.prototype.canCopySpace = function(spaceId, optionalInfo) {
	alert("SampleSpaceExtension.canCopySpace \n spaceId = " +  spaceId);
};

SampleSpaceExtension.prototype.canExportSpace = function(spaceId, optionalInfo) {
	alert("SampleSpaceExtension.canExportSpace \n spaceId = " +  spaceId);
};

SampleSpaceExtension.prototype.canDeleteSpace = function(spaceId, optionalInfo) {
	alert("SampleSpaceExtension.canDeleteSpace \n spaceId = " +  spaceId);
};
