<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%-- Copyright IBM Corp. 2009  All Rights Reserved.                    --%>

<head>
<%
// get config service so that we can add all the configuration values into ibmConfig
com.ibm.mm.framework.services.IConfigService configService = com.ibm.mm.framework.Platform.getInstance().getConfigService();

String builderContext = configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_BUILDER);
String enablerContext = configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_ENABLER);

String hubUrl = "/mashuphub";
String currentLocale=request.getLocale().toString().replace('_', '-').toLowerCase();

String framework = request.getParameter("framework");
if (framework == null)
    framework = "full";

String htmlPage = request.getParameter("demo");
if (htmlPage == null) {
    response.sendError(500, "No demo to load specified");
	return;
}

//some double byte languages like chinese need to enlarge font size to 12pt or above
boolean needEnlargeFont=currentLocale.startsWith("zh")||currentLocale.startsWith("ja")||currentLocale.startsWith("ko");

%>
	<script language="JavaScript" type="text/javascript">
		ibmConfig = {
<%
    java.util.Iterator<String> configNames = configService.clientNames();
    while (configNames.hasNext()) {
        String name = configNames.next();
        Boolean tryBoolFirst = configService.getBoolean(name);
        if (null == tryBoolFirst) {
           continue;
        }
        boolean boolVal = tryBoolFirst.booleanValue();
        if (boolVal) {
%>
            "<%=name%>": <%=boolVal%>,
<%          
        } else {
           // see if it is really false     
           String value = configService.getString(name);
           if ("false".equalsIgnoreCase(value) || "no".equalsIgnoreCase(value)) {
%>
            "<%=name%>": false,
<%
           } else {//try string array
               String[] valueArray= configService.getStrings(name);
               String values = "[]";
               if (valueArray != null && valueArray.length != 1){
                   if (name.equals("available.locales")) continue;
                   values = "[";
                   for (int i=0; i<valueArray.length; i++) {
                       values += "\""+valueArray[i]+"\"" + ",";
                   }
                   values = values.substring(0, values.length() -1);
                   values +="]";
%>
            "<%=name%>": <%=values%>,
<%          
               } else{ //try string
                   value = configService.getString(name);
                   if(value != null){
                       value = "\""+value+"\"";
%>
            "<%=name%>": <%=value%>,
<%          
                   }
               }
           }
       }   
   }
    
%>
			contextRootEnabler: "<%=enablerContext%>",
			contextRootBuilder: "<%=builderContext%>",			
            "com.ibm.mashups.navigation.hidden": "com.ibm.mashups.navigation.hidden",
            "com.ibm.mashups.space.hidden": "com.ibm.mashups.space.hidden",
			xhrTunneling:<%=configService.getString(com.ibm.mm.ConfigConstants.TUNNEL_MODE,"false")%>,
			loadServices:false,
			availableLocales:"<%=configService.getString( com.ibm.mm.ConfigConstants.AVAILABLE_LOCALES, "de,en,es,fr,it,he,ja,ko,pt-br,zh,zh-tw,ROOT")%>",
			<% // dynamic values, cannot be moved to ConfigService %>
			sessionId: "<%=request.getRequestedSessionId()%>",
			hubURL: "<%=hubUrl%>",
			locale:"<%=currentLocale%>",
			fontSizeEnlarged:<%=needEnlargeFont%>,
			mappingFunction: null,
			extensions: [],
            anonymousUser: <%=request.getUserPrincipal() == null%>,
			namespaces: {
				base: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base",
				model: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
				ext: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/extensions",
				opensearch: "http://a9.com/-/spec/opensearch/1.1/"
			}
		};
		ibmConfig.user="admin";
		ibmConfig.livetextService = [ {"match":"*.iWidgetSkin[skin]","processEnclosedTags":true,'waitOnPreTag':true, "module":"tagservices", "path":ibmConfig["com.ibm.mashups.contextroot"]+"/js/com/ibm/mm/livetext", "baseClass":"tagservices.skins"}, {"match":"*.mm_iWidget","processEnclosedTags":false,'waitOnPreTag':false, "module":"tagservices", "path":ibmConfig["com.ibm.mashups.contextroot"]+"/js/com/ibm/mm/livetext", "baseClass":"tagservices.widgets"}];

		djConfig={
            isDebug:ibmConfig.isDebug,
            popupConsole:ibmConfig.popupConsole,
            locale:"<%=currentLocale%>"
        };
	</script>

	<title>Lotus Mashups Demo [<%=htmlPage %>]</title>
	<link rel="shortcut icon" href="<%=builderContext%>/images/favicon.ico" type="image/x-icon">
	<link rel="icon" href="<%=builderContext%>/images/favicon.ico" type="image/x-icon">	

<link rel="stylesheet" href="<%=enablerContext%>/js/bluedojo/dijit/themes/tundra/tundra.css" type="text/css">
<script type="text/javascript" src='<%=enablerContext%>/js/bluedojo/dojo/dojo.js'></script>

<script type="text/javascript" src="<%=enablerContext%>/js/openajaxhub/OpenAjaxManagedHub-all.js"></script>

<script language="JavaScript" type="text/javascript">
    dojo.registerModulePath("com.ibm.mm.enabler","<%=enablerContext%>/js/com/ibm/mm/enabler");
    dojo.registerModulePath("com.ibm.mashups.enabler","<%=enablerContext%>/js/com/ibm/mashups/enabler");  
    dojo.registerModulePath("com.ibm.mm.data","<%=enablerContext%>/js/com/ibm/mm/data");
    dojo.registerModulePath("com.ibm.mashups.iwidget","<%=enablerContext%>/js/com/ibm/mashups/iwidget");
    dojo.registerModulePath("com.ibm.mm.iwidget","<%=enablerContext%>/js/com/ibm/mm/iwidget");
    dojo.registerModulePath("com.ibm.mashups.services","<%=enablerContext%>/js/com/ibm/mashups/services");
    dojo.registerModulePath("com.ibm.mm.services","<%=enablerContext%>/js/com/ibm/mm/services");
</script>

<% if ("light".equals(framework)) { %>
<script type="text/javascript" src="<%=enablerContext%>/js/com/ibm/mm/enabler/enabler.core.js"></script>
<% } else { %>
<script type="text/javascript" src="<%=enablerContext%>/js/com/ibm/mm/enabler/enabler.js"></script>
<% } %>


<script type="text/javascript" >
dojo.registerModulePath("com.ibm.mashups.livetext","<%=enablerContext%>/js/com/ibm/mashups/livetext");
dojo.registerModulePath("com.ibm.mm.livetext","<%=enablerContext%>/js/com/ibm/mm/livetext");
dojo.require("com.ibm.mm.livetext.serviceImpl");
		var livetextService = new com.ibm.mm.livetext.serviceImpl();
		TagService = SemTagSvc = livetextService;
		dojo.addOnLoad(function(){
			livetextService.init();
		});		
</script>
<script type="text/javascript" >
		dojo.addOnLoad(function(){
		    com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
		});		
</script>

</head>
<body class="tundra">
<% try {
    pageContext.include(htmlPage);
  } catch (Exception e) {
      response.sendError(500, "The specified demo isn't available");
 } %>
</body>
</html>
