/* (C) Copyright IBM Corp. 2007  All Rights Reserved.                */
dojo.require("com.ibm.mm.enabler.debug");
dojo.declare("resourceTest",null,{

	onLoad: function () {
        this.exportUrlInput = this.iContext.getElementById("exportUrlInput");
        this.exportUrlSelect = this.iContext.getElementById("exportUrlSelect");
        this.importUrlInput = this.iContext.getElementById("importUrlInput");
        this.importUrlSelect = this.iContext.getElementById("importUrlSelect");
        this.resourceFeedInput = this.iContext.getElementById("resourceFeedInput");
        this.importResponseInput = this.iContext.getElementById("importResponseInput");
    },
    
    onExportUrlSelected: function (selectedValue) {
        this.exportUrlInput.value = selectedValue;
    },

    onImportUrlSelected: function (selectedValue) {
        this.importUrlInput.value = selectedValue;
    },

    exportPressed: function () {
        var myUrl = this.exportUrlInput.value;
        var me = this;
        dojo.xhrGet({
            url: myUrl,
            load: function( data, ioArgs ) {
                me.resourceFeedInput.value = data;
                return data;
            },
            error: function(data, ioArgs) {
                me.resourceFeedInput.value = "Data: " + data + "\nStatus: " + ioArgs.xhr.status + "\nStatus Text: " + ioArgs.xhr.statusText + "\nResponse Text:\n" + ioArgs.xhr.responseText;
                return data;
            },
            sync: false,
            handleAs: "text"
        });
    },
    
    importPressed: function () {
        var myUrl = this.importUrlInput.value;
        var me = this;
        dojo.rawXhrPost({
            headers: {"Content-Type":"text/xml"},
            url: myUrl,
            load: function(data, ioArgs ) {
                me.importResponseInput.value = data;
                return data;
            },
            error: function(data, ioArgs) {
                me.importResponseInput.value = "Data: " + data + "\nStatus: " + ioArgs.xhr.status + "\nStatus Text: " + ioArgs.xhr.statusText + "\nResponse Text:\n" + ioArgs.xhr.responseText;
                return data;
            },
            sync: false,
            postData: me.resourceFeedInput.value,
            handleAs: "text"
        })
    }
});
