<%--
****************************************************************
IMPORTANT NOTICE
Please be careful when modifying this file as stack products such as bspace and portal depend on it.
- You ARE allowed to add server specific java code into this file as stack products such as portal overwrite this file
  However any variable that is set here an being used outside of this file needs to be send to the stack products.
  In such a case notify all stack products as well as Stephan Hesmer/Germany/IBM and Kris Vishwanathan/Fairfax/IBM
****************************************************************
--%>

<%
// get config service so that we can add all the configuration values into ibmConfig
final com.ibm.mm.framework.services.IConfigService configService = com.ibm.mm.framework.Platform.getInstance().getConfigService();
final com.ibm.mm.framework.services.IBlobConfigService blobConfigService = (com.ibm.mm.framework.services.IBlobConfigService)com.ibm.mm.framework.Platform.getInstance().getPlatformService(com.ibm.mm.framework.services.IBlobConfigService.SERVICE_ID);

final String isDebug	    		= configService.getString(com.ibm.mm.ConfigConstants.CLIENT_IS_DEBUG);
final String builderContext			= configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_BUILDER);
String enablerContext 				= configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MAIN, "/mum");
// first let's see if we have a mymashups available, then fallback to root, and finally fallback to /mum
final String mymashupsEnablerContext= configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MYMASHUPS, enablerContext);
    
// look for the servlet path
final String servletPathHome 		= configService.getString(com.ibm.mm.ConfigConstants.SERVLET_PATH_MASHUPS_HOME, "/enabler");

/* unused? */
final String publicHome 			= mymashupsEnablerContext+servletPathHome;

/* deprecated? */
final String hubUrl 				= "/mashuphub";

/* used in bootstrap.jsp */
final String productName 			= configService.getString(com.ibm.mm.ConfigConstants.PRODUCT_NAME);

final String debugAtAllCosts		= configService.getString(com.ibm.mm.ConfigConstants.CLIENT_DOJO_DEBUG_AT_ALL_COSTS);

final String availableLocales 		= join(configService.getStrings(com.ibm.mm.ConfigConstants.AVAILABLE_LOCALES),",");

final String currentLocale			= getCurrentLocale(request.getLocale().toString(),availableLocales);
final String displayLocale			= request.getLocale().toString();
	
final boolean needEnlargeFont 		= needEnlargedFont(currentLocale);

final String isBidi 				= isBidi(currentLocale);

final String livetxtCfg 			= blobConfigService.getString("tagservice.entries.cfg");

// get any common js uris from configuration service.
final String[] common_js = configService.getStrings(com.ibm.mm.ConfigConstants.COMMON_JS);

final String user = getUser(request);

%>


<script language="JavaScript" type="text/javascript">
	ibmConfig = {
<%
	final java.util.Iterator<String> configNames = configService.clientNames();
	while (configNames.hasNext()) {
	    final String name = configNames.next();
	    final Boolean tryBoolFirst = configService.getBoolean(name);
        if (null == tryBoolFirst) {
           continue;
        }
        final boolean boolVal = tryBoolFirst.booleanValue();
        if (boolVal) {
%>
            "<%=name%>": <%=boolVal%>,
<%          
        } else {
           // see if it is really false     
           final String value = configService.getString(name);
           
           if ("false".equalsIgnoreCase(value) || "no".equalsIgnoreCase(value)) {
%>
            "<%=name%>": false,
<%
           } else {//try string array
               final String[] valueArray = configService.getStrings(name);
               if (valueArray != null && valueArray.length != 1){
            	   if (name.equals(com.ibm.mm.ConfigConstants.AVAILABLE_LOCALES)) continue;
%>
            "<%=name%>": <%=toJson(valueArray)%>,
<%          
               } else if(value != null){
%>
            "<%=name%>": "<%=value.toString()%>",
<%          
               }
           }
       }   
   }
	
%>
			contextRootEnabler: 				 	"<%=mymashupsEnablerContext%>",
			contextRootBuilder: 				 	"<%=builderContext%>",
            "com.ibm.mashups.navigation.hidden":	"com.ibm.mashups.navigation.hidden",
            "com.ibm.mashups.space.hidden": 		"com.ibm.mashups.space.hidden",
			availableLocales:						"<%=availableLocales%>",
<% 			
			// dynamic values, cannot be moved to ConfigService
%>
			sessionId: 								"<%=request.getRequestedSessionId()%>",
			hubURL: 								"<%=hubUrl%>",
			locale:									"<%=currentLocale%>",
			displayLocale:							"<%=displayLocale%>",
			fontSizeEnlarged:						<%=needEnlargeFont%>,
			mappingFunction: 						null,
			extensions: 							[],
            servicedocument: 						'<%com.ibm.mm.framework.rest.next.utils.Helper.writeServiceResponse("service:collection", out, request, response);%>',
            servicedocument_version_max:			"2.0",
            anonymousUser: 							<%=(user==null)%>,
			securityOff: 							<%=!com.ibm.mm.framework.Platform.getInstance().isSecurityEnabled()%>,
			user:									"<%= user%>",
            isBidi: 								<%=isBidi%>,
            "com.ibm.mashups.builder.filter.title.regexp" : '[@\\\\/:*?\"<>|]+'
		};
		
<%
	if (livetxtCfg != null) {
%>		
	ibmConfig.livetextService = <%= livetxtCfg %>;
<%
	}
%>
	djConfig = {
           isDebug: ibmConfig.isDebug,
           debugAtAllCosts: <%=debugAtAllCosts%>,
           popup:   ibmConfig.popupConsole,
           locale:  "<%=currentLocale%>"
	};
</script>