<%!
public static String join(final String[] arr, final String delim) {
	if(arr.length == 0) {
		return "";
	}
	
	final StringBuilder b = new StringBuilder(arr[0]);
	for (int i = 1; i < arr.length; i++) {
		b.append(delim).append(arr[i]);
	}
	return b.toString();
}

public static String toJson(final String[] arr) {
	final StringBuilder b = new StringBuilder("[");
	if(arr.length > 0) {
		b.append("\"").append(join(arr,"\",\"")).append("\"");
	}
	b.append("]");
	return b.toString();
}

public static String getUser(final HttpServletRequest request) {
	String user = null;
	if (request.getUserPrincipal() != null) {
	    user = request.getUserPrincipal().getName();
	}
	if (!com.ibm.mm.framework.Platform.getInstance().isSecurityEnabled()) { 
	    final String cookieName = com.ibm.mm.framework.rest.next.servlet.Constants.SECURITY_OFF_COOKIE_NAME;//"valid_user";
	    final javax.servlet.http.Cookie cookies [] = request.getCookies();
	    if (cookies != null) {
	        for (int i = 0; i < cookies.length; i++) {
	           if (cookies[i].getName().equals(cookieName)) {
	                user = cookies[i].getValue();
	                if (user.equals(com.ibm.mm.framework.rest.next.servlet.Constants.ANONYMOUS_USER_NAME/*"anonymous"*/)) user = null;
	                break;
	            }
	        }
	    }
	}
	return user;
}

public static String isBidi(final String locale) {
	//determine if this is a bidi language
	return java.awt.ComponentOrientation.RIGHT_TO_LEFT.equals(java.awt.ComponentOrientation.getOrientation(new java.util.Locale(locale))) ? "1" : "0";
}

public static boolean needEnlargedFont(final String locale) {
	final String[] enlargeLocalePrefixes = com.ibm.mm.framework.Platform.getInstance().getConfigService().getStrings(com.ibm.mm.ConfigConstants.ENLARGE_LOCALE_PREFIXES);
		
	for(final String prefix : enlargeLocalePrefixes) {
		if(locale.startsWith(prefix)) {
			return true;
		}
	}
	return false;
}

public static String getCurrentLocale(String requestLocale, final String availableLocales) {
	
	final com.ibm.mm.framework.services.IConfigService configService = com.ibm.mm.framework.Platform.getInstance().getConfigService();
	
	final String systemDefaultLocaleFallback = configService.getString(com.ibm.mm.ConfigConstants.DEFAULT_LOCALE_FALLBACK);
	
	String systemDefaultLocale = configService.getString(com.ibm.mm.ConfigConstants.DEFAULT_LOCALE);

	com.ibm.icu.util.ULocale systemDefaultULocale = null;
	if (systemDefaultLocale == null || "".equals(systemDefaultLocale)) {
	    systemDefaultLocale = systemDefaultLocaleFallback;
	    systemDefaultULocale = new com.ibm.icu.util.ULocale(systemDefaultLocale);
	} else {
	    try {
	        systemDefaultULocale = new com.ibm.icu.util.ULocale(systemDefaultLocale);
	        systemDefaultLocale = systemDefaultULocale.getBaseName();
	    } catch (Exception ex) {
	        systemDefaultLocale = systemDefaultLocaleFallback;
	        systemDefaultULocale = new com.ibm.icu.util.ULocale(systemDefaultLocale);
	    }
	}

	// he is the new iw ;-)
	if(requestLocale.startsWith("iw")) {
		requestLocale = "he"+requestLocale.substring(2);
	}
	com.ibm.icu.util.ULocale currentULocale = new com.ibm.icu.util.ULocale(requestLocale);
	String normalizedULocaleBaseName;
	String currentLocale;
	while (true) {
	   normalizedULocaleBaseName = currentULocale.getBaseName().replace('_','-').toLowerCase();

	   //the locale is supported.
	   if (availableLocales.indexOf(normalizedULocaleBaseName) >= 0) {
		   currentLocale = normalizedULocaleBaseName;
		   break;
	   }
	   else {
			//no more fallbacks, we will have to fall back to the system default locale.
			if (normalizedULocaleBaseName.length() <= 2) {
				currentULocale = systemDefaultULocale;
				currentLocale = systemDefaultLocale;
				break;
			}
	   }
	   currentULocale = currentULocale.getFallback();
	}
	return currentLocale;
}
%>