<%@include file="include/bootfuncs.jsp" %>
<%
    final com.ibm.mm.framework.services.IConfigService configService = com.ibm.mm.framework.Platform.getInstance().getConfigService();

    // first let's see if we have a mymashups available, then fallback to root, and finally fallback to /mum
    String enablerContext = configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MYMASHUPS, configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MAIN, "/mum"));
       
    final String realEnablerContext = configService.getString(com.ibm.mm.ConfigConstants.CONTEXT_ROOT_MAIN, "/mum");
    
    // look for the servlet path
    final String servletPathHome = configService.getString(com.ibm.mm.ConfigConstants.SERVLET_PATH_MASHUPS_HOME, "/enabler");
    
    final String publicHome = enablerContext+servletPathHome;
    
    final String privateContentHandler = configService.getString(com.ibm.mm.ConfigConstants.CONTENTHANDLER_PRIVATE,"/mycontenthandler");

    final boolean isErrorScreen = request.getParameter("fail") != null;
    
    final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("resources.bootstrap",request.getLocale());
    
    final String availableLocales 		= join(configService.getStrings(com.ibm.mm.ConfigConstants.AVAILABLE_LOCALES),",");

    final String currentLocale			= getCurrentLocale(request.getLocale().toString(),availableLocales);
    
    final String isBidi 				= isBidi(currentLocale);
    
    final String isDebug	    		= configService.getString(com.ibm.mm.ConfigConstants.CLIENT_IS_DEBUG);    
    
    final String rtlClass = "1".equals(isBidi) ? "mumrtl" : "";
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="en">
<head>
    <title><%=configService.getString(com.ibm.mm.ConfigConstants.PRODUCT_NAME)%></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <%@include file="include/share.js.jsp" %>
    <link rel="shortcut icon" href="/mum/images/favicon.ico" type="image/x-icon"/>
    <link rel="icon" href="/mum/images/favicon.ico" type="image/x-icon"/>
    <link rel="stylesheet" href="/mum/_combined.css" type="text/css"/>
    
    <script language="JavaScript" type="text/javascript">
	
	function adjustToFrame() {
        try {
            var myLocation = document.location + "";
            
            // check if login is shown in the embedding usecase
            if (window.parent.length >= 1) {
                // search for height & width:
                var pos1;
                var pos2;
                
                pos1 = myLocation.indexOf("&sb=");
                if (pos1 > -1) {
                    pos1 += 4;
                    pos2 = myLocation.indexOf("&", pos1);
                    
                    var scrollbarEnabled;
                    
                    if (pos2 > -1)
                        scrollbarEnabled = myLocation.substring(pos1, pos2);
                    else
                        scrollbarEnabled = myLocation.substring(pos1);
                        
                    
                    if (scrollbarEnabled == "yes")
                        return;
                }
                
                var myHeight = 0;
                
                pos1 = myLocation.indexOf("&h=");
                
                if (pos1 >-1) {
                    pos1 += 3;
                    pos2 = myLocation.indexOf("&", pos1);
                    if (pos2 > -1)
                        myHeight = myLocation.substring(pos1, pos2);
                    else
                        myHeight = myLocation.substring(pos1);
                }
                
                var myWidth = 0;
                
                pos1 = myLocation.indexOf("&w=");
                
                if (pos1 >-1) {
                    pos1 += 3;
                    pos2 = myLocation.indexOf("&", pos1);

                    if (pos2 > -1)
                        myWidth = myLocation.substring(pos1, pos2);
                    else
                        myWidth = myLocation.substring(pos1);
                }
                
                
                if (myWidth > 0 && myHeight >0) {
                    var contentDiv = document.getElementById("contentDiv");
                    contentDiv.style.width=myWidth + "px";
                    contentDiv.style.height=myHeight + "px";
                    contentDiv.style.overflow="auto";
                    
                    contentDiv = document.getElementById("innerContentDiv");
                    contentDiv.style.width=parseInt(myWidth)+1 + "px";
                    contentDiv.style.height=parseInt(myHeight)+1 + "px";
                }
            }
        } catch (e) {
        }
    }
	
    window.onload = function() {
        adjustToFrame()
    }
    </script>
    <script type="text/javascript">
        djConfig={
            locale:"<%=currentLocale%>"
        };
    </script>
    <%
    	final String _enablerContext = enablerContext;
    	enablerContext = realEnablerContext;
    %>
    <%@include file="include/dojo.jsp" %>
    <%
    	enablerContext = _enablerContext;
    %>
    
    <script type="text/javascript">
        dojo.require("dijit._base.sniff");
        dojo.require("dijit._base.wai");
        
        dojo.addOnLoad(function() {
			dojo.attr(dojo.doc.documentElement,"lang",dojo.locale);
	        if (dojo.isSafari >= 4 && dojo.isSafari < 5) {
				dojo.addClass(dojo.doc.documentElement,"dj_safari4");
			}		
		});
    </script>