/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mm.widget.dataViewer._WB_VER_.widget.ColorPalette");

dojo.require('dijit.ColorPalette');	

dojo.declare("com.ibm.mm.widget.dataViewer._WB_VER_.widget.ColorPalette", dijit.ColorPalette, {
	// palette: String
	//		Size of grid, either "7x10" or "3x4".
	palette: "8x16",

	// _palettes: Map
	// 		This represents the value of the colors.
	//		The first level is a hashmap of the different arrays available
	//		The next two dimensions represent the columns and rows of colors.
	_palettes: {
		"8x16": [
			["#FFFFFF", "#DDDDDD", "#BBBBBB", "#999999", "#666666", "#444444", "#222222", "#000000"],
			["#FFEEEE", "#FFFFDD", "#FFFFEE", "#EEFFEE", "#EEFFFF", "#EEEEFF", "#FFEEFF", "#FFEEFF"],
			["#FFCCCC", "#FFFFBB", "#FFFFCC", "#CCFFCC", "#CCFFFF", "#CCCCFF", "#FFCCFF", "#FFCCFF"],
			["#FFAAAA", "#FFEE99", "#FFFFAA", "#AAFFAA", "#AAFFFF", "#AAAAFF", "#EEAAFF", "#FFAAFF"],
			["#FF8888", "#FFDD88", "#FFFF88", "#88FF88", "#88FFFF", "#8888FF", "#DD88FF", "#FF88FF"],
			["#FF6666", "#FFCC66", "#FFFF66", "#66FF66", "#66FFFF", "#6666FF", "#CC66FF", "#FF66FF"],
			["#FF4444", "#FFBB44", "#FFFF44", "#44FF44", "#44FFFF", "#4444FF", "#BB44FF", "#FF44FF"],
			["#FF2222", "#FFAA22", "#FFFF22", "#22FF22", "#22FFFF", "#2222FF", "#AA22FF", "#FF22FF"],
			["#FF0000", "#FF9900", "#FFFF00", "#00FF00", "#00FFFF", "#0000FF", "#9900FF", "#FF00FF"],
			["#DD0000", "#DD8800", "#DDDD00", "#00DD00", "#00DDDD", "#0000DD", "#8800DD", "#DD00DD"],
			["#BB0000", "#BB7700", "#BBBB00", "#00BB00", "#00BBBB", "#0000BB", "#7700BB", "#BB00BB"],
			["#990000", "#996600", "#999900", "#009900", "#009999", "#000099", "#660099", "#990099"],
			["#770000", "#774400", "#777700", "#007700", "#007777", "#000077", "#550077", "#770077"],
			["#550000", "#553300", "#555500", "#005500", "#005555", "#000055", "#440055", "#550055"],
			["#330000", "#332200", "#333300", "#003300", "#003333", "#000033", "#330033", "#330033"],
			["#110000", "#111100", "#111100", "#001100", "#001111", "#000011", "#220011", "#110011"]
		]
	},

	_name: {
		"8x16": [
			["White", "Fog", "Silver", "Dark Gray", "Dim Gray", "Charcoal", "Soot", "Black"],
			["Lavender Blush", "Light Yellow", "Ivory", "Pale Jade", "Azure", "Mist", "Pale Lavender", "Pale Lavender"],
			["Pink", "Cornsilk", "Lemon Chiffon", "Mint", "Overcast Blue", "Slate Blue", "Light Violet", "Light Violet"],
			["Light Pink", "Moccasin", "Cream", "Pale Green", "Pale Turquoise", "Light Cornflower", "Violet", "Bubblegum"],
			["Light Coral", "Apricot", "Butter", "Light Green", "Light Sky Blue", "Sky Blue", "Plum", "Cherry Blossom"],
			["Salmon", "Peach", "Banana", "Spearmint", "Swimming Pool Blue", "Blue Flower", "Lilac", "Light Magenta"],
			["Tomato", "Orange", "Yellow Corn", "Florescent Green", "Blue Taffy", "Royal Blue", "Wisteria", "Pink Lemonade"],
			["Scarlet", "Dark Orange", "Canary", "Lawn Green", "Electric Blue", "Lapis Lazuli", "Heliotrope", "Cezanne Rose"],
			["Red", "Tangerine", "Yellow", "Lime", "Cyan", "Blue", "Plasma", "Magenta"],
			["Venetian Red", "Cappuccino", "Pistachio", "Emerald", "Turquoise", "Medium Blue", "Amethyst", "Mulberry"],
			["Fire Brick", "Dark Goldenrod", "Khaki Green", "Grass green", "Dark Turquoise", "Sapphire", "Iris", "Dark Fuchsia"],
			["Dark Red", "Sienna", "Scuppernong", "Apple", "Dark Cyan", "Dark Blue", "Delphinium", "Hyacinth"],
			["Maroon", "Saddle Brown", "Olive", "Green", "Teal", "Navy", "Grape", "Purple"],
			["Burgundy", "Raw Umber", "Hazel", "Dark Green", "Deep Sea Green", "Midnight Blue", "Morning Glory", "Cranberry-Grape Juice"],
			["Mahogany", "Bistre", "Avocado Peel", "Forest Green", "Dark Teal", "Ultramarine", "Acai", "Acai"],
			["Ruby Black", "Dark Brown", "Onyx", "Black Forest", "Deep Sea", "Blackberry", "Blackberry Cobbler", "Blackcurrant"]
		]
	},
	// _imagePaths: Map
	//		Path to the palette images
	_imagePaths: {
		// #11662: Lazyload image path to support custom context root
		"8x16": ""//dojo.moduleUrl("com.ibm.mm.widget.dataViewer._WB_VER_", "widget/templates/images/color_palette.png")
	},

	// templatePath: String
	//		Path to the template of this widget.
	templateString: "<div class=\"dijitInline dijitColorPalette\">\n\t<div class=\"dijitColorPaletteInner\" dojoAttachPoint=\"divNode\" waiRole=\"grid\" tabIndex=\"-1\">\n\t\t<img alt=\"color palette\" class=\"dijitColorPaletteUnder\" dojoAttachPoint=\"imageNode\" waiRole=\"presentation\" />\n\t</div>\t\n</div>\n",

	// _paletteDims: Object
	//		Size of the supported palettes for alignment purposes.
	_paletteDims: {
		"8x16": {"width": "166px", "height": "326px"}
	},
	
	triggerInput: null,
	
	_focusFirstImg:function(){
		this._cellNodes[0].childNodes[0].focus();//focus on the first image input after color picker popup
	},
	
	postCreate: function(){
		// A name has to be given to the colorMap, this needs to be unique per Palette.
		dojo.mixin(this.divNode.style, this._paletteDims[this.palette]);
		// #11662: Lazyload image path to support custom context root
		this.imageNode.setAttribute("src", dojo.moduleUrl("com.ibm.mm.widget.dataViewer._WB_VER_", "widget/templates/images/color_palette.png"));
		//this.imageNode.setAttribute("src", this._imagePaths[this.palette]);
		var choices = this._palettes[this.palette];	
		var colorNames = this._name[this.palette];
		this.domNode.style.position = "relative";
		this._cellNodes = [];
		var url= dojo.moduleUrl("dojo", "resources/blank.gif");
	    var colorObject = new dojo.Color();
	    var coords = this._paletteCoords;
		
		for(var row=0; row < choices.length; row++){
			for(var col=0; col < choices[row].length; col++) {
                var imgNode;
                imgNode = dojo.create("input");
                imgNode.type = "image";
				
                dojo.addClass(imgNode, "dijitPaletteImg");
                var color = choices[row][col],
                        colorValue = color; //colorObject.setColor(dojo.Color.named[color]);
                imgNode.color = colorValue;//.toHex();
                imgNode.src = url;
                var red = parseInt("0x" + color.substr(1, 2), 16);
                var green = parseInt("0x" + color.substr(3, 2), 16);
                var blue = parseInt("0x" + color.substr(5, 2), 16);
				imgNode.title = imgNode.alt = dojo.string.substitute(com.ibm.mm.widget.dataViewer._WB_VER_.dataViewerMessages.L_COLOR_PICKER_COLOR_TITLE, [red, green, blue]);
                
                dojo.style(imgNode,"border-color",colorValue);
                dojo.style(imgNode,"border-width",0);
                dojo.attr(imgNode,"value",colorValue);
                
                var imgStyle = imgNode.style;
                imgStyle.color = imgStyle.backgroundColor = imgNode.color;
				var cellNode = dojo.create("span");
				cellNode.appendChild(imgNode);
				
                dojo.forEach(["Dijitclick", "MouseEnter", "Blur", "Focus", "KeyDown"], function(handler) {
                    this.connect(cellNode.childNodes[0], "on" + handler.toLowerCase(), "_onCell" + handler);
                }, this);
                
                this.divNode.appendChild(cellNode);
				var cellStyle = cellNode.style;
                cellStyle.top = coords.topOffset + (row * coords.cHeight) + "px";
                cellStyle.left = coords.leftOffset + (col * coords.cWidth) + "px";
				dojo.attr(cellNode.childNodes[0], "tabIndex", "-1");
				
				dojo.addClass(cellNode, "dijitPaletteCell");
				dijit.setWaiRole(cellNode, "gridcell");
                cellNode.index = this._cellNodes.length;
                cellNode.childNodes[0].index = this._cellNodes.length;
                this._cellNodes.push(cellNode);
            }
		}
		this._cellNodes[this._currentFocus].tabIndex = 0;
		this._xDim = choices[0].length;
		this._yDim = choices.length;
		
		this.connect(this.divNode, "onUnload", "_setTriggerInputFocus");
        this.connect(this.divNode, "onfocus", "_onDivNodeFocus");
        this.connect(this.divNode, "onblur", "onBlur");
        
		// Now set all events
		// The palette itself is navigated to with the tab key on the keyboard
		// Keyboard navigation within the Palette is with the arrow keys
		// Spacebar selects the color.
		// For the up key the index is changed by negative the x dimension.
		
		var keyIncrementMap = {
			UP_ARROW: -this._xDim,
			// The down key the index is increase by the x dimension.
			DOWN_ARROW: this._xDim,
			// Right and left move the index by 1.
			RIGHT_ARROW: 1,
			LEFT_ARROW: -1
		};
		for(var key in keyIncrementMap){
			this._connects.push(dijit.typematic.addKeyListener(this.domNode,
				{keyCode:dojo.keys[key], ctrlKey:false, altKey:false, shiftKey:false},
				this,
				function(){
					var increment = keyIncrementMap[key];
					return function(count){ this._navigateByKey(increment, count); };
				}(),
				this.timeoutChangeRate, this.defaultTimeout));
		}
		
		this.focus();
	},
	
	/**
	 * @Override
	 * Called when the widget stops being "active" because focus moved to something outside of it, or the user clicked somewhere outside of it, or the widget was hidden.
	 * @param {Object} event
	 */
	onBlur: function(event) {
		event = dojo.fixEvent(event);
		this.onChange();
		dojo.stopEvent(event);
	},
	
	_onCellKeyDown: function(event) {
        event = dojo.fixEvent(event);
        if (event.keyCode === dojo.keys.ESCAPE){
            dojo.stopEvent(event);
            this.onChange();
			return false;
        }
	},
	
	_navigateByKey: function(increment, typeCount){
		// summary:
		// 	  	This is the callback for typematic.
		// 		It changes the focus and the highlighed color.
		// increment:
		// 		How much the key is navigated.
		// typeCount:
		//		How many times typematic has fired.

		// typecount == -1 means the key is released.
		if(typeCount == -1){ return; }
		
		var newFocusIndex = this._currentFocus + increment;
		if(newFocusIndex < this._cellNodes.length && newFocusIndex > -1)
		{
			var focusNode = this._cellNodes[newFocusIndex];
			focusNode.childNodes[0].focus();
			this._currentFocus = newFocusIndex;
		}
	},
	
	_selectColor:function(selectNode){
		var img=selectNode;
		var imgValue = this.value = img.value;
		this.onChange(imgValue);
	},
	
	_setTriggerInput: function(inObj){
		this.triggerInput = inObj;
	},
	
	_setTriggerInputFocus: function(){
		this.triggerInput && this.triggerInput.focus();
	},
	
	_onCellDijitclick: function(/*Event*/ evt){
		// summary:
		//		Handler for click, enter key & space key. Selects the color.
		// evt:
		//		The event.
		evt = dojo.fixEvent(evt);
		var target = evt.currentTarget;
		if (this._currentFocus != target.index){
			this._currentFocus = target.index;
			window.setTimeout(function(){dijit.focus(target)}, 0);
		}
		this._selectColor(target);
		dojo.stopEvent(evt);
		this.triggerInput.focus();//focus the input which popup the color picker
	},
	
	_removeCellHighlight: function(index){
		dojo.removeClass(this._cellNodes[index].childNodes[0], "dijitPaletteCellHighlight");
	},
	
	_onBlur:function(){
		dojo.style(this.domNode.parentNode, "display", "none");	
	},
	
	onChange: function(color){
		this.indicator && dojo.style(this.indicator, "backgroundColor", color);
		this.inputId && (dojo.byId(this.inputId).value = color);
		this._onBlur();
		dojo.publish("ColorChanged",[this.indicator]);		
	}
});
