dojo.provide("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ContentSelectionPage");

dojo.require("dojox.uuid.generateTimeBasedUuid");

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ContentSelectionPage", [com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ChangeWatchingPage,dijit._Widget, dijit._Templated], {
	 templateString : 
		"<div class='dataviewer'>" +
			"<div role='presentation' class='content'>" + 
				"<div class='wizard_page_header'>${I_WIZARD_DATAVIEWER_TITLE}</div>" +
				"<hr class='wizard_page_separator'/>" + 
		        "<div >"+
		            "<label for='${domIdPrefix}_rowsPerPage'>${L_CONF_ROWSPERVIEW}</label>"+
		        "</div>"+
				"<div>"+
		            "<select size='1' style='width: 15em;margin-top:5px;' name='rowsPerPage' id='${domIdPrefix}_rowsPerPage'>" +
		                "<option value='5' selected='selected'>5</option>"+
		                "<option value='10'>10</option>"+
		                "<option value='15'>15</option>"+
		                "<option value='20'>20</option>"+
		                "<option value='30'>30</option>"+
		            "</select>" +
				"</div>" +
		        "<div style='margin-top:10px;'>"+
				    "<input type='checkbox' class='autoWidth' name='showHeader' id='${domIdPrefix}_showHeader'>"+
					"<label for='${domIdPrefix}_showHeader'>${L_CONF_SHOWHEADER}</label>"+
		        "</div>"+
		        "<div class='sectionColumn'>"+
		            "<label>${L_CONF_COLUMNS}</label>"+
		            "<div id='${domIdPrefix}_ColumnTableContainer'>"+
		                "<div id='${domIdPrefix}_ColumnTable'></div>"+
		            "</div>"+
				"</div>" +
		"</div>" +
	"</div>",
	
	contants : com.ibm.mm.builder.iwidget.widgetbuilder.WBuilderConstants,
	
	getName : function() {
		return this.I_WIZARD_CONTETN_SELECTION;
	},
	
	getSequence : function(){
		return 2;
	},
	
	byId : function(id){
		return dojo.isString(id) ? dojo.byId(this.domIdPrefix + "_" + id) : id;
	},
	
	getQueryScopeNode : function() {
		return this.domNode;
	},
	
	getWatchedControls : function() {
		return [
			{queryString : "#" + this.domIdPrefix + "_rowsPerPage"},
			{queryString : "input[type='checkbox']", getValue : function() {
				return this.checked;
			}},
			{queryString : "input[type='text']"}
		];
	},
	
	postMixInProperties : function() {
	   this.applyNLS();
	   this.resourceBundle = com.ibm.mm.builder.iwidget.widgetbuilder.widgetBuilderMessages;
	   this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ContentSelectionPage");
	   this.domIdPrefix = dojox.uuid.generateTimeBasedUuid();
	},
	
	postCreate : function() {
		
	},
	
	updateValue : function() {
		this.notifyUpdatePreview();
		this._setInitValue();
	},
	
	loadFeedURL : function(feedURL){
//http://9.123.196.231:9080/mashuphub/client/plugin/generate/entryid/18/pluginid/3	
		if (!feedURL) {
			return;
		}	
		feedURL = iWidgetContainer.getAllWidgets().createNewWidget.iScope.iContext.io.rewriteURI(dojo.trim(feedURL));
		var self = this;
		this._dataSource = new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.remoteDataSource(feedURL, function(e){
			self.removeColumnTable();
			self.showErrorMessage(e, "editMessageBox");
		});
		this._dataSource.getData(function(data){
			self.restoreConfigView();
			var columnList = data.columnList;		
			var columns = self.prepareDataForColumnListWidget(columnList);
			try{
				dijit.registry.remove(self.domIdPrefix + "_ColumnTable");
				self.ColumnTable = new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ColumnsList({
					wid: self.domIdPrefix + "field"
				}, self.byId("ColumnTable"));
				self.ColumnTable.initialize(columns);
				self.ColumnTable.render();
				self._setupListeners();
			}catch(e){
				console.error(e);
				self.LOGGER.severe("loadFeedURL", self.resourceBundle.E_CREATE_COLUMN_TABLE);
			}
		});
		
	},
	
	removeColumnTable: function(){
		var ColumnTableContainer = this.byId("ColumnTableContainer");		
		
		if (this.ColumnTable){
			this.ColumnTable.destroy();
			this.ColumnTable = null;
			dijit.registry.remove(this.domIdPrefix + "_ColumnTable");

			dojo.empty(ColumnTableContainer);
			var columnTable = dojo.doc.createElement("div");
			columnTable.id = this.domIdPrefix+"_ColumnTable";
			ColumnTableContainer.appendChild(columnTable);
		}
	},
	/*Restore configuration view UI to default state*/
	restoreConfigView: function(){
    	this.removeColumnTable();
	},	
	/*
	 * This method supports table column display order/filter/alignment
	 */
	prepareDataForColumnListWidget: function(columnList){
		if (columnList.length <= 0){
			throw(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.NoContentException(this.resourceBundle.E_NO_CONTENT));
		}

		var columns = [];
		for (var i = 0; i < columnList.length; i++) {
			var name = columnList[i];
			//add label and sorttype to column datatype
			var column = {
				'name': name,
				'align': 'left',	// default
				'checked': true,	// default
				'index': i,
				'label': name,
				'sorttype':'String'				
			};
			columns.push(column);
		}
		return columns;
	},
	
	_setInitValue : function(){
		var framework = com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework;
		var rowsPerView = framework.getItemValue("rowsPerView");
		var showHeader = framework.getItemValue("showHeader");
		var columnsStr = framework.getItemValue("columns");
		
		this.byId("rowsPerPage").value = parseInt(rowsPerView, 10);
		var showHeaderCheckBox = this.byId("showHeader");
		if (showHeader === "true") 
			showHeaderCheckBox.checked = true;
		else showHeaderCheckBox.checked = false;

		var columns = {};
		if (columnsStr && columnsStr !== "null") {
			try{
				columns = dojo.fromJson(columnsStr);
				this.removeColumnTable();							
				this.ColumnTable = new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ColumnsList({
					wid: this.domIdPrefix + "field"
				}, this.byId("ColumnTable"));				
				this.ColumnTable.setSettings(columns);
				this.ColumnTable.render();
				this._setupListeners();
			}catch(e1){
				this.LOGGER.severe("onedit", this.resourceBundle.E_ITEMSET_COLUMNS_BROKEN);
			}
		}else{
			var feedURL = framework.getItemValue("feedURL");
			this.loadFeedURL(feedURL);
		}
	},
	
	updateDefinition : function(){
		var itemSetArray = [];
		var rowsPerPage = this.byId("rowsPerPage").value;
		itemSetArray.push(this._createItem("rowsPerView",rowsPerPage));
		var showHeader = "true";
       	if (this.byId("showHeader").checked) showHeader = "true";
		else showHeader = "false";
		itemSetArray.push(this._createItem("showHeader",showHeader));
		var columns = "";
		if (this.ColumnTable) {
			columns = this.ColumnTable.getSettings();
		}
		itemSetArray.push(this._createItem("columns",columns));
		var framework = com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework;
		framework.updateItemSet(itemSetArray);
	}
});

com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework.register(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ContentSelectionPage, {sequence : 1});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ColumnsList", [dijit._Widget, dijit._Templated], {
	
	wid: '',
	
	tableBody: null,
	
	templateString: "<div id='${wid}' class='columnList'><table role='presentation'><tbody dojoAttachPoint='tableBody'></tbody></table></div>",
	
	columns: [],		// columns should be put in oirginal order with index property
	
	_columnsMap: {},	// hashmap for random accessing columns
	
	resourceBundle: null,
	
	tdEventsList: null,
	
	postCreate: function() {
		this.widgetId = this.wid;
		this.contextRootBuilder = "/dataViewer";
	},
	
	destroy: function(){
		if (this.tdEventsList && dojo.isArray(this.tdEventsList)){
			for (var i = 0; i < this.tdEventsList.length; i++){
				if (this.tdEventsList[i] && dojo.isArray(this.tdEventsList[i])) dojo.forEach(this.tdEventsList[i], dojo.disconnect);				
			}
		}
		this.inherited(arguments);
	},
	
	initialize: function(/*array*/columns) {
		this.resourceBundle = com.ibm.mm.builder.iwidget.widgetbuilder.widgetBuilderMessages;
		if (dojo.isArray(columns)) {
			this.columns = columns;
		}
		for (var i = 0; i < this.columns.length; i++) {
			this._columnsMap[this.columns[i].name] = i;
		}
	},
	
	render: function() {
		dojo.empty(this.tableBody);
		if (!this.columns || this.columns.length == 0)
			return;
		
		var orderedColumns = new Array(this.columns.length);
		for (var i = 0; i < orderedColumns.length; i++) {
			orderedColumns[this.columns[i].index] = this.columns[i];
		}
		
		this.tdEventsList = [];
		for (var i = 0, length = orderedColumns.length; i < length; i++) {
			var tdEvents =  [];
			var column = orderedColumns[i];
            var ctr = dojo.doc.createElement('tr');
            
			var td1 = dojo.doc.createElement("td");
            ctr.appendChild(td1);
            var td2 = dojo.doc.createElement('td');
            dojo.addClass(td2, "columnName");
            ctr.appendChild(td2);
			var td3 = dojo.doc.createElement('td');	// text align buttons
            dojo.addClass(td3, "alignButtons");
			ctr.appendChild(td3);
			var td4 = dojo.doc.createElement('td');	// hidden input
			ctr.appendChild(td4);
			var td5 = dojo.doc.createElement('td');	// column order buttons
			dojo.addClass(td5, "orderButtons");
			ctr.appendChild(td5);
			var td6 = dojo.doc.createElement("td"); // sort type(String or Number)
			dojo.addClass(td6, "sortType");
            ctr.appendChild(td6);
			var td7 = dojo.doc.createElement("td"); // restore button
			dojo.addClass(td7, "restoreButtons");
            ctr.appendChild(td7);
			
			// TD1: checkbox for filtering columns
			var td1Html = "<input type='checkbox' class='autoWidth' id='" +this.widgetId + "COLUMN_" + i + "HEADER_CHECK' name='" + column.name + "' title='" + dojo.string.substitute(this.resourceBundle.L_CONF_SHOWCOLUMN_LABEL_1, [column.name]) + "'";
			td1Html += ((column.checked === true || column.checked === 'checked')?"checked='true'":"");
			td1Html += " >";
			td1Html += "<label for='" +this.widgetId + "COLUMN_" + i + "HEADER_CHECK' style='display:none'>" + dojo.string.substitute(this.resourceBundle.L_CONF_SHOWCOLUMN_LABEL_1, [column.name]) + "</label>";
            td1.innerHTML = td1Html;
			// events[0]
            tdEvents.push(dojo.connect(td1, "onclick", this, "onColumnCheckBoxClick"));
			
            // TD2: display label in td2
            var labelText = column.label || column.name;
            var td2Html = "<input type=\"text\" name=\"" + column.name + "_label\" title=\"" + this.resourceBundle.L_CONF_COLUMN_TITLE_RENAME_LABEL + " " + column.name + "\" value=\""+labelText+"\"/>";
            td2.innerHTML = td2Html;
			// events[1]
            tdEvents.push(dojo.connect(td2.firstChild, "onchange", this, "onColumnLabelChange"));
            
			// TD3: text align buttons
			var div_left = dojo.doc.createElement('div');
			var div_center = dojo.doc.createElement('div');
			var div_right = dojo.doc.createElement('div');
			
			td3.appendChild(div_left);
			td3.appendChild(div_center);
			td3.appendChild(div_right);
			
			// TD4: hidden input, store text align value
			column.align = (column.align) ? column.align : "left"
			td4.innerHTML = "<input type='hidden' id='" + this.wid + "align_col_" + escape(column.name) + "' value='" + column.align + "'/>";
			
			var leftHtml = "";
			if (column.align === "left") {
				leftHtml = "<input type='image' alt='" + dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_IS_SELECTED_1, [this.resourceBundle.L_LEFT]) + "' id='" + this.wid + "align_col_left_img_" + escape(column.name) + "' name='" + column.name + "' value='left' src='" + this.contextRootBuilder + "/images/align_left_selected.png' style='float:left;cursor:pointer;'/>";
			} else {
				leftHtml = "<input type='image' alt='" + dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_1, [this.resourceBundle.L_LEFT]) + "' id='" + this.wid + "align_col_left_img_" + escape(column.name) + "' name='" + column.name + "' value='left' src='" + this.contextRootBuilder + "/images/align_left.png' style='float:left;cursor:pointer;'/>";
			}
			div_left.innerHTML = leftHtml;
			
			var centerHtml = "";
			if (column.align === "center") {
				centerHtml = "<input type='image' alt='" + dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_IS_SELECTED_1, [this.resourceBundle.L_CENTER]) + "' id='" + this.wid + "align_col_center_img_" + escape(column.name) + "' name='" + column.name + "' value='center' src='" + this.contextRootBuilder + "/images/align_center_selected.png' style='float:left;cursor:pointer;'/>";
			} else {
				centerHtml = "<input type='image' alt='" + dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_1, [this.resourceBundle.L_CENTER]) + "' id='" + this.wid + "align_col_center_img_" + escape(column.name) + "' name='" + column.name + "' value='center' src='" + this.contextRootBuilder + "/images/align_center.png' style='float:left;cursor:pointer;'/>";
			}
			div_center.innerHTML = centerHtml;
			if (column.align === "right") {
				div_right.innerHTML = "<input type='image' alt='" + dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_IS_SELECTED_1, [this.resourceBundle.L_RIGHT]) + "' id='" + this.wid + "align_col_right_img_" + escape(column.name) + "' name='" + column.name + "' value='right' src='" + this.contextRootBuilder + "/images/align_right_selected.png' style='float:left;cursor:pointer;'/>";
			} else {
				div_right.innerHTML = "<input type='image' alt='" + dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_1, [this.resourceBundle.L_RIGHT]) + "' id='" + this.wid + "align_col_right_img_" + escape(column.name) + "' name='" + column.name + "' value='right' src='" + this.contextRootBuilder + "/images/align_right.png' style='float:left;cursor:pointer;'/>";
			}
			
			// events[2] - events[4]
			tdEvents.push(dojo.connect(div_left, "onclick", this, "onAlignButtonClick"));
			tdEvents.push(dojo.connect(div_center, "onclick", this, "onAlignButtonClick"));
			tdEvents.push(dojo.connect(div_right, "onclick", this, "onAlignButtonClick"));
			
			// TD5: column order buttons
			var div_up = dojo.doc.createElement('div');
			var div_down = dojo.doc.createElement('div');
			
			td5.appendChild(div_up);
			td5.appendChild(div_down);
			
			if (i <= 0) {
				div_up.innerHTML = "<input type='image' alt='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEUP_DISABLED + "' aria-label='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEUP_DISABLED + "' src='" + this.contextRootBuilder + "/images/up_disabled.png' style='float:left;cursor:not-allowed;'/>";
			} else {
				div_up.innerHTML = "<input type='image' alt='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEUP_ENABLED + "' aria-label='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEUP_ENABLED +"' value='" + i + "' src='" + this.contextRootBuilder + "/images/up.png' style='float:left;cursor:pointer;'/>";
				// events[5]
				tdEvents.push(dojo.connect(div_up, "onclick", this, "onColumnUpClick"));
			}
			
			if (i >= this.columns.length-1) {
				div_down.innerHTML = "<input type='image' alt='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEDOWN_DIABLED + "' aria-label='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEDOWN_DIABLED + "' src='" + this.contextRootBuilder + "/images/down_disabled.png' style='float:left;cursor:not-allowed;'/>";
			} else {
				div_down.innerHTML = "<input type='image' alt='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEDOWN_ENABLED + "' aria-label='" + this.resourceBundle.L_CONF_COLUMN_ORDER_MOVEDOWN_ENABLED +"' value='" + i + "' src='" + this.contextRootBuilder + "/images/down.png' style='float:left;cursor:pointer;'/>";
				// events[6]
				tdEvents.push(dojo.connect(div_down, "onclick", this, "onColumnDownClick"));
			}	
			
			// TD6: display sortBy drop down menu
			var sortTypeText = column.sorttype;
			var sortTypeList= new Array(this.resourceBundle.L_CONF_COLUMN_SORTTYPE_STRING,this.resourceBundle.L_CONF_COLUMN_SORTTYPE_NUMBER);
			var sortTypeTitle = dojo.string.substitute(this.resourceBundle.L_CONF_COLUMN_SORTTYPE_1, [this.resourceBundle.L_CONF_COLUMN_SORTTYPE_STRING]);
			var selectHtml = "<select name=\"" + column.name + "_sorttype\" title=\"" + sortTypeTitle + "\">";
			for(var j=0; j<sortTypeList.length; j++){
				selectHtml += "<option value=\"" + sortTypeList[j] + "\"" + ((!!sortTypeText&&sortTypeText==sortTypeList[j])?" selected":"") + " title=\"Sort as "+sortTypeList[j]+"\">" + sortTypeList[j] + "</option>";
			}
			selectHtml += "</select>";
			td6.innerHTML = selectHtml;
			var sortTypeSelect = dojo.query("select", td6)[0];
			// events[7]
			tdEvents.push(dojo.connect(sortTypeSelect, "onchange", this, "onColumnSorttypeChange"));
			
			// TD7: Restore column name button
			var restoreTitle = dojo.string.substitute(this.resourceBundle.L_CONF_COLUMNS_RESTORE_TITLE_1, [column.name]);
			
			td7.innerHTML = "<a href='javascript:;' style='white-space:nowrap;'>" + this.resourceBundle.L_CONF_COLUMNS_RESTORE_TITLE + "<span class='access'>" + restoreTitle + "</span></a>";
			var restoreNameBtn = dojo.query("a", td7)[0];
			// events[8]
			tdEvents.push(dojo.connect(restoreNameBtn, "onclick", this, "onRestoreNameBtnClick"));		
			this.tdEventsList[i] = tdEvents;
            this.tableBody.appendChild(ctr);
			ctr.initialColumnName = column.name;
		}
	},
	
	onColumnCheckBoxClick: function(event) {
		var columnName = event.target.name;
		if (columnName && this._columnsMap) {
			this.columns[this._columnsMap[columnName]].checked = event.target.checked ? event.target.checked : false;
		}
	},
	
	swapRowContent: function(oriRowIndex, tarRowIndex, tr1, tr2) {
		//disconnect the dynamic event bind before swap
		for(var j = 0; j < this.tdEventsList.length; j++){
			if(j == oriRowIndex || j == tarRowIndex){
				for(var k = 0; k < this.tdEventsList[j].length; k++){
					if(k == 5 || k == 6) continue;//events[5] and [6] are for swap button which need no swap
					dojo.disconnect(this.tdEventsList[j][k]);
				}
			}
		}
		
		for (var i = 0, length = tr1.cells.length; i < length; i++) {
			if(i == 4) continue; //tds[4] is the swap button which needs no swap
			
			var tr1Sorttype,tr2Sorttype;
			if(i == 5){
				//save the sorttype before content swap
				tr1Sorttype = dojo.query("select", tr1.cells[i])[0].value;
				tr2Sorttype = dojo.query("select", tr2.cells[i])[0].value;
			}
			this.swapCellContent(tr1.cells[i], tr2.cells[i]);
			
			if (i == 2){/* add onclick handler for column alignment images*/
				var imgControls = dojo.query("input", tr1.cells[2]);
				for (var j=0; j<imgControls.length; j++) this.tdEventsList[oriRowIndex][i] = dojo.connect(imgControls[j].parentNode, "onclick", this, "onAlignButtonClick");

				imgControls = dojo.query("input", tr2.cells[2]);
				for (j=0; j<imgControls.length; j++) this.tdEventsList[tarRowIndex][i] = dojo.connect(imgControls[j].parentNode, "onclick", this, "onAlignButtonClick");
			}
            
			if(i == 5){
				//restore sorttype after content swap
				var newTr1Sorttype = dojo.query("select", tr1.cells[i])[0];
				var newTr2Sorttype = dojo.query("select", tr2.cells[i])[0];
				newTr1Sorttype.value = tr2Sorttype;
				newTr2Sorttype.value = tr1Sorttype;
				this.tdEventsList[oriRowIndex][7] = dojo.connect(newTr1Sorttype, "onchange", this, "onColumnSorttypeChange");
				this.tdEventsList[tarRowIndex][7] = dojo.connect(newTr2Sorttype, "onchange", this, "onColumnSorttypeChange");
			}
			
			if (i==6) {
				var restoreNameBtn1 = dojo.query("a", tr1.cells[i])[0];
				var restoreNameBtn2 = dojo.query("a", tr2.cells[i])[0];
				this.tdEventsList[oriRowIndex][8] = dojo.connect(restoreNameBtn1, "onclick", this, "onRestoreNameBtnClick");
				this.tdEventsList[tarRowIndex][8] = dojo.connect(restoreNameBtn2, "onclick", this, "onRestoreNameBtnClick");
			}
		}
		var initialColumnName1 = tr1.initialColumnName;
		tr1.initialColumnName = tr2.initialColumnName;
		tr2.initialColumnName = initialColumnName1;
	},
	
	swapCellContent: function(td1, td2)	 {
		td1.parentNode.replaceChild(td2.cloneNode(true), td1);
		td2.parentNode.replaceChild(td1.cloneNode(true), td2);
	},
	
	getColumnIndexFromRow: function(tr) {
		var inputNode = dojo.query("input", tr.cells[1])[0];
		var columnName = inputNode.value;
		for (var i = 0, length = this.columns.length; i < length; i++) {
			if (this.columns[i].label === columnName) {
                columnName = this.columns[i].name;
				break;
            }
		}
		return this._columnsMap[columnName];
	},
	
	onColumnUpClick: function(event) {
		var index = event.target.getAttribute('value');
		index = parseInt(index, 10);
		if (index <= 0) return;
		
		var oriRow = this.tableBody.rows[index];
		var tarRow = this.tableBody.rows[index - 1];
		this.swapRowContent(index, (index - 1), oriRow, tarRow);
		
		this.columns[this.getColumnIndexFromRow(oriRow)].index ++;
		this.columns[this.getColumnIndexFromRow(tarRow)].index --;
	},
	
	onColumnDownClick: function(event) {
		var index = event.target.getAttribute('value');
		index = parseInt(index, 10);
		if (index >= this.tableBody.rows.length - 1) return;
		
		var oriRow = this.tableBody.rows[index];
		var tarRow = this.tableBody.rows[index + 1];
		this.swapRowContent(index,(index + 1),oriRow, tarRow);
		
		this.columns[this.getColumnIndexFromRow(oriRow)].index --;
		this.columns[this.getColumnIndexFromRow(tarRow)].index ++;
	},
	
	onAlignButtonClick: function(event) {
		var target = event.target;
		var formerValue = dojo.byId(this.wid + 'align_col_' + escape(target.name)).value;
		var targetValue = target.getAttribute('value');
		if (targetValue != formerValue) {
			var formerImg = dojo.byId(this.wid + 'align_col_' + formerValue + '_img_' + target.name);
			if (formerImg) {
				formerImg.src = this.contextRootBuilder + "/images/align_" + formerValue + ".png";
				formerImg.alt = dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_1, [this.resourceBundle["L_" + formerValue.toUpperCase()]]);
			}
			var newImg = dojo.byId(this.wid + 'align_col_' + targetValue + '_img_' + target.name);
			if (newImg) {
				newImg.src = this.contextRootBuilder + "/images/align_" + targetValue + "_selected.png";
				newImg.alt = dojo.string.substitute(this.resourceBundle.L_CONF_ALIGN_IS_SELECTED_1, [this.resourceBundle["L_" + targetValue.toUpperCase()]]);
			}
			
			dojo.byId(this.wid + 'align_col_' + escape(target.name)).value = target.getAttribute('value');
			for (var i = 0; i < this.columns.length; i++) {
				if (this.columns[i].name == target.name) {
					this.columns[i].align = target.getAttribute('value');
				}
			}
		}
	},
	
	//set column label
	onColumnLabelChange: function(event) {
		var columnName = event.target.name;
		columnName = columnName.substr(0,columnName.length-6);    //delete "_label"
		if (columnName && this._columnsMap) {
			this.columns[this._columnsMap[columnName]].label = event.target.value;
		}
	},
	
	//set column sort type
	onColumnSorttypeChange: function(event) {
		var columnName = event.target.name;
		columnName = columnName.substr(0,columnName.length-9);    //delete "_sorttype"
		if (columnName && this._columnsMap) {
			this.columns[this._columnsMap[columnName]].sorttype = event.target.value;
		}
		
		var sortTypeTitle = dojo.string.substitute(this.resourceBundle.L_CONF_COLUMN_SORTTYPE_1, [event.target.value]);

		event.target.setAttribute("title", sortTypeTitle);	
	},
	
	getParentByType : function(/* HTMLElement */node, /* string */type) {
		//	summary
		//	Returns the first ancestor of node with tagName type.
		var _document = dojo.doc;
		var parent = dojo.byId(node);
		type = type.toLowerCase();
		while((parent)&&(parent.nodeName.toLowerCase()!=type)){
			if(parent==(_document["body"]||_document["documentElement"])){
				return null;
			}
			parent = parent.parentNode;
		}
		return parent;	//	HTMLElement
	},
	
	onRestoreNameBtnClick: function(event) {
		var target = event.target;
		var tr = this.getParentByType(target, "tr");
		var columnName = tr.initialColumnName;
		var inputBox = dojo.query("td.columnName input", tr)[0];
		inputBox.value = columnName;
		if (columnName && this._columnsMap) {
			this.columns[this._columnsMap[columnName]].label = columnName;
		}
	},
	
	setSettings: function(columnsSettings){
		var newColumns = [];
		for (var i = 0; i < columnsSettings.columnList.length; i++) {
			var columnsItem = {
				'name': columnsSettings.columnList[i],
				'align': columnsSettings.columnsAlign[columnsSettings.columnList[i]],
				'checked': columnsSettings.columnFilter[i],
				'index': columnsSettings.columnsOrder[i],
				'label': columnsSettings.columnLabel[i],
				'sorttype': (!columnsSettings.columnSorttype || !columnsSettings.columnSorttype[i]) ? "String" : columnsSettings.columnSorttype[i]
			}
			newColumns.push(columnsItem);
		}
		this.initialize(newColumns);
	},
	
	getSettings: function() {
		var columnsSettings = {
			'columnList': [],
			'columnsAlign': {},
			'columnFilter': [],
			'columnsOrder': [],
			'columnLabel': [],
			'columnSorttype': []
		}
		for (var i = 0; i < this.columns.length; i++) {
			columnsSettings.columnList.push(this.columns[i].name);
			columnsSettings.columnsAlign[this.columns[i].name] = this.columns[i].align;
			columnsSettings.columnFilter.push(this.columns[i].checked);
			columnsSettings.columnsOrder.push(this.columns[i].index);
			columnsSettings.columnLabel.push(!this.columns[i].label?this.columns[i].name:this.columns[i].label);
			columnsSettings.columnSorttype.push(!this.columns[i].sorttype?"String":this.columns[i].sorttype);
		}
		return dojo.toJson(columnsSettings);
	}
});

com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages = com.ibm.mm.builder.iwidget.widgetbuilder.widgetBuilderMessages;

/*
 * dataModel takes the responsibility of parsing the data. The data returned from data model support
 * pagination as default. Set pagination fields as empty string or zero if data source does not support it.
 * 
 */

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel", null, {
	canProcess: function(data, contentType){
		/*For performance reason, we return the second parameter data*/
		return {'support' : false, 'data' : null};
	},

	process: function(data){
		return null;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.XMLDataModel", com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel, {
	name: 'XMLDataModel',

	constructor: function(){
		this.dataModel = new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.FlattenDataModel();
	},

	canProcess: function(data, contentType){
		if (contentType && data && contentType.toUpperCase().indexOf('XML') !== -1){
		    data = dojox.data.dom.createDocument(data);
		}
		
		if (dojo.isObject(data)) {
			var feedNodes = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getChildNodesByTagName(data, "feed");
			
			if (feedNodes.length > 0) {
				return {'support' : true, 'data' : data};
			}
		}
		return {'support' : false, 'data' : null};
	},

	process: function(data, _xmlDoc){
		var xmlDoc = _xmlDoc ? _xmlDoc : (dojo.isObject(data) ? data : dojox.data.dom.createDocument(data) );
		var jsonArray = this.handleFeed(xmlDoc);
		if (!dojo.isObject(data)) xmlDoc = null;
		if (jsonArray.length <= 0){
			//throw("No content from data source");
			throw(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.NoContentException(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_NO_CONTENT));
		}
		var columnList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getColumnList(jsonArray[0]);
		var paginationData = {'totalResult' : jsonArray.length, 'startIndex' : 0, 'itemsPerPage' : jsonArray.length,
			'first' : '', 'last' : '', 'previous' : '', 'next' : '', 
			'result' : jsonArray,  'columnList' : columnList};
		return paginationData;
	},
	
	/*
	 * Use data model to handle the ATOM feed
	 */
	handleFeed: function(data){
		var entryArray = [];
		var entryNodes = dojo.isIE ? data.getElementsByTagName("entry") : dojo.query("entry", data);
		if (entryNodes) {
			for (var i = 0; i < entryNodes.length; i++) {
				var entryNode = entryNodes[i];
				if (!entryNode) {
					continue;
				}
				try{
					this.dataModel.process(entryNode, entryArray);			
				} catch(e){
					//Data model could not handle this entry
					continue;
				}
			}
		}
		return entryArray;
		
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.RSSDataModel", com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel, {
	name: "RSSDataModel",
	
    constructor: function(){
        this.dataModel = new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.FlattenDataModel();
    },
    
	canProcess: function(data, contentType){
        if (contentType && contentType.toUpperCase().indexOf('XML') !== -1 && data){
            data = dojox.data.dom.createDocument(data);
        }
        
        if (dojo.isObject(data)){
			var rootNodes = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getChildNodesByTagName(data, "rss");
			if (rootNodes.length === 0) {
				rootNodes = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getChildNodesByTagName(data, "rdf");
			}
			if (rootNodes.length > 0) {
                return {'support' : true, 'data' : data};
			}
        }
        return {'support' : false, 'data' : null};
	},
	
	process: function(data, _xmlDoc){
        var xmlDoc = _xmlDoc ? _xmlDoc : (dojo.isObject(data) ? data : dojox.data.dom.createDocument(data) );
        var jsonArray = this.handleFeed(xmlDoc);
        if (!dojo.isObject(data)) xmlDoc = null;
        if (jsonArray.length <= 0){
            //throw("No content from data source");
            throw(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.NoContentException(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_NO_CONTENT));
        }
        var columnList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getColumnList(jsonArray[0]);
        
        var paginationData = {'totalResult' : jsonArray.length, 'startIndex' : 0, 'itemsPerPage' : jsonArray.length,
            'first' : '', 'last' : '', 'previous' : '', 'next' : '', 
            'result' : jsonArray,  'columnList' : columnList};
        return paginationData;
	},
	
    /*
     * Use data model to handle the RSS feed
     */
    handleFeed: function(data){
        var entryArray = [];
        var entryNodes = dojo.isIE ? data.getElementsByTagName("item") : dojo.query("item", data);
        if (entryNodes) {
            for (var i = 0; i < entryNodes.length; i++) {
                var entryNode = entryNodes[i];
                if (!entryNode) {
                    continue;
                }
                try{
                    this.dataModel.process(entryNode, entryArray);          
                } catch(e){
                    //Data model could not handle this entry
                    continue;
                }
            }
        }
        return entryArray;
    }
});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.CSVDataModel", com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel, {
	name: 'CSVDataModel',

	canProcess: function(data, contentType){
		if (dojo.isString(contentType) && contentType.toUpperCase().indexOf('XML') >= 0){
			return {'support' : false, 'data' : null};
		}

		if (data && dojo.isString(data)){
			var rows = data.split('\r\n');
			if (!rows || rows.length <= 0){
				return {'support' : false, 'data' : null};
			}
			
			var columnList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.splitterCSVData(rows[0]);
			if (!columnList || columnList.length <= 0) return {'support' : false, 'data' : null};
			var columnLength = columnList.length;
			for (var i=1; i<rows.length; i++){
				if (rows[i] === "") {
					break;
				}
	
				var rowList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.splitterCSVData(rows[i]);
				if (!rowList || rowList.length !== columnLength) return {'support' : false, 'data' : null};
			}
	
			return {'support' : true, 'data' : null};			
		}

		return {'support' : false, 'data' : null};
	},

	process: function(data){

		var jsonArray = this.processCSVData(data);
		if (jsonArray.length <= 0){
			//throw("No content from data source");
			throw(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.NoContentException(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_NO_CONTENT));
		}
		var columnList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getColumnList(jsonArray[0]);
		
		var paginationData = {'totalResult' : jsonArray.length, 'startIndex' : 0, 'itemsPerPage' : jsonArray.length,
			'first' : '', 'last' : '', 'previous' : '', 'next' : '', 
			'result' : jsonArray,  'columnList' : columnList};
		return paginationData;

	},

	processCSVData: function(dataString, viewConfig){

		var jsonArray = [];		

		var rows = dataString.split('\r\n');
		if (!rows || rows.length <= 0){
			//throw('Illegal CSV document');
			throw(com.ibm.mm.builder.iwidget.widgetbuilder.widgetBuilderMessages.E_ILLEGAL_CSV_DOCUMENT);
		}

		var columnList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.splitterCSVData(rows[0]);
		for (var j=0; j<columnList.length; j++){
			columnList[j] = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.unescapeCSVCell(columnList[j]);
		}
		for (var i=1; i<rows.length; i++){
			if (rows[i] === "") {
				break;
			}

			var rowDataList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.splitterCSVData(rows[i]);
			if (rowDataList.length < columnList.length){
				//throw('Illegal CSV document');
				throw(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_ILLEGAL_CSV_DOCUMENT);
			}

			var data = {};
			for (var j=0; j<columnList.length; j++){
				data[columnList[j]] = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.unescapeCSVCell(rowDataList[j]);
			}
			jsonArray.push(data);
		}
		
		return jsonArray;
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.CSVLikeDataModel", com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel, {
	name: 'CSVLikeDataModel',

	/*
	 * If input string comply with below format, return true, otherwise, return false
	 * column 1 name, column 2 name, ... | type, type, ... | cell 1 value, cell 2 value, ... | ...
	 */
	canProcess: function(data, contentType){
		if (dojo.isString(contentType) && contentType.toUpperCase().indexOf('XML') >= 0){
			return {'support' : false, 'data' : null};
		}

		if (data && dojo.isString(data)){
			data = data.replace(/\n/g, "");
			var rows = data.split('|');
			if (!rows || rows.length <= 2){
				return {'support' : false, 'data' : null};
			}
			
			var columnList = rows[0].split(',');
			if (!columnList || columnList.length <= 0) return {'support' : false, 'data' : null};
	
			var columnLength = columnList.length;
			for (var i=1; i<rows.length; i++){
				if (rows[i] === "") {
					break;
				}
	
				var rowList = rows[i].split(',');
				if (!rowList || rowList.length !== columnLength) return {'support' : false, 'data' : null};
			}
	
			return {'support' : true, 'data' : null};			
		}

		return {'support' : false, 'data' : null};
	},

	process: function(data){

		data = data.replace(/\n/g, "");
		var rows = data.split('|');
		
		var columnList = rows[0].split(',');
		
		var jsonArray = [];
		var object;
		for (var i=2; i<rows.length; i++){
			if (rows[i] === "") {
				break;
			}

			object = {};
			var rowList = rows[i].split(',');
			for (var j=0; j<columnList.length; j++){
				object[columnList[j]] = rowList[j];
			}
			jsonArray.push(object);

		}

		if (jsonArray.length <= 0){
			//throw("No content from data source");
			throw(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.NoContentException(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_NO_CONTENT));
		}
		
		var paginationData = {'totalResult' : jsonArray.length, 'startIndex' : 0, 'itemsPerPage' : jsonArray.length,
			'first' : '', 'last' : '', 'previous' : '', 'next' : '', 
			'result' : jsonArray,  'columnList' : columnList};
		return paginationData;

	}
});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.JSONArrayDataModel", com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel, {
	name: 'JSONArrayDataModel',

	canProcess: function(data, contentType){
		if (contentType && contentType.toUpperCase().indexOf('XML') !== -1){
			return {'support' : false, 'data' : null};
		}
		if (dojo.isString(data)) {
			try {
				data = dojo.fromJson(data);
			} catch(e) {
				return {'support' : false, 'data' : null};
			}
		}
		return {'support' : dojo.isArray(data) && data.length > 0, 'data' : null };
	},

	process: function(jsonArray){
		if (dojo.isString(jsonArray)) {
			jsonArray = dojo.fromJson(jsonArray);
		}
		if (jsonArray.length <= 0){
			//throw("No content from data source");
			throw(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.NoContentException(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_NO_CONTENT));
		}
		var columnList = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getColumnList(jsonArray[0]);
		
		var paginationData = {'totalResult' : jsonArray.length, 'startIndex' : 0, 'itemsPerPage' : jsonArray.length,
			'first' : '', 'last' : '', 'previous' : '', 'next' : '', 
			'result' : jsonArray,  'columnList' : columnList};
		return paginationData;

	}
});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.JSONFeedDataModel", com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel, {
	name: 'JSONFeedDataModel',

	canProcess: function(data, contentType){
		if (contentType && contentType.toUpperCase().indexOf('XML') !== -1){
			return {'support' : false, 'data' : null};
		}
		return { 'support' : !!(data && data.totalResult && (data.startIndex !== undefined) && data.itemsPerPage && data.first && data.last && data.result && data.columnList), 'data' : null }; 

	},

	process: function(data){
		return data;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.JSONFeedEventDataModel", com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataModel, {
	name: 'JSONFeedEventDataModel',

	canProcess: function(data, contentType){
		if (contentType && contentType.toUpperCase().indexOf('XML') !== -1){
			return {'support' : false, 'data' : null};
		}
		
		if (!data){
			return {'support' : false, 'data' : null};
		}

		try{
			//simply check the format
			var jsonData = data;
			if (jsonData && jsonData['atom:feed']){
				return {'support' : true, 'data' : null};
			}
		}catch(e){}

		return {'support' : false, 'data' : null};
	},

	process: function(data){

		var result = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.parseJSONFeed(data);
		
		var paginationData = {'totalResult' : result.totalResults, 'startIndex' : result.StartIndex || 0, 'itemsPerPage' : result.itemsPerPage,
			'first' : result.first || '', 'last' : result.last || '', 'previous' : result.previous || '', 'next' : result.next || '', 
			'result' : result.result,  'columnList' : result.columnNames};
			
		//store to cache before return
		var url = result.first || result.last || result.previous || result.next;
		if (url === ''){ 
			throw(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_ILLEGAL_PIPELINE_DATA);			
		}
		
		//opensearch spec, startIndex starts from 1
		var startIndex = paginationData.startIndex;
		var count = paginationData.itemsPerPage;
		var pipelineID = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getparamFromURL(url, "id");
		
		var selfURL = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.createPipelineURL(url, "count", count);
		selfURL = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.createPipelineURL(url, "startIndex", startIndex);
		
		var cache = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.dataFetcher._cache;
		
		delete cache.data;         //clear cache
		cache.data = null;
		
		cache.key.startIndex = startIndex;
		cache.key.count = count;
		cache.key.pipelineID = pipelineID;
		cache.key.url = selfURL;
		cache.data = paginationData;
		
		return paginationData;

	}
});

/*
 * FlattenDataModel takes the responsibility of parsing the ATOM data feed entry. Mainly the ATOM
 * feeds come from Mashup Hub.
 * This class support ATOM feed with below characteristic
 * <entry>
 * 	<content type="application/xml">
 * 		data ...
 * 	</content>
 * </entry>
 */
dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.FlattenDataModel", null, {
	/*
	 * entryNode : feed entry node, as input
	 * entryArray : store processed result
	 */
	process: function(entryNode, entryArray){
		if (entryNode.nodeName.toLowerCase() === "entry") {
			var contentNodes = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getChildNodesByTagName(entryNode, "content");
			if (!contentNodes || contentNodes.length === 0) {
				contentNode = entryNode;
			} else {
				var contentNode = contentNodes[0];
			}
		} else {
			// RSS case
			var contentNode = entryNode;
		}
        var startNode = contentNode;
		
		var rowNodes = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getChildNodesByTagName(contentNode, "row");
		if (rowNodes && rowNodes.length > 0) {
			startNode = rowNodes[0];
		}
        
		var childNodes = com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.getDescendantNodes(startNode);
        if (childNodes.length === 0) {
			childNodes.push(startNode);
		}
		
		com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil._setResultForEntryNode(entryNode, childNodes, entryArray);
	}
});

/*Write more data model below*/




dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.remoteDataSource", null, {
	name: 'remoteDataSource',
	
	constructor: function(feedURL, errorCallback){
		this.feedURL = feedURL;
		this.errorCallback = errorCallback;
		this.dataModels = [
			new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.XMLDataModel(), 
			new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.RSSDataModel(),
			new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.JSONArrayDataModel(),
			new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.CSVLikeDataModel(), 
			new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.CSVDataModel(),
			new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.JSONFeedDataModel()];
		this.resourceBundle = com.ibm.mm.builder.iwidget.widgetbuilder.widgetBuilderMessages;
	},

	getData: function(callback){
		var self = this;
		var bindArgs = {
			url: this.feedURL ,
			load: function(data, ioArgs){
				try{
					var contentType = ioArgs ? ioArgs.xhr.getResponseHeader('Content-Type') : null;
					var found = false;
					
					for(var i=0; i < self.dataModels.length; i++) {
						var dataModel = self.dataModels[i];
						var status = dataModel.canProcess(data, contentType);
						if (status['support']){
							found = true;
							var paginationData = dataModel.process(data, status['data']);
							callback(paginationData, self.name, dataModel.name);
							break;
						}
					}
					
					if (!found){
						// Data source is not supported
						throw(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.DataSourceNotSupportException(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerMessages.E_DATA_SOURCE_NOT_SUPPORTED));
					}
				}
				catch(e){
					self.errorCallback(e);
				}
			},
			error: function(error, ioArgs){
				self.errorCallback(new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.IOException(self.resourceBundle.E_CHECK_URL));
			}
		}

		var dataFetcher = new com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.dataViewerUtil.dataFetcher();
		dataFetcher.getData(bindArgs);
	}
});