dojo.provide("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ContentSourcePage");

dojo.require("dojox.validate.web");

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ContentSourcePage", [com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ChangeWatchingPage,dijit._Widget, dijit._Templated], {
	templateString : 
	    "<div class='dataviewer'>" +
			"<div role='presentation' class='content'>" +
				"<div class='wizard_page_header'>${I_WIZARD_DATAVIEWER_TITLE}</div>" + 
				"<hr class='wizard_page_separator'/>"+
				"<div class='wizard_page_content' style='margin:16px'>"+
				 	"<div class='wizard_page_section'>"+
						"<div><input type='radio' name='data_viewer_option' class='url_option' id='url_radio' value='url' checked='true' dojoAttachPoint='_selectUrlNode'><label for='url_radio'>${I_WIZARD_DATAVIEWER_CONTENT_URL}</label></div>"  +
						"<div class='wizard_input'><input type='text' size='40' id='url_input' class='url_input inputText' value='http://' title=\"${I_WIZARD_DATAVIEWER_CONTENT_URL}\" dojoAttachPoint='_urlInputNode' /><input type='button' class='standardbutton' value='${L_COMMON_LOAD}' title='${L_COMMON_LOAD}' dojoAttachPoint='_loadButtonNode'></div>"+
					"</div>"+
				
					"<div class='wizard_page_section' dojoAttachPoint='_fromCatalogSection' style='display:none;'>"+
						"<div><input type='radio' name='data_viewer_option' class='url_option' value='catalog' id='category_radio' dojoAttachPoint='_selectCategoryNode'><label for='category_radio'>${I_WIZARD_DATAVIEWER_CONTETN_CATALOG}</label></div>"  +
						"<div class='wizard_input'><input type='button' class='standardbutton' value='${I_WIZARD_DATAVIEWER_SELECT_FROM_CATALOG}' title='${I_WIZARD_DATAVIEWER_SELECT_FROM_CATALOG}' dojoAttachPoint='selectNode'/><input class='url_input inputText_' dojoAttachPoint='urlNode' type='text' size='20'  title='${I_WIZARD_DATAVIEWER_CONTETN_CATALOG}'/></div>"+
					"</div>"+
							
				"</div>" +
			"</div>"+	
		"</div>"	,
		
	// URL Dijit parameters
	_urlDijitClass: "com.ibm.mashups.widget.dijit.url.v103",
    _urlWidgetHelper: null,
    _urlDijit: null,
	_searchDialog:null,
	
	getName : function() {
		return this.I_WIZARD_CONTETN_SOURCE;
	},
	
	getSequence : function(){
		return 1;
	},
	
	postMixInProperties : function() {
	   this.applyNLS();
	},
	
	postCreate : function(){		
		if (builderConfig.hasHub) {
			dojo.style(this._fromCatalogSection, "display", "block");
			var hubUrl = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.HUB_URL);
			this.openSearchUrl = hubUrl + '/atom?nologin=true';
			dojo.connect(this.selectNode,"onclick",this,this._createHubBrowserDialog);
		}
		if(dojo.isIE == 7){
			dojo.style(this.selectNode,"width","15em");
			dojo.attr(this.urlNode,"size","18");
		}
		dojo.connect(this._selectUrlNode,"onclick",this,this._selectUrlOptionClicked);
		dojo.connect(this._selectCategoryNode,"onclick",this,this._selectCategoryOptionClicked);
		this._toggleButtonEnable(this.selectNode,false);
		this._toggleButtonEnable(this.urlNode,false);
		dojo.connect(this._loadButtonNode, "onclick", this, this._loadUrl);
	},
	
	postLoaded : function() {
	   var pageRootUrl = this.getPageRootUrl();
	   dojo.registerModulePath(this._urlDijitClass, pageRootUrl + "dijit-library/urlDijit");
	   dojo["require"](this._urlDijitClass + "._dialog");
	},
	
	_selectUrlOptionClicked : function(){
		this._toggleButtonEnable(this.selectNode,false);
		this._toggleButtonEnable(this.urlNode,false);
		this._toggleButtonEnable(this._loadButtonNode,true);
		this._toggleButtonEnable(this._urlInputNode,true);
	},
	
	_selectCategoryOptionClicked : function(){
		this._toggleButtonEnable(this.urlNode,true);
		this._toggleButtonEnable(this.selectNode,true);
		this._toggleButtonEnable(this._urlInputNode,false);
		this._toggleButtonEnable(this._loadButtonNode,false);
	},
	
	_toggleButtonEnable : function(node, enabled) {
		
		if (enabled) {
			dojo.removeAttr(node, "disabled");
			dojo.removeClass(node, "disabled");
		}
		else {
			dojo.attr(node, "disabled", "disabled");
			dojo.addClass(node, "disabled");
		}
		
	},
	
	_validateUrl : function(url) {
		if(url.indexOf("/") == 0){
			return true;
		}
		return dojox.validate.isUrl(url, {scheme: true, allowLocal: true, allowIP : true, allowNamed: true}) || this._validateNamedHostUrl(url);
	},
	
	_validateNamedHostUrl: function(url) {
		var protocolRE = dojo.regexp.buildGroupRE([true, false],
			function(q){ if(q){ return "(https?|ftps?)\\://"; } return ""; }
		);

		// Path and query and anchor RE
		var pathRE = "(/(?:[^?#\\s/]+/)*(?:[^?#\\s/]+(?:\\?[^?#\\s/]*)?(?:#[A-Za-z][\\w.:-]*)?)?)?";
		var hostRE = "[a-zA-Z0-9_-]*(\\:\\d+)?";

	
		var re = new RegExp("^(" + protocolRE +")(" + hostRE+ ")(" + pathRE + ")$");
		return re.test(url); // Boolean

  	},  
  
	_loadUrl : function() {
		var value = dojo.trim(this._urlInputNode.value);
		if (value == "") {
			this.showMessage(this.I_WIZARD_WEBSITE_NOURL);
			return;
		}
		if (!this._validateUrl(value)) {
			this.showMessage(this.E_WIZARD_WEBSITE_INVALID_URL);
			return;
		}
		this.hideMessage();
		this.updateDefinition();
		this.notifyUpdatePreview();
	},
	
	validate : function() {
		if (this._selectUrlNode.checked) {
			var value = dojo.trim(this._urlInputNode.value);
			if (value == "") {
				return this.I_WIZARD_WEBSITE_NOURL;
			}
			if (!this._validateUrl(value)) {
				return this.E_WIZARD_WEBSITE_INVALID_URL;
			}
		}
		return true;
	},
	
	updateValue : function() {
		this._setInitValue();
	},
	
	_setInitValue : function(){
		var oldItemSet = com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework.getItemSet();
		var inputNode = this._urlInputNode;
		var urlItemSets = dojo.filter(oldItemSet, function(item) {
			return item.id == "feedURL";
		});
		if (urlItemSets.length) {
			inputNode.value = urlItemSets[0].value || "http://";
		}
	},
	
	_createHubBrowserDialog : function(){
		if (!this._searchDialog) {
			this._searchDialog = new (dojo.getObject(this._urlDijitClass).HubBrowseDialog)( {
				title :"Browse data feed catalog",
				openSearchUrl : iWidgetContainer.getAllWidgets().createNewWidget.iScope.iContext.io.rewriteURI(this.openSearchUrl),
				dialogStyle: 'width: 750px;',
				onFeedSelect: dojo.hitch(this, function(url) {
					console.debug('selected url',url);
					this.urlNode.value = url;
				})		
			});
			this._searchDialog.startup();
		}
		this._searchDialog.show();
	},
	
	_getOption : function(){
		var selectedOption = "";
		var selected = dojo.filter(dojo.query("input.url_option",this.domNode),function(node) {
			return node.checked;
		});
		if (selected.length > 0) {
			selectedOption = selected[0].value;
		}
		return selectedOption;
	},
	
	updateDefinition : function(){
		var selected = this._getOption();
		var inputNode = null;
		if("url" == selected){
			inputNode = dojo.query("input.url_input", this.domNode)[0];
		}else if("catalog" == selected){
			inputNode = dojo.query("input.url_input", this.domNode)[1];
		}
		
		var value = dojo.trim(inputNode.value);
		var itemSet = new com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.ItemSetObject();
		itemSet.id = "feedURL";
		itemSet.value = value;
//		dojo.publish("com.ibm.mashups.dataviewer.feedurl.refreshed", [value]);
		com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework.updateItemSet([itemSet]);
	}
});

com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework.register(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.dataViewer.ContentSourcePage, {sequence : 0});


