/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
/**
 * @author Tong Li (litong01@us.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.require("dojox.validate.web");

dojo.declare("com.ibm.mm.widget.htmlFragment._WB_VER_",null,{	

	WID:null,
	
	rootFrame:null,
	
	resourceBundle:null,
				
    onLoad: function () {
	    dojo.registerModulePath("com.ibm.mm.widget.htmlFragment._WB_VER_", this.iContext.io.rewriteURI("js"));
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		dojo.requireLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_", "widgetStr",cs.getValue("locale"), cs.getValue("availableLocales"));
	    try {
			this.resourceBundle = dojo.i18n.getLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_", "widgetStr"); 		
		} catch(e) {
			dojo.requireLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_", "widgetStr", ibmConfig["default.locale"], cs.getValue("availableLocales"));
			this.resourceBundle = dojo.i18n.getLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_", "widgetStr", ibmConfig["default.locale"]);
		}
		
		var rootNode = this.iContext.getRootElement();
		
		var wid = this.iContext.widgetId;
		this.WID = "_" + wid + "_";		
		
		var tags = dojo.query(".rootFrame", rootNode);
		this.rootFrame = tags[0];
		this.rootFrame.title = this.resourceBundle.I_HTMLFRAGMENT_IFRAME_TITLE;
		
		var contentNode = dojo.byId(rootNode.id + "_content");
		if (contentNode != null) {
			this.doResize();
		}
		
		//currently we don't support onUnload() of iWidget. After it's supported, we should invoke dojo.unsubscribe for the subscriptions.
		this._subscriptions = [];
		this._subscriptions.push(dojo.subscribe(rootNode.id + "/endSizing", this, 'doResize'));	
		this._subscriptions.push(dojo.subscribe(rootNode.id + "/endHeightSizing", this, 'doResizeHeight'));
	},

	onview:function(){
		dojo.byId(this.WID+"default_message").innerHTML = this.resourceBundle.I_HTMLFRAGMENT_CONF_URL_DISPALY; 
		var att = this.iContext.getiWidgetAttributes();
		if (att != null) {
			var theUrl = att.getItemValue('url');
			if (theUrl != null && theUrl != "") {
				if(dojo.isSafari == 4){
					var widgetParentNode = this.iContext.getRootElement().parentNode;
					dojo.style(widgetParentNode,"overflow","visible");
				}
				try{
					this.rootFrame.src = this.filterURI(theUrl);
				}catch(e){
					alert(this.resourceBundle.I_HTMLFRAGMENT_CANTLOAD_URL);
					return;
				}
				this.rootFrame.style.display = "";
				dojo.byId(this.WID+"default_message").style.display="none";
				
				// In FF, iframe can't expand to 100% properly
				if(dojo.isFF) {
					var height = null;
					if (dojo.byId(this.WID.substring(1)+"content")){
						height = dojo.byId(this.WID.substring(1)+"content").style.height;
					}
					if(height){
						this.rootFrame.style.height = parseInt(height) + "px";
					} 
				}
				//in Safari, fix issue of large height, set fixed height to IWID_content div.
				if(dojo.isSafari || dojo.isIE == 6) {
					var contentNode = dojo.byId(this.WID.substring(1)+"content");
					if (contentNode){
						if(!contentNode.style.height)		
							contentNode.style.height = "200px";
					}				
				}
				this.doResize();
			} else {
				this.rootFrame.style.display = "none";
				dojo.byId(this.WID+"default_message").style.display="";
			}
		}	
	},
	
	onedit:function(){
		var urlInputId = this.WID + "url";
		if (dojo.hasClass(dojo.body(),"mumrtl")){
			dojo.byId(urlInputId).style.textAlign = "right";
		}
		var att = this.iContext.getiWidgetAttributes();
		if (att != null) {
			var theUrl = att.getItemValue('url');
			if (theUrl != null) {
				dojo.byId(urlInputId).value = theUrl;
			}
		}	
		dojo.byId(this.WID+"type_url_text").innerHTML = this.resourceBundle.I_HTMLFRAGMENT_TYPE_URL;
		dojo.attr(dojo.byId(this.WID+"url"),"title",this.resourceBundle.I_HTMLFRAGMENT_TYPE_URL);
		dojo.byId(this.WID+"btn_apply").value = this.resourceBundle.I_SYSTEM_MESSAGE_APPLY;
		dojo.attr(dojo.byId(this.WID+"btn_apply"),"title",this.resourceBundle.I_SYSTEM_MESSAGE_APPLY);
		dojo.byId(this.WID+"cancel_text").innerHTML = this.resourceBundle.I_COMMON_CANCEL;
		dojo.attr(dojo.byId(this.WID+"cancel_text"),"title",this.resourceBundle.I_COMMON_CANCEL);
	},
	
    /**
     * Prevent XSS attach
     * @param {String} url url to be encoded
     */
    filterURI: function(url) {
		if (dojo.isString(url)) {
			// filter "javascript:" and "vbscript:"
	        var regex = new RegExp("[ \t\n\x0B\f\r]*(((j|&#106;|&#x6A;|&#0000106;)[ \t\n\x0B\f\r]*(a|&#97;|&#x61;|&#0000097;)[ \t\n\x0B\f\r]*(v|&#x76;|&#118;|&#0000118;)[ \t\n\x0B\f\r]*(a|&#97;|&#x61;|&#0000097;))|((v|&#x76;|&#118;|&#0000118;)[ \t\n\x0B\f\r]*(b|&#x62;|&#98;|&#0000098;)))[ \t\n\x0B\f\r]*(s|&#x73;|&#115;|&#0000115;)[ \t\n\x0B\f\r]*(c|&#x63;|&#99;|&#0000099;)[ \t\n\x0B\f\r]*(r|&#x72;|&#114;|&#0000114;)[ \t\n\x0B\f\r]*(i|&#x69;|&#105;|&#0000105;)[ \t\n\x0B\f\r]*(p|&#x70;|&#112;|&#0000112;)[ \t\n\x0B\f\r]*(t|&#x74;|&#116;|&#0000116;)[ \t\n\x0B\f\r]*(:|&#x3A;|&#58;|&#0000058;)", "i");
			return regex.test(url) ? "" : url;
		} else {
			return "";
		}
    },
    
    displayMarkup: function(iEvent) {
		var obj = iEvent.payload;	
		
		if(dojo.isString(obj)){
			if(obj.indexOf("http") != 0 && obj.indexOf("https") != 0){
				obj = "";
				dojo.byId(this.WID+"default_message").innerHTML=this.resourceBundle.I_HTMLFRAGMENT_CANTLOAD_URL;
				return;
			}
		}
		
		this.rootFrame.style.display = "";
		dojo.byId(this.WID+"default_message").style.display="none";
		this.rootFrame.src = this.filterURI(obj);
		
		if(dojo.isSafari) {
			var contentNode = dojo.byId(this.WID.substring(1)+"content");
			if (contentNode){
					if(!contentNode.style.height)		
							contentNode.style.height = "200px";
			}		
		}
		this.doResize();
	},
	
	cancelInput:function(){
		this.iContext.iEvents.fireEvent("onModeChanged",null,{newMode:'view'});
	},
	
	saveURL:function() {
		var urlNode = dojo.byId(this.WID + "url");
		if (urlNode != null) {
			var theURL=urlNode.value
			var jsCheck=this.isValidUrl(theURL)
			if(!jsCheck){
				var msg=this.resourceBundle.I_HTMLFRAGMENT_ERROR_INVALID_URL
				msg=this.resourceBundle.I_HTMLFRAGMENT_ERROR_INVALID_URL;
				if(!confirm(msg)){
					return
				}				
			}
			var att = this.iContext.getiWidgetAttributes();
			att.setItemValue('url',theURL,false);
			att.save();
			this.iContext.iEvents.fireEvent("onModeChanged",null,{newMode:'view'});
		}
	},
	
	isValidUrl:function(url){
		if(url.indexOf("http")!=0){
			return false;
		}
		return dojox.validate.isUrl(url);	
	},

	doResize:function() {
		var rootNode = this.iContext.getRootElement();
		if (dojo.byId(rootNode.id + "_content")){
			var contentNode = dojo.byId(rootNode.id + "_content");
			contentNode.style.overflow='hidden';		
			var cw=contentNode.style.width;
			//if(cw==null||cw==""){
				cw="100%";
			//}else{
			//	cw=parseInt(contentNode.style.width)-3+"px";
			//}
			this.rootFrame.style.width=cw;
			
			var ch=contentNode.style.height;
			if(ch==null||ch==""){
				ch="100%";
			}else{
				ch=parseInt(contentNode.style.height)-3+"px";
			}
			this.rootFrame.style.height=ch;			
		} 
	},
	
	onSizeChanged: function(iEvent){
		if(this.iContext.getiDescriptor().getItemValue("mode") == this.iContext.constants.mode.EDIT){
			var contentNode = dojo.byId(this.WID + "contentNode");
			var contentMarginBox = dojo.marginBox(contentNode);
			var dialogContentBox = dojo.contentBox(contentNode.parentNode);
			var footerMarginBox = dojo.marginBox(dojo.byId(this.WID + "footer"));
			
			contentMarginBox.h = dialogContentBox.h - footerMarginBox.h;
			contentMarginBox.w = dialogContentBox.w;
			dojo.marginBox(contentNode, contentMarginBox);
		} else {
			var payload = iEvent.payload;
			
			dojo.mixin(this.rootFrame.style, {
				width: payload.newWidth + "px",
				height: payload.newHeight - 3 + "px"
			})
		}
	},
	
	doResizeHeight:function(){
		var rootNode = this.iContext.getRootElement();
		if (dojo.byId(rootNode.id + "_content")){
			var contentNode = dojo.byId(rootNode.id + "_content");
			contentNode.style.overflow='hidden';		
			var ch=contentNode.style.height;
			if(ch==null||ch==""){
				ch="100%";
			}else{
				ch=parseInt(contentNode.style.height)-3+"px";
			}
			this.rootFrame.style.height=ch;			
		}
	},
	
	_unloadIframe : function(elem) {
        if (elem.attachEvent) {
            elem.src = "";
            elem.attachEvent("onload", function() {
                elem.outerHTML = "";
                elem = null;
            });
        }
    },
    
    onUnload : function() {
        dojo.forEach(this._subscriptions, dojo.unsubscribe);
        this._unloadIframe(this.rootFrame);
    }
});
