dojo.provide("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.websiteDisplayer.ContentSourcePage");
dojo.require("com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.Page");
dojo.require("com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.ItemSetObject");
dojo.require("dojox.validate.web");

dojo.declare("com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.websiteDisplayer.ContentSourcePage", [com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.Page,dijit._Widget,dijit._Templated], {
	templateString : 
	    "<div class='wizard_page_content'>" + 
			"<div class='wizard_page_header'>${I_WIZARD_WEBSITE_URL}</div>" + 
			"<hr class='wizard_page_separator'/>"+
			"<div class='wizard_page_center'>" +
				"<label for='website_wizard_url_input'>${I_WIZARD_WEBSITE_CONTENT}</label><br/>" +
				"<input type='text' id='website_wizard_url_input' class='url_input' dojoAttachPoint='_urlInputNode' > <input type='button' class='lotusFormButtonLong' value='${L_COMMON_LOAD}' title='${L_COMMON_LOAD}' dojoAttachPoint='_loadButtonNode' />" + 
			"</div>" + 
		"</div>",	
	
	getName : function() {
		return this.I_WIZARD_CONTETN_SOURCE;
	},
		
	getSequence : function(){
		return 1;
	},
			
	postMixInProperties : function() {
		this.applyNLS();
	},	
	
	postCreate : function(){
		dojo.connect(this._loadButtonNode, "onclick", this, this._loadUrl);
	},
	
	updateValue : function() {
		var oldItemSet = com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework.getItemSet();
		var inputNode = this._urlInputNode;
		var urlItemSet = dojo.filter(oldItemSet,function(item){
			return item.id == "url";
		});
		if (urlItemSet.length > 0) {
			inputNode.value = urlItemSet[0].value || "http://";
		}
	},
	
	_validateUrl : function(url) {
		return dojox.validate.isUrl(url, {scheme: true, allowLocal: true, allowIP : true});
	},
	
	_normalizeUrl : function(url) {
		if (url.indexOf("http://") != 0 && url.indexOf("https://") != 0) {
			url = "http://" + url;
		}
		return url;
	},
	
	_loadUrl : function() {
		var value = dojo.trim(this._urlInputNode.value);
		if (value == "") {
			this.showMessage(this.I_WIZARD_WEBSITE_NOURL);
			return;
		}
		value = this._normalizeUrl(value);
		if (!this._validateUrl(value)) {
			this.showMessage(this.E_WIZARD_WEBSITE_INVALID_URL);
			return;
		}
		this.hideMessage();
		this.updateDefinition();
		this.notifyUpdatePreview();
	},
	
	validate : function() {
		var value = dojo.trim(this._urlInputNode.value);
		if (value == "") {
		    return this.I_WIZARD_WEBSITE_NOURL;
		}
		value = this._normalizeUrl(value);
		if (!this._validateUrl(value)) {
			return this.E_WIZARD_WEBSITE_INVALID_URL;
		}
		return true;
	},
	
	updateDefinition : function(){
		var inputNode = this._urlInputNode;
		var value = dojo.trim(inputNode.value);
		value = this._normalizeUrl(value);
		var itemSet = new com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.ItemSetObject();
		itemSet.id = "url";
		itemSet.value = value;
		com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework.updateItemSet([itemSet]);
	}
});

com.ibm.mashups.builder.iwidget.widgetbuilder.wizard.framework.register(com.ibm.mm.builder.iwidget.widgetbuilder.outOfBoxWizards.websiteDisplayer.ContentSourcePage, {sequence : 0});