# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation 2007, 2008, 2009. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

# import related classes
import sys;
from java.lang import *;
import java.io.File as File;
import re;
import shutil;
import os;
import os.path;

print "*************************************************************************************"
print "start: init"
print ""

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

print ""
print "end: init"

def getRESTDeploymentTargets():
    print ""
    
    restDeploymentTargetsList = getObjectArray(AdminConfig.list("WBIRestDeploymentTarget"));
    
    print "The value of restDeploymentTargetsList is ", restDeploymentTargetsList
    print ""
    return  restDeploymentTargetsList;  
#endDef

def getRestWebModules(restDeploymentTarget):
    print ""

    webModulesList = getObjectArray(AdminConfig.list("WBIRestWebModule", restDeploymentTarget));
    
    print "The value of webModulesList is ", webModulesList
    print ""
    return  webModulesList; 
#endDef

def registerDefaultRESTServices(businessSpaceClusterName, businessSpaceNodeName, businessSpaceServerName):
    print ""
    
    print "The value of businessSpaceClusterName is", businessSpaceClusterName;
    print "The value of businessSpaceNodeName is", businessSpaceNodeName;
    print "The value of businessSpaceServerName is", businessSpaceServerName;
    
    bfmRestAlreadyRegistered = "False";
    taskRestAlreadyRegistered = "False";
    
    restDeploymentTargetsList = getRESTDeploymentTargets();
    
    for restDeploymentTarget in restDeploymentTargetsList:
        contextID = AdminConfig.showAttribute(restDeploymentTarget, "contextID");
        print ""
        print "The current deployment target context ID is ", contextID 
        contextIDValues = contextID.split(":");
                
        webModulesList = getRestWebModules(restDeploymentTarget);
                
        for webModule in webModulesList:
            print ""
            
            currentWebModuleName = AdminConfig.showAttribute(webModule, "name");
            print "The value of currentWebModuleName is", currentWebModuleName 
        
            applicationName = AdminConfig.showAttribute(webModule, "applicationName");
            print "The value of applicationName is ", applicationName
                                            
            default = AdminConfig.showAttribute(webModule, "default");
            print "The value of default is ", default

            if (currentWebModuleName == "rest.gateway.war") and (applicationName == "REST Services Gateway Dmgr"):                
                default = "true";
                print "Resetting the default to ", default
            
            if not (default == None) and (default == "true"):
                print ""
                
                if (currentWebModuleName == "bfmrestapi.war"):
                    if (bfmRestAlreadyRegistered == "True"):
                        continue
                    else:
                        bfmRestAlreadyRegistered = "True"
                                        
                if (currentWebModuleName == "taskrestapi.war"):
                    if (taskRestAlreadyRegistered == "True"):
                        continue
                    else:
                        taskRestAlreadyRegistered = "True"


                if len(contextIDValues) == 6:               
                    nodeName = contextIDValues[3];
                    serverName = contextIDValues[5];                    
                    print "The value of nodeName is ", nodeName, " - serverName is ", serverName
                    
                    print "Registering the REST service endpoints."
                    if (isEmptyString(businessSpaceClusterName) == "False"):
                        status = AdminTask.registerRESTServiceEndpoint(['-businessSpaceClusterName', businessSpaceClusterName, '-nodeName', nodeName, '-serverName', serverName])
                        print status;
                    else:
                        status = AdminTask.registerRESTServiceEndpoint(['-businessSpaceNodeName', businessSpaceNodeName, '-businessSpaceServerName', businessSpaceServerName, '-nodeName', nodeName, '-serverName', serverName])
                        print status;
                    
                elif len(contextIDValues) == 4:
                    clusterName = contextIDValues[3];
                    print "The value of clusterName is ", clusterName
                    
                    print "Registering the REST service endpoints."
                    if (isEmptyString(businessSpaceClusterName) == "False"):
                        status = AdminTask.registerRESTServiceEndpoint(['-businessSpaceClusterName', businessSpaceClusterName, '-clusterName', clusterName])
                        print status;
                    else:
                        status = AdminTask.registerRESTServiceEndpoint(['-businessSpaceNodeName', businessSpaceNodeName, '-businessSpaceServerName', businessSpaceServerName, '-clusterName', clusterName])
                        print status;
                    
                else:
                    print ""
                    print "The following context ID is not valid : ", contextID
                    continue
    print ""   
#endDef

print "*************************************************************************************"
print "start:  REST services registration migration"
print ""
try:
    cellType = getCellType();
    
    if cellType == 'STANDALONE':
        print "Migrating the stand-alone profile"
                
        registerDefaultRESTServices("", System.getProperty("local.node"), getLocalServerName());            
        
        AdminConfig.save();     
            
                                        
    elif cellType == 'DISTRIBUTED':
        print "Migrating the distributed (dmgr or customized) profile"
        # check whether the local node is a deployment manager Node
        isDMgrNode = isDMgrNode();
            
        if (isDMgrNode != "False"):
            migratedClusterName = System.getProperty("bpm.upgrade.cluster.name");
            print ""
            print "The value of migratedClusterName is ", migratedClusterName;
            
            if migratedClusterName and (isEmptyString(migratedClusterName) == "False"):
                
                registerDefaultRESTServices(migratedClusterName, "", "");        
                
                AdminConfig.save();                        
                                
        else:        
            print "Migrating the distributed custom profile"
            
            nodeID = AdminConfig.getid(getCellContext() + getNodeContext("use-local-server"));            
            print ""
            print "The value of nodeID is ", nodeID;

            servers = getObjectArray(AdminConfig.list("Server", nodeID));
            
            for server in servers:
                serverType = AdminConfig.showAttribute(server, "serverType");
                print ""
                print "The value of serverType is ", serverType
                
                if (serverType == "APPLICATION_SERVER"):
                    serverName = AdminConfig.showAttribute(server, "name");
                    print "The value of serverName is ", serverName
                    
                    clusterName = AdminConfig.showAttribute(server, "clusterName");
                    print "The value of clusterName is ", clusterName
                    
                    if (not (clusterName)) or (isEmptyString(clusterName) == "True"):
                        print "Migrating server ", serverName, " on Node ", System.getProperty("local.node");
                        
                        try:
                            registerDefaultRESTServices("", System.getProperty("local.node"), serverName);
                            
                            AdminConfig.save();
                        except:
                            print "Cannot migrate REST services configuration. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value                        
                    else:
                        print "Skipping the migration for cluster members"             
           
            
    else:
        print "Unknown cell type"
except:
    print "Cannot migrate REST services registration. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
                
            
print 
print ""
print "end: REST services registration migration"
print "*************************************************************************************"