/** Licensed Materials - Property of IBM, 5724-U69, (C) Copyright IBM Corp. 2008 - All Rights reserved.  **/
dojo.provide("com.ibm.mm.builder");
if(!dojo._hasResource["com.ibm.mm.builder.dnd.Avatar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.Avatar"] = true;
/**
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.Avatar");

dojo.declare("com.ibm.mm.builder.dnd.Avatar", dojo.dnd.Avatar, {

	construct: function(){
		
		var a = dojo.doc.createElement("div");
		a.className = "dojoDndAvatar";
		a.style.position = "absolute";
		a.style.zIndex = 1999;
		a.style.margin = "0px"; // to avoid dojo.marginBox() problems with table's margins
		var k = Math.min(5, this.manager.nodes.length);
		var source = this.manager.source, node;
		for(var i = 0; i < k; ++i){
			if(source.creator){
				// create an avatar representation of the node
				node = source._normalizedCreator(source.getItem(this.manager.nodes[i].id).data, "avatar").node;
			}else{
				// or just clone the node and hope it works
				node = this.manager.nodes[i].cloneNode(true);
				if(node.tagName.toLowerCase() == "tr"){
					// insert extra table nodes
					var table = document.createElement("table"),
						tbody = document.createElement("tbody");
					tbody.appendChild(node);
					table.appendChild(tbody);
					node = table;
				}
			}
			node.id = "";
			a.appendChild(node);
		}
		this.node = a;
	},
	
	update: function(){
		//no need to update avatar in mashups
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.Manager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.Manager"] = true;
/**
 * Lotus Mashups DND manager
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.Manager");




var dojoDndManagerOffsetX = dojo.dnd.manager().OFFSET_X;
var dojoDndManagerOffsetY = dojo.dnd.manager().OFFSET_Y;

var dojoDndManagerStartDrag = dojo.dnd.manager().startDrag;
dojo.dnd.manager().startDrag = function(source, nodes, copy){
	if (source && source.declaredClass &&
		source.declaredClass.indexOf("com.ibm.mm.builder.dnd") === 0) {
	
		dojo.dnd.manager().OFFSET_X = 1;
		dojo.dnd.manager().OFFSET_Y = 1;
	}
	dojoDndManagerStartDrag.call(this, source, nodes, copy);
}

var dojoDndManagerStopDrag = dojo.dnd.manager().stopDrag;
dojo.dnd.manager().stopDrag = function(){
	if (this.source && this.source.declaredClass &&
		this.source.declaredClass.indexOf("com.ibm.mm.builder.dnd") === 0) {
		
		dojo.dnd.manager().OFFSET_X = dojoDndManagerOffsetX;
		dojo.dnd.manager().OFFSET_Y = dojoDndManagerOffsetY;
	}
	dojoDndManagerStopDrag.call(this);
}

var dojoDndManagerOnMouseMove = dojo.dnd.manager().onMouseMove;
dojo.dnd.manager().onMouseMove = function(e){
	if (this.source && this.source.moving) {
		this.source.moving(e);
	
	} else {
		dojoDndManagerOnMouseMove.call(this, e);
	}
}

var dojoDndManagerMakeAvatar = dojo.dnd.manager().makeAvatar;
dojo.dnd.manager().makeAvatar = function(){
	if (this.source && this.source.declaredClass && 
		this.source.declaredClass.indexOf("com.ibm.mm.builder.dnd") === 0) {
		return new com.ibm.mm.builder.dnd.Avatar(this);
	
	} else {
		return dojoDndManagerMakeAvatar.call(this);
	}
}

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.FreeformSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.FreeformSource"] = true;
/**
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.FreeformSource");

/**
 * FreeformSource is the drop target of one column in free form
 */
dojo.declare("com.ibm.mm.builder.dnd.FreeformSource", dojo.dnd.AutoSource, {
	
	accept: ["iWidgetDefinition", "iWidgetInstance"],
	withHandles: true,
	
	constructor: function(node, params){
		dojo.subscribe("/dnd/cancel", this, "onDndDragOut");
		this.logger = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dnd.FreeformSource");
	},
	
	onDropExternal: function(source, nodes, copy){
		try {
			var draggedNodeId = nodes[0].id;
			var item = source.getItem(draggedNodeId)
			var type = item && item.type && item.type[0];
			var constraints = dojo.coords(this.node, true);
			var _position = {
				x: Math.max(this._last_drop_X - constraints.x, 0),
				y: Math.max(this._last_drop_Y - constraints.y, 0)
			};

			if(type === "iWidgetDefinition"){
				var defaultWidgetWidth = com.ibm.mm.builder.constant.defaultWidgetWidth;
				if (constraints.w - _position.x < defaultWidgetWidth) {
					_position.x = constraints.w - defaultWidgetWidth;
				}
				this.layout.createWidget(item.data, {position: _position});
			}else{
				this.layout.displayWidget({id: item.data, position: _position});
			}
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		} catch (e) {
			this.logger.severe("onDropExternal", e.message);
		}
	},
	
	onDropInternal: function(nodes, copy){
		try {
			this.inherited(arguments);
			this._moveDraggedNode(this.getSelectedNodes()[0]);
		} catch (e) {
			this.logger.severe("onDropInternal", e.message);
		}
	},
	
	onDndDragOut: function(){
		try {
			if(dojo.dnd.manager().source !== this) return;
			
			var draggedWidgetSkin = this.getSelectedNodes()[0]
			var draggedWidgetSpan = dojo.query(".mm_iWidget", draggedWidgetSkin)[0];
			
			this.layout.focusWidget(draggedWidgetSpan.id);
			this._moveDraggedNode(draggedWidgetSkin);
			
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		} catch (e) {
			this.logger.severe("onDndDragOut", e.message);
		}


	},
	
	onMouseMove: function(e){
		try {
			com.ibm.mm.builder.dnd.FreeformSource.superclass.onMouseMove.call(this, e);
				if (this.isDragging) {
					var m = dojo.dnd.manager();
					if (this === m.source && m.avatar && m.avatar.node && m.avatar.node.style.marginLeft === "0px" && (dojo.isOpera || e.layerX > 0)) {
						var ml = dojo.isOpera ? e.offsetX: e.layerX;
						if(!builderConfig.isBidi){
							m.avatar.node.style.marginLeft = "-" + ml + "px";
						}else{
							m.avatar.node.style.marginLeft = "-" + (parseInt(this.getSelectedNodes()[0].style.width) - e.layerX) + "px";
						}
						m.avatar.node.style.marginTop = 34 + "px";
						this.marginLeft = ml;
					}
				}
		} catch (e) {
			this.logger.severe("onMouseMove", e.message);
		}
	},
	
	onMouseUp: function(e){
		try {
			this._last_drop_X = e.pageX;
			this._last_drop_Y = e.pageY;
			com.ibm.mm.builder.dnd.FreeformSource.superclass.onMouseUp.call(this, e);
		} catch (e) {
			this.logger.severe("onMouseUp", e.message);
		}
	},
	
	onDndCancel: function(){
		try {
			if( this === dojo.dnd.manager().source ){ com.ibm.mm.builder.utils.htmlUtil.showNodes(dojo.dnd.manager().nodes); }
				this.inherited(arguments);
		} catch (e) {
			this.logger.severe("onDndCancel", e.message);
		}
	},
	
	onDndStart: function(source, nodes, copy){
		try {
			if(this === source){ com.ibm.mm.builder.utils.htmlUtil.hideNodes(nodes); }
				this.inherited(arguments);
		} catch (e) {
			this.logger.severe("onDndStart", e.message);
		}
	},
	
	/*
	 * move dragged node to avatar's position
	 */
	_moveDraggedNode: function(widgetNode){
		try {
			var m = dojo.dnd.manager();
				var cst = dojo.coords(this.node);
				var ac = dojo.coords(m.avatar.node);
				dojo.marginBox(widgetNode, {l:ac.x  - cst.x, t: ac.y  - cst.y});
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		} catch (e) {
			this.logger.severe("_moveDraggedNode", e.message);
		}
	},
	
	moving: function(e){
		try {
			var m = dojo.dnd.manager();
			var avatar = m.avatar;
			if(!avatar){
				return false;
			}
			dojo.dnd.autoScroll(e);
			
			var a = dojo.coords(avatar.node);
			var ml = parseInt(avatar.node.style.marginLeft) || 0;
			//avatar container coords
			var ac = {
				l: (e.pageX + m.OFFSET_X),
				t: (e.pageY + m.OFFSET_Y),
				w: a.w - ml,
				h: a.h
			};
			
			var cst = dojo.coords(this.node, true);
			//source constrained area
			var c = {
				l:cst.x + 1 - ml,
				r:cst.x + cst.w - ml - ac.w, 
				t:cst.y - 34,
				b:cst.y + cst.h - ac.h
			};
			//limit four direction.
			//avatar.node.style.left = (ac.l < c.l ? c.l : c.r < ac.l ? c.r : ac.l) + "px";
			//avatar.node.style.top = (ac.t < c.t ? c.t : c.b < ac.t ? c.b : ac.t) + "px";
			//limit only top-left direction.
			var al = ac.l < c.l ? c.l : (c.r < ac.l ? c.r : ac.l);
			var at = ac.t < c.t ? c.t : (c.b < ac.t ? c.b : ac.t);
			dojo.marginBox(avatar.node, {l: al, t: at});
			//adjust the width
			com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeMoved(null, ac.l, ac.w);
			//adjust the height
			if (e.pageY > c.b) {
			   var newHeight = (e.pageY + ac.h);
			   dojo.style(this.node, "height", newHeight + "px");
			   //Also change the freeform div height to fix defect 8342
			   dojo.byId(this.layout.iContext.widgetId).style.height = newHeight+"px";
			}
		} catch (e) {
			this.logger.severe("moving", e.message);
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireTarget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireTarget"] = true;
/**
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.QuickWireTarget");

/**
 * FreeformSource is the drop target of one column in free form
 */
dojo.declare("com.ibm.mm.builder.dnd.QuickWireTarget", dojo.dnd.Target, {
	
	accept: ["iWidgetDefinition", "iWidgetInstance"],
	
	handler:null,
	
	onDndDrop: function(source, nodes, copy, target){
		try {
			this.inherited(arguments);
		} catch (e) {
			//the source node will be null for unknown reason.
		}
	},
	
	onDropExternal: function(source, nodes, copy){
		var sid = nodes[0].getAttribute("dnddata");
		if(nodes[0].getAttribute("dndtype") === "iWidgetDefinition"){
			sid = this.layout.createWidget(nodes[0].getAttribute("dnddata"));
		}
		//hide before do autowire
		com.ibm.mm.builder.utils.iwidgetUtil.hideWidget(sid);
		var self = this;
		this.handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(sid, function(){
			var payload = {
				sourceWidgetId: sid,
				targetWidgetId: self.targetId,
				callBackFuncContext: self,
				callbackFunc: "moveEffect"
			}
			var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
			es.broadcastEvent("com.ibm.mashups.builder.createQuickWire", payload);
			com.ibm.mm.builder.utils.iwidgetUtil.showWidget(sid);
			self.disconnectHandler();
		});
	},
	
	disconnectHandler:function(){
		if (this.handler){
			com.ibm.mashups.services.ServiceManager.getService("eventService").unsubscribeEvent(this.handler,null);
		}
	}
});

com.ibm.mm.builder.dnd.QuickWireTargetMap = {};

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.ACLSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.ACLSource"] = true;
dojo.provide("com.ibm.mm.builder.dnd.ACLSource");

dojo.declare("com.ibm.mm.builder.dnd.ACLSource",dojo.dnd.AutoSource,{
	
	checkAcceptance: function(source, nodes){
		//prevent dropping nodes to the  searchSouce
		 return (this.name != "aclSearch");
	},
	
	onDndCancel: function(){
		try {
			if (this.node && this.node.childNodes) {
				com.ibm.mm.builder.utils.htmlUtil.uncheckAll(this.node.childNodes);
			}
		} catch (e) {}
		this.inherited(arguments);
	},
	
	onDropExternal: function(source, nodes, copy){
		var draggedNodes = dojo.dnd.manager().avatar.node.childNodes[0].childNodes;
		if(source.name == "aclSearch"){
			draggedNodes = this.layout.checkDraggedNode(source,this,draggedNodes);
		}
		var anchor = this.before ? this.targetAnchor : (this.targetAnchor ? this.targetAnchor.nextSibling : null);
		dojo.forEach(draggedNodes,function(item){
			this.layout.transferNode(source,this,item.id,anchor,(source.name === "aclSearch"));
			if(!this.before && anchor != null){ anchor = anchor.nextSibling; }
		},this);
		dojo.publish(source.name);
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateAllPageControl);
	},
	
	
	onDropInternal: function(nodes, copy){},
	
	destroy: function(){
		dojo.forEach(this.container,"item.destroy();");
		this.inherited(arguments);
	}
});

com.ibm.mm.builder.dnd.ACLSource.createSource = function(domNode,accept,layout,name,listLengthPerPage,hiddenNodes){
	return new com.ibm.mm.builder.dnd.ACLSource(domNode,{
		accept:accept,
		layout:layout,
		name:name,
		listLengthPerPage:listLengthPerPage,
		container:[],
		allStayedUsers:{},
		currentPage:1,
		totalPage:1,
		
		creator: function(item, hint){
			if (hint == "avatar") {
				var n = document.createElement("div");
				dojo.forEach(this.node.childNodes, function(item){
					var checkBox = dojo.query("input", item)[0];
					if (checkBox.checked) {
						checkBox.checked = false;
						dojo.removeClass(item, this.name + "ItemHover");
						var cloneDraggedNode = item.cloneNode(true);
						n.appendChild(cloneDraggedNode);
					}
				},this);
				return { node: n, data: item, type: ["acluser"] };
			}
		}
	});
}

}

if(!dojo._hasResource["com.ibm.mashups.builder.model.page"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.page"] = true;
dojo.provide("com.ibm.mashups.builder.model.page" );

/**
 * This interface defines builder runtime page operations.
 * Usage: var page = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
 */
dojo.declare( "com.ibm.mashups.builder.model.Page", null, {

    /**
     * Returns builder runtime page data changed or not.
     * @ibm-api
     * @type Boolean
     * @return {Boolean} The boolean value of whether page data is dirty, if dirty, return true, if not dirty, return false. never <code>null</code>
     */
    isDirty:function(){
    	return true;
    },

    /**
     * Set builder runtime page data status.
     * @ibm-spi
     * @param {Boolean} _dirty boolean value to indicate whether page data is dirty or not, must not be <code>null</code>. 
     * @type void
     */
    setDirty:function(_dirty){
    },

    /**
     * Returns builder runtime page id.
     * @ibm-api
     * @type  String
     * @return {String} runtime page id, never <code>null</code>
     */
    getID:function(){
    	return new String();
    },

    /**
     * Set builder runtime page id
     * @ibm-spi
     * @param {String} _pid the page id to set, must not be <code>null</code>. 
     * @type void
     */
    setID:function(_pid){
    },
    
    /**
     * Returns builder runtime page mode.
     * @ibm-api
     * @type  String
     * @return {String} runtime page mode, never <code>null</code>
     */
    getPageMode:function(){
    	return new String();
    },

    /**
     * Set builder runtime page mode
     * @ibm-spi
     * @param {String} _pageMode the page mode to set, must not be <code>null</code>. 
     * @type void
     */
    setPageMode:function(_pageMode){
    },
    
    /**
     * Set auto-wiring enablement status of current page
     * @ibm-api
     * @param {Boolean} _isEnabled true/false 
     * @type void
     */
    setAutoWiringEnablement:function(_isEnabled) {
    	
    },
	
	/**
     * Return whether auto-wiring is enabled for this page
     * @ibm-api
     * @deprecated use isAutoWiringEnabled() instead.
     * @type Boolean 
     * @return  return true/false, never <code>null</code>
     */
    getAutoWiringEnablement:function() {
		
    },
	
	/**
     * Return whether auto-wiring is enabled for this page
     * @ibm-api
     * @type Boolean 
     * @return  return true/false, never <code>null</code>
     */
	isAutoWiringEnabled:function(){
		
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.builder.model.theme"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.theme"] = true;
dojo.provide("com.ibm.mashups.builder.model.theme" );

/**
 * This interface defines builder runtime theme operation.
 * Usage: var theme = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
 */
dojo.declare( "com.ibm.mashups.builder.model.Theme", null, {

    /**
     * Returns builder runtime theme id
     * @ibm-api
     * @type    String
     * @return  runtime theme id, never <code>null</code>
     */
    getID:function(){
    	return new String();
    },

    /**
     * Set builder runtime theme id
     * @param {String} _themeId theme id to set, must not be <code>null</code>. 
     * @ibm-spi
     * @type void
     */
    setID:function(_themeId){
    },
    
    /**
     * Register the layout widget id in theme model
     * @param {String} _layoutId layout widget id in theme.html
     * @ibm-spi
     * @type void
     */
    registerLayout:function(_layoutId){
    },
    
    /**
     * Return array which contains all layout widgets' id in current theme.
     * @ibm-api
     * @type Array
     * @return all layout widget's id, never <code>null</code>
     */
    getLayouts:function(){
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.builder.model.contextMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.contextMenu"] = true;
dojo.provide("com.ibm.mashups.builder.model.contextMenu" );

/**
 * This interface defines builder runtime page operations.
 */
dojo.declare( "com.ibm.mashups.builder.model.ContextMenu", null, {

 	/**
     * Returns a array of JSON objects for a given collection of menu choices for the selected context menu. <br/>
	 * JSON object format <br/>
     * { <br/>
	 * &nbsp;&nbsp;&nbsp;&nbsp;isSeparator: true/false, whether this item is a menu separator,<br/>
	 * &nbsp;&nbsp;&nbsp;&nbsp;iconClass: icon class name for menu item,<br/>
	 * &nbsp;&nbsp;&nbsp;&nbsp;description: item description,<br/>
	 * &nbsp;&nbsp;&nbsp;&nbsp;title: menu item title,<br/>
	 * &nbsp;&nbsp;&nbsp;&nbsp;localized: com.ibm.mashups.enabler.Localized,contains titles and descriptions for all supported locales,   <br/> 
     * &nbsp;&nbsp;&nbsp;&nbsp;enabled: true/false, whether this item is enabled,<br/>
	 * &nbsp;&nbsp;&nbsp;&nbsp;id: the id if listed, the id if listed, otherwise, null,v
	 * &nbsp;&nbsp;&nbsp;&nbsp;ordinal:  this could be null, which means it wasn't provided in the xml, so should add it to the end of the context menu,v
     * &nbsp;&nbsp;&nbsp;&nbsp;actionCallBackFunction: some_javascript_function_from_configuration_file(somepassedinResourceID,somepassedinResourceType, _metadata,_someObject)<br/>
     * }<br/>
     * @ibm-api
     * @param {String} _contextMenuItemId  this is from the list of possible menu items like: (ContextMenu.page, ContextMenu.space, ContextMenu.toolbox, ContextMenu.modeSelector ContextMenu.widgetSkin, or any additional extension, must not be <code>null</code>.
     * @param {String} _targetResourceId this is the resource that you want to associate the decision for this menu choice with. This will be passed into the label provider function referenced in the contextmenu configuration file, must not be <code>null</code>.  
     * @param {String} _targetResourceType this is the resource type to so we can pass that into the labelprovider javascript function.  Possible values for would be "com.ibm.mashups.enabler.space.SpaceNode" or "com.ibm.mashups.iwidget.widget.IWidgetDefinition" or "com.ibm.mashups.enabler.navigation.NavigationNode"  
	 * @param {Object} _someObject this allows an arbitrary object to be passed into all 3 function invocations, in case they need additional data for making the decisions. 
	 * @type Array
     * @return {Array} A JSON object array of menu choices, or <code>null</code> if no choices exist for that context menu
	 */
    getContextMenu:function(_contextMenuItemId,_targetResourceId, _targetResourceType, _someObject){
    	      return null;
  	}
			  

});

}

if(!dojo._hasResource["com.ibm.mashups.builder.model.runtimemodel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.runtimemodel"] = true;
dojo.provide("com.ibm.mashups.builder.model.runtimemodel");





/**
 * Interface representing builder runtime model
 * Usage: var runtimeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel();
 */
dojo.declare( "com.ibm.mashups.builder.model.RuntimeModel", null, {
    
    /**
     * Returns the builder context menu model
     * @type    com.ibm.mashups.builder.model.ContextMenu
     * @return  context menu model, never <code>null</code>
     */
    getCurrentContextMenu: function() {
        return new com.ibm.mashups.builder.model.ContextMenu();
    },
    
    /**
     * Returns the builder page model
     * @ibm-api
     * @type    com.ibm.mashups.builder.model.Page
     * @return  page model, never <code>null</code>
     */
    getCurrentPage: function() {
        return new com.ibm.mashups.builder.model.Page();
    },
    
    /**
     * Returns the builder theme model
     * @ibm-api
     * @type    com.ibm.mashups.builder.model.Theme
     * @return  theme model, never <code>null</code>
     */
    getCurrentTheme: function() {
        return new com.ibm.mashups.builder.model.Theme();
    }
    
});

}

if(!dojo._hasResource["com.ibm.mashups.builder.model.factory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.factory"] = true;
dojo.provide("com.ibm.mashups.builder.model.factory");




/**
* Interface for an builder runtime model factory.
*/
dojo.declare( "com.ibm.mashups.builder.model.Factory", null, {
    
    /**
     * Returns builder runtime model
     * @ibm-api
     * @type    com.ibm.mashups.builder.model.RuntimeModel
     * @return  runtime model, never <code>null</code>
     */
    getRuntimeModel: function() {
        return new com.ibm.mashups.builder.model.RuntimeModel();
    }, 
	
	/**
     * Returns the builder context menu model
     * @ibm-api
     * @type    com.ibm.mashups.builder.model.ContextMenu
     * @return  context menu model, never <code>null</code>
     */
	getContextMenuModel: function(){
		return new com.ibm.mashups.builder.model.ContextMenu();
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.builder.model"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model"] = true;
dojo.provide("com.ibm.mashups.builder.model");







}

if(!dojo._hasResource["com.ibm.mm.builder.model.page"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model.page"] = true;
dojo.provide("com.ibm.mm.builder.model.page");



/**
 * Implementation of builder runtime page model.
 */
dojo.declare( "com.ibm.mm.builder.model.PageImpl", [com.ibm.mashups.builder.model.Page], {
    
	dirty:false,
	
	currentPageId:null,
	
	currentPageMode:null,
	
	isAutoWiringEnabled:builderConfig.pageAutoWiringDefault,

    isDirty:function(){
    	return this.dirty;
    },

    setDirty:function(_dirty){
    	this.dirty = _dirty;
		dojo.publish(com.ibm.mm.builder.eventTopics.Save_Icon_Change, [_dirty]);
    },

    getID:function(){
    	return this.currentPageId;
    },

    setID:function(_pid){
    	this.currentPageId = _pid;
    },
    
    getPageMode:function(){
    	return this.currentPageMode;
    },

    setPageMode:function(_pageMode){
    	this.currentPageMode = _pageMode;
    },

    setAutoWiringEnablement:function(_isEnabled) {
    	//eval the input param in case it's a "string" (IE)
		if(_isEnabled != null && (_isEnabled == "true" || _isEnabled == "false" || _isEnabled == true || _isEnabled == false)){
			this.isAutoWiringEnabled = eval(_isEnabled)
		}else{
			this.isAutoWiringEnabled = builderConfig.pageAutoWiringDefault;
		}
    },
    
    getAutoWiringEnablement:function() {
    	return this.isAutoWiringEnabled;
    },
	
	isAutoWiringEnabled:function(){
		return this.isAutoWiringEnabled;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.model.theme"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model.theme"] = true;
dojo.provide("com.ibm.mm.builder.model.theme");



/**
 * Implementation of builder runtime page model.
 */
dojo.declare( "com.ibm.mm.builder.model.ThemeImpl", [com.ibm.mashups.builder.model.Theme], {
    
	currentThemeId:null,
	
	layouts: null,
	
	constructor: function(){
		this.layouts = new Array();
	},
	
	_hasRegister:function(_layoutId) {
		for(var i = 0; i < this.layouts.length; i++){
			if(_layoutId == this.layouts[i])
				return true;
		}
		return false;
	},
	
	registerLayout:function(_layoutId) {
		if(!this._hasRegister(_layoutId))
			this.layouts.push(_layoutId);
	},
	
	getLayouts:function(){
		return this.layouts;
    },
    
    getID:function(){
    	return this.currentThemeId;
    },
	
    setID:function(_themeId){
    	this.currentThemeId = _themeId;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.builder.model.contextMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model.contextMenu"] = true;
dojo.provide("com.ibm.mm.builder.model.contextMenu");

dojo.require("dojox.data.dom" );

//dojo.require("com.ibm.mashups.enabler.xml" );
//dojo.require("com.ibm.mm.enabler.xpath");
//dojo.require("com.ibm.mashups.enabler.model.shared");

dojo.declare( "com.ibm.mm.builder.Localized", com.ibm.mashups.enabler.Localized, {
	
	ns : { "cm" : "http://www.ibm.com/xmlns/prod/sw/context-menu/1.0"},
	
    constructor:function () {
		this._data = new Array();
    },

    /**
     * Returns a list model containing the locales that are supported by this
     * object. The presence of a locale in this list does not mean that a title
     * <b>and</b> description is available, but rather that either one or both are available in that locale.
     * @return {Array} a list of locales defined for this object, returns an 
     * empty array if no locales are supported. Can never be <code>null</code>.
     */
    getLocales: function() {
		var ret = new Array();
        for (var i = 0; i < this._data.length; ++i) {
			ret.push(this._data[i].locale);
		}		
        return ret;
    },

    /**
     * Returns the title of this object in the given locale.
     * @param {String} locale the locale for which to retrieve the title, 
     * must not be <code>null</code>.
     * @return {String} the title of this node in the given locale. If a title is not
     * available in the given locale, this method will return <code>null</code>. 
     * It is up to the invoker of the method to implement an appropriate fallback mechanism.
     */
    getTitle: function(locale) {
    	var def = 0;
        for (var i = 0; i < this._data.length; ++i) {
			if (this._data[i].locale.toLowerCase().replace("_","-") == locale) {
				return this._data[i].title;
			} else {
				if (!def && this._data[i].locale.toLowerCase().replace("_","-") == ibmConfig["default.locale"])
					def = i;
			}
		}		
        return (this._data[def] && this._data[def].title) ? this._data[def].title : null; 
    },


    /**
     * Returns the description of this object in the given locale.
     * @param {String} locale   the locale for which to retrieve the 
     * description, must not be <code>null</code>.
     * @return {String} the description of this node in the given locale. If a 
     * description is not available in the given locale, this method 
     * will return <code>null</code>. It is up to the invoker of the 
     * method to implement an appropriate fallback mechanism.
     */
    getDescription: function(locale) {
    	var def = 0;
        for (var i = 0; i < this._data.length; ++i) {
			if (this._data[i].locale.toLowerCase().replace("_","-") == locale) {
				return this._data[i].description;
			} else {
				if (!def && this._data[i].locale.toLowerCase().replace("_","-") == ibmConfig["default.locale"])
					def = i;
			}
		}	
		return (this._data[def] && this._data[def].description) ? this._data[def].description : null; 
    },
	
	setTitles: function(_node){
		var titles = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("cm:title/cm:nls-string", _node, this.ns);
		var i = titles.length;
		if (i > 0) { 
			while (--i >= 0) {
				var lang = com.ibm.mm.enabler.utilities.getAttributeWithNS(titles[i], "xml:lang", "lang", com.ibm.mm.enabler.model.NameSpaceFactory.getNameSpaceUri("xml"));
				if (lang !== null) {
					var title = titles[i].firstChild.nodeValue;
					var anItem = {
						"locale": lang,
						"title": title,
						"description": null
					};
				}
				this._data.push(anItem);
			}
		}
		else { // Try to use the content of element "title" if there is no nls string
			var titles = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("cm:title", _node, this.ns);
			if(titles.length > 0) {
				var anItem = {
						"locale": "en",
						"title": titles[0].firstChild.nodeValue,
						"description": null
				};
				this._data.push(anItem);
			}
		}
	},
	
    /**
     * Sets the title for the given locale.
     * @param {String} title    title to set; must not be <code>null</code>
     * @param {String} locale   locale to set the title for; must not be <code>null</code>
     * @return <code>null</code> 
     */
    setTitle: function(title, locale) {
		locale.replace(/-/g, "_");
		for (var i = 0; i < this._data.length; ++i) {
			if (this._data[i].locale == locale)
			{
				this._data[i].title = title;
				return null;				
			}
		}
		var anItem = {"locale":locale,"title":title,"description":null};
		this._data.push(anItem);
		return null;
    },

    /**
     * Sets the description for the given locale.
     * @param {String} desc     description to set; must not be <code>null</code>
     * @param {String} locale   locale to set the description for; must not be <code>null</code>
     * @return <code>null</code>
     */
    setDescription: function(desc, locale) {
		for (var i = 0; i < this._data.length; ++i) {
			if (this._data[i].locale == locale)
			{
				this._data[i].description = desc;
				return null;				
			}
		}
		var anItem = {"locale":locale,"title":null,"description":desc};
		this._data.push(anItem);
		return null;
    }

});

              
/**
 * Implementation of builder runtime context menu model.
 */
dojo.declare( "com.ibm.mm.builder.model.ContextMenuImpl", [com.ibm.mashups.builder.model.ContextMenu], {
    
	ns : { "cm" : "http://www.ibm.com/xmlns/prod/sw/context-menu/1.0"},

	xmlData:null,
	
    CONTEXT_MENU_PROVIDER: "ContextMenu_Provider",
	
	LOGGER : com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.model.ContextMenuImpl"),
	
	getContextMenu:function(_contextMenuItemId,_targetResourceId, _targetResourceType, _someObject){
        var ret = []; 
		this._loadAhead();
        if (this.xmlData)
		{
	        var expr = 'cm:contextmenu/cm:menu[@definition="'+_contextMenuItemId+'"]'; 
	        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this.xmlData, this.ns);
			if (nodes && nodes.length > 0)
			{
		        expr = "cm:contextMenuItem";
		        var subnodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, nodes[0], this.ns);
				if (subnodes && subnodes.length > 0)
				{
			        for (var i = 0; i < subnodes.length; ++i) {		
						var myMetadata = this._getMetaData("cm:meta-data", subnodes[i]);
						myMetadata = myMetadata.length == 0 ? null : myMetadata;
						if (this._checkVisibility(subnodes[i],_targetResourceId,_targetResourceType,myMetadata,_someObject))
						{
							var isSeparator = this._checkSeparator(subnodes[i]);
							var myLocalized = this._getLocalized(subnodes[i]);
							var mytitle = myLocalized.getTitle(dojo.locale);
							var mydescription = myLocalized.getDescription("en");
							var myIconClass = this._getIconClass(subnodes[i]);
							var myState = this._getState(subnodes[i],_targetResourceId,_targetResourceType,myMetadata,_someObject);
							var myAction = this._getFunction("cm:action-handler", subnodes[i]);
							if (myAction) 
								myAction = this._buildMethod(myAction, _targetResourceId, _targetResourceType, myMetadata, _someObject);
							var anItem = {
								"isSeparator":isSeparator,
								"localized": myLocalized,
								"title": mytitle,
								"description": mydescription,
								"iconClass":myIconClass,
								"enabled": myState,
								"id": subnodes[i].getAttribute("id"),
								"ordinal": subnodes[i].getAttribute("ordinal"),
								"actionCallBackFunction": myAction
							};
							ret.push(anItem);					
						}
					}
				}
			}
        }        
        return ret;
  	},
	
	/**
	 * Default returns true, unless there is a javascript code that explicitly returns false "javascript:false"
	 * or state function that returns false
	 * @param {Object} _node
	 * @param {Object} _targetResourceId
	 * @param {Object} _targetResourceType
	 * @param {Object} _metadata
	 * @param {Object} _someObject
	 */
	_checkVisibility:function(_node,_targetResourceId,_targetResourceType,_metadata,_someObject){
		var visible = true;
		var myVisible = this._getFunction("cm:visibility-provider", _node);
		if (myVisible){
			try{
				visible = this._buildMethod(myVisible,_targetResourceId,_targetResourceType,_metadata,_someObject)();
				if (visible === null || visible === "") {  //Need to check this, if the visibility function returns null or nothing, then use default value
					visible = true;
				}
			}
			catch(e){
				this.LOGGER.severe("_checkVisibility",e,_node)
			}
		}
		return !!visible;
	},
	
	/**
	 * Default returns false, unless there is a attributethat explicitly defines separator="true"
	 * @param {Object} _node
	 */
	_checkSeparator:function(_node){
		var isSeparator = _node.getAttribute("separator");
		return isSeparator ? eval(isSeparator) : false;
	},
	
	/**
	 * Default Returns "enabled", unless there is a javascript code that explicitly returns false "javascript:false"
	 * or state function that returns false
	 * @param {Object} _node
	 * @param {Object} _targetResourceId
	 * @param {Object} _targetResourceType
	 * @param {Object} _metadata
	 * @param {Object} _someObject
	 */
	_getState:function(_node,_targetResourceId,_targetResourceType,_metadata,_someObject){
		var state = true;   
		var myState = this._getFunction("cm:state-provider", _node);
		if (myState)
		{
			try{
				state = this._buildMethod(myState,_targetResourceId,_targetResourceType,_metadata,_someObject)();
				if (state === null || state === "") {  //Need to check this, if the state function returns null or nothing, then use default value
					state = true;
				}
			}
			catch(e){
				this.LOGGER.severe("_getState",e,_node)
			}
		}
		return !!state ? "enabled" : "disabled";
	},
	
	_buildMethod:function(_myMethod,_targetResourceId,_targetResourceType,_metadata,_someObject){
		var method = null;
		try {
			if (_myMethod.match("^" + "javascript:") == "javascript:") {  // deal with something like "javascript:alert(1)" or "javascript:false", even "javascript:this.inNva"
				if (_someObject && _someObject["context"]) {
					method = dojo.hitch(_someObject["context"], function(){
						return eval(_myMethod);
					})
				}
				else {
					method = function(){
						return eval(_myMethod);
					}
				}
			}
			else {
				if (_someObject && _someObject["context"]) {
					method = dojo.hitch(_someObject["context"],function(){
						return eval(_myMethod).call((_someObject && _someObject["context"]) ? _someObject["context"] : this, _targetResourceId, _targetResourceType, _metadata, _someObject)
					})
				}else{
					method = function(){
						return eval(_myMethod).call(this, _targetResourceId, _targetResourceType, _metadata, _someObject)
					}
				}
			}
		}catch(e){
			this.LOGGER.severe("_buildMethod",e,_myMethod)
			method = function(){};  //never return null to avoid the possible error when the function is invoked
		}
		return method;  
	},
	
	_getLocalized:function(_node){
		var myloc = new com.ibm.mm.builder.Localized();
		myloc.setTitles(_node);
        nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("cm:description", _node, this.ns);
		if (nodes && nodes.length > 0)
		{ 
			myloc.setDescription(nodes[0].firstChild.nodeValue,"en");
		}
		return myloc;
	},	
	
	_getFunction:function(_expr, _node){
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(_expr, _node, this.ns);
		if (nodes && nodes.length > 0 && nodes[0].firstChild)
		{
			return nodes[0].firstChild.nodeValue;
		}
		return null;
	},	
	
	/**
	 * Default returns null, unless there is a attributethat explicitly defines an iconClass value
	 * @param {Object} _node
	 */
	_getIconClass:function(_node){
		return _node.getAttribute("iconClass");
	},

	_getMetaData:function(_expr, _node){
		var myArray = [];
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(_expr, _node, this.ns);
		if (nodes && nodes.length > 0)
		{
	        for (var i = 0; i < nodes.length; ++i) {
				if (nodes[i].firstChild) {
					var anItem = {
						"key": nodes[i].firstChild.nodeValue,
						"value": nodes[i].firstChild.nodeValue
					};
					myArray.push(anItem);
				}
			}
		}
		return myArray;
	},	

    _loadAhead: function() {
        if (this.xmlData != null) return;
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var co = cs.getConfigObject(this.CONTEXT_MENU_PROVIDER);
		this.xmlData = dojox.data.dom.createDocument(co.getValue("contextmenu.xml"));	
    }
});

}

if(!dojo._hasResource["com.ibm.mm.builder.model.runtimemodel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model.runtimemodel"] = true;
dojo.provide("com.ibm.mm.builder.model.runtimemodel");






/**
 * Implementation of builder runtime model
 */
dojo.declare( "com.ibm.mm.builder.model.RuntimeModelImpl", [com.ibm.mashups.builder.model.RuntimeModel], {
    
	page:null,
	
	theme:null,
	
	contextMenu:null,
	
	getCurrentContextMenu: function() {
		if (!this.contextMenu){
			this.contextMenu = new com.ibm.mm.builder.model.ContextMenuImpl();
		}
        return this.contextMenu;
    },
    
	getCurrentPage: function() {
		if (!this.page){
			this.page = new com.ibm.mm.builder.model.PageImpl();
		}
        return this.page;
    },
    
    getCurrentTheme: function() {
    	if (!this.theme){
    		this.theme = new com.ibm.mm.builder.model.ThemeImpl();
    	}
        return this.theme;
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.builder.model.factory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model.factory"] = true;
dojo.provide("com.ibm.mm.builder.model.factory");





/**
 * Implementation of builder factory model
 */
dojo.declare( "com.ibm.mm.builder.model.FactoryImpl", [com.ibm.mashups.builder.model.Factory], {
	
	builderRuntimeModel:null,
	contextMenuModel:null,
	
    getRuntimeModel: function() {
		if (!this.builderRuntimeModel){
			this.builderRuntimeModel = new com.ibm.mm.builder.model.RuntimeModelImpl();
		}
        return this.builderRuntimeModel;
    },
	
	getContextMenuModel: function() {
		if (!this.contextMenuModel){
			this.contextMenuModel = new com.ibm.mm.builder.model.ContextMenuImpl();
		}
        return this.contextMenuModel;
    }
});

//public factory
com.ibm.mashups.builder.model.Factory = new com.ibm.mm.builder.model.FactoryImpl();

}

if(!dojo._hasResource["com.ibm.mm.builder.model"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model"] = true;
dojo.provide("com.ibm.mm.builder.model");


}

if(!dojo._hasResource["com.ibm.mm.builder.utils.userUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.userUtil"] = true;
/**
 * author EriK (bizheng@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.userUtil");

com.ibm.mm.builder.utils.userUtil.isLookasideEnabled = function(attName){
	var lookasideAttNames = this.getUserModel().getLookasideAttributeNames().start();
	
	if ((typeof lookasideAttNames == "undefined") || (lookasideAttNames == null) || (lookasideAttNames.length == 0)) {
		return false;
	}

	if ((typeof attName == "undefined") || (attName == null)) {
	   return true;	
	}
	
	for (var i = 0; i < lookasideAttNames.length; i++) {
		if (attName == lookasideAttNames[i]) {
			return true;
		}
	} 

	return false;
}


com.ibm.mm.builder.utils.userUtil.getCurrentUser = function(){
	return this.getUserModel().findCurrentUser().start();
}

com.ibm.mm.builder.utils.userUtil.getCurrentUserID = function(){
	return this.getUserModel().findCurrentUser().start().getID();
}

com.ibm.mm.builder.utils.userUtil.getUserModel = function() {
	if(com.ibm.mm.builder.userModel == null)
		com.ibm.mm.builder.userModel = com.ibm.mashups.enabler.model.Factory.getUserModel();
	return com.ibm.mm.builder.userModel;
}

com.ibm.mm.builder.utils.userUtil.getAnonymousMode = function(){
	return this.getUserModel().getAnonymousMode();
}

com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode = function(){
	// there will be three mode of the return value from getAnonymousMode()
	// com.ibm.mashups.enabler.user.AnonymousMode.ANONYMOUS  -> nomral anonymous mode, most of the actions disabled
	// com.ibm.mashups.enabler.user.AnonymousMode.USER  -> extended anonymous mode, confirmable api to check further permission
	// com.ibm.mashups.enabler.user.AnonymousMode.OFF   -> anonymous is off
	return this.getAnonymousMode() === com.ibm.mashups.enabler.user.AnonymousMode.ANONYMOUS;
}

com.ibm.mm.builder.userModel = null;

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.enablerUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.enablerUtil"] = true;
/**
 * @author Jove (zhongqj@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.enablerUtil");

/**
 * 
 * @param {String} key
 * @return {String} if the key is never saved, null will be returned
 */	
com.ibm.mm.builder.utils.enablerUtil.getPageMetaData=function(key,pageId){
	var currentPage = null;
	if (typeof pageId != "undefined"){
		currentPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId); 
	}else{
		currentPage = com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
	}
	
	if(currentPage){
		var layoutModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().getLayoutModel(currentPage.getID());
		if(layoutModel) {
			var lmRoot = layoutModel.getRoot().start();
			if (lmRoot){
				return lmRoot.getMetaData(key);
			}
		}
	}
	return null;
}

com.ibm.mm.builder.utils.enablerUtil.setPageMetaData = function(key, value, pageId){
	var pageNode = pageId ? com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId) : 
		com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
	if (pageNode) {
		var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
		var layoutModel = navModel.getLayoutModel(pageNode.getID());
		if (layoutModel) {
			var lmRoot = layoutModel.getRoot().start();
			if (lmRoot) {
				lmRoot.setMetaData(key, value);
				navModel.commit().start();
			}
		}
	}
}

com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData = function(metadata, pageId){
	var pageNode = pageId ? com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId) : 
		com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
	if (pageNode) {
		var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
		var layoutModel = navModel.getLayoutModel(pageNode.getID());
		if (layoutModel) {
			var lmRoot = layoutModel.getRoot().start();
			if (lmRoot) {
				for (var key in metadata) {
					lmRoot.setMetaData(key, metadata[key]);
				}
				navModel.commit().start();
			}
		}
	}
}

com.ibm.mm.builder.utils.enablerUtil.removePageMetaData = function(keys, pageId){
	var pageNode = pageId ? com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId) : 
		com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
	if (pageNode) {
		var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
		var layoutModel = navModel.getLayoutModel(pageNode.getID());
		if (layoutModel) {
			var lmRoot = layoutModel.getRoot().start();
			if (lmRoot) {
				dojo.forEach(keys, function(key){
					if(key != "com.ibm.mashups.acl.role.USER" && key != "com.ibm.mashups.acl.role.EDITOR") 
					lmRoot.removeMetaData(key);
				})
				navModel.commit().start();
			}
		}
	}
}

com.ibm.mm.builder.utils.enablerUtil.getUnescapedNodeTitle = function(node, locale){
	if (!node) { return null; }
	var nodeLocale = null;
	try {
		var lc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
		nodeLocale = lc.getLocale(node);
	} catch (e) { //this exception is thrown out when node is created by builder
	}
	return node.getTitle(locale || nodeLocale || dojo.locale) || node.getTitle(ibmConfig["default.locale"]) || ""; 
}

com.ibm.mm.builder.utils.enablerUtil.getNodeTitle = function(node, locale){
	return com.ibm.mm.builder.utils.htmlUtil.escapeString(this.getUnescapedNodeTitle(node, locale));
}

com.ibm.mm.builder.utils.enablerUtil.getNodeDescription = function(node, locale){
	if(!node){return null;}
	var lc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
	return node.getDescription(locale || lc.getLocale(node) || dojo.locale) || "";
}

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.spaceUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.spaceUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.spaceUtil");




/**
 * Return navigation model, if refresh is true, the cache will be clean and retrieve the model again.
 * @param {boolean} refresh
 * @param {string} id
 */
(function(){
var enabler = com.ibm.mashups.enabler;
var builder = com.ibm.mm.builder
var constant = builder.constant;
var strategy = enabler.strategy;
var ef = enabler.model.Factory;
var af = enabler.model.state.AccessorFactory;
var userUtil = builder.utils.userUtil;
var enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
var cs = com.ibm.mashups.services.ServiceManager.getService(enabler.services.ConfigService.SERVICE_NAME);
var configConstants = com.ibm.mashups.enabler.services.ConfigConstants;
var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cws = com.ibm.mm.builder.coreWidgetsStrings;

var spaceUtil = {
	getSpaceModel: function(refresh){
		if (refresh || !this.spaceModel) {
			var spaceModel = ef.getSpaceModel();
			spaceModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(5));
			this.spaceModel = spaceModel;
		}
		//clean cache
		this.currentSpaceNode = null;
		
		return this.spaceModel;
	},
	
	getSpaceByNavigation: function(navNode){
		if(navNode)	return this.getSpaceModel().findSpaceByNavigation(navNode).start();
		return null;
	},
	
	getSpaceIdByPageId: function(pageId){
		var s = this.getSpaceByNavigation(com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId));
		if(s) {return s.getID();}
		return null;
	},
	
	getCurrentSpaceId: function(){
		return this.getSpaceAccessor().getSpaceID();
	},
	
	getCurrentSpaceNode: function(){
		if(!this.currentSpaceNode || this.currentSpaceNode.getID() !== this.getCurrentSpaceId()){
			this.currentSpaceNode = this.getSpaceNode(this.getCurrentSpaceId());
		}
		return this.currentSpaceNode;
	},
	
	setSpaceId: function(sid){
		this.getSpaceAccessor().setSpaceID(sid);
		com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().commit().start();
		if (!sid) {
			dojo.cookie("inPersonalSpace", "true");
		}else{
			dojo.cookie("inPersonalSpace", null);
		}
	},
	
	getSpaceAccessor: function(){
		this.spaceAccessor = this.spaceAccessor || 
			af.getSpaceAccessor(com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel());
		return this.spaceAccessor;
	},
	
	getWelcomeSpaceId: function(){
        return cs.getValue(configConstants.WELCOME_SPACE_ID);
    },
	
	getHomeSpaceId: function(){
		if (userUtil.isLookasideEnabled("com.ibm.mashups.user.DEFAULT_SPACE")) {
		
			try {
				this._homeSpaceId = this._homeSpaceId || userUtil.getCurrentUser().getAttribute("com.ibm.mashups.user.DEFAULT_SPACE");
				//check whether the space exists
				if (this._homeSpaceId === "null") 
					return null;
				if (this._homeSpaceId === "-1") 
					return null;
				return this._homeSpaceId;
			} 
			catch (e) {
				return null;
			}
		}
		
		return null;
	},
	
	setHomeSpaceId: function(sid){
		sid = sid || "-1";
		this._homeSpaceId = sid;
		var userModel = userUtil.getUserModel();
		var user = userUtil.getCurrentUser();
		if(user){
			user.setAttribute("com.ibm.mashups.user.DEFAULT_SPACE", sid);
			userModel.commit().start();
			es.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
		}
	},
	
	isHomeSpace: function(spaceId){
		return this.getHomeSpaceId() === spaceId;
	},
	
	isWelcomeSpace: function(spaceId){
		return this.getWelcomeSpaceId() === spaceId;
	},
	
	isPersonalSpace: function(spaceId){
		return !this.getCurrentSpaceId();
	},
	
	getSpaceTitle: function(spaceId, locale) {
		return enablerUtil.getNodeTitle(this.getSpaceNode(spaceId), locale) || this.getPersonalSpaceTitle();
	},
	
	getPersonalSpaceTitle: function(){
		if(ibmConfig.PERSONAL_SPACE_KEY && cws[ibmConfig.PERSONAL_SPACE_KEY]){
			return cws[ibmConfig.PERSONAL_SPACE_KEY];
		}
		return cws.I_SPACE_PERSONAL_SPACE;
	},

	getSpaceIconURL: function(space){
		var names = space.getMetaDataNames();
		for ( var i = 0; i < names.length; i++) {
			if (names[i] != null && (names[i] == "iconUrl" || names[i].search("^\{.*\}iconUrl$") != -1)) { // this meta is for "iconUrl"
				return space.getMetaData(names[i]);
			}
		}
		
		return null;
	},
	
	setSpaceIconURL: function(space, iconUrl){
		var names = space.getMetaDataNames();
		var found = false; 
		for ( var i = 0; i < names.length; i++) {
			if (names[i] != null && (names[i] == "iconUrl" || names[i].search("^\{.*\}iconUrl$") != -1)) { // this meta is for "iconUrl"
				space.setMetaData(names[i], iconUrl);
				found = true;
			}
		}
		
		if (!found) {
			space.setMetaData("{http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/extensions}iconUrl", iconUrl);			
		}
		
		return ;
	},
	
	getSpaceNode: function(spaceId){
		if (spaceId === this.getCurrentSpaceId() && this.currentSpaceNode) { return this.currentSpaceNode; }
		spaceId = spaceId || this.getCurrentSpaceId();
		if (spaceId) { return this.getSpaceModel().find(spaceId).start(); }
	},
	//todo remove duplicate code to check title.
	validateSpaceName: function(title){
   		var cwm = com.ibm.mm.builder.coreWidgetsMessages;
    	if (!title) {
        	return false;
    	}
    	if (title.length == 0) {
        	alert(cwm.E_SPACE_UTIL_INVALID_NAME_EMPTY_0);
        	return false;
    	}
    	title = dojo.trim(title)
    	if (title.length == 0) {
        	alert(cwm.E_SPACE_UTIL_INVALID_NAME_BLANK_0)
        	return false;
    	}
    
    	if (title.length >= 256) {
        	alert(cwm.E_SPACE_UTIL_INVALID_NAME_LENGTH_0);
        	return false;
    	}
    
        var match = ibmConfig[configConstants.BUILDER_TITLE_FILTER_REGEXP];
        if (match) {
            if (title.match(match)) {
                alert(cwm.E_SPACE_UTIL_INVALID_NAME_CHAR_0);
                return false;
            }
        }
    	return true;
	},
	
	isVisiable: function(node){
		if (!node) { return false; }
		if(dojo.isString(node)){
			node = this.getSpaceNode(node);
		}
		if (!node.isHidden()) { return true; }
		return this.isBusinessSpaceServer() ? this.canEdit(node) : false;
	},
	
	canEdit: function(node){
		if (!node) { return false; }
		var ac = com.ibm.mm.builder.utils.acModelUtil;
		return ac.isSpaceOwner(node) || ac.canEditSpace(node);
	},
	
	isBusinessSpaceServer: function(){
		return cs.getValue(configConstants.SERVER_TYPE) == configConstants.SERVER_TYPE_BSPACE;
	}
}
com.ibm.mm.builder.utils.spaceUtil = spaceUtil;
})();

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.pageUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.pageUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.pageUtil");




com.ibm.mm.builder.utils.pageUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.pageUtil");

com.ibm.mm.builder.utils.pageUtil.getPageIdFromSpace = function(spaceId){
	return this.getPageAccessor(spaceId).getPageID();
}

com.ibm.mm.builder.utils.pageUtil.getFirstPageInSpace = function(spaceId){
	return this.getFirstChildPageId(com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNodeId(spaceId));
}

com.ibm.mm.builder.utils.pageUtil.getFirstPageInHomeSpace = function(){
	var spaceId = com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId();
	return this.getFirstChildPageId(com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNodeId(spaceId));
}

com.ibm.mm.builder.utils.pageUtil.setPageId = function(pid, spaceId){
	this.getPageAccessor(spaceId||com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()).setPageID(pid);
	//change to view mode because enabler needs that.
	this.changePageMode("view");
}

com.ibm.mm.builder.utils.pageUtil.getPageAccessor = function(spaceId){
	return com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(
		com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel(), spaceId
	);
}

com.ibm.mm.builder.utils.pageUtil.getPageModeAccessor = function(spaceId){
	return com.ibm.mashups.enabler.model.state.AccessorFactory.getPageModeAccessor(
		com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel()
	);
}

com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode = function(){
	return this.getPageModeAccessor(com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()).getPageMode();
} 
/**
 * Get current page id
 */
com.ibm.mm.builder.utils.pageUtil.getCurrentPageId = function(){
	return com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
}

com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode = function(){
	if(!this.currentPageNode || this.currentPageNode.getID() !== this.getCurrentPageId()){
		this.currentPageNode = this.getPageNode(this.getCurrentPageId());
	}
	return this.currentPageNode;
}

/**
 * Get current page id
 */
com.ibm.mm.builder.utils.pageUtil.getParentPageId = function(pageId){
    var p = this.getParentPageNode(pageId);
    return (p) ? p.getID() : null;
}

com.ibm.mm.builder.utils.pageUtil.getFirstChildPageId = function(pageId){
	var p = this.getFirstChildPage(pageId);
	return (p)? p.getID(): null;
}
/**
 * get first visible page
 * @param {String or NavigationNode} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getFirstChildPage = function(pageId){
	var page = this.getPageNode(pageId);
	if (page) {
		var _navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
		if (_navModel.hasChildren(page)) {
			var iter = _navModel.getChildren(page);
			while (iter.hasNext()) {
				var node = iter.next();
				if (this.isVisiable(node)) return node;
			}
		}
	}
	return null;
}

com.ibm.mm.builder.utils.pageUtil.getParentPageNode = function(pageId){
	var parentNode = null; 

	var navUtil = com.ibm.mm.builder.utils.navigationUtil;
	var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
	var _navModel = navUtil.getNavigationModel();
	var pid = this._getPageId(pageId);
	if(pid){
		parentNode = _navModel.getParent(pid).start();
	}
	return parentNode || navUtil.getNavigationRootNode(spaceUtil.getCurrentSpaceId());
}

com.ibm.mm.builder.utils.pageUtil.getSiblingPages = function(pageId){
   	return this.getChildPages(this.getParentPageNode(pageId));
}

com.ibm.mm.builder.utils.pageUtil.getChildPages = function(page){
	if(typeof page === "string"){
		page = this.getPageNode(page);
		if(!page){return null;}
	}
	var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	return navModel.hasChildren(page) ? navModel.getChildren(page) : null;
}
/**
 * Determine the first page to render
 */
com.ibm.mm.builder.utils.pageUtil.getDefaultPage = function(pageId){
	return this.getPageNode(pageId) || this.getFirstRootPageId();
}

com.ibm.mm.builder.utils.pageUtil.getDefaultPageId = function(pageId){
	var p = this.getDefaultPage(pageId);
	if (!p.getID) { return p;} //added this line
	return (p) ? p.getID() : null;
}

/**
 * Determine the first page to render
 */
com.ibm.mm.builder.utils.pageUtil.getFirstRootPageId = function(){
	var utils = com.ibm.mm.builder.utils;
	var rootId = utils.navigationUtil.getNavigationRootNodeId(utils.spaceUtil.getCurrentSpaceId());
	return this.getFirstChildPageId(rootId);
}

/**
 * Determine the page id of the page in the current space whose page title matches title using locale.
 * Used by links on Welcome page of Welcome Space to switch to other pages in the Welcome Space. 
 */
com.ibm.mm.builder.utils.pageUtil.getCurrentSpacePageIdByPageTitle = function(title, locale) {
	var iter = this.getSiblingPages(this.getFirstRootPageId());
  while (iter.hasNext()) {
    var page = iter.next();
	  if (this.getPageTitle(page.getID(), locale) == title) {
			return page.getID();
		}
	}
	return null;
}

/**
 * Get page content by page id
 * If pageId is null, current page content is returned.
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageContent = function(pageId){

    var layoutModel = this.getPageLayoutModel(pageId)
    if (!layoutModel) {
        return null;
    }
    
    var lmRoot = layoutModel.getRoot().start();
    if (lmRoot) {
        return lmRoot.getFragment();
    }
    
    alert(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_NO_PAGE_OR_NET_DISCONNECT_0);
    return null;
}

com.ibm.mm.builder.utils.pageUtil.getPageTitle = function(page, locale){
    if (!page) { return null; }
	
	if (dojo.isString(page)) {
		page = this.getPageNode(page);
	}
	
	return com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(page, locale);
}

com.ibm.mm.builder.utils.pageUtil.getUnescapedPageTitle = function(page, locale){
    if (!page) { return null; }
	
	if (dojo.isString(page)) {
		page = this.getPageNode(page);
	}
	
	return com.ibm.mm.builder.utils.enablerUtil.getUnescapedNodeTitle(page, locale);
}

com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle = function(locale){
	return this.getPageTitle(this.getDefaultPageId(), locale);
}

/** 
 * @param {Object} pageId
 * @param {Object} locale
 */
com.ibm.mm.builder.utils.pageUtil.getPageDescription = function(pageId, locale){
    var node = this.getPageNode(pageId);
	return com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(node, locale);
}

/**
 * return page layout itemset
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageLayoutItemSet = function(pageId){

    var layoutModel = this.getPageLayoutModel(this._getPageId(pageId));
    if (!layoutModel) { return null; }
    
    var lmRoot = layoutModel.getRoot().start();
    if (lmRoot) {
        return lmRoot.getMetaData(com.ibm.mm.builder.constant.layoutWidgetItemSet);
    }
    return null;
}

/**
 * Create page with page title
 * @param {String} title
 * @param {String} parentId, if null, the new page will created as sibling of current page.
 */
com.ibm.mm.builder.utils.pageUtil.createPage = function(title, parentId, onErrorCb){
	var utils = com.ibm.mm.builder.utils;
	var parentPage = this.getPageNode(parentId || this.getParentPageId() || 
		utils.navigationUtil.getNavigationRootNodeId(utils.spaceUtil.getCurrentSpaceId()));
	
	var _navModel = utils.navigationUtil.getNavigationModel();
	
	// create page
    var newPage = _navModel.create(null);
    newPage.setTitle(title, dojo.locale);
	newPage.setTitle(title, ibmConfig["default.locale"]);
	//we change this logic to save theme when save page instead saving theme after creating page.
    var themeId = utils.themeUtil.getThemeId(parentPage.getID());
    if (!utils.themeUtil.getThemeModel().find(themeId).start()){
        themeId = utils.themeUtil.getDefaultThemeId();
    }
    newPage.setTheme(themeId);
    
	_navModel.insert(newPage, parentPage, null);
	
	// create layout
	var layoutModel = _navModel.getLayoutModel(newPage.getID());
	if (layoutModel) {
		var lmRoot = layoutModel.create();
		layoutModel.insert(lmRoot);
		
		// set empty fragment
		lmRoot.setFragment(" ");
		
		// commit changes
		var deferred = _navModel.commit();
		var newNode = null;
		deferred.setOperationCallback(function(node, operation, status, params) {
			if(!node && status >= 400){
				com.ibm.mm.builder.utils.pageUtil.LOGGER.severe("createPage", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PUB_API_CREATE_PAGE_1,[status]));
			}else{
				newNode = node.getID();
			}
		});
		
		deferred.setFinishedCallback(function(ret, statusCode) {
			if(!newNode || statusCode >= 400){
				if(onErrorCb) onErrorCb();
				com.ibm.mm.builder.utils.pageUtil.LOGGER.severe("createPage", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PUB_API_CREATE_PAGE_1,[statusCode]));
			}else{
				dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
				var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
				es.broadcastEvent("com.ibm.mashups.builder.pageCreated", newNode);
				es.broadcastEvent("com.ibm.mashups.builder.switchPage", newNode);
				es.broadcastEvent("com.ibm.mashups.builder.spacemanager.pageCreated", newNode);
			}
		});
		deferred.start(false);
	} else {
		this.LOGGER.trace("cannot get layoutmodel");
	}
};

/**
 * Update page's content, title and theme
 * @param {Hash} pageProps, example: {content: "test", title:"new name", theme:"columnlayout"}
 * @param {String} parentId, if null, the new page will created as sibling of current page.
 */
com.ibm.mm.builder.utils.pageUtil.updatePage = function(pageId, pageProps){
	var pageNode = pageId ? this.getPageNode(pageId) : this.getCurrentPageNode();
	if (!pageNode) { return; }
	var _navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var need_to_commit = false;
	var target_page = null;
	if(pageProps.content){
		if (_navModel.hasLayoutModel(pageNode)) {
			
			var layoutModel = _navModel.getLayoutModel(pageNode);
			if (layoutModel) {
				var lmRoot = layoutModel.getRoot().start() || layoutModel.create();
				lmRoot.setFragment(pageProps.content);
				layoutModel.insert(lmRoot);
				need_to_commit = true;
			}
		}
	}
	
	if(pageProps.title && pageProps.title != this.getPageTitle(pageNode)){
		if(this.validatePageName(pageProps.title)){
			pageNode.setTitle(pageProps.title, dojo.locale);
			need_to_commit = true;
		}else{
			return;
		}
	}
	
	if(pageProps.description && pageProps.description != com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(pageNode)){
		pageNode.setDescriptione(pageProps.description, dojo.locale);
		need_to_commit = true;
	}
	
	var themeId = com.ibm.mm.builder.utils.themeUtil.getThemeId(pageNode);
	if (pageProps.theme && pageProps.theme != themeId) {
		pageNode.setTheme(pageProps.theme);
		need_to_commit = true;
	}
	//if theme is null, save default theme as well.
	if (themeId === "null") {
		pageNode.setTheme(com.ibm.mm.builder.utils.themeUtil.getDefaultThemeId());
		need_to_commit = true;
	}
	
	if (need_to_commit){
		_navModel.commit().start();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
	}
};

com.ibm.mm.builder.utils.pageUtil.saveCurrentPage = function(content){
	var pageProps = {};
	pageProps.content = content || this.getPageContent();
	this.updatePage(null, pageProps);
	
};

/**
 * Delete page
 * @param {String} parentId, if null, current page will be deleted
 */
com.ibm.mm.builder.utils.pageUtil.deletePage = function(pageId){
	//set page to false to disable the page save checker.
	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
	var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	navModel.remove(this._getPageId(pageId));
	navModel.commit().start();
	//reset current page after delete page
	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(null);
};

com.ibm.mm.builder.utils.pageUtil.isRoot = function(pageId){
	var node = this.getPageNode(pageId);
	var currentSpaceId = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
	return !node || node.getID() == com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNodeId(currentSpaceId);

};
/**
 * Get page layout model
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageLayoutModel = function(pageId){
    var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
    return navModel.getLayoutModel(this._getPageId(pageId));
	
}

com.ibm.mm.builder.utils.pageUtil.getPageLayoutNode = function(pageId){
   var layoutModel = this.getPageLayoutModel(pageId);
   if(layoutModel) return layoutModel.getRoot().start();
}

/**
 * Get the page node, return current page node if pageId is null
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageNode = function(pageId){
	var pid = this._getPageId(pageId);
	if(pid){
		var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
		return navModel.find(pid).start();
	}
}

/**
 * Get the page id, return current page id if pageId is null
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil._getPageId = function(pageId){
    return pageId || this.getCurrentPageId();
}

//
///**
// * TODO: this method may not be used for v1.1
// * The following utility methods are for root widget to filter the script which
// * may be contained in page content (index.html).
// *
// * The scripts will be executed before all the widgets in the page content get loaded.
// *
// * Drawbacks of current implementation:
// * 1. Based on enabler aggregation api, if script element contains "document.write", an error occur.
// * 	  However, "document.write" is not a recommended way to develop iWidget in Lotus Mashups.
// * 2. Lack the methods to detect other potential elements user may add into index.html such as <link>.
// */
///**
// * This method will iterate over script elements and attach an id attribute ,
// * this is necessary so if there's document.write, it got over written
// * otherwise you will get a blank page!
// * @param {String} content the page content
// */
//com.ibm.mm.builder.utils.pageUtil.updateScriptElementId = function(/*String*/content){
//    var tempDIV = document.createElement("DIV");
//    tempDIV.innerHTML = content;
//    // find the script elements
//    var scriptElems = tempDIV.getElementsByTagName("script");
//    if (scriptElems != null) {
//        for (var i = 0; i < scriptElems.length; i++) {
//            var scriptElem = scriptElems[i];
//            // include an id if there is none so far
//            // (needed to lookup script in original DOM later on)
//            var id = scriptElem.getAttribute("id");
//            if (id == null || id == "") {
//                scriptElem.setAttribute("id", "_scr#" + i);
//            }
//        }
//    }
//    return tempDIV.innerHTML;
//};
//
///**
// * Execute all the script inside the node.
// * @param {DomNode} node the container node of script elements
// */
//com.ibm.mm.builder.utils.pageUtil.evalScripts = function(/*DomNode*/node){
//    var scriptElems = node.getElementsByTagName("script");
//    for (var i = 0; i < scriptElems.length; i++) {
//        com.ibm.mm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER.handle(scriptElems[i]);
//    }
//};

/**
 * Check page name , if name is valid , return true , or , return false
 * //todo change to one ui for error message display instead of alert
 */
com.ibm.mm.builder.utils.pageUtil.validatePageName = function(title){
   var cwm = com.ibm.mm.builder.coreWidgetsMessages;
    if (!title) {
        return false;
    }
    if (title.length == 0) {
        alert(cwm.E_PAGE_UTIL_INVALID_NAME_EMPTY_0);
        return false;
    }
    title = dojo.trim(title)
    if (title.length == 0) {
        alert(cwm.E_PAGE_UTIL_INVALID_NAME_BLANK_0)
        return false;
    }
    
    if (title.length >= 256) {
        alert(cwm.E_PAGE_UTIL_INVALID_NAME_LENGTH_0);
        return false;
    }
    
    var match = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.BUILDER_TITLE_FILTER_REGEXP];
    if (match) {
        if (title.match(match)) {
            alert(cwm.E_PAGE_UTIL_INVALID_NAME_CHAR_0);
            return false;
        }
    }
    return true;
};

com.ibm.mm.builder.utils.pageUtil.getEmptyPageMessage = function(msg){
	var empty_content = 
		"<div class='empty_div'>"+
			"<div class='empty_outer_div'>" +
				"<div class='empty_inner_div'>" +
				com.ibm.mm.builder.utils.htmlUtil.formatMessage(msg) +
				"</div>" +
			"</div>"+
		"</div>";
    return empty_content;
};

com.ibm.mm.builder.utils.pageUtil.encodeBase64 = function(str){
    function unicode2utf8(str){
        var result = [];
        for (var i = 0, len = str.length; i < len; i++) {
            var ch = str.charCodeAt(i);
            if ((ch >= 0x0001) && (ch <= 0x007F)) {
                result.push(str.charAt(i));
            }
            else 
                if (ch > 0x07FF) {
                    result.push(String.fromCharCode(0xE0 | ((ch >> 12) & 0x0F)));
                    result.push(String.fromCharCode(0x80 | ((ch >> 6) & 0x3F)));
                    result.push(String.fromCharCode(0x80 | ((ch >> 0) & 0x3F)));
                }
                else {
                    result.push(String.fromCharCode(0xC0 | ((ch >> 6) & 0x1F)));
                    result.push(String.fromCharCode(0x80 | ((ch >> 0) & 0x3F)));
                }
        }
        return result.join("");
    }
    str = unicode2utf8(str);
    
    var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var out, i, len;
    var c1, c2, c3;
    
    len = str.length;
    i = 0;
    out = [];
    while (i < len) {
        c1 = str.charCodeAt(i++) & 0xff;
        if (i == len) {
            out.push(base64EncodeChars.charAt(c1 >> 2));
            out.push(base64EncodeChars.charAt((c1 & 0x3) << 4));
            out.push("==");
            break;
        }
        c2 = str.charCodeAt(i++);
        if (i == len) {
            out.push(base64EncodeChars.charAt(c1 >> 2));
            out.push(base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4)));
            out.push(base64EncodeChars.charAt((c2 & 0xF) << 2));
            out.push("=");
            break;
        }
        c3 = str.charCodeAt(i++);
        out.push(base64EncodeChars.charAt(c1 >> 2));
        out.push(base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4)));
        out.push(base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6)));
        out.push(base64EncodeChars.charAt(c3 & 0x3F));
    }
    return out.join("");
};

com.ibm.mm.builder.utils.pageUtil.isEmptyPage = function(pageNode){
	if (!pageNode) return true;
	return !com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().hasLayoutModel(pageNode);
};

com.ibm.mm.builder.utils.pageUtil.isVisiable = function(node){
	if (!node) { return false; }
	if (dojo.isString(node)) {
		node = this.getPageNode(node);
	}
	if (!node.isHidden()) { return true; }
	return com.ibm.mm.builder.utils.spaceUtil.isBusinessSpaceServer() ? this.canEdit(node) : false;
};

com.ibm.mm.builder.utils.pageUtil.canEdit = function(node){
	if (!node) { return false; }
	var ac = com.ibm.mm.builder.utils.acModelUtil;
	if (ac.isPageOwner(node.getID())) { return true; }
	if (ac.getUserPermission(node.getID()) === ac.EDIT) { return true; }
	return false;
};

com.ibm.mm.builder.utils.pageUtil.updatePageTitle = function(){
	var pageTitle = this.getUnescapedPageTitle(this.getCurrentPageId());
	if (!pageTitle || dojo.trim(pageTitle) == "") {
		dojo.doc.title = builderConfig.productName
	}
	else {
		dojo.doc.title = builderConfig.productName + " - " + pageTitle;
	}
};

com.ibm.mm.builder.utils.pageUtil.isGlobalPage = function(){
	return dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid) && dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid) !== "null"
};

com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm =  function(callback, cancelcb){
	
	if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()){
		var cws = com.ibm.mm.builder.coreWidgetsStrings;
		var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
	        contentWarning: cws.I_PAGE_SAVE_WARNING,
	        contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
	        btnSaveText: cws.I_COMMON_SAVE,
	        btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
	        btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
	        callbackSave: callback,
	        callbackNotSave: callback,
			callbackCancel: cancelcb
	    });
	    saveConfirmDlg.show();
	}else{
		if(callback) callback();
	}
}

com.ibm.mm.builder.utils.pageUtil.changePageMode = function(mode){
	if (mode == "view" || mode == "edit") {
		com.ibm.mm.builder.utils.pageUtil.getPageModeAccessor().setPageMode(mode);
		com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel().commit().start();
	}
}

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.navigationUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.navigationUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.navigationUtil");







/**
 * Return navigation model, if refresh is true, the cache will be clean and retrieve the model again.
 * @param {boolean} refresh
 * @param {string} id
 */
(function(){
var enabler = com.ibm.mashups.enabler;
var builder = com.ibm.mm.builder;
var strategy = enabler.strategy;
var ef = enabler.model.Factory;
var ems = enabler.model.state;
var af = ems.AccessorFactory;
var pageUtil = builder.utils.pageUtil;
var userUtil = builder.utils.userUtil;
var spaceUtil = builder.utils.spaceUtil;
var cs = com.ibm.mashups.services.ServiceManager.getService(enabler.services.ConfigService.SERVICE_NAME);
var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
var logger = enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.navigationUtil");
			
var navigationUtil = {
	getNavigationModel: function(){
		if (!this._navModel) {
			var _navModel = ef.getNavigationModel();
			
			// multipart strategies
	        var plaStrategy = new strategy.PageLoadAheadStrategy(true, true, true);
	        var ulaStrategy = new strategy.UserLoadAheadStrategy(true);
	        var cclaStrategy = new strategy.CatalogCategoryLoadAheadStrategy(true);
			
			// list loadahead strategy
	        var llaStrategy = new strategy.ListLoadAheadStrategy(com.ibm.mm.builder.constant.NavigationPageSize);
	
	        // temporary until we have true model singletons
			// comments this since we don't use communityModel anymore
//	        var aclChecker = builder.ACLChecker;
//	        plaStrategy.setCommunityModel(builder.ACLChecker.communityModel);
	        ulaStrategy.setUserModel(builder.utils.userUtil.getUserModel());
	        cclaStrategy.setCatalogCategoryModel(builder.utils.toolboxUtil.getCatalogModel());
			
	        _navModel.setStrategy([plaStrategy, llaStrategy, ulaStrategy, cclaStrategy]);
	        this._navModel = _navModel;
			
			//clean cache
			com.ibm.mm.builder.utils.pageUtil.currentPageNode = null;
			this.personalSpaceNavigationRootNode = null;
		}
		return this._navModel;
	},
	
	getSharedNavigationModel: function(){
		if(!this._sharedNavModel){
			var _sharedNavModel = ef.getSharedNavigationModel();
			_sharedNavModel.setStrategy(new enabler.strategy.ListLoadAheadStrategy(
				com.ibm.mm.builder.constant.NavigationPageSize
			));
			this._sharedNavModel = _sharedNavModel;
		}
		return this._sharedNavModel;
	},
	
	getNavigationStateModel: function(){
		if (!this.navigationStateModel)
			this.navigationStateModel = ems.NavigationStateModelFactory.getNavigationStateModel();
		
		return this.navigationStateModel;
	},
	
	getNavigationRootNode: function(spaceId){
		if(spaceId){
			 // find the selected node
			var space = spaceUtil.getSpaceModel().find(spaceId).start();
			if (space) {
				return pageUtil.getPageNode(space.getRootNavigation().getID());
			}
		}
		return this.getPersonalSpaceNavigationRootNode();
	},
	
	getPersonalSpaceNavigationRootNode: function(){
		if(!this.personalSpaceNavigationRootNode){
			this.personalSpaceNavigationRootNode = this.getNavigationModel().getRoot().start();
		}
		return this.personalSpaceNavigationRootNode;
	},
	
	getPersonalSpaceNavigationRootId: function(){
		return this.getPersonalSpaceNavigationRootNode().getID();
	},
	
	getNavigationRootNodeId: function(spaceId){
		return this.getNavigationRootNode(spaceId).getID();
	},
	
	getSharedNavigationRootNode: function(){
		return this.getSharedNavigationModel().getRoot().start();
	},
	
	getFirstPageNode: function(){
		//autoaccept shared page in LockedDownAnonymousMode
		if(userUtil.isLockedDownAnonymousMode()){
			this.autoAcceptAllPages();
		}
		
		//get page id from cookie or location hash
		var pid = pageUtil.getPageIdFromSpace();
		
		//refresh and login from global page, direct to previous page instead of page from navigation state api
		if (dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid)) {
			pid = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid);
			dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null,{expires: -1});
		}
		
		//get page id form cookie
		if (pid) {
			var page = pageUtil.getPageNode(pid);
			if (page) { return page; }
			else {
				//try to auto accept page, todo refactor with personal space auto accept
				page = this.getSharedNavigationModel().find(pid).start();
				if (page) {
					var _navModel = this.getNavigationModel();
					var root = this.getPersonalSpaceNavigationRootNode();
					// auto accept shared page
					_navModel.insert(page, root, null);
					_navModel.commit().start();
					return _navModel.find(pid).start();
				}
			}
		}
		if (this.isLastPageWhenLogin()) { //goto last vistied page in space if user's setting is last page
			//go to first page in last visited space, if the space is not hidden
			if (!pid && spaceUtil.getCurrentSpaceId()) {
				if(spaceUtil.getSpaceNode(spaceUtil.getCurrentSpaceId())){
					pid = pageUtil.getFirstPageInSpace(spaceUtil.getCurrentSpaceId());
					return pageUtil.getPageNode(pid);
				}else{
					return this.gotoHomeSpace();
				}
			}
		}
		
		var sid = spaceUtil.getCurrentSpaceId();
		if (sid) {
			var pid = pageUtil.getFirstPageInSpace(sid);
			if (pid) {
				var page = pageUtil.getPageNode(pid);
				if (page) { return page; }
			}
			spaceUtil.setSpaceId(sid);
			return null;
		}
		
		if(dojo.cookie("inPersonalSpace") && dojo.cookie("inPersonalSpace") !== "null") {
			return this.gotoPersonalSpace();
		}
		return this.gotoHomeSpace();
	},
	
	gotoHomeSpace: function(){
		var homespaceId = spaceUtil.getHomeSpaceId();
		if (homespaceId && spaceUtil.getSpaceNode(homespaceId)) {
			spaceUtil.setSpaceId(homespaceId);
			var pid = pageUtil.getFirstPageInHomeSpace();
			if (pid) {
				var page = pageUtil.getPageNode(pid);
				if (page) { return page; }
			}
			return null;
		}
		
		// see if there is a welcome space
        var welcomespaceId = spaceUtil.getWelcomeSpaceId();
		if (welcomespaceId && spaceUtil.getSpaceNode(welcomespaceId)) {
			spaceUtil.setSpaceId(welcomespaceId);
			var pid = pageUtil.getFirstPageInSpace(welcomespaceId);
			if (pid) {
				var page = pageUtil.getPageNode(pid);
				if (page) { return page; }
			}
			return null;
		}
		return this.gotoPersonalSpace();
	},
	
	gotoPersonalSpace: function(){
		spaceUtil.setSpaceId(null);
		
		//goto personal space
		var _navModel = this.getNavigationModel();
		var root = this.getPersonalSpaceNavigationRootNode();
		var pid = pageUtil.getPageIdFromSpace();
		if (pid) {
			var page = this.getSharedNavigationModel().find(pid).start();
			if(page){
				// auto accept shared page
				_navModel.insert(page, root, null);
				_navModel.commit().start();
				return this.getNavigationModel().find(pid).start();
			}
		}
		// if there is no any page, auto accept all pages from share navigation node
		if (!_navModel.hasChildren(root)) {
			this.autoAcceptPagesFromDefaultGroup();
		}
		//return first page on the space
		return pageUtil.getFirstChildPage(root.getID());
	},
	
	/**
	 * Auto accept pages that shared from 'default' user group in personal space
	 */
	autoAcceptPagesFromDefaultGroup: function() {
		
		var navigationModel = this.getNavigationModel();
		var navgationRootNode = this.getNavigationRootNode();
		var sharedNavigationModel = this.getSharedNavigationModel();
		var sharedRoot = this.getSharedNavigationRootNode();
		
		var iter = sharedNavigationModel.getChildren(sharedRoot);
		while (iter.hasNext()) {
			var pageNode = iter.next();
			//ideally we only accept pages shared among the default user group
			//because of the unstable community js api, so far we accept all pages
			var isInDefaultGroup = false;
			var autoAcceptName = cs.getValue(cs.CLIENT_AUTO_ACCEPT_SHARED_GROUPNAME);
			if (autoAcceptName === "*") {
				isInDefaultGroup = true;
			} else {
				sharedNavigationModel.find(pageNode.getID()).start();
				var layoutModel = sharedNavigationModel.getLayoutModel(pageNode.getID());
				if (layoutModel) {
					var layoutNode = layoutModel.getRoot().start();
					var acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(null, layoutNode);
					var userList = com.ibm.mm.builder.utils.acModelUtil.getAllMembersInModel(acModel);
					
					var autoAcceptGroupNames = autoAcceptName.split(';')
					for (var i = 0, n = userList.length; i < n; i++) {
						var userName = userList[i].getDisplayName();
						for (var x = 0, y = autoAcceptGroupNames.length; x < y; x++) {
							if (autoAcceptGroupNames[x] == userName) {
								isInDefaultGroup = true;
								break;
							}
						}
					}
				}
			}
			if (isInDefaultGroup) {
				var page = sharedNavigationModel.find(pageNode.getID()).start();
				navigationModel.insert(page, navgationRootNode);
			}
		}
	    navigationModel.commit().start();
	},
	
	/**
	 * Auto accept pages that shared to anonymous
	 */
	autoAcceptAllPages: function(){
		try {
			var navigationModel = this.getNavigationModel();
			var navgationRootNode = this.getNavigationRootNode();
			var sharedNavigationModel = this.getSharedNavigationModel();
			var sharedRoot = this.getSharedNavigationRootNode();
			
			var iter = sharedNavigationModel.getChildren(sharedRoot);
			while (iter.hasNext()) {
				navigationModel.insert(iter.next(), navgationRootNode);
			}
			navigationModel.commit().start();
		} 
		catch (e) {
			console.log(e)
		}
	},
	
	getRedirectAddress: function(){
		return enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(this.getNavigationStateModel());
	},
	
	/**
	 * Re-order page
	 * @param {String} pageId ID of the page to be re-ordered
	 * @param {String} targetPageId ID of the page to be inserted
	 * @param {String} position insert position, include "next", "previous", "children".
	 */
	reorderPageNode: function(pageId, targetPosPageId, position) {
		try {
			var navigationModel = this.getNavigationModel();
			var context = this.getReorderPageContext(targetPosPageId, position),
				page = pageUtil.getPageNode(pageId),
				parent = context.parent,
				next = context.next;
			// @Stephan #11481 Start
			// please fix enabler api: js error when page is not null and parent is root.
			if(navigationModel.confirmInsert(page, parent, next)){
				navigationModel.insert(page, parent, next);
				navigationModel.commit().start();
				
			    es.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
			}
			// @Stephan #11481 End
		} catch (e) {
			logger.severe("reorderPageNode", e.message);
		}
	},
	
	getReorderPageContext: function(pageId, position) {
		var navigationModel = this.getNavigationModel(),
	    	page = pageUtil.getPageNode(pageId),
			parent = null,
			next = null;
		
		switch (position) {
			case "previous":
			    parent = navigationModel.getParent(pageId).start();
			    next = page;
				break;
			case "next":
			    parent = navigationModel.getParent(pageId).start();
				var childrenIter = navigationModel.getChildren(parent);
				while (childrenIter.hasNext()) {
					var child = childrenIter.next();
					if (child.getID() === pageId) {
						next = childrenIter.next();
						break;
					}
				}
			    break;
			default:  // children as default
			    parent = page;
		}
		return {
			parent: parent,
			next: next
		}
	},
	
	/**
	 * Check if descendantPage is descendant of parent
	 * @param {String} parentPageId
	 * @param {String} descendantPageId
	 */
	isDescendant: function(parentPageId, descendantPageId) {
		var navigationModel = this.getNavigationModel();
		var rootId = this.getNavigationRootNodeId();
		var pageId = descendantPageId;
		while(parentPageId !== pageId) {
			var parent = navigationModel.getParent(pageId).start();
			if (!parent) return false;
			
			pageId = parent.getID();
			if (rootId === pageId) break;
		}
		return parentPageId === pageId;
	},
	
	isLastPageWhenLogin: function(){
		try{
			var u = com.ibm.mm.builder.utils.userUtil.getCurrentUser();
			return u.getAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN") === "lastpage";
		}catch(e){
			return true;
		}
	}
}
com.ibm.mm.builder.utils.navigationUtil = navigationUtil;
})();

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.acModelUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.acModelUtil"] = true;
/**
	@author Bi Zheng(ERiK) bizheng@cn.ibm.com
*/

dojo.provide("com.ibm.mm.builder.utils.acModelUtil");



com.ibm.mm.builder.utils.acModelUtil.VIEW = 0;

com.ibm.mm.builder.utils.acModelUtil.PERSONALIZE = 1;

com.ibm.mm.builder.utils.acModelUtil.EDIT = 2;

com.ibm.mm.builder.utils.acModelUtil.OWNER = 3;

com.ibm.mm.builder.utils.acModelUtil.getUserPermission = function(pageId) {
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var layoutModel = navigationModel.getLayoutModel(pageId);
	if (layoutModel) {
		var layoutNode = layoutModel.getRoot().start();
		if (layoutNode) {
			if (layoutNode.confirmSetFragment()) 
				return com.ibm.mm.builder.utils.acModelUtil.EDIT;
			else 
				return com.ibm.mm.builder.utils.acModelUtil.VIEW;
		}
	}
	return com.ibm.mm.builder.utils.acModelUtil.VIEW;
}

com.ibm.mm.builder.utils.acModelUtil.getPageOwner = function(pageId){
	if (!pageId) { return null; }
	
	var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId); 
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var layoutModel = navigationModel.getLayoutModel(pageId);
	var layoutNode = layoutModel.getRoot().start();
	var acModel = null;
	if (!spaceId) {
		// personal page 
		acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
	}
	else {
		var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
		var space = spaceModel.find(spaceId).start();
		acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space, layoutNode);
	}
	var pageOwner = acModel.getOwner();
	if (pageOwner) { return pageOwner; }
	return null;
}

com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner = function(spaceId){
	var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);
	var acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
	return acModel.getOwner();
}
/*
 * @deprecated, repalce with isPageOwner 
 * @param {Object} pageId
 */
com.ibm.mm.builder.utils.acModelUtil.isOwner = function(pageId){
	var pageOwner = com.ibm.mm.builder.utils.acModelUtil.getPageOwner(pageId);
	if (pageOwner) {
		var currentUserId = com.ibm.mm.builder.utils.userUtil.getCurrentUserID();
		if (pageOwner.getID() == currentUserId) { return true; }
	}
	return false;
}

com.ibm.mm.builder.utils.acModelUtil.getViewers = function(acModel){
	return com.ibm.mm.builder.utils.acModelUtil.getMemberListFromRoleModel(com.ibm.mashups.enabler.ac.RoleType.USER,acModel);
}

com.ibm.mm.builder.utils.acModelUtil.getEditors = function(acModel){
	return com.ibm.mm.builder.utils.acModelUtil.getMemberListFromRoleModel(com.ibm.mashups.enabler.ac.RoleType.EDITOR,acModel);
}

/**
 * Add the input id (user or group id)
 * memberIds:JSON object, format like 
 * {memberId:membertype} 
 * membertype can be either "user" or "group"
 */

com.ibm.mm.builder.utils.acModelUtil.addViewers = function(acModel,memberIds){
	com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType(acModel,memberIds,com.ibm.mashups.enabler.ac.RoleType.USER);
}

com.ibm.mm.builder.utils.acModelUtil.addEditors = function(acModel,memberIds){
	com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType(acModel,memberIds,com.ibm.mashups.enabler.ac.RoleType.EDITOR);
}


com.ibm.mm.builder.utils.acModelUtil.insertMemberWithRoleType = function(acModel, memberIds, roleType){
    var roleModel = acModel.getRoleModel();
	var role = com.ibm.mm.builder.utils.acModelUtil.createRole(acModel, roleModel, roleType);

	if (role) {
		var memberModel = roleModel.getMemberModel(role);
		if (memberModel) {
			for (memberId in memberIds) {
				var newNode = memberModel.create({
					type: memberIds[memberId],
					id: memberId
				});
				memberModel.insert(newNode, null);
			}
		}
	}
}

com.ibm.mm.builder.utils.acModelUtil.createRole = function(acModel, roleModel, roleType){
	roleModel.setCursorPosition(0);
	var iterator = roleModel.iterator();
	if (!iterator) { return; }
	while (iterator.hasNext()) {
		var role = iterator.next();
		if (!role) { continue; }
		if (role.getRoleType() == roleType) {
			return role;
		}
	}

	var role = roleModel.create({ roletype: roleType });
	roleModel.insert(role, null);
    return role;
}

com.ibm.mm.builder.utils.acModelUtil.getPageAC = function(pageId){
	if (!pageId) { return null; }
	var acModel = null;
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	navigationModel.find(pageId).start();
	var layoutModel = navigationModel.getLayoutModel(pageId);
    var layoutNode = layoutModel.getRoot().start();
	
	var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId); 
	if (spaceId) {
		//page in space
		var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
		var space = spaceModel.find(spaceId).start();
		acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space, layoutNode);
	}
	else {
		//page in personal space
		acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
	}
	return acModel;
}

com.ibm.mm.builder.utils.acModelUtil.getPersonalPageAC = function(pageId) {
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	navigationModel.find(pageId).start();
	var layoutModel = navigationModel.getLayoutModel(pageId);
    var layoutNode = layoutModel.getRoot().start();
    var acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
	return acModel;
}

com.ibm.mm.builder.utils.acModelUtil.getSpacePageAC = function(spaceId,pageId){
	var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
	var space = spaceModel.find(spaceId).start();
	
	var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	navigationModel.find(pageId).start();
	var layoutModel = navigationModel.getLayoutModel(pageId);
    var layoutNode = layoutModel.getRoot().start();
	
	return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space,layoutNode);
}

com.ibm.mm.builder.utils.acModelUtil.canEditSpace = function(spaceId){
	var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);
	var ea = com.ibm.mashups.enabler.ac.AccessFactory.getEffectiveAccess(space);
	if (ea.hasRole("editor") || ea.hasRole("manager")) return true;
	return false;
}

com.ibm.mm.builder.utils.acModelUtil.getSpaceAC = function(spaceId){
	if(!spaceId)
		return null;
	var spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
	var space = spaceModel.find(spaceId).start();
	return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
}

com.ibm.mm.builder.utils.acModelUtil.getAllMembersInModel = function(acModel){
	var roleModel = acModel.getRoleModel();
	roleModel.setCursorPosition(0);
	var iterator = roleModel.iterator();
	var memberList = [];
	if (!iterator) { return; }
	while (iterator.hasNext()) {
		var role = iterator.next();
		if (!role) {
			continue;
		}
		var memberModel = roleModel.getMemberModel(role);
		if (!memberModel) {
			continue;
		}
		memberModel.setCursorPosition(0);
		var iterator2 = memberModel.iterator();
		if (!iterator2) {
			continue;
		}
		while (iterator2.hasNext()) {
			var member = iterator2.next();
			if (!member) {
				continue;
			}
			memberList.push(member.getEntity());
		}
	}
	return memberList;
}

com.ibm.mm.builder.utils.acModelUtil.getMemberListFromRoleModel = function(roleType, acModel){
	var roleModel = acModel.getRoleModel();
	roleModel.setCursorPosition(0);
	var iterator = roleModel.iterator();
	var memberList = [];
	if (!iterator) { return; }
	while (iterator.hasNext()) {
		var role = iterator.next();
		if (!role || (role.getRoleType() != roleType)) {
			continue;
		}
		var memberModel = roleModel.getMemberModel(role);
		if (!memberModel) {
			continue;
		}
		memberModel.setCursorPosition(0);
		var iterator2 = memberModel.iterator();
		if (!iterator2) {
			continue;
		}
		while (iterator2.hasNext()) {
			var member = iterator2.next();
			if (!member) {
				continue;
			}
			memberList.push(member.getEntity());
		}
	}
	return memberList;
}

com.ibm.mm.builder.utils.acModelUtil.removeAllMembers = function(acModel){
	com.ibm.mm.builder.utils.acModelUtil.removeViewers(acModel);
	com.ibm.mm.builder.utils.acModelUtil.removeEditors(acModel);
}

com.ibm.mm.builder.utils.acModelUtil.removeViewers = function(acModel,removeIdList){
	com.ibm.mm.builder.utils.acModelUtil.removeMembersWithRoleType(acModel,com.ibm.mashups.enabler.ac.RoleType.USER,removeIdList);
}

com.ibm.mm.builder.utils.acModelUtil.removeEditors = function(acModel,removeIdList){
	com.ibm.mm.builder.utils.acModelUtil.removeMembersWithRoleType(acModel,com.ibm.mashups.enabler.ac.RoleType.EDITOR,removeIdList);
}

com.ibm.mm.builder.utils.acModelUtil.removeMembersWithRoleType = function(acModel, roleType,removeIdList){
	var currentUserId = com.ibm.mm.builder.utils.userUtil.getCurrentUserID();
	var needRemoveAll = (arguments.length == 2);
	if(!needRemoveAll && !removeIdList){ return; }
	var roleModel = acModel.getRoleModel();
	roleModel.setCursorPosition(0);
	var iterator = roleModel.iterator();
	if (!iterator) { return; }
	while (iterator.hasNext()) {
		var role = iterator.next();
		if (!role || (role.getRoleType() != roleType)) {
			continue;
		}
		var memberModel = roleModel.getMemberModel(role);
		if (!memberModel) {
			continue;
		}
		memberModel.setCursorPosition(0);
		var iterator2 = memberModel.iterator();
		if (!iterator2) {
			continue;
		}
		while (iterator2.hasNext()) {
			var member = iterator2.next();
			if (!member) {
				continue;
			}
			var entity = member.getEntity();
			if (entity.getID() != currentUserId) {
				if (!needRemoveAll) {
					for (var id in removeIdList) {
						if ((entity.getID() == id) && (entity.getEntityType() == removeIdList[id])) {
							memberModel.remove(member);
							break;
						}
					}
				}
				else {
					memberModel.remove(member);
				}
			}
		}
	}
}

com.ibm.mm.builder.utils.acModelUtil.isPageOwner = function(pageId){
	return this.isOwner(pageId);
}

com.ibm.mm.builder.utils.acModelUtil.isSpaceOwner = function(space){
	if (!space) { return false; }
	if (!space.declaredClass) {
		space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(space);
	}
	if (space) {
		var owner = this.getSpaceOwner(space.getID());
		if (owner) { return owner.getID() === com.ibm.mm.builder.utils.userUtil.getCurrentUserID()} 
	}
	return false;
}

}

if(!dojo._hasResource["com.ibm.mm.builder.constant"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.constant"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.constant");

com.ibm.mm.builder.constant = {
	//remove, useless
	appURL: "http://localhost:8080",
	
	enablerModelIdPrefix:"id:",
	
	mmIWidget: "mm_iWidget",//iWidget spec v1
	
	mmOAGadget: "mm_OAGadget", //openAjax
	
	mmGGadget: "mm_OSGadget", //OpenSocial Gadget
	
	osGadgetChrome: "gadgets-gadget-chrome",
	
	osGadgetUserPrefs: "gadgets-gadget-user-prefs-dialog",
	
	osGadgetContent: "gadgets-gadget-content",

	
	mmDefinition:"mm_Definition", //iWidget spec v1
	
	mmItemSet: "mm_ItemSet",//iWidget spec v1
	
	mmItem: "mm_Item",//iWidget spec v1
	
	generic_widget_icon: "/mum/images/generic_widget_icon.gif",
	
	skinIdPrefix: "mm_ibm_skin_",
	
	skinClass: "iWidgetSkin",
	
	dragHandler: "_dragHandler",
	
	resizeHandler: "_resizer",
	
	resizeHandlerExt: "_res",
	
	resizeHeightExt: "_heightRes",
	
	widgetBody: "_widgetBody",
	
	widgetContent: "_content",
	
	menuHandler: "_menu",
	
	iWidgetContent: "mm_Content",
	
	iWidgetLoading: "mm_loading",
	
	handledEvents: "mm_handledEvents",
	
	event: "mm_event",
	
	publishedEvents: "mm_publishedEvents",
	
	receivedEvent: "mm_ReceivedEvent",//iWidget spec v1
	
	mmEvent:"mm_Event",//iWidget spec v1
	
	sourceWidget: "mm_SourceWidget",
	
	mmSourceEventName:"mm_SourceEventName",//iWidget spec v1
	
	mmTargetEventName:"mm_TargetEventName",//iWidget spec v1
	
	iwSourceEvent: "mm_SourceEvent",
	
	iwTargetEvent: "mm_TargetEvent",
	
	sourceEvent: "mm_SourceEvent",
	
	targetEvent: "mm_TargetEvent",
	
	itemSet: "mm_itemSet",//to be removed, replaced by mmItemSet
	
	item: "mm_item",
	
	itemName: "mm_itemName",//to be removed, replaced by mmItemSet
	
	itemValue: "mm_itemValue",//to be removed, replaced by mmItemSet
	
	configPannelNode: "configPannelNode",
	
	widget_span_attr_class: "class",
	
	widget_span_attr_widget: "widget",//to be removed, replaced by mmDefinition
	
	widget_span_attr_style: "style",
	
	widget_span_attr_onNewWire: "onnewwire", //to be removed, enabler will handle onNewWire/onRemoveWire
	
	widget_span_attr_id: "id",
	
	widget_span_attr_visible: "visible",
	
	widget_span_attr_skin: "skin",
	
	nva_skin_upper: "_upper",
	
	no_page_message:"No page to show. Please use navigation widget to create a new page.",
	
	aclIdPrefix:"_acl",
	
	editbarDragHandler:"_dragHandler_editbar",
	
	freeformLayoutClass:"freednd",
	
	columnLayoutClass:"fixeddnd",
	
	HWCClass:"nva",
	
	toolboxClass:"toolbox",
	
	nvaSkinName:"nva",
	
	layoutWidgetItemSet:"LayoutWidgetAttributes",
	
	autoWiringEnabled: "com.ibm.mashups.builder.autoWiringEnabled",
	
	dbcsEnlarged: "dbcsEnlarged",
	/**
	 * navigation pagination number, default is 5; 
	 * adjust by the whole page reslovation and item height
	 */
	NavigationPageSize: 20,
	
	ToolboxPageSize: 20,
	
	editBarHeight:35,
	
	/**
	 * Send XmlHttpRequest to backend to keep session alive
	 * Current value: 5 minutes
	 */
	intervalToKeepSessionAlive:5*60*1000,
	
	defaultWidgetWidth : 400,
	
	cookieKey_previous_pid: "digest.ignore.previous_pid",
	cookieKey_globalPageId: "digest.ignore.global_page_id",
	cookieKey_globalPageOpenedSpaceId: "digest.ignore.global_page_id_openedSpace"
};

}

if(!dojo._hasResource["com.ibm.mm.builder.widgetCreator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widgetCreator"] = true;
/**
 * This class is used to create the span microformat for a iWidget
 * All the information should be passed in by a com.ibm.mm.builder.widget.PaletteEntry object
 * 
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widgetCreator");

dojo.declare("com.ibm.mm.builder.widgetCreator",null,{
	
	widgetSkin:null,
	
	widgetDefXML:null,
	
	onNewWire:null,
	
	widgetType:null,
	
	uid:null,
	
	widgetTitle:null,
	
	systemWidget:null,
	
	widgetParam:null,
	
	configPanelNodeName:null,

	/**
	 * @constructor
	 * @param {String} uid the unique id of this iWidget instance
	 * @param {Object} inlineItemObj is an object in type of com.ibm.mm.builder.widget.PaletteEntry.
	 * this object should take all the information which is needed to create the microformat of the iWidget.
	 */
	constructor: function (_uid,widgetMetaData,itemset) {
		this.uid = _uid;
		this.itemSet = itemset;
		if (typeof widgetMetaData != 'undefined'){
			this.widgetDefXML = widgetMetaData.getDefinitionURL(false);
			var onnewwire = widgetMetaData.getMetadata("onNewWire");
			if (onnewwire == ""){
				this.onNewWire = "null";
			}else{
				this.onNewWire = onnewwire;
			}
			// Reading widgettype for determing other types of widgets such open social and open ajax.
			var widgetType = widgetMetaData.getMetadata("widgetType");
			if (widgetType == ""){
				this.widgetType = "null";
			}else{
				this.widgetType = widgetType;
			}
			this.widgetTitle = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(widgetMetaData);
			this.systemWidget = false;
			this.widgetParam = this._jsonObj(widgetMetaData.getMetadata("widgetParam"))
			this.istrusted = com.ibm.mm.builder.utils.iwidgetUtil.isTrustedWidget(widgetMetaData.getID());
			this.autowire = widgetMetaData.getMetadata("com.ibm.mashups.builder.autoWiringEnabled");
		}
	},
	
	_jsonObj: function(paramStr) {
		return (paramStr)? dojo.fromJson(paramStr): {};
	},
	
	/**
	 * set the skin type, it should be "none" or "shadow" or "blue"
	 * @param {String} _widgetSkin
	 */
	setWidgetSkin:function(_widgetSkin){
		this.widgetSkin = _widgetSkin;
	},
	
	/**
	 * return the configPanelNodeName
	 */
	getConfigPanelNodeName:function(){
		return this.configPanelNodeName;
	},
	
	/**
	 * create the root span string, this is the start of the span
	 */
	createRootSpan:function(){
		var rootSpan = document.createElement("span");
		
		// other widget types for openSocial
		if (this.widgetType !== null && this.widgetType=="mm_OAGadget")
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmOAGadget);
		else if (this.widgetType !== null && this.widgetType=="mm_OSGadget")
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmGGadget);
		else
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmIWidget);

		rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_id,""+this.uid);
		rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin,this.widgetSkin);	
		com.ibm.mm.builder.utils.iWidgetSpecUtil.setWidgetDefXML(rootSpan,this.widgetDefXML);		
		if (!this.istrusted){
			rootSpan.setAttribute("sandbox","true");
		}
		if (this.autowire == "true"){
			rootSpan.setAttribute("autowiringenabled","true");
		}	
		return rootSpan;
	},

	/**
	 * create the parameter string
	 */	
	createParamsElement: function(){
		var param = null;
		if (this.widgetParam && this.widgetParam.length) {
			param = com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan()
			dojo.forEach(this.widgetParam, function(item){
				com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, item["itemName"], item["itemValue"]);
			});
		}
		if (this.itemSet) {
			param = param || com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
			for (var key in this.itemSet) {
				var ii = dojo.query("[href='#" + key + "']", param);
				if (ii && ii[0]) {
					ii[0].innerHTML = this.itemSet[key]
				}
				else {
					com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, key, this.itemSet[key]);
				}
			}
		}
		return param;
	},		

	/**
	 * call this method to get the microformat of a widget
	 */					
	getWidget:function(){
		var param = this.createParamsElement();
		var root = this.createRootSpan();
		if (param!=null){
			root.appendChild(param);
		}
		return root;
	}
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.iwidgetUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.iwidgetUtil"] = true;
/**
 * @author EriK (bizheng@cn.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.iwidgetUtil");






com.ibm.mm.builder.utils.iwidgetUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.iwidgetUtil");
/**
 * in order to enable embedding widget from palette, this method is to
 * create the a widget fragment for the widget in palette.
 * @param {String} widgetDefId this id represents the widget id in palette
 */
com.ibm.mm.builder.utils.iwidgetUtil.getWidgetFragment=function(widgetDefId){
	var newWidgetId = this._getUid();
	var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId);
	var widgetcreator = new com.ibm.mm.builder.widgetCreator(newWidgetId, widgetMD);
	var widgetSpan = widgetcreator.getWidget();
	var widgetStr = com.ibm.mm.builder.utils.htmlUtil.getElementString(widgetSpan);
	return widgetStr;
};
	
/**
 * 
 * @param {Object} att iWidgetAttribute
 */
com.ibm.mm.builder.utils.iwidgetUtil.dumpItemSetsToJSON=function(att){
	var obj={};
	dojo.forEach(att.getAllNames(),function(name){
		obj[name]=att.getItemValue(name);
	});
	return dojo.toJson(obj);
};

com.ibm.mm.builder.utils.iwidgetUtil.loadItemSetsFromJSON=function(att,jsonStr){
	if(jsonStr){
		var obj=dojo.fromJson(jsonStr);
		for (key in obj) {
			att.setItemValue(key,obj[key],false);
		}	
	}
};

com.ibm.mm.builder.utils.iwidgetUtil.loadItemSetsFromJSONObject=function(att,jsonObj){
	if(jsonObj){
		for (key in jsonObj) {
			att.setItemValue(key,jsonObj[key],false);
		}
	}
};
/**
 * Return the widget instance icon
 * @param {String} widgetInstanceId  - this widget instance id
 */
com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceIcon = function(widgetInstanceId){
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
	if (!widgetModel){
		return com.ibm.mm.builder.constant.generic_widget_icon;
	}
	else {
		var iconValue = widgetModel.getIWidgetInstance().getIDescriptorItems().getItemValue("icon");
		var iconValue2 = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(iconValue);
		var retVal = iconValue2 || com.ibm.mm.builder.constant.generic_widget_icon;
		if (builderConfig.isBidi) {
			return this.getRtlIconUrl(retVal);
		}
		return retVal;
	}
};

/**
 * Return the widget instance title
 * @param {String} widgetInstanceId  - this widget instance id
 */
com.ibm.mm.builder.utils.iwidgetUtil.getOriginalWidgetInstanceTitle = function(widgetInstanceId){
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
	if (!widgetModel) { return null; }
	var idi = widgetModel.getIWidgetInstance().getIDescriptorItems();
	return unescape(idi.getItemValue("title", dojo.locale) || idi.getItemValue("title", ibmConfig["default.locale"]));
}

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle = function(widgetInstanceId){
	return com.ibm.mm.builder.utils.htmlUtil.escapeString(this.getOriginalWidgetInstanceTitle(widgetInstanceId));
}

/**
 * This is a helper method; It is convenient to save the widget title and title in ItemSet
 * @param {String} widgetInstanceId - this widget instance id
 * @param {String} title - the new title for this widget instance
 * @param {String} iconUrl - the url of icon
 */
com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitleAndIcon = function(widgetInstanceId, title, iconUrl){
	this.saveWidgetInstanceTitle(widgetInstanceId, title, dojo.locale);
	this.saveWidgetInstanceIcon(widgetInstanceId, iconUrl);
};

/**
 * Save the widget instance title
 * @param {String} widgetInstanceId - this widget instance id
 * @param {String} title - the new title for this widget instance
 * @param {String} locale - the locale for this title; used in v2.0
 */
com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitle = function(widgetInstanceId, title, locale){
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
	if (widgetModel){
		// formalize locale, zh-TW 
		var separator = "-";
		var localeParts = locale.split("-");
		if (localeParts.length == 1) {
			localeParts = locale.split("_");
			separator = "_";
		}
		if (localeParts.length >= 2) {
			localeParts[1] = localeParts[1].toUpperCase();
		}

		var formattedLocale="";
		for (var i = 0; i < localeParts.length; i++) {
			formattedLocale  = formattedLocale + localeParts[i];
			if (i < localeParts.length - 1) {
				formattedLocale  = formattedLocale + separator;
			}
		}

		var widgetInstance = widgetModel.getIWidgetInstance();
		var md = widgetInstance.getIDescriptorItems();
		md.setItemValue("title",escape(title),false,formattedLocale);
		com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().commit().start();
	}
};

com.ibm.mm.builder.utils.iwidgetUtil.formatWidgetTitle = function(title){
	if(!title) {return'';}
	return title.replace(/^(&nbsp;)*/,"").replace(/</g,"&lt;").replace(/>/g,"&gt;");
};

/**
 * Save the widget instance icon
 * @param {String} widgetInstanceId - this widget instance id
 * @param {String} iconUrl
 */
com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceIcon = function(widgetInstanceId, iconUrl){
	var widgetInstance = this.getiWidgetWrapper(widgetInstanceId);
	var md= widgetInstance.getIDescriptorItems();
	if(!iconUrl)iconUrl="/mum/images/generic_widget_icon.gif";
	md.setItemValue("icon",iconUrl);
	com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().commit().start();
};

com.ibm.mm.builder.utils.iwidgetUtil.getRtlIconUrl = function (ltrIcon){
	
	//returns immediately if the icon is converted to rtl already
	if (!ltrIcon || ltrIcon.match("_rtl")) {
		return ltrIcon;
	}
	var rtlIcon = ltrIcon;
	
	/*
	 * getRtlIconToTest will return the RTL version of the LTR filename. For example,
	 * if the LTR file is actiontimer.png, actiontimer_rtl.png will be returned.
	 */
	var tmpRtlIconUrl = this.getRtlIconToTest(ltrIcon);
	try{
		var xhr = this.getXhr();
		if(xhr != null && tmpRtlIconUrl != null) {
			xhr.onreadystatechange = function() {}
			xhr.open("HEAD", tmpRtlIconUrl, false);
			xhr.send(null);
			/*
			 * If the _rtl image file exists, its URL
			 * will be assigned to rtlIcon.  The
			 * below condition will be true when the HEAD 
			 * request returns with a success status indicating
			 * that the file was found.
			 */
			if(xhr.readyState == 4 && xhr.status == 200){
				rtlIcon = tmpRtlIconUrl;
			}
		}
	}
	catch (err) {
		/*
		 * Quietly handle error, icon will be set to default ltr value
		 */
	}
	return rtlIcon;
};

com.ibm.mm.builder.utils.iwidgetUtil.getRtlIconToTest = function(ltrIcon){
	
	if(!ltrIcon) return ltrIcon;
	
	var index = ltrIcon.lastIndexOf(".");
	var filePrefix = ltrIcon.substr(0, index);
	var fileSuffix = ltrIcon.substr(index+1);
	return filePrefix.concat("_rtl.", fileSuffix);
};

com.ibm.mm.builder.utils.iwidgetUtil.getXhr = function() {
	if(window.ActiveXObject) { // if IE
		try {
			return new ActiveXObject("Msxml2.XMLHTTP");
		} catch(e) {
			try {
				return new ActiveXObject("Microsoft.XMLHTTP");
			} catch(e) {
				return;
			}
		}
	} else if(window.XMLHttpRequest) { // if Mozilla, Safari, etc.
		return new XMLHttpRequest();
	}
};

/**
 * Save the widget instance title
 * @param {String} widgetInstanceId the container node of script elements
 */
com.ibm.mm.builder.utils.iwidgetUtil.getiWidgetWrapper = function(widgetInstanceId){
	return com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId).getIWidgetInstance();
};

com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetIDescriptor = function(widgetInstanceId, widgetMD){
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
	if (widgetModel){
		var widgetInstance = widgetModel.getIWidgetInstance();
		var md = widgetInstance.getIDescriptorItems();
		
		var iconUrl = widgetMD.getIconURL(false);
		if(!iconUrl) iconUrl="/mum/images/generic_widget_icon.gif";
		md.setItemValue("icon",iconUrl);

		dojo.forEach(widgetMD.getLocales(),function(l){	
			md.setItemValue("title", escape(widgetMD.getTitle(l)), false, l);
		});
		com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().commit().start();
	}
};

com.ibm.mm.builder.utils.iwidgetUtil.definitionMap = {};
com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance = function(widgetInstanceNode, widgetDefinitionId){
	var self = com.ibm.mm.builder.utils.iwidgetUtil;
	if(widgetDefinitionId) self.definitionMap[widgetInstanceNode.id] = widgetDefinitionId;
	dojo.publish(
		"/com/ibm/mashups/livetext/livetextchanged", 
		[
		 	widgetInstanceNode, 
		 	false, 
		    // preProcessCallback
		 	function(domNode, tagArray){}, 
		    // postProcessCallback		    
		 	function(domNode, tagArray, allErrors){
				var widgetmodel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceNode.id)
				if (widgetmodel != null){
                    var wdid = self.definitionMap[widgetInstanceNode.id];
                    if (wdid) {
                        var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(wdid);
                        //self.saveWidgetInstanceTitleAndIcon(widgetInstanceNode.id, com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(widgetMD), widgetMD.getIconURL());
                        self.updateWidgetIDescriptor(widgetInstanceNode.id, widgetMD);
						self.definitionMap[widgetInstanceNode.id] = null;
//                        com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(widgetInstanceNode.id, function(){
//                        	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.autoWiringWidget", widgetInstanceNode.id);
//                        });
                    }
                    com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(widgetInstanceNode.id);
				}
		 	}
		 ]
	);
};

/**
 * Return the widget definition xml file url
 * @param {String} widgetId widget id
 */
com.ibm.mm.builder.utils.iwidgetUtil.getWidgetXMLURL = function(widgetId){
	var def = dojo.query(".mm_Definition", dojo.byId(widgetId))[0];
	if (def){
		return def.getAttribute("href");
	}else{
		return "";
	}
}

com.ibm.mm.builder.utils.iwidgetUtil._getUid = function(){
	return "ns_"+ dojox.uuid.generateTimeBasedUuid().replace(/\-/g,"");
}
//load system widgets
com.ibm.mm.builder.utils.iwidgetUtil.loadWidgets = function(/*Dom Node*/div, /*Function*/callback){
	dojo.publish(
	    "/com/ibm/mashups/livetext/livetextchanged", 
	    [
		    div, 
		    false, 
		    // preProcessCallback
		    function(domNode, tagArray){
		    	//do something before loading widgets
		    	var widgetNumInTheme = tagArray.length;
		    	var widgetLoadedCount = 0;
				/*
		    	var cb = function(){
		    		widgetLoadedCount++
		    		if (widgetLoadedCount == widgetNumInTheme) {
		    			if(callback)callback();
		    		}
		    	}
		    	dojo.forEach(tagArray, function(tag){dojo.subscribe(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "."+tag.id, this, cb);})
				*/
				var cb = function(){
					widgetLoadedCount++;
		    		if (widgetLoadedCount == widgetNumInTheme) {
		    			if(callback )callback();
		    		}
		    	}
		    	dojo.forEach(tagArray, function(tag){
					var lazyLoad = tag.getAttribute("lazyLoad");
					if (!lazyLoad || (lazyLoad && lazyLoad != "true")) {
						dojo.subscribe(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "."+tag.id, this, cb);
					}
					else{
						cb();				
					}
				})
		    }, 
		    // postProcessCallback
		    function(domNode, tagArray, allErrors){}
		]
	);
};

/**
 * the return value like as
 * <code>
 * &lt;span id="ns_c45da78078c711dd9bd3b19884ccd4aa" class="mm_iWidget iWidgetSkin" skin="Glass" 
 * locationstyle="position:absolute;left:86px;top:59px;width:400px;height:277px;z-Index:50;" visible="true" layoutdata="layout:freeForm;"&gt;
 * </code>
 * @param {Object} widgetDefinitionId widget definition id, for example, id:feedreader
 * @param {Object} itemset
 */
com.ibm.mm.builder.utils.iwidgetUtil.createWidgetSpan = function(widgetDefinitionId,itemset){
	var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefinitionId);
	if(!widgetMD){
		//add the error message when there is no widget definition in toolbox
		com.ibm.mm.builder.utils.iwidgetUtil.LOGGER.severe("createWidgetSpan",com.ibm.mm.builder.coreWidgetsMessages.E_DND_CREATEWIDGET_0);
		return;
	}
	var uid = this._getUid();
	var widgetcreator = new com.ibm.mm.builder.widgetCreator(uid, widgetMD,itemset);
	var layoutBean = com.ibm.mm.builder.freeLayOutBean || com.ibm.mm.builder.columnLayoutBean;
	if(layoutBean) {
		widgetcreator.setWidgetSkin(layoutBean.getSelectedSkin());
	}else{
		widgetcreator.setWidgetSkin(com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId());
	}
	return widgetcreator.getWidget();
};

com.ibm.mm.builder.utils.iwidgetUtil.toggleMarkedSandboxWidget = function(widgetDefId){
	var tu = com.ibm.mm.builder.utils.toolboxUtil;
	tu.getWidgetDefinition(widgetDefId).setMetadata("sandbox_user", this.isMarkedSandboxWidget(widgetDefId) ? "false":"true");
	tu.getCatalogModel().commit().start();
}

com.ibm.mm.builder.utils.iwidgetUtil.isMarkedSandboxWidget = function(widgetDefId){
	return "true" == com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId).getMetadata("sandbox_user");
}

com.ibm.mm.builder.utils.iwidgetUtil.isSandboxWidget = function(widgetDefId){
	return "true" == com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId).getMetadata("sandbox_definition");
}

com.ibm.mm.builder.utils.iwidgetUtil.isDisabledSandboxWidget = function(widgetDefId){
	if (!this.diabledSandboxList || this.diabledSandboxList == null){
		if (dojo.isString(builderConfig.sandboxDisabled) == true) this.diabledSandboxList = [builderConfig.sandboxDisabled];
		else this.diabledSandboxList = builderConfig.sandboxDisabled;
	}	
	if (this.diabledSandboxList.length == 0) return false;
	var widgetDefUrl = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId).getDefinitionURL(false);
	for (var i = 0; i < this.diabledSandboxList.length; i++) {
		if (dojo.trim(widgetDefUrl) === dojo.trim(this.diabledSandboxList[i])) {
			return true;
		}else if ( dojo.trim(widgetDefUrl).indexOf(dojo.trim(this.diabledSandboxList[i])) != -1&& dojo.trim(this.diabledSandboxList[i]).indexOf("/") != 0) {//check relative path like dataEditor/dataEditor.xml
			return true;		
		}else if (dojo.trim(widgetDefUrl).indexOf(dojo.trim(this.diabledSandboxList[i])) != -1&& dojo.trim(this.diabledSandboxList[i]).indexOf("/") == 0&& dojo.trim(widgetDefUrl).indexOf(":") != -1 ){ //check absolute path like /dataEditor/dataEditor.xml
			//make sure protocol, hostname,port match to window.location.
			var buf = widgetDefUrl.split("//");
			var protocol = buf[0];
			var buf2 = buf[1].split("/");
			var host = buf2[0];
			if (protocol == window.location.protocol && window.location.host == host){
				return true;
			} else if ( protocol == window.location.protocol && protocol == "http:" && host.indexOf(window.location.host) == 0 ){
				if (host.substr(host.indexOf(":")+1) == "80")return true;
			} else if (protocol == window.location.protocol && protocol == "https:" && host.indexOf(window.location.host) == 0){
				if (host.substr(host.indexOf(":")+1) == "443")return true;
			}
		}		
	}
	return false;
}

com.ibm.mm.builder.utils.iwidgetUtil.isTrustedWidget = function(widgetDefId){
	return this.isDisabledSandboxWidget(widgetDefId) || !(this.isSandboxWidget(widgetDefId) || this.isMarkedSandboxWidget(widgetDefId));
}
/**
 * This method will leverage subscribeEvent service to make sure the callback is invoked after the widget isntance is created
 * 
 * @param {String} widgetInstanceId
 * @param {Function} callback
 */
com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId = function(/*string*/widgetInstanceId, /*function*/callback){
	var handler = null;
	if(!widgetInstanceId || !callback) return handler; 
	var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetInstanceId);
	if (wm && wm.loaded) {
		callback();
	} else {
		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		handler = eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetInstanceId, null, callback);
	}
	return handler;
}

com.ibm.mm.builder.utils.iwidgetUtil.hideWidget = function(widgetId){
	var widget = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix  + widgetId);
	if(widget) widget.style.display="none";
}
	
com.ibm.mm.builder.utils.iwidgetUtil.showWidget = function(widgetId){
	var widget = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix  + widgetId);
	if(widget) widget.style.display="";
}

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetSpanByMetadata = function(widgetMD, itemSet){
	var param = null;
	var widgetParam = dojo.fromJson(widgetMD["widgetParam"]);
	
	//store metadata to toolbox widget metadata cache for updating title/icon in skin.
	var wmdWithTitleIcon = {id:widgetMD.id, _md: widgetMD};
	wmdWithTitleIcon.getID = function(){
		return this._md.id;
	}
	wmdWithTitleIcon.getTitle = function(locale){
		if (!this._md.title) { return null; }
		return this._md.title[locale];
	}
	wmdWithTitleIcon.getLocales = function(){
		if (!this._md.title) { return []; }
		if (!this.locales) { 
			this.locales = [];
			for(var l in this._md.title){
				this.locales.push(l)
			}
		}
		return this.locales;
	}
	wmdWithTitleIcon.getIconURL = function(){
		return this._md.icon;
	}
	com.ibm.mm.builder.utils.toolboxUtil.setWidgetDefinition(wmdWithTitleIcon)
	
	if (widgetParam && widgetParam.length) {
		param = com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
		dojo.forEach(widgetParam, function(item){
			com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, item["itemName"], item["itemValue"]);
		});
	}
	
	if (itemSet) {
		param = param || com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
		for (var key in itemSet) {
			var ii = dojo.query("[href='#" + key + "']", param);
			if (ii && ii[0]) {
				ii[0].innerHTML = itemSet[key]
			}
			else {
				com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, key, itemSet[key]);
			}
		}
	}
	
	var rootSpan = document.createElement("span");
	
	// OpenSocial support change
		if (this.widgetType !== null && this.widgetType=="mm_OAGadget")
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmOAGadget);
		else if (this.widgetType !== null && this.widgetType=="mm_OSGadget")
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmGGadget);
		else
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmIWidget);

	rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_id, "" + this._getUid());
	var layoutBean = com.ibm.mm.builder.freeLayOutBean || com.ibm.mm.builder.columnLayoutBean;
	if (layoutBean) {
		rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, layoutBean.getSelectedSkin());
	}
	com.ibm.mm.builder.utils.iWidgetSpecUtil.setWidgetDefXML(rootSpan, widgetMD["definition"]);
	
	if (com.ibm.mm.builder.widget.sandboxEnabled){
		if(widgetMD["sandbox_definition"] === "true" || widgetMD["sandbox_user"] === "true") {
			rootSpan.setAttribute("sandbox", "true");
		}
	}
	
	if (widgetMD["com.ibm.mashups.builder.autoWiringEnabled"] === "true") {
		rootSpan.setAttribute("autowiringenabled", "true");
	}
	if (param) {
		rootSpan.appendChild(param);
	}
	return rootSpan;
}

com.ibm.mm.builder.utils.iwidgetUtil.getWidgetSupportedModes = function(widgetId){
	var modes = null;
	var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
	if (widgetWrapper){
		var getSMDeferred = widgetWrapper.getIWidgetDefinition();
		getSMDeferred.setFinishedCallback(function(widgetDef, status){
			if (widgetDef){
				modes = widgetDef.getSupportedModes();
			}
		});
		getSMDeferred.start(false);	
	}
	return modes;
}

com.ibm.mm.builder.utils.iwidgetUtil.isWidgetVisible = function(widgetId){
	var widgetSpan = dojo.byId(widgetId);
	if(widgetSpan) {
		return widgetSpan.getAttribute("visible") ? eval(widgetSpan.getAttribute("visible")) : false;
	}
	return false;
}

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.iWidgetSpecUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.iWidgetSpecUtil"] = true;
/**
 * This class servers as a utility class for support IBM iWidget Spec v1 microformat.
 * @author Jove (zhongqj@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.iWidgetSpecUtil");


com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue = function(spanNode, itemNameString, itemValueString){
    var item = document.createElement("a");
    dojo.addClass(item, com.ibm.mm.builder.constant.mmItem);
    item.setAttribute("href", "#" + itemNameString);
    item.innerHTML = com.ibm.mm.builder.utils.htmlUtil.escapeString(itemValueString);
    spanNode.appendChild(item);
}

com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan = function(){
    var param = document.createElement("span");
    
    dojo.addClass(param, com.ibm.mm.builder.constant.mmItemSet);
    param.setAttribute("title", "attributes");
    
    return param;
}

com.ibm.mm.builder.utils.iWidgetSpecUtil.setWidgetDefXML = function(spanNode, widgetXmlString){
    var aTag = document.createElement("a");
    dojo.addClass(aTag, com.ibm.mm.builder.constant.mmDefinition);
    aTag.setAttribute("href", widgetXmlString);
    spanNode.appendChild(aTag);
}

/**
 * for iwidget microformat new syntax only
 * @param {String} iwidgetId
 * @return widget definition XML
 */
com.ibm.mm.builder.utils.iWidgetSpecUtil.getWidgetDefXML = function(iwidgetId){
    var widgetSpan = dojo.byId(iwidgetId);
    var def = dojo.query(com.ibm.mm.builder.constant.mmDefinition, widgetSpan)[0];
    return def.getAttribute("href");
}

com.ibm.mm.builder.utils.iWidgetSpecUtil.getKeyFromHref = function(node){
    var hrefValue = node.getAttribute("href");
    if (hrefValue == null) return "";
    var pos = hrefValue.indexOf("#");
    if (pos < 0) return "";
    return hrefValue.substring(pos + 1);
}

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogResizer"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialogResizer");



dojo.declare("com.ibm.mm.builder.widget.CustomDialogResizer", 
	[dojox.layout.ResizeHandle], {
	
	innerContainer: null,
	
	innerMargin: null,
	
	oritation: "right",
	
	intLeftRTLOrig:0,
	
	// onResize: function
	// called each time dialog is resized
	onResize: null,

	templateString: '<div dojoAttachPoint="resizeHandle" class="customDialogResizeHandle"><div></div></div>',
	
	_beginSizing: function(/*Event*/ e){
		// summary: setup movement listeners and calculate initial size
		
		if (this._isSizing){ return false; }

		this.targetWidget = dijit.byId(this.targetId);

		// FIXME: resizing widgets does weird things, disable virtual resizing for now:
		if (this.targetWidget) { this.activeResize = true; } 

		this.targetDomNode = this.targetWidget ? this.targetWidget.domNode : dojo.byId(this.targetId);
		if (this.targetContainer) { this.targetDomNode = this.targetContainer; } 
		if (!this.targetDomNode){ return; }

		this.intLeftRTLOrig = parseInt(this.targetDomNode.style.left);
		
		if (!this.activeResize) {
			this.targetDomNode.appendChild(this._activeResizeNode); 
			dojo.fadeIn({ node: this._activeResizeNode, duration:120, 
				beforeBegin: dojo.hitch(this,function(){
					this._activeResizeNode.style.display=''; 
				})
			}).play(); 
		}

		this._isSizing = true;
		this.startPoint  = {'x':e.clientX, 'y':e.clientY};

		// FIXME: this is funky: marginBox adds height, contentBox ignores padding (expected, but foo!)
		var mb = (this.targetWidget) ? dojo.marginBox(this.targetDomNode) : dojo.contentBox(this.targetDomNode);  
		this.startSize  = { 'w':mb.w, 'h':mb.h };

		this._connects = []; 
		this._connects.push(dojo.connect(document,"onmousemove",this,"_updateSizing")); 
		this._connects.push(dojo.connect(document,"onmouseup", this, "_endSizing"));
		this._connects.push(dojo.connect(document,"onmouseleave", this, "_endSizing"));

		e.preventDefault();
	},
	
	_changeSizing: function(/*Event*/ e){
		
		// summary: apply sizing information based on information in (e) to attached node
		var tmp = this._getNewCoords(e);
		if(tmp===false){ return; }
		
		if(this.targetWidget && typeof this.targetWidget.resize == "function"){
			this.targetWidget.resize(tmp);
		}else{
			var intLeft = 0;
			if (builderConfig.isBidi) {
				intLeft = this.intLeftRTLOrig - tmp.dx;				
			}			
			dojo.style(this.targetDomNode,"width",tmp.w+"px"); 
			dojo.style(this.targetDomNode,"height",tmp.h+"px");
			if (builderConfig.isBidi) {
				dojo.style(this.targetDomNode,"left",intLeft+"px");
			}
			if(this.innerContainer && this.innerMargin){
				this.innerContainer.style.height = (tmp.h - this.innerMargin.top - this.innerMargin.bottom ) + "px";
				this.innerContainer.style.width = (tmp.w - this.innerMargin.left - this.innerMargin.right - 2) + "px";				
			}
		}	
		e.preventDefault();
		
		if(this.onResize != null)
		{
			this.onResize(tmp.w, tmp.h);
		}
	},

	_getNewCoords: function(/* Event */ e){
		
		// On IE, if you move the mouse above/to the left of the object being resized,
		// sometimes clientX/Y aren't set, apparently.  Just ignore the event.
		try{
			if(!e.clientX  || !e.clientY){ return false; }
		}catch(e){
			// sometimes you get an exception accessing above fields...
			return false;
		}
		this._activeResizeLastEvent = e; 

		var dx = this.startPoint.x - e.clientX;
		var dy = this.startPoint.y - e.clientY;
		
		var newW = 0;
		var newH = (this._resizeY) ? this.startSize.h - dy : this.startSize.h;
		if (!builderConfig.isBidi) {
   		   newW = (this._resizeX) ? this.startSize.w - dx : this.startSize.w;		   
        } else {		
		   newW = (this._resizeX) ? this.startSize.w + dx : this.startSize.w;
        }

		// minimum size check
		if(this.minSize){
			//var mb = dojo.marginBox(this.targetDomNode);
			if(newW < this.minSize.w){
				newW = this.minSize.w;
			}
			if(newH < this.minSize.h){
				newH = this.minSize.h;
			}
		}
		return {w:newW, h:newH, dx:dx};  // Object
	},
	
	_endSizing: function(/*Event*/ e){
		this.inherited(arguments);
		dojo.forEach(this._connects,function(c){
			dojo.disconnect(c); 
		});
		
		// Note: the target dom node id is like : "widgetId_edit"
		if (this.targetDomNode){
			var domId = this.targetDomNode.id;
			if (domId.indexOf("_edit")!=-1){
				var widgetId = domId.substr(0,domId.length-5);
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				var dlgContentNode = dojo.query(".dialog_container",this.targetDomNode)[0];
				var payload = {"newWidth": parseInt(dlgContentNode.style.width),"newHeight": parseInt(dlgContentNode.style.height)};
				eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);	
			}			
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogMoveable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogMoveable"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialogMoveable");



dojo.declare("com.ibm.mm.builder.widget.CustomDialogMoveable", dojo.dnd.Moveable, {

    adjustPosOnMouseUp: function(){
        this.node.style.left = this.checkValue(this.node.style.left);
        this.node.style.top = this.checkValue(this.node.style.top);
    },
    
    checkValue: function(value){
        try {
            var numValue = parseInt(value.substring(0, value.length - 2));
            if (numValue < 0) 
                return "0px";
        } 
        catch (e) {
        }
        return value;
    },
    
    onMoveStop: function(/* dojo.dnd.Mover */mover){
        com.ibm.mm.builder.widget.CustomDialogMoveable.superclass.onMoveStop.call(this, mover);
        this.adjustPosOnMouseUp();
    }
    
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialog"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialog");







dojo.declare("com.ibm.mm.builder.widget.CustomDialog", [dijit.Dialog], {

    templateString: 
		"<div dojoAttachPoint='dialogNode' class='custom_dialog'>" +
		    "<div dojoAttachPoint='dialogDivsNode' class='customDialogDiv lotusDialog'>" +
			    "<div dojoAttachPoint='titleBar' class='dialog_titlebar' waiRole='dialog'>" +
					"<a title='${closeIconTitle}' class='dialog_titlebar_close_wrapper lotusBtnImg' dojoAttachPoint='closeButtonNode'" +
						"href='javascript:;' aria-label='${closeIconTitle}' dojoAttachEvent='onclick:trueHide,onkeypress:hideWithKey'>" +
						"<img alt='${closeIconTitle}' title='${closeIconTitle}' class='dialog_titlebar_close' src='" + builderConfig.builderPath + "/images/oneui/blank.gif'/>" +
						"<span class='lotusAltText'>X</span>" +
					"</a>" +
			    	"<div dojoAttachPoint='titleNode' class='dialog_titlebar_title'></div>" +
		    	"</div>" +
			    "<div dojoAttachPoint='containerNode' class='dialog_container'></div>" +
			    "<span dojoAttachPoint='tabEnd' ></span>" +
			    "<div dojoAttachPoint='leftBar' class='dialog_leftsidebar'></div>" +
			    "<div dojoAttachPoint='rightBar' class='dialog_rightsidebar'></div>" +
			    "<div dojoAttachPoint='endBar' class='dialog_endbar'></div>" +
			    "<div dojoAttachPoint='leftResizeHandler' class='dialog_leftResize_handler'></div>" +
			    "<div dojoAttachPoint='rightResizeHandler' class='dialog_rightResize_handler'></div>" +
		    "</div>" +
    	"</div>",
    
    sharedWidget: false, //whether this dialog widget should alive when page change
    
	belongId: null,
    
    nodeWidth: null,
    
    nodeHeight: null,
    
    title: null,
    
    titleHeight: 28,
    
    titleBarHeight: "0px",
    
    endBarHeight: "0px",
    
    bottomHeight: 14,
    
    topBarBackground: null,
    
    topBarOpacity: null,
    
    bottomBarBackground: null,
    
    bottomBarOpacity: null,
    
    bottomBarTip: null,
    
    bottomBarTipColor: "white",
    
    leftBarWidth: "0px",
    
    rightBarWidth: "0px",
    
    displayCloseButton: true,
    
    containerNodePadding: null,
    
    containerBackgroundColor: null,
    
    containerOpacity: null,
    
    hasLeftBottomResizer: false,
    
    hasRightBottomResizer: true,
    
    modelDialog: true,
    
    needUnderLay: true,
    
    initLeftPosition: null,
    
    initTopPosition: null,
    
    alwaysCenter: true,
    
    subDialogs: null,
    
    roundCorner: false,
    
    dialogStack: [],
    
    innerConnects: [],
    
    closeCallback: null, 	// a callback to set when you need to do something when the dialog is hided
    
    dynaInitialized: false, // used when user doens't specify the node's width
    						// After calculate the outer container's width, will be set to true
    
    closeIconTitle: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
    
    //isEmbedPageBidi: false, // 8143: embedPage will set to true when creating a bidi preview dialog 
    // 9637: removed rtl version of custom_dialog_nomodel so removed param isEmbedPageBidi
    
	scrollEnabled: false,
	
    postCreate: function(){
        this.inherited(arguments);
        this.domNode.className = "custom_dialog";
        this.subDialogs = [];
		//this.setTitle();//postpone until show to allow width to be set
		this.scrollEnabled && dojo.style(this.containerNode, "overflow", "scroll");
        
		dojo.subscribe("/enabler/pageChanged", this, "destroyOnPageChange");
    },
    
    setTitle: function(title){
		this.title = title || this.title;
		if (this.title && this.titleNode && this.title != this.titleNode.title) {
			com.ibm.mm.builder.utils.htmlUtil.setNodeTitle(this.title, this.titleNode);
		}
	},
    
    // Search for if the page contains an applet
    containXOjbect: function(){
        return document.applets.length > 0 || document.getElementsByTagName("Object").length > 0;
    },
    
    // temp fix for old widget spec
    oldWidgetSpecHitch: function(){ // for custom dialog instance to over write
    },
    // end temp fix
    
    registerSubDialog: function(subDialogId){
        if (dojo.isString(subDialogId)) {
            this.subDialogs.push(subDialogId);
            var subDialog = dijit.byId(subDialogId);
            if (subDialog && !subDialog.modelDialog) {
                subDialog.domNode.style.zIndex = this.domNode.style.zIndex;
            }
        }
    },
    
    hideWithKey: function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) 
            return true;
        this.hide();
    },
    
    hide: function(){
		if(!this.open)
			return;
    	//if (!dojo.isIE && this.closeButtonNode.style.display != "none") 
            //this.closeButtonNode.focus();
        this.doHide();
    },
    
    doHide: function(){
		if(!this.open)
			return;
		
        //disconnect the onkey function for the dialog
        if (this.dialogStack.length > 1) {
            var subDig = this.dialogStack.pop();
            dojo.disconnect(subDig.onKeyHandler);
            var parentDialog = this.dialogStack[this.dialogStack.length - 1];
            parentDialog.onKeyHandler = dojo.connect(document.documentElement, "onkeypress", parentDialog, "_onKey");
        }
        else 
            if (this.dialogStack.length === 1) {
                var dialog = this.dialogStack.pop();
                dojo.disconnect(dialog.onKeyHandler);
            }
			
		dojo.forEach(this.subDialogs, function(subDialogId){
			var subDialog = dijit.byId(subDialogId);
            subDialog && subDialog.hide();
		});

        // temp fix for old widget spec
        setTimeout(this.oldWidgetSpecHitch, this.duration);
    
		//override the dijit.Dialog hide logic here. 
		var ds = com.ibm.mm.builder.widget.customDialogStack;
		if(!this._alreadyInitialized || this != ds[ds.length-1]){
			return;
		}
		
		if(this.modelDialog){
			com.ibm.mm.builder.widget.customDlgHighestZIndex -= 2;
			this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgZIndexOnPage;
		}
		
		if(this._fadeIn.status() == "playing"){
			this._fadeIn.stop();
		}
		
		com.ibm.mm.builder.widget.customDialogStack.pop();

		this._fadeOut.play();

		if (this._scrollConnected){
			this._scrollConnected = false;
		}
		dojo.forEach(this._modalconnects, dojo.disconnect);
		this._modalconnects = [];

		if(this._relativePosition){
			delete this._relativePosition;	
		}
		this.open = false;
	},
    
    trueHide: function(){
		this.doHide();
    },
    
	_onKey: function(/*Event*/ evt){
		// summary:
		//		Handles the keyboard events for accessibility reasons
		// tags:
		//		private
		if(dijit._dialogStack.length > 0) 
			return;
			
		var ds = com.ibm.mm.builder.widget.customDialogStack;
		if (ds[ds.length - 1] != this) 
			return;
		
		if (evt.charOrCode) {
			var dk = dojo.keys;
			var node = evt.target;
			if (evt.charOrCode === dk.TAB) {
				this._getFocusItems(this.domNode);
			}
			var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
			// see if we are shift-tabbing from first focusable item on dialog
			if (node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB) {
				if (!singleFocusItem) {
					dijit.focus(this._lastFocusItem); // send focus to last item in dialog
				}
				dojo.stopEvent(evt);
			}
			else 
				if (node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey) {
					if (!singleFocusItem) {
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}
				else {
					// see if the key is for the dialog
					while (node) {
						if (node == this.domNode) {
							if (evt.charOrCode == dk.ESCAPE) {
								this.onCancel();
							}
							else {
								return; // just let it go
							}
						}
						node = node.parentNode;
					}
					// this key is for the disabled document window
					if (evt.charOrCode !== dk.TAB) { // allow tabbing into the dialog for a11y
						dojo.stopEvent(evt);
					// opera won't tab to a div
					}
					else 
						if (!dojo.isOpera) {
							try {
								this._firstFocusItem.focus();
							} 
							catch (e) { /*squelch*/
							}
						}
				}
		}
	},
	
	/**
	 * the recommended way to get underlay of the dialog.
	 */
    _getUnderlay: function(){
		if(!this._underlay)
			this._underlay = new com.ibm.mm.builder.widget.CustomDialogUnderlay();
		return this._underlay;		
	},
	
	//In dojo 1.4, we can use dojo.isMac
	_isMac : function() {
		return navigator.appVersion.indexOf("Macintosh") >= 0;
	},
	
	/**
	 * Initialization when the dialog is showed for the first time
	 */
    _setup: function(){
        this.moveableHandles = [];
        
		//initialize the global dijit._underlay to avoid exception when the parent's uninitialize is called
		if(!dijit._underlay)
			dijit._underlay = new dijit.DialogUnderlay(); 
		
        this.titleBar && this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
            handle: this.titleBar
        }));
        this.leftBar && this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
            handle: this.leftBar
        }));
        this.rightBar && this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
            handle: this.rightBar
        }));
        this.endBar && this.moveableHandles.push(new com.ibm.mm.builder.widget.CustomDialogMoveable(this.domNode, {
            handle: this.endBar
        }));
        
        if (this.modelDialog) { // is model dialog
//			com.ibm.mm.builder.widget.customDlgZIndexOnPage += 2;	//Increase every time when there is a new model dialog on the page
            this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgZIndexOnPage;
        } else { 				// is not model dialog
        	//if (!this.isEmbedPageBidi) { 9637
        		com.ibm.mm.builder.utils.htmlUtil.setClass(this.domNode, "custom_dialog_nomodel");
        	//}
        }
		
		var node = this.domNode;
		if (this.modelDialog && this.needUnderLay) {
			var underlay = this._getUnderlay();
            this._fadeIn = dojo.fx.combine([
				dojo.fadeIn({
                    node: node,
                    duration: this.duration
                }), 
				dojo.fadeIn({
                    node: underlay.domNode,
                    duration: this.duration,
                    onEnd: dojo.hitch(this, function(){
                        underlay.show();
                        underlay.setZIndex(dojo.style(node, "zIndex") - 1);
						if (!(this._isMac() && dojo.isSafari == 4)) {
							this._addBackIFrame(dojo.style(node, "zIndex") - 2);
						}				
						
                    })
            	})
			]);
            this._fadeOut = dojo.fx.combine([
				dojo.fadeOut({
                    node: node,
                    duration: 600
            	}), 
				dojo.fadeOut({
                    node: underlay.domNode,
                    duration: 700,
                    onEnd: dojo.hitch(this, function(){
						node.style.display = "none";
                        underlay.hide();
						this._removeBackIFrame();
                        this.closeCallback && setTimeout(dojo.hitch(this, this.closeCallback), 500);
              		})
            	})
			]);
        } else {
            this._fadeIn = dojo.fadeIn({
                node: node,
                duration: this.duration
            });
            this._fadeOut = dojo.fadeOut({
                node: node,
                duration: 600,
                onEnd: dojo.hitch(this,function(){
                    node.style.display = "none";
					this.closeCallback && setTimeout(dojo.hitch(this, this.closeCallback), 500);
                })
            });
        }
    },
	
	/**
	 * Initialize the skin of the dialog accoring to the given params when the it's created
	 */
	InitDialogSkin: function(){
        if (this.roundCorner) 
            dojo.addClass(this.dialogNode, "mumRoundCorner");
        
        this.closeButtonNode.style.display = this.displayCloseButton ? "" : "none";
        
        if (!this.title) {
            this.titleNode.style.display = "none";
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.titleBar, "dialog_titlebar_notitle");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.leftBar, "dialog_leftsidebar_notitle");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.rightBar, "dialog_rightsidebar_notitle");
            this.titleHeight = 14;
        }
        else {
            this.titleNode.style.display = "";
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.titleBar, "dialog_titlebar");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.leftBar, "dialog_leftsidebar");
            com.ibm.mm.builder.utils.htmlUtil.setClass(this.rightBar, "dialog_rightsidebar");
            this.titleHeight = 28;
        }
        
        this.nodeWidth && (this.containerNode.style.width = this.nodeWidth);
		dojo.forEach((this.nodeStyle || "").split(";"), function(singleStyle){
			var kvp = singleStyle.split(":");
			if(kvp.length === 2) this.containerNode.style[kvp[0]] = kvp[1];
		}, this);
        this.nodeHeight && (this.containerNode.style.height = this.nodeHeight);
        this.containerNodePadding && (this.containerNode.style.padding = this.containerNodePadding);
        this.leftBarWidth && (this.leftBar.style.width = this.leftBarWidth);
        this.leftBarWidth && (this.containerNode.style.marginLeft = this.leftBarWidth);
        this.rightBarWidth && (this.rightBar.style.width = this.rightBarWidth);
        this.rightBarWidth && (this.containerNode.style.marginRight = this.rightBarWidth);
        this.containerBackgroundColor && (this.containerNode.style.backgroundColor = this.containerBackgroundColor);
        this.containerOpacity && (this.containerNode.style.opacity = this.containerOpacity);
        
        //the style of the title and bottom bar
        this.topBarBackground && (this.titleBar.style.backgroundColor = this.topBarBackground);
        this.topBarOpacity && (this.titleBar.style.opacity = this.topBarOpacity);
        this.topBarOpacity && (this.titleBar.style.filter = "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=" + this.topBarOpacity * 100);
        this.titleBarHeight != "0px" && (this.titleBar.style.height = this.titleBarHeight);
        this.bottomBarBackground && (this.endBar.style.backgroundColor = this.bottomBarBackground);
        this.bottomBarOpacity && (this.endBar.style.opacity = this.bottomBarOpacity);
        this.bottomBarOpacity && (this.endBar.style.filter = "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=" + this.bottomBarOpacity * 100);
        
        if (this.endBarHeight && this.endBarHeight != "0px") {
            this.endBar.style.height = this.endBarHeight;
            var _height = parseInt(this.endBarHeight) + 1 + "px";
            this.leftBar.style.bottom = _height;
            this.rightBar.style.bottom = _height;
        }
        
        this.bottomBarTip && (this.endBar.innerHTML = this.bottomBarTip);
        this.bottomBarTip && (this.endBar.style.color = this.bottomBarTipColor);
        
        //Init resize handle
        if (this.hasLeftBottomResizer) {
			this.leftResizeHandler.style.display = "";
            this.leftResizer = new com.ibm.mm.builder.widget.CustomDialogResizer({
                targetContainer: this.domNode,
                animateSizing: false,
                activeResize: true,
                innerContainer: this.containerNode,
                innerMargin: {
                    top: this.titleHeight,
                    bottom: this.bottomHeight,
                    left: parseInt(this.leftBarWidth),
                    right: parseInt(this.rightBarWidth)
                },
				onResize: dojo.hitch(this, "onResize")
            }, this.leftResizeHandler);
            this.leftResizer.startup();
        }
        if (this.hasRightBottomResizer) {
			this.rightResizeHandler.style.display = "";
            this.rightResizer = new com.ibm.mm.builder.widget.CustomDialogResizer({
                targetContainer: this.domNode,
                animateSizing: false,
                activeResize: true,
                innerContainer: this.containerNode,
                innerMargin: {
                    top: this.titleHeight,
                    bottom: this.bottomHeight,
                    left: parseInt(this.leftBarWidth),
                    right: parseInt(this.rightBarWidth)
                },
				onResize: dojo.hitch(this, "onResize")
            }, this.rightResizeHandler);
            this.rightResizer.startup();
        }
    },
    
    /**
     * Display the dialog
     */
    show: function(){
        if (this.open) return;
        
		// first time we show the dialog, there's some initialization stuff to do			
        if (!this._alreadyInitialized) {
            this._setup();
			this.InitDialogSkin();
            this._alreadyInitialized = true;
        }
        if (this._fadeOut.status() == "playing") {
            this._fadeOut.stop();
        }
        
        this._modalconnects.push(dojo.connect(window, "onscroll", this, "layout"));
        this._modalconnects.push(dojo.connect(window, "onresize", this, function(){
				// IE gives spurious resize events and can actually get stuck
				// in an infinite loop if we don't ignore them
				var viewport = dijit.getViewport();
				if(!this._oldViewport ||
						viewport.h != this._oldViewport.h ||
						viewport.w != this._oldViewport.w){
					this.layout();
					this._oldViewport = viewport;
				}
			}));
		
        if (this.dialogStack.length > 0) {
            var formerDialog = this.dialogStack[this.dialogStack.length - 1];
            dojo.disconnect(formerDialog.onKeyHandler);
        }
        this.dialogStack.push(this);
        if (this.modelDialog) {
            this._modalconnects.push(this.onKeyHandler = dojo.connect(document.documentElement, "onkeypress", this, "_onKey"));
        }
        
        dojo.style(this.domNode, "opacity", 0);
        var hasHeightDivList = new Array();
        //fix the width bug of IE6 
        if (!this.dynaInitialized) {
            if (dojo.isIE == 6) {
                dojo.query("div", this.domNode).forEach(function(node, i){
                    // add if cause here ,if need.
                    var heightObj = new Array();
                    heightObj["node"] = node;
                    heightObj["height"] = node.style.height;
                    node.style.height = "auto";
                    hasHeightDivList.push(heightObj);
                });
            }
        }
        this.domNode.style.display = "block";
        this.domNode.style.visibility = "";
        this.open = true;
        this._loadCheck(); // lazy load trigger
		
		//only do this once, when use modify the width/height of the dialog by resizer, the second time show will keep the user's config
        if (!this.dynaInitialized) {
        	
        	this.domNode.style.height = null;
        	
        	if(this.nodeHeight != null){
        		this.containerNode.style.height = this.nodeHeight;
        	}else {
        		this.containerNode.style.height = null;
        	}
        	
            var leftnum = parseInt(this.leftBarWidth.substring(0, this.leftBarWidth.length - 2));
            var rightnum = parseInt(this.rightBarWidth.substring(0, this.rightBarWidth.length - 2));
            var nodeWidthNum;
            if (this.nodeWidth != null) {
				this.containerNode.style.width = this.nodeWidth;
                nodeWidthNum = parseInt(this.nodeWidth.substring(0, this.nodeWidth.length - 2));
                this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
            }
            else {
				var node;
				if(this.containerNode.hasChildNodes())
				{
					node = this.containerNode.childNodes[0];
				}
				else
				{
					node = this.containerNode;
				}
				nodeWidthNum = dojo.coords(node).w;
                this.containerNode.style.width = nodeWidthNum + "px";
                this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
            }
            if (dojo.isIE == 6) {
                for (var i = 0; i < hasHeightDivList.length; i++) {
                    if (hasHeightDivList[i].height && hasHeightDivList[i].height != "auto") {
                        hasHeightDivList[i].node.style.height = hasHeightDivList[i].height;
                    }
                    else {
                        hasHeightDivList[i].node.style.height = "";
                    }
                }
            }
            this._position();
            this.positionWithGivenValue();
            this.dynaInitialized = true;
        } else {
            if (this.alwaysCenter && this.initLeftPosition == null && this.initTopPosition == null) 
                this._position();
			dojo.style(this.containerNode, "width", "100%");
        }
//		this.hasXObject = this.containXOjbect();
//		if (this.hasXObject) {
//            //hide all the applets, otherwise the applets will display beyond the background layer
//            this._hideXObjects();
//        }
		
		//update the ZIndex information
		if(this.modelDialog){
			com.ibm.mm.builder.widget.customDlgHighestZIndex += 2;
			this.domNode.style.zIndex = com.ibm.mm.builder.widget.customDlgHighestZIndex;
		}
		
         //set title after width has been set
        this.setTitle();
        com.ibm.mm.builder.widget.customDialogStack.push(this);
        this._fadeIn.play();
        this._savedFocus = dijit.getFocus(this);
        
        hasHeightDivList = null;
        //For dojo1.1.1 support
        this._getFocusItems(this.domNode);
        // set timeout to allow the browser to render dialog
        if (this._firstFocusItem) {
            setTimeout(dojo.hitch(this, function(){
                dijit.focus(this._firstFocusItem);
            }), this.duration + 500);
        }
    },
	
    setNodeWidth: function(newWidth){
        this.containerNode.style.width = this.nodeWidth = newWidth;
        if (this.dynaInitialized) { //if has been shown
            var leftnum = parseInt(this.leftBarWidth);
            var rightnum = parseInt(this.rightBarWidth);
            var nodeWidthNum = this.nodeWidth ? parseInt(this.nodeWidth) : dojo.coords(this.containerNode).w;
            
            this.domNode.style.width = (nodeWidthNum + leftnum + rightnum + 2) + "px";
        }
    },
    
    setNodeHeight: function(newHeight){
        this.containerNode.style.height = this.nodeHeight = newHeight;
    },
    
    setBottomTip: function(tip){
        this.endBar.innerHTML = this.bottomBarTip = tip;
    },
    
    setBottomTipColor: function(color){
        this.endBar.style.color = this.bottomBarTipColor = color;
    },
    
    autoAdjust: function(){},
    
    
    //Although this is a protected function for dijit.Dialog
    //Use it anyway to avoid copy much code from dijit.Dialog
	onCancel: function(){
		this.trueHide();
	},
    
    destroyOnPageChange: function(){
        !this.sharedWidget && this.destroy();
    },
    
    destroy: function(){
		if (this.open) {
			this.hide();
		}
        dojo.forEach(this.innerConnects, dojo.disconnect);
		if (this.moveableHandles){
		    for (var i = 0; i < this.moveableHandles.length; i++){
				this.moveableHandles[i].destroy();
			}	
		}
		
		dojo.destroy(this.leftBar);
		dojo.destroy(this.rightBar);
		dojo.destroy(this.endBar);
		dojo.destroy(this.closeButtonNode);
		dojo.destroy(this.titleBar);		
		this.leftResizer && this.leftResizer.destroy();
		this.rightResizer && this.rightResizer.destroy();
		dojo.destroy(this.leftResizeHandler);
		dojo.destroy(this.rightResizeHandler);
		if(this._underlay)  // need this since from 1.3.2, dijit.dialog doesn't destroy the underlay
			this._underlay.destroy();
		if(this.shimmer){  
			dojo.destroy(this.shimmer);
		}
		this.inherited(arguments);
    },
    
    positionWithGivenValue: function(){
        this.initLeftPosition && (this.domNode.style.left = this.initLeftPosition);
        this.initTopPosition && (this.domNode.style.top = this.initTopPosition);
    },
    
    /**
     * Position modal dialog in center of screen
     */
    _position: function(){
        if (dojo.hasClass(dojo.body(), "dojoMove")) 
            return;
        var viewport = dijit.getViewport();
        var mb = dojo.marginBox(this.domNode);
        
        var left = Math.floor((viewport.l + (viewport.w - mb.w) / 2));
        var top = Math.floor((viewport.t + (viewport.h - mb.h) / 2));
        this.domNode.style.left = left > 0 ? left + "px" : "0px";
        this.domNode.style.top = top > 0 ? top + "px" : "0px";
    },
    
    layout: function(){
        // summary: position the Dialog and the underlay
        if (this.domNode.style.display != "none") {
            this.modelDialog && this.needUnderLay && this._getUnderlay().layout();
        }
    },
    
    /**
     * This function will add one iframe under the underlay of the dialog
     * Its purpose is to solve the overlap problem of applet,flash,ActiveX object,ect.
     */
    _addBackIFrame: function(zIndex){
		this.shimmer = document.createElement('iframe');
		this.shimmer.style.position = 'absolute';
		this.shimmer.style.zIndex = zIndex;
		this.shimmer.setAttribute('frameborder', '0');
		this.shimmer.style.filter = 'progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0)';
		document.body.appendChild(this.shimmer);
        this._adjustBackIFramePosition();
    },
    
    /**
     * This function is in charge of adjust the iframe's positon when user scroll the window
     */
    _adjustBackIFramePosition: function(){
        var viewport = dijit.getViewport();
        this.shimmer.style.top = viewport.t + "px";
        this.shimmer.style.left = viewport.l + "px";
        this.shimmer.style.width = viewport.w + "px";
        this.shimmer.style.height = viewport.h + "px";
        
        // process twice since the scroll bar may have been removed
        // by the previous resizing
        var viewport2 = dijit.getViewport();
        if (viewport.w != viewport2.w) {
            this.shimmer.style.width = viewport2.w + "px";
        }
        if (viewport.h != viewport2.h) {
            this.shimmer.style.height = viewport2.h + "px";
        }
    },
    
    /**
     * Remove the iframe when the dialog is hidden
     */
    _removeBackIFrame: function(){
        if (this.shimmer) {
			dojo._destroyElement(this.shimmer);
			this.shimmer = null;
        }
    },
    
//    _hideXObjects: function(){
//        //hide all the applets
//        var applets = document.getElementsByTagName("Applet");
//        for (i = 0; i < applets.length; i++) {
//            applets[i].style.visibility = "hidden";
//        }
//        //hide all object div(flash, svg)
//        var objs = document.getElementsByTagName("Object");
//        for (i = 0; i < objs.length; i++) {
//            objs[i].style.visibility = "hidden";
//        }
//    },
	
	onResize: function(width, height){
		// hook for child widgets
	}
});

com.ibm.mm.builder.widget.customDialogStack = [];
com.ibm.mm.builder.widget.customDlgZIndexOnPage = 800;
com.ibm.mm.builder.widget.customDlgHighestZIndex = 800;
com.ibm.mm.builder.widget.editDialogUnderlay = null;

dojo.declare("com.ibm.mm.builder.widget.CleanDialog", com.ibm.mm.builder.widget.CustomDialog, {
	/**
	 * Override the super method to make all WidgetEditDialog use the only global underlay:
	 * com.ibm.mm.builder.widget.editDialogUnderlay
	 */
	_getUnderlay: function(){
		if(!com.ibm.mm.builder.widget.editDialogUnderlay)
			com.ibm.mm.builder.widget.editDialogUnderlay = new com.ibm.mm.builder.widget.CustomDialogUnderlay({
				id: "cleanDialogUnderlay"
			});
		return com.ibm.mm.builder.widget.editDialogUnderlay;
	}
});

dojo.declare("com.ibm.mm.builder.widget.GeneralWidgetModeDialog", com.ibm.mm.builder.widget.CleanDialog, {
	
	postCreate: function(){
		this.inherited(arguments);
		this.modeChangeHandle = dojo.subscribe(com.ibm.mm.enabler.iw.iEvents.Constants.modeChanged,
			this, this.onModeChanged);
	},
	
	onModeChanged: function(widgetId, mode){
		this.hide();
	},
	
	hideWithKey: function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) 
            return true;
        this.trueHide();
    },
	
	trueHide: function(){
		if(this.belongId) {
			serviceManager.getService("eventService").fireEvent(this.belongId, "onModeChanged", {newMode:'view'});
			return;	
		}
		this.doHide();
	},
	
	destroy: function(){
		dojo.unsubscribe(this.modeChangeHandle);
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.widget.WidgetEditDialog", com.ibm.mm.builder.widget.GeneralWidgetModeDialog, {
	onModeChanged: function(widgetId, mode){
		if(mode === "edit" && this.belongId === widgetId) {
			this.hide();
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.CustomDialogUnderlay", dijit.DialogUnderlay, {
    templateString: 
		'<div class="customDialogUnderlayWrapper" id="${id}_underlay">' +
    		'<div class="customDialogUnderlay" dojoAttachPoint="node"></div>' +
    	'</div>',
    
    setZIndex: function(zIndex){
        dojo.style(this.domNode, "zIndex", zIndex);
    },
	postCreate: function() {
		this.inherited('postCreate',arguments);
		if(this.bgIframe.iframe){
			dojo.attr(this.bgIframe.iframe,'title','underlay');
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.layoutUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.layoutUtil"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.layoutUtil");








com.ibm.mm.builder.utils.layoutUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.layoutUtil");

com.ibm.mm.builder.utils.layoutUtil.getPageSize=function(){
	var windowHeight
	if (self.innerHeight) { 
		// all except Explorer
		windowHeight = self.innerHeight
	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
		windowHeight = document.documentElement.clientHeight
	} else if (document.body) { 
		// other Explorers
		windowHeight = document.body.clientHeight
	}
	return windowHeight	
}

com.ibm.mm.builder.utils.layoutUtil.getPageContent=function(pid){
	if(!pid){
        if (!com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode()) {
            // User has no pages in navigation
    		var empty_content = 
    			"<div class='empty_div'>"+
    				"<div class='empty_outer_div'>" +
    					"<div class='empty_inner_div'>" +
    					com.ibm.mm.builder.utils.htmlUtil.formatMessage(com.ibm.mm.builder.coreWidgetsStrings.W_NO_PAGE_TO_SHOW) +
    					"</div>" +
    				"</div>"+
    			"</div>";
            return {"content":empty_content};
        }
		return;
	}
	try{
		if (com.ibm.mm.builder.utils.pageUtil.isEmptyPage(com.ibm.mm.builder.utils.pageUtil.getPageNode(pid))){
			return null;
		}
		var pageContent = new Object();
		var layoutModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().getLayoutModel(pid);
		if(!layoutModel){ return null; }
		var lmRoot = layoutModel.getRoot().start();
	    if (lmRoot){
	    	pageContent.content = lmRoot.getFragment();
			var pageAttributes = new Object();
			var metadataNames = lmRoot.getMetaDataNames();
			dojo.forEach(metadataNames, function(metadataName){
				pageAttributes[metadataName] = lmRoot.getMetaData(metadataName);
			})
			
			pageContent.pageAttributes  = pageAttributes;
	        return pageContent;
	    } else {
	        return null;
	    }
	}catch(e){
		com.ibm.mm.builder.utils.layoutUtil.LOGGER.severe(
			"getPageContent",
			dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_MAIN_INVALID_ID_2,[pid,e.message])
		);
	}    
}

/**
 * transformBgIamge is change a pagebackgroundiamge's url into a legal one in columnformlayout.
 * @param {String} pageBgIamgeValue
 */
com.ibm.mm.builder.utils.layoutUtil.transformBgIamge = function(pageBgIamgeValue){
	// TODO: remove the hardcoded number
	if(pageBgIamgeValue.search(/url/i) != 0){
		pageBgIamgeValue = "url" + pageBgIamgeValue;
	}
	if(pageBgIamgeValue.indexOf("(") != 3){
		pageBgIamgeValue = pageBgIamgeValue.substring(0,3) + "(" +  pageBgIamgeValue.substring(3) + ")";
	}
	if(pageBgIamgeValue.search(/http/i) != 4){
		if(pageBgIamgeValue.substring(4,5) != "/"){
			pageBgIamgeValue = pageBgIamgeValue.substring(0,4) + "http://" + pageBgIamgeValue.substring(4) + "";
		}
	}
	return pageBgIamgeValue;
}

com.ibm.mm.builder.utils.layoutUtil.setBorderSelect = function(borderSelect) {
	var index = 0;
	borderSelect.options[index++].innerHTML = com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_NONE;
	var widths = [1,2,3];
	var styles = [com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_SOLID,
				  com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOTTED,
				  com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOUBLE];
	for(var i=0; i<styles.length; i++) {
		for(var j=0; j<widths.length; j++) {
            borderSelect.options[index++].innerHTML = widths[j] + com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PAGE_UNIT + " " + styles[i];
		}
	}
}

com.ibm.mm.builder.utils.layoutUtil.createSlider=function(iWID,targetDivId,valueDivId,startValue,displayArtifact,maximValue,increment,graphicDivId){
	var sliderDiv = dojo.byId(iWID + targetDivId);
	dojo.byId(iWID + valueDivId).innerHTML = startValue + displayArtifact;
	var slider = dijit.byId(iWID + targetDivId);
	if (slider){
		slider.destroy();
	}
	var sliderProp = new Object();
	sliderProp.id = iWID + targetDivId;
	sliderProp.value = startValue;
	sliderProp.pageIncrement = increment;
	sliderProp.maximum = maximValue;
	sliderProp.showButtons = false;
	sliderProp.style = "width:120px;height:20px;";
	slider = new dijit.form.HorizontalSlider(sliderProp,sliderDiv);
	dojo.connect(slider,"onChange",null,function(newvalue){
		var transformed = dojo.number.format(arguments[0],{places:0,pattern:'##.'})
		dojo.byId(iWID + valueDivId).innerHTML = transformed + displayArtifact;
		if(graphicDivId){
			dojo.byId(iWID + graphicDivId).style.width = transformed + "px";
		}
	});
}

com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex=function(prop){
	var index = 0;
	switch(prop){
		case "none":
			index = 0;
			break;
		case "1px solid":
			index = 1;
			break;
		case "2px solid":
			index = 2;
			break;
		case "3px solid":
			index = 3;
			break;				
		case "1px dotted":
			index = 4;
			break;
		case "2px dotted":
			index = 5;
			break;
		case "3px dotted":
			index = 6;
			break;					
		case "3px double":
			index = 7;
			break;	
		case "6px double":
			index = 8;
			break;
		case "9px double":
			index = 9;
			break;																								
	}
	return index;
}

com.ibm.mm.builder.utils.layoutUtil.getImagePropSelectIndex=function(prop){
	var index = 0;
	switch(prop){
		case "RepeatX":
			index = 0;
			break;
		case "RepeatY":
			index = 1;
			break;
		case "Repeat":
			index = 2;
			break;
		case "Center":
			index = 3;
			break;												
	}
	return index;
}

com.ibm.mm.builder.utils.layoutUtil.stretchHeight = function(layoutId){
	var root = dojo.byId(layoutId);
	var widgetcontents = dojo.query("." + com.ibm.mm.builder.constant.iWidgetContent,root);
	var len = widgetcontents.length;
	for (var i=0;i<len;i++){
		if (widgetcontents[i].parentNode == root){
			widgetcontents[i].style.height = "100%";
			break;
		}
	}
}
	
com.ibm.mm.builder.utils.layoutUtil.addTip = function(msg,node,maxlen,field) {
	if(!field) field = "innerHTML";
	if(msg.length > maxlen) {
		node[field] = msg.substr(0,maxlen) + "...";
		node.setAttribute("title",msg);
	} else {
		node[field] = msg;
	}
}

com.ibm.mm.builder.utils.layoutUtil.removeAllChildren = function(fNode){
	var children = null;
	if (dojo.isIE){
		children = fNode.children;
	}else{
		children = fNode.childNodes;
	}
	var len = children.length;
	if (len!=0){
		for (var i=0;i<len;i++){
			dojo._destroyElement(children[i]);
		}
	}
}

com.ibm.mm.builder.utils.layoutUtil.widgetInLayout = function(widgetId,layoutId){
	if (widgetId == layoutId){return false;}
	var widget = dojo.byId(widgetId);
	if (widget){
		var node = widget;
		while (node.tagName != "BODY"){
			if (node.id == layoutId) {
				return true;
			}
			var node = node.parentNode;
		}
	}else{
		return false;
	}
	return false;
}	

com.ibm.mm.builder.utils.layoutUtil.publishWidgetSize = function(widgetId){
	var loadedHandler = null;
	var publishWidgetSize = function(){
		var widgetBox = dojo.contentBox(widgetId + "_content");
		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		var payload = {"newWidth": widgetBox.w,"newHeight": widgetBox.h};
		eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);	
		if (loadedHandler) eventService.unsubscribeEvent(loadedHandler,null);	
	}
	var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
	if (wm && wm.loaded) {
		publishWidgetSize();
	} else {
		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		loadedHandler = eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetId, null, publishWidgetSize);
	}	
}

com.ibm.mm.builder.utils.layoutUtil.resizeWidget = function(widgetId, height, width){
    width && com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeResized(widgetId, width);
    
    var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
    var skinBox = dojo.contentBox(widgetSkinNode);			
	
	if (width && builderConfig.isBidi) {
		var origLeft = parseInt(widgetSkinNode.style.left);
		var dx = skinBox.w - width;
		var newLeft = origLeft + dx;
		dojo._setBox(widgetSkinNode, newLeft);
	}		
	
    width && (skinBox.w = width);
    skinBox.h = height;
    dojo.contentBox(widgetSkinNode, skinBox);
    
    var widgetContentNode = dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetContent);
    var widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(widgetId 
		+ com.ibm.mm.builder.constant.widgetBody),"paddingTop");
	widgetBodyPadTop = widgetBodyPadTop ? parseInt(widgetBodyPadTop) : 0;
	
    var hack_widgetContentBox = dojo.contentBox(widgetContentNode);
	
    dojo.marginBox(widgetContentNode, {
        l: 0,
        t: 0,
        w: width ? width : -1,
        h: height - widgetBodyPadTop
    });
    
    var widgetContentBox = dojo.contentBox(widgetContentNode);
	
	//this is a work-around to fix an issue in safari rtl where content box seems to always
	//decrease in width regardless whether margin box is increasing or decreasing
	if(dojo.isSafari && builderConfig.isBidi){
		dojo.contentBox(widgetContentNode,{w:(widgetContentBox.w + 2*(hack_widgetContentBox.w - widgetContentBox.w))});
	}
	var newWidth = width ? widgetContentBox.w : -1;
	if (!width) dojo.style(widgetSkinNode,"width","auto");//9632
	var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
    eventService.broadcastEvent("com.ibm.mashups.builder.widgetResized", {
        widgetId: widgetId,
        width: newWidth,
        height: widgetContentBox.h
    });
	
	var payload = {"newWidth": newWidth,"newHeight": widgetContentBox.h};
	eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + widgetId, payload);
}

com.ibm.mm.builder.utils.layoutUtil.refreshLayoutData = function(widgetId){
	if (com.ibm.mm.builder.columnLayoutBean){
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil.refreshLayoutData(widgetId);
	}
}

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.wireUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.wireUtil"] = true;
/**
 * Util class for wiring widget
 @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.wireUtil");

com.ibm.mm.builder.utils.wireUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.wireUtil");

com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts = function(layouts) {
	var widgets = [];
	if(layouts) {
		for(var i = 0; i < layouts.length; i++) {
			//Temp fix for defect 8300, since all layout may call this due to fix on 7931
			try {
				var oneLayout = eval("_" + layouts[i] + "_iContext.scope.getWidgets()");
				widgets = widgets.concat(oneLayout);
			}catch(e){
				continue;
			}
	    }
	}
	return widgets;
}

/**
 * Get all the widgets which contains event that can handle (with match or trasformable payload type) the specify event of this widget
 * @param {string} id: the uid of the widget
 * @param {string} eventName: the event name of the widget's query event
 * @param (Array)  List contains all wrapper widget(layout widget) id
 * @return (Array) widgets: all the widgets object(include their match event)have the match handle events
 */
com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEvents = function(id, eventName,layouts){
    com.ibm.mm.builder.utils.wireUtil.LOGGER.entering("wireUtil: getMatchHandleEvents with " + eventName);
    //Get the widget instance and the event object
	var widgets = new Array();
    var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
	if (!sourceWrapper) return widgets;
	
    var pubEvent = sourceWrapper.getPublicEvent(eventName);
    
    var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts);
    
    var len = iwidgetsFromHTMLFragment.length;
   
    var totalWiredEvents = 0;
    // query all other widgets one by one
    // only care about the non-system widget
    for (var x = 0; x < len; x++) {
        var spanId = iwidgetsFromHTMLFragment[x];
		var iwidgetSpan = dojo.byId(spanId);
        //can not be the same widget
        if (spanId != id && iwidgetSpan.getAttribute("internalWidget") != "true") {
            var totalWiredEvents = 0;
            // Get the compare widget instance
            var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(spanId);
			if (!targetWrapper) continue;
			if (targetWrapper.isLoaded() == false) continue;
            var matchedEvents = new Array();
            var hasMatchEvent = false;
            var wiredEvents = new Array();
            
            var type = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(spanId);
            // Get all the handle events of the widget 
            var hanEvents = targetWrapper.getWidgetHandledEvents();
			if(hanEvents != null){
	            for (var n = 0; n < hanEvents.length; n++) {
	                var hanEvent = hanEvents[n];
	                //CHECK PRIVATE
	                if (hanEvent.getAttribute("private") != "true"){
		                var isWired = false;
		                var isMatch = false;
		                // Compare the handel event and the source widget's publish eventpayload type
						var isEventCompatible = com.ibm.mm.builder.utils.wireUtil.isEventFlexCompatible(pubEvent,hanEvent);
		                //if (matchInfo.isAMatch() || matchInfo.canAutoTransform()) { // if the event payload is match
		                if (isEventCompatible) { // if the event payload is match
		                    hasMatchEvent = true;
		                    isMatch = true;
		                    var wires = targetWrapper.getWires();
		                    if (wires == null) 
		                        wires = []
		                    for (var i = 0; i < wires.length; i++) {
		                        aWire = wires[i];
		                        //if the wire already exist
		                        if (id == aWire.getSourceWidgetID() && eventName == aWire.getSourceEventName() && hanEvent.name == aWire.getTargetEventName()) {
		                            isWired = true;
		                            totalWiredEvents++;
		                            wiredEvents.push(aWire);
		                        }
		                    }
		                }
		                //matchInfo.addExInfo(spanId, type, isMatch, isWired, hanEvent.name, hanEvent.type, hanEvent.description);
						var matchInfo = com.ibm.mm.builder.utils.wireUtil.createMatchEvent(spanId, type, isMatch, isWired, hanEvent.name, hanEvent.type, hanEvent.description);
		                matchedEvents.push(matchInfo);
	                }
	            }
			}
            widgets.push(com.ibm.mm.builder.utils.wireUtil.createMatchWidget(spanId, type, hasMatchEvent, totalWiredEvents, matchedEvents, wiredEvents, targetWrapper.getWires()));
        }
    }
    com.ibm.mm.builder.utils.wireUtil.LOGGER.exiting("wireUtil: getMatchHandleEvents with " + eventName);
    return widgets;
}

/**
 * Get all send events which can be wired with the given receive event of the given widget
 * @param {string} id: the uid of one widget
 * @param {string} eventName: the receive event name of the widget
 * @param (Array)  List contains all wrapper widget(layout widget) id
 * @return (Array) widgets: all the widgets object(include their match event)have the match sender events
 */
com.ibm.mm.builder.utils.wireUtil.getAllMatchPubEvents = function(id, eventName,layouts){
    com.ibm.mm.builder.utils.wireUtil.LOGGER.entering("wireUtil: getAllMatchPubEvents");
    var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
	var widgets = new Array();
	if (!targetWrapper) return widgets;
    var targetEvent = targetWrapper.getPublicEvent(eventName);
	
	var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts);
  
    var len = iwidgetsFromHTMLFragment.length;
    
    var wires = targetWrapper.getWires();
    if (wires == null) 
        wires = []
                 
    // only care about the non-system widget
    for (var x = 0; x < len; x++) {
        var spanId = iwidgetsFromHTMLFragment[x];
		var iwidgetSpan = dojo.byId(spanId);
        //another widget
        if (spanId != id && iwidgetSpan.getAttribute("internalWidget") != "true") {
            var totalWiredEvents = 0;
            var matchedEvents = new Array();
            var hasMatchEvent = false;
            var wiredEvents = new Array();
            var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(spanId);
			if (!sourceWrapper) continue;
			if (sourceWrapper.isLoaded() == false) continue;
			
            var type = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(spanId);
            var pubEvents = sourceWrapper.getWidgetPublishedEvents();
			if (pubEvents != null) {    
	            for (var n = 0; n < pubEvents.length; n++) {
	            	var pubEvent = pubEvents[n];
	            	//CHECK PRIVATE
	                if (pubEvent.getAttribute("private") != "true"){
		                var isWired = false;
		                var isMatch = false;
						var isEventCompatible = com.ibm.mm.builder.utils.wireUtil.isEventFlexCompatible(pubEvent,targetEvent);
		                if (isEventCompatible) { // if the event payload is match
		                    hasMatchEvent = true;
		                    isMatch = true;
		                    for (var i = 0; i < wires.length; i++) {
		                        aWire = wires[i];
		                        //if the wire already exist
		                        if (spanId == aWire.getSourceWidgetID() && pubEvent.name == aWire.getSourceEventName() && eventName == aWire.getTargetEventName()) {
		                            isWired = true;
		                            totalWiredEvents++;
		                            wiredEvents.push(aWire);
		                        }
		                    }
		                }
		                var matchInfo = com.ibm.mm.builder.utils.wireUtil.createMatchEvent(spanId, type, isMatch, isWired, pubEvent.name, pubEvent.type, pubEvent.description);
		                matchedEvents.push(matchInfo);
	                }
	            }
			}
            widgets.push(com.ibm.mm.builder.utils.wireUtil.createMatchWidget(spanId, type, hasMatchEvent, totalWiredEvents, matchedEvents, wiredEvents, sourceWrapper.getWires()));
        }
    }
    com.ibm.mm.builder.utils.wireUtil.LOGGER.exiting("wireUtil: getAllMatchPubEvents");
    return widgets;
}

 /**
 * Create js object contains the widget info
 */
com.ibm.mm.builder.utils.wireUtil.createMatchWidget = function(id, type, hasMatchEvent, totalWiredEvents, events, wiredEvents, wires){
    var widget = new Object();
    widget["id"] = id;
    widget["type"] = type;
    widget["hasMatchEvent"] = hasMatchEvent;
    widget["totalWiredEvents"] = totalWiredEvents;
    widget["events"] = events;
    widget["wiredEvents"] = wiredEvents;
    widget["receivedWires"] = wires;
    return widget;
}

/**
* Create js object contains the event info
*/
com.ibm.mm.builder.utils.wireUtil.createMatchEvent = function(id, type, isMatch, isWired, eventName, eventType, eventDesc){
    var event = new Object();
    event["id"] = id;
    event["type"] = type;
    event["isMatch"] = isMatch;
    event["isWired"] = isWired;
    event["name"] = eventName;
    event["payloadType"] = eventType;
    event["description"] = eventDesc;
    return event;
}

 /**
 * Create the span which will be stored in microformat for saving the wire info
 */
com.ibm.mm.builder.utils.wireUtil.createWireSpan = function(sourceId, sourceEvent, targetEvent){
    var recEvent = document.createElement("span");
    recEvent.className = com.ibm.mm.builder.constant.receivedEvent;
    
    var srcWidget = document.createElement("a");
    srcWidget.className = com.ibm.mm.builder.constant.iwSourceEvent;
    srcWidget.setAttribute("href", "#" + sourceId);
    srcWidget.innerHTML = sourceEvent;
    
    var tarEvent = document.createElement("span"); //what event will handle the fired event
    tarEvent.className = com.ibm.mm.builder.constant.iwTargetEvent;
    tarEvent.innerHTML = targetEvent;
    
    recEvent.appendChild(srcWidget);
    recEvent.appendChild(tarEvent);
    return recEvent;
}
 /**
 * This function will be called when one widget is dropped on another and their payloads are match.
 * It will add a wire in memory and update the dom node at same time
 * @param sourceId(String): the dropped widget's id
 * @param targetId(String): the already-in-canvas widget's id
 */
com.ibm.mm.builder.utils.wireUtil.addWireWhenMatch = function(sourceId, targetId){
    var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(sourceId);
    if (!sourceWrapper) return false;
    var pubEvents = sourceWrapper.getWidgetPublishedEvents(); //never null, since the events have been checked
    var sourceEventName = pubEvents[0].name;
    
    var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(targetId);
	if (!targetWrapper) return false;
    var hanEvents = targetWrapper.getWidgetHandledEvents(); //never null, since the events have been checked
    //the handle events' names of the target widget 
    var targetEventName = hanEvents[0].name;
    
    var rc = com.ibm.mm.builder.utils.wireUtil.addWire(sourceId, sourceEventName, targetId, targetEventName);
    return rc;
}
 /**
 * Called by addWireWhenMatch() to add a wire in memory and update the dom node
 */
com.ibm.mm.builder.utils.wireUtil.addWire = function(sourceId, sourceEvent, targetId, targetEvent){    
	var rc = false;
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
	var widgetwrapper = widgetModel.find(targetId);
	if (widgetwrapper != null){
		var widgetinstance = widgetwrapper.getIWidgetInstance();
		widgetinstance.addWire(sourceId,sourceEvent,targetEvent);
		var deferred = widgetModel.commit();
		deferred.start(false);
		rc = true;
	}	
    return rc;
    
}

com.ibm.mm.builder.utils.wireUtil.isWireExist = function(sourceId, sourceEvent, targetId, targetEvent){
	var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(targetId);
	if (!targetWrapper) return false;
    var targetWires = targetWrapper.getWires();
    var isWireExist = false;
    for(var i = 0; i < targetWires.length; i++) {
    	var wire = targetWires[i];
    	if(sourceId == wire.getSourceWidgetID() && sourceEvent == getSourceEventName() && targetId == getTargetWidgetID() && targetEvent == getTargetEventName()) {
    		isWireExist = true;
    		break;
    	}
    }
    return isWireExist;
}

/**
 * remove a wire in memory and update the dom node
 */
com.ibm.mm.builder.utils.wireUtil.removeWire = function(sourceId, sourceEvent, targetId, targetEvent){
	var rc = false;
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
	var widgetwrapper = widgetModel.find(targetId);
	if (widgetwrapper != null){
		var widgetinstance = widgetwrapper.getIWidgetInstance();
		widgetinstance.removeWire(sourceId,sourceEvent,targetEvent);
		var deferred = widgetModel.commit();
		deferred.start();
		rc = true;
	}	
    return rc;
}

com.ibm.mm.data.dataTypeChecker = null;

com.ibm.mm.builder.utils.wireUtil.dataTypeChecker =  function() {
	if(com.ibm.mm.data.dataTypeChecker == null)
		com.ibm.mm.data.dataTypeChecker = new com.ibm.mm.data.datatypes();
	return com.ibm.mm.data.dataTypeChecker;
}
/**
 * Check whether the payload type of two events is compatible
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventCompatible = function(/** Object */ sourceEvent, /** Object */ targetEvent){

    if (sourceEvent == null || targetEvent == null)
        return false;
	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeMatch(targetEvent.type, sourceEvent.type);
    return result;
}

/**
 * Check whether the payload type of two events is compatible with more flex rules
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventFlexCompatible = function(/** Object */ sourceEvent, /** Object */ targetEvent){

    if (sourceEvent == null || targetEvent == null)
        return false;
	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeFlexMatch(targetEvent.type, sourceEvent.type);
    return result;
}

/**
 * Check whether the payload type of two widget is compatible
 * @param sourceId(string) : the id of the drop widget
 * @param targetId(string) : the id of the target widget
 */
com.ibm.mm.builder.utils.wireUtil.isWidgetCompatible = function(sourceId, targetId){
	
	if (sourceId == null || targetId == null || sourceId == targetId) 
        return false;
    
	var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(targetId);
	if (!targetWrapper) return false;
	var hanEvents = targetWrapper.getWidgetHandledEvents();
	
	var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(sourceId);
	if (!sourceWrapper) return false;
	var pubEvents = sourceWrapper.getWidgetPublishedEvents();
	
    if (pubEvents == null || hanEvents == null || pubEvents.length < 1 || hanEvents.length < 1) 
        return false;
    
	var publishPayloadType = pubEvents[0].type;
	var handlePayloadType = hanEvents[0].type;
    var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeMatch(handlePayloadType, publishPayloadType);
    return result;
}

/**
 * The prototype of checking whether the event is match: 1) event name is the same; 2) event payload is the same.
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire = function(/** Object */ sourceEvent, /** Object */ targetEvent){
    if (sourceEvent == null || targetEvent == null){return false;}
    //check the id or name is the same, currently no out-of-box widgets can work if add this condition
    if (sourceEvent.name != targetEvent.name) {return false;}
    if (sourceEvent.type == "any" ||  targetEvent.type == "any" || sourceEvent.type != targetEvent.type) {return false;}
    return true;
//	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
//	var result = checker.doesTypeFlexMatch(targetEvent.type, sourceEvent.type);
//    return result;
}

/**
 * Setup auto wire between new created auto wire enabled widget and other existing widgets.
 * @param {string} id: the uid of the widget
 */
com.ibm.mm.builder.utils.wireUtil.setupAutoWiring = function(id){
    //Get the widget instance and the event object
	
	var result = {
		"widgetId":id,
		"hasAutoWire":false,
		"publishTo": new Array(),
		"receiveFrom": new Array()
	}
	
	if(dojo.byId(id) == null || dojo.byId(id).getAttribute("autowiringenabled") != "true")
		return result;
	
	var publishTo = {};
	var receiveFrom = {};
	
    var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
    var pubEvents = widgetWrapper.getWidgetPublishedEvents();
    var hanEvents = widgetWrapper.getWidgetHandledEvents();
    
    var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
    var layouts = themeModel.getLayouts();
    var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts);
    
    var len = iwidgetsFromHTMLFragment.length;
    
    for (var x = 0; x < len; x++) {
        var spanId = iwidgetsFromHTMLFragment[x];
        //can not be the same widget
        if (spanId != id) {
        	var iwidgetSpan = dojo.byId(spanId);
        	if(iwidgetSpan.getAttribute("autowiringenabled") == "true" && iwidgetSpan.getAttribute("internalWidget") != "true") {
	        	// Get the compare widget instance
	            var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(spanId);
	            if(pubEvents != null) {
		            for(var y = 0; y < pubEvents.length; y++) {
		            	// Get all the handle events of the widget 
			            var targetHanEvents = targetWrapper.getWidgetHandledEvents();
						if (targetHanEvents != null){
				            for (var n = 0; n < targetHanEvents.length; n++) {
				                var targetHanEvent = targetHanEvents[n];
				                // Compare the handle event and the source widget's publish event name and payload type
								if (com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire(pubEvents[y],targetHanEvent)){
									// create the wire
									com.ibm.mm.builder.utils.wireUtil.addWire(id,pubEvents[y].name,spanId,targetHanEvent.name);
									result["hasAutoWire"] = true;
									if(publishTo[spanId] == null) {
										result["publishTo"].push(spanId);
										publishTo[spanId] = true;
									}
								}
				            }//end for
						}//end if
		            }
	            }//end if
	            if(hanEvents != null) {
		            for(var z = 0; z < hanEvents.length; z++) {
		            	// Get all the handle events of the widget 
			            var sourcePubEvents = targetWrapper.getWidgetPublishedEvents();
						if (sourcePubEvents != null){
				            for (var n = 0; n < sourcePubEvents.length; n++) {
				                var sourcePubEvent = sourcePubEvents[n];
				                // Compare the handle event and the source widget's publish event name and payload type
								if (com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire(sourcePubEvent, hanEvents[z])){
									// create the wire
									com.ibm.mm.builder.utils.wireUtil.addWire(spanId,sourcePubEvent.name,id,hanEvents[z].name);
									result["hasAutoWire"] = true;
									if(receiveFrom[spanId] == null) {
										result["receiveFrom"].push(spanId);
										receiveFrom[spanId] = true;
									}
								}
				            }//end for
						}//end if
		            }
	            }//end if
        	}// end if "autowiring" == true
        }
    }
    return result;
}

/**
 * Check if the new created widget can be auto wired to other existing widgets on the page.
 * @param {string} id: the uid of the widget
 */
com.ibm.mm.builder.utils.wireUtil.checkAutoWiring = function(id){
    //Get the widget instance and the event object
	if(dojo.byId(id) == null || dojo.byId(id).getAttribute("autowiringenabled") != "true")
		return false;
	
    var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
    var pubEvents = widgetWrapper.getWidgetPublishedEvents();
    var hanEvents = widgetWrapper.getWidgetHandledEvents();
    
    var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
    var layouts = themeModel.getLayouts();
    var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts);
    
    var len = iwidgetsFromHTMLFragment.length;
    
    for (var x = 0; x < len; x++) {
        var spanId = iwidgetsFromHTMLFragment[x];
        //can not be the same widget
        if (spanId != id) {
            // Get the compare widget instance
        	var iwidgetSpan = dojo.byId(spanId);
        	if(iwidgetSpan.getAttribute("autowiringenabled") == "true" && iwidgetSpan.getAttribute("internalWidget") != "true") {
	            var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(spanId);
	            if(pubEvents != null) {
		            for(var y = 0; y < pubEvents.length; y++) {
		            	// Get all the handle events of the widget 
			            var targetHanEvents = targetWrapper.getWidgetHandledEvents();
						if (targetHanEvents != null){
				            for (var n = 0; n < targetHanEvents.length; n++) {
				                var targetHanEvent = targetHanEvents[n];
				                // Compare the handle event and the source widget's publish event name and payload type
								if (com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire(pubEvents[y],targetHanEvent)){
									return true;
								}
				            }//end for
						}//end if
		            }
	            }//end if pubEvents
	            if(hanEvents != null) {
		            for(var z = 0; z < hanEvents.length; z++) {
		            	// Get all the handle events of the widget 
			            var sourcePubEvents = targetWrapper.getWidgetPublishedEvents();
						if (sourcePubEvents != null){
				            for (var n = 0; n < sourcePubEvents.length; n++) {
				                var sourcePubEvent = sourcePubEvents[n];
				                // Compare the handle event and the source widget's publish event name and payload type
								if (com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire(sourcePubEvent, hanEvents[z])){
									return true;
								}
				            }//end for
						}//end if
		            }
	            }//end if hanEvents
        	}// end if getAttribute("autowiring") == true
        }
    }
    return false;
}


}

if(!dojo._hasResource["com.ibm.mm.builder.utils.htmlUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.htmlUtil"] = true;
dojo.provide("com.ibm.mm.builder.utils.htmlUtil");



com.ibm.mm.builder.utils.htmlUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.htmlUtil");

//OpenSocial support change
if (this.widgetType !== null && this.widgetType=="mm_OSGadget")
	com.ibm.mm.builder.utils.htmlUtil.widgetClass = new RegExp("\\b"+com.ibm.mm.builder.constant.mmGGadget+"\\b")
else
	com.ibm.mm.builder.utils.htmlUtil.widgetClass = new RegExp("\\b"+com.ibm.mm.builder.constant.mmIWidget+"\\b")
	
com.ibm.mm.builder.utils.htmlUtil.classMatchType = {
	ContainsAll : 0, // all of the classes are part of the node's class (default)
	ContainsAny : 1, // any of the classes are part of the node's class
	IsOnly : 2 // only all of the classes are part of the node's class
}

com.ibm.mm.builder.utils.htmlUtil.endsWith = function(/*string*/str, /*string*/end, /*boolean*/ignoreCase){
// summary:
//	Returns true if 'str' ends with 'end'

	if(ignoreCase){
		str = str.toLowerCase();
		end = end.toLowerCase();
	}
	if((str.length - end.length) < 0){
		return false; // boolean
	}
	return str.lastIndexOf(end) == str.length - end.length; // boolean
}

com.ibm.mm.builder.utils.htmlUtil.startsWith = function(/*string*/str, /*string*/start, /*boolean*/ignoreCase){
	// summary:
	//	Returns true if 'str' starts with 'start'
	if(ignoreCase) {
		str = str.toLowerCase();
		start = start.toLowerCase();
	}
	return str.indexOf(start) == 0; // boolean
}

com.ibm.mm.builder.utils.htmlUtil.getAttribute = function(/* HTMLElement */node, /* string */attr){

	node = dojo.byId(node);

	if((!node)||(!node.getAttribute)){
		// if(attr !== 'nwType'){
		//	alert("getAttr of '" + attr + "' with bad node"); 
		// }
		return null;
	}
	var ta = typeof attr == 'string' ? attr : new String(attr);

	// first try the approach most likely to succeed
	var v = node.getAttribute(ta.toUpperCase());
	if((v)&&(typeof v == 'string')&&(v!="")){ 
		return v;	//	string 
	}

	// try returning the attributes value, if we couldn't get it as a string
	if(v && v.value){ 
		return v.value;	//	string 
	}

	// this should work on Opera 7, but it's a little on the crashy side
	if((node.getAttributeNode)&&(node.getAttributeNode(ta))){
		return (node.getAttributeNode(ta)).value;	//	string
	}else if(node.getAttribute(ta)){
		return node.getAttribute(ta);	//	string
	}else if(node.getAttribute(ta.toLowerCase())){
		return node.getAttribute(ta.toLowerCase());	//	string
	}
	return null;	//	string
}

com.ibm.mm.builder.utils.htmlUtil.getParentByType = function(/* HTMLElement */node, /* string */type) {
	//	summary
	//	Returns the first ancestor of node with tagName type.

	var _document = dojo.doc;
	var parent = dojo.byId(node);
	type = type.toLowerCase();
	while((parent)&&(parent.nodeName.toLowerCase()!=type)){
		if(parent==(_document["body"]||_document["documentElement"])){
			return null;
		}
		parent = parent.parentNode;
	}
	return parent;	//	HTMLElement
}

com.ibm.mm.builder.utils.htmlUtil.hasAttribute = function(/* HTMLElement */node, /* string */attr){
	//	summary
	//	Determines whether or not the specified node carries a value for the attribute in question.
	return com.ibm.mm.builder.utils.htmlUtil.getAttribute(dojo.byId(node), attr) ? true : false;	//	boolean
}

com.ibm.mm.builder.utils.htmlUtil.hasClass = function(/* HTMLElement */node, /* string */classname){
	return (new RegExp('(^|\\s+)'+classname+'(\\s+|$)')).test(com.ibm.mm.builder.utils.htmlUtil.getClass(node))	//	boolean
}

com.ibm.mm.builder.utils.htmlUtil.addClass = function(/* HTMLElement */node, /* string */classStr){
	//	summary
	//	Adds the specified class to the end of the class list on the
	//	passed &node;. Returns &true; or &false; indicating success or failure.
	if (com.ibm.mm.builder.utils.htmlUtil.hasClass(node, classStr)) {
	  return false;
	}
	classStr = (com.ibm.mm.builder.utils.htmlUtil.getClass(node) + " " + classStr).replace(/^\s+|\s+$/g,"");
	return com.ibm.mm.builder.utils.htmlUtil.setClass(node, classStr);	//	boolean
}

com.ibm.mm.builder.utils.htmlUtil.setClass = function(/* HTMLElement */node, /* string */classStr){
	//	summary
	//	Clobbers the existing list of classes for the node, replacing it with
	//	the list given in the 2nd argument. Returns true or false
	//	indicating success or failure.
	node = dojo.byId(node);
	var cs = new String(classStr);
	try{
		if(typeof node.className == "string"){
			node.className = cs;
		}else if(node.setAttribute){
			node.setAttribute("class", classStr);
			node.className = cs;
		}else{
			return false;
		}
	}catch(e){
		com.ibm.mm.builder.utils.htmlUtil.LOGGER.severe("setClass",dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_HTML_UTIL_SET_CLASS_1,[e.message]));
	}
	return true;
}

com.ibm.mm.builder.utils.htmlUtil.getClass = function(/* HTMLElement */node){
	//	summary
	//	Returns the string value of the list of CSS classes currently assigned directly 
	//	to the node in question. Returns an empty string if no class attribute is found;
	node = dojo.byId(node);
	if(!node){ return ""; }
	var cs = "";
	if(node.className){
		cs = node.className;
	}else if(com.ibm.mm.builder.utils.htmlUtil.hasAttribute(node, "class")){
		cs = com.ibm.mm.builder.utils.htmlUtil.getAttribute(node, "class");
	}
	return cs.replace(/^\s+|\s+$/g, "");	//	string
}

com.ibm.mm.builder.utils.htmlUtil.getClasses = function(/* HTMLElement */node) {
	var c = com.ibm.mm.builder.utils.htmlUtil.getClass(node);
	return (c == "") ? [] : c.split(/\s+/g);	//	array
}

com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass = function(clzName,parent) {
	var iwidgetsSpan = dojo.query("." + clzName,parent);
	var len = iwidgetsSpan.length;
	var children = new Array();
	for (var x=0;x<len;x++){
		if (com.ibm.mm.builder.utils.htmlUtil.isDirectChild(iwidgetsSpan[x],parent)){
			children.push(iwidgetsSpan[x]);
		}
	}
	return children;
}

com.ibm.mm.builder.utils.htmlUtil.setUnderlayBgColor = function(){
	var bodyNode = document.getElementsByTagName("BODY")[0];
	var tags = dojo.query(".dijitDialogUnderlay", bodyNode);
	var len =  tags.length;
	for (var k=0;k<len;k++){
		dojo.style(tags[k], {
			background: "black",
			opacity: "0.35",
			filter: "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0.35"
		})
	}		
}



// to check if there is any span named iw:iWidget, between child and parent
com.ibm.mm.builder.utils.htmlUtil.isDirectChild = function(child,parent){
	var clzName = child.className;
	var pNode = child.parentNode;
	while (pNode!=parent){
		if (pNode.className == clzName){
			return false;
		}else{
			pNode = pNode.parentNode;
		}
	}
	return true;
}

com.ibm.mm.builder.utils.htmlUtil.getDirectChildrenbyClass = function(clzName,parent) {
	var iwidgetsSpan = dojo.query("." + clzName,parent);
	var len = iwidgetsSpan.length;
	var children = new Array();
	for (var x=0;x<len;x++){
		if (iwidgetsSpan[x].parentNode == parent){
			children.push(iwidgetsSpan[x]);
		}
	}
	return children;
}

com.ibm.mm.builder.utils.htmlUtil.combineTwoColumn = function(root,left,right){
	if (this.endsWith(root,"/>")){
		root = root.substr(0,root.length - 2);
		root = root + ">\n";
	}else{
		if (this.endsWith(root,"</div>",true)){
			root = root.substr(0,root.length - 6)+"\n";
		}else{
			return "";
		}
	}
	root = root + left;
	root = root + right;
	root = root + "</div>";
	return root;
}

com.ibm.mm.builder.utils.htmlUtil.getElementById = function(parentNode, tagId) {
    var retval = null;
    var childTags = parentNode.getElementsByTagName("*");
    for (var ii=0; ii<childTags.length; ii++) {
        if (childTags[ii].id == tagId) {
            retval = childTags[ii];
            break;
        }
    }
    return (retval)
}
	
com.ibm.mm.builder.utils.htmlUtil.getElementsByClassName = function() {
	var retval = [];
	var searchTags= ["div", "span"];
	for (index=0;index<searchTags.length;index++) {
		els = document.getElementsByTagName(searchTags[index]);
		var elsLen = els.length;
		for (i=0;i<elsLen; i++) {
			if ( this.widgetClass.test(els[i].className)) {
				retval[retval.length] = els[i];
				
			}
        }
	}
	return retval;
}
	
com.ibm.mm.builder.utils.htmlUtil.getElementString = function(node) {
	var ndiv = document.createElement("div");
	var clonedNode = node.cloneNode(true);
	ndiv.appendChild(clonedNode);
	return ndiv.innerHTML;
}

com.ibm.mm.builder.utils.htmlUtil.addOnclickToElement = function(element,func){
	if (element.attachEvent){
		//IE
		element.attachEvent("onclick",function(){eval(func);});
	}else{
		//FF
		element.setAttribute("onclick","javascript:"+func);
	}
}

com.ibm.mm.builder.utils.htmlUtil.removeOnclickFromElement = function(element,func){
	if (element.detachEvent){
		//IE TODO: this does not work, how to detach the onclick event?
		element.detachEvent("onclick",function(){eval(func);});
	}else{
		//FF
		element.removeAttribute("onclick");
	}		
}

com.ibm.mm.builder.utils.htmlUtil.getInclosedWidgets = function(node) {
	var retval = [];
	if (node != null) {		
		var allWidgets = this.getElementsByClassName();
		if (allWidgets && allWidgets.length>0) {
			for (var index=0;index<allWidgets.length;index++) {
				var aNode = allWidgets[index];
				if (node == this.getWidgetParent(aNode)) {
					retval[retval.length] = aNode;
				}
			}
		}
	}
	return retval;
}

com.ibm.mm.builder.utils.htmlUtil.getChildWidgets = function(/*Node*/selfNode) {
	 var retval = [];
	 if (selfNode) {
	 	var aNode = dojo.byId(selfNode);
		 var childNodes = aNode.childNodes;
		 if (childNodes != null && childNodes.length > 0) {
			 for (var index=0;index<childNodes.length;index++) {
				 child = childNodes[index];
				 if (child) {
					 if (this.widgetClass.test(child.className)) {
						 retval[retval.length] = child;
					 }
					 else {
						 children = checkChildElement(child);
						 if (children != null) {
							 for (ii=0;ii<children.length;ii++) {
								 retval[retval.length] = children[ii];
							 }
						 }
					 }
				 }
			 }
		 }
	 }
	 return retval;
}

com.ibm.mm.builder.utils.htmlUtil.checkParentElement = function(/*Node*/selfNode) {
	if (selfNode) {
		var dadNode = selfNode.parentNode;
		if (dadNode) {
			if (dadNode.className) {
				if (this.widgetClass.test(dadNode.className)) {
					return dadNode.id;
				}
			}
			return this.checkParentElement(dadNode);
		}
	}
	return null;
}

com.ibm.mm.builder.utils.htmlUtil.prependChild = function(/*Element*/node, /*Element*/parent){
	//	summary:
	//		prepends node to parent's children nodes
	if(parent.firstChild) {
		parent.insertBefore(node, parent.firstChild);
	} else {
		parent.appendChild(node);
	}
	return true;	//	boolean
}

com.ibm.mm.builder.utils.htmlUtil.disableSelection = function(/*DomNode*/element){
	// summary: disable selection on a node
	element = dojo.byId(element)||dojo.body();
	
	if(dojo.isMoz){
		element.style.MozUserSelect = "none";
	}else if(dojo.isSafari){
		element.style.KhtmlUserSelect = "none"; 
	}else if(dojo.isIE){
		element.unselectable = "on";
	}else{
		return false;
	}
	return true;
}

com.ibm.mm.builder.utils.htmlUtil.getWidgetParent = function(/*String*/id) {
	if (id==null) {
		return null;
	}	   		
	return this.checkParentElement(dojo.byId(id));
}

com.ibm.mm.builder.utils.htmlUtil.setStyle = function() {
	var node = arguments[0];
	for(var i=1; i<arguments.length; i++) {
		stylePair = arguments[i].split(":");
		node.style[stylePair[0]] = stylePair[1];
	}
}
	
com.ibm.mm.builder.utils.htmlUtil.createRadioButton = function(radioName,radioValue,radioOnclick,selected,title){
	var radioString = "<input type='radio' name='";
	radioString = radioString + radioName+ (title ? ("' title='" + title) : "") + "' value='";
	radioString = radioString + radioValue+ "' onclick='";
	radioString = radioString + radioOnclick+ "'";
	if (selected){
		radioString = radioString + " checked>";
	}else{
		radioString = radioString + ">";
	}
	return radioString;
}
	
com.ibm.mm.builder.utils.htmlUtil.getLimitedString = function(text, restrictionNum){
	if(!text)return ""
	if(text.length > restrictionNum){
		text = text.substr(0, restrictionNum) + "..."
	}
	return text
}

/**
 * @deprecated
 */
com.ibm.mm.builder.utils.htmlUtil.addShadow = function(domNode,classes) {
	for(var i=0; i<classes.length; i++) {
		var div = document.createElement("div");
		div.className = classes[i];
		domNode.appendChild(div);
	}
}

com.ibm.mm.builder.utils.htmlUtil.getSubstitute = function(message, args){
	if(message && args){
		return dojo.string.substitute(message, args);
	}
	return message;
}

com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle =	function (obj, prop) {
	if (obj.currentStyle) {
		var objStyle = obj.currentStyle[prop];
		if(ibmConfig.fontSizeEnlarged && prop === "fontSize" && objStyle.match(/em/)){
			var p = obj.parentNode;
			var isDialog = false;
			while(p && p.tagName.toLowerCase() != "body"){
				if (dojo.hasClass(p, "dialog_container")) {
					isDialog = true;
					break;
				}
				p = p.parentNode;
			}
			if(isDialog){
				var currentFontSize =parseFloat(objStyle.replace("em",""));
				var enlargedFontSize = parseFloat((p.currentStyle[prop]).replace("em",""));
				objStyle = currentFontSize*enlargedFontSize+"em";
			}
		}
		return objStyle;
	}
	else if (window.getComputedStyle) {
		prop = prop.replace (/([A-Z])/g, "-$1");
		prop = prop.toLowerCase ();
		return window.getComputedStyle (obj, "").getPropertyValue(prop);
	}
	return null;
}

com.ibm.mm.builder.utils.htmlUtil.createElementWithClass = function (type,classNm,innerHTML){
	var node = document.createElement(type);
	dojo.addClass(node, classNm);
	if(innerHTML)
		node.innerHTML = innerHTML;
	return node;
}

/*
 * get the actually length of string with necessary style 
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWidthByFontStyle = function(str, fontSize, fontFamily, fontWeight){
    if (!this.stringCheckDiv){
    	this.stringCheckDiv = document.createElement("span");
    	this.stringCheckDiv.style.whiteSpace = "nowrap";
    	this.stringCheckDiv.style.position = "absolute";
    	document.body.appendChild(this.stringCheckDiv);
    }
    var fontSize = fontSize || this.getCurrentStyle(document.body, "fontSize") || "";
    var fontFamily = fontFamily || this.getCurrentStyle(document.body, "fontFamily") || "";
    var fontWeight = fontWeight || this.getCurrentStyle(document.body, "fontWeight") || "";
    this.stringCheckDiv.style.fontSize = fontSize;
    this.stringCheckDiv.style.fontFamily = fontFamily;
    this.stringCheckDiv.style.fontWeight = fontWeight;
    this.stringCheckDiv.innerHTML = this.formatBlankSpace(str);
    this.stringCheckDiv.style.display = '';
    var w = this.stringCheckDiv.scrollWidth;
    this.stringCheckDiv.style.display = 'none';
    return w;
}

/*
 * get the actually length of string with the node's style and its parents'
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWidth = function(str, node, fontStyle){
	if(fontStyle && fontStyle.fontSize){
		this._fontSize = fontStyle.fontSize;
		this._fontFamily = fontStyle.fontFamily || "Arial,Helvetica,sans-serif";
		this._fontWeight = fontStyle.fontWeight || "normal";
		return this.getStrWidthByFontStyle(str, this._fontSize, this._fontFamily, this._fontWeight);
	}
	if(node){
		this._fontSize = this._fontFamily = this._fontWeight = null;
		while(node && !(this._fontSize && this._fontFamily && this._fontWeight)){
			if(!this._fontSize)this._fontSize = this.getCurrentStyle(node, "fontSize");
			if(!this._fontFamily)this._fontFamily = this.getCurrentStyle(node, "fontFamily");
			if(!this._fontWeight)this._fontWeight = this.getCurrentStyle(node, "fontWeight");
			node = node.parentNode;
		}
	}
	return this.getStrWidthByFontStyle(str, this._fontSize, this._fontFamily, this._fontWeight);
}

/*
 * get the intercepted string with the node's style and its parents' in limited width
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit = function(str, node, limitWidth, fontStyle){
	if (!str || str.length <= 0 || !limitWidth || limitWidth <= 0) return "";
	var delta = 2;
	var percentage = 0.618;
	var min_str = str.substring(0, 1) + "...";
	var min_width = this.getStrWidth(min_str, node, fontStyle);
	if (limitWidth <= min_width) return min_str;
	var width = this.getStrWidth(str, node, fontStyle);
	if (width < limitWidth) { return str; }
	else {
		var begin = 0;
		var end = str.length;
		while (begin < end) {
			if (end - begin <= delta) {
				while (this.getStrWidth(str.substring(0, begin) + "...") > limitWidth) 
					begin -= 1
				return (str.substring(0, begin) + "...")
			}
			var index = begin + Math.round((end - begin) * percentage);
			var width_intercepted = this.getStrWidth(str.substring(0, index));
			if (width_intercepted < limitWidth) {
				begin = index;
				end = end;
			}else{
				begin = begin;
				end = index;
			}
		}
	}
}

/*
 * Truncate the string in 'textField' of 'node' and provide the whole string in 'tipField' if necessary.
 */

com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText = function(/* DomNode */node,/* String */tipField,/* obj */fontStyle){
	dojo.forEach(dojo.query(".truncatedLabel",node),function(item){
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(item,tipField,fontStyle);
	});
}

com.ibm.mm.builder.utils.htmlUtil.truncateNodeText = function(/* DomNode */node,/* String */tipField, /*obj */fontStyle){
	var	textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
	if(!tipField){
		tipField = "title";
	}
	var widthLimit = 0;
	var str = node[textField];
	if(str.length == 0 ){return;}
	if (dojo.hasAttr(node, "widthlimit")) {
		widthLimit = parseInt(dojo.attr(node, "widthlimit"));
	}
	else {
		widthLimit = dojo.contentBox(node).w;
		if (widthLimit == 0) {
			widthLimit = parseInt(dojo.style(node,"width"));
		}
	}
	if (widthLimit > 0) {
		var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, node, widthLimit,fontStyle);
		if(shortStr.length <= str.length + 2 && !dojo.hasAttr(node,tipField)){
			dojo.attr(node,tipField,this.unEscapeString(str));
		}
		node[textField] = (textField === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? this.formatBlankSpace(shortStr) : shortStr;
	}
}

com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesWord = function(node){
	dojo.forEach(dojo.query(".wordTruncatedLabel",node),function(item){
		com.ibm.mm.builder.utils.htmlUtil.truncateWord(item);
	});
}


com.ibm.mm.builder.utils.htmlUtil.truncateWord = function(node,strContent,widthLimit){
	if(ibmConfig.fontSizeEnlarged){ return strContent; }
	if( !node ){return strContent;}
	var textType = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
	var str = strContent || node[textType];
	if(str.length == 0){ return strContent; }
	var wordsArr = str.split(" ");
	if (!widthLimit && dojo.hasAttr(node, "widthlimit")) {
		widthLimit = parseInt(dojo.attr(node, "widthlimit"));
	}
	var width = widthLimit ? widthLimit : dojo.contentBox(node).w;
	dojo.forEach(wordsArr,function(singleWord,index){
		wordsArr[index] =com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(singleWord,node,width); 
	});
	var content = wordsArr.join(" ");
	var resultContent = (textType === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? this.formatBlankSpace(content) : content;
	if(!str){	
		node[textType] = resultContent; 
	} else{
		return resultContent;
	}
	
}

com.ibm.mm.builder.utils.htmlUtil.markTruncation = function(node,widthLimit){
	dojo.addClass(node,"truncatedLabel");
	dojo.attr(node,"widthLimit",widthLimit);
}

/**
 *handle space and line separator 
 */
com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace = function(title){
	if (!title) return "";
	return	title.replace(/\s/g, "&nbsp;");
}
/*
 * This method will replace & with &amp; to avoid incorrect display string &bmp; as an instance.
 * it will handle space as well.
 */
com.ibm.mm.builder.utils.htmlUtil.formatDisplayedContent = function(content, noNeedReplaceAmp, noNeedReplaceNbsp){
	if (!content) return '';
	if (!noNeedReplaceAmp) {
		content = content.replace(/&/g, "&amp;");
	}
	if (!noNeedReplaceNbsp) {
		content = content.replace(/\s/g, "&nbsp;");
	}
	return content;
}

com.ibm.mm.builder.utils.htmlUtil.escapeString = function(content){
	if (!content) return "";
	return content.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
}

com.ibm.mm.builder.utils.htmlUtil.unEscapeString = function(content){
	if(!content) return "";
	return content.replace(/&amp;/g,"&").replace(/&quot;/g,"\"").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&nbsp;/g," ");
}
/**
 * 
 * @param {String} str the message 
 */
com.ibm.mm.builder.utils.htmlUtil.formatMessage = function(str){
	if (!str || str.length <= 0) {
		return "";
	} 
	else {
		var lineSeparatorIndex = str.indexOf("\n");
		if (lineSeparatorIndex > 0) {
			var firstLine = str.substring(0, lineSeparatorIndex);
			var leftLine = str.substring(lineSeparatorIndex);//include '\n'
			return "<div class='firstLineFont truncatedLabel' widthLimit='400'>" + firstLine + "</div><span class='leftLineFont'>" +
			 leftLine.replace(/\n/g, "<br/>")+ "</span>";
		}
		else {
			return str.replace(/\n/g, "<br/>");
		}
	}
}
/**
 * set the title of node
 * @param {String} tileStr the tile of node
 * @param {Object} titleNode the node    
 * @param {Float} limitWidth the width of title
 * 
 */
com.ibm.mm.builder.utils.htmlUtil.setNodeTitle = function(titleStr, titleNode, limitWidth) {
	if (!titleNode||!titleStr)
		return;
	if(!limitWidth||limitWidth<=0){
		try{
			var valueStr=this.getCurrentStyle(titleNode,"width");
			limitWidth = (valueStr=="auto")?valueStr:parseFloat(valueStr.match(/\d*\.?\d*/));
		}catch(e){
			limitWidth = null
		}
	}
	titleNode.title = "";
    if(!limitWidth||limitWidth=="auto"){
    	titleNode.innerHTML =this.formatBlankSpace(titleStr);
    	return;
    }
	var _title = this.getStrWithLimit(titleStr, titleNode, limitWidth);
	titleNode.innerHTML = this.formatBlankSpace(_title);
	if (titleStr != _title) titleNode.title = this.unEscapeString(titleStr);
}

/**
 * set the title of node with font style
 * @param {String} tileStr, the tile of node
 * @param {Object} titleNode the node    
 * @param {Float} limitWidth, the width of title
 * @param {Map} fontStyle, it should be a map like this <code>{fontSize:"10px", fontFamily:"Sanson", fontWeight:"bold"}</code>
 * 
 */
com.ibm.mm.builder.utils.htmlUtil.setNodeTitleWithStyle = function(titleStr, titleNode, limitWidth, fontStyle) {
	if (!titleNode||!limitWidth||!titleStr||limitWidth<=0||!fontStyle){
		return;
	}
	titleNode.title = "";
	var _title = this.getStrWithLimit(titleStr, titleNode, limitWidth, fontStyle);
	if(titleNode.tagName == "INPUT"){//button
		titleNode.value = _title;
	}else{
		titleNode.innerHTML = this.formatDisplayedContent(_title);
	}
	
	if (titleStr != _title) titleNode.title = titleStr;
}

/**
 * set label and title under such conditions with limited width
 *  node.innerHTML = dojo.string.substitute(label,["<span class=\"youclass\">"+string+"</span>"]);
 */
com.ibm.mm.builder.utils.htmlUtil.setCombinedStringInNode = function(label, content, node, limitedWidth, className){
	var labelWidth = this.getStrWidth(label, node);
	if (labelWidth > limitedWidth) {
		var title = dojo.string.substitute(label, [content]);
		this.setNodeTitle(title, node, limitedWidth);
		return;
	}
	var tempSpan = document.createElement("span");
	tempSpan.className = className;
	node.appendChild(tempSpan);
	var limitedContent = this.getStrWithLimit(content, tempSpan, limitedWidth - labelWidth);
	
	var _content = dojo.string.substitute(label, ["<span class=\"" + className + "\">" + this.formatDisplayedContent(limitedContent) + "</span>"]);
	node.removeChild(tempSpan);
	node.innerHTML = _content;
	if (limitedContent != content) node.title = dojo.string.substitute(label, [content]);
}

/**
 * load a CSS file on the fly.
 */
com.ibm.mm.builder.utils.htmlUtil.loadCss = function(css_url){
	this.loadedCss = this.loadedCss || [];
	
	for(var i=0; i<this.loadedCss.length; i++) {
		var css = this.loadedCss[i];
		if(css == css_url){
			return;
		}
	}
	
	var headID = document.getElementsByTagName("head")[0];         
	var cssNode = document.createElement('link');
	cssNode.type = 'text/css';
	cssNode.rel = 'stylesheet';
	cssNode.href = css_url;
	cssNode.media = 'screen';
	headID.appendChild(cssNode);
			
	this.loadedCss.push(css_url);
}

com.ibm.mm.builder.utils.htmlUtil.removeIframe = function(node){
	if(!node) return;
	var iframe = dojo.query("iframe",node)[0];
	if(iframe){ iframe.parentNode.removeChild(iframe); }
}

com.ibm.mm.builder.utils.htmlUtil.showNodes = function(nodes){
	dojo.forEach(nodes, function(node){
		if (node.style) 
			node.style.display = "";
	});
}

com.ibm.mm.builder.utils.htmlUtil.hideNodes = function(nodes){
	dojo.forEach(nodes, function(node){
		if (node.style) 
			node.style.display = "none";
	});
}

com.ibm.mm.builder.utils.htmlUtil.releaseNode = function(node){
	if (node) {
		try {
			node.onmouseout = null;
			node.onmousemove = null;
			node.onclick = null;
			node.onfocus = null;
			node.onkeypress = null;
			node.innerHTML = "";
		} 
		catch (e) {
		}
	}
}

com.ibm.mm.builder.utils.htmlUtil.uncheckAll = function(pNodes){
	dojo.forEach(pNodes,function(item){
		var inputs = dojo.query("input", item);
		if (inputs) {
			var checkBox = dojo.query("input", item)[0];
			checkBox.checked = false;
		}
	});
}

com.ibm.mm.builder.utils.htmlUtil.getAllCheckedNodes = function(pNode){
	var checkedNodes = [];
	dojo.forEach(pNode.childNodes,function(item){
		var checkBox = dojo.query("input", item)[0];
		if(checkBox.checked){checkedNodes.push(item);}
	});
	return checkedNodes; 
}

//TODO: need to find another better way to fix the bug(scrollbar is hidden by the background in embed dialog)
com.ibm.mm.builder.utils.htmlUtil.showScrollBar = function(widgetId){
	if(widgetId != "layoutwidget"){ return; }
	var rootNode= dojo.byId(widgetId);
	if( !rootNode ){ return; }
	var iframeNode = rootNode.parentNode;
	while(iframeNode){
		if(iframeNode.nodeName.toLowerCase() === "#document"){ break; }
		iframeNode = iframeNode.parentNode;
	}
	if( !iframeNode ){ return; }
	var iframeNode = rootNode.parentNode.parentNode.parentNode; 
	if(dojo.isIE && (iframeNode.URL.match(/mycontenthandler/))){
		var rDiv = dojo.query(".mm_Content > div",rootNode)[0];
		if(rDiv){ rDiv.style.position = "static"; }
		var container = dojo.query(".wrapper",rootNode)[0];
		if(container){ container.style.position = "static"; }
	}	
}

/*fix an ie bug: quotes of the attribute's value on a dom will be removed when use innerHTML to get the content.
 *for example: <div title="${key}" /> will be <div title=${key} /> in ie
 */
com.ibm.mm.builder.utils.htmlUtil.addMissingQuoteInTitle = function(str){
	if(!str){ return ""; }
	return str.replace(/title\s*=\s*\${([^}]+)}/g,"title=\"${$1}\"");
}

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.ShadowMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ShadowMenu"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.ShadowMenu");



/**
 * summary: cusomize the dijit.Menu with shadow
 */	
dojo.declare("com.ibm.mm.builder.widget.ShadowMenu", [dijit.Menu], {
	
	offset_x: 0,
	offset_y: 0,
	leftClickToOpen: true,
	openPosition:"BL",
	
	postCreate: function(){
	 	this.inherited(arguments);
		if (!this.isLeftToRight()) { this.offset_x = -this.offset_x; }
		if(dojo.isIE === 6) return;
		this._connects.push([dojo.connect(window, "resize", this, function(){
			if(this.shadow)this.shadow.setDisabled(true);
			dijit.popup.close(this);
		})]);
		//bug: resolve the problem that the style of menu can't adjust when user change the page theme
	    dojo.addClass(this.domNode,"lotusActionMenu");
	},
	
	/*
	 * override this method to fix dojo issue and builder bug 8934
	 */
	onItemHover: function(item){
		if (this.popupFocusTimer) {
			clearTimeout(this.popupFocusTimer);
		}
		this.inherited(arguments);
	},

	/*
	 * Override _openMyself method to change the menu display position.
	 * 
	 * offset_x and offset_y are used to adjust the position 
	 * according to the target node.
	 */
	_openMyself: function(/*Event*/ e, /*DomNode?*/ node, /*DomNode?*/ iframe){
		if(this.leftClickToOpen&&e.button>0){
			return;
		}
		//TODO fix ie refresh issue..
		try {
			dojo.stopEvent(e);
		} catch (e) {
		}

		//---change the default open position begin
		var node = e.target;
		if(this.targetNodeIds && this.targetNodeIds.length == 1){
			node = this.targetNodeIds[0];
		}
		var coords = dojo.coords(node, true);
		var cbox = dojo.contentBox(node);
		
		var xPack = 0;
		if(this.openPosition.charAt(1) == "R"){
			xPack = this.isLeftToRight() ? cbox.w : -cbox.w;
		}
		
		var x = coords.x + xPack + (this.offset_x||0) + (this.isLeftToRight() ? 0 : cbox.w);
		var y = coords.y + (this.openPosition.charAt(0) == "B" ? cbox.h : 0) + (this.offset_y||0);
		//---change the default open position end

		var self=this;
		var savedFocus = null; //hot fix for opera on spacemanager
		try{savedFocus = dijit.getFocus(this);}catch(e){}
		this.closeAndRestoreFocus = function(){
			// user has clicked on a menu or popup
			if(self.refocus && savedFocus){
				dijit.focus(savedFocus);
			}
			dijit.popup.close(self);
		}
		
		this._prepareData();
		
		//no need to open menu without menu item 
		if (this.getChildren().length === 0) { return; }
		
		dijit.popup.open({
			popup: this,
			x: x,
			y: y,
			onExecute: this.closeAndRestoreFocus,
			onCancel: this.closeAndRestoreFocus,
			orient: this.isLeftToRight() ? 'L' : 'R'
		});
		this.focus();
		
		this._onBlur = function(){
			this.inherited('_onBlur', arguments);
			dijit.popup.close(this);
		}
	},
	
	_prepareData: function(){
		if (!this._isMenuCreated && !this._isMenuCreating) {
			this._isMenuCreating = true;
			this.prepareData();
			this._isMenuCreated  = true;
			this._isMenuCreating  = false;
		}
	},
	prepareData: function(){},
	
	_openPopup: function(){
		if(this.focusedChild.popup._prepareData){ this.focusedChild.popup._prepareData(); }
		this._orient = this.isLeftToRight() ? {'TR': 'TL', 'TL': 'TR'} : {'TL': 'TR', 'TR': 'TL'};
		
		this.inherited(arguments);
	},
	
    onOpen: function(){
		this.inherited(arguments);
		//if domnode is too small, no necessary to create shadow
		var p = dojo.marginBox(this.domNode);
		if(p.w < 1 && p.h < 1){return;}
		
		this.shadow = this.shadow || new com.ibm.mm.builder.widget.Shadow({
			node: this.domNode
		});
		
		this.resizeShadow();
	},
	
	resizeShadow:function(){
		var s = this.shadow;
		setTimeout(function(){
			if (s) {
				s.resize();
				s.setDisabled(false);
			}
		}, 50);
	},
	
	onClose: function(){
		//fix dojo1.3.2 issue: dojo do not remove the hovered item style by default
		dojo.forEach(this.containerNode.childNodes,function(item){
			dojo.removeClass(item,"dijitMenuItemHover");
			dojo.removeClass(item,"dijitMenuItemSelected");
		});
		this.inherited(arguments);
		if(this.shadow){
			this.shadow.setDisabled(true);
		}
	},
	
	destroy: function(){
		if(this.shadow){
			this.shadow.destroy();
			this.shadow = null;
		}
		//set the closure to null to avoid memory leak
		this._onBlur = null;
		this.closeAndRestoreFocus = null;
		//close menu to avoid memory leak on IE
		try {
			dijit.popup.close(this);
		} catch (e) {}//context menu of widget already destroy it, cannot close it.
		this.inherited(arguments);
	}
});
/**
 * summary: Adds a drop-shadow (right and bottom side if LTR, left and bottom if RTL) to a node.
 */
dojo.declare("com.ibm.mm.builder.widget.Shadow", dojox.fx.Shadow, {
	
	shadowPng: dojo.moduleUrl("com.ibm.mm.builder.widget", "resources/shadow"),
	
	// shadowThickness: Integer
	// 	How wide (in px) to make the shadow
	shadowThickness: 5,

	// shadowOffset: Integer
	//	How deep to make the shadow appear to be
	shadowOffset: 0,
	
	// shadowOffset_x: Integer
	//	How deep to make the shadow appear to be in x direction
	shadowOffset_x: 5,

	postCreate: function(){
		this.inherited(arguments);
		this.node.style.position = "relative";
		//create a fake node to represent the original node
		this.realNode = this.node;
		
		this.node = this._getFakeNode(this.realNode);
		
		this.pieces={};
		var x0 = this.shadowOffset_x
		var x1 = -1 * this.shadowThickness + this.shadowOffset_x;
		var y0 = this.shadowOffset;
		var y1 = this.shadowOffset + this.shadowThickness;
		
		if(this.isLeftToRight()){
			this._makePiece("tr", "top", y0, "left", 0);
			this._makePiece("r", "top", y1, "left", 0, "scale");
			this._makePiece("bl", "top", 0, "left", x1);
			this._makePiece("b", "top", 0, "left", x0, "scale");
			this._makePiece("br", "top", 0, "left", 0);
		}else{
			var x1 = -1 * this.shadowThickness;
			this._makePiece("tl", "top", y0, "left", x1);
			this._makePiece("l", "top", y1, "left", x1, "scale");
			this._makePiece("bl", "top", 0, "left", x1);
			this._makePiece("b", "top", 0, "left", 0, "scale");
			this._makePiece("br", "top", 0, "right", 0);
		}
		
		this.nodeList = dojo.query(".shadowPiece",this.node);
		//Set alt attribute for accessibility support and make sure all shadow can show over other menu
		dojo.forEach(this.nodeList, 'dojo.attr(item,"alt","");item.style.zIndex=1001;');
		
		//it seems menu will resize the created shadow, so commnet it to avoid invoke twice.
		//this.resize();
	},

	_getFakeNode: function(node){
		var coords = dojo.coords(node, true);
		
		var shadowDiv = dojo.query(dojo.create("div", null, dojo.body()))
			.addClass("mashupsShadowNode")
			.style({
				position: "absolute",
				left: coords.x + "px",
				top: coords.y + "px",
				zIndex: 998
			})[0];
		
		dojo.query(dojo.create("iframe", {frameborder: 0}, shadowDiv))
			.addClass("shadowedNodePlaceHolder").addClass("shadowPiece")
			.style({heith: "0px", width: "0px"});
		
		this._resizeFakeNode(shadowDiv);
		return shadowDiv;
	},
	
	setDisabled: function(/* Boolean */disabled){
		this.inherited(arguments);
		this.node && (this.node.style.visibility = disabled ? "hidden" : "visible");
	},
	
	resize: function(args){
		this._resizeFakeNode();
		var x, y;
		if(args){ 
			x = args.x; y = args.y;
		}else{
			var co = dojo.marginBox(this.realNode);
			x = co.w; y = co.h;
		}
		var sideWidth = Math.max(x - this.shadowOffset_x, 0);
		var sideHeight = Math.max(y - (this.shadowOffset + this.shadowThickness), 0);
		y = Math.max(y, 1);
		x = Math.max(x, 1);
		with(this.pieces){
			if (this.isLeftToRight()) {
				dojo.marginBox(r, {h:sideHeight, l:x});
				dojo.marginBox(tr, {l:x});
				dojo.marginBox(br, {l:x})
			} else {
				dojo.marginBox(l, {h:sideHeight});
			}
			dojo.marginBox(b, {w: sideWidth, t:y});
			dojo.marginBox(bl, {t:y});
			dojo.marginBox(br, {t:y})
		}
	},
	
	_resizeFakeNode: function(node){
		var fakeNode = node || this.node;
		var coords = dojo.coords(this.realNode, true);
		
		var pl = dojo.query(".shadowedNodePlaceHolder", fakeNode)[0];
		if(pl) dojo.marginBox(pl, { w: coords.w, h: coords.h });
		if(fakeNode) dojo.marginBox(fakeNode, {l: coords.x, t: coords.y});
	},
	
	uninitialize: function(){
		if(this.node){
			dojo.destroy(this.node);
			this.node = null;
		}
		this.inherited(arguments);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.MumMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MumMenu"] = true;
/**
 * This is a customized dijit.Menu
 *
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Erik	(bizheng@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.MumMenu");



dojo.declare("com.ibm.mm.builder.widget.MumMenu", com.ibm.mm.builder.widget.ShadowMenu, {

	counter:0,
	
	templateString: 
		'<table class="dijit remixMenu" waiRole="menu" dojoAttachEvent="onkeypress:_onKeyPress">' +
    		'<tbody class="dijitReset" dojoAttachPoint="containerNode"></tbody>' +
    	'</table>',

	postCreate: function(){
	 	this.inherited(arguments);
		if(this.targetNodeIds && this.targetNodeIds.length == 1){
			var target = this.targetNodeIds[0];
			var targetid = target.id;
			if (targetid){
				if (targetid.indexOf("_menu")!=-1){
					var widgetId = targetid.substr(0,targetid.length-5);
					var widgetSpan = dojo.byId(widgetId);
					if (widgetSpan){
						if (widgetSpan.getAttribute("visible") === "false"){
							// fix the wrong open position for context menu in NVA
							this.offset_x = 41;
							this.offset_y = dojo.isIE ? 0:8;
						}
					}
				 var contextWidget = dijit.byId(widgetId + com.ibm.mm.builder.constant.dragHandler+"_editbar");
				if (contextWidget) {
					dojo.connect(this, "onBlur", contextWidget, "hide")
				}	
				}	
			}
		}
	},
	    
	_pubMenuEvent:function(){
		
	},
	
	resizeShadow:function(){
		//TODO: a temp fix for IE7 issue, need to find correct solution soon.
		var self = this;
		setTimeout(function(){
			if(self.shadow){
				self.shadow.resize();
				self.shadow.setDisabled(false);
			}
		}, (dojo.isIE===7?500:0));
	},
	
	onClose:function(){
		// counter is the temp for dojo menu call onClose twice every time.
		this.counter = this.counter + 1;
		this.inherited(arguments);
		if (this.counter == 2){
			this.counter = 0;
			var self = this;
			setTimeout(function(){
				self._pubMenuEvent();	
			}, 0);
		}
	},
    onBlur: function(){
			dijit.popup.close(this);	
	},
	onOpen: function(){
		try {
			this.inherited(arguments);
			var self = this;
			if(dojo.isIE !== 7)	return;
			setTimeout(function(){
				if(self.parentMenu && self.parentMenu.shadow) self.parentMenu.shadow.resize();
			}, 250);
		} catch (e) {
			console.log(e)
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.MumMenuItem", dijit.MenuItem, {
    templateString: 
		'<tr class="dijitReset dijitMenuItem remixMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1" ' +
    		'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick">' +
	    	'<td><div dojoAttachPoint="iconNode" class="dijitReset lotusDijitMenuItemIcon"></div></td>' +
			'<td tabIndex="-1" class="dijitReset dijitMenuItemLabel lotusDijitMenuItemLabel truncatedLabel" widthLimit="170" dojoAttachPoint="containerNode" waiRole="menuitem"></td>' +
			'<td class="dijitReset" dojoAttachPoint="arrowCell">' +
				'<div dojoAttachPoint="arrowWrapper" style="display: none">'+
				    '<div class="lotusDijitMenuExpandEnabled"></div>' +
				    '<span class="dijitMenuExpandA11y">+</span>' +
				'</div>'+
		    '</td>' +
			'<td><div class="dijitReset lotusDijitMenuItemIcon"></div></td>' +
    	'</tr>',
	postCreate: function(){
		if(dojo.isIE === 7 ){
			com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(this.containerNode, null, {fontSize:"1.3em"});
		}
	},
	
    focus: function(){
        dojo.addClass(this.domNode, 'dijitMenuItemHover');
		this.inherited(arguments);
    },

	_setSelected: function(selected){
		this.inherited(arguments);	
		if(selected){ return; }
		dojo.removeClass(this.domNode,"dijitMenuItemHover");
	},
	
	setDisabled: function(/*Boolean*/value){
        // summary: enable or disable this menu item
        this.disabled = value;
        dojo[value ? "addClass" : "removeClass"](this.domNode, 'remixMenuItemDisabled');
        dijit.setWaiState(this.containerNode, 'disabled', value ? 'true' : 'false');
    },
	
	startup: function(){
		if (this.popup) {
			dojo.body().appendChild(this.popup.domNode);
			this.arrowWrapper.style.display = "";
			this.popup.domNode.style.display = "none";
			dijit.setWaiState(this.containerNode, "haspopup", "true");
		}
	},
	
	destroyDescendants: function(){
		if(this.popup){
			this.popup.destroyRecursive();
			delete this.popup;
		}
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.widget.MumPopupMenuItem", com.ibm.mm.builder.widget.MumMenuItem, {
	
	_fillContent: function(){
		if(this.srcNodeRef){
			var nodes = dojo.query("*", this.srcNodeRef);
			dijit.PopupMenuItem.superclass._fillContent.call(this, nodes[0]);

			// save pointer to srcNode so we can grab the drop down widget after it's instantiated
			this.dropDownContainer = this.srcNodeRef;
		}
	},
		
	startup: function(){
		if(this._started){ return; }
		this.inherited(arguments);

		// we didn't copy the dropdown widget from the this.srcNodeRef, so it's in no-man's
		// land now.  move it to dojo.doc.body.
		if(!this.popup){
			var node = dojo.query("[widgetId]", this.dropDownContainer)[0];
			this.popup = dijit.byNode(node);
		}
		dojo.body().appendChild(this.popup.domNode);

		this.popup.domNode.style.display="none";
		if(this.arrowWrapper){
			dojo.style(this.arrowWrapper, "visibility", "");
		}
		dijit.setWaiState(this.focusNode, "haspopup", "true");
	},
	
	destroyDescendants: function(){
		if(this.popup){
			this.popup.destroyRecursive();
			delete this.popup;
		}
		this.inherited(arguments);
	}
	
});

dojo.declare("com.ibm.mm.builder.widget.MumMenuSeparator", dijit.MenuSeparator, {
    // summary
    //	A line between two menu items 
    templateString: 
		'<tr>'+
    		'<td colspan=4>'+
				'<div class="mumMenuSeparator"></div>'+
			'</td>' +
		'</tr>'
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.WidgetMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.WidgetMenu"] = true;
/* Copyright IBM Corp. 2009  All Rights Reserved.                    */
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.WidgetMenu");




/**
 * This class is used to create menu, manage the action of menu item
 */
dojo.declare("com.ibm.mm.builder.widget.WidgetMenu", null, {

	iwidgetId: "",
	
	targetNode: null,
	
	inNva: false,
	
	pMenu: null,
	
	editPane: null,
	
	editorDiv: null,
	
	cws: com.ibm.mm.builder.coreWidgetsStrings,
	
	supportedModeString : {
		'print': com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MODE_PRINT,
		'help': com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MODE_HELP
	},
	
	// temp fix for old widget spec
	oldWidgetConfigId:"",
	oldWidgetConfigParentNode:null,
	// end temp fix
	
    constructor: function(params){
		this.needResizeMoveMenuItems = true;
		
		dojo.mixin(this, params);
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.widget.WidgetMenu");
        this.eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        this.widgetModes = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetSupportedModes(this.iwidgetId);
        this.cleanDomDialogHandle = dojo.subscribe(com.ibm.mm.builder.eventTopics.Page_ContentChanged, this, "cleanDomDialog");
    	// subscribe topic which need to support v1.1 widget 
		dojo.subscribe(com.ibm.mm.builder.Topics.Widget_ConfigurationFinished, this, "closeEditDialog");
    },
	
	hasEditMode:function(){
		return this.isWidgetLoaded() && dojo.indexOf(this.widgetModes, "edit") >= 0;
	},
	
	isWidgetLoaded: function(){
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.iwidgetId);
		return widgetModel && widgetModel.loaded;
	},
	
	createOtherModesItem: function(){
		var modePopup = null; 
		var widgetMenu = this;
		dojo.forEach(this.widgetModes, function(mode){
            if (mode != "view" && mode != "edit") {
				modePopup = modePopup || new com.ibm.mm.builder.widget.MumMenu({
					id: this.targetNode.id + "_mode",
					parentMenu:	this.pMenu
				});
                modePopup.addChild(new com.ibm.mm.builder.widget.MumMenuItem({
                    label: mode.charAt(0).toUpperCase() + mode.substring(1),
                    userMode: mode,
                    onClick: function(){ widgetMenu.showModePane(this.userMode); }
                }));
            }
		}, this);
		if(modePopup) {
			this.pMenu.addChild(new com.ibm.mm.builder.widget.MumPopupMenuItem({
				label: this.cws.I_CONTEXT_MENU_MODE, 
				popup: modePopup,
				disabled: !this.isWidgetLoaded()
			}))
		}
	},
	
	createSkinItem: function(){
		
		var widgetMenu = this;
        var skinPopup = new com.ibm.mm.builder.widget.MumMenu({
            id: this.targetNode.id + "_skin",
            parentMenu: this.pMenu
        });
        
		var iwidgetId = this.iwidgetId;
		var widgetSkin = dojo.byId(this.iwidgetId).getAttribute("skin");
        
		var lc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
       	dojo.forEach(com.ibm.mm.builder.utils.skinUtil.getAllSkins(), function(skin){
        	if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
                var skinTitle = skin.getTitle(ibmConfig["default.locale"] != dojo.locale ? 
					lc.getLocale(skin) : dojo.locale);
                var skinMenuItem = new com.ibm.mm.builder.widget.MumMenuItem({
                    label: skinTitle,
                    skinID: skin.getID(),
                    iconClass: skin.getID() == widgetSkin ? "menuIconClass" : null,
                    onClick: function(){ 
						widgetMenu.eventService.broadcastEvent("com.ibm.mashups.builder.changeSkin", {
							id: iwidgetId, skin: this.skinID });
					}
                });
				
				//for a11y
				if (widgetSkin == skin.getID() && !(dojo.isIE === 8 && builderConfig.isBidi)) {
					var dijitMenuLabelA11y = dojo.doc.createElement("span");
					dojo.addClass(dijitMenuLabelA11y,"access");
					dijitMenuLabelA11y.innerHTML = "is selected";
					skinMenuItem.containerNode.appendChild(dijitMenuLabelA11y);		
				}
				skinPopup.addChild(skinMenuItem);
            }
		}, this);
		
		this.pMenu.addChild(new com.ibm.mm.builder.widget.MumPopupMenuItem({
			label: this.cws.I_CONTEXT_MENU_SKIN, 
			popup: skinPopup,
			disabled: !this.isWidgetLoaded()
		}));		
    },
	
	createDiaplayItem: function(inNva){
		return new com.ibm.mm.builder.widget.MumMenuItem({
            label: inNva ? this.cws.I_CONTEXT_MENU_DISPLAY : this.cws.I_CONTEXT_MENU_HIDE,
			iconClass : inNva ? "contextMenuIconDisplay" : "contextMenuIconHide",
			disabled: !this.isWidgetLoaded(),
            onClick: dojo.hitch(this, function(){
                this.eventService.broadcastEvent(
					inNva ? "com.ibm.mashups.builder.displayWidget" : "com.ibm.mashups.builder.hideWidget", 
					this.iwidgetId);
            })
        })
	},
	
	createMenu: function(){
        this.pMenu = new com.ibm.mm.builder.widget.MumMenu({
            targetNodeIds: [this.targetNode],
            id: this.targetNode.id + "_menu"
        });
		
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.widgetSkin",this.iwidgetId,null,{context:this});
		
		//move to new menu, but lack of support for sub menu
		for (var i = 0; i < widgetMenus.length; ++i) {
			
			if(widgetMenus[i].isSeparator){
				if (this.needResizeMoveMenuItems){
					this.pMenu.addChild(new com.ibm.mm.builder.widget.MumMenuSeparator());				
				}else{
					if (widgetMenus[i].id != "resizeMenuSeparator") {
						this.pMenu.addChild(new com.ibm.mm.builder.widget.MumMenuSeparator());	
					}
				}
				continue;
			}
			
			if (!this.needResizeMoveMenuItems){
				if ((widgetMenus[i].id === "resize") || (widgetMenus[i].id === "move")){
					continue;
				}
			}
			var itemId = widgetMenus[i].id ? widgetMenus[i].id : "";
			switch(itemId) {
				case "supportModes":
						this.createOtherModesItem();	// Other mode support
					break;
				case "skins":
						if(!this.inNva) {
							this.createSkinItem();
						}
					break;
				case "hideOrShow":
						this.pMenu.addChild(this.createDiaplayItem(this.inNva));
					break;
				default:
						var mitem = new com.ibm.mm.builder.widget.MumMenuItem({
							label: 		widgetMenus[i].title,
							iconClass: 	widgetMenus[i].iconClass,
							disabled: 	widgetMenus[i].enabled == "disabled",
							onClick: 	widgetMenus[i].actionCallBackFunction
						});	
						this.pMenu.addChild(mitem);
					break;
			}
		}
        this.pMenu._pubMenuEvent = dojo.hitch(this, this.hideMenu);
        this.pMenu.startup();	
	},
	
	open: function(evt){
		if(this.pMenu) {
			this.pMenu.destroyRecursive();
			delete this.pMenu;
		}
		if (!this.pMenu) {
			this.createMenu();
		}
		this.pMenu._openMyself(evt);
	},
		
    showModePane: function(mode){
        mode = mode.toLowerCase();
        var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.iwidgetId);
        //mode Title, we support "help" and "print" currently
        var modeStr = this.supportedModeString[mode.toLowerCase()]; 
        var modeTitle = modeStr || mode.charAt(0).toUpperCase() + mode.substring(1);
        widgetMenu = this;
        this.otherModePane = new com.ibm.mm.builder.widget.GeneralWidgetModeDialog({
            id: this.iwidgetId + "_" + mode,
            title: dojo.string.substitute(this.cws.I_SYSTEM_MODE_TITLE, [modeTitle, widgetTitle]),
            type: mode,
			nodeWidth: "600px",
			nodeHeight: "400px",			
            needModeSwitch: true,
            belongId: this.iwidgetId,
            containerBackgroundColor: "white",
            closeCallback: function(){
                this.destroyRecursive();
            }
        })
        serviceManager.getService("eventService").fireEvent(this.iwidgetId, "onModeChanged", {
            newMode: mode,
            rootElementId: this.otherModePane.containerNode
        });
        this.otherModePane.show();
    },

	showEditPane:function(){
		// temp fix for old widget spec
		this.oldWidgetConfigId = "";
		this.oldWidgetConfigParentNode = null;
		// end temp fix
		
		var widgetSpan = dojo.byId(this.iwidgetId);
		var configNodeId = "";
		
        var items = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.mmItem, widgetSpan);
        dojo.forEach(items, function(item){
        	var str = com.ibm.mm.builder.utils.iWidgetSpecUtil.getKeyFromHref(item)
            if (str == com.ibm.mm.builder.constant.configPannelNode)
                configNodeId = "_" + this.iwidgetId + "_" + item.innerHTML.replace(/\n/g, "");
        });
		
		if (configNodeId){
			// temp fix for old widget spec
			this.oldWidgetConfigId = configNodeId;
			this.oldWidgetConfigParentNode = dojo.byId(configNodeId).parentNode;
			// end temp fix
			
			var editnode = dojo.byId(configNodeId);
			editnode.style.display = "";
			this.editorDiv.appendChild(editnode);
		}	
		var _title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.iwidgetId);
		if (!com.ibm.mm.builder.editPane) {
			com.ibm.mm.builder.editPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
				id: this.iwidgetId + "_edit",
				title: dojo.string.substitute(this.cws.I_SYSTEM_CONF_TITLE, [_title]),
				type: "config",
				nodeWidth: dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "600px" : null,
				nodeHeight: dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "400px" : null,
				needModeSwitch: true,
				modelDialog: true,
				belongId: this.iwidgetId,
				containerBackgroundColor: "white"
			});
		} else { // the edit dialog exists
			com.ibm.mm.builder.editPane.setTitle(dojo.string.substitute(this.cws.I_SYSTEM_CONF_TITLE, [_title]))
			com.ibm.mm.builder.editPane.id = this.iwidgetId + "_edit",
			com.ibm.mm.builder.editPane.belongId = this.iwidgetId;
			com.ibm.mm.builder.editPane.nodeWidth = dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "600px" : null;
			com.ibm.mm.builder.editPane.nodeHeight = dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "400px" : null;
			com.ibm.mm.builder.editPane.containerNode.innerHTML = ""
			com.ibm.mm.builder.editPane.dynaInitialized = false;
			com.ibm.mm.builder.editPane.containerNode.style.display = "";
		}
		this._fillInEditModeContent(configNodeId);
		com.ibm.mm.builder.editPane.show();
	},
	
	_fillInEditModeContent:function(configNodeId){
		if (!configNodeId) {
            serviceManager.getService("eventService").fireEvent(this.iwidgetId, "onModeChanged", {
                newMode: 'edit',
				rootElementId: com.ibm.mm.builder.editPane.containerNode
            });
        }
		// temp fix for old widget spec
		if (this.oldWidgetConfigId != ""){
			var _oldWidgetConfigId = this.oldWidgetConfigId;
			var _oldWidgetConfigParentNode = this.oldWidgetConfigParentNode;
			com.ibm.mm.builder.editPane.oldWidgetSpecHitch = function(){
				if ((_oldWidgetConfigId!="") && (_oldWidgetConfigParentNode)){
					dojo.byId(_oldWidgetConfigId).style.display = "none";
					_oldWidgetConfigParentNode.appendChild(dojo.byId(_oldWidgetConfigId));
				}
			}
		}
		// end temp fix
	},
	
	hideMenu:function(){
		dojo.unsubscribe(this.cleanDomDialogHandle);
		dojo.unsubscribe(this.editActionHandle);
		this.pMenu && this.pMenu.destroyRecursive();
		this.modePopup && this.modePopup.destroyRecursive();
		this.skinPopup && this.skinPopup.destroyRecursive();
		var editBar = dijit.byId(this.iwidgetId + com.ibm.mm.builder.constant.editbarDragHandler);
		if (editBar) editBar.hide();
		// fix for defect 11622
		var widgetSpan = dojo.byId(this.iwidgetId);
		if (widgetSpan){
			if (widgetSpan.getAttribute("visible") === "false"){
				// widget in NVA, the widget skin need to switched to view mode
				com.ibm.mm.builder.skinHelper.hideNVASkinEditMode(this.iwidgetId+"_menu", this.iwidgetId+"_icon", this.iwidgetId+"_name", this.iwidgetId+"_upper");
			}			
		}
		this.pMenu = null;
		this.modePopup = null;
		this.skinPopup = null;
	},
	
	cleanDomDialog: function(){
		this.destroyElementsFromBodyByClass("dijitDialog");
		this.destroyElementsFromBodyByClass("dijitDialogUnderlayWrapper");		
	},
	
	// only for v1.1 widgets
	closeEditDialog: function(widgetId){
		this.eventService.fireEvent(widgetId, "onModeChanged", {newMode:'view'});
	},
	
	destroyElementsFromBodyByClass:function(clzName){
		var elements = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(clzName, dojo.body());
		for (var j=0; elements && j<elements.length;j++){
			if (clzName === "dijitDialog" && elements[j].getAttribute("widgetid") === "pageSourceContainer")
				continue;	
			dojo._destroyElement(elements[j]);	
		}
	},
	
	destroy:function(){
		this.pMenu && this.pMenu.destroyRecursive();
		delete this.pMenu;
	}
});

com.ibm.mm.builder.editPane = null;

}

if(!dojo._hasResource["com.ibm.mm.builder.skinHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.skinHelper"] = true;
dojo.provide("com.ibm.mm.builder.skinHelper");




dojo.declare("com.ibm.mm.builder.skinHelper", null, {

    overWidgetHandler: null,
    outWidgetHandler: null,
	
	nva_IconHideTimer:null,
	nva_IconShowTimer:null,
    
    // create a menu
    createMenu: function(evt, targetNodeId, widgetId, inNva){
		//fix for defect 12032: if user click on the widget menu icon while one context menu is showing
		if (com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu && com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow){
			if (widgetId != com.ibm.mm.builder.widgetMenu.iwidgetId){
				//if the showing menu is from another widget
				com.ibm.mm.builder.widgetMenu.hideMenu();
			}else{
				//if the showing menu is the menu user want to open again
				return;
			}
		}
		if(com.ibm.mm.builder.widgetMenu){
			com.ibm.mm.builder.widgetMenu.destroy();
		}
		// end fix for 12032
        com.ibm.mm.builder.widgetMenu = new com.ibm.mm.builder.widget.WidgetMenu({
			iwidgetId: widgetId,
			inNva: inNva,
			targetNode: dojo.byId(targetNodeId)
		});
		com.ibm.mm.builder.widgetMenu.open(evt);
        com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
    },
    
    // launch wiring UI
    launchWiring: function(widgetId){
		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		var widgetIcon =widgetUtil.getWidgetInstanceIcon(widgetId);
		var dialogParam = {
			nodeWidth: "486px",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME,
			titleIconUrl: widgetIcon,
			leftBarWidth: "18px",
			rightBarWidth: "12px",
			displayCloseButton: true,
			hasRightBottomResizer: false
		}
		var payload = {
	    	widgetTypeId: "wireInterface",
	        eventName:  "com.ibm.mashups.builder.editWire",
	        eventPayload:  widgetId,
	        dialogParam:  dialogParam,
			hasRightBottomResizer: false,
	        requestRefresh: true
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
    },
    
    // launch wiring UI
    launchWireGraph: function(widgetId){
    	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayWireGraph", widgetId);  	
    }, 
    
    getMaxZOrder: function(layoutId){
		var maxZOrder = 50;
		// TODO: we need enabler api to query out the inner widgets in a layout widget
		//Temp fix because the loadWidgets is called twice due to the temp fix of defect 7971,make sure the iContext is not null
		// TODO: we need to find out why it's called twice
		if (eval("_" + layoutId + "_iContext")) {
			var widgetIds = eval("_" + layoutId + "_iContext.scope.getWidgets()");
			if (widgetIds && widgetIds.length > 0) {
				for (var i = 0; i < widgetIds.length; i++) {
					var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetIds[i]);
					if (skinDiv && skinDiv.style.zIndex) {
						var indexInt = parseInt(skinDiv.style.zIndex);
						if (maxZOrder < indexInt) {
							maxZOrder = indexInt;
						}
					}
				}
				// make sure the zIndex value is the biggest one.
				maxZOrder = maxZOrder + 1;
			}
		}
        return maxZOrder;
    },
    
    // Display Menu Icons in NVA skin
    displayMenuIcon: function(menuId, iconId, nameId, upperId){
        // these two timers are needed to dealing with IE7
        window.clearTimeout(this.nva_IconHideTimer);
        this.nva_IconShowTimer = window.setTimeout(function(){
            if (dijit.byId(menuId + "_menu")) {
				return;
			}
			var menu = dojo.byId(menuId);
            var icon = dojo.byId(iconId);
            menu.style.display = "";
            icon.parentNode.style.display = "none";
            
            // change skin layout
			var upper = dojo.byId(upperId);
			
			dojo.addClass(upper, "nvaUpperDivHovered");

			//for a11y
			var wiringIcon = dojo.query(".nva_widgetInteraction", menu)[0];
			wiringIcon.focus();
        }, 10)
        
    },
    
    // Hide Menu Icons in NVA skin
    hideMenuIcon: function(menuId, iconId, nameId, upperId){
        // these two timers are needed to dealing with IE7
        window.clearTimeout(this.nva_IconShowTimer);
		if (dijit.byId(menuId + "_menu")) {
			return;
		}
        this.nva_IconHideTimer = window.setTimeout(function(){
			if (dijit.byId(menuId + "_menu")) {
				return;
			}
			com.ibm.mm.builder.skinHelper.hideNVASkinEditMode(menuId, iconId, nameId, upperId);
        }, 10)
    	
    },
	
	hideNVASkinEditMode:function(menuId, iconId, nameId, upperId){
        var menu = dojo.byId(menuId);
        if (menu) menu.style.display = "none";

	    var icon = dojo.byId(iconId);
        if (icon) icon.parentNode.style.display = "";
        
        // change skin layout
        var upper = dojo.byId(upperId);
		
		if (upper) dojo.removeClass(upper, "nvaUpperDivHovered");
	},
    
    // Display edit bar
    displayEditBar: function(editBarId,resizeBarId){
        this.setEditBarOpaque(editBarId,resizeBarId);
    },
    
    // Hide edit bar
    hideEditBar: function(editBarId,resizeBarId){
    	window.clearTimeout(this["showEditTimer_" + editBarId])
        window.clearTimeout(this["hideEditTimer_" + editBarId])
       	var tid = "";
    	if (builderConfig.isBidi && dojo.isIE===6) tid = this.getWidgetIdByEditBarId(editBarId);
        this["hideEditTimer_" + editBarId] = window.setTimeout(function(){
			var resizeId = editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHandlerExt)
            var resizeBar;
            if(resizeBarId)resizeBar = dojo.byId(resizeBarId);
            else resizeBar = dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHandlerExt))
            			 || dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHeightExt))
            var editBar = dojo.byId(editBarId);
            if (editBar) {
                editBar.style.display = "none";
                if (builderConfig.isBidi && dojo.isIE) {                	
			    	dojo.removeClass(dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody),"widgetBodyEdit");
			    	var _title = dojo.byId(tid+"_title");
			    	if (_title) dojo.removeClass(dojo.byId(tid+"_title"),"widgetTitleEdit");
			    	if (dojo.hasClass(dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent),"rtlOverride_IE_paddingTop_0px")) {
			    		dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent).style.paddingTop = "0px";
			    	}			    	
                }
            }
            if(resizeBar){
            	resizeBar.style.display = "none";
            }
        }, 100);
    },
	
	// IE6 only: keep the editBar when mouse is moving on the widgetBody's margin
	keepEditBar: function(editBarId) {
		window.clearTimeout(this["hideEditTimer_" + editBarId]);
	},
    
    // Set edit bar opaque
    setEditBarOpaque: function(editBarId,resizeBarId){
    	window.clearTimeout(this["hideEditTimer_" + editBarId]);
    	if (!(builderConfig.isBidi && dojo.isIE===6)) {
	        this.showEditBarTimer = window.setTimeout(function(){
	        	var resizeBar;
	            if(resizeBarId)resizeBar = dojo.byId(resizeBarId);
	            else resizeBar = dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHandlerExt))
	            			 || dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHeightExt))
	            var editBar = dojo.byId(editBarId);
				if (editBar){
	                editBar.style.display = "";
	            }
	            if(resizeBar){
	            	resizeBar.style.display = "";
	            }
	        }, 100);
    	} else {
    		this.bidiSetEditBarOpaque(editBarId,resizeBarId);
    	}
    },
    
    getEditBarIdBySkinId: function(skinId){
        var widgetId = skinId.substring(com.ibm.mm.builder.constant.skinIdPrefix.length, skinId.length);
        return widgetId + com.ibm.mm.builder.constant.editbarDragHandler;
    },
    getColumnResizeBarIdBySkinId: function(skinId){
        var widgetId = skinId.substring(com.ibm.mm.builder.constant.skinIdPrefix.length, skinId.length);
        return widgetId + com.ibm.mm.builder.constant.resizeHeightExt;
    },
    getFreeFormResizeBarIdBySkinId: function(skinId){
        var widgetId = skinId.substring(com.ibm.mm.builder.constant.skinIdPrefix.length, skinId.length);
        return widgetId + com.ibm.mm.builder.constant.resizeHandlerExt;
    },
    getWidgetIdByEditBarId: function(editBarId){
        return editBarId.substr(0, editBarId.length - com.ibm.mm.builder.constant.editbarDragHandler.length);
    },
    getWidgetIdByNvaSkinId: function(skinId){
        skinId = skinId.replace(com.ibm.mm.builder.constant.skinIdPrefix, "");
        return skinId.replace(com.ibm.mm.builder.constant.nva_skin_upper, "");
    },
    /*
	 * Use bidiSetEditBarOpaque to fix the display in rtl IE6 when hovering
	 * over the widget and displaying the edit bar.  In the rtl IE6 browser,
	 * the parent div of the editBar gets height and makes the widget much
	 * taller than it is supposed to be.  Same thing may happen on the resizer
	 * div.
	 * 
	 * Note:  This problem exists only on the rtl IE6 browser, and in both 
	 * freestyle and column layouts.
     */
	 bidiSetEditBarOpaque: function(editBarId,resizeBarId) {
	    if (builderConfig.isBidi && dojo.isIE === 6) {
	    	var bodyTop = null;
	    	var titleTop = null;
	    	var contentPaddingTop = null;
	    	var tid = this.getWidgetIdByEditBarId(editBarId); 
	    	if (this.isColumnLayout(tid)) dojo.byId(tid + com.ibm.mm.builder.constant.editbarDragHandler).style.position = "static";
	    	var style = this.getStyle(dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody),"top");
	    	if (style != null) {	    			
    			bodyTop = style;
    	    	var adjust = this.getColumnLayoutAdjustment(tid);
    			if (adjust) bodyTop = parseInt(bodyTop)+adjust+"px";	
	    	}
	    	var _title = dojo.byId(tid+"_title");
	    	if (_title) {
	    		style = this.getStyle(_title,"top");
	    		if (style != null) titleTop = style;
	    	}
	    	contentPaddingTop = this.getStyle(dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent),"paddingTop");
		    this.showEditBarTimer = window.setTimeout(function(){
		    	var resizeBar;
		        if(resizeBarId)resizeBar = dojo.byId(resizeBarId);
		        else resizeBar = dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHandlerExt))
		        			 || dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHeightExt))
		        var editBar = dojo.byId(editBarId);
				if (editBar){
		            editBar.style.display = "";
			    	dojo.addClass(dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody),"widgetBodyEdit");
			    	var _title = dojo.byId(tid+"_title");
			    	if (_title) dojo.addClass(dojo.byId(tid+"_title"),"widgetTitleEdit");
	        		if (bodyTop != null) dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody).style.top = bodyTop;
	            	if (titleTop != null) _title.style.top = titleTop;
	            	if (contentPaddingTop != null) dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent).style.paddingTop = contentPaddingTop;
		        }
		        if(resizeBar){
		        	resizeBar.style.display = "";
		        }
		    }, 100);
	    }	
	},
	/* getStyle is used to get a position for rtl IE edit mode.
	 * Currently, the following class name patterns are supported:
	 *    rtlEditIE6_<value>,rtlEditIE7_<value>, rtlEditIE8_<value>  
	 * 
	 * In the skin.html's body or title div (any div can be passed in),
	 * a class should be added following this naming convention if the
	 * widget requires repositioning.
	 * An example is the Glass/Tinted Glass theme which uses 
	 *    rtlEditIE6_top_50px
	 *    
	*/
	getStyle: function(div,search) {
		var className = (div.className).split(" ");
		if (className) {
			for (var i=0; i<className.length; i++) {
				var str = className[i].split("_");
				if (str.length && str.length === 3) {
					if ( (str[0] == "rtlEditIE6" && dojo.isIE===6) ||
						 (str[0] == "rtlEditIE7" && dojo.isIE===7) ||
						 (str[0] == "rtlEditIE8" && dojo.isIE===8) ) {
						if (str[1] === search) {
						   return str[2];
						}
					}
				}
			}
		}
	    return null;
	},
	
	getColumnLayoutAdjustment: function(tid) {
		var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + tid);
		var adjust = 0;
		var pageAttrJson = null;
		var sibling = skinDiv.previousSibling;
		while (sibling) {
			//in columnLayout, add up the skin heights plus widthbetweenWidgets for widgets above this one			
			if (pageAttrJson == null) {
				pageAttrJson = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
			}
			adjust = adjust + parseInt(sibling.style.height)+parseInt(pageAttrJson.widthBetweenWidgets);
			sibling = sibling.previousSibling;
		}
		return adjust;
	},
	
	isColumnLayout: function(tid) {
		var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + tid);
		var isColumnLayout = false;
		var parent = skinDiv.parentNode;
		if (dojo.hasClass(parent, com.ibm.mm.builder.constant.columnLayoutClass)) {
			isColumnLayout = true; 
		}
		return isColumnLayout;
	}	
});

// global variable of Constant
com.ibm.mm.builder.skinHelper = new com.ibm.mm.builder.skinHelper();
com.ibm.mm.builder.widgetMenu = null;

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.skinUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.skinUtil"] = true;
/**
 * Util class for skin
 */
dojo.provide("com.ibm.mm.builder.utils.skinUtil");


com.ibm.mm.builder.utils.skinUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.skinUtil");

com.ibm.mm.builder.utils.skinUtil.getSkinNode = function(skinId){
	var skinModel = com.ibm.mm.builder.utils.skinUtil._getSkinModel();
	if (skinModel != null){
		return skinModel.find(skinId).start();
    }
    com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getSkinNode", com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
    return null;
}

com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId = function(){
	var curThemeId = com.ibm.mm.builder.utils.themeUtil.getCurrentThemeId();
	if (curThemeId){
	    var themeModel = com.ibm.mm.builder.utils.themeUtil.getThemeModel(true); 
	    var theme = com.ibm.mm.builder.utils.themeUtil.getThemeNode(curThemeId);
	    if (theme!=null)
	    	return theme.getDefaultSkin();
		else{
			com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getDefaultSkinId", com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
			return null;
		}		
	}
	return null;
}

com.ibm.mm.builder.utils.skinUtil.getDefaultSkin = function(){
	var defaultSkinId = com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId();
	if (defaultSkinId){
		return com.ibm.mm.builder.utils.skinUtil.getSkinNode(defaultSkinId);
	}else{
		return com.ibm.mm.builder.utils.skinUtil.getFirstSkinNode();
	}
}

com.ibm.mm.builder.utils.skinUtil.getFirstSkinNode = function(){
	var skinModel = com.ibm.mm.builder.utils.skinUtil._getSkinModel();
	if (skinModel != null){
		var iterator = skinModel.iterator(); 
        if (iterator.hasNext()) {
            var skin = iterator.next();
            var title = skin.getTitle("en");
            if ((title) && (skin.getMetaData("com.ibm.mashups.builder.skin.nva"))) {
                skin = iterator.next();
            }
            return skin;
        }
	}
	com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getFirstSkinNode",com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
	return null;
}

com.ibm.mm.builder.utils.skinUtil.getNVANode = function(){
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
	var nvaSkin = null;
	dojo.forEach(skins, function(skin){
		var title = skin.getTitle("en");
        if ((title) && (skin.getMetaData("com.ibm.mashups.builder.skin.nva"))) {
			nvaSkin = skin;
        }
    });
	if (nvaSkin){
		return nvaSkin;
	}else{
		com.ibm.mm.builder.utils.skinUtil.LOGGER.severe("getNVANode",com.ibm.mm.builder.coreWidgetsMessages.E_SKIN_THEME_NOT_EXIST_0);
		return null;		
	}
}

com.ibm.mm.builder.utils.skinUtil._getSkinModel = function(){
    var curThemeId = com.ibm.mm.builder.utils.themeUtil.getCurrentThemeId();
    var themeModel = com.ibm.mm.builder.utils.themeUtil.getThemeModel(); 
    var theme = com.ibm.mm.builder.utils.themeUtil.getThemeNode(curThemeId);
    if (theme!=null){
		if (!this.skinModel){
        	this.skinModel = themeModel.getSkinModel(theme);
        	this.skinModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(10));
		}
		return this.skinModel;
    }
    return null;
}

/**
 * create editbar for widget
 */
com.ibm.mm.builder.utils.skinUtil.getEditBarNode = function(args,layoutContext){
		/*<div id="${widgetId}_dragHandler_editbar" style="display:none" class="editBar" onmouseover="javascript:com.ibm.mm.builder.skinHelper.setEditBarOpaque('${widgetId}_dragHandler_editbar')" >
			<div id="${widgetId}_dragHandler" class="dojoDndHandle borderinHM">
				<div class="widgetDragHandlerMiddle">
					<img src="${iconUrl}"  class="widgetIconStyle">
					<span class="widgetTitleShadow" >${title}</span>
					<span class="widgetTitle" >${title}</span>
					<img src="/mum/images/interactions_icon.png" class="widgetInteraction" title="Click to wire widgets" border=0>
					<img id="${menuId}" src="/mum/images/context_menu.png" class="widgetContext" title="Click to open menu of options" onclick="javascript:com.ibm.mm.builder.skinHelper.createMenu(event,'${menuId}','${widgetId}')" border=0>	
				</div>	
				<div class="widgetDragHandlerLeft"></div>
				<div class="widgetDragHandlerRight"></div>
			</div>
			<div class="widgetDragHandlerBG"></div>
			<div class="widgetDragHandlerCorner"></div>
			<div class="editBarRightTopCornerShadow"></div>	
			<div class="editBarCornerShadow"></div>
		</div>*/
		var editBar = document.createElement("div");
		dojo.addClass(editBar,"editBar");
		editBar.id = args.widgetId + com.ibm.mm.builder.constant.editbarDragHandler;
		editBar.style.display = "none";
		dojo.connect(editBar,"onmouseover", null, function(){com.ibm.mm.builder.skinHelper.setEditBarOpaque(args.widgetId + com.ibm.mm.builder.constant.editbarDragHandler);});
		
		var widgetDragHandler = document.createElement("div");
		widgetDragHandler.id = args.widgetId + '_dragHandler';
		dojo.addClass(widgetDragHandler,"dojoDndHandle");
		dojo.addClass(widgetDragHandler,"borderinHM");
		var widgetDragHandlerMiddle = document.createElement("div");
		dojo.addClass(widgetDragHandlerMiddle,"widgetDragHandlerMiddle");
		
		var widgetIcon = document.createElement("img");
		//Fix bug 2854 [Performance Defect]Too many resources are downloaded during login.
		//comment out this line will help to reduce one http request for each widget in the page
		//widgetIcon.src= args.iconUrl;
		dojo.addClass(widgetIcon,"widgetIconStyle");
		
		var widgetTitleShadow = document.createElement("span");
		widgetTitleShadow.innerHTML= args.title;
		dojo.addClass(widgetTitleShadow,"widgetTitleShadow");
		
		var widgetTitle = document.createElement("span");
		widgetTitle.innerHTML= args.title;
		dojo.addClass(widgetTitle,"widgetTitle");
		
		if(dojo.isSafari || dojo.isIE){
			widgetTitleShadow.style.width = "75%";
			widgetTitle.style.width = "75%";
		}
		
		var wiringIcon = document.createElement("input");		 
		wiringIcon.alt = wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_WIRE_ICON_TITLE;			
		dojo.addClass(wiringIcon,"widgetInteraction");
		
		dojo.attr(wiringIcon,"type","image");
		if (builderConfig.isBidi) {
			dojo.attr(wiringIcon,"src",builderConfig.builderPath + "/images/d_wiring_icon_rtl.png");	
		}
		else {
			dojo.attr(wiringIcon,"src",builderConfig.builderPath + "/images/d_wiring_icon.png");	
		}
		dojo.connect(wiringIcon,"onclick", null,  function(){
			com.ibm.mm.builder.skinHelper.launchWiring(args.widgetId);
		});
		
		// fix dnd issue when click the icon
		dojo.connect(wiringIcon,"onmousedown",null,function(evt) {dojo.stopEvent(evt)});
		
		var menuIcon = document.createElement("input");
		menuIcon.id= args.widgetId + "_menu";				
		menuIcon.alt = menuIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_EDIT_ICON_TITLE;
		dojo.addClass(menuIcon,"widgetContext");
		dojo.attr(menuIcon,"type","image");
		if (builderConfig.isBidi) {
			dojo.attr(menuIcon,"src",builderConfig.builderPath + "/images/context_menu_rtl.png");	
		}
		else {
			dojo.attr(menuIcon,"src",builderConfig.builderPath + "/images/context_menu.png");
		}
		
		dojo.connect(menuIcon, "onclick", null, function(event){com.ibm.mm.builder.skinHelper.createMenu(event,args.widgetId+"_menu",args.widgetId,false,layoutContext)});
		// fix dnd issue when click the icon
		dojo.connect(menuIcon,"onmousedown",null, function(evt) {dojo.stopEvent(evt)});
		
		widgetDragHandlerMiddle.appendChild(widgetIcon);
		widgetDragHandlerMiddle.appendChild(widgetTitleShadow);
		widgetDragHandlerMiddle.appendChild(widgetTitle);
		widgetDragHandlerMiddle.appendChild(wiringIcon);
		widgetDragHandlerMiddle.appendChild(menuIcon);
		
		var widgetDragHandlerLeft = document.createElement("div");
		var widgetDragHandlerRight = document.createElement("div");
		
		if (builderConfig.isBidi) {
			dojo.addClass(widgetDragHandlerLeft,"widgetDragHandlerLeftRtl");
			dojo.addClass(widgetDragHandlerRight,"widgetDragHandlerRightRtl");
		}
		else {
			dojo.addClass(widgetDragHandlerLeft,"widgetDragHandlerLeft");
			dojo.addClass(widgetDragHandlerRight,"widgetDragHandlerRight");
		}
		
		widgetDragHandler.appendChild(widgetDragHandlerLeft);
		widgetDragHandler.appendChild(widgetDragHandlerRight);
		widgetDragHandler.appendChild(widgetDragHandlerMiddle);
		
		var widgetDragHandlerBG = document.createElement("div");
		dojo.addClass(widgetDragHandlerBG,"widgetDragHandlerBG");
		
		var widgetDragHandlerCorner = document.createElement("div");
		dojo.addClass(widgetDragHandlerCorner,"widgetDragHandlerCorner");
		
		var editBarRightTopCornerShadow = document.createElement("div");
		dojo.addClass(editBarRightTopCornerShadow,"editBarRightTopCornerShadow");
		
		var editBarCornerShadow = document.createElement("div");
		dojo.addClass(editBarCornerShadow,"editBarCornerShadow");
		
		editBar.appendChild(widgetDragHandler);
		editBar.appendChild(widgetDragHandlerBG);
		editBar.appendChild(widgetDragHandlerCorner);
		editBar.appendChild(editBarRightTopCornerShadow);
		editBar.appendChild(editBarCornerShadow);
		
		return editBar;
	}
	
/**
 *  parse the width,height.. from the locationStyle string
 *  @param locationStyle should be "position:absolute;width:300px;height:400px;left:20px;top:400px;z-Index:40;"
 */
com.ibm.mm.builder.utils.skinUtil.getValueFromStyle = function(key,locationStyle){
	if (locationStyle.indexOf(key)==-1){return null;}
	var pos = locationStyle.indexOf(key);
	var substr1 = locationStyle.substr(pos,locationStyle.length);
	var startPos = substr1.indexOf(":");
	var endPos = substr1.indexOf(";");
	var value = substr1.substr(startPos + 1,endPos - startPos);
	return value;
}

com.ibm.mm.builder.utils.skinUtil.setValueToStyle = function(locationStyle,key,value){
	if (locationStyle.indexOf(key)==-1){return null;}
	var pos = locationStyle.indexOf(key);
	var left = locationStyle.substr(0,pos + key.length + 1);
	var draftRight = locationStyle.substr(pos + key.length + 1,locationStyle.length);
	var right = draftRight.substr(draftRight.indexOf(";"),draftRight.length);
	var newStyle = left + value + right;
	return newStyle;
}

com.ibm.mm.builder.utils.skinUtil.updateDefaultSize = function(widgetId){
	var updateWidgetSize = function(){
		var wrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
		var defaultHeight = wrapper.getIDescriptorItems().getItemValue("defaultHeight");
		var defaultWidth = wrapper.getIDescriptorItems().getItemValue("defaultWidth");
		var payload = null;
		if (defaultHeight || defaultWidth) {
			payload = new Object();
			payload.widgetId = widgetId;
			if(defaultHeight) payload.height = defaultHeight;
			if(defaultWidth) payload.width = defaultWidth;
		}
		if (payload){
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget",payload);				
		}			
	}
	var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
	if (wm && wm.loaded) {
		updateWidgetSize();
	} else {
		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetId, null, updateWidgetSize);
	}
}
	
/**
 *  set mouseout handler of widget for hiding editbar
 */	
com.ibm.mm.builder.utils.skinUtil._widgetOnMouseOut = function(iwidgetId){
	dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix+iwidgetId).onmouseout=function(){com.ibm.mm.builder.skinHelper.hideEditBar(iwidgetId+com.ibm.mm.builder.constant.editbarDragHandler);};
	com.ibm.mm.builder.skinHelper.hideEditBar(iwidgetId+com.ibm.mm.builder.constant.editbarDragHandler);
}
/**
 * update the title and/or icon of the widget instance
 * @param {String} widgetInstanceId
 */
com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon = function(widgetInstanceId){
	var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
	var _title = widgetUtil.getWidgetInstanceTitle(widgetInstanceId);
	var title = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(_title);
	var icon = widgetUtil.getWidgetInstanceIcon(widgetInstanceId);
	try{
        dojo.attr(dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix+widgetInstanceId),"aria-label",_title);
    }catch(error){
		// skins resources are loaded with widget resources w/ multipart
        if (com.ibm.mashups.enabler.io.XHRMultipartFactory.isMultipartEnabled()) {
            return;
        }
        throw error;
    }
	// if visible == false, the widget instance is in NVA
	// if visible == true, the widget instance is in VA
	var visible = dojo.byId(widgetInstanceId).getAttribute("visible");
	if (visible == "false") {
		var iconDiv = dojo.byId(widgetInstanceId + "_icon");
		if (iconDiv) {
			iconDiv.src = icon;
			iconDiv.alt="";
		}
		// concat the display title if it is too long
		var titleNode = dojo.byId(widgetInstanceId + "_name_middle");
		titleNode.innerHTML = _title;
		titleNode.title = _title;
		
		//for a11y
		if (iconDiv) {
			iconDiv.alt = titleNode.textContent;
		}

		dojo.attr(titleNode,"widthLimit","210");
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(titleNode,null,{fontSize:"1.2em",fontWeight:"bold"});
	} else {
		//update title and icon in skin
		var titleContent = document.getElementById(widgetInstanceId + "_title_content");
		var iconContent = document.getElementById(widgetInstanceId + "_icon");
		if (titleContent) titleContent.innerHTML = title;
		if (iconContent) {
			iconContent.src = icon;
			iconContent.alt = "";
		}
		//update icon and title in edit bar
		var editbar = dojo.byId(widgetInstanceId + "_dragHandler");
		if(editbar) {
			var titleSpan = dojo.query(".widgetTitle", editbar)[0];
			var styleWidth = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(editbar.parentNode.parentNode,"width");
			var width = parseInt(parseInt(styleWidth.replace(/px/,""))*0.55-120);
			if(titleSpan) {
				dojo.attr(titleSpan,"widthLimit",width);
				titleSpan.innerHTML = _title;
				titleSpan.title = _title;
				com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(titleSpan);
			}
			var titleShadowSpan = dojo.query(".widgetTitleShadow", editbar)[0];		
			if(titleShadowSpan) {
				dojo.attr(titleShadowSpan,"widthLimit",width);
				titleShadowSpan.innerHTML = _title;
				titleShadowSpan.title = _title;
				com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(titleShadowSpan);
			}
			var iconImag = dojo.query(".widgetIconStyle", editbar)[0];
			if(iconImag){ 
				iconImag.src = icon;
				iconImag.alt = "";
			}
		}
	}
}

com.ibm.mm.builder.utils.skinUtil.skinMinSize = {
	"Default":76
};

com.ibm.mm.builder.utils.skinUtil.getMinSize = function(skin){
	if(typeof com.ibm.mm.builder.utils.skinUtil.skinMinSize[skin]!='undefined')
		return com.ibm.mm.builder.utils.skinUtil.skinMinSize[skin];
	else
		return com.ibm.mm.builder.utils.skinUtil.skinMinSize["Default"];
}

/*
 * get the skinNode's location information
 */
com.ibm.mm.builder.utils.skinUtil.getLocationValue = function(key, widgetId){
	var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	return dojo.style(widgetSkinNode,key);
}

com.ibm.mm.builder.utils.skinUtil.setLocationValue = function(key,value,widgetId){
	var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	dojo.style(widgetSkinNode,{key:value});
}

com.ibm.mm.builder.utils.skinUtil.markIWidgetInstanceAsDraggable = function(wdigetInstanceId){
	var skinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + wdigetInstanceId);
	skinNode.setAttribute("dndtype", "iWidgetInstance");
	skinNode.setAttribute("dnddata", wdigetInstanceId);
	dojo.addClass(skinNode,"dojoDndItem")
}

com.ibm.mm.builder.utils.skinUtil.skins = null;

com.ibm.mm.builder.utils.skinUtil.getAllSkins = function(){
	if(com.ibm.mm.builder.utils.skinUtil.skins &&
           (0 < com.ibm.mm.builder.utils.skinUtil.skins.length)){
		return com.ibm.mm.builder.utils.skinUtil.skins;   	
	}
	com.ibm.mm.builder.utils.skinUtil.skins = [];
	var skinModel = com.ibm.mm.builder.utils.skinUtil._getSkinModel();
    if (skinModel != null) {
        var iterator = skinModel.iterator();
        while (iterator.hasNext()) {
            com.ibm.mm.builder.utils.skinUtil.skins.push(iterator.next());
        }
    }
	return com.ibm.mm.builder.utils.skinUtil.skins;
}

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.embedUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.embedUtil"] = true;
/**
 * This class serves as a utility class to support embedding widget or mashup page 
 * to an external web page
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.embedUtil");


com.ibm.mm.builder.utils.embedUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.embedUtil");

/**
 * This method is for preview of open search result, like dataviewer, or feed reader widget
 * It accepts the widget parameter json object. Those parameter will be applied into the widget instance which will be shown in the preview UI.
 * @param {String} widgetUrl: url of widget definition xml file
 * @param {JSON} params: widget parameter
 * @param {Object} callback: call back function when the widget is created, should pass in the function which will lauch the preview dialog
 */
com.ibm.mm.builder.utils.embedUtil.launchFeedPreview = function(widgetUrl,params,callback){
	// First, create a widget instance
	var newWidgetId = com.ibm.mm.builder.utils.embedUtil.createDummyWidgetMarkup(widgetUrl);
	
	// Second, call live text to parse dom
	var widgetPlaceHolder = dojo.byId("Embedding_Widget_TmpDiv");
	var widgetMD = com.ibm.mm.builder.utils.embedUtil.createDummyMD(widgetUrl);
	
	com.ibm.mm.builder.utils.iwidgetUtil.loadWidgets(widgetPlaceHolder, function(){
		// Add open search code to lauch preview dlg
		var widgetInstance = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(newWidgetId).getIWidgetInstance();
        if (widgetInstance == null) {
            com.ibm.mm.builder.utils.embedUtil.LOGGER.severe("launchFeedPreview",dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_NOWIDGET_ERROR_1,[newWidgetId]));
			return;
        }
        var instanceAttributes = widgetInstance.getAttributes();
		for (var paraName in params){
			if (params[paraName]){
				instanceAttributes.setItemValue(paraName,params[paraName],false);	
			} 			
		}	
		var genScript = com.ibm.mm.builder.utils.embedUtil.generateURL(widgetUrl,null,400,600,true,instanceAttributes);
		callback(genScript);
	});
	
	// Third, update title and icon if necessary
	com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitleAndIcon(newWidgetId,widgetMD.widgetname, widgetMD.widgetIconSrc);
}

/**
 * Create a dummy widget instance markup
 * @param {String} widgetUrl
 * @return {String} the created widget instance id
 */
com.ibm.mm.builder.utils.embedUtil.createDummyWidgetMarkup = function(widgetUrl){
	var newWidgetId = com.ibm.mm.builder.utils.iwidgetUtil._getUid();
	var widgetMD = com.ibm.mm.builder.utils.embedUtil.createDummyMD(widgetUrl);
	var widgetcreator = new com.ibm.mm.builder.widgetCreator(newWidgetId, widgetMD);
	var widgetSpan = widgetcreator.getWidget();
	widgetSpan.removeAttribute("skin");
	var widgetStr = com.ibm.mm.builder.utils.htmlUtil.getElementString(widgetSpan);
	var widgetPlaceHolder = dojo.byId("Embedding_Widget_TmpDiv");
	if (widgetPlaceHolder){
		widgetPlaceHolder.innerHTML = ""; 
	}else{
		widgetPlaceHolder = document.createElement("div");
		widgetPlaceHolder.id = "Embedding_Widget_TmpDiv";
		dojo.body().appendChild(widgetPlaceHolder);
		//widgetPlaceHolder.style.visibility = "hidden";
		widgetPlaceHolder.style.display = "none";
	}
	widgetPlaceHolder.innerHTML = widgetStr;
	return newWidgetId;
}

/**
 * create a dummy widget meta data object, in order to call widget creator to create widget instance
 * @param {String} widgetUrl
 * @return {Object} widget meta data object
 */
com.ibm.mm.builder.utils.embedUtil.createDummyMD = function(widgetUrl){
	var widgetMD = {};
	widgetMD.id = "";
	widgetMD.widgetname = "";
	widgetMD.widgetDefXML = widgetUrl;
	widgetMD.widgetIconSrc = "";
	widgetMD.widgetParam = null;
	widgetMD.onNewWire = null;
	widgetMD.systemWidget = false;
	return widgetMD;
}

/**
 * Create a widget instance markup
 * @param {String} widgetDefId
 * @return {String} the created widget instance id
 */
com.ibm.mm.builder.utils.embedUtil.createEmbeddingWidgetMarkup = function(widgetDefId){
	var newWidgetId = com.ibm.mm.builder.utils.iwidgetUtil._getUid();
	var widgetMD = com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition(widgetDefId);
	var widgetcreator = new com.ibm.mm.builder.widgetCreator(newWidgetId, widgetMD);
	var widgetSpan = widgetcreator.getWidget();
	// for embedding widget, no skin is needed
	widgetSpan.removeAttribute("skin");
	var widgetPlaceHolder = dojo.byId("Embedding_Widget_TmpDiv");
	if (widgetPlaceHolder){
		widgetPlaceHolder.innerHTML = ""; 
	}else{
		widgetPlaceHolder = document.createElement("div");
		widgetPlaceHolder.id = "Embedding_Widget_TmpDiv";
		//widgetPlaceHolder.style.visibility = "hidden";
		widgetPlaceHolder.style.display = "none";
		dojo.body().appendChild(widgetPlaceHolder);
	}
	widgetPlaceHolder.appendChild(widgetSpan);
	return newWidgetId;
}

/**
 * Destroy embeded widget instance
 * @param {String} widgetId
 */
com.ibm.mm.builder.utils.embedUtil.destroyEmbeddedWidget = function(widgetId){
	var widgetPlaceHolder = dojo.byId("Embedding_Widget_TmpDiv");
	if (widgetPlaceHolder){
		widgetPlaceHolder.innerHTML = ""; 
	}
	var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
	eventService.publishEvent(com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS,widgetId);
}

com.ibm.mm.builder.utils.embedUtil.createRadioButton = function(radioName,radioValue,radioOnclick,selected,title,id){
	
	var radioString = "<input type='radio' name='";
	radioString += radioName+ "' value='";
	radioString += radioValue+ "' title='";
	radioString += title+ "' id='";
	radioString += id+ "' aria-label='";
	radioString += title+ "'";
	
	
	if(radioOnclick) {
		radioString += "onclick='"+radioOnclick+"' onkeypress='(function(e,self) { if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {self.onclick(e);} })(event,this);'";
	}
	if (selected){
		radioString += " checked>";
	}else{
		radioString += ">";
	}
	return radioString;
}

com.ibm.mm.builder.utils.embedUtil.getHeight = function(nodeId) {
		var height = dojo.byId(nodeId+"_height").value + "px";
		return height;
	}	
	
com.ibm.mm.builder.utils.embedUtil.getWidth = function(nodeId) {
		var width ="auto";
		if(dojo.query("[name="+nodeId+"_emdPgWidth]")[0].checked){
			width = dojo.byId(nodeId+"_width").value + "px";
		}
		return width;
	}

com.ibm.mm.builder.utils.embedUtil.createClearDiv = function(){
	var adiv = document.createElement("div");
	adiv.style.clear = "both";
	return adiv;
}

com.ibm.mm.builder.utils.embedUtil.createCheckPreview = function(uid,checked){
		var placeHolder = com.ibm.mm.builder.utils.htmlUtil.createElementWithClass("div","embedPreviewTxt","");
		placeHolder.id = uid + "_previewDiv";
		
		var placeHolderLeft = com.ibm.mm.builder.utils.htmlUtil.createElementWithClass("span","embedPreviewTxtLeft","");
		var ckBox = com.ibm.mm.builder.utils.htmlUtil.createElementWithClass("input","","");
		ckBox.id = uid + "_checkBox";
		ckBox.setAttribute("type","checkbox");
		ckBox.title = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PREVIEW_BYDEFAULT;
		setTimeout(function(){
			ckBox.checked = checked;
		},0)
		var txtSpan = document.createElement("label");
		txtSpan.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PREVIEW_BYDEFAULT;
		txtSpan.setAttribute("for",ckBox.id);
		dojo.attr(txtSpan,"widthLimit","320");
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(txtSpan);
		
		placeHolderLeft.appendChild(ckBox);
		placeHolderLeft.appendChild(txtSpan);
		
		var placeHolderRight = com.ibm.mm.builder.utils.htmlUtil.createElementWithClass("span","embedPreviewTxtRight","");
		var closeLink = com.ibm.mm.builder.utils.htmlUtil.createElementWithClass("a","embedPgPreviewLink",com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PREVIEW_CLOSE);
		closeLink.id = uid + "_closeLink";	
		closeLink.href = 'javascript:void(0)';
		closeLink.title = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PREVIEW_CLOSE;
		dojo.attr(closeLink,"widthLimit","160");
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(closeLink);
		placeHolderRight.appendChild(closeLink);
		
		placeHolder.appendChild(placeHolderLeft);
		placeHolder.appendChild(placeHolderRight);	
		return placeHolder;
	}

// validate the 	
com.ibm.mm.builder.utils.embedUtil.validateInput = function(prefixId,parent){
	// validate width
	if(dojo.query("[name="+prefixId+"_emdPgWidth]")[0].checked){
		var widthInput = dojo.byId(prefixId+"_width");
		if (widthInput){
			if (!dojox.validate.isInRange(widthInput.value,{min: 50, max: 2000})){
				alert(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR1_0);
				return false;
			}
			if ((parseInt(widthInput.value)+"")!=widthInput.value){
				alert(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR2_0);
				return false;				
			}
		}
	}
	
	// validate height
	var heightInput = dojo.byId(prefixId+"_height");
	if (heightInput){	
		if (!dojox.validate.isInRange(heightInput.value,{min: 50, max: 2000})){
			alert(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR1_0);
			return false;
		}
		if ((parseInt(heightInput.value)+"")!=heightInput.value){
			alert(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_WIDTHHEIGHT_INPUTERROR2_0);
			return false;				
		}		
	}
	
	return true;	
}

/**
 * This method is used to call embedding generator to get the url for embedding page or embedding widget
 * @param {String} widgetXml
 * @param {String} pid
 * @param {String} width
 * @param {String} height
 * @param {Boolean} haveScroll
 * @param {JSON} itemSet
 */
com.ibm.mm.builder.utils.embedUtil.generateURL = function(widgetXml,pid,width,height,haveScroll,itemSet,sandboxed){
	var embeddingGenerator = new com.ibm.mashups.enabler.EmbeddingGenerator(widgetXml,pid);
	embeddingGenerator.setPreferences(itemSet);
	embeddingGenerator.setWidth(width);
	embeddingGenerator.setHeight(height);
	embeddingGenerator.setScrollbar(haveScroll);
 
    if (typeof sandboxed != "undefined") {
        if (sandboxed) {
            embeddingGenerator.setSandboxed(sandboxed);
        }
    }
    
	if (typeof itemSet != "undefined"){
		if (itemSet){
			embeddingGenerator.setPreferences(itemSet);
		}
	}	
	return embeddingGenerator;
}

com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog = function(id, type, widgetType){	
	var widgetTypeId;
	var eventName;
	var dialogParam = {
		containerBackgroundColor: "white",
		nodeWidth:dojo.isIE?"550px":'545px',
		initLeftPosition: "100px",
		initTopPosition: "100px",
		displayCloseButton: true	
	};
	
	if(type == "page")
	{
		widgetTypeId = "embedPage";
		eventName = "com.ibm.mashups.builder.embedPage";
		
		var pageTitle = com.ibm.mm.builder.utils.pageUtil.getPageTitle(id);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PAGE_TITLE, [pageTitle]);
		
		dialogParam.id = id + "_embeddingPage";
		dialogParam.title = title;
	}
	else
	{
		widgetTypeId = "embedWidget";
		eventName = "com.ibm.mashups.builder.embedWidget";
		
		dialogParam.id = "mainEmbeddingDialog";
		dialogParam.title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_WIDGET_HEADERTEXT, [widgetType]);
	}
	
	var payload = {
    	widgetTypeId: widgetTypeId,
        eventName: eventName,
        eventPayload:  id,
		requestRefresh: true,
        dialogParam:  dialogParam
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
}

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.themeUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.themeUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.themeUtil");

com.ibm.mm.builder.utils.themeUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.themeUtil");
/**
 * return theme model
 * @param {Object} theme
 */
com.ibm.mm.builder.utils.themeUtil.getThemeModel = function(refresh){
	if(refresh || !this.themeModel){
		this.themeModel = com.ibm.mashups.enabler.model.Factory.getThemeModel();
		this.themeModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(25));
	}
	return this.themeModel;
}

com.ibm.mm.builder.utils.themeUtil.getThemeNode = function(themeId){
	var themeNode = this.getThemeModel().find(themeId).start();
	if(themeNode) return themeNode;
	
	try{
		// when the theme is invalid, set the page theme as default theme and commit.
		var defaultThemeId = this.getDefaultThemeId();
		var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
		var pageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
		var page = navigationModel.find(pageId).start();
		page.setTheme(defaultThemeId);
		navigationModel.commit().start();
	}catch(ex){
		com.ibm.mm.builder.utils.themeUtil.LOGGER.severe("getThemeNode", "Fail to set default theme to current page!")		
	}
	return  this.getDefaultThemeNode();
}

com.ibm.mm.builder.utils.themeUtil.getDefaultThemeNode = function(){
	var themeModel = this.getThemeModel();
	return themeModel.find(this.getDefaultThemeId()).start();
}

com.ibm.mm.builder.utils.themeUtil.getDefaultThemeId = function(spaceId){
	// if space root node has set theme, return space' theme
	// add the spaceId check to fix bug 9121
	if (spaceId) {
		var themeId = com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNode(spaceId).getTheme();
		if(themeId && themeId != "null") return themeId;
	}
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	return cs.getValue(cs.CLIENT_DEFAULT_THEME_ID);
}

com.ibm.mm.builder.utils.themeUtil.getCurrentSpaceThemeId = function(){
	var spaceId = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
	var themeId = com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNode(spaceId).getTheme();
	if (themeId && themeId != "null") { return themeId; }
}


/**
 * return theme title
 * @param {Object} theme
 */
com.ibm.mm.builder.utils.themeUtil.getThemeTitle = function(theme, locale){
	if (!theme) {
		return null;
	}
	return com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(theme, locale);
}

/**
 * Load the given page's theme
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.themeUtil.loadTheme = function(pageId){
	
	var page = com.ibm.mm.builder.utils.pageUtil.getDefaultPage(pageId);
	if(!page){ //cannot find the any possible page
		this.loadDefaultTheme();
		return;
	}
	var currentThemeId = this.getCurrentThemeId();
	if(!currentThemeId){ // first time to load theme
		this._load(this.getThemeId(pageId));
	}
}

com.ibm.mm.builder.utils.themeUtil.loadDefaultTheme = function(){
	var dt = this.getCurrentSpaceThemeId();
	var ct = this.getCurrentThemeId();
	if (!ct || ct != dt) {
		this._load(dt);
	}
}

com.ibm.mm.builder.utils.themeUtil.getCurrentThemeId = function(){
	var themeId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().getID();
	return themeId === "null" ? null : themeId;
}

com.ibm.mm.builder.utils.themeUtil.getThemeId = function(page){
	var pu = com.ibm.mm.builder.utils.pageUtil;
	var pageNode = null;
	if (page) {
		if (dojo.isString(page)) {
			pageNode = pu.getPageNode(page)
		}
		else {
			pageNode = page;
		}
	}
	else {
		pageNode = pu.getCurrentPageNode();
	}
	if (!pageNode) { return null};
	var themeId = pageNode.getTheme();
	if (!themeId || themeId === "null") { return this.getDefaultThemeId(); }
	return themeId;
}

com.ibm.mm.builder.utils.themeUtil.getCurrentThemeNode = function(){
	return this.getThemeNode(this.getCurrentThemeId());
}

com.ibm.mm.builder.utils.themeUtil._load = function(themeId){
	if (!themeId || themeId === "null") {
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		themeId = cs.getValue(cs.CLIENT_DEFAULT_THEME_ID);
	}
	var tm = this.getThemeNode(themeId);
	if(!tm){
		alert(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_MAIN_LOAD_THEME_MODEL_FAIL_0,[themeId || "null"]));
	}
	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().setID(themeId);
	
	//set body id to enable theme developer to customize the widget style
	document.body.id = themeId;
	
    var htmlUrl = this.getThemeModel().findResourceUrl(tm, "theme.html");
    var cssUrl = this.getThemeModel().findResourceUrl(tm, "theme.css");
    com.ibm.mm.builder.utils.htmlUtil.loadCss(cssUrl);
    if (builderConfig.isBidi) {
        var cssRtlUrl = this.getThemeModel().findResourceUrl(tm, "theme_rtl.css");
        com.ibm.mm.builder.utils.htmlUtil.loadCss(cssRtlUrl);
    }
    var bindArgs = {
        url: htmlUrl,
		handle: function(data, ioArgs){
//			//keep previous children in body
//			var previousChildren = [];
//			dojo.forEach(dojo.body().childNodes, function(item){previousChildren.push(item)});
//			document.body.innerHTML = data;
//			dojo.forEach(previousChildren, "dojo.body().appendChild(item)");
			if(data instanceof Error){
				//dojo.body().innerHTML = ioArgs.xhr.responseText;
				return;
			}
			document.body.innerHTML = data
			
			var i = 1;
//			//handle js if there is
			dojo.forEach(document.body.getElementsByTagName("script"), function(script){
				//TODO replace enabler internal api with public api.
				try{
				var id = script.getAttribute( "id" );
				if (id === null || id == "" ) {
						script.setAttribute( "id", "_scr#" + i );
						i++;
				}
				com.ibm.mm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER.handle(script);
				}catch(e){
					console.log("Exception evaluate js:"+e.message); //todo, since we're already frozen on tvt.
				}
				
			});
			
			//parse iwidgets in the theme
			var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
            mpHandler.startTransaction();
			com.ibm.mm.builder.utils.iwidgetUtil.loadWidgets(null, function(){
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchPage");
			});
			mpHandler.endTransaction(true);
			
			//add theme particular style to body
			var bodyClasses = com.ibm.mm.builder.utils.themeUtil.getCurrentThemeNode().
				getMetadata("com.ibm.mashups.theme.body.class");
			dojo.forEach(bodyClasses.split(" "), function(className){
				dojo.addClass(dojo.body(), className);
			})
			
			//add the dbcs classes
			if(ibmConfig.fontSizeEnlarged){
				dojo.addClass(dojo.body(), com.ibm.mm.builder.constant.dbcsEnlarged);
			}
		},
		error: function(err, ioArgs){
			//if the theme is wrong, load default theme instead.
//			var u = com.ibm.mm.builder.utils;
//			if (u.pageUtil.getCurrentPageId()) {
//				u.pageUtil.updatePage(u.pageUtil.getCurrentPageId(), {
//					theme: u.themeUtil.getDefaultThemeId()
//				});
//			}
			setTimeout(function(){
				com.ibm.mm.builder.utils.themeUtil.loadDefaultTheme();
			}, 0);
		}
	}
	dojo.xhrGet(bindArgs);
}

com.ibm.mm.builder.utils.themeUtil.unloadAllWidgets = function(needReload){
	var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
    var layouts = themeModel.getLayouts();
	var widgetIds = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts)
	
	dojo.forEach(widgetIds, function(widgetId){
		com.ibm.mm.builder.commonActions.removeWidget(widgetId);
	});
	// needReload indicate whether the unload widgets action require a new load widgets action followed.
	// if we publish this event to enabler, pass in the widget id array, enabler will notify builder to do load widgets action.
	if (needReload){
		serviceManager.getService("eventService").publishEvent(
			com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS, widgetIds);		
	}
}

mmBuilder_layoutWidgetsPool = new Array();
com.ibm.mm.builder.utils.themeUtil.unloadWidgetsInLayout = function(layoutId){
	mmBuilder_layoutWidgetsPool.push(layoutId);
	var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
    var layouts = themeModel.getLayouts();
	if (layouts) {
		if (mmBuilder_layoutWidgetsPool.length == layouts.length){
			for(var i = 0; i < layouts.length; i++) {
				mmBuilder_layoutWidgetsPool.pop(layouts[i]);
		    }
		}
		if (mmBuilder_layoutWidgetsPool.length == 0){
			mmBuilder_layoutWidgetsPool = new Array();
			com.ibm.mm.builder.utils.themeUtil.unloadAllWidgets(true);
		}
	}
}


}

if(!dojo._hasResource["com.ibm.mm.builder.utils.toolboxUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.toolboxUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.toolboxUtil");
/**
 * find widget definition metadata in categories;
 * it will be replaced when enabler provide handy API.
 * 
 * //TODO have to cache the metadata for dnd, it is too late to create avatar until retrieving data from server by enabler
 * @param {String} widgetDefId
 */
com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition = function(widgetDefId){
	this.entries = this.entries || {};
	var entry = this.entries[widgetDefId];
	if(entry){
		return entry;
	}
	var categoryModel = this.getCatalogModel();
	
	var rootNode = categoryModel.getRoot().start()
    var catIterator = categoryModel.getChildren(rootNode);

    while (catIterator.hasNext()) {
		var entryModel = categoryModel.getCatalogEntryModel(catIterator.next());
		var wdmd = entryModel.find(widgetDefId).start();
		if (wdmd) {
			this.setWidgetDefinition(wdmd);
			return wdmd;
		}
	}
};

com.ibm.mm.builder.utils.toolboxUtil.setWidgetDefinition = function(model){	
	this.entries = this.entries || {};
	this.entries[model.getID()] = model;
};

/**
 * 
 * @param {boolean} reload, if true, empty the cached model.
 */
com.ibm.mm.builder.utils.toolboxUtil.getCatalogModel = function(reload){
	if(reload || !this._catModel){
		var enabler = com.ibm.mashups.enabler;
		var _catModel = enabler.model.Factory.getCatalogCategoryModel();
		_catModel.setStrategy(new enabler.strategy.ListLoadAheadStrategy(30));
		this._catModel = _catModel;
		this.catalogEntrys = null;
		this.entries = null;
	}
	return this._catModel;
};

com.ibm.mm.builder.utils.toolboxUtil.getDescription = function(catagory, id){
    var _catModel = this.getCatalogModel();
    var _entryModel = _catModel.getCatalogEntryModel(catagory);
    var node = _entryModel.find(id).start();
	var desc = com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(node);
	return com.ibm.mm.builder.utils.htmlUtil.escapeString(desc);
};

com.ibm.mm.builder.utils.toolboxUtil.getCategories = function(sync){
	if (this.catalogEntrys) {
		return this.catalogEntrys;
	}
	this.catalogEntrys = [];
	var cm = this.getCatalogModel();
	var rootNode = cm.getRoot().start(sync);
	var iter = cm.getChildren(rootNode);
	while (iter.hasNext()) {
		this.catalogEntrys.push(iter.next());
	}
	return this.catalogEntrys;
};

com.ibm.mm.builder.utils.toolboxUtil.clearTooltipsTimer = function(/*Array*/tips){
	for(var i=0,l=tips.length;i<l;i++){clearTimeout(tips.shift());}
};

com.ibm.mm.builder.utils.toolboxUtil.clearTooltips = function(){
	dojo.forEach(dojo.query(".dijitTooltip"), function(t){t.style.display = "none";});
}

com.ibm.mm.builder.utils.toolboxUtil.preloadWidgetEntries = function(){
	var _catModel = this.getCatalogModel();
	var categories = this.getCategories(true);
    var mpHandler = com.ibm.mashups.enabler.io.XHRMultipartFactory.create();
    mpHandler.startTransaction();
	dojo.forEach(categories, function(catagory){
		var _categoryModel = _catModel.getCatalogEntryModel(catagory);
		var elemIterator = _categoryModel.iterator();
		elemIterator.start(false);
	})
	mpHandler.endTransaction();
} 

}

if(!dojo._hasResource["com.ibm.mm.builder.utils.PageWidthChanger"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.PageWidthChanger"] = true;
dojo.provide("com.ibm.mm.builder.utils.PageWidthChanger");

dojo.declare("com.ibm.mm.builder.utils.PageWidthChanger", null, {

	constructor : function() {
		this._changer = new com.ibm.mm.builder.utils.PageWidthChanger.Changer();
		this._pageWidthMode = {};
		if (dojo.isIE == 6) {
			this._resizeFn = dojo.hitch(this, this._resizeHandler);
			window.attachEvent("onresize", this._resizeFn);
		}
	},	
	
	setWidthRangeProvider : function(provider) {
		this._wrp = provider;
	},
	
	setWidgetListProvider : function(provider) {
	    this._wlp = provider;
	},
	
	setPageWidthModeProvider : function(provider) {
		this._pwmp = provider;
	},
	
	init : function() {
		this._pageWidthMode = this.getPageWidthMode();
	},
	
	addPageWidthModeChangedListener : function(listener) {
		this._pwmcListener = listener;
	},
	
	getPageWidthRange : function() {
		return {
			min : this._wrp.getMinimum(),
			max : this._wrp.getMaximum()
		};
	},
	
	_getBodyWidthToFitViewport : function() {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		return d.width - delta - 23;
	},
	
	changeWidthToFitViewport : function(minWidth) {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		/*var fluidWidth = d.width - delta - 60;
		dojo.style(dojo.query("html")[0], {
			"width" : (d.width - delta) + "px"
		});
		this._changer.setWidth(fluidWidth);*/
		this.useFluidLayout(minWidth);
		//this._changer.setOverflow();
	},
	
	useFluidLayout : function(minWidth) {
		this._changer.restoreToFluidLayout();
		if (minWidth) {
			var min = Math.max(parseInt(minWidth), this._wrp.getMinimum());
			this.setMinimumWidth(min);
		}
	},
	
	_getViewportDimension : function() {
	  var w = window.innerWidth || (document.documentElement && document.documentElement.clientWidth) || document.getElementsByTagName('body')[0].clientWidth;
	  var h = window.innerHeight || (document.documentElement && document.documentElement.clientHeight) || document.getElementsByTagName('body')[0].clientHeight;
	  return {width : w, height : h};
	},
	
	changeWidth : function(width) {
	    var minWidth = this._pageWidthMode.mode == "dynamic" ? this._getBodyWidthToFitViewport() : 0;
		var viewportWidth = this._getBodyWidthToFitViewport();
		//var min = Math.max(this._wrp.getMinimum(), minWidth), max = this._wrp.getMaximum();
		var min = Math.min(this._wrp.getMinimum(), this._wrp.getMaximum()) , max = this._wrp.getMaximum();
		width = Math.min(Math.max(width, min), max);
		if (this._pageWidthMode.mode == "dynamic") {
			width = width < viewportWidth ? "auto" : width;
		}
		this._changer.changeTo(width, min, max);
	},
	
	changeWidthDelta : function(delta) {
	    var oldX = this._changer.getWidth();
		this.changeWidth(oldX + delta);
	},
	
	setMinimumWidth : function(width) {
		this._changer.setMinimum(width);
	},

	
	_normalizeWidgetId : function(widgetId) {
	   return  widgetId.indexOf(com.ibm.mm.builder.constant.skinIdPrefix) === 0 ? widgetId : com.ibm.mm.builder.constant.skinIdPrefix + widgetId;
	},
	
	_getMinimumWidthForWidgets : function(widgetIds) {
	  widgetIds = widgetIds || this._wlp.getWidgetIds() || [];
	  var rightPos = dojo.map(widgetIds, function(widgetId) {
	   var box = dojo.marginBox(dojo.byId(this._normalizeWidgetId(widgetId)));
			return box.l + box.w;
	  }, this);
	  var min = 0;
	  dojo.forEach(rightPos, function(value) {
		  min = Math.max(min, value);
	  });
	  return min;
	},
	
	_getWidgetMarginBox : function(widgetId) {
	    widgetId = this._normalizeWidgetId(widgetId);
	    return dojo.marginBox(dojo.byId(widgetId));
	},
	
	_isWidthInViewport : function(width) {
		var d = this._getViewportDimension();
		var delta = dojo.marginBox(dojo.body()).w - dojo.contentBox(dojo.body()).w;
		var fluidWidth = d.width - delta - 60;
		return width < fluidWidth;
	},
	
	getPageWidthMode : function() {
	    return (this._pwmp && this._pwmp.getPageWidthMode && this._pwmp.getPageWidthMode()) || {};
	},
	
	setPageWidthMode : function(pageWidthMode) {
		if (pageWidthMode.mode !== this._pageWidthMode.mode || 
			parseInt(pageWidthMode.width) !== parseInt(this._pageWidthMode.width)) {
			this._pageWidthMode = pageWidthMode;
			
			var payload = {
				"type" : "change",
				"summary" : {
				   "old" : dojo.clone(this._pageWidthMode),
				   "new" : dojo.clone(pageWidthMode)
				}
			};
			if (this._pwmcListener) {
				if (dojo.isFunction(this._pwmcListener)) {
				   this._pwmcListener(payload);
				}
				else if (dojo.isObject(this._pwmcListener)) {
					this._pwmcListener.fn.apply(this._pwmcListener.scope || dojo.global, [payload]);
				}
			}
		}
	},
	
	hasReactionToWidget : function() {
	   return this._pageWidthMode.mode == "dynamic";
	},
	
	_needsToAdjustWidth : function() {
		return this._pageWidthMode.mode == "dynamic";
	},
	
	_changeWidthAndScroll : function(width, left) {
		this.changeWidth(width);
		this._changer.scrollToView(left);
	},

	widgetToBeResized : function(widgetId, width, deltaW) {
	    if (!this.hasReactionToWidget()) {
			return;
		}
		//this._changer.cancelOverflow();
		/*if (deltaW < 0) {
			var box = this._getWidgetMarginBox(widgetId);
			if (box.l + width > this._changer.getWidth()) {
			  this.changeWidth(box.l + width);
			  this._changer.scrollToView(box.l);
			}
		}*/
		var box = this._getWidgetMarginBox(widgetId);
		this.changeWidth(box.l + width);
		this._changer.scrollToView(box.l);
	},
	
	widgetToBeMoved : function(widgetId, left, width) {
	   if (!this.hasReactionToWidget()) {
			return;
		}
		if (typeof left == "undefined" || left === null) {
			throw new Error("Please provide the left coordinate.");
		}
		if (typeof width == "undefined" || width === null) {
			if (widgetId) {
				var box = this._getWidgetMarginBox(widgetId);
				width = box.w;
			}
			else {
				throw new Error("Please provide the widget id or width.");
			}
		}
		//this._changer.cancelOverflow();
		
		this.changeWidth(left + width);
		this._changer.scrollToView(left);
	},
	
	
	widgetToBeRemoved : function() {
	   if (!this.hasReactionToWidget()) {
			return;
	   }
	   var widgetIds = this._wlp.getWidgetIds();
	   var min = this._getMinimumWidthForWidgets(widgetIds);
	   this.changeWidth(min);
	},
	
	_resizeHandler : function() {
		if (!this._needsToAdjustWidth()) {
			return;
		}
		window.detachEvent("onresize", this._resizeFn);
		this._clearWidthChangerTimeout();
		this._widthChangerTimeout = window.setTimeout(dojo.hitch(this, this._changeMinMaxWidth), 300);
		window.attachEvent("onresize", this._resizeFn);
	},
	
	_changeMinMaxWidth : function() {
		var min = this._wrp.getMinimum();
		var max = this._wrp.getMaximum();
		this._changer._changeMinMaxWidth(min, max);
		this._clearWidthChangerTimeout();
	},
	
	_clearWidthChangerTimeout : function() {
		if (this._widthChangerTimeout) {
			window.clearTimeout(this._widthChangerTimeout);
		}
	}
	
});


dojo.declare("com.ibm.mm.builder.utils.PageWidthChanger.Changer", null, {
	WIDTH_CHANGE_THROTTLE_VALUE : 50,
	
	constructor : function() {
		this._node = dojo.body();
		this._toChangeWidthTimer = null;
	},
	
	_getNode : function() {
		return this._node;
	},
	
	_changeMinMaxWidth : function(min, max) {
		var currentWidth = document.documentElement.clientWidth;
		var newWidth = currentWidth < min ? min : (currentWidth > max ? max : currentWidth);
		if (newWidth == min || newWidth == max) {
			this.setWidth(newWidth);
		}
		else {
			this.setWidth("auto");
		}
	},
	
	changeTo : function(/* Number */ width, min, max) {
		//this._clearChangeToTimer();
		//this._toChangeWidthTimer = window.setTimeout(dojo.hitch(this, this._doChangeTo, width, min, max),this.WIDTH_CHANGE_THROTTLE_VALUE);
		this._doChangeTo(width, min, max);
	},
	
	_clearChangeToTimer : function() {
		if (this._toChangeWidthTimer) {
			window.clearTimeout(this._toChangeWidthTimer);
		}
	},
	
	_normalizeNumericValues : function(value) {
		if (value || value === 0) {
			var v = /^\d+$/.test(value + "") ? (value + "px") : value;
			return v;
		}
	},
	
	_hackForShadowMenu : function() {
		dojo.query(".mashupsShadowNode").
			forEach( function(item) {
				// defect 13906, only hack for invisible ShadowMenu
				if(dojo.style(item, "visibility") != "visible") {
					dojo.style(item, "left", 0);
				}
			});
	},
	
	_doChangeTo : function(width, min, max) {
		var obj = {};
		var w = this._normalizeNumericValues(width);
		if (w) {
			obj["width"] = w;
		}
		var minW = this._normalizeNumericValues(min);
		if (minW) {
			obj["minWidth"] = minW;
		}
		var maxW = this._normalizeNumericValues(max);
		if (maxW) { 
			obj["maxWidth"] = maxW;
		}
		dojo.style(this._getNode(), obj);
		this._hackForShadowMenu();
	},
	
	setMinimum : function(width) {
	    this._doChangeTo(null, width);
	},
	
	setWidth : function(width) {
		this._doChangeTo(width);
	},
	
	getWidth : function() {
	  return dojo.style(this._getNode(), "width");
	},
	
	setOverflow : function() {
		dojo.style(dojo.query("html")[0], {
			"overflowX" : "hidden"
		});
		window.scrollTo(0, window.pageYOffset);
	},
	
	cancelOverflow : function() {
		dojo.style(dojo.query("html")[0], {
			"overflowX" : "auto"
		});
	},
	
	scrollToView : function(xPos) {
		//window.scrollTo(xPos, window.pageYOffset);
	},
	
	restoreToFluidLayout : function() {
		var maxWidth = dojo.isIE ? "100%" : "auto";
		this._doChangeTo("auto", "auto", "100%");
	}
});

if (!dojo.isObject("com.ibm.mm.builder.utils.pageWidthChanger")) {
	dojo.setObject("com.ibm.mm.builder.utils.pageWidthChanger", new com.ibm.mm.builder.utils.PageWidthChanger());
}

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.ExtendableShadowMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ExtendableShadowMenu"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.ExtendableShadowMenu");



/**
 * summary: Shadow menu with extension
 */
dojo.declare("com.ibm.mm.builder.widget.ExtendableShadowMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	
	hasMorePage:false,
	
	currentPosition: 0,
	
	isLastItemShowed:false,
	
	loadedEntriesNumber:0,
	
	limitedSize:null,
	
	onOpen: function(){
		if (!this._arrowIsCreated) {
			this.upArrow = new com.ibm.mm.builder.widget.MenuItemArrow({type: "previous"});
			this.addChild(this.upArrow, 0);
			
			this.downArrow = new com.ibm.mm.builder.widget.MenuItemArrow({type: "next"});
			this.addChild(this.downArrow, this.loadedEntriesNumber + 1);	
			this._arrowIsCreated = true;
		}
		this.adjustMenu();
		this.inherited(arguments);
	},
	
	/*
	 * Show the arrows when then number is greater than page sizing
	 */
	adjustMenu: function(){
		var children = this.getChildren();
		for (var i = 0, len = children.length; i < len; i++) {
			var child = children[i];
			if (child.declaredClass == "com.ibm.mm.builder.widget.MenuItemArrow") {
				if (this.hasMorePage) {
					child.domNode.style.display = "";
					if (child.type === "previous") {
						child.setDisabled(this.currentPosition > 0 ? false : true);
						
					} else if (child.type === "next") {
						child.setDisabled(this.isLastItemShowed);
						
					} else {
						child.domNode.style.display = "none";
					}
				}
			}
			if (child.declaredClass == "dijit.PopupMenuItem" || child.constructor.superclass.declaredClass == "dijit.PopupMenuItem") {
				child.domNode.style.display = (i > this.currentPosition && i <= this.currentPosition + this.limitedSize) ? "" : "none";
			}
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.MenuItemArrow", [dijit.MenuItem], {
	
	type: null,
	
	templateString: 
		"<tr class='dijitReset dijitMenuItem MenuItemArrow' dojoAttachEvent='onmouseenter:_onHover,onmouseleave:_onUnhover' style='display:none;'>"+
	        "<td colspan='4'>"+
				"<div>"+
					"<img dojoAttachPoint='pageNextNode' dojoAttachEvent='onclick:_entryFlip,onkeypress:_onKeyPressEntryFlip'  class='NavigationMenuPageNext' alt='' tabindex=0 />"+
					"<span class='NavigationMenuPageDivider'></span>"+
					"<img  dojoAttachPoint='jumpNextPage' dojoAttachEvent='onclick:_pageFlip,onkeypress:_onKeyPressPageFlip'  class='NavigationMenuPageJump' alt='' tabindex=0 />"+
				"</div>"+
			"</td>"+
		"</tr>",
			
	postCreate: function(){
		this.imgPath = builderConfig.builderPath+ "/images/" + this.type;
        this.pageNextNode.src = this.imgPath + "_entry_disabled.png";
        this.jumpNextPage.src = this.imgPath + "_page_disabled.png";
	},
	
	_onKeyPressEntryFlip:function(e){
        switch (e.keyCode) {
            case dojo.keys.ENTER:
                this._entryFlip(e);
                break;
        }
	},
	_onKeyPressPageFlip:function(e){
        switch (e.keyCode) {
            case dojo.keys.ENTER:
                this._pageFlip(e);
                break;
        }
	},
	setDisabled: function(/*Boolean*/ disabled){
        this.pageNextNode.src = this.imgPath + "_entry" + (disabled ? "_disabled" : "_enabled") + ".png";
        this.jumpNextPage.src = this.imgPath + "_page" + (disabled ? "_disabled" : "_enabled") + ".png";
		this.isDisabled = disabled;
	},
	
	_entryFlip: function(e){
		if (this.isDisabled) { return; }
		
		var parent = this.getParent();
		this._flipHelper(parent);
		parent.adjustMenu();
		if (parent.shadow) { parent.shadow.resize(); }
	},
	
	_flipHelper: function(parent){
		if (this.type === "previous") {
			if (parent.currentPosition > 0) {
				parent.currentPosition--;
				parent.isLastItemShowed = false;
			}
		}
		else if (this.type === "next") {
			var pages = parent.pages;
			if (!pages || parent.isLastItemShowed) { return; }
			
			if ((parent.currentPosition + parent.limitedSize) === parent.loadedEntriesNumber && pages.hasNext()) {
				var page = pages.next();
				var newItem = parent.createNewItem(page);
				dojo.forEach(parent.getChildren(), function(child){
					if (child.declaredClass === "com.ibm.mm.builder.widget.MenuItemArrow") {
						parent.addChild(newItem, parent.getIndexOfChild(child));
					}
				});
				parent.loadedEntriesNumber++;
				parent.currentPosition++;
				parent.isLastItemShowed = !pages.hasNext();
			}
			else {
				parent.currentPosition++;
				parent.isLastItemShowed = (parent.currentPosition + parent.limitedSize) === parent.loadedEntriesNumber;
			}
		}
	},
	
	_pageFlip: function(e){
		if (this.isDisabled) return;
		
		var parent = this.getParent();
		for (var i = 0; i < parent.limitedSize; i++) {
			this._flipHelper(parent);
		}
		parent.adjustMenu();
		if (parent.shadow) {
			parent.shadow.resize();
		}
	},
	
	focus: function(){
		// this throws on IE (at least) in some scenarios
		try{ dijit.focus(this.pageNextNode); }catch(e){}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.IndicatorSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.IndicatorSource"] = true;
dojo.provide("com.ibm.mm.builder.dnd.IndicatorSource");



/**
 * IndicatorSource is the auto sync source. It will create indicator during dragging.
 * 
 * @author jarod (zhangpy@cn.ibm.com)
 */
dojo.declare("com.ibm.mm.builder.dnd.IndicatorSource", dojo.dnd.AutoSource, {
		
	onMouseMove: function(e){
		this.inherited(arguments);
		if (this.isDragging) {
			if (this.removeIndicatorTimer) clearTimeout(this.removeIndicatorTimer);
			if (dojo.dnd.manager().canDropFlag && this.targetState != "Disabled") {
				this.createIndicator(e);
			}
		}
	},
	
	onDndDrop: function(source, nodes, copy, target){
		this.inherited(arguments);
		this.removeIndicator();
	},

	removeIndicator: function(){
		//callback for customized layout to remove inidcator
	},
	
	createIndicator: function(e){
		//callback for customized layout to create inidcator
	},
	
	onDndCancel: function(){
		this.inherited(arguments);
		this.removeIndicator();
	},
	
	onDraggingOut: function(){
		this.removeIndicatorTimer = setTimeout(dojo.hitch(this, function(){
			this.removeIndicator();
		}, 2));
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationPanel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationPanel"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.navigation.NavigationPanel");








(function(){
var maxLen = 150;
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var pageUtil = utils.pageUtil;
var navigationUtil = utils.navigationUtil;
var spaceUtil = utils.spaceUtil;
var themeUtil = utils.themeUtil;
var userUtil = utils.userUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
/**
 * The default breadcrumb navigation
 * @version 2.0
 */
dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanel", 
	[dijit._Widget, dijit._Templated, dijit._Container],{
	
	templateString: '<ul class="navigationPanel" dojoAttachPoint="containerNode"></ul>',
	
	npItemShowNum: 4, //the max number of last navigation items to show; Others will hide in separator ...
	
	/**
	 * the iEvent handler for navigation iEvent: "refreshNavigation" 
	 * it will refresh page if necessary.
	 */
	refresh: function(pid, needSwitch){
		this._cleanup();
		
		var currentPageIdBeforeRefresh = pageUtil.getCurrentPageId();
		var locationBeforeRefresh = location.href;
		//build models and render
		var models = this._getNavigationModelArray(pid);
		
		if (!models) { //this means there is no any page
			//if the theme is different from default, load defautl theme.
			if (themeUtil.getCurrentSpaceThemeId() != themeUtil.getCurrentThemeId()) {
				pageUtil.setPageId();
				setTimeout(function(){
					window.location.reload();
				}, 10)
				return;
			}
			//prompt user to create a new page.
			var m = navigationUtil.getNavigationModel();
			var rootNode = navigationUtil.getNavigationRootNode(spaceUtil.getCurrentSpaceId());
			if (m.confirmCreate() && m.confirmInsert(null, rootNode, null) && !userUtil.isLockedDownAnonymousMode()) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.EmptyPagePanelItem());
			}
		} else {
			//reload theme if the page has new theme
			if (themeUtil.getThemeId() != themeUtil.getCurrentThemeId()) {
				var cpid = pageUtil.getCurrentPageId();
				pageUtil.setPageId(cpid);
				var redirectAddress = navigationUtil.getRedirectAddress();
				setTimeout(function(){
					//if only pid is changed, reload the page.
					//there are two conditions: 
					// 1) http://localhost:8080/mum/enabler#pid=1&
					// 2) http://localhost:8080/mum/enabler#    (this means no page before switch)
					if(redirectAddress === locationBeforeRefresh.replace(/pid=([^&]*)/, "pid=" + cpid) || 
						(locationBeforeRefresh.indexOf("pid=") < 0 && redirectAddress === locationBeforeRefresh.replace("#", "#pid="+cpid + "&"))){
						location.reload();
					}else{
						location.href = redirectAddress;
					}
				}, 10)
				return;
			}
			
			//if there is no page before refresh and new page is added, swith to new page
			if (!currentPageIdBeforeRefresh) {
				needSwitch = true;
			}
			
			// iterate all items in models and paint it
			var slashAdjust = 1;
			var _len = models.length;
			
			//if model's length reach the upper limit(here is npItemShowNum(4))
			//we will add NavPaneArrow widget(show as "...")
			if (_len > this.npItemShowNum) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavPaneArrow());
				slashAdjust = 2;
			}
			//adjust the begin item number in model
			var _begin = 0;
			if (_len > this.npItemShowNum) {
				_begin = _len - this.npItemShowNum;
			}
			
			//render the navigation items and slash
			for (var i = _begin; i < _len; i++) {
				var naviModel = models[i];
				var navPaneItem = new com.ibm.mm.builder.iwidget.navigation.NavigationPanelItem({
					navigationNode: naviModel
				});
				this.addChild(navPaneItem);
				if (i < _len - 1) {//slash between two NavPaneItem
					this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationPanelSeparator());
				}
			}
		}
		dojo.forEach(this.getChildren(), function(child){ child.startup(); });
		
		this._adjustWidthForBidiIE();
		
		pageUtil.updatePageTitle();
		
		setTimeout(function(){
			if(needSwitch){
				var pageId = pageUtil.getCurrentPageId();
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				pageUtil.setPageId(pageId);
				eventService.broadcastEvent("com.ibm.mashups.builder.pageSwitched", pageId);
			}
		}, 0);
	},
	
	_adjustWidthForBidiIE: function(){
		if ((builderConfig.isBidi && dojo.isIE)) {
			setTimeout(function(){
				var nav = dojo.query(".navigatorDiv")[0];
				if (nav){
					var piw = 0;
					dojo.query(".navigationPanelItem", nav).forEach(function(item){
						piw += dojo.coords(item, true).w
					});
					dojo.query(".emptyPagePanelItem", nav).forEach(function(item){
						piw += dojo.coords(item, true).w
					});
					var adjust = 5;//IE7 & IE6
					if (dojo.isIE === 8) adjust = 30;
					nav.style.width = piw + adjust + "px";					
				}
				if (builderConfig.isBidi && dojo.isIE === 8) {
					//use paddingRight to prevent Welcome Page and Space Selector overlap
					var navPan = dojo.query(".navigationPanel", nav)[0];
					if (navPan) navPan.style.paddingRight = "30px";
				}
			}, 0);
		}
	},
	/**
	 * Init the Navigation's models array, so that the Navigation knows
	 * which item(s) it should render.
	 */
	render: function(pid) {
		this.refresh(pid, true);
	},
	
	_cleanup: function(){
		dojo.forEach(this.getChildren(), function(item){
			item.destroy();
			delete item;
		});
	},
	
	destroy: function(){
		this._cleanup();
		this.inherited(arguments);
	},
	/**
	 * Construct navigation model array according to parameter pid
	 * The array represents the data of navigation panel items.
	 * @param {String} pid: current page id. If it is not specified, get the current page id
	 * @return array of the models
	 */
	_getNavigationModelArray: function(pid) {
		//if parameter pid is null, used current page id;
		//if current page is null, try to find first page under root
		var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		pid = pid || currentPage.getID();
		if(!pid){
			var spaceId = spaceUtil.getCurrentSpaceId();
			pid = spaceId ? pageUtil.getFirstPageInSpace(spaceId) : pageUtil.getFirstRootPageId();
		}
		//if current page still is null, this means no page exists.
		if(!pid) { return null; }
		
		//update current page id and space id
		currentPage.setID(pid);
		var spaceId = spaceUtil.getSpaceIdByPageId(pid);
		if (spaceId !== spaceUtil.getCurrentSpaceId()) {
			spaceUtil.setSpaceId(spaceId);
		}
		//try to build model array
		var menuModelArrays = [];
		var navModel = navigationUtil.getNavigationModel();
		var currentModel = navModel.find(pid).start();
		var rootId = navigationUtil.getNavigationRootNodeId();
		var currentSpaceRootId = navigationUtil.getNavigationRootNodeId(spaceUtil.getCurrentSpaceId());
		//Loop to root to build the menuModelArrays array that holds all the models of the item that need to be rendered
		while(currentModel && currentModel.getID() !== rootId && currentModel.getID() !== currentSpaceRootId) {
			menuModelArrays.push(currentModel);
			currentModel = navModel.getParent(currentModel.getID()).start();
		}
		if(menuModelArrays.length === 0){ return null; } //means no any page under root
		return menuModelArrays.reverse();
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanelItem",
	[dijit._Widget, dijit._Templated, dijit._Contained],
{
	/**
	 * current page model
	 */
	navigationNode: null,
	
	/**
	 * current menu object stored for reuse
	 */
	pageMenu:null,
	
	templateString: 
		'<li dojoAttachEvent="onmouseover:_onHover,onmouseout:_onUnHover,onkeypress:_onKeyPress,onclick: _onClick">'+
			'<div dojoAttachPoint="containerNode" class="navigationPanelItem">'+
				'<div dojoAttachPoint="titleNode" tabindex="0" class="navigationPanelItemLabel truncatedLabel" widthLimit="150"></div>'+
			'</div> '+
		'</li>',

	postCreate: function(){
		var node = this.titleNode;
		var title = pageUtil.getPageTitle(this.navigationNode);
		setTimeout(function(){ //set timeout to make sure the class is applied on the node
			node.innerHTML = title;
			htmlUtil.truncateNodeText(node);
			if ((builderConfig.isBidi && dojo.isIE) || (dojo.isIE === 6)) {
				var w = htmlUtil.getStrWidth(node.innerHTML, node);
				node.style.width = w + "px";
			}
		},0);
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
				this.renderMenu(evt);
			break;
		}
	},
	
	onFocus:function(){
		dojo.addClass(this.containerNode, "navigationPanelItemHover");
		this.focus();
	},
	
	onBlur:function(){
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){
			dojo.removeClass(this.containerNode, "navigationPanelItemHover");
		}
	},
	
	focus: function(){
		try{
			dijit.focus(this.domNode);
		}catch(e){} // this throws on IE (at least) in some scenarios
	},
	
	_onHover: function(evt){
		dojo.addClass(this.containerNode, "navigationPanelItemHover");
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){ this.focus(); }
	},
	
	_onUnHover: function(evt){
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){
			dojo.removeClass(this.containerNode, "navigationPanelItemHover");
		}
	},
	
	renderMenu: function(evt){
		//the page id should be the parent id of the current item.
		this.pageMenu = this.pageMenu || new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({
			targetNodeIds: [this.containerNode],
			siblingPageId: this.navigationNode.getID(),
			parentPanelItem: this
		});
		
		this.pageMenu._openMyself(evt);
	},
	
	_onClick: function(evt){
		this.renderMenu(evt);
	},
	
	uninitialize: function(){
		if (this.pageMenu) {
			if(this.pageMenu.isShowingNow){
				dijit.popup.close(this.pageMenu);
			}
			this.pageMenu.destroyRecursive();
			delete this.pageMenu;
			this.pageMenu = null;
		}
		this.inherited(arguments);
	}
});

/**
 * A slash line between two page items
 */
dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanelSeparator",
	[dijit._Widget, dijit._Templated, dijit._Contained], {

	templateString: '<li><span class="navigationPanelSeparator">/</span></li>',

	postCreate: function(){
		dojo.setSelectable(this.domNode, false);
	},
	
	isFocusable: function(){
		// summary: over ride to always return false
		return false;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavPaneArrow",
	[dijit._Widget, dijit._Templated, dijit._Contained], {
	
	templateString: '<li><div class="NavPaneArrow">...</div></li>'
	
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.EmptyPagePanelItem",
	[dijit._Widget, dijit._Templated, dijit._Contained], {

	templateString:
		'<li dojoAttachEvent="onclick:_showInput,onkeydown:_enterToShowInput" tabindex="0" class="emptyPagePanelItem">'+
			'<span dojoAttachPoint="pageTitleLabel" class="emptyPagePanleLabel truncatedLabel" widthLimit="200"></span>'+
			'<label dojoAttachPoint="realPageTitleLabel" for="${id}_input" style="display: none"></label>'+
			'<input id="${id}_input" dojoAttachPoint="pageTitleInput" dojoAttachEvent="onkeydown:_onKeyPress,onblur:_onBlur"/>'+
		'</li>',
	
	postCreate: function(){
		this._hideInput();
		htmlUtil.truncateNodeText(this.pageTitleLabel);
		dojo.attr(this.realPageTitleLabel,'innerHTML',com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE);
	},
	
	_enterToShowInput: function(evt){
		if(evt.keyCode === dojo.keys.ENTER){
			this._showInput();
		}
	},
	
	_showInput: function(evt){
		this.pageTitleLabel.style.display = "none";
		this.pageTitleInput.style.display = "";
		this.pageTitleInput.focus();
	},
	
	_hideInput: function(){
		this.pageTitleLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE;
		this.pageTitleLabel.style.display = "";
		this.pageTitleInput.style.display = "none";
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.ENTER:
				var name = this.pageTitleInput.value;
				if (!pageUtil.validatePageName(name)) {	return;	}
				name = dojo.trim(name);
				pageUtil.createPage(name);
				dojo.stopEvent(evt);
				break;
			case dojo.keys.ESCAPE:
				this._hideInput();
				dijit.focus(this.domNode);
				dojo.stopEvent(evt);
				break;
		}
	},
	
	_onBlur: function(evt){
		if(!this.pageTitleInput.value){ this._hideInput(); }
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenu", com.ibm.mm.builder.widget.ExtendableShadowMenu ,{

	siblingPageId: null,
	
	parentPageId: null,
	
	parentPanelItem: null,
	
	offset_x: -1,
	
	popupDelay: 250,
	
	postCreate: function(){
		this.limitedSize = com.ibm.mm.builder.constant.NavigationPageSize;
		this.inherited(arguments);
		dojo.addClass(this.domNode, "navigationMenu");
		var navMenu = this;
		var pNodeId = this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
		
		if (this.dndDisable) { return; }
		
		if (userUtil.isLockedDownAnonymousMode()) { return; }
		this.dndSource = new com.ibm.mm.builder.dnd.IndicatorSource(this.domNode, {
			
			accept: ["navigationPage"],
			
			creator: function(item, hint){
				if(hint === "avatar"){
					var selectedNode = dojo.query("tr[dnddata='"+item+"']")[0];
					var tbody = selectedNode.parentNode.cloneNode(false);
					var n = selectedNode.parentNode.parentNode.cloneNode(false);
					tbody.appendChild(selectedNode.cloneNode(true));
					n.appendChild(tbody);
					return { node: n, data: item, type: ["navigationPage"] };
				}
				return {
					node: navMenu.createNewItem(pageUtil.getPageNode(item)).domNode,
					data: item,
					type: ["navigationPage"]
				};
			},
			
			onDndCancel: function(){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndCancel.call(this);
				dojo.forEach(navMenu.getChildren(), function(c){
					if(c.declaredClass === "dijit.PopupMenuItem") c.setDisabled(false);
				});
				this.hoveredPageId = "";
			},
			
			onDndStart: function(source, nodes, copy){
				if (this === source) {
					var node = dijit.byId(nodes[0].id);
					if (node && node.popup) {
						node.popup._stopPopupTimer();
						if (node.popup.isShowingNow) {
							//bug 11434, not sure why safari will close all menu when close popup.
							//timer can solve such issue.
							window.setTimeout(function(){
								dijit.popup.close(node.popup);
							}, 500);
						}
						node.setDisabled(true);
					}
				}
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndStart.call(this, source, nodes, copy);
			},
			
			onDropExternal: function(source, nodes, copy){ //this means to parent or child
				if (!navMenu.isShowingNow || !this.hoveredPageId || !this.dropIndicator) { return; }
				dijit.popup.close(navMenu._getTopMenu());
				var draggedNodeId = nodes[0].getAttribute("dnddata");
				var hoveredPageId = this.hoveredPageId;
				var position = (this.hoveredNewPage) ? "children" : ((this.before) ? "previous" : "next");
				//put the heavy operation later after dnd cancel
				setTimeout(function(){
					navigationUtil.reorderPageNode(draggedNodeId, hoveredPageId, position);
				}, 0);
			},
			
			onDropInternal: function(nodes, copy){ //this means reorder
				if (!navMenu.isShowingNow || !this.dropIndicator) { return; }
				dijit.popup.close(navMenu._getTopMenu());
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDropInternal.call(this, nodes, copy);
				var draggedNodeId = nodes[0].getAttribute("dnddata");
				var hoveredPageId = this.hoveredPageId;
				var position = (this.before) ? "previous" : "next";
				//put the heavy operation later after dnd cancel
				setTimeout(function(){
					navigationUtil.reorderPageNode(draggedNodeId, hoveredPageId, position);
				}, 0);
			},
			
			/* fix the bug 11434
			 * The menu focus behavior is incorrect in some specified dnd operation such as
			 * dragging too fast so that the mouse hovers the avatar etc. 
			 */
			onDndSourceOver: function(source){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndSourceOver.call(this, source);
				if (!navMenu.isActive) { navMenu._onFocus(); }
			},
			
			removeIndicator: function(){
				if (this.dropIndicator) {
					navMenu.removeChild(this.dropIndicator);
					this.dropIndicator = null;
				}
				if (navMenu.shadow && navMenu.isShowingNow) { navMenu.shadow.resize(); }
			},
			//todo simply this method
			createIndicator: function(e){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.createIndicator.call(this, e);
				var hoveredNode = e.target.parentNode;
				if(!hoveredNode){ this.removeIndicator(); return; }
				var menuChildren = navMenu.getChildren();
				if(menuChildren.length === 3 && menuChildren[2].declaredClass == "com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem"){
					this.hoveredPageId = navMenu.parentPageId;
					this.hoveredNewPage = true;
					if(!this.dropIndicator)	this.insertIndicator(1);
					return;
				}else if(menuChildren.length === 4 && menuChildren[1] === this.dropIndicator && 
					menuChildren[3].declaredClass == "com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem"){
					return;
				} else {
					this.hoveredPageId = hoveredNode.getAttribute("dnddata");
					if(!this.hoveredPageId){ this.removeIndicator(); return; }
				}
				this.hoveredNewPage = false;
				
				//should not insert the same position
				var draggedPageId = this.getSelectedNodes() && this.getSelectedNodes()[0] && this.getSelectedNodes()[0].getAttribute("dnddata");
				if(this.hoveredPageId === draggedPageId){ this.removeIndicator(); return; }
				
				//if previous/next page is the dragged page, should void to create indicator
				if((this.before && hoveredNode.previousSibling && hoveredNode.previousSibling.getAttribute("dnddata") === draggedPageId) ||
					(!this.before && hoveredNode.nextSibling && hoveredNode.nextSibling.getAttribute("dnddata") === draggedPageId)) {
					this.removeIndicator(); return;
				}
				//if the dragged page can't insert into current menu, the indicator will not be created.
				var navigationModel = navigationUtil.getNavigationModel();
				var page = pageUtil.getPageNode(draggedPageId);
				var parentPage = pageUtil.getPageNode(navMenu._getParentPageId());
				try {
					if (!navigationModel.confirmInsert(page, parentPage)) return;
				} catch (e) {
					console.log(draggedPageId, navMenu._getParentPageId());
					console.error(e);
				}
				
				var insertIndex =  navMenu.getIndexOfChild(dijit.byId(hoveredNode.id)) + ((this.before) ? 0 : 1);
				this.insertIndicator(insertIndex);
			},
			
			insertIndicator: function(insertIndex){
				this.dropIndicator = this.dropIndicator || new com.ibm.mm.builder.iwidget.navigation.NavigationMenuDNDIndicator();
				navMenu.addChild(this.dropIndicator, insertIndex);
				if(navMenu.shadow){ navMenu.shadow.resize(); }
			}
		});
		//the new source created during dragging need to init the state.
		if(dojo.dnd.manager().source && dojo.dnd.manager().source.isDragging){
			this.dndSource.isDragging = true;
		}
	},
	
	//change the dijit.Menu's default behaviour(onClick) to onItemHover when the popup menu should be shown by key
	_onKeyPress: function(evt){
		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.keyCode){
			case dojo.keys.RIGHT_ARROW:
				this.onItemHover(this.focusedChild);
				break;
			case dojo.keys.LEFT_ARROW:
				if(this.parentMenu){
					this.onCancel(false);
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},
	
	_onPageItemClick: function(pageId){
		dijit.popup.close(this._getTopMenu());
		
		setTimeout(function(){
			if (com.ibm.mm.builder.TabbedNavigationDelegate){
				// clear the global page in tabbed navigation
				com.ibm.mm.builder.TabbedNavigationDelegate.onClearGlobalPage();
			}else{
				// clear the global page in other navigations
				dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
			}
			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage", pageId);
		}, 0);
	},
	
	prepareData: function(){
		var pages;
        if (this.siblingPageId) {
		    pages = pageUtil.getSiblingPages(this.siblingPageId);
		} else if (this.parentPageId) {
		    pages = pageUtil.getChildPages(this.parentPageId);
        }
        if (!this.confirmInsert) {
            var pNodeId = this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
            this.confirmInsert = navigationUtil.getNavigationModel().confirmInsert(null, pageUtil.getPageNode(pNodeId), null);
        }
		var canCreatePage = navigationUtil.getNavigationModel().confirmCreate() && this.confirmInsert && !userUtil.isLockedDownAnonymousMode();
		
		if (pages) {
			var self = this;
			while (pages.hasNext()) {
				if (self.loadedEntriesNumber >= com.ibm.mm.builder.constant.NavigationPageSize) {
					self.hasMorePage = true;
					self.isLastItemShowed = false;
					break;
				}
				var node = pages.next();
				if (com.ibm.mm.builder.utils.pageUtil.isVisiable(node)) {
					this.addChild(this.createNewItem(node));
					this.loadedEntriesNumber++;
				}
			}
			
			if (this.loadedEntriesNumber > 0 && canCreatePage) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
			}
		}
		if(canCreatePage){
			this.addChild(new com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem({
				parentPageId: this._getParentPageId()
			}));
		}
		
		this.pages = pages;
		htmlUtil.truncateAllChildNodesText(this.domNode,null,{fontSize:"1.2em"});
		
		//make sure the current panel item is highlighted when the page is openning.
		if(this.parentPanelItem && this.parentPanelItem.containerNode){
			dojo.addClass(this.parentPanelItem.containerNode, "navigationPanelItemHover");
		}
	},
	
	_getParentPageId: function(){
		return this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
	},
	
	createNewItem: function(page){
		var pageId = page.getID();
		var newChild = new dijit.PopupMenuItem({
			label: pageUtil.getPageTitle(pageId),
			popup: new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({ parentPageId: pageId }),
			postCreate:function(){
				dijit.PopupMenuItem.prototype.postCreate.call(this);
				htmlUtil.markTruncation(this.containerNode,"153");
			},
			_onClick: dojo.hitch(this, "_onPageItemClick", pageId)
		});
		
		newChild.domNode.setAttribute("dndtype", "navigationPage");
		newChild.domNode.setAttribute("dnddata", pageId);
		dojo.query(".dijitMenuArrowCell",newChild.domNode)[0].style.display = "none";
		
		dojo.addClass(newChild.domNode, "dojoDndItem");
		return newChild;
	},
	
	onClose: function(){
		this.inherited(arguments);
		if(this.parentPanelItem && this.parentPanelItem.containerNode){
			dojo.removeClass(this.parentPanelItem.containerNode, "navigationPanelItemHover");
		}
	},
	
	uninitialize: function(){
		if (this.dndSource) {
			this.dndSource.destroy();
		}
		this.parentPanelItem = null;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem", dijit.MenuItem, {
	
	//newPageMenuItemTd is add for automation test.
	templateString:
		'<tr class="dijitReset dijitMenuItem newPageMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"'
			+'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,onclick:_onClick,onkeypress:_onKeyPressMenuItem">'
			+'<td class="dijitReset newPageMenuItemTd" dojoAttachPoint="containerNode" colspan="4">' +
				'<label dojoAttachPoint="realPageTitleLabel" for="${id}_input" style="display: none"></label>'+
				'<input type="text" dojoAttachPoint="input" id="${id}_input" style="display:none"' +
					'dojoAttachEvent="onkeypress:_onKeyPress,onfocus:_onfocus, onblur:_onblur" ></input>' +
				'<div dojoAttachPoint="textNode" class="dijitMenuItemLabel truncatedLabel" widthLimit="153"></div>' +
			'</td>'
		+'</tr>',

	parentPageId: null,
	
	postCreate: function(){
		this.inherited(arguments);
		//make sure that user can click mouse to move the caret
		dojo.setSelectable(this.domNode, true);
		
		var label = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE;
		this.input.title = label
		this.textNode.innerHTML = label;
		this.textNode.title = label;
		dojo.attr(this.realPageTitleLabel,'innerHTML',label);
	},
	
	//reactive the default key event by clearing the parent's function used to prevent the default key event. 
	//todo, if there is mem leak, try to use dojo.connect to fix
	_onfocus: function(){
		this.parentPreviousKeyPress = this.getParent()._onKeyPress;
		this.getParent()._onKeyPress = function(evt){}
	},
	
	_onblur: function(){
		this.getParent()._onKeyPress = this.parentPreviousKeyPress;
	},
	
	_onKeyPressMenuItem:function(e){
		switch (e.keyCode){
			case dojo.keys.ENTER:
			  this._onClick(e);
			  break;
		}
	},
	_onClick: function(evt){
		this.textNode.style.display = "none";
		this.input.style.display = "";
		this.input.focus();
		this._resizeShadow();
	},
	
	_onKeyPress: function(evt){
        switch (evt.keyCode) {
            case dojo.keys.ENTER:
				var newPageName = this.input.value;
				if (!pageUtil.validatePageName(newPageName)) {
		            return;
		        }
				newPageName = dojo.trim(newPageName);
		
				dijit.popup.close(this.getParent()._getTopMenu());
				dojo.stopEvent(evt);
				
            	this._createNewPage(newPageName);
                break;
				
            case dojo.keys.ESCAPE:
				this._restore();
                dojo.stopEvent(evt);
                break;
        }
	},
	
	_restore: function(){
		this.input.style.display = "none";
		this.input.value = "";
		this.textNode.style.display = "";
		this._resizeShadow();
	},
	
	_createNewPage: function(newPageName){
		var cancelcb = dojo.hitch(this, function(){
			this._restore();
		});
		
		var cb = dojo.hitch(this, function(){
			pageUtil.createPage(newPageName,this.parentPageId, cancelcb);
		});
		
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb, cancelcb);
	},
	
	//have to do this..
	_resizeShadow: function(){
		var shadow = this.getParent().shadow;
		if (shadow) { shadow.resize(); }
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator", dijit.MenuSeparator, {
	
	templateString: '<tr class="dijitMenuSeparator"><td colspan=4><div class="dijitNewMenuSeparator"></div></td></tr>'
	
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenuDNDIndicator", dijit.MenuSeparator, {
	
	templateString: '<tr class="NavigationMenuDNDIndicator"><td colspan=4><div class="NavigationMenuDNDIndicatorInstance"></div></td></tr>'
	
});

})();

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationStore"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.navigation.NavigationStore");



dojo.declare("com.ibm.mm.builder.model.NavigationStore", dojo.data.ItemFileReadStore, {
    /**
     * summary:
     *  NavigationNodesReadStore extends ItemFileReadStore to implement an 
     *  navigation model store in Lotus Mashups navigation nodes.
     */
    constructor: function(navigationModel, spaceId){
		this.navigationModel = navigationModel;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this.acModeUtil = com.ibm.mm.builder.utils.acModelUtil;
		
        this.items = [];
		
		var root = this.navigationUtil.getNavigationRootNode(spaceId);
		this.items.push(root);
		
		var childrenIter = this.navigationModel.getChildren(root);
		while(childrenIter.hasNext()) {
			var childNode = childrenIter.next();
			if (this.pageUtil.isVisiable(childNode)) {
				this.items.push(childNode);
			}
		}
		
        //convert to a map
        this.parent_node_map = {};
        this.id_node_map = {};
        this.rootNode = root;
		root.__type = "root";
		
        dojo.forEach(this.items, function(node){
			var parent = this.navigationModel.getParent(node.getID()).start();
			var parentId = parent ? parent.getID() : null;
			if (parentId) {
				if (!this.parent_node_map[parentId]) {
					this.parent_node_map[parentId] = [];
				}
				this.parent_node_map[parentId].push(node);
				this.id_node_map[node.getID()] = node;
			}
        }, this);
        dojo.forEach(this.items, function(node){
            node.__children = this.parent_node_map[node.getID()];
			
			var hasChildren = this.navigationModel.hasChildren(node);
			node.__type = hasChildren ? "_stub" : "node";
        }, this);
    },
    
    //dojo.data.api.Read API
    getValue: function( /* item */ item, /* attribute-name-string */ attribute, 
                        /* value? */ defaultValue){
        var values = this.getValues(item, attribute);
        return (values.length > 0)?values[0]:defaultValue;
    },

    getValues: function(/* item */ item, /* attribute-name-string */ attribute){
		var values = null;
		switch(attribute) {
			case "id":
			    values = [item.getID()]
			    break;
			case "title":
			    if (this.rootNode === item) values = ["  "];
				else values = [this.pageUtil.getUnescapedPageTitle(item.getID())];
				break;
			case "description":
			    values = [this.pageUtil.getPageDescription(item.getID())];
				break;
			case "type":
			    values = item.__type;
				break;
			case "parentId":
				var parent = this.navigationModel.getParent(item.getID()).start();
	            var parentId = parent ? parent.getID() : null;
			    values = [parentId];
				break;
			case "children":
			    values = item.__children;
				break;
			case "selfUri":
			    values = [item.getID()];
				break;
			default:
			    values = null;
		}
		values = (values && dojo.isArray(values)) ? values : [values];
		return values;
    },

    getAttributes: function(/* item */ item){
        return ["id", "title", "description", "type", "parentId", "children", "selfUri"];
    },

    hasAttribute: function( /* item */ item, /* attribute-name-string */ attribute){
        return !!(this.getValue(item, attribute));
    },

    containsValue: function(/* item */ item, /* attribute-name-string */ attribute, /* anything */ value){
        return this.getValue(item, attribute) == value;
    },

    isItem: function(/* anything */ something){
		return something.getID();
    },

    isItemLoaded: function(/* anything */ something) {
		return this.isItem(something) && something.__type !== "_stub";
    },

    /**
     * Lazy load sub items
     * @param {Object} keywordArgs
     */
    loadItem: function(/* object */ keywordArgs){
		var item = keywordArgs.item;
        this._assertIsItem(item);
		
		var childrenIter = this.navigationModel.getChildren(item);
		item.__children = [];
		while(childrenIter.hasNext()) {
            var childNode = childrenIter.next();
            
            if (!childNode.__type) childNode.__type = this.navigationModel.hasChildren(childNode) ? "_stub" : "node";
			var parent = this.navigationModel.getParent(childNode.getID()).start();
            var parentId = parent ? parent.getID() : null;
            if(!this.parent_node_map[parentId]){
                this.parent_node_map[parentId] = [];
            }
            this.parent_node_map[parentId].push(childNode);
            this.id_node_map[childNode.getID()] = childNode;
            this.items.push(childNode);
			item.__children.push(childNode);
        }
		item.__type = "node";
		
	    //Done processing!  Call the onItem, if any.
        if(keywordArgs.onItem){
            var scope = keywordArgs.scope ? keywordArgs.scope : dojo.global;
            keywordArgs.onItem.call(scope, item);
        }
    },

    getFeatures: function(){
        return {'dojo.data.api.Read':true, 'dojo.data.api.Identity':'id'};
    },

    close: function(/*dojo.data.api.Request || keywordArgs || null */ request){
    },

    getLabel: function(/* item */ item){
        return this.getValue(item, "title");
    },

    getLabelAttributes: function(/* item */ item){
        return ["title"];
    },
    
    //dojo.data.api.Identity API
    getIdentity: function(/* item */ item){
        return this.getValue(item, "id");
    },

    getIdentityAttributes: function(/* item */ item){
        return ["id"];
    },
	
    fetchItemByIdentity: function(/* object */ keywordArgs){
        var node = this.id_node_map[keywordArgs.identify];
        node = node ? node : null;
        if(keywordArgs.onItem){
            var scope =  keywordArgs.scope?keywordArgs.scope:dojo.global;
            keywordArgs.onItem.call(scope, node);
        }
    },
    
    fetch: function(/* Object */ keywordArgs){
        var query = keywordArgs.query;
        if(query === null){
            keywordArgs.onComplete([this.rootNode], keywordArgs);
        }
    },
    
    getRootItem: function(){
        return this.rootNode;
    },
	
	reset: function() {
		dojo.forEach(this.items, function(item) {
			delete item.__type;
            delete item.__children;
		});
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings");

dojo.declare("com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings",null,{
	
	widgetId:"",
	
	selectedSkin: null,
	
	editMode: false,
	
	editorHeight: 0,
	
	skinObjects:null,
	
	constructor: function(){
		this.selectedSkin = com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId();
	},
	
	getPageDefaultSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.backgroundimagetype = "URL";
		defaultSetting.backgroundimage = "url(" + builderConfig.builderPath + "/images/layoutBackground.jpg)";
		defaultSetting.backgroundimageproperty = "Center";
		defaultSetting.backgroundimagetransparency = "0";
		defaultSetting.pagebgcolor = "#fff";
		defaultSetting.pageborderstyle = "none";
		defaultSetting.pagebordercolor = "#DDDDDD";
		defaultSetting.pagemargin = "0";
		return defaultSetting;
	},
	
	getWidgetDefaultSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.skin = com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId();
		defaultSetting.applyDefaultSkinToAll = "0";
		return defaultSetting;		
	},
	
	getWidgetId:function(){
		return this.widgetId;
	},
		
	getSelectedSkin:function(){
		return this.selectedSkin
	},	

	setWidgetId:function(_wid){
		this.widgetId = _wid;
	},
	
	setSelectedSkin:function(_selectedSkin){
		this.selectedSkin = _selectedSkin
	}
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.defaultSettings"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.defaultSettings"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.columnlayout.defaultSettings");

dojo.declare("com.ibm.mm.builder.iwidget.columnlayout.defaultSettings",null,{

	widgetId:"",
	
	currentColumnNum:3,
	
	selectedSkin: null,
	
	columnsJSONObject:null,
	columnAttrJSONObject:null,
	pageAttrJSONObject:null,

	skinObjects:null,
	
	DEFAULT_COLUMN_WIDTH : 0.33,
	
	constructor: function(){
		this.selectedSkin = com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId();
	},
	
	getPageDefaultSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.pageBgColor = "#fff";
		defaultSetting.pageBgImageType = "URL";
		defaultSetting.pageBgImage = "url(" + builderConfig.builderPath + "/images/columnLayout.jpg)";
		defaultSetting.backgroundimageproperty = "Center";
		defaultSetting.bgImageOpacity = "0";
		defaultSetting.pageBorder = "none";
		defaultSetting.pageBorderColor = "#DDDDDD";
		defaultSetting.pageMargin = "10";
		return defaultSetting;
	},

	getColDefaultSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.columnNumber = "3";
		//defaultSetting.widths = dojo.fromJson('{"1": "32.7%", "2": "32.7%", "3": "32.7%"}');
		defaultSetting.widths = {
		  "1" : this.DEFAULT_COLUMN_WIDTH,
		  "2" : this.DEFAULT_COLUMN_WIDTH,
		  "3" : this.DEFAULT_COLUMN_WIDTH
		};
		defaultSetting.all = this.createObject("","none","","0");
		for(var i=1;i<=3;i++){
			defaultSetting[i] = this.createObject("","none","","0");
		}
		defaultSetting.widthBetweenColumn = "10";
		return defaultSetting;		
	},

	getColumnSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.columnNumber = "3";
		//defaultSetting.widths = dojo.fromJson('{"1": "350px", "2": "350px", "3": "350px"}');
		defaultSetting.widths = {
		  "1" : this.DEFAULT_COLUMN_WIDTH,
		  "2" : this.DEFAULT_COLUMN_WIDTH,
		  "3" : this.DEFAULT_COLUMN_WIDTH
		};
		return defaultSetting;		
	},
	
	getColumnAttrSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.all = this.createObject("","none","","0");
		for(var i=1;i<=3;i++){
			defaultSetting[i] = this.createObject("","none","","0");
		}		
		return defaultSetting;		
	},
	
	getSingleColumnDefaultSetting:function(){
		return this.createObject("","none","","0");
	},

	getPageAttrSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.pageBgColor = "#fff";
		defaultSetting.pageBgImageType = "URL";
		defaultSetting.pageBgImage = "url(" + builderConfig.builderPath + "/images/columnLayout.jpg)";
		defaultSetting.backgroundimageproperty = "Center";
		defaultSetting.bgImageOpacity = "0";
		defaultSetting.pageBorder = "none";
		defaultSetting.pageBorderColor = "#DDDDDD";
		defaultSetting.pageMargin = "10";
		defaultSetting.widthBetweenColumn = "10";
		defaultSetting.widthBetweenWidgets = "10";
		defaultSetting.widgetLeftRightMargin = "0";
		defaultSetting.applyDefaultSkinToAll = "0";
		return defaultSetting;
	},
				
	createObject:function(bgcolor,border,bordercolor,enabled){
		var obj = new Object();
		obj.bgcolor = bgcolor;
		obj.border = border;
		obj.bordercolor = bordercolor;
		obj.enabled = enabled;
		return obj;	
	},
		
	getWidgetDefaultSetting:function(){
		var defaultSetting = new Object();
		defaultSetting.skin = com.ibm.mm.builder.utils.skinUtil.getDefaultSkinId();
		defaultSetting.widthBetweenWidgets = "10";
		defaultSetting.widgetLeftRightMargin = "0";
		defaultSetting.applyDefaultSkinToAll = "0";
		return defaultSetting;		
	},
		
	getWidgetId:function(){
		return this.widgetId;
	},

	getCurrentColumnNum:function(){
		return this.currentColumnNum
	},	

	getSelectedSkin:function(){
		return this.selectedSkin
	},
	
	getColumnsJSONObject:function(){
		return this.columnsJSONObject
	},	
	
	getColumnAttrJSONObject:function(){
		return this.columnAttrJSONObject
	},	
	
	getPageAttrJSONObject:function(){
		return this.pageAttrJSONObject
	},					

	setWidgetId:function(_wid){
		this.widgetId = _wid;
	},

	setCurrentColumnNum:function(_currentColumnNum){
		this.currentColumnNum = _currentColumnNum
	},	

	setSelectedSkin:function(_selectedSkin){
		this.selectedSkin = _selectedSkin
	},

	setColumnsJSONObject:function(_columnsJSONObject){
		this.columnsJSONObject = _columnsJSONObject
	},	
	
	setColumnAttrJSONObject:function(_columnAttrJSONObject){
		this.columnAttrJSONObject = _columnAttrJSONObject;
	},	
	
	setPageAttrJSONObject:function(_pageAttrJSONObject){
		this.pageAttrJSONObject = _pageAttrJSONObject
	}					
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil");

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil");

/**
 * get widget from free form layout
 * @return an array which contains widget dom node
 */			
com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.getWidgetsFromLayout = function(){
	var freeformId = com.ibm.mm.builder.freeLayOutBean.getWidgetId();
	var widgetsContainerNode = dojo.byId("_"+freeformId+"_container").cloneNode(true);
	var queryResult = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,widgetsContainerNode);
	//OpenSocial support change
	queryResult = queryResult + dojo.query("." + com.ibm.mm.builder.constant.mmGGadget,widgetsContainerNode);
	var len = queryResult.length;
	var widgets = new Array();
	for (var i=0;i<len;i++){
		var contentElems = dojo.query("." + com.ibm.mm.builder.constant.iWidgetContent,queryResult[i]);
		if (contentElems.length>0){
			var contentElem = contentElems[0];
			queryResult[i].removeChild(contentElem);
			widgets.push(queryResult[i]);	
		}else{
			widgets.push(queryResult[i]);
		}
	}
	return widgets;
}
	
com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.createSkinConfigUI = function(skinDivId,wid){
	var skinConfig = dojo.byId(skinDivId);
	com.ibm.mm.builder.utils.layoutUtil.removeAllChildren(skinConfig);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
	if (skins.length > 0) {
        com.ibm.mm.builder.freeLayOutBean.skinObjects = new Array();
		dojo.forEach(skins, function(skin){
			//TODO:BUG1901: No localed title for noSkin and thinSkin in Skin Model
			var skinTitle = skin.getTitle(dojo.locale);
			if(ibmConfig["default.locale"] != dojo.locale && (null == skinTitle || "" == skinTitle)) {
				skinTitle = skin.getTitle(ibmConfig["default.locale"]);
			}				
			if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")){
				com.ibm.mm.builder.freeLayOutBean.skinObjects.push(skin);
				var fathDiv = document.createElement("div");
				skinConfig.appendChild(fathDiv);
				dojo.addClass(fathDiv,"skinPreviewDiv");
				
				var funcName = "com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin(\""+ skin.getID() + "\",\"" +  wid + "\")";
				var funcNameWithKey = "com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkinWithKey(event,\"" + skin.getID() + "\",\"" + wid + "\")";				
				var inner = "<DIV align='center' id='" + wid + "_" + skin.getID();
				inner = inner + "' style='margin-top:4px;' onclick='";
				inner = inner + "eval(" + funcName + ");' onkeypress='";
				inner = inner + "eval(" + funcNameWithKey + ");'>";
				inner = inner + "<IMG tabindex='0' src='" + skin.getPreviewUrl() + "' alt='" + skinTitle + "' orig_title='" + skinTitle + "' title='" + skinTitle + "' id='" + wid + "_" + skin.getID() + "_img" + "'/></DIV>";
				fathDiv.innerHTML = inner;
			}
	    });
    } else {
    	com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.LOGGER.severe("createSkinConfigUI",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CREATE_SKIN_CONF_0);
	}
}

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkinWithKey = function(event, skinvalue, wid){
    var keyCode = event.keyCode;
    if (keyCode != dojo.keys.ENTER) 
        return true;
    com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin(skinvalue, wid);
}	
	/**
	 * chooseSkin is called when click the different skin type in configuration pane
	 * @param {Object} skinvalue
	 */
com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin = function(skinvalue,wid){
	this.containerSkinValue = skinvalue;
	com.ibm.mm.builder.freeLayOutBean.setSelectedSkin(skinvalue);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
    if (skins.length > 0) {
		dojo.forEach(skins, function(skin){
	        if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
				var skinUIDiv = dojo.byId(wid+"_"+skin.getID());
				var img = dojo.byId(wid+"_"+skin.getID() + "_img");
				if (skinvalue == skin.getID()){
					skinUIDiv.parentNode.style.border = "1px solid";
					skinUIDiv.parentNode.style.borderColor = "#739DD7";
					skinUIDiv.parentNode.style.backgroundColor = "#BED2EE";
					var skinTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_SKIN_SELECTED,[img.getAttribute('orig_title')]);
					img.setAttribute('alt',skinTitle);
					img.setAttribute("title",skinTitle);
				}else{
					skinUIDiv.parentNode.style.border = "1px solid";
					skinUIDiv.parentNode.style.borderColor = "#F3F3F3";		
					skinUIDiv.parentNode.style.backgroundColor = "";				
					img.setAttribute('title', img.getAttribute('orig_title'));
					img.setAttribute('alt', img.getAttribute('orig_title'));
				}
	        }
	    });
    } else {
    	com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.LOGGER.severe("chooseSkin",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CHOOSE_SKIN_0);
	}		
}	

/**
 * deprecated
 */
//com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.getFreeFormWidgetFragment = function(widgetId){
//	var widgetSpan = dojo.byId(widgetId).cloneNode(true);
//	var toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.iWidgetContent, widgetSpan);
//    if (toDel.length > 0) {
//		widgetSpan.removeChild(toDel[0]);
//	}	
//	var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetSpan.id);
//	
//	if (skinDiv){
//		var width = dojo._getContentBox(skinDiv).w;
//		var height = dojo._getContentBox(skinDiv).h;
//		if (parseInt(skinDiv.style.left)<0){
//			skinDiv.style.left = "0px";
//		}
//		if (parseInt(skinDiv.style.top)<0){
//			skinDiv.style.top = "0px";
//		}									
//		var locationStyle = "position:absolute;left:" + skinDiv.style.left + ";top:" + skinDiv.style.top + ";width:" + width + "px;height:" + height + "px;";
//		if (skinDiv.style.zIndex != null && skinDiv.style.zIndex != ""){
//			locationStyle = locationStyle + "z-Index:" + skinDiv.style.zIndex + ";";
//		}
//        widgetSpan.setAttribute("locationstyle", locationStyle);			
//	}
//	var widgetFragment = com.ibm.mm.builder.utils.htmlUtil.getElementString(widgetSpan);
//	return widgetFragment;
//}

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.validatePageMetaData = function(metadataObj){
	if (metadataObj.backgroundimagetype && metadataObj.backgroundimage && metadataObj.pagebgcolor && metadataObj.backgroundimageproperty){
		return metadataObj;
	}
	else {
		var defaultItemSet=new com.ibm.mm.builder.iwidget.freeformlayout.defaultSettings();
		return dojo.mixin(defaultItemSet.getPageDefaultSetting(),defaultItemSet.getWidgetDefaultSetting(), metadataObj);
	}
}

com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil._setTitleForColorNode = function(node,perfixTitle){
    var color = dojo.style(node, "backgroundColor");
    var titleSubstuite = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR_PICKER_COLOR_TITLE;
    var title;
    if (color.indexOf("rgb") != -1) {
        var rgb = color.substring(4, color.length - 1);
        var rgbArray = rgb.split(",");
        title = dojo.string.substitute(titleSubstuite, [rgbArray[0], rgbArray[1], rgbArray[2]]);
    }
    else {
        var inHexStr = color.substring(color.length - 6);
        var red = parseInt("0x" + inHexStr.substr(0, 2), 16);
        var green = parseInt("0x" + inHexStr.substr(2, 2), 16);
        var blue = parseInt("0x" + inHexStr.substr(4, 2), 16);
        title = dojo.string.substitute(titleSubstuite, [red, green, blue]);
    }
    
    if (perfixTitle.indexOf(":") == -1) {
		dojo.attr(node, "title", perfixTitle + ":" + title);
	}
	else{
		dojo.attr(node, "title", perfixTitle + title);
	}
}
	

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.configHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.freeformlayout.configHelper"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.freeformlayout.configHelper");



dojo.declare("com.ibm.mm.builder.iwidget.freeformlayout.configHelper",null,{

	_iContext:null,
	
	//WID equals "_"+widgetId+"_". 
	WID:null,
	
	colorPickerHeight:0,
	colorPickerAdjustPosX: 0,
	colorPickerAdjustPosY: 19,
	colorPickerHeight:0,
		
	freeformDnDSource:null,
	
	freeformEditPane:null,
	
	colorPicker:null,
	
	backgroundImageType:"",
	
	applyDSToAll:"0",
	previousDefaultSkin:null,
	
	configIconMouseOverHandler:null,
	configIconMouseOutHandler:null,
	configIconOnFocusHandler:null,
	currentPageMode:"view",
	
	constructor:function(iContext,WID){
		this._iContext = iContext;
		this.WID = WID;
	},
		
	getPageProperties : function(att){
		var pageProp = new Object();
		pageProp.backgroundimagetype = att.getItemValue("backgroundimagetype");
		pageProp.backgroundimage = att.getItemValue("backgroundimage");
		pageProp.backgroundimageproperty = att.getItemValue("backgroundimageproperty");
		pageProp.backgroundimagetransparency = att.getItemValue("backgroundimagetransparency");
		pageProp.pagebgcolor = att.getItemValue("pagebgcolor");
		pageProp.pageborderstyle = att.getItemValue("pageborderstyle");	 
		pageProp.pagebordercolor = att.getItemValue("pagebordercolor");	
		pageProp.pagemargin = att.getItemValue("pagemargin");
		pageProp.pageWidthMode = att.getItemValue("pageWidthMode");
		pageProp.pageWidth = att.getItemValue("pageWidth");
		return pageProp;	
	},
		
	getWidgetProperties : function(att){
		var widgetProp = new Object();
		widgetProp.skin = att.getItemValue("skin");
		widgetProp.applyDefaultSkinToAll = att.getItemValue("applyDefaultSkinToAll");
		return widgetProp;	
	},
	
	showConfigurationIcon:function(){
		if(this.currentPageMode != "edit") return; 
		
		clearTimeout(this.showConfigurationIconTimer);
		this.showConfigurationIconTimer = window.setTimeout(dojo.hitch(this, function(){
			dojo.style(this.WID + "configIcon", "display", "");
		}),40);
	},
	
	hideConfigurationIcon:function(){
		clearTimeout(this.hideConfigurationIconTimer);
		this.hideConfigurationIconTimer = window.setTimeout(dojo.hitch(this, function(){
			dojo.style(this.WID + "configIcon", "display", "none");
		}),40);
	},
		
	setPageProperties : function(/*boolean*/init,pageProperties){
		var bgitype,bgi,bgiproperty,bgitransparency,bgcolor,pageborderstyle,pagebordercolor,pagemargin,skin;	
		if (pageProperties != null) {
			bgitype = pageProperties.backgroundimagetype;
			bgi = pageProperties.backgroundimage;
			bgiproperty = pageProperties.backgroundimageproperty;
			bgitransparency = pageProperties.backgroundimagetransparency;
			bgcolor = pageProperties.pagebgcolor;
			pageborderstyle = pageProperties.pageborderstyle;	 
			pagebordercolor = pageProperties.pagebordercolor;	
			pagemargin = pageProperties.pagemargin;				
		}
		this.backgroundImageType = bgitype;
		var selectNone = false;
		var selectURL = false;
		if (bgitype == "URL"){
			selectURL = true;
			dojo.byId(this.WID + "pageBgImageURL_input").value = bgi;
			var moreProp = dojo.byId(this.WID + "urlMoreProperties");
			moreProp.style.display = "";
		}else{
			selectNone = true;
			var moreProp = dojo.byId(this.WID + "urlMoreProperties");
			moreProp.style.display = "none";
		}	
		var noneTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND_IMAGE + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_NONE;
		dojo.byId(this.WID + "pageBgImageNone").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"BGIType","0","eval(" + this.WID + "iContext.iScope().selectBGINone())",selectNone,noneTitle);
		var urlTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND_IMAGE + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_URL;
		dojo.byId(this.WID + "pageBgImageURL").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"BGIType","1","eval(" + this.WID + "iContext.iScope().selectBGIURL())",selectURL,urlTitle);	
		var bgColorIndicator = dojo.byId(this.WID + "colorIndicator");
		bgColorIndicator.style.backgroundColor = bgcolor;
		com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil._setTitleForColorNode(bgColorIndicator,com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR);
		var borderColorIndicator = dojo.byId(this.WID + "borderColorIndicator");
		borderColorIndicator.style.backgroundColor = pagebordercolor;
		com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil._setTitleForColorNode(borderColorIndicator,com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER_COLOR);
		
		var pageBorderSelection = dojo.byId(this.WID + "pageBorder");
		pageBorderSelection.options[com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex(pageborderstyle)].selected = true;
		// add title dynamically...
		pageBorderSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER + ":" + pageBorderSelection.options[pageBorderSelection.selectedIndex].innerHTML);
		dojo.connect(pageBorderSelection,"onchange",this,function() {
			var pageBorderSelection = dojo.byId(this.WID + "pageBorder");
			var selectedOption = pageBorderSelection.options[pageBorderSelection.selectedIndex];
			pageBorderSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER + ":" + selectedOption.innerHTML);
		});
		var imagePropSelection = dojo.byId(this.WID + "ImagePropSelection");
		imagePropSelection.options[com.ibm.mm.builder.utils.layoutUtil.getImagePropSelectIndex(bgiproperty)].selected = true;
		// add title dynamically...
		imagePropSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROPERTIES + ":" + imagePropSelection.options[imagePropSelection.selectedIndex].innerHTML);
		dojo.connect(imagePropSelection,"onchange",this,function() {
			var imagePropSelection = dojo.byId(this.WID + "ImagePropSelection");
			var selectedOption = imagePropSelection.options[imagePropSelection.selectedIndex];
			imagePropSelection.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROPERTIES + ":" + selectedOption.innerHTML);
		});
		// init the background image Transparency option
		var bTslider = dijit.byId(this.WID + "bgiTransparency");
		if(bTslider && !init){
			bTslider.setValue(bgitransparency);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this.WID,"bgiTransparency","bgiTransparencyValue",bgitransparency,"%","100","5");
		}
		// init page margin option
		var pMslider = dijit.byId(this.WID + "pageMarginSlider");
		dojo.byId(this.WID  + "pageMarginSliderGraphic").style.width = pagemargin + "px";
		if(pMslider && !init){
			pMslider.setValue(pagemargin);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this.WID,"pageMarginSlider","pageMarginSliderValue",pagemargin,"","20","1","pageMarginSliderGraphic");
		}
	},
	
	setWidgetProperties : function(/* boolean */ init, widgetProperties){
		var skin;
		this.previousDefaultSkin = com.ibm.mm.builder.freeLayOutBean.getSelectedSkin();
		if(widgetProperties != null){
			skin = widgetProperties.skin;
		}
		
		var applyAllusingDSTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN;
		var applyAllWidgetTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL;
	
		if (widgetProperties.applyDefaultSkinToAll=="0"){
			this.applyDSToAll = "0";
			dojo.byId(this.WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","1","eval(" + this.WID + "iContext.iScope().selectDSApllyToExisting())",true,applyAllusingDSTitle);
			dojo.byId(this.WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","0","eval(" + this.WID + "iContext.iScope().selectDSApllyToAll())",false,applyAllWidgetTitle);
		}else{
			this.applyDSToAll = "1";
			dojo.byId(this.WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","0","eval(" + this.WID + "iContext.iScope().selectDSApllyToExisting())",false,applyAllusingDSTitle);
			dojo.byId(this.WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.htmlUtil.createRadioButton(this.WID+"DefaultSkinApplyType","1","eval(" + this.WID + "iContext.iScope().selectDSApllyToAll())",true,applyAllWidgetTitle);
		}		
		com.ibm.mm.builder.iwidget.freeformlayout.freeformUtil.chooseSkin(skin,this._iContext.widgetId);	
	},
		
	selectBGINone : function(){
		this.backgroundImageType = "None";
		var moreProp = dojo.byId(this.WID + "urlMoreProperties");
		moreProp.style.display = "none";
	},
		
	selectBGIURL : function(){
		this.backgroundImageType = "URL";
		var moreProp = dojo.byId(this.WID + "urlMoreProperties");
		moreProp.style.display = "";
	},
	
	selectDSApllyToExisting:function(){
		this.applyDSToAll = "0";
	},	
		
	selectDSApllyToAll:function(){
		this.applyDSToAll = "1";
	},		
		
	restoreDefaultConfiguration : function(){
		this.restoreDefaultPageConfiguration();
		this.restoreDefaultWidgetConfiguration();
	},
		
	restoreDefaultPageConfiguration : function(){
		var pageDefaultSetting = com.ibm.mm.builder.freeLayOutBean.getPageDefaultSetting();
		this.setPageProperties(false, pageDefaultSetting);
		var urlRequired = dojo.byId(this.WID + "URLRequired_text");
		urlRequired.style.display="none";
	},
	
	restoreDefaultWidgetConfiguration : function(){
		var widgetDefaultSetting = com.ibm.mm.builder.freeLayOutBean.getWidgetDefaultSetting();
		this.setWidgetProperties(false, widgetDefaultSetting);
	},
			
	showMorePageProperty : function(){
		var morePropText = dojo.byId(this.WID + "pagePropertiesMore");
		var moreProp = dojo.byId(this.WID + "pageMoreProperties");
		if (morePropText.innerHTML == com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS){
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
			dojo.attr(morePropText,"title",com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE);
			moreProp.style.display = "none";
		}else{
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS;
			dojo.attr(morePropText,"title",com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS);
			moreProp.style.display = "";			
		}		
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(moreProp);	
	},
	
	showMorePagePropertyWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) return true;		
		this.showMorePageProperty();
	},
		
	showMoreWidgetProperty : function(){
		var morePropText = dojo.byId(this.WID + "widgetPropertiesMore");
		var moreProp = dojo.byId(this.WID + "widgetMoreProperties");
		if (morePropText.innerHTML == com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS){
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
			moreProp.style.display = "none";
		}else{
			morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_LESS;
			moreProp.style.display = "";			
		}	
	},
	
	/**
	 * toEditMode is called when user click the edit icon
	 */
	showConfiguration : function(){
		this.freeformEditPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
            id: this._iContext.widgetId + "_edit",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PRO_TITLE,
            type: "config",
            nodeWidth: "520px",
            needModeSwitch: true,
            belongId: this._iContext.widgetId,
            containerBackgroundColor: "white",
            hasRightBottomResizer: false,
			closeCallback: function(){ 
				this.destroy();
			}
        })
        
		serviceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: this.freeformEditPane.containerNode
        });
		
		this.freeformEditPane.show();
	},
	
	applySettings : function(){
		var att = this._iContext.getiWidgetAttributes();
		var bgitype,bgi,bgiproperty,bgitransparency,bgcolor,pageborderstyle,pagebordercolor,pagemargin,skin;	
		if (att != null) {
			bgitype = att.getItemValue("backgroundimagetype");
			bgi = att.getItemValue("backgroundimage");
			bgiproperty = att.getItemValue("backgroundimageproperty");
			bgitransparency = att.getItemValue("backgroundimagetransparency");
			bgcolor = att.getItemValue("pagebgcolor");
			pageborderstyle = att.getItemValue("pageborderstyle");	 
			pagebordercolor = att.getItemValue("pagebordercolor");	
			pagemargin = att.getItemValue("pagemargin");	
			skin = att.getItemValue("skin");			
		}
		
		
		//the background color should be applied to the container node when the height of layout increases
		if(bgcolor != "None")
			dojo.byId(this.WID+"container").style.backgroundColor = bgcolor;
		else
			dojo.byId(this.WID+"container").style.backgroundColor = "transparent";
		
		if(pagemargin != "None")
			dojo.byId(this.WID+"freeFormTable").style.padding = pagemargin + "px";
		else 
			dojo.byId(this.WID+"freeFormTable").style.padding = "";
		
		if (pageborderstyle == "none"){
			dojo.byId(this.WID+"freeFormTable").style.border = 0;
		} else {
			dojo.byId(this.WID+"freeFormTable").style.border = pageborderstyle + " " + pagebordercolor;
		}
		
		if (bgitype == "URL"){
			dojo.byId(this.WID+"container").style.backgroundImage = com.ibm.mm.builder.utils.layoutUtil.transformBgIamge(bgi);
			if (bgiproperty == "Scale"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "no-repeat";
				dojo.byId(this.WID+"container").style.backgroundPosition = "left top";
			}
			if (bgiproperty == "RepeatX"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "repeat-x";
				dojo.byId(this.WID+"container").style.backgroundPosition = "left top";
			}
			if (bgiproperty == "RepeatY"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "repeat-y";
				dojo.byId(this.WID+"container").style.backgroundPosition = "left top";
			}
			if (bgiproperty == "Repeat"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "repeat";
			}		
			if (bgiproperty == "Center"){
				dojo.byId(this.WID+"container").style.backgroundRepeat = "no-repeat";
				dojo.byId(this.WID+"container").style.backgroundPosition = "top center";
			}		
			bgitransparency = 100 - bgitransparency;								
			dojo.byId(this.WID+"container").style.opacity = parseInt(bgitransparency)/100;	
			dojo.byId(this.WID+"container").style.filter = "alpha(opacity=" + bgitransparency + ")";
		} else {
			dojo.byId(this.WID+"container").style.backgroundImage = "";
			dojo.byId(this.WID+"container").style.backgroundRepeat = "";
			dojo.byId(this.WID+"container").style.backgroundPosition = "";
			dojo.byId(this.WID+"container").style.filter = "";
			// fix 1713
			// When there is background image, it should not be removed, just set it transparent.
			// When there is no background image, no need to set opacity, and the opacity should only be set once.
			/*
			if(dojo.isIE) {
				if(dojo.byId(this.WID+"container").style.backgroundImage == "none"
						|| dojo.byId(this.WID+"container").style.backgroundImage == "") {
				} else {
					if(dojo.byId(this.WID+"container").style.filter!="")
						dojo.byId(this.WID+"container").style.filter = "alpha(opacity=0)";
				}
					
			} else {
				dojo.byId(this.WID+"container").style.backgroundImage = "none";
			}
			*/
		}
	},
		
	/**
	 * show the page background color picker
	 */	
	showPageBgColorPicker : function(){
		if(this.backgroundImageType=="URL") return;
		var indicatorX = dojo._abs(dojo.byId(this.WID+"colorIndicator")).x;
		var indicatorY = dojo._abs(dojo.byId(this.WID+"colorIndicator")).y;
		var relativeX = indicatorX - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).x + this.colorPickerAdjustPosX;
		var relativeY = indicatorY - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).y + this.colorPickerAdjustPosY;
		this._showColorPalette(this.WID+"colorIndicator",relativeX,relativeY);	
	},
		
	showPageBorderColorPicker : function(){
		if(dojo.byId(this.WID + "pageBorder").selectedIndex == 0)
			return;
		var indicatorX = dojo._abs(dojo.byId(this.WID+"borderColorIndicator")).x;
		var indicatorY = dojo._abs(dojo.byId(this.WID+"borderColorIndicator")).y;
		var relativeX = indicatorX - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).x + this.colorPickerAdjustPosX;
		var relativeY = indicatorY - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).y + this.colorPickerAdjustPosY;
		this._showColorPalette(this.WID+"borderColorIndicator",relativeX,relativeY);
	},
			
	/**
	 * this function is called to show the color picker
	 */
	_showColorPalette : function(indicatorId,posX,posY){
		var rtlColorPaletteAdjust = 0;
		var palette = "8x16";		
		var father = dojo.byId(this.WID+"ColorPaletteContainer");
		var indicator = dojo.byId(indicatorId);
		var colorPaletteX = posX;
		var colorPaletteY = posY;
		if (this.colorPicker!=null){
			this.colorPicker.destroy();
			var colorPalette = document.createElement("div");
			colorPalette.id = this.WID+"ColorPalette";
			father.appendChild(colorPalette);
		}
		this.colorPicker = new com.ibm.mm.builder.widget.MumColorPalette({
			palette:palette,
			indicator:indicatorId
		}, dojo.byId(this.WID+"ColorPalette"));
		if(builderConfig.isBidi){
			var str = this.colorPicker._paletteDims[palette].width;
			str=str.replace(/px/,"");
			rtlColorPaletteAdjust = new Number(str)-19;//18 is size of preview color div box width + a pixel more for looks
		}
		father.style.left = colorPaletteX - rtlColorPaletteAdjust + "px";
		father.style.top = colorPaletteY + "px";
		father.style.zIndex = 888;		
		father.style.display = "";
		this.colorPicker.focus();
	},
		
	cancelInput : function(){
		serviceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {newMode:'view'});
		
		var att = this._iContext.getiWidgetAttributes();
		var skinFromAttr = att.getItemValue("skin");
		com.ibm.mm.builder.freeLayOutBean.setSelectedSkin(skinFromAttr);
	},
		
	validateInput : function(){
		if (this.backgroundImageType == "URL") {
			var urlvalue = dojo.byId(this.WID + "pageBgImageURL_input").value;
			if (dojo.trim(urlvalue) == ""){
				dojo.byId(this.WID + "URLRequired_text").style.display = "";
				return false;
			}else{
				dojo.byId(this.WID + "URLRequired_text").style.display = "none";
				return true;
			}
		}	
		return true;			
	},
		
	/**
	 * saveInput is called when click the save button in configuration pane
	 * things to do in saveInput:
	 * 1. save and update the itemsets in page fragment
	 * 2. save the itemsets in page metadata
	 * 3. hide the configuration pane
	 */
	saveInput : function(){
		if(!this.validateInput()) return;
		
		// update attribute	
		var att = this._iContext.getiWidgetAttributes();
		att.setItemValue("skin", com.ibm.mm.builder.freeLayOutBean.getSelectedSkin(), false);
		att.setItemValue("backgroundimagetype", this.backgroundImageType, false);
		if (this.backgroundImageType === "URL") {
			att.setItemValue("backgroundimage", dojo.byId(this.WID + "pageBgImageURL_input").value, false);
		}
		att.setItemValue("backgroundimageproperty", dojo.byId(this.WID + "ImagePropSelection").value, false);
		
		var bgiTrans = dojo.byId(this.WID + "bgiTransparencyValue").innerHTML;
		var bgiTransAttr = parseInt(bgiTrans) + "";
		att.setItemValue("backgroundimagetransparency", bgiTransAttr, false);
		att.setItemValue("pagebgcolor", dojo.byId(this.WID + "colorIndicator").style.backgroundColor, false);
		att.setItemValue("pageborderstyle", dojo.byId(this.WID + "pageBorder").value, false);
		att.setItemValue("pagebordercolor", dojo.byId(this.WID + "borderColorIndicator").style.backgroundColor, false);
		att.setItemValue("applyDefaultSkinToAll", this.applyDSToAll, false);
		
		var pageMargin = dojo.byId(this.WID + "pageMarginSliderValue").innerHTML;
		var pageMarginAttr = parseInt(pageMargin) + "";
		att.setItemValue("pagemargin", pageMarginAttr, false);
		att.save();
		
		// Change the widget skins on canvas
		this.changeWidgetSkin();
		
		this.previousDefaultSkin = com.ibm.mm.builder.freeLayOutBean.getSelectedSkin();
		
		var jsonStr=com.ibm.mm.builder.utils.iwidgetUtil.dumpItemSetsToJSON(att);
		com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData(dojo.fromJson(jsonStr));
		
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		serviceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {newMode:'view'});
	},
	
	savePageWidthMode : function(pageWidthMode) {
		var att = this._iContext.getiWidgetAttributes();
		att.setItemValue("pageWidthMode", pageWidthMode.mode, false);
		att.setItemValue("pageWidth", pageWidthMode.width, false);
		att.save();
		com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData({
			pageWidthMode: pageWidthMode.mode,
			pageWidth: pageWidthMode.width
		});
	},
	
    changeWidgetSkin: function(){
		dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, this.WID + "container").forEach(function(widgetSpan){
			if (this.applyDSToAll == 1 || (this.applyDSToAll == 0 && 
				widgetSpan.getAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin) === this.previousDefaultSkin)) {
                
				widgetSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, com.ibm.mm.builder.freeLayOutBean.getSelectedSkin());
                
				var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetSpan.id);
				var skinBox = dojo.marginBox(widgetSkin);
                var locationStyle = dojo.string.substitute(
					"position:absolute;width:${w}px;height:${h}px;left:${l}px;top:${t}px;", skinBox);
                if (widgetSkin.style.zIndex)
                    locationStyle += "z-Index:" + widgetSkin.style.zIndex + ";";
                widgetSpan.setAttribute("locationstyle", locationStyle);
				
				
                com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(widgetSpan);
            }
		}, this);
    },	
				
	/**
	 * For Globalization request, set the text on the configuration UI dynamically
	 */
	fillInTheText : function(){
		dojo.parser.parse(this.freeformEditPane.domNode);
		//dojo.byId(this.WID + "restoretitle_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_TITLE;
		//dojo.byId(this.WID + "pagebackgroud_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND;
		dojo.byId(this.WID + "pageproperties_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_PROPERTIES;
		dojo.byId(this.WID + "pagebgimage_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BACKGROUND_IMAGE;
		dojo.byId(this.WID + "pagebgnone_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_NONE;
		dojo.byId(this.WID + "pageBgImageURL_input").title = dojo.byId(this.WID + "pagebgimageurl_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_URL;
		dojo.byId(this.WID + "URLRequired_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_URL_REQUIRED;
		dojo.byId(this.WID + "ImagePropSelection").title = dojo.byId(this.WID + "pagebgimageproperties_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROPERTIES;
		//dojo.byId(this.WID + "pagescale_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_SCALE;
		dojo.byId(this.WID + "pagerepeathorizontal_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_REPEATH;
		dojo.byId(this.WID + "pagerepeatvertical_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_REPEATV;
		dojo.byId(this.WID + "pagerepeatboth_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PRO_REPEATB;
		dojo.byId(this.WID + "pagecenter_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_PROP_CENTER;
		dojo.byId(this.WID + "pagebgimagetrans_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_IMAGE_TRANS;
		//dojo.byId(this.WID + "pageedge_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_EDGE;
		dojo.byId(this.WID + "pageBorder").title = dojo.byId(this.WID + "pageborder_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BORDER;
		dojo.byId(this.WID + "pagemargin_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_MARGIN;
		//dojo.byId(this.WID + "restoredefpagepro_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_PAGE_PROPERTIES;
		dojo.byId(this.WID + "widgtpro_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_PROPERTIES;
		dojo.byId(this.WID + "defskinfornewwidgets_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN;
		dojo.byId(this.WID + "applyAllUsingDS_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN;
		dojo.byId(this.WID + "applyAllWigets_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL;
		
		//dojo.byId(this.WID + "widgetPropertiesMore").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
		//dojo.byId(this.WID + "restoredefpgpro_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_PAGE_PROPERTIES;
		dojo.byId(this.WID + "pgcolor_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR;
		dojo.byId(this.WID + "pagePropertiesMore").title = dojo.byId(this.WID + "pagePropertiesMore").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_MORE;
		
		var widthLimit = dojo.isIE ? "60" : "140";
		dojo.byId(this.WID + "restoredef_text2").value = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_BUTTON;
		dojo.attr(dojo.byId(this.WID+"restoredef_text2"),"widthLimit",widthLimit);
		dojo.byId(this.WID + "restoredef_text3").value = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_BUTTON;
		dojo.attr(dojo.byId(this.WID+"restoredef_text3"),"widthLimit",widthLimit);
		
		var charLimit=dojo.isIE?14:16
		//dojo.byId(this.WID + "save_text").value = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE ;
		//dojo.byId(this.WID + "cancel_text").title = dojo.byId(this.WID + "cancel_text").innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL ;
		// border style
		var borderSelect = dojo.byId(this.WID + "pageBorder");
		com.ibm.mm.builder.utils.layoutUtil.setBorderSelect(borderSelect)
		
		//for a11y
		dojo.byId(this.WID + "restoredef_text2").title = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_PAGE_PROPERTIES;
		dojo.byId(this.WID + "restoredef_text3").title = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_RESTORE_DEFAULT_WIDGET_PROPERTIES;
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(dojo.byId(this.WID+this.currentPageMode));
	},
	
	toChangeFreeFormMode:function(){
		var configdiv = dojo.byId(this.WID+"layoutWidgetConfigDiv");
		if (configdiv){
			if (this.currentPageMode == "edit"){
				if (!dojo.isIE || dojo.isIE > 6) {
					this.configIconMouseOverHandler = dojo.connect(dojo.byId(this.WID+"freeFormTable").parentNode, "onmouseover", this, "showConfigurationIcon");
					this.configIconMouseOutHandler = dojo.connect(dojo.byId(this.WID+"freeFormTable").parentNode, "onmouseout", this, "hideConfigurationIcon");
					this.configIconOnFocusHandler = dojo.connect(dojo.byId(this.WID+"freeFormTable"), "onkeypress", this, "showConfigurationIcon");
				} 
				configdiv.style.display = "";
			}else{	
				if (!dojo.isIE || dojo.isIE > 6) {
					dojo.disconnect(this.configIconMouseOverHandler);
					dojo.disconnect(this.configIconMouseOutHandler);
					dojo.disconnect(this.configIconOnFocusHandler);
				}
				configdiv.style.display = "none";
			}
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.MashupSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.MashupSource"] = true;
/**
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.MashupSource");

/**
 * Mashup auto source, we need the declared source begin with com.ibm.mm to cutermize the avatar
 */
dojo.declare("com.ibm.mm.builder.dnd.MashupSource", dojo.dnd.Source, {
});

dojo.declare("com.ibm.mm.builder.dnd.MashupAutoSource", dojo.dnd.AutoSource, {
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel");









/**
 * This dijit will render the whole toolbox pane including toolbox drawer and menu.
 * todo refactor with menubar in next version.
 * @version 2.0
 */
(function(){
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var toolboxUtil = utils.toolboxUtil;
var iwidgetUtil = utils.iwidgetUtil;
var spaceUtil = utils.spaceUtil;
var themeUtil = utils.themeUtil;
var enablerUtil = utils.enablerUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cwm = com.ibm.mm.builder.coreWidgetsMessages;
var cws = com.ibm.mm.builder.coreWidgetsStrings;

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxPanel",
	[dijit._Widget, dijit._Templated, dijit._Container], {
	
	templateString: '<div class="toolboxPanel"><ul dojoAttachPoint="containerNode"></ul></div>',
	
	/**
	 * Hide the palette
	 */
	hide: function() {
		dojo.fx.wipeOut({node:this.domNode, duration:500}).play();
		this.domNode.style.display = "none";
	},
	/**
	 * Show the palette
	 */
	show: function() {
		if(this.getChildren().length === 0){ this.refresh(); }
		
		dojo.fx.wipeIn({
			node: this.domNode,
			duration: 500,
			onEnd: (dojo.isIE === 6) ? dojo.hitch(this, function(){this.domNode.style.display = "block"}) : null
		}).play();
		 
		if (dojo.isIE === 7) { this.domNode.style.display = "block"; }
	},
	
	/**
	 * render toolbox and assign its item context
	 */
	refresh: function(){
		//destroy all children
		dojo.forEach(this.getChildren(), function(c){
			if (c.destroy) {c.destroy();}
		});
		
		var cs = toolboxUtil.getCategories();
		for(var i=0; i<cs.length && i< 5; i++){
			var entry = new com.ibm.mm.builder.iwidget.toolbox.ToolboxPanelItem({categoryNode: cs[i]});
			this.addChild(entry);
		}
	}
});

/**
 * This dijit will render the drawer including toolbox pop menu
 */
dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxPanelItem", 
	[dijit._Widget, dijit._Templated, dijit._Container], {

	categoryNode: null,
	
	templateString: 
		'<li dojoAttachEvent="onmouseover:_onHover, onmouseout:_onUnHover, onkeypress:_onKeyPress">' +
			'<div dojoAttachPoint="containerNode" class="toolboxPanelItem" tabindex=0 role="button">' +
				'<span dojoAttachPoint="categoryTitle" class="toolboxPanelItemTitle" > </span>' +
				'<img dojoAttachPoint="toolboxPanelItemIcon" class="toolboxPanelItemIcon" alt=""></img>' +
			'</div>' +
		'</li>',
	
    postCreate: function(){
		var title = enablerUtil.getNodeTitle(this.categoryNode);
		var node = this.categoryTitle;
		setTimeout(function(){ //set timeout to wait for the css is applied
			node.innerHTML = htmlUtil.getStrWithLimit(title, node, 132);
			node.title = title;
		}, 0);
		this.toolboxPanelItemIcon.src = builderConfig.builderPath + "/images/toolbox/drawerClosedTriangle.gif";
	},
	
	onFocus:function(){
		this._onHover();
	},
	
	onBlur:function(){
		this._onUnHover();
	},
	
	_onKeyPress: function(e){
		switch (e.keyCode) {
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
				if (this.itemMenu) {
					this.itemMenu._openMyself(e);
				}
				break;
		}
	},
	
    _onHover: function(e){
		dojo.addClass(this.containerNode, "toolboxPanelItemHover");
		this.itemMenu = this.itemMenu || new com.ibm.mm.builder.iwidget.toolbox.ToolboxMenu({
			targetNodeIds:[this.containerNode],
			catagory:this.categoryNode
		});
    },
    
    _onUnHover: function(e){
		if(this.itemMenu && !this.itemMenu.isShowingNow) {
			dojo.removeClass(this.containerNode, "toolboxPanelItemHover");
		}
    },
	
	destroy: function(){
		if(this.itemMenu){
			this.itemMenu.destroyDescendants();
			this.itemMenu.destroy();
		}
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxMenu",
	com.ibm.mm.builder.widget.ExtendableShadowMenu,
{	
	catagory: null,
	offset_x: -1,
	offset_y: 1,
	
	//store tooltip timer
	toolTipTimers: [],
	
	postCreate: function(){
		this.limitedSize = com.ibm.mm.builder.constant.ToolboxPageSize;
        this.inherited(arguments);
        dojo.addClass(this.domNode, "toolboxMenu");
		dojo.subscribe("/dnd/start", this, function(){ dijit.popup.close(this); });
	},
	
	onItemHover: function(item){
		this.focusChild(item);
	},
	
	prepareData: function(){
		
		var _catModel = toolboxUtil.getCatalogModel();
		var _categoryModel = _catModel.getCatalogEntryModel(this.catagory);
		var elemIterator = _categoryModel.iterator();
		elemIterator.setCursorPosition(0);
		while (elemIterator.hasNext()) {
			if (this.loadedEntriesNumber >= com.ibm.mm.builder.constant.ToolboxPageSize) {
				this.hasMorePage = true;
				this.isLastItemShowed = false;
				break;
			}
			var entry = elemIterator.next();
			//cache the widget defs
			toolboxUtil.setWidgetDefinition(entry);
			
			this.addChild(this.createNewItem(entry));
			this.loadedEntriesNumber++;
			this.dndsource = new com.ibm.mm.builder.dnd.MashupAutoSource(this.domNode, {
				singular: true,
				accept: ["none"],
				creator: function(item, hint){
					if (hint == "avatar") {
						return {
							node: new com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuItemAvatar({
								widgetDefId: item
							}).domNode,
							data: item,
							type: ["iWidgetDefinition"]
						};
					}
				}
			});
			this.pages = elemIterator;
		}
		if(this.loadedEntriesNumber === 0 && com.ibm.mm.builder.commonActions.hasHub()){
			this.emptyCatalog = this.emptyCatalog ||
			new com.ibm.mm.builder.iwidget.toolbox.EmptyCatalogMessageBox({
				label: dojo.string.substitute(cws.I_TOOLBOX_NO_CHILD_IN_CATEGORY, 
					["<a href='#' onclick='com.ibm.mm.builder.commonActions.catalogNewWindow(); return false;'>" + cws.I_TOOLBOX_CATEGORY_NAME + "</a>"]
				)
			});
			this.addChild(this.emptyCatalog);
		}
	},
	
	/*
	 * Change the default behavior to design. 
	 */
	_openPopup: function(){
		// summary: open the popup to the side of the current menu item
		this._stopPopupTimer();
		var from_item = this.focusedChild;
		var popup = from_item.popup;

		if(popup.isShowingNow){ return; }
		if(popup._prepareData){ popup._prepareData(); }
		dojo.addClass(from_item.arrowWrapper, "toolboxActionMenuSurround")

		popup.parentMenu = this;
		var self = this;
		dijit.popup.open({
			parent: this,
			popup: popup,
			around: from_item.arrowWrapper,
			orient: this.isLeftToRight() ? {'BL':'TL', 'TL':'BL'} : {'BR':'TR', 'TR':'BR'},
			onCancel: function(){
				// called when the child menu is canceled
				dijit.popup.close(popup);
				from_item.focus();	// put focus back on my node
				self.currentPopup = null;
			}
		});
		this.currentPopup = popup;

		if(popup.focus){
			setTimeout(dojo.hitch(popup, "focus"), 100);
		}
	},
	
	createNewItem:function(page) {
		return new com.ibm.mm.builder.iwidget.toolbox.ToolboxPopupMenuItem({
			id: page.getID(),
			popup: new com.ibm.mm.builder.iwidget.toolbox.ToolboxActionMenu({ entryModel: page, catagory: this.catagory }),
			entryModel: page
		});
	},
	
	onClose: function(){
		this.inherited(arguments)
		dojo.removeClass(this.targetNodeIds[0], "toolboxPanelItemHover");
		toolboxUtil.clearTooltipsTimer(this.toolTipTimers);
		toolboxUtil.clearTooltips();
		
		if(this.hoverBorder) this.hoverBorder.hide();
	}
});
//todo it is possible to replace popitem with normal item to avoid to override _openpop method
dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxPopupMenuItem", dijit.PopupMenuItem, {
	
	templateString:
		'<tr class="dijitReset dijitMenuItem dojoDndItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"'
			+'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onItemClick">'
			+'<td class="dijitReset toolboxPopupMenuItemCell1" waiRole="presentation">'
				+'<img class="dijitMenuItemIcon" dojoAttachPoint="iconNode" alt=""></img>'
			+'</td>'
			+'<td class="dijitReset toolboxPopupMenuItemCell2">'
				+'<img class="warningIconNode" dojoAttachPoint="warningIconNode" alt="" title=""></img>'
				+'<span class="dijitMenuItemLabel" dojoAttachPoint="containerNode"></span>'
			+'</td>'
			+'<td class="dijitReset toolboxPopupMenuItemCell3" waiRole="presentation">'
				+'<div dojoAttachPoint="arrowWrapper" style="display: none" dojoAttachEvent="onclick:_onClick">'
					+'<div class="dijitMenuMode"><img dojoAttachPoint="arrowWrapperIcon" alt=""></img></div>'
					+'<span class="dijitMenuExpandA11y">+</span>'
				+'</div>'
			+'</td>'
		+'</tr>',
	
	postCreate: function(){
		this.imagePath = builderConfig.builderPath + "/images/"
		this.iconNode.src = this.entryModel.getIconURL() || this.imagePath + "generic_widget_icon.gif";
		
		if(builderConfig.isBidi){
			this.arrowWrapperIcon.src = this.imagePath + "context_menu_rtl.png";
			this.iconNode.src = iwidgetUtil.getRtlIconUrl(this.iconNode.src);
		}
		else {
			this.arrowWrapperIcon.src = this.imagePath + "context_menu.png";
		}
		
		this.domNode.setAttribute("dndtype", "iWidgetDefinition");
		this.domNode.setAttribute("dnddata", this.id);
		dijit.setWaiState(this.focusNode, "haspopup", "true");
		this.updateToolboxItemUI();
	},
	
	updateToolboxItemUI: function(){
		this.isTrusted = com.ibm.mm.builder.widget.sandboxEnabled ? (iwidgetUtil.isTrustedWidget(this.entryModel.getID())) : true; 
		
		if (this.isTrusted) {
			this.warningIconNode.src = this.imagePath + "blank.gif";
			dojo.removeClass(this.warningIconNode,"warningIconNode");
		} else {
			this.warningIconNode.src = this.imagePath + "oneui/iconWarning.gif";
			this.warningIconNode.alt = "sandbox";
			dojo.addClass(this.warningIconNode,"warningIconNode");
		}
		
		var title = enablerUtil.getNodeTitle(this.entryModel);
		var limitedLength = ((dojo.isIE) ? 240 : 250) - ((this.isTrusted) ? 0 : 22);
		this.attr('label', htmlUtil.formatBlankSpace(
			htmlUtil.getStrWithLimit(title, this.containerNode, limitedLength)
		));
	},
	
	_onItemClick: function(){
		if(this.popup.isShowingNow){ 
			dijit.popup.close(this.popup);
			dojo.removeClass(this.arrowWrapper, "toolboxActionMenuSurround");
		}
	},
	
	_onClick:function(){
		this.closeTooltip(false);
		this.inherited(arguments);
		var tips = this.getParent().toolTipTimers;
		toolboxUtil.clearTooltipsTimer(tips);
	},
		
	_setSelected: function(selected){
		this.inherited(arguments);	
		if(selected){ return; }
		this.closeTooltip(true);
		var tips = this.getParent().toolTipTimers;
		toolboxUtil.clearTooltipsTimer(tips);
		dojo.removeClass(this.arrowWrapper, "toolboxActionMenuSurround");
		this._hideWarningBorder();
		this.arrowWrapper.style.display = "none";
	},
	
	focus: function(){
		this.inherited(arguments);
		if(!this.isTrusted){
			this.getParent().hoverBorder = this.getParent().hoverBorder 
				|| new com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuUntrustedItemHoverBorder();
			var selfDomNode = this.domNode;
			this.getParent().hoverBorder.show(selfDomNode);
			
			dojo.removeClass(selfDomNode,"dijitMenuItemHover");
			dojo.addClass(selfDomNode,"untrustedDijitMenuItemHover");
		}
		this.arrowWrapper.style.display = "";
		var queryClassName = this.isTrusted ? "dijitMenuItemHover" : "untrustedDijitMenuItemHover";
		dojo.forEach(dojo.query("." + queryClassName, this.domNode.parentNode), function(menuItem){
			if (this.id !== menuItem.id) {
				dojo.removeClass(menuItem, queryClassName);
			}
		}, this);
		var tips = this.getParent().toolTipTimers;
		var self = this;
		tips.push(setTimeout(function(){
			if(!self.tooltip) self.createTooltip();
			if(self.getParent().isShowingNow){
				dijit.popup.open({
					parent: self,
					popup: self.tooltip,
					around:self.domNode,
					orient: self.isLeftToRight() ? {'BR':'BL','BL':'BR'} : {'BL':'BR','BR':'BL'},
					onExecute: function(){
						self.closeTooltip(true);
					},
					onCancel: function(){
						self.closeTooltip(true);
					},
					onClose: function(){
						self.closeTooltip(true);
					}
				});
			}
		}, 1000));
	},
	
	closeTooltip:function(needFocus){
		if(this.tooltip){
			dijit.popup.close(this.tooltip);
			this.tooltip = null;
			if(needFocus){ this.focus(); }
		}
	},
	
	_hideWarningBorder: function(){
		//hide all warning widget border
		if (!this.isTrusted) {
			dojo.removeClass(this.domNode, "untrustedDijitMenuItemHover");
			if (this.getParent().hoverBorder) this.getParent().hoverBorder.hide();
		}
		if(this.tooltipChildren){this.changeTooltipStyle(false);}
	},
	/**
	 * create tooltip for this toolbox item
	 */
	createTooltip: function(){
		if(this.tooltip) { return; }
		var title = enablerUtil.getNodeTitle(this.entryModel);
		var desc = toolboxUtil.getDescription(this.getParent().catagory,this.id);
		if(title + desc != ""){
			var newT = (title.length > 0) ? "<b>" + title + "</b><br/>" : "";
			var tooltipLabel = "<div class='tooltipLabel'>" + newT + desc + "</div>";
			this.tooltip = new com.ibm.mm.builder.iwidget.toolbox.TooltipDialog({
				tipContent: tooltipLabel,
				isSandbox: !this.isTrusted
			});
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxActionMenu", com.ibm.mm.builder.widget.ShadowMenu,{
	
	postCreate: function(){
		this.inherited(arguments);
		dojo.addClass(this.domNode, "toolboxActionMenu");
		this.entryId = this.entryModel.getID();
    },
	
	canShowSandboxSeparator: function(){
		return com.ibm.mm.builder.widget.sandboxEnabled;
	},
	
	canToggleSandbox: function(){
		return !iwidgetUtil.isDisabledSandboxWidget(this.entryId) && !iwidgetUtil.isSandboxWidget(this.entryId) && this.entryModel.confirmSetMetaData() ;
	},
	
	canShowMarkAsTrustedSandBoxMenuItem: function(){
		return com.ibm.mm.builder.widget.sandboxEnabled && !dijit.byId(this.entryId).isTrusted;
	},
	
	canShowMarkAsUntrustedSandBoxMenuItem: function(){
		return com.ibm.mm.builder.widget.sandboxEnabled && dijit.byId(this.entryId).isTrusted;
	},
	
	canRemove: function(){
		return toolboxUtil.getCatalogModel().confirmRemove(this.entryModel);
	},
	
	addWidget: function(){
    	eventService.broadcastEvent("com.ibm.mashups.builder.addWidget", this.entryId);
	},
	
	embedWidget: function(){
		var widgetType = enablerUtil.getNodeTitle(this.entryModel);
		com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog(this.entryId, "widget", widgetType);
	},
	
	removeWidgetDefinition:function(){
		var _catModel = toolboxUtil.getCatalogModel();
        var _entryModel = _catModel.getCatalogEntryModel(this.catagory);
        var myElement = _entryModel.find(this.entryId).start();
        var menuTitle = enablerUtil.getNodeTitle(myElement)
        var warnInfo = htmlUtil.getSubstitute(cwm.I_TOOLBOX_DELETE_WARN_1, [menuTitle]);
        if (confirm(warnInfo)) {
            _entryModel.remove(this.entryId);
            _catModel.commit().start();
			toolboxUtil.getCatalogModel(true);
			eventService.broadcastEvent("com.ibm.mashups.builder.refreshPalette");
        }
	},
	
	toggleMark:function(){
		iwidgetUtil.toggleMarkedSandboxWidget(this.entryId);
		dijit.byId(this.entryId).updateToolboxItemUI();
		this.destroyDescendants();
		this.opened = false;
    },
	
	onOpen: function(){
		if (this.getChildren().length > 0) { return; }
		this.addChild(new com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuEmptyPlaceHolder({ needJoin: true }));
		
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.toolboxAction", this.entryId, null, {
			context: this
		});
		
		for (var i = 0; i < widgetMenus.length; ++i) {
			if (widgetMenus[i].isSeparator) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator())
				continue;
			}
			this.addChild(new dijit.MenuItem({
				label: widgetMenus[i].title,
				iconClass: widgetMenus[i].iconClass,
				disabled: widgetMenus[i].enabled === "disabled",
				onClick: widgetMenus[i].actionCallBackFunction
			}));
		}
		this.addChild(new com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuEmptyPlaceHolder());
		this.inherited(arguments);
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuSeparator", dijit.MenuSeparator, {
	
    templateString: '<tr><td colspan=4><div class="toolboxActMenuSeparator"></div></td></tr>'

});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxActMenuEmptyPlaceHolder", dijit.MenuSeparator, {

	templateString: '<tr><td colspan=4><div class="toolboxActMenuEmptyPlaceHolder" dojoAttachPoint="containerNode"></div></td></tr>',
	
	postCreate:function(){
		if(this.needJoin) this.containerNode.innerHTML = '<div class="toolboxActMenuTopJoinPoint"></div>';
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuItemAvatar", [dijit._Widget, dijit._Templated], {

	templateString: '<div class="dojoDndItem"><img dojoAttachPoint="avatarIcon" /><span dojoAttachPoint="avatarTitle"></div>',
	
	postCreate:function(){
		var d = toolboxUtil.getWidgetDefinition(this.widgetDefId);
		this.avatarIcon.src = d.getIconURL();
		this.avatarTitle.innerHTML = enablerUtil.getNodeTitle(d);
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.ToolboxMenuUntrustedItemHoverBorder",[dijit._Widget, dijit._Templated],{
	
	templateString: '<div class="toolboxMenuUntrustedItemHoverBorder"></div>',
	
	postCreate:function(){
		this._createBorder();
	},
	
	_createBorder: function(){
		this.divs = [];
        for (var i = 0; i < 4; i++) {
            var borderHover = document.createElement("div");
            borderHover.style.display = "none";
            dojo.addClass(borderHover, "toolboxMenuUntrustedItemHoverBorder");
            this.divs.push(borderHover);
            document.body.appendChild(borderHover);
        }
	},
	
	show:function(dom){
		var coords = dojo.coords(dom, true);
		//left, top, right, bottom border
		dojo.marginBox(this.divs[0], {l:coords.x, t:coords.y, w:1, h:coords.h - 1});
		dojo.marginBox(this.divs[1], {l:coords.x, t:coords.y, w:coords.w - 2, h:1});
		dojo.marginBox(this.divs[2], {l:coords.x + coords.w - 2, t:coords.y, w:1, h:coords.h - 1});
		dojo.marginBox(this.divs[3], {l:coords.x, t:coords.y + coords.h - 2, w:coords.w - 2, h:1});
       
		dojo.forEach(this.divs, 'item.style.display="";');
	},
	
	hide:function(){
		dojo.forEach(this.divs, 'item.style.display="none";');
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.EmptyCatalogMessageBox",dijit.MenuItem,{
	
	postCreate:function(){
		this.inherited(arguments);
		this.iconNode.style.display = "none";
		this.arrowWrapper.style.display = "none";
		dojo.addClass(this.containerNode,"emptyCatalogMessage");
	},
	
	_onHover: function(){
		this.getParent().onItemHover(this);
	},
	_setSelected: function(selected){}
});

dojo.declare("com.ibm.mm.builder.iwidget.toolbox.TooltipDialog",dijit.TooltipDialog,{
	autofocus:false,
	
	postCreate:function(){
		dojo.addClass(this.domNode,"toolboxTooltip");
		var tooltipConnector = dojo.query(".dijitTooltipConnector",this.domNode)[0];
		if(this.isSandbox){ 
			dojo.addClass(this.domNode,"sandboxTooltip");
		} 
		dojo.addClass(tooltipConnector,(this.isSandbox ? "sandbox" : "default") +"DijitTooltipConnector"); 
		this.containerNode.innerHTML = this.tipContent;	
	},
		
	orient: function(/*DomNode*/node, /*String*/ aroundCorner, /*String*/ corner){
		var c = this._currentOrientClass;
		if(c){
			dojo.removeClass(this.domNode, c);
		}
		c = "dijitTooltip" + (aroundCorner.charAt(1) == 'L' ? "Left" : "Right");
		dojo.addClass(this.domNode, c);
		this._currentOrientClass = c;
	}
});

})();

}

if(!dojo._hasResource["com.ibm.mm.catalog.hubUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.catalog.hubUtil"] = true;
dojo.provide("com.ibm.mm.catalog.hubUtil");

/**
 * This is a utilities class which helps to get the server address of Mashup Hub from configuration file
 * and get the url of services provided by Mashup Hub.
 */
dojo.declare("com.ibm.mm.catalog.hubUtil", null, {
	
	paramServiceUrl			: '/client/hub/params/entryid/',
	openSearchUrl			: '/atom?',
	securedUrl				: '/secured',
	anonymousUrl			: '/public',
	newFeedUrl				: '/permalink?landing=newfeed',
	newFeedMashupUrl		: '/permalink?landing=newmashup',
	
	/**
	 * Read default Hub server url from configuration file.
	 * This may be changed later.
	 */
    getDefaultHubUrl: function(){
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		return cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.HUB_URL);
	},
	
	/**
	 * get the anonymous access hub url, it's for "goto catalog"
	 */
	getHubAnonymousUrl: function() {	
		return this.getDefaultHubUrl() + this.anonymousUrl;		
	},
	
	/**
	 * get the secure hub url, it's for "goto catalog"
	 */
	getHubSecuredUrl: function() {	
		return this.getDefaultHubUrl() + this.securedUrl;		
	},
	
	/**
	 * Get the parameter service url of MashupHub
	 */
	getHubParameterServiceUrl: function(){
		return [this.getDefaultHubUrl(), this.paramServiceUrl].join("");
	},
	
	/**
	 * get the feed search url of MashupHub
	 */
	getHubOpenSearchUrl: function(){
		return [this.getDefaultHubUrl(), this.openSearchUrl].join("");
	},
	
	/**
	 * get the "Create Feed" url of MashupHub
	 */
	getHubFeedCreationUrl: function(){
		return [this.getHubSecuredUrl(), this.newFeedUrl].join("");
	},
	
	/**
	 * get the "Create Feed Mashup" url of MashupHub
	 */
	getHubFeedMashupCreationUrl: function(){
		return [this.getHubSecuredUrl(), this.newFeedMashupUrl].join("");
	}
	
});

com.ibm.mm.catalog.hubUtil = new com.ibm.mm.catalog.hubUtil();

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.ModeSelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.ModeSelector"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.ModeSelector");









dojo.declare("com.ibm.mm.builder.iwidget.ModeSelector",
	[dijit._Widget, dijit._Templated, dijit._Container],{

	templateString: "<div>"+
					"<div dojoAttachPoint='modeSelectorOuterContainer' class='modeSelector_outerContainer'>" +
						"<div dojoAttachPoint='modeTitle' class='modeSelector_modeTitleDiv' tabindex='0' role='button' wairole='button'>" +
								"<div dojoAttachPoint='modeTitleText' class='modeSelector_modeTitleText'></div>" +
						"</div>" +
						"<div class='modeSelector_modeImage' tabindex='0' dojoAttachPoint='modeSelector_button' role='button' wairole='button' title='Open Mode Selector Menu' aria-label='Open Mode Selector Menu' dojoAttachEvent='onkeypress:_onMenuKeyPress'>" +
								"<img dojoAttachPoint='modeSelector_modeImage_img' alt='Mode Selector button' class='modeSelector_modeImage_img' title=''/>" +
						"</div>" +
					"</div>" +
					"<div dojoAttachPoint='modeSelectorGotoHub' class='modeSelector_iconForHub' >"+
						"<a dojoAttachEvent='onclick:gotoCatalog,onkeypress:_gotoCatalog' role='button' wairole='button' class='modeSelectorLink' dojoattachpoint='gotoHubLink' href='javascript:void(0)' title='Open Catalog in a New Browser' aria-label='Open Catalog in a New Browser'>Open Catalog in a New Browser</a>"+
					"</div>"+
					"</div>",
					
		
	selections: null,
	
	optionTexts:null,
	
	ViewText: null,
	EditText: null,
	SourceText: null,
	CatalogText: null,
	MorePagesText:null,
	
	quickAction: "",
	
	modeSelectorContext:null,
	
	currentPageMode: "View",

	dropDownMenu:null,
	
	userAccessLevel: null,
	
	menuInitialized: false,

	eventService: com.ibm.mashups.services.ServiceManager.getService("eventService"),
		
	constructor:function(prop,node,_iContext){
		this.modeSelectorContext=_iContext;
		if(com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode())
			return;
		// set the default mode
		this.selections = {};
		this.selections.ViewMode = "View";
		this.selections.EditMode = "Edit";
		this.selections.SourceMode = "Source";
		this.selections.WidgetMode = "Widget";
		this.selections.CatalogMode = "Catalog";
		this.selections.MorePagesMode = "MorePages";
		
		// init the UI text, replace with message key when do g18n
		this.ViewText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_VIEW;
		this.EditText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_EDIT;
		this.CatalogText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG;
		this.CatalogNewWindowText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG_NEW_WINDOW;
		this.WidgetCreateText = com.ibm.mm.builder.coreWidgetsStrings.I_CREATE_NEW_WIDGET;
		this.FeedCreationText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_CREATE_FEED;
		this.FeedMashupCreationText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_CREATE_FEEDMASHUP;
		this.SourceText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_SOURCE;
		this.MorePagesText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_SHARE;
		
		
		this.optionTexts = {};
		this.optionTexts[this.selections.ViewMode] = this.ViewText;
		this.optionTexts[this.selections.EditMode] = this.EditText;
		this.optionTexts[this.selections.SourceMode] = this.SourceText;
		this.optionTexts[this.selections.CatalogMode] = this.CatalogText;
		this.optionTexts[this.selections.MorePagesMode] = this.MorePagesText;
		
		this.quickActionTexts = {};
		this.quickActionTexts[this.selections.ViewMode] = this.ViewText;
		this.quickActionTexts[this.selections.EditMode] = this.EditText;
		
		this.event = [];
		
		this.init = function(){
			this.modeTitleText.title = this.EditText;
			dojo.attr(this.modeTitle,'title',this.EditText);
			dojo.attr(this.modeTitle,'aria-label',this.EditText);			
			this.modeTitleText.innerHTML = this.quickActionTexts[this.selections.ViewMode];
			var wView = dojo.coords(this.modeTitleText).w;
			this.modeTitleText.innerHTML = this.quickActionTexts[this.selections.EditMode];
			var wEdit = dojo.coords(this.modeTitleText).w;
			var width = wView > wEdit ? wView : wEdit;
			this.modeTitleText.style.width = width + "px";
		};
		
		var self = this;
		this.onView = function(){
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [self.selections.ViewMode]);
			
			if (self.currentPageMode == self.selections.EditMode) {
				// save page
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.savePage");
				//TODO  need to add wire here
				dojo.publish(com.ibm.mm.builder.eventTopics.Save_Icon_Change, [false]);
				
				com.ibm.mm.builder.commonActions.changePageMode("view");
				self.updateModeSelector(self.selections.ViewMode);
			}
		};
		
		this.onEdit = function(){
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [self.selections.EditMode]);
			if (self.currentPageMode == self.selections.ViewMode) {
				com.ibm.mm.builder.commonActions.changePageMode("edit");
				self.updateModeSelector(self.selections.EditMode);
			}
		};
	},
	
	_gotoCatalog:function(e){
		switch(e.keyCode || e.charCode){
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
			 this.gotoCatalog();
			break;
		}
	},
	
	gotoCatalog:function(){
		com.ibm.mm.builder.commonActions.catalogNewWindow();
	},
	
	initMenu:function(){
		if(this.menuInitialized)
			return;
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.action",currentPageId,null,{context:this});
		
		var modeNode = null;
		for (var i = 0; i < widgetMenus.length; ++i) {
			if(widgetMenus[i].isSeparator){
				this.dropDownMenu.addChild(new com.ibm.mm.builder.iwidget.ModeSelectorMenuSeparator());
				continue;
			}
			var mitem = new com.ibm.mm.builder.iwidget.ModeSelectorMenuItem({
					label: widgetMenus[i].title,
					mode: widgetMenus[i].id,
					iconClass: widgetMenus[i].iconClass,
					disabled:widgetMenus[i].enabled == "disabled",
					onClick: widgetMenus[i].actionCallBackFunction
					});	

			if(widgetMenus[i].id == this.currentPageMode)
					modeNode = mitem;
			this.dropDownMenu.addChild(mitem);
			this.dropDownMenu.entrys.push(mitem);
		}
		this.dropDownMenu.startup();
		this.dropDownMenu.setCurrentMode(modeNode.domNode);
		this.menuInitialized = true;
		this.updatePermissionWithLevel();
	},
	
	createMenu : function(){
		var self = this;	
		var tMenu = new com.ibm.mm.builder.iwidget.ModeSelectorMenu({
				targetNodeIds:[this.modeSelector_modeImage_img],
				leftClickToOpen:true,
				openPosition:"BR",
				prepareData: function(){
					self.initMenu();
				}
			});	
		return tMenu;			
	},
		
	postCreate: function() {
		dojo.attr(this.modeSelector_button,"title",com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_OPEN);
		dojo.attr(this.modeSelector_button,"aria-label",com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_OPEN);
		dojo.attr(this.modeSelector_modeImage_img,"alt",com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_BUTTON);
		var isBidi = builderConfig.isBidi;
		if (com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
			this.modeSelectorOuterContainer.style.display = "none";
			if (!builderConfig.hasHub) {
				this.modeSelectorGotoHub.style.display = "none"
			}
			else {
				this.gotoHubLink.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG_NEW_WINDOW;
				this.gotoHubLink.title = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG_NEW_WINDOW;
			}
			
		}
		else {
			this.modeSelectorGotoHub.style.display = "none"
			imageDom = this.modeSelector_modeImage_img;
			imageDom.src = builderConfig.builderPath + "/images/mode_selector_btn_os.png";
			this.dropDownMenu = this.dropDownMenu || this.createMenu();
			this.init();
			// set the id for automation test 
			this.modeTitle.id = "modeSelector_modetitle_div";
		}
	},
	
	updatePermissionWithLevel:function(accessLevel) {
		if(accessLevel == com.ibm.mm.builder.utils.acModelUtil.VIEW){
			this.userAccessLevel = com.ibm.mm.builder.utils.acModelUtil.VIEW;
		}else{
			this.userAccessLevel = accessLevel ? accessLevel : this.userAccessLevel;
		}
		switch (this.userAccessLevel) {
			case com.ibm.mm.builder.utils.acModelUtil.VIEW:
				if (this.events) {
					dojo.forEach(this.events, dojo.disconnect);
				}
				dojo.addClass(this.modeTitleText, "disabled");
				this.modeTitle.style.cursor = "default";
				break;
				
			case com.ibm.mm.builder.utils.acModelUtil.EDIT:
				if (this.events) {
					dojo.forEach(this.events, dojo.disconnect);
				}
				dojo.removeClass(this.modeTitleText, "disabled");
				this.modeTitle.style.cursor = "pointer";
				this.events = [dojo.connect(this.modeTitle, "onclick", this, "onTitleClick"), dojo.connect(this.modeTitle, "onkeypress", this, "onKeyPress")];
				break;
				
			default:
				dojo.addClass(this.modeTitleText, "disabled");
				this.modeTitle.style.cursor = "default";
				break;
		}
		if (this.menuInitialized) {
			var viewMode = null;
			var editMode = null;
			var self = this;
			dojo.forEach(this.dropDownMenu.entrys, function(item){
				if (self.selections.ViewMode == item.mode) {
					viewMode = item;
				}
				if (self.selections.EditMode == item.mode) {
					editMode = item;
				}
			});
			switch (this.userAccessLevel) {
				case com.ibm.mm.builder.utils.acModelUtil.VIEW:
					/*case com.ibm.mm.builder.utils.acModelUtil.PERSONALIZE:*/
					viewMode.attr('disabled', true)
					editMode.attr('disabled', true)
					break;
					
				case com.ibm.mm.builder.utils.acModelUtil.EDIT:
					viewMode.attr('disabled', false)
					editMode.attr('disabled', false)
					break;
					
				default:
					viewMode.attr('disabled', true)
					editMode.attr('disabled', true)
					break;
			}
		}
	},
	
	onKeyPress: function(evt){
		if(evt && evt.type === "keypress" && (evt.keyCode == dojo.keys.ENTER || evt.charCode == dojo.keys.SPACE)){
			this.onTitleClick();
		}
	},
	
	_onMenuKeyPress:function(evt){
		if(evt && evt.type === "keypress" && (evt.keyCode == dojo.keys.ENTER || evt.charCode == dojo.keys.SPACE)){
			this.dropDownMenu._openMyself(evt);
		}
	},
	
	onTitleClick: function() {
		switch (this.quickAction) {
			case this.selections.ViewMode:
				this.onView();
				break;
			
			case this.selections.EditMode:
				this.onEdit();
				break;
	
			default:
				break;
		}
	},	
	
	_changeQuickAction: function(action) {
		this.quickAction = action;
		this.modeTitleText.innerHTML = this.quickActionTexts[this.quickAction];
		var title = this.optionTexts[this.quickAction];
		this.modeTitleText.title = title;
		dojo.attr(this.modeTitle,'title',title);
		dojo.attr(this.modeTitle,'aria-label',title);
		
		//this._setActionsStyle();
	},
	
	/**
	 * this method will be triggered when the page mode is changed.
	 * mode = "edit" page is in edit mode
	 * mode = "view" page is in view mode
	 * @param {String} mode
	 */
	updateModeSelector: function(mode){
		this.currentPageMode = mode;
		if (mode == this.selections.EditMode){
			this._changeQuickAction(this.selections.ViewMode);
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [this.selections.EditMode]);
		}
		if (mode == this.selections.ViewMode){
			this._changeQuickAction(this.selections.EditMode);
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [this.selections.ViewMode]);			
		};
		
	}
});


dojo.declare("com.ibm.mm.builder.iwidget.ModeSelectorMenu",
	[com.ibm.mm.builder.widget.ShadowMenu],{
	
	postCreate: function(){
		this.inherited(arguments);
		this.entrys = [];		
		dojo.addClass(this.domNode, "modeSelectorMenu");
		dojo.subscribe("com.ibm.mm.catalog.Topics.Mode_Change",this,"changeSelected");
	},
	
	changeSelected: function(mode){
		var self = this;
		dojo.forEach(this.entrys,function(item){
			if(mode === item.mode){
				self.setCurrentMode(item.domNode);
			}
		})
	},
	
	setCurrentMode : function(modeDom) {
		if (this._currentMode) {
			if(this._currentMode == modeDom){
				return;
			}
			var iconNode = dojo.query("td",this._currentMode)[0];
			dojo.removeClass(iconNode, "checked");
			var containerNode = dojo.query("td",this._currentMode)[1];
			dojo.removeClass(containerNode, "checked");
			var describedNode = dojo.query("span",containerNode)[0];
			describedNode.innerHTML = "";				
		}
		var td0Dom = dojo.query("td",modeDom)[0];
		dojo.addClass(td0Dom, "checked");
		var td1Dom = dojo.query("td",modeDom)[1];
		dojo.addClass(td1Dom, "checked");
		var describedNode = dojo.query("span",td1Dom)[0];		
		describedNode.innerHTML =  " " +com.ibm.mm.builder.coreWidgetsStrings.I_MODE_IS_SELECT;		
		this._currentMode = modeDom;
	},
	
	onClose: function(){
		this.inherited(arguments);
		if(this.targetNodeIds && this.targetNodeIds[0]){
			this.targetNodeIds[0].src = builderConfig.builderPath + "/images/mode_selector_btn_os.png";
		}
	}
});

dojo.declare(
	"com.ibm.mm.builder.iwidget.ModeSelectorMenuItem",
	[dijit.MenuItem],
{
	iconSrc: builderConfig.builderPath + "/images/blueCheckmark.gif", 
	mode:"",
	postCreate: function(){
		this.inherited("postCreate",arguments);	
		this.iconNode.src = this.iconSrc;
		this.domNode.setAttribute("mode", this.mode); 
		dojo.addClass(this.iconNode.parentNode,"menuItemCheckMark");	
		var dijitMenuLabelA11y = dojo.doc.createElement("span");
		dojo.addClass(dijitMenuLabelA11y,"access");
		this.containerNode.appendChild(dijitMenuLabelA11y);		
	},
	//rewrite to only change containerNode to disabled 
	_setDisabledAttr: function(/*Boolean*/ value){
		// summary:
		//		Hook for attr('disabled', ...) to work
		//		Enable or disable this menu item.
		this.disabled = value;
		dojo[value ? "addClass" : "removeClass"](this.containerNode, 'dijitMenuItemDisabled');
		dijit.setWaiState(this.focusNode, 'disabled', value ? 'true' : 'false');
	},
	
	focus: function(){
		this.menuItemCheckMark = dojo.query(".menuItemCheckMark",this.domNode)[0];
		this.menuItemCheckMark.style.backgroundImage = "none";
		this.inherited(arguments);
	},
	
	_setSelected: function(selected){
		this.inherited(arguments);
		if(selected){ return; }
		this.menuItemCheckMark.style.backgroundImage = "url("+builderConfig.builderPath+"/images/sideBar.gif)";
	}

	
});

dojo.declare(
	"com.ibm.mm.builder.iwidget.ModeSelectorMenuSeparator",
	[dijit.MenuSeparator],
{
	templateString: '<tr class="dijitMenuSeparator"><td colspan=4>'
			+'<div class="modeSelector_seperator">'
			+'<div class="menuItem"> </div>'
			+'<div class="modeSelector_divider""></div>'
			+'</div>'
			+'</td></tr>',
	
	
	destroy: function(){
		dijit.registry.remove(this.domNode.id)
	},
	
	postCreate: function(){
		dojo.setSelectable(this.domNode, false);
		this.domNode.style.height = "2px";
		this.domNode.style.lineHeight = "2px";			
		this.domNode.style.fontSize = "1pt";
	}	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.SystemWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.SystemWidget"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.SystemWidget");



/**
 * Summary: Define common action in core iwidget level.
 */
dojo.declare("com.ibm.mm.builder.iwidget.SystemWidget", null, {
	
	cws: com.ibm.mm.builder.coreWidgetsStrings,
	cwm: com.ibm.mm.builder.coreWidgetsMessages,
	eventService: com.ibm.mashups.services.ServiceManager.getService("eventService"),
	LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass),
	
	onPageModeChanged: function(iEvent){
		var pl = iEvent.payload;
		if(!pl || pl.length < 2){ return; }
		var modeName = "on"+ pl.charAt(0).toUpperCase() + pl.substring(1).toLowerCase();
		if(this[modeName]) this[modeName]();
	},
	
	getViewRootNode: function(){
		return this._getModeRootNode("view");
	},
	
//	//todo cannot get edit root if edit dom shows in dialog
//	getEditRootNode: function(){
//		return this._getModeRootNode("edit");
//	},
	
	_getModeRootNode: function(mode){
		return dojo.query(".mm_Content." + mode, this.iContext.getRootElement())[0];
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.SystemTemplatedWidget", com.ibm.mm.builder.iwidget.SystemWidget, {

	onView: function(){
		this._loadMode("View");
	},
	
	onEdit: function(){
		this._loadMode("Edit");
	}, 
	
	_loadMode: function(mode){
		//only load once
		if(this[mode + "IsLoaded"]) return;
		
		var methods = {};
		for(var elementName in this){
			if(typeof this[elementName] == "function" && !(elementName in this.constructor.superclass)){
	        	methods[elementName] = dojo.hitch(this, this[elementName]);
			}
		}
		
		var modeNode = this["get"+ mode+"RootNode"]();
		var modeNodeContent = dojo.isIE ? com.ibm.mm.builder.utils.htmlUtil.addMissingQuoteInTitle(modeNode.innerHTML) : modeNode.innerHTML;
		//to make child object access template widget's attach points
		var modeTemplate = new com.ibm.mm.builder.iwidget.TemplatedWidget(
			//mix in the methods of this to support dojoAttachEvent
			dojo.mixin({templateString: modeNodeContent}, methods)
		);
		var attachedNodes = {};
		//mixin attachPoints in context
		for(var nn in modeTemplate){
			var rr = modeTemplate[nn];
    		if ((rr && rr.nodeType == 1 && nn !== "domNode") || rr instanceof dijit._Widget){
        		attachedNodes[nn] = rr;
			}
		}
		dojo.mixin(this, attachedNodes);
		modeNode.innerHTML = "";
		modeNode.appendChild(modeTemplate.domNode);
		this[mode + "IsLoaded"] = true;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TemplatedWidget", [dijit._Widget, dijit._Templated], {
	
	widgetsInTemplate: true,
	
    postMixInProperties: function(){
        var t = this.templateString;
        if (t) {
			this.templateString = dojo.string.substitute(t, com.ibm.mm.builder.coreWidgetsStrings, function(v, k){
				return v || "$ {" + k + "}"; //error if removing the blank space between $ and {
			});
		}
    }
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.GenericLayout"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.GenericLayout"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.GenericLayout");

/**
 * Summary: Define common action in layout widget.
 */
dojo.declare("com.ibm.mm.builder.iwidget.GenericLayout", null, {
	
	layoutWidgetId: "",
	
	widgetContainerId:"",

	//Layout widget common behavior
	getWidgetInstanceId:function(){
		return this.layoutWidgetId;
	},
	
	getWidgetDefURL:function(){
		var iwidgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		return iwidgetUtil.getWidgetXMLURL(this.layoutWidgetId);
	},
	
	//Layout widget common ievent handler
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.changePageMode'
	 * @param {Object} iEvent payload
	 */
	onPageModeChanged: function(iEvent){
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.pageSwitched'
	 * @param {Object} iEvent payload
	 */
    onPageSwitched: function(iEvent){
    },
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.addWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetAdded:function(iEvent){
	},		

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetResized:function(iEvent){
	},

	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.stateChanged'
	 * @param {Object} iEvent payload
	 */	
	onStateChanged:function(iEvent){
	},	
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.moveAction'
	 * @param {Object} iEvent payload
	 */
    onMoveDialogShow: function(iEvent){
    },	
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.resizeAction'
	 * @param {Object} iEvent payload
	 */	
    onResizeDialogShow: function(iEvent){
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.displayWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetDisplayed: function(iEvent){
	},				
		
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.highlightWidget'
	 * @param {Object} iEvent payload
	 */
	onWidgetHighlighted:function(iEvent){
		var widgetId = iEvent.payload;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.widgetContainerId)){
			// highlight the widget
		    var skin = dojo.byId(widgetId).getAttribute("skin");
		    var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		    
		    var coords = dojo.coords(skinDiv);
		    var scroll = dojo._docScroll();
		    var highlightDiv = dojo.byId("mmDiv_highlight");
		    if (!highlightDiv) {
		        highlightDiv = document.createElement("div");
		        highlightDiv.id = "mmDiv_highlight";
		        highlightDiv.style.position = "absolute";
		        highlightDiv.style.backgroundImage = "url('" + builderConfig.builderPath + "/images/widget_highligh_color.png')";
		        document.body.appendChild(highlightDiv);
		    }
		    highlightDiv.style.display = "none";
		    highlightDiv.style.left = (coords.x + scroll.x) + "px";
		    highlightDiv.style.top = (coords.y + scroll.y) + "px";
	        highlightDiv.style.width = coords.w + "px";
	        highlightDiv.style.height = coords.h + "px";
	        // zIndex must smaller than wiring pane
	        highlightDiv.style.zIndex = 780;
		    highlightDiv.style.display = "";			
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.removeWidgetHighlight'
	 * @param {Object} iEvent payload
	 */
	onWidgetHighlightRemoved:function(iEvent){
		var highlightDiv = dojo.byId("mmDiv_highlight");
	    if (highlightDiv){
	    	highlightDiv.style.display = "none";
	    }
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.renameWidget'
	 * @param {Object} iEvent payload
	 */	
	onWidgetRenamed:function(iEvent){
		var widgetInfo = iEvent.payload;
		var widgetId = widgetInfo.id;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.widgetContainerId)){
			com.ibm.mm.builder.utils.iwidgetUtil.saveWidgetInstanceTitle(widgetId,widgetInfo.name, widgetInfo.locale);
			com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(widgetId);				
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.addNewWire'
	 * @param {Object} iEvent payload
	 */
	onNewWireAdded:function(iEvent){
		var wireInfo = iEvent.payload;
		var targetWidgetId = wireInfo.targetWidgetId;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(targetWidgetId,this.widgetContainerId)){
			com.ibm.mm.builder.utils.wireUtil.addWire(wireInfo.sourceWidgetId, wireInfo.sourceEvent, wireInfo.targetWidgetId, wireInfo.targetEvent);
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.removeWire'
	 * @param {Object} iEvent payload
	 */
	onWireRemoved:function(iEvent){
		var wireInfo = iEvent.payload;
		var targetWidgetId = wireInfo.targetWidgetId;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(targetWidgetId,this.widgetContainerId)){
			com.ibm.mm.builder.utils.wireUtil.removeWire(wireInfo.sourceWidgetId, wireInfo.sourceEvent, wireInfo.targetWidgetId, wireInfo.targetEvent);
		}
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.changeSkin'
	 * @param {Object} iEvent payload
	 */
	onWidgetSkinChanged: function(iEvent){
		var para = iEvent.payload;
		var widgetId = para.id;
		var newskin = para.skin;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.widgetContainerId)){
			this.processLocationWhenChangeSkin(widgetId);
			var widgetSpan = dojo.byId(widgetId);
			var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
			if(dojo.isIE || dojo.isSafari){
				var widgetBody = dojo.query(".widgetBody", widgetSkin)[0];
				widgetBody && (widgetBody.onselectstart = null);
			}
			widgetSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, newskin);
			dojo.publish("/com/ibm/mashups/livetext/livetextchanged", [widgetSpan]);
		}		
	},
	
	/**
	 * Handle function for iEvent 'com.ibm.mashups.builder.skinLoaded'
	 * @param {Object} iEvent payload
	 */
	onSkinLoaded: function(iEvent){
		var message = iEvent.payload;
		var widgetId = message.widgetId;
		if (!com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.widgetContainerId))
			return;
		this.postAttachSkin(message);
	},
	
	//skin behavior
	processLocationWhenChangeSkin:function(widgetId){
	},
	
	postAttachSkin:function(message){
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.pagesource.CodeEditor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.pagesource.CodeEditor"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.pagesource.CodeEditor")

dojo.declare("com.ibm.mm.builder.iwidget.pagesource.CodeEditor", null, {
	
	editor: null,
	
	constructor: function(editor){
		this.editor = editor;
	},
	
    // syntax highlighting parser
    _syntaxHighlight: function(flag){
        var ml = this.editor.innerHTML;

        if (!ml) return;
		
		ml = ml.replace(/&gt;/g, '>').replace(/&lt;/g, '<').replace(/<br>/g, '\n').replace(/(<font.*?>)/g, '').
				replace(/(<\/font>)/g, '').replace(/(<\/?\w+[^>]+>)/g, "\f$1\b").replace(/</g, '&lt;').
				replace(/>/g, document.all ? '&gt;<br/>' :  '&gt;').replace(/\n/g, '<br>');
        
		while (true) {
            var idx = ml.indexOf("\f");
            if (idx == -1) break;
            var idx2 = ml.indexOf("\b");
            var s = ml.substring(idx + 1, idx2);
            if (s.indexOf(" ") != -1) {
                s = s.replace(/(\w+)=(\"[^\"]*\")/g, "<font color=\"#7B007B\">$1</font>=<font color=\"#2900FF\">$2</font>");
            }
            ml = ml.substring(0, idx) + '<font color="#397D7B">' + s + '</font>' + ml.substring(idx2 + 1);
        }
        this.editor.innerHTML = ml;
		
    },
	
    setCode: function(code){
        this.editor.innerHTML = code.replace(/\u2009/gi, '');
		this._syntaxHighlight();
    }
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringModel"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringModel");
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.SelectedModel");


/**
 * The Wiring model, contains an model array represent all the widgets data and their relationships
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringModel", null, {

    constructor: function(selectedWidgetId, layouts){
        this.selectedWidgetId = selectedWidgetId;
		var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
       	this.layouts = themeModel.getLayouts();
        this.wiringModel = [];
        this.root = null;
        this.selectedRoot = [];
        this.notRootWidgets = [];
        this.rootArray = [];
        //this.log = com.ibm.mm.builder.wiringCanvas.wiringLog;
    },
    
    setupWiringModel: function(){
        this.setupInitialData();
        //this._setupRootArray();
        this._setupModel();
    },
    
    setupInitialData: function(){
        this.eventsMap = new Object();
        
        var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.selectedWidgetId);
        var incomingWires = widgetWrapper.getWires();
        var eventTargetObject = {};
        eventTargetObject[this.selectedWidgetId] = this.selectedWidgetId;
        
        for (var n = 0; n < incomingWires.length; n++) {
            var incomingWire = incomingWires[n];
            var handleEvent = {};
            handleEvent[incomingWire.SourceEvent] = eventTargetObject;
            //TODO: check because enabler has a bug here, remove source widget will not remove the wire
            if(dojo.byId(incomingWire.getSourceWidgetID()) != null) {
	            this.rootArray.push({
	                sourceWidget: incomingWire.getSourceWidgetID(),
	                sourceEvent: incomingWire.getSourceEventName(),
	                targetWidget: incomingWire.getTargetWidgetID(),
	                targetEvent: incomingWire.getTargetEventName()
	            });
            }
        }
        
        var widgetsArray = this._getOtherWidgets();
        
        for (var i = 0; i < widgetsArray.length; i++) {
            var wires = widgetsArray[i].getWires();
 			
            for (var j = 0, length = wires.length; j < length; j++) {
                if (wires[j].getSourceWidgetID() == this.selectedWidgetId) {
					var wire = wires[j];
                    this.rootArray.push({
                        sourceWidget: wire.getSourceWidgetID(),
                        sourceEvent: wire.getSourceEventName(),
                        targetWidget: wire.getTargetWidgetID(),
                        targetEvent: wire.getTargetEventName()
                    });
                }
            }
        }
        
        
     },
    
    _getOtherWidgets: function(){
        var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(this.layouts);
        
        var len = iwidgetsFromHTMLFragment.length;
        
        var widgetsArray = new Array();
        for (var x = 0; x < len; x++) {
            var id = iwidgetsFromHTMLFragment[x];
            if (id != this.selectedWidgetId) {
                var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
                widgetsArray.push(targetWrapper);
            }
        }
        return widgetsArray;
    },
    /**
     * Find out the root widget from eventService
     */
    _setupRootArray: function(){
        var wires = this.eventsMap;
        
        for (var source in wires) {
            for (var event in wires[source]) {
                for (var target in wires[source][event]) {
                    if (wires[source][event][target].length > 0) {
                        var wireItem = {
                            source: source,
                            event: event,
                            target: target,
                            dataName: ""
                        };
                        this.rootArray.push(wireItem);
                    }
                }
            }
        }
    },
    
    /**
     * set up the model
     */
    _setupModel: function(){
        for (var i = 0, length = this.rootArray.length; i < length; i++) {
            var wire = this.rootArray[i];
            this._addLinkToModel(wire.sourceWidget, wire.targetWidget);
        };
            },
    
    /**
     * Add a link to the model, take
     * @param {Object} sourceId source as parent
     * @param {Object} targetId target as child
     */
    _addLinkToModel: function(sourceId, targetId){
        var sourceModel = this.getModel(sourceId);
        var targetModel = this.getModel(targetId);
        
        sourceModel.children.push(targetId);
        targetModel.parents.push(sourceId);
    },
    
    /**
     * Get the sub model centerd by selected widget
     * @param {String} selectedWidgetId
     * @return {com.ibm.mm.builder.iwidget.wiringscreen.SubWiringModel} sub model
     */
    getSelectedModelFrom: function(selectedWidgetId){
        return new com.ibm.mm.builder.iwidget.wiringscreen.SelectedModel(this, selectedWidgetId);
    },
    
    /**
     * Get the root of the a widget,
     * @param {String} widgetId
     * @return {Array} widget list
     */
    getRootFrom: function(widgetId){
        this.selectedRoot = this.getParents(widgetId);
        if (this.selectedRoot.length == 0) {
            this.selectedRoot.push(this.getModel(widgetId));
        }
        return this.selectedRoot;
    },
    
    /**
     * Get the children of the wiring model
     * @param {String} widgetId
     * @return {Array} the children list
     */
    getChildren: function(widgetId){
        var children = [];
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            if (this.wiringModel[i].id == widgetId) {
                var childrenID = this.wiringModel[i].children;
                for (var j = 0, length = childrenID.length; j < length; j++) {
                    var childInfo = this.getInfo(childrenID[j]);
                    if (childInfo) 
                        children.push(childInfo);
                }
                break;
            }
            else {
                continue;
            }
        }
        return children;
    },
    
    
    /**
     * Get the parent of the wiring model
     * @param {String} widgetId
     */
    getParents: function(widgetId){
        //return [];
        var parents = [];
        
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            if (this.wiringModel[i].id == widgetId) {
                var parentsID = this.wiringModel[i].parents;
                for (var j = 0, length = parentsID.length; j < length; j++) {
                    var parentInfo = this.getInfo(parentsID[j])
                    if (parentInfo) 
                        parents.push(parentInfo);
                }
                break;
            }
            else {
                continue;
            }
        }
        
        return parents;
    },
    
    /**
     * Get the info of the specific wiring model
     * @param {String} widgetId
     * @return {Object} widgetModel
     */
    getInfo: function(widgetId){
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            if (this.wiringModel[i].id == widgetId) {
                return this.wiringModel[i];
            }
            else {
                continue;
            }
        }
    },
    
    /**
     * Get the model info for the specific wiring model, if the model is not exist, create and return
     * @param {Object} widgetId An iWidget Object
     * @return {Object} widgetModel
     */
    getModel: function(/*iWidget Object*/widgetId){
        var widgetSpan = dojo.byId(widgetId);
        //get the widget content node
        var widgetContent = widgetSpan.parentNode;
        
        var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
        var widgetIcon = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceIcon(widgetId);
        var visibility = widgetContent.style.display != "none";
        var widgetModel = this.getInfo(widgetId);
        
        if (widgetModel == null) {
            widgetModel = {
                id: widgetId,
                name: widgetTitle,
                icon: widgetIcon,
                parents: [],
                children: [],
                visibility: visibility,
                position: {
                    x: 0,
                    y: 0
                },
                selected: false
            }
            
            this.wiringModel.push(widgetModel);
        }
        return widgetModel;
    },
    
    _alreadyInWidgetInfoArray: function(widgetInfo, widgetInfoArray){
        var widgetInfoList = [];
        var isAllExist = true;
        if (dojo.isArray(widgetInfo)) {
            widgetInfoList = widgetInfo;
        }
        else {
            widgetInfoList = [widgetInfo];
        }
        for (var i = 0; i < widgetInfoList.length; i++) {
            var widgetInfo = widgetInfoList[i];
            var isExist = false;
            for (var j = 0, length = widgetInfoArray.length; j < length; j++) {
                if (widgetInfoList[i].id == widgetInfoArray[j].id) {
                    isExist = true;
                    break;
                }
            }
            isAllExist = isAllExist && isExist;
        }
        return isAllExist;
    },
    
    _removeFromWidgetInfoArray: function(widgetInfo, widgetInfoArray){
        for (var i = 0, length = widgetInfoArray.length; i < length; i++) {
            if (widgetInfo.id == widgetInfoArray[i].id) {
                widgetInfoArray.splice(i, 1);
            }
        }
    }
});

/**
 * The subclass of Wiring model. used to represent a submodel that related to the selected widget
 * It can compute the depth and width of the model tree, and the coordinate of each widget which will be rendered on the canvas.
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.SelectedModel", com.ibm.mm.builder.iwidget.wiringscreen.WiringModel, {
    constructor: function(parentModel, widgetId){
        this.size = {
            x: 1,
            y: 1
        };//size of the sub model
        this.parentsHeight = [0];
        this.childrenHeight = [0];
        this.levelHeight = []; //array contains the depth of each level in the tree
        this.parentModel = parentModel;
        this.widgetId = widgetId;
        this.wiringModel = [];
        //initial the model 
        this._setModelFrom(widgetId);
    },
    
    /**
     * Initial the selected model from the selected widget
     * @param {String} widgetId
     */
    _setModelFrom: function(widgetId){
        var centerWidgetInfo = this.parentModel.getModel(widgetId);
        if (centerWidgetInfo) {
            this._addSelectedItem(centerWidgetInfo);
            this._addParentsToModel(this.widgetId, 1);
            this._addChildrenToModel(this.widgetId, 1);
            this._computeWiringMapSize();
            this._computeWidgetsPosition();
        }
    },
    /**
     * Check weather the model has link in it
     */
    hasLink: function(){
        //if leveHeight length greater than zero, it has link in it  		
        return (this.levelHeight.length > 1);
    },
    /**
     * Add selected widget to the model
     */
    _addSelectedItem: function(centerWidgetInfo){
        centerWidgetInfo.position.y = 1;
        centerWidgetInfo.position.x = 0;
        centerWidgetInfo.selected = true;
        this.wiringModel.push(centerWidgetInfo);
    },
    
    /**
     * Add related parents to the submodel
     * @param {String} widgetId
     * @param {number} level The distance from the selected widget to this widget, start from 1
     */
    _addParentsToModel: function(widgetId, level){
        var parents = this.parentModel.getParents(widgetId);
        if (parents.length > 0 && this.parentsHeight[level] == null) {
            this.parentsHeight.push(0);
        }
        for (var i = 0, length = parents.length; i < length; i++) {
            if (!this.getInfo(parents[i].id)) {
                parents[i].position.x = -level;
                this.parentsHeight[level]++;
                parents[i].position.y = this.parentsHeight[level];
                parents[i].selected = false;
                this.wiringModel.push(parents[i]);
                //now we only get the directly parents
                //this._addParentsToModel(parents[i].id, level + 1);
            }
        }
    },
    /**
     * Add related child to the submodel
     * @param {String} widgetId
     * @param {number} level The distance from the selected widget to this widget, start from 1
     */
    _addChildrenToModel: function(widgetId, level){
        var children = this.parentModel.getChildren(widgetId);
        if (this._alreadyInWidgetInfoArray(children, this.wiringModel)) {
            return;
        }
        if (children.length > 0 && this.childrenHeight[level] == null) {
            this.childrenHeight.push(0);
        }
        for (var i = 0, length = children.length; i < length; i++) {
            if (!this.getInfo(children[i].id)) {
                children[i].position.x = level;
                this.childrenHeight[level]++;
                children[i].position.y = this.childrenHeight[level];
                children[i].selected = false;
                this.wiringModel.push(children[i]);
                //now we only get the directly children
                //this._addChildrenToModel(children[i].id, level + 1);
            }
        }
    },
    /**
     * Compute the number of number of level and max height of levels of the model tree
     */
    _computeWiringMapSize: function(){
        //compute the max width
        var maxWidth = this.parentsHeight.length + this.childrenHeight.length - 1;
        var maxHeight = 1;
        //find the max height of each level
        for (var i = 1, length = this.parentsHeight.length; i < length; i++) {
            if (this.parentsHeight[i] > maxHeight) {
                maxHeight = this.parentsHeight[i];
            }
        }
        for (var i = 1, length = this.childrenHeight.length; i < length; i++) {
            if (this.childrenHeight[i] > maxHeight) {
                maxHeight = this.childrenHeight[i];
            }
        }
        //record the size of the model
        this.size = {
            x: maxWidth,
            y: maxHeight
        };
        //initial the array according to the max width.
        for (var i = 0; i < maxWidth; i++) {
            this.levelHeight.push(0);
        }
    },
    /**
     * Compute the position of each widget thumb on canvas
     */
    _computeWidgetsPosition: function(){
        var parentsHeight = this.parentsHeight.length - 1;
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            //Shift the position x to the place will be drawn
            this.wiringModel[i].position.x += parentsHeight;
            //record the height of each level
            if (this.levelHeight[this.wiringModel[i].position.x] < this.wiringModel[i].position.y) {
                this.levelHeight[this.wiringModel[i].position.x] = this.wiringModel[i].position.y
            }
        }
    }
});


}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringItem"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringItem");




/**
 * The WiringItem widget, serve as the thumb of each widget in the overview graph
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringItem", [dijit._Widget, dijit._Templated],
{
	
	templateString:"<div class=\"wiringgraphitem\">\n\t<div class=\"wiringgraphitemimage\" dojoAttachPoint=\"imageNode\"></div>\n\t<div class=\"wiringgraphitemname truncatedLable\" dojoAttachPoint=\"textNode\" widthLimit=\"190\" keepBlankSpace=\"\"></div>\n</div>\n",
	
	id:"",
	icon:null,
	name:null,
	originalname:null,
	parents:null,
	children:null,
	visibility:true,
	position: {x:0, y:0},
	maxNameLength: 12,
	cutLength: 9,
	IEMaxNameLength: 12,
	defaultName: "Mashups Widget",
	isSelected:false,
	widgetNameStyleName: "itemname",
	
	postCreate : function(){
		var locale = dojo.locale;
		if(locale && (locale.indexOf("zh-tw") == 0 || 
		   locale.indexOf("ja") == 0 || 
		   locale.indexOf("ko") == 0)){
			this.maxNameLength = 6;
			this.cutLength = 4;
			this.IEMaxNameLength = 6;
		}
		this._setWidgetName();
		this._setWidgetImage();
		this._setImageBackground();
		this.domNode.setAttribute("id", this.id + "_overviewgraph_item");
	},
	
	/**
	 * set the widget name style
	 */
	_setWidgetName: function(){
		this.textNode.innerHTML = this.name || this.defaultName;
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(this.textNode, null, {fontSize:"1.2em",fontWeight:"bold"});
		
		if(this.isSelected){
			this._setWidgetNameStyle("selected");
		}else if(this.visibility){
			this._setWidgetNameStyle("visible");
		}else{
			this._setWidgetNameStyle("hidden");
		}
	},
	
	/**
	 * set the widget name style
	 */
	_setWidgetNameStyle: function(classPrefix){
		com.ibm.mm.builder.utils.htmlUtil.addClass(this.textNode, classPrefix + this.widgetNameStyleName);
	},
	
	/**
	 * set the image of the widget item
	 */
	_setWidgetImage: function(){
		var image = document.createElement("img");
		image.setAttribute("src",this.icon);
		dojo.attr(image, "width", 19);
		dojo.attr(image, "height", 19);
		this.imageNode.appendChild(image);
		this.imageNode.setAttribute("id", this.id + "_overviewgraph_item_icon");
		this.imageNode.title = this.name;
		image.alt = this.name;
	},
	
	/**
	 * set the class as the hidden/visible style
	 */
	_setImageBackground: function(){
		if(this.visibility){
			com.ibm.mm.builder.utils.htmlUtil.addClass(this.imageNode, "visibleitembackground");
		}else{
			com.ibm.mm.builder.utils.htmlUtil.addClass(this.imageNode, "hiddenitembackground");
		}
	},
	
	/**
	 * get the short name of the widget name
	 */
	_getShortName: function(){
		this.originalname = this.name;
		if(!this.name){
			return this.defaultName;
		}
		this.name = dojo.trim(this.name);
		var maxLength = this.maxNameLength;
		if (dojo.isIE) {
			maxLength = this.IEMaxNameLength;
		}
			
		if(this.name.length < maxLength){
			return this.name;
		}else{
			this.name = this.name.substring(0, this.cutLength) + "...";
			return this.name;
		}
	},
	
	/**
	 * get the image dom node
	 */
	getImageNode : function(){
		return this.imageNode;
	}
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas");









/**
 * The WiringCanvas widget. it use the wiring model to render the overview graph in a dialog
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas", [dijit._Widget, dijit._Templated], {

    templateString: "<div class='wiringcanvas'>" +
						"<div DojoAttachPoint='graphContainer' class='graphcontainer'>" +
						"</div>" +
					"</div>",
					
	iContext:null,
	alone:true,
	diagramNode: null,
    
	cws: com.ibm.mm.builder.coreWidgetsStrings,
	
	constructor: function(params){
		//all widget thumb in the canvas
	   	this.itemList = [];
		//the thumb of iwidget already drawed on canvas
	    this.finishedWidgetList = [];
	    this.finishedLinkList = [];
		this.widgetItemQueue = [];
		
        //the default size of thumb and the arrow link 
		this.bgWidth = 82;
		this.itemWidth = 92;
		this.gridHorizontalInterval = 120;
        this.bgHeight = 54;
        this.gridHeight = 2 * this.bgHeight;
        this.gridWidth = this.itemWidth + this.gridHorizontalInterval;
        this.arrowWidth = 12;
        this.arrowHeight = 10;
		
		this.canvasMargin = 0;
		
		this.minCanvasWidth = 420 ;
		this.minCanvasHeight = 100 ;
		this.maxDialogHeight = 5 * this.gridHeight + 10;
		this.lineCornerRadius = 4;
		
		this.dialogSideBarWidth = 0;
		this.dialogBackgroundColor = "#1f1f1f";
		this.dialogTopAndBottom = 20/*bottom height*/ + 36/*top height*/ + 2/*dialog border*/ + 2;
        
		//wiring log information
        this.wiringLog = {
            type: "",
            message: "",
            details: "",
            isShow: false
        }; //type can be : error|info|warn
        
		this.explainText = "";
    },
	
	postCreate: function(){
		this.createDialog();
	},
	
	/**
	 * create and show the wiring graph
	 */
	showGraph:function(){
		this.showLoading();
	    this.createModel();
		var requireString = dojo.require;
		requireString.call(dojo, "dojox.gfx");
		this.hideLoading();
		
		this.createGraph();
	},
	
    /**
	 * Create the dialog contains the wiring graph
	 */
    createDialog: function(){
		this.wiringDialog = new com.ibm.mm.builder.widget.CleanDialog({
			id: this.selectedWidgetId + "_wireGraph",
			nodeWidth: null,  // the content node width, not the dialog, so you can focus on your own node
			nodeHeight: null,    // the content node width, null for autofix
			title: this.cws.I_WIRINGGRAPH_TITLE,
			containerBackgroundColor: null,   // the background color of the container
			displayCloseButton: true,    
			modelDialog:this.alone,
			hasRightBottomResizer: false,
			leftBarWidth: this.dialogSideBarWidth + "px",
			rightBarWidth: this.dialogSideBarWidth + "px",
			containerNodePadding: "0px",
			bottomBarTipColor: "#ff9a9a",
			closeCallback: dojo.hitch(this, function(){
				this.destroy();
			})
        });
		this.wiringDialog.containerNode.appendChild(this.domNode);
		if(!this.alone) {
			var wirePaneDlg = dijit.byId("wireInterface_uniDialog");
			if(wirePaneDlg)
				wirePaneDlg.registerSubDialog(this.selectedWidgetId + "_wireGraph");
		}
    },
	/**
	 * Show a loading tips when computing the diagram
	 */
	showLoading: function(){
		this.loadingNode = document.createElement("div");
		var imgPath = builderConfig.builderPath + "/images/loading.gif";
		this.loadingNode.innerHTML = "<img border='0' src='" + imgPath + "'/>" +
			"<span style='font-size:1.3em;color:white'>" + this.I_WIRINGGRAPH_LOADING_MESSAGE + "</span>";
		
		this.wiringDialog.domNode.style.width = this.minCanvasWidth + "px";
		
		this.graphContainer.appendChild(this.loadingNode);
		this.show();
	},
	/**
	 * Hide the loading tips when computing the diagram
	 */
	hideLoading: function(){
		this.graphContainer.removeChild(this.loadingNode);
	},
    
	/**
	 * create the model of the wiring graph
	 */
    createModel: function(){
        this.parentWiringModel = new com.ibm.mm.builder.iwidget.wiringscreen.WiringModel(this.selectedWidgetId,this.iContext.scope.layouts);
		//Initialize the whole model of all widget
        this.parentWiringModel.setupWiringModel();
		//Create the model from the selected widget
        this.wiringModel = this.parentWiringModel.getSelectedModelFrom(this.selectedWidgetId);
    },
    
	/**
	 * create the the wiring graph and show it
	 */
    createGraph: function(){
		this.wiringDialog.setNodeWidth(this.getCanvasWidth() + "px");
		
		this.wiringDialog.show();
		
		//set up the canvas for drawing graph
		this._setupCanvas();
        
		//get root from the selected widget
        var roots = this.wiringModel.getRootFrom(this.selectedWidgetId);
        
		//loop to make all link in the tree added to the canvas
        for (var i = 0, length = roots.length; i < length; i++) {
			this.widgetItemQueue.push(roots[i]);
        }
		this._drawLinks();
		
		// set the info tip at the bottom
		if (this.wiringModel.hasLink()) {
			this._setupBottomTips();
			this.diagramExplainTextNode.innerHTML = this.explainText;
			dojo.attr(this.diagramNode, "title", this.explainText);
		}
		
		//if any error happening, the dialog will show the error message
        if (this.wiringLog.isShow) {
            com.ibm.mm.enabler.debug.logInlineMessage(this.graphContainer, this.wiringLog.type, this.wiringLog.message, this.wiringLog.details);
        }
	},
	
	/**
	 * set the help information
	 */
	_setupBottomTips: function(){
		var selectedWidget =  this._getWidget({"id":this.selectedWidgetId});
		var widgetName = com.ibm.mm.builder.utils.iwidgetUtil.formatWidgetTitle(selectedWidget.name);
		
		var widgetNameForTip = "<span style='font-style:italic'>" + widgetName + "</span>";
		var bottomTip = dojo.string.substitute(this.cws.I_WIRINGGRAPH_BOTTOM_MESSAGE_BEFORE, [widgetNameForTip]);
		
		//this.wiringDialog.setBottomTip(bottomTip);
		com.ibm.mm.builder.utils.htmlUtil.setClass(this.diagramTip, "wiringgrpahbottomtip");
		this.diagramTip.innerHTML = bottomTip;
		
		//this.wiringDialog.setBottomTipColor("#ff9a9a");
	},
	
	/**
	 * initialize the canvas for drawing the wiring overview graph
	 */
	_setupCanvas: function(){
        var canvasWidth = this.getCanvasWidth();
        var canvasHeight = this.getCanvasHeight();
        
		// setup the diagram node
        this.diagramNode = document.createElement("div");
		dojo.attr(this.diagramNode,"tabindex","0");
        this.diagramExplainTextNode = document.createElement("span");
        this.diagramTip = document.createElement("div");
		
		this.domNode.style.width = canvasWidth + "px";
		//this.domNode.style.height = canvasHeight + "px";
		
		com.ibm.mm.builder.utils.htmlUtil.setClass(this.diagramNode, "diagramnode");
		com.ibm.mm.builder.utils.htmlUtil.setClass(this.diagramExplainTextNode, "diagramExplainTextNode");
		
		//must append on domNode before create surface, or will raise error on IE
		this.graphContainer.appendChild(this.diagramExplainTextNode);
		this.graphContainer.appendChild(this.diagramNode);
		this.graphContainer.appendChild(this.diagramTip);
		
        this.surface = dojox.gfx.createSurface(this.diagramNode, canvasWidth, this._getSurfaceHeight());
    },	
	
    /**
	 * show the wiring graph dialog and set the backgound dark.
	 */
    show: function(){
        this.wiringDialog.show();
    },
    
	/**
	 * draw all the links
	 */
	_drawLinks: function(){
		var tmpItem = this.widgetItemQueue.splice(0,1)[0];
		this._drawLinksFrom(tmpItem);
	},
	/**
	 * Draw the graph from root
	 * @param {Object} source The root node
	 */
    _drawLinksFrom: function(source){
		if(!source)
			return;
        if (!this._isFinishedWidget(source.id)) {
            var children = this.wiringModel.getChildren(source.id);
            //first create the source widget in case it not exit.
			this._getWidgetDomNode(source);
			
			//find all the children of the source and create the link on the canvas 
			for (var i = 0, length = children.length; i < length; i++) {
				var target = children[i];
				if (target) {
					this._createLink(source, target);
				}
			}
			//mark this widget as finished
			this.finishedWidgetList.push(source.id);
			
			//recursion to the chldren of the source
			for (var i = 0, length = children.length; i < length; i++) {
				if (children[i]) {
					this.widgetItemQueue.push(children[i]);
				}
			}
			this._drawLinksFrom(this.widgetItemQueue.splice(0,1)[0]);
        }
    },
    
	/**
	 * Check weather the widget is already created in the graph
	 * @param {number} id The id of the widget
	 */
    _isFinishedWidget: function(id){
        for (var i = 0, length = this.finishedWidgetList.length; i < length; i++) {
            if (this.finishedWidgetList[i] == id) 
                return true;
        }
        return false;
    },
	
	/**
	 * Check weather the link from srouce to target is already created in the graph
	 * @param {number} sourceId The id of the source widget
	 * @param {number} targetId The id of the target widget
	 */
    _isFinishedLink: function(sourceId,targetId){
        for (var i = 0, length = this.finishedLinkList.length; i < length; i++) {
            if (this.finishedLinkList[i].source == sourceId && this.finishedLinkList[i].target == targetId) {
				return true;
			}
        }
        return false;
    },
	
	/**
	 * create link between widgets
	 * @param {Object} source The source widget
	 * @param {Object} target The target widget
	 */
    _createLink: function(source, target){
		if (this._isRelateToSelectedWidget(source, target)) {
			if (this._isFinishedLink(target.id, source.id)) {
				this._createBackArrow(target);
			}
			else {
				this._createForwardLink(source, target);
			}
			this._generateExplainText(source, target);
		}
    },
	
	_generateExplainText: function(source, target){
		this.explainText += dojo.string.substitute(this.cws.I_WIRINGGRAPH_LINK_EXPLAIN_TEXT, [source.name, target.name]);
	},
	
	_isRelateToSelectedWidget:function(source, target){
		if(source.id == this.selectedWidgetId || target.id == this.selectedWidgetId)
			return true;
		return false;
	},
	/**
	 * Create a back arrow on exsit link
	 * @param {Object} target The id of the target widget
	 */
	_createBackArrow: function(target){
		var targetWidgetNode = this._getWidgetDomNode(target);
		var arrowPoint = this._getBackArrowPoint(targetWidgetNode);
        //create the arrow on the surface
		var image = this._createImage(builderConfig.builderPath + (!builderConfig.isBidi) ? "/images/arow_head_left.gif" : "/images/arow_head_left.gif", 
			this.arrowWidth,
			this.arrowHeight
		);
		//move the image of arrow to the right place
        image.setTransform(dojox.gfx.matrix.translate(arrowPoint.x, arrowPoint.y));
	},
	
	_createImage : function(src, width, height) {
		var image = this.surface.createImage({
            width: width,
            height: height,
            src: src
        });
		if (dojo.isSafari != 4) {
			return image;
		}
		else {
			var group = this.surface.createGroup();
			group.add(image);
			return image;
		}
	},
	
	/**
	 * Create forword link
	 * @param {Object} source The id of the source widget
	 * @param {Object} target The id of the target widget
	 */
	_createForwardLink: function(source, target){
		//get the model and create the related widget		
        var sourceWidgetNode = this._getWidgetDomNode(source);
        var targetWidgetNode = this._getWidgetDomNode(target);
		
		//if source is not finished and hasLoop(source, target) draw a loop
		
		//else // a normal link
        //caculate the place
        var startPoint = this._getStartPoint(sourceWidgetNode);
        var endPoint = this._getEndPoint(targetWidgetNode);
        var middlePoints = this._getMiddlePoints(startPoint, endPoint);
		var lineStyle = {
            color: [255, 255, 255],
            width: 2,
            dashstyle: "solid"
        };

		//the start line
		var startX = (!builderConfig.isBidi)?(middlePoints[0].x - this.lineCornerRadius):(middlePoints[0].x + this.lineCornerRadius);
		var path = "M" + startPoint.x + " " + startPoint.y + //start point
        " L" +
        //(middlePoints[0].x - this.lineCornerRadius) +
		(startX) +
        " " +
        middlePoints[0].y //end point
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the first round corner
		//path = "M" + (middlePoints[0].x - this.lineCornerRadius) + " " + middlePoints[0].y +//start point
		path = "M" + (startX) + " " + middlePoints[0].y +
        " S" + 
		 middlePoints[0].x +
        " " +
        middlePoints[0].y +
        " " +
		middlePoints[0].x +
        " " +
        this._getFirstCornerStartY(middlePoints);//end point
		
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the vertical line
		path = "M" + (middlePoints[0].x) + " " + this._getFirstCornerStartY(middlePoints) +//start point
        " L" +
        middlePoints[1].x +
        " " +
        this._getSecondCornerStartY(middlePoints)//end point
		
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the second round corner

		var endX = (!builderConfig.isBidi)?(middlePoints[1].x + this.lineCornerRadius):(middlePoints[1].x - this.lineCornerRadius);
		path = "M" + middlePoints[1].x + " " + this._getSecondCornerStartY(middlePoints) +//start point
        " S" + 
		 middlePoints[1].x +
        " " +
        middlePoints[1].y +
        " " +
		//(middlePoints[1].x + this.lineCornerRadius) +
		endX +
        " " +
        middlePoints[1].y ; 
		
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the end line
		//path = "M" + (middlePoints[1].x + this.lineCornerRadius) + " " + middlePoints[1].y  +//start point
		path = "M" + (endX) + " " + middlePoints[1].y  +//start point
        " L" +
        endPoint.x +
        " " +
        endPoint.y //end point
        
		this.surface.createPath(path).setStroke(lineStyle);
        var arrowPoint = this._getArrowPoint(endPoint);
        //create the arrow on the surface
		var arrowHead = (!builderConfig.isBidi) ? "/images/arow_head.gif" : "/images/arow_head_left.gif";
		var image = this._createImage(builderConfig.builderPath + arrowHead,
			this.arrowWidth,
			this.arrowHeight
		);
		//move the image of arrow to the right place
		// #11717 No need to hack IE6 from 2.0
		//if((dojo.isIE === 6 ) && builderConfig.isBidi){
        //	image.setTransform(dojox.gfx.matrix.translate(arrowPoint.x - this.getCanvasWidth(), arrowPoint.y));
		//}else{
        	image.setTransform(dojox.gfx.matrix.translate(arrowPoint.x, arrowPoint.y));
		//}
		this.finishedLinkList.push({"source":source.id,"target":target.id});
	},
    
	/**
	 * get the Y of end point in the first coner(that is the start point of the vertical line) 
	 * @param {Object} middlePoints
	 */
	_getFirstCornerStartY : function(middlePoints){
		var y = middlePoints[0].y;
		if(middlePoints[0].y < middlePoints[1].y){
			return y + this.lineCornerRadius;
		}else if(middlePoints[0].y > middlePoints[1].y){
			return y - this.lineCornerRadius; 
		}else{
			return y;
		}
	},
	
	/**
	 * get the Y of end point in the second coner(that is the end point of the vertical line) 
	 * @param {Object} middlePoints
	 */
	_getSecondCornerStartY : function(middlePoints){
		var y = middlePoints[1].y;
		if(middlePoints[0].y < middlePoints[1].y){
			return y - this.lineCornerRadius;
		}else if(middlePoints[0].y > middlePoints[1].y){
			return y + this.lineCornerRadius; 
		}else{
			return y;
		}
	},
    
	/**
	 * Create or get(if already exsit) the item(as domNode) of the widget
	 * @param {Object} itemInfo The infomation of the widget
	 */
    _getWidgetDomNode: function(itemInfo){
		return this._getWidget(itemInfo).domNode;
    },
	
	/**
	 * Create or get(if already exsit) the item's image dom node of the widget
	 * @param {Object} itemInfo The infomation of the widget
	 */
	 _getWidgetImageNode: function(itemInfo){
		return this._getWidget(itemInfo).getImageNode();
    },
    
	/**
	 * Create or get(if already exsit) the item(as a widget) of the widget
	 * @param {Object} itemInfo The infomation of the widget
	 */
	_getWidget : function(itemInfo){
		//if has already been created, just return 
        for (var i = 0, length = this.itemList.length; i < length; i++) {
            if (this.itemList[i].id == itemInfo.id) 
                return this.itemList[i].itemWidget;
        }
		
		//if not created yet, create it
        var widgetNode;
		
		dojo.mixin(itemInfo, {"isSelected":(itemInfo.id == this.selectedWidgetId)});
        var item = new com.ibm.mm.builder.iwidget.wiringscreen.WiringItem(itemInfo);
        
		//set the layout variable
        var marginLeft = (this.wiringModel.size.x * this.gridWidth <= this.minCanvasWidth + 80)? 60: 20;
        var marginTop = 20;
        var marginLeftForOne = (this.minCanvasWidth- 100)/2;
        var marginTopForOne = 20;
        var gridWidth = this.gridWidth;
        var gridHeight = this.gridHeight;
		var itemWidth = this.itemWidth;
        
        widgetNode = item.domNode;

		if(!this.wiringModel.hasLink()){
			if(builderConfig.isBidi){
				var x = this.getCanvasWidth() - (itemInfo.position.x * gridWidth + marginLeftForOne) - itemWidth + "px"
			}else{
				var x = (itemInfo.position.x * gridWidth + marginLeftForOne) + "px";
			}
			var y = ((itemInfo.position.y-1) * gridHeight + marginTopForOne) + "px";
			this._setWidgetPositionAndAdd(widgetNode, x, y);
		} else if (this.wiringModel.levelHeight[itemInfo.position.x] == this.wiringModel.size.y) {
			//if the wiring model has no link relationship or the height of this level is the size of the model
			//draw the widget according to the original place
			if(builderConfig.isBidi){
				var x = this.getCanvasWidth() - (itemInfo.position.x * gridWidth + marginLeft) - itemWidth + "px"
			}else{
				var x = (itemInfo.position.x * gridWidth + marginLeft) + "px";	
			}
			var y = ((itemInfo.position.y-1) * gridHeight + marginTop) + "px";
			this._setWidgetPositionAndAdd(widgetNode, x, y);

		}
		else {
			//if the height of this level is not the size of model, compute the height of the grid height
			var interGridHight = ((this.wiringModel.size.y - 1) / this.wiringModel.levelHeight[itemInfo.position.x]) * gridHeight;
			var extendMarginTop = interGridHight / 2;
			if (builderConfig.isBidi) {
				var x = this.getCanvasWidth() - (itemInfo.position.x * gridWidth + marginLeft) - itemWidth + "px"
			}else {
				var x = (itemInfo.position.x * gridWidth + marginLeft) + "px";
			}
			var y = ((itemInfo.position.y - 1) * interGridHight + marginTop + extendMarginTop) + "px";
			
			this._setWidgetPositionAndAdd(widgetNode, x, y);
		}
        
		//add the widget to the itemList
        this.itemList.push({
            id: itemInfo.id,
            itemWidgetNode: widgetNode,
            itemWidget: item
        });
        
        return item;
	},
	
	/**
	 * Create a Highlight div node for the selected widget
	 * @param {Widget} item A wiring item
	 */
    _createHighlightDiv: function(item){
        var highlightDiv = document.createElement("div");
        com.ibm.mm.builder.utils.htmlUtil.setClass(highlightDiv, "hightlightwiringgraphitem");
        highlightDiv.appendChild(item.domNode);
        return highlightDiv;
    },
    
	/**
	 * get the start point of a link
	 * @param {DomNode} node The node of the start item of a link
	 */
    _getStartPoint: function(node){
		//compute the x and y coordinate of the start posion 
		var coords = dojo.coords(node);
        var px = coords.l + this.itemWidth - (this.itemWidth-this.bgWidth)/2;
		if (builderConfig.isBidi) {
			px = px - this.itemWidth;		
		}
				
        var py = coords.t + this.bgHeight / 2;
        return {
            x: px,
            y: py
        };
    },
    
	/**
	 * get the end point of a link
	 * @param {DomNode} node The node of the end item of a link
	 */
    _getEndPoint: function(node){
		//compute the x and y coordinate of the end posion
		var coords = dojo.coords(node);
        var px = coords.l - this.arrowWidth + (this.itemWidth-this.bgWidth)/2;
		if (builderConfig.isBidi) {
			px = px + this.itemWidth;		
		}
		
        var py = coords.t + this.bgHeight / 2;
        return {
            x: px,
            y: py
        };
    },
    
	/**
	 * get the middle points of a link to form the curve
	 * @param {Object} start The coordinate of the start position a link
	 * @param {Object} end The coordinate of the end position a link
	 */
    _getMiddlePoints: function(start, end){
		//compute the x and y coordinate of the middle positions
        var mx = (start.x + end.x) / 2;
		//compute the y coordinate of the first and second middle positions
        var my1 = start.y;
        var my2 = end.y;
        
        return [{
            x: mx,
            y: my1
        }, {
            x: mx,
            y: my2
        }];
    },
    
	 
	/**
	 * get the points of the arrow on a link
	 * @param {Object} end The coordinate of the end position a link
	 */
    _getArrowPoint: function(end){
        return {
            x: end.x,
            y: (end.y - this.arrowHeight/2)
        };
    },
	
	/**
	 * get the points of the back arrow on a link
	 * @param {Object} end The coordinate of the end position a link
	 */
    _getBackArrowPoint: function(node){
		//compute the x and y coordinate of the start posion 
		var startPoint = this._getStartPoint(node);
        return {
            x: startPoint.x - 2,
            y: startPoint.y - this.arrowHeight/2
        };
    },
	
    /**
	 * get the number of a size like "10px"
	 * @param {String} v The size in "10px" format
	 */
    _getPixel: function(v){
        return parseInt(v.substring(0, v.indexOf('p')));
    },
    
	/**
	 * compute the canvas dom node width
	 */
    getCanvasWidth: function(){
		var width = this.wiringModel.size.x * this.gridWidth - 80;
		if(width < this.minCanvasWidth)
			width = this.minCanvasWidth;
        return width;
    },
    
	/**
	 * compute the Dialog(Customized Dialog in Mashups) width
	 */
    getMMDialogWidth: function(){
        var width = (this.getCanvasWidth() + 2*(this.dialogSideBarWidth+1) + 2*this.canvasMargin);
        return (width + "px");
    },
	
	/**
	 * compute the canvas dom node height
	 */
    getCanvasHeight: function(){
		var height = this.wiringModel.size.y * this.gridHeight + 10;
		if (height < this.minCanvasHeight) {
			height = this.minCanvasHeight;
		}
        return height;
    },
	
	/**
	 * compute the Dialog container height
	 */
	_getDialogContainerHeight: function(){
		var height = this.getCanvasHeight();
		if (height > this.maxDialogHeight) {
			height = this.maxDialogHeight;
		}
		return height;
    },
    
	/**
	 * compute the Dialog(Customized Dialog in Mashups) height
	 */
	getMMDialogHeight: function(){
        var height = this._getDialogContainerHeight() + this.dialogTopAndBottom;
		return (height + "px");
    },
	
	/**
	 * compute the svg surface height
	 */
	_getSurfaceHeight: function(){
        return (this.getCanvasHeight() - 4);
    },
	
	/**
	 * add a wiring item dom node on wiring canvas
	 */
    _setWidgetPositionAndAdd: function(widget, left, top){
        widget.style.top = top;
		// #11717 No need to hack on IE6 from 2.0
//		if (dojo.isIE === 6 && builderConfig.isBidi) {
//			widget.style.left = (parseInt(left) - this.getCanvasWidth())+"px";
//		}
//		else {
			widget.style.left = left;
//		}
        this.graphContainer.appendChild(widget);
    },
    
	/**
	 * destroy all the wiring items and dialog
	 */
    destroy: function(){
		for (var i = 0, length = this.itemList.length; i < length; i++) {
			this.itemList[i].itemWidget.destroy();
		}
		this.inherited(arguments);
		this.wiringDialog.destroy();
	},
	
	setContext:function(context){
    	this.iContext = context;
    }
});




}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WirePane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WirePane"] = true;
/**
 @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WirePane");






(function(){
var cws = com.ibm.mm.builder.coreWidgetsStrings;
var htmlUtil = com.ibm.mm.builder.utils.htmlUtil;

dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WirePane", [dijit._Widget, dijit._Templated], {
	
	templateString:"<div dojoAttachPoint='wirePaneDiv' class='mumWirePaneDiv'>\n    <div dojoAttachPoint='prompter' class='mumPrompter'>\n        <div dojoAttachPoint='closer' class='mumPrompterCloser'> </div>\n        <div dojoAttachPoint='contentNode' class='mumPrompterContent'>\n            <div dojoAttachPoint='contentTextNode' tabindex='0' class='mumPrompterContentText'></div>\n            <div dojoAttachPoint='contentLabelNode' class='mumPrompterContentLabel'></div>\n        </div>\n        <div dojoAttachPoint='arrowNode' class='mumPrompterArrow'></div>\n        <div dojoAttachPoint='arrowNodeMid' class='mumPrompterArrowMid'></div>\n        <div dojoAttachPoint='arrowNodeBottom' class='mumPrompterArrowBottom'></div>\n        <div dojoAttachPoint='bottomShadow' class='mumPrompterBottomShadow'></div>\n        <div dojoAttachPoint='lbCornerShadow' class='mumPrompterBottomCornerShadow'></div>\n    </div>\n    <div dojoAttachPoint='wirePaneTitleDiv' class='mumWirePaneTitleDiv' tabindex=0>\n        <div dojoAttachPoint='shadowCenter' class='titleCenterShadow'></div>\n        <div tabindex='0' dojoAttachPoint='wirePaneTitleDivRight' class='mumWirePaneTitleDivSendTabSend'>\n            <div dojoAttachPoint='leftDivOfSendTab' class='mumLeftDivOfSendTabSend'>\n                <div dojoAttachPoint='sendIconDiv' class='mumSendIconDivSend'></div>\n            </div>\n            <div dojoAttachPoint='midDivOfSendTab' class='mumMidDivOfSendTabSend'>\n                <div dojoAttachPoint='sendTextDiv' class='mumSendTextDiv'></div>\n            </div>\n            <div dojoAttachPoint='rightDivOfSendTab' class='mumRightDivOfSendTabSend'>\n                <div dojoAttachPoint='sendWireCountDiv' class='mumSendWireCountDiv'></div>\n            </div>\n        </div>\n        <div tabindex='0' dojoAttachPoint='wirePaneTitleDivLeft' class='mumWirePaneTitleDivReceiveTabSend'>\n            <div dojoAttachPoint='leftDivOfReceiveTab' class='mumLeftDivOfReceiveTabSend'>\n                <div dojoAttachPoint='recIconDiv' class='mumReceiveIconDivSend'></div>\n            </div>\n            <div dojoAttachPoint='midDivOfReceiveTab' class='mumMidDivOfReceiveTabSend'>\n                <div dojoAttachPoint='receiveTextDiv' class='mumReceiveTextDiv'></div>\n            </div>\n            <div dojoAttachPoint='rightDivOfReceiveTab' class='mumRightDivOfReceiveTabSend'>\n                <div dojoAttachPoint='receiveWireCountDiv' class='mumReceiveWireCountDiv'></div>\n            </div>\n        </div>\n        <div dojoAttachPoint='shadowCorner' class='titleCornerShadow'></div>\n    </div>\n    <div dojoAttachPoint='firstAreaTopDiv' class='firstAreaTopDivSend'></div>\n    <div dojoAttachPoint='firstAreaDiv' class='mumFirstAreaDivSend'>\n        <div dojoAttachPoint='firstRightShadow' class='mumSideShadow'></div>\n        <div dojoAttachPoint='wirePaneCurrentWidgetDiv' tabindex=0></div>\n        <div dojoAttachPoint='wirePaneEventsDiv'></div>\n    </div>\n    <div dojoAttachPoint='firstAreaBottomDiv' class='mumFirstAreaBottomDivSend'></div>\n    <div dojoAttachPoint='secondAreaDiv' class='mumSecondAreaDivSend'>\n        <div dojoAttachPoint='secondRightShadow' class='mumSideShadow'></div>\n        <div dojoAttachPoint='wirePaneWidgetsDiv'></div>\n        <div dojoAttachPoint='wirePaneWidgetEventsDiv'></div>\n    </div>\n    <div dojoAttachPoint='secondAreaBottomDiv' class='mumSecondAreaBottomDivSend'></div>\n    <div dojoAttachPoint='bottomDiv' class='bottomDiv'>\n        <div dojoAttachPoint='bottomQmarkDiv' class='bottomQmarkDiv'></div>\n        <input type='submit' dojoAttachPoint='buttonDivGraph' class='lotusFormButton'></input>\n\t\t<input type='submit' dojoAttachPoint='buttonDivDone'class='lotusFormButton'></input>\n    </div>\n</div>\n",
   
	iContext:null,
					
    iwidgetId: "", //the widget uid 
    
    /*
     * The divs for display the corresponding info
     */
	
    wirePane: null,
    
    wirePaneDiv: null,
    
    wirePaneTitleDiv: null,
    
    wirePaneTitleDivLeft: null,
    
    sendIconDiv: null,
	
	sendWireCountDiv: null,
	
	receiveWireCountDiv: null,
    
    wirePaneTitleDivRight: null,
    
    recIconDiv: null,
    
    wirePaneCurrentWidgetDiv: null,
    
    wirePaneEventsDiv: null,
    
    wirePaneWidgetsDiv: null,
    
    wirePaneWidgetEventsDiv: null,
    
    wirePaneAdaptersDiv: null,
    
	firstAreaTopDiv: null,
	
    firstAreaDiv: null,
    
    firstAreaBottomDiv: null,
	
	secondAreaBottomDiv: null,
    
    secondAreaDiv: null,
    
    secondAreaTopDiv: null,
    
    thirdAreaDiv: null,
    
	bottomQmarkDiv: null,
	
    bottomDiv: null,
    
    prompter: null,
    
    widgetObj: null, // cache object, store all the widget-related info(name,icon...)
    
	highlightTimer: null,
    
	selectedEvent: "", //user selected event
	
	selectedWireWidget: "",
	
    //cache object, widgets which have match event
    widgets: null,
    
    //cache object, the events map for current event
    eventsMap: null,
    
    currentType: "", // current tab ( send/receive)
    
    grayTip: null, // The bottom Div for showing the Tip
    
    showPrompter: true,
    
    localized: com.ibm.mashups.enabler.context.Factory.getLocalizedContext(),
    
	/**
	 * current action step
	 * 1: init
	 * 2: choose event
	 * 3: choose widget
	 */
	actionStep: 1, 
	
    clickedWidgetDiv: null, // the clicked widget div in the second pane
    
    allHanWires: 0,
    
    allPubWires: 0,
	
	titleFontStyle: {fontSize:"1.4em", fontFamily:"Arial,Helvetica,sans-serif", fontWeight:"bold"},
	
	defaultFontStyle: {fontSize:"1.4em", fontFamily:"Arial,Helvetica,sans-serif", fontWeight:"normal"},
	
	italicStyle: {fontSize:"1.4em", fontFamily:"Arial,Helvetica,sans-serif", fontWeight:"normal", fontStyle:"italic"},
	
    LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.wiringscreen.WirePane"),
	
	setSelectedEvent: function(eventName){
        this.selectedEvent = eventName;
    },
    
    /** 
     * Init the wire pane, place divs into right position and set the css class
     */
    initWirePane: function(){

		this.grayTip = document.createElement("div");
        this.grayTip.innerHTML = cws.I_WIRING_NO_MATCH_WIDGET;
		
		//Init the 2 main panes, hide the second at first
		dojo.fx.wipeOut({
            node: this.secondAreaDiv,
            duration: 10
        }).play();
		
		this.hideElement(this.secondAreaBottomDiv);
		
		//Init the title (text, icon)
		this.createTitleDiv();
		
		//Current widget's event
        this.wirePaneEventsDiv.setAttribute("id", "wirePaneEventsDiv_id");
        
        this.wirePaneWidgetsDiv.style.display = "none";
        
        dojo.fx.wipeOut({
            node: this.wirePaneWidgetEventsDiv,
            duration: 10
        }).play();
		
		// Buttons on the right-bottom
		dojo.attr(this.buttonDivDone,"title",cws.I_WIRING_DONE);
		dojo.attr(this.buttonDivDone,"value",cws.I_WIRING_DONE);
		dojo.attr(this.buttonDivGraph,"title",cws.I_WIRING_SHOW_GRAPH);
		dojo.attr(this.buttonDivGraph,"value",cws.I_WIRING_SHOW_GRAPH);
		
		dojo.attr(this.wirePaneTitleDivLeft, "title", cws.I_WIRING_TITLE_RECEIVE);
        dojo.attr(this.wirePaneTitleDivRight, "title", cws.I_WIRING_TITLE_SEND);
	
		dojo.connect(this.closer, "onclick", this, "closePrompter");
		
		dojo.connect(this.bottomQmarkDiv, "onclick", this, "onClickQmark");
        
		var closeFun = function(){
			com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
			com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWidgetHighlight", this.iwidgetId);
       }
		
		dojo.connect(this.buttonDivDone, "onclick", this, dojo.hitch(this, closeFun));
		
		dojo.connect(this.buttonDivGraph, "onclick", this, dojo.hitch(this, function(){
            this.onClickShowGraph();
            com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWidgetHighlight", this.iwidgetId);
        }));
		
		if(this.iContext.dialogContainer) {
			dojo.connect(this.iContext.dialogContainer.closeButtonNode, "onclick", this, dojo.hitch(this, closeFun));
		}
		
		//for a11y
		this._insertA11yHint(this.wirePaneTitleDivRight, "Send Tab is selected");
		this._insertA11yHint(this.wirePaneTitleDivLeft, "Use Left/Right arrow key to select Receive Tab");

    },
    
	/**
	 * Util function, hide the div
	 * @param {Object} div
	 */
    hideElement: function(div){
        div.style.display = "none";
    },
    
    showElement: function(div){
        div.style.display = "";
    },
	
    /**
     * Display the prompter on the left side based on action step
     * @param {Object} step // in which step of current action, value should be 1,2,3
     * @param {Object} domNode
     */
    displayPrompter: function(step){
		//save the status for restore from hidden
		this.actionStep = step;
		
        if (this.showPrompter == false) 
            return;
        var align = {
            'TL': 'TR',
            'BR': 'BL'
        }
		
		var properColor = this.getProperColor(step);
		
		var closerNode = dojo.query(".mumPrompterCloser",this.prompter)[0];
		htmlUtil.setClass(closerNode, "mumPrompterCloser");
		dojo.addClass(closerNode, "mumCloser" + properColor);
		
		//for a11y
		closerNode.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + properColor.toLowerCase() + "_closer.png' alt=''>";

		
        var contentNode = dojo.query(".mumPrompterContent", this.prompter)[0]
		htmlUtil.setClass(contentNode, "mumPrompterContent");
		dojo.addClass(contentNode, "mumContent" + properColor);
		
		var arrowNode = dojo.query(".mumPrompterArrow", this.prompter)[0]
		htmlUtil.setClass(arrowNode, "mumPrompterArrow");
		dojo.addClass(arrowNode, "mumPrompterArrow" + properColor);
		
        var textNode = dojo.query(".mumPrompterContentText", this.prompter)[0]
        var labelNode = dojo.query(".mumPrompterContentLabel", this.prompter)[0]
        htmlUtil.setClass(labelNode, "mumPrompterContentLabel");
		
        dojo.addClass(labelNode, "mumLabel" + properColor);
		dojo.attr(textNode,"keepBlankSpace","");
		var truncatedWidgetName = htmlUtil.truncateWord(textNode,this.widgetObj.widgetname,128);
		var truncatedSelectedEvent = htmlUtil.truncateWord(textNode,this.selectedEventTitle,128);
		var truncatedWiredWidget = htmlUtil.truncateWord(textNode,this.selectedWireWidget,128);
		switch (step) {
            case "1":
				if (this.currentType == "Send") {
					textNode.innerHTML = dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_1, [" "+truncatedWidgetName+" "]);
					textNode.title = dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_1, [" "+this.widgetObj.widgetname+" "]);
				} else {
					textNode.innerHTML = dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_1, [" "+truncatedWidgetName+" "]);
					textNode.title = dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_1, [" "+this.widgetObj.widgetname+" "]);
				} 
                labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_1;
                htmlUtil.setClass(this.prompter, "mumPrompterAtEvents");
                break;
            case "2":
				if (this.currentType == "Send"){
               		textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_2,[" "+truncatedSelectedEvent+" "]), textNode, 585);
					textNode.title = dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_2,[" "+this.selectedEventTitle+" "]);
				} else {
					textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_2,[" "+truncatedSelectedEvent+" "]), textNode, 530);
					textNode.title = dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_2,[" "+this.selectedEventTitle+" "]);
				}		
                labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_2;
                htmlUtil.setClass(this.prompter, "mumPrompterAtWidgets");
                break;
            case "3":
				if (this.currentType == "Send"){
                	textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_3,[" "+truncatedWiredWidget+" "," "+truncatedSelectedEvent+" "]), textNode, 585);
					textNode.title = dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_3,[" "+this.selectedWireWidge+" "," "+this.selectedEventTitle+" "])
				} else {
					textNode.innerHTML = htmlUtil.getStrWithLimit(dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_3,[" "+truncatedWiredWidget+" "," "+truncatedWidgetName+" "]), textNode, 530);
					textNode.title = dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_3,[" "+this.selectedWireWidge+" "," "+this.widgetObj.widgetname+" "]);	
				}	
					labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_3;
                htmlUtil.setClass(this.prompter, "mumPrompterAtWidgetEvents");
                break;
        }
		this.prompter.style.visibility = "visible"
		 
//		var borderTop = htmlUtil.getCurrentStyle(this.prompter,'border-top-width');
//		var borderBottom = htmlUtil.getCurrentStyle(this.prompter,'border-bottom-width');
		
		var coord = dojo.coords(this.prompter);
		 
		var coordArrow = dojo.coords(this.arrowNode);
		 
		var temp = coord.h - coordArrow.h + coordArrow.t;
		 
		this.arrowNodeMid.style.height = temp + "px"
    },
    
    closePrompter: function(){
        this.showPrompter = false;
        this.prompter.style.visibility = "hidden";
		this.bottomQmarkDiv.style.visibility = "visible"
    },
    
	onClickQmark: function(){
		this.showPrompter = true;
		this.prompter.style.visibility = "visible";
		this.displayPrompter(this.actionStep);
		this.bottomQmarkDiv.style.visibility = "hidden"
	},
	
	/**
	 * This function will be invoked when user click the "Show Graph" button 
	 * Hide the wire interface and display the wiring graph
	 */
	onClickShowGraph: function() {
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayWireGraph", this.iwidgetId);  	
//		this.iContext.scope.displayWireGraph(this.iwidgetId,true);
	},
    /**
     * Get the proper color name based on current tab and action step
     * @param {Object} step: action step, should be 1/2/3
     * @return Blue or Green
     */
    getProperColor: function(step){
        switch (step) {
            case "1":
                if (this.currentType == "Send") 
                    return "Green"
                else 
                    return "Blue"
                break;
            case "2":
                if (this.currentType == "Send") 
                    return "Blue"
                else 
                    return "Green"
                break;
            case "3":
                if (this.currentType == "Send") 
                    return "Blue"
                else 
                    return "Green"
                break;
        }
    },
    /**
     * Util function
     * Get the proper text for event name display
     * @param {Object} name
     */
    getProperName: function(name){
        var result = "<span title='" + name + "' >";
        if (name.length >= 18) {
            result = result + name.substring(0, 14) + "...";
        }
        else 
            result = result + name;
        result = result + "</span>";
        return result;
    },
	
	/**
     * Util function
     * Get the proper text for widget title display
     * @param {Object} name
     */
    getProperTitle: function(name,len){
        var result = "<span tabindex='0' title='" + name + "' >";
		if(len == null)
			len = 25;
        if (name.length >= len) {
            result = result + name.substring(0, len - 4) + "...";
        }
        else 
            result = result + name;
        result = result + "</span>";
        return result;
    },
	
	/**
     * Util function
     * Get the proper text for combined common data type
     * @param {Object} type
     */
	getShownType:function(type){
		var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
		return checker.getTypeLabel(type);	
	},
	
    /**
     * Own wipeIn function to avoid the "height=auto" problem of dojo.fx.wipeIn
     * @param {Object} args
     */
	wipeIn:function( args){
		args.node = dojo.byId(args.node);
		var node = args.node, s = node.style, o;
	
		var anim = dojo.animateProperty(dojo.mixin({
			properties: {
				height: {
					// wrapped in functions so we wait till the last second to query (in case value has changed)
					start: function(){
						// start at current [computed] height, but use 1px rather than 0
						// because 0 causes IE to display the whole panel
						o = s.overflow;
						s.overflow="hidden";
						if(s.visibility=="hidden"||s.display=="none"){
							s.height="1px";
							s.display="";
							s.visibility="";
							return 1;
						}else{
							var height = dojo.style(node, "height");
							return Math.max(height, 1);
						}
					},
					end: function(){
						return node.scrollHeight;
					}
				}
			}
		}, args));
	
		dojo.connect(anim, "onEnd", function(){ 
			//s.height = "auto";
			s.overflow = o;
		});
	
		return anim; // dojo._Animation
	},

    /**
     * Util function
     * Generate a div element with the given css class
     * @param {string} className : the css class name for the div
     */
    createDivWithClass: function(className){
        var tempDiv = document.createElement("div");
        dojo.addClass(tempDiv, className);
        return tempDiv;
    },
    
    /**
     * Adjust the div class when switch between "Send" and "Receive" model
     */
    adjustDivsStyle: function(){
		this.adjustTitleDiv();
		htmlUtil.setClass(this.firstAreaTopDiv, "firstAreaTopDiv" + this.currentType);
        htmlUtil.setClass(this.firstAreaDiv, "mumFirstAreaDiv" + this.currentType);
        htmlUtil.setClass(this.secondAreaDiv, "mumSecondAreaDiv" + this.currentType);
        htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDiv" + this.currentType);
        htmlUtil.setClass(this.secondAreaBottomDiv,"mumSecondAreaBottomDiv" + this.currentType);
		this.hideElement(this.secondAreaBottomDiv);	
    },
    
    /**
     * This function will be invoke when user click on the left(receive) tab on wire pane title
     * Switch between "Send" and "Receive" and change the pane content
     */
    onClickTitlePaneLeft: function(e){
        if (this.currentType == "Send") {
            this.currentType = "Receive";
            
            htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivLeftClick");
            htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivSendTab");
            
            htmlUtil.setClass(this.sendIconDiv, "mumSendIconDiv");
            htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDivClick");
            
            this.adjustDivsStyle();
            
            this.createReceiveEventsDiv();
            dojo.fx.wipeOut({
                node: this.secondAreaDiv,
                duration: 10
            }).play();
			this.hideElement(this.secondAreaBottomDiv);
			
 			//for a11y
			this._insertA11yHint(this.wirePaneTitleDivLeft, "Receive Tab is selected");
			this._insertA11yHint(this.wirePaneTitleDivRight, "Use Left/Right arrow key to select Send Tab");
 
        }
		this.displayPrompter("1");
    },
    onKeyPresTitlePane:function(e){
    	switch(e.keyCode){
			case dojo.keys.LEFT_ARROW:	
				this.onClickTitlePaneLeft(e);
			break;
			case dojo.keys.RIGHT_ARROW:	
				this.onClickTitlePaneRight(e);
			break;
		}
    },
    
    /**
     * This function will be invoke when user click on the right(send) tab on wire pane title
     * Switch between "Send" and "Receive" and change the pane content
     */
    onClickTitlePaneRight: function(e){
        if (this.currentType == "Receive") {
            this.currentType = "Send";
            
            htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivReceiveTab");
            htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivRightClick");
            
            htmlUtil.setClass(this.sendIconDiv, "mumSendIconDivClick");
            htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDiv");
            
            this.adjustDivsStyle();
            
            this.createSendEventsDiv();
            //wipe out other panes, only remain the first event pane
            dojo.fx.wipeOut({
                node: this.secondAreaDiv,
                duration: 10
            }).play();
			this.hideElement(this.secondAreaBottomDiv);

			//for a11y
			this._insertA11yHint(this.wirePaneTitleDivRight, "Send Tab is selected");
			this._insertA11yHint(this.wirePaneTitleDivLeft, "Click to select Receive Tab");
        }
		this.displayPrompter("1")
    },
    
	
	onMouseOverCurrentWidget: function(e) {
		var widgetDiv = e.currentTarget;
		dojo.addClass(widgetDiv,"mumMouseOverCurrentWidget" + this.currentType)
	},
	
	onMouseOutCurrentWidget: function(e) {
		var widgetDiv = e.currentTarget;
		dojo.removeClass(widgetDiv,"mumMouseOverCurrentWidget" + this.currentType)
	},
	onKeyPressEvent:function(e){
		switch(e.keyCode){
			case dojo.keys.ENTER:
			  this.onClickEvent(e);
			break;
		}
	},
    /**
     * This function will be invoke when user choose one event
     * Display the second widgets pane based on the selected event
     */
    onClickEvent: function(e){
    
        var eventDiv = e.currentTarget;
        
        //Display the return image
        var returnImgs = dojo.query(".mumEventDivReturnImg" + this.currentType, eventDiv);
        returnImgs[0].style.visibility = "visible";
        
        /*
         * Hide all other events
         */
        if (eventDiv.getAttribute("isClicked") != "true") {
        
            var eventName = eventDiv.getAttribute("eventName");
            this.selectedEvent = eventName;
			this.selectedEventTitle = eventDiv.getAttribute("eventTitle");
            this.widgets = this.eventsMap[this.currentType + "-" + eventName];
            
            //fade all other events
            var otherEvents = dojo.query(".mumEventDiv", this.wirePaneEventsDiv);
            if (otherEvents.length > 1) {
                for (var i = 0; i < otherEvents.length; i++) {
                    var event = otherEvents[i];
                    if (event.getAttribute("eventName") != eventName) {
                        dojo.fx.combine([dojo.fadeOut({
                            node: event,
                            duration: 1000
                        }), dojo.fx.wipeOut({
                            node: event,
                            duration: 1000
                        })]).play();
                        event.setAttribute("isClicked", "false");
                    }
                }
            }
            eventDiv.setAttribute("isClicked", "true");
			htmlUtil.setClass(eventDiv,"mumEventDivClicked" + this.currentType);
            //new event , hide the widget's event pane
            var matchWidgetCount = this.createWidgetsDiv();
            
            //show new link pane
            //htmlUtil.setClass(this.firstAreaDiv, "mumFirstAreaDivClick" + this.currentType);
			htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDivExpand" + this.currentType);
            this.showElement(this.secondAreaBottomDiv);
            
            dojo.fx.wipeIn({
                node: this.secondAreaDiv,
                duration: 1000
            }).play();
            this.showElement(this.secondAreaBottomDiv);
			this.displayPrompter("2");
            
        }
    },
    onKeyPressEventReturnImg:function(e){
    	switch(e.keyCode){
    		case dojo.keys.ENTER:
    		 this.onClickEventReturnImg(e);
    		break;
    	}    	 	
    },
    /**
     * This function will be invoke when user click on the return image of one event.It will
     * 1. hide the return image
     * 2. display all other events
     * 3. hide the second pane
     * @param {event} e: the "onclick" event of the return image in selected event's div
     */
    onClickEventReturnImg: function(e){
    
        var eventDiv = e.currentTarget.parentNode;
		
		//restore to the org status, need to judget whether this event has wired with other event or not.
        htmlUtil.setClass(eventDiv,"mumEventDiv");
		var countDiv = dojo.query(".mumEventDivCount" + this.currentType, eventDiv);
        var count = parseInt(countDiv[0].innerHTML);
        if(count > 0)
        	dojo.addClass(eventDiv,"mumEventDivWired");
				
        if (eventDiv.getAttribute("isClicked") == "false") {
            return;
        }
        //hide the return image and the separator bar
        var returnImg = e.currentTarget;
        returnImg.style.visibility = "hidden";
        
        //fade all other events
        var otherEvents = dojo.query(".mumEventDiv", this.firstAreaDiv);
        if (otherEvents.length == 1) {
            otherEvents[0].setAttribute("isClicked", "false");
            dojo.stopEvent(e);
        }
        else 
            if (otherEvents.length > 1) {
                for (var j = 0; j < otherEvents.length; j++) {
                    var event = otherEvents[j];
                    dojo.fx.combine([dojo.fadeIn({
                        node: event,
                        duration: 1000
                    }), this.wipeIn({
                        node: event,
                        duration: 1000
                    })]).play();
                    event.setAttribute("isClicked", "false");
                }
                dojo.stopEvent(e);
            }
		
        htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDiv" + this.currentType);
		
        dojo.fx.wipeOut({
            node: this.secondAreaDiv,
            duration: 500
        }).play();
		this.hideElement(this.secondAreaBottomDiv);
		dojo.fx.wipeOut({
            node: this.wirePaneWidgetEventsDiv,
            duration: 10
        }).play();
		
		this.displayPrompter("1")
    },
    onKeyPressWidget:function(e){
    	switch(e.keyCode){
    		case dojo.keys.ENTER:
    			this.onClickWidget(e);
    		break;
    	}
    },
    /**
     * This function will be invoked when user click on one widget in the second area
     * @param {Event} e: the event object of the widget div's "onclick"
     */
    onClickWidget: function(e){
        var aWidgetDiv = e.currentTarget;
        this.selectedWireWidget = aWidgetDiv.getAttribute("widgetName");
        this.clickedWidgetDiv = aWidgetDiv;
        // Find the return image button
        var returnImgs = dojo.query(".mumWidgetDivReturnImg" + this.currentType, aWidgetDiv);
        returnImgs[0].style.visibility = "visible";
        //A11Y        
        returnImgs[0].setAttribute("tabindex","0");
        
        var widgetId = e.currentTarget.getAttribute("widgetId");
        
        htmlUtil.setClass(aWidgetDiv, "mumWidgetClicked" + this.currentType);
        //dojo.addClass(aWidgetDiv, "mumWidgetClicked" + this.currentType);
		
        if (aWidgetDiv.getAttribute("isClicked") == "true") 
            return;
        //fade out all other widgets
        var widgetDivs = dojo.query(".mumWireWidget" + this.currentType, this.wirePaneWidgetsDiv);
        if (widgetDivs.length > 0) {
            for (var i = 0; i < widgetDivs.length; i++) {
                var widgetDiv = widgetDivs[i];
                if (widgetDiv.getAttribute("widgetId") != widgetId) {
                     dojo.fx.combine([dojo.fadeOut({
                        node: widgetDiv,
                        duration: 1000
                    }),
                    dojo.fx.wipeOut({
                        node: widgetDiv,
                        duration: 1000
                    })]).play();
                    widgetDiv.setAttribute("isClicked", false);
                }
            }
        }
        //make the selected widget div
        aWidgetDiv.setAttribute("isClicked", "true");
        this.createWidgetEventsDiv(widgetId);
        //display the event-event wire pane
        dojo.fx.wipeIn({
            node: this.wirePaneWidgetEventsDiv,
            duration: 1000
        }).play();
        dojo.fadeIn({
            node: this.wirePaneWidgetEventsDiv,
            duration: 1000
        }).play();
        this.displayPrompter("3")
		
		//Remove the widget highlight
		window.clearTimeout(this.highlightTimer);
		dojo.publish(com.ibm.mm.builder.eventTopics.WirePane_OutWidget, [widgetId]);
    },
    onKeyPressWidgetReturnImg:function(e){
    	switch(e.keyCode){
    		case dojo.keys.ENTER:
    		  this.onClickWidgetReturnImg(e);
    		 break;
    	}
    },
    /**
     * This function will be invoked when user click on the return image button
     * on the right side of the selected widget's div
     * @param {Event} e: the "onclick" event of the widget div's return image
     */
    onClickWidgetReturnImg: function(e){
    
        //hide the return image
        e.currentTarget.style.visibility = "hidden";
        var aWidgetDiv = e.currentTarget.parentNode;
        
        if (aWidgetDiv.getAttribute("isClicked") == "false") 
            return;
        
		htmlUtil.setClass(aWidgetDiv, "mumWireWidget" + this.currentType);
		
        //fade in other widgets
        var widgetDivs = dojo.query(".mumWireWidget" + this.currentType, this.wirePaneWidgetsDiv);
        if (widgetDivs.length > 1) {
            for (var i = 0; i < widgetDivs.length; i++) {
                var widgetDiv = widgetDivs[i];
                dojo.fadeIn({
                    node: widgetDiv,
                    duration: 1000
                }).play();
                this.wipeIn({
                    node: widgetDiv,
                    duration: 1000
                }).play();
                widgetDiv.setAttribute("isClicked", "false");
            }
        }
        //restore the widget div status
        aWidgetDiv.setAttribute("isClicked", "false");
        dojo.fx.wipeOut({
            node: this.wirePaneWidgetEventsDiv,
            duration: 1000
        }).play();
        dojo.fadeOut({
            node: this.wirePaneWidgetEventsDiv,
            duration: 1000
        }).play();
        dojo.stopEvent(e);
		this.displayPrompter("2")
    },
    
    onMouseOverWidget: function(e){
        var widgetDiv = e.currentTarget;
        if (widgetDiv.getAttribute("isClicked") == "true") {
            return;
        }
        var widgetId = widgetDiv.getAttribute("widgetId");
        var _this = this;
		this.highlightTimer = window.setTimeout(function(){
			//com.ibm.mm.builder.utils.iwidgetUtil.highlightWidget(widgetId);
			com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.highlightWidget", widgetId);			
//			_this.iContext.iEvents.publishEvent("widgetHighlighted", widgetId);
		},300);
    },
    
    onMouseOutWidget: function(e){
        var widgetDiv = e.currentTarget;
        if (widgetDiv.getAttribute("isClicked") == "true") {
            return;
        }
        var widgetId = widgetDiv.getAttribute("widgetId");
        var widget = this.getWidgetFromMap(widgetId);
        if (widget.totalWiredEvents > 0) 
            dojo.addClass(widgetDiv, "mumHasWiredEvent")
		window.clearTimeout(this.highlightTimer);
        com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWidgetHighlight", widgetId);
//		this.iContext.iEvents.publishEvent("widgetHighlightRemoved",widgetId);
    },
    
    /**
     * Invoke when user click on one widget's event div in the second pane
     * which has been click before(already display the wire div)
     * It will remove the wire div and restore the event back to normal status
     * @param {Object} aEventDiv: the clicked div
     */
    restoreEventDiv: function(aEventDiv){
    
        if (aEventDiv.getAttribute("isClicked")) { // Click before, now in expand status
            aEventDiv.setAttribute("isClicked", "false");
            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
            var actionDivs = dojo.query(".mumWidgetPaneEventActionDiv", aEventDiv);
            if (actionDivs != null && actionDivs.length > 0) {
                for (var i = 0; i < actionDivs.length; i++) {
                    var actionDiv = actionDivs[i];
                    aEventDiv.removeChild(actionDiv);
                }
            }
        }
    },
    
    /**
     * Invoke when user click on a matched event and want to connect
     * 1. restore all other event back to normal status
     * 2. generate a connection div and append to this event's div
     * @param {Event} e The "onclick" event of the selected event div
     */
    onClickConEventDiv: function(e){
    
        var aEventDiv = e.currentTarget;
        
        // Fetch all needed info and fill them into the new generated event connection div
        var id = aEventDiv.getAttribute("belongId");
        var eventName = aEventDiv.getAttribute("eventName");
        var aEvent = this.getEventFromWidget(id, eventName)
        
        var aEventInfoDiv = document.createElement("div");
        htmlUtil.setClass(aEventInfoDiv, "mumWidgetPaneEventInfoDiv" + this.currentType);
        
        // the text and checkbox 
        var checkMarkDiv = dojo.query(".checkMarkDiv", aEventDiv)[0];
        if (aEvent.isWired) {
            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
            this.disconnectEvent(id, eventName);
            checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' title='"+aEventDiv.firstChild.title+"'/>"
            aEventDiv.setAttribute("isChecked", "");
        }
        else {
            this.connectEvent(id, eventName);
            checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true title='"+aEventDiv.firstChild.title+"'/>"
            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
            aEventDiv.setAttribute("isChecked", "checked");
        }
    },
    
    onMouseOverConEventDiv: function(e){
        var aEventDiv = e.currentTarget;
        var checked = aEventDiv.getAttribute("isChecked")
        if (checked == "checked") {
            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheckMouseOver" + this.currentType);
        }
        else {
            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivMouseOver");
        }
    },
    
    onMouseOutConEventDiv: function(e){
        var aEventDiv = e.currentTarget;
        var checked = aEventDiv.getAttribute("isChecked")
        if (checked == "checked") {
            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
        }
        else {
            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
        }
    },
    
    onClickWidgetPaneEventReturnImg: function(e){
    
        var aEventDiv = e.currentTarget.parentNode;
        
        var infoDiv = dojo.query(".mumWidgetPaneEventInfoDiv" + this.currentType, aEventDiv);
        var returnImg = dojo.query(".mumWidgetPaneEventReturnImg", aEventDiv);
        aEventDiv.removeChild(returnImg[0]);
        
        dojo.removeClass(infoDiv[0], "mumFloatLeft");
        
        var allEventsDiv = dojo.query(".mumWidgetPaneEventDiv", this.mumWidgetEventsDiv);
        for (var m = 0; m < allEventsDiv.length; m++) {
            var anotherEvent = allEventsDiv[m];
            dojo.fadeIn({
                node: anotherEvent,
                duration: 1000
            }).play();
            dojo.fx.wipeIn({
                node: anotherEvent,
                duration: 1000
            }).play();
        }
        
        var allGrayEventsDiv = dojo.query(".mumWidgetPaneEventDivGray", this.mumWidgetEventsDiv);
        for (var m = 0; m < allGrayEventsDiv.length; m++) {
            var anotherEvent = allGrayEventsDiv[m];
            dojo.fadeIn({
                node: anotherEvent,
                duration: 1000
            }).play();
            dojo.fx.wipeIn({
                node: anotherEvent,
                duration: 1000
            }).play();
        }
        
        dojo.stopEvent(e);    
    },
    
	/**
	 * Fetch the widget object from the cache
	 * @param {Object} id: the widget id
	 */
    getWidgetFromMap: function(id){
        var widget;
        for (var i = 0; i < this.widgets.length; i++) {
            widget = this.widgets[i];
            if (id == widget.id) {
                return widget;
            }
        }
        return null;
    },
    
	/**
	 * Get the event object from cache based on the widget id and event name
	 * @param {Object} id : the id of the widget
	 * @param {Object} eventName : the name of the event
	 */
    getEventFromWidget: function(id, eventName){
        var event;
        for (var i = 0; i < this.widgets.length; i++) {
            var widget = this.widgets[i];
            if (id == widget.id) {
                var events = widget.events;
                for (var j = 0; j < events.length; j++) {
                    event = events[j];
                    if (event.name == eventName) 
                        break;
                }
                break;
            }
        }
        return event;
    },
    
	/**
	 * Update the cache after add/remove wire on the interaction interface
	 * @param {string} sourceId
	 * @param {string} sourceEvent
	 * @param {string} targetId
	 * @param {string} targetEvent
	 */
    updateEventsMap: function(sourceId, sourceEvent, targetId, targetEvent, isAddWire){
        //var widgetsArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEvents(sourceId, sourceEvent,this.iContext.scope.layouts);
        //this.eventsMap["Send-" + sourceEvent] = widgetsArray;
        //this.widgets = widgetsArray;
    	var eventName = targetEvent;
		var widgetId = targetId;
		if(this.currentType == "Receive") {
			eventName = sourceEvent;
			widgetId = sourceId;
		}
		var wireVar = -1;
		if(isAddWire) 
			wireVar = 1;
        for (var i = 0; i < this.widgets.length; i++) {
            var widget = this.widgets[i];
            if (widgetId == widget.id) {
            	//Find the widget
            	widget.totalWiredEvents += wireVar;
                var events = widget.events;
                for (var j = 0; j < events.length; j++) {
                    var event = events[j];
                    if (event.name == eventName) {
                    	//Find the event
                    	event.isWired = isAddWire;
                    }
                }
                break;
            }
        }
    },
    
    addWire: function(sourceId, sourceEvent, targetId, targetEvent, needUpdate){
        
        var wireInfo = {
        		"sourceWidgetId":sourceId,
        		"sourceEvent":sourceEvent,
        		"targetWidgetId":targetId,
        		"targetEvent":targetEvent
        };
        
        com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.addNewWire", wireInfo);
        
		if (needUpdate) {
			this.updateEventsMap(sourceId, sourceEvent, targetId, targetEvent,true);
		}
    	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	},
    
    removeWire: function(sourceId, sourceEvent, targetId, targetEvent, needUpdate){
        
    	var wireInfo = {
        		"sourceWidgetId":sourceId,
        		"sourceEvent":sourceEvent,
        		"targetWidgetId":targetId,
        		"targetEvent":targetEvent
        };
    	
    	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWire", wireInfo);
    	
		if (needUpdate) {
			this.updateEventsMap(sourceId, sourceEvent, targetId, targetEvent,false);
		}
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
    },
    
    disconnectEvent: function(id, eventName){
        if (this.currentType == "Send") {
            this.removeWire(this.iwidgetId, this.selectedEvent, id, eventName, true);
        }
        else {
            this.removeWire(id, eventName, this.iwidgetId, this.selectedEvent, true);
        }
        this.updateEventWireCount(id, -1);
    },
    
    connectEvent: function(id, eventName){
    
        if (this.currentType == "Send") {
            this.addWire(this.iwidgetId, this.selectedEvent, id, eventName, true);
        }
        else {
            this.addWire(id, eventName, this.iwidgetId, this.selectedEvent, true);
        }
        this.updateEventWireCount(id, 1);
    },
    
	/**
	 * Update the wire count on the UI
	 * @param {string} id: target widget id
	 * @param {number} num: wire added(1)/ wire removed (-1)
	 */
    updateEventWireCount: function(id, num){
        var eventDivs = dojo.query(".mumEventDivClicked" + this.currentType, this.wirePaneEventsDiv);
        for (var i = 0; i < eventDivs.length; i++) {
            var eventDiv = eventDivs[i];
            if (eventDiv.getAttribute("eventName") == this.selectedEvent) {
                var countDiv = dojo.query(".mumEventDivCount" + this.currentType, eventDiv)[0];
				var count;
				if(countDiv.innerHTML == "" || countDiv.innerHTML == null)
					count = 0;
                else
					count = parseInt(countDiv.innerHTML);
                count = count + num;
				htmlUtil.setClass(countDiv, "mumEventDivCount" + this.currentType);
				if (count > 0) {
					countDiv.innerHTML = count;
					if (count == 1) 
						dojo.addClass(countDiv, "mumEventDivCountSingleWire" + this.currentType)
					else 
						dojo.addClass(countDiv, "mumEventDivCountMultiWire" + this.currentType)
					
				}
				else
					countDiv.innerHTML = "";
				
				//for a11y
				this._insertEventA11yHint(this.currentType, eventDiv, count);				
            }
        }
		var curWireIcon = dojo.query(".mumCurrentWidgetArrow" + this.currentType,this.wirePaneCurrentWidgetDiv)[0];
		var currentWidgetName = dojo.query(".mumCurrentWidgetName" + this.currentType,this.wirePaneCurrentWidgetDiv)[0];
        if (this.currentType == "Send") {
			this.allPubWires += num;
            if (builderConfig.isBidi) {
				this.sendIconDiv.innerHTML = "(" + this.allPubWires + ")";
			}
			else {
				this.sendWireCountDiv.innerHTML = "(" + this.allPubWires + ")";
			}
			//update the UI of the current widget
			if (this.allPubWires == 0) {
				dojo.addClass(curWireIcon, "mumHiddenElement");
				htmlUtil.setNodeTitleWithStyle(currentWidgetName.title,currentWidgetName,375,this.titleFontStyle);
			}
			else 
				if (this.allPubWires == 1 && num == 1) {
					dojo.removeClass(curWireIcon, "mumHiddenElement");
					htmlUtil.setNodeTitleWithStyle(currentWidgetName.title,currentWidgetName,345,this.titleFontStyle);
				}
        }
        else {
			this.allHanWires += num;
            if (builderConfig.isBidi) {
				this.recIconDiv.innerHTML = "(" + this.allHanWires + ")";
			}
			else {
				this.receiveWireCountDiv.innerHTML = "(" + this.allHanWires + ")";
			}
			//update the UI of the current widget
			if (this.allHanWires == 0) {
				dojo.addClass(curWireIcon, "mumHiddenElement");
				htmlUtil.setNodeTitleWithStyle(currentWidgetName.title,currentWidgetName,375,this.titleFontStyle);
			}
			else 
				if (this.allHanWires == 1 && num == 1) {
					dojo.removeClass(curWireIcon, "mumHiddenElement");
					htmlUtil.setNodeTitleWithStyle(currentWidgetName.title,currentWidgetName,345,this.titleFontStyle);
				}
        }
        //update the UI of the selected widget
        var widget = this.getWidgetFromMap(id);
        var arrow = dojo.query(".mumWireIndicator" + this.currentType, this.clickedWidgetDiv)[0];
		var widgetname = dojo.query(".mumWireWidgetTitle", this.clickedWidgetDiv)[0];
		
        if (widget.totalWiredEvents > 0) {
			arrow.style.display = "";
			htmlUtil.setNodeTitleWithStyle(widgetname.title,widgetname,345,this.titleFontStyle);
//            arrow.style.visibility = "visible";
		}
		else {
			htmlUtil.setNodeTitleWithStyle(widgetname.title,widgetname,375,this.titleFontStyle);
			arrow.style.display = "none";
		}
//            arrow.style.visibility = "hidden";
    },
    
    createWidgetEventsDiv: function(id){
    
        this.wirePaneWidgetEventsDiv.innerHTML = "";
		var widgetsTitleDiv = document.createElement("div");
        if (this.currentType == "Send") {
            htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivSend");
			htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETEVENTS_SEND,widgetsTitleDiv,425,this.titleFontStyle);
        }
        else if (this.currentType == "Receive") {
                htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivReceive");
				htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETEVENTS_RECEIVE,widgetsTitleDiv,425,this.titleFontStyle);
        }       
        
        htmlUtil.setClass(this.wirePaneWidgetEventsDiv, "mumWidgetEventsDiv" + this.currentType);
        var mumWidgetEventsContentDiv = this.createDivWithClass("mumWidgetEventsContentDiv" + this.currentType)
                
        for (var i = 0; i < this.widgets.length; i++) {
            var aWidget = this.widgets[i];
            if (aWidget.id == id) {
                var events = aWidget.events;
                for (var j = 0; j < events.length; j++) {
                    var aEvent = events[j];
                    var eventName = aEvent.name;
                    var aEventDiv = document.createElement("div");
                    aEventDiv.setAttribute("belongId", id);
                    aEventDiv.setAttribute("eventName", eventName);
					
                    if (aEvent.isMatch) {
                    
                        dojo.connect(aEventDiv, "onclick", this, "onClickConEventDiv");
                        dojo.connect(aEventDiv, "onmouseover", this, "onMouseOverConEventDiv");
                        dojo.connect(aEventDiv, "onmouseout", this, "onMouseOutConEventDiv");
                        
                        var checkMarkDiv = document.createElement("div");
						dojo.addClass(checkMarkDiv, "checkMarkDiv");
                        dojo.addClass(checkMarkDiv, "mumFloatLeft");
                       
                        if (aEvent.isWired) {
                            checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true />"
                            aEventDiv.setAttribute("isChecked", "checked")
                            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                        }
                        else {
                            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                            checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' />"
                            aEventDiv.setAttribute("isChecked", "")
                        }
						
                        var aEventInfoDiv = this.createDivWithClass("mumWidgetPaneEventInfoDiv" + this.currentType);
//                        aEventInfoDiv.appendChild(checkMarkDiv);
                        
						//TODO: Need to replace with new widgetModel SPI, wait for the getHandledEvent(eventName) SPI ready
						var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
						
						
						var oneEvent = null;
						if(widgetWrapper!=null&&widgetWrapper!=undefined){
							oneEvent = widgetWrapper.getPublicEvent(eventName);
						}
						var title = oneEvent.getAttribute("title",dojo.locale)?oneEvent.getAttribute("title",dojo.locale):(oneEvent.getAttribute("title","en") ? oneEvent.getAttribute("title","en"): oneEvent.name);
						var description = oneEvent.getAttribute("description",dojo.locale)?oneEvent.getAttribute("description",dojo.locale):oneEvent.name;
						
						var eventDivText1 = this.createDivWithClass("mumWidgetPaneEventInfoText" + this.currentType);
						dojo.addClass(eventDivText1, "mumEventDivText1");
						var eventDivText3 = this.createDivWithClass("mumWidgetPaneEventInfoText" + this.currentType);
						dojo.addClass(eventDivText3, "mumEventDivText3");
						
						eventDivText1.title = title;
						eventDivText1.innerHTML = htmlUtil.escapeString(title);
						
						var payloadType = this.getShownType(aEvent.payloadType);
						eventDivText3.title = payloadType;
						eventDivText3.innerHTML = htmlUtil.escapeString(payloadType);
						
						var wrapperDiv1 = document.createElement("div");
						wrapperDiv1.appendChild(eventDivText1);
						
						var wrapperDiv3 = document.createElement("div");
						wrapperDiv3.appendChild(eventDivText3);
						
						//A11Y
						if (aEvent.isWired) {
                            checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true title='"+aEventInfoDiv.title+"' />"
                            aEventDiv.setAttribute("isChecked", "checked")
                            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                        }
                        else {
                            htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                            checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' title='"+aEventInfoDiv.title+"' />"
                            aEventDiv.setAttribute("isChecked", "")
                        }
						aEventInfoDiv.appendChild(checkMarkDiv);
						
						var storeEventDivInnerHTML = aEventInfoDiv.innerHTML;
						
						//construct the event content
						var eventContent;	
												
	                    if (this.currentType == "Send") {
							// To fix bug 3218 3228
							var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_RECEIVE,
								[
									title,
									this.getShownType(aEvent.payloadType),
									description
								]
							);
							aEventInfoDiv.title = eventTitle;
							//construct the event content
							eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_RECEIVE,
								[
									wrapperDiv1.innerHTML,
									'<div class="mumWidgetPaneEventInfoTextMid">',
									'</div>',
									wrapperDiv3.innerHTML
								]);
								
						}else {
							// To fix bug 3218 3228
							var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_SEND,
								[
									eventName,
									this.getShownType(aEvent.payloadType),
									description
								]
							);
							aEventInfoDiv.title = eventTitle;	
							eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_SEND,
								[
									wrapperDiv1.innerHTML,
									'<div class="mumWidgetPaneEventInfoTextMid">',
									'</div>',
									wrapperDiv3.innerHTML
								]);						
						}
						aEventInfoDiv.innerHTML = aEventInfoDiv.innerHTML + eventContent;
						
						eventDivText1 = dojo.query(".mumEventDivText1",aEventInfoDiv)[0];
						var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1,this.defaultFontStyle);
						
						eventDivText3 = dojo.query(".mumEventDivText3",aEventInfoDiv)[0];
						var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3,this.defaultFontStyle);
						
						var eventDivText2 = dojo.query(".mumWidgetPaneEventInfoTextMid",aEventInfoDiv)[0];
						var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2,this.italicStyle);
						eventDivText2.title = eventDivText2.innerHTML;
						
						var totalWidth = dojo.isIE ? 380 : 395;
						
						if(div1Width + div2Width + div3Width > totalWidth){
										
							var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
							var widthLeftFor3 = widthLeft - div1Width;
							var widthLeftFor1 = widthLeft - div3Width;
							
							if(widthLeftFor3 > 60){  //try to only truncate one only
								div3Width = widthLeftFor3;
								htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML,eventDivText3,div3Width,this.defaultFontStyle);
							}else if(widthLeftFor1 > 60){
								div1Width = widthLeftFor1;
								htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML,eventDivText1,div1Width,this.defaultFontStyle);
							}else {
								div1Width = widthLeft*0.6;
								div3Width = widthLeft*0.4;
								htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML,eventDivText1,div1Width,this.defaultFontStyle);
								htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML,eventDivText3,div3Width,this.defaultFontStyle);
							}
						}
                        aEventDiv.appendChild(aEventInfoDiv);
                    }
                    mumWidgetEventsContentDiv.appendChild(aEventDiv);
                    
                }
                break;
            }
        }
		var mumWidgetEventsBottomDiv = this.createDivWithClass("mumWidgetEventsBottomDiv" + this.currentType);
		
		this.wirePaneWidgetEventsDiv.appendChild(widgetsTitleDiv);
		this.wirePaneWidgetEventsDiv.appendChild(mumWidgetEventsContentDiv);
		this.wirePaneWidgetEventsDiv.appendChild(mumWidgetEventsBottomDiv);
    },
    
    /**
     * This function will be invoked when user click on one event in first area.
     * 1. Init and display the second area
     * 2. Render every other widget based on the info fetched by wireUtil
     * 3. Place the return image button and the tip
     */
    createWidgetsDiv: function(){
        //reset the whole widgets pane
        this.wirePaneWidgetsDiv.innerHTML = "";
		this.wirePaneWidgetEventsDiv.innerHTML = "";
		this.hideElement(this.wirePaneWidgetEventsDiv);
        htmlUtil.setClass(this.wirePaneWidgetsDiv, "mumPaneDiv");
        //Init the tip div
		htmlUtil.setClass(this.grayTip, "mumWireWidgetTip" + this.currentType);
        this.grayTip.innerHTML = cws.I_WIRING_NO_MATCH_WIDGET;
        //Init the title
        var widgetsTitleDiv = document.createElement("div");
        if (this.currentType == "Send") {
            htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivSend");
			htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETS_SEND,widgetsTitleDiv,425,this.titleFontStyle);
//            widgetsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_WIDGETS_SEND,40);
        }
        else 
            if (this.currentType == "Receive") {
                htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivReceive");
				htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETS_RECEIVE,widgetsTitleDiv,425,this.titleFontStyle);
//                widgetsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_WIDGETS_RECEIVE,40);
            }
		// The content pane in the middle
		var wirePaneWidgetsContentDiv = this.createDivWithClass("mumWidgetsContentDiv" + this.currentType);
		this.wirePaneEventsDiv.appendChild(wirePaneWidgetsContentDiv);
		
        var matchWidgetCount = 0;
        var preFetchId;
        //Render every other widgets in the widgets pane if they have at least one event can be wired with current widget's event
        for (var i = 0; i < this.widgets.length; i++) {
            var aWidget = this.widgets[i];
            if (aWidget.hasMatchEvent) { // has event can be wired to this widgets, create div
                matchWidgetCount++;
                preFetchId = aWidget.id;
                var aWidgetDiv = document.createElement("div");
                aWidgetDiv.setAttribute("widgetId", aWidget.id);
                aWidgetDiv.setAttribute("isClicked", "false");
				aWidgetDiv.setAttribute("widgetName", aWidget.type);
				//A11Y
				aWidgetDiv.setAttribute("title",aWidget.type);
				aWidgetDiv.setAttribute("tabindex","0");
                dojo.addClass(aWidgetDiv, "mumWireWidget" + this.currentType);
                
                //arrow to indicate is currently wired with the widget
                var wireIndicator = document.createElement("div");
                dojo.connect(aWidgetDiv, "onmouseover", this, "onMouseOverWidget");
                dojo.connect(aWidgetDiv, "onmouseout", this, "onMouseOutWidget");
                dojo.connect(aWidgetDiv, "onclick", this, "onClickWidget");
                //A11Y
                //dojo.connect(aWidgetDiv, "onfocus", this, "onMouseOverWidget");
                //dojo.connect(aWidgetDiv, "onblur", this, "onMouseOutWidget");
                dojo.connect(aWidgetDiv, "onkeypress", this, "onKeyPressWidget");
			
		 		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
				var titleIcon=widgetUtil.getWidgetInstanceIcon(aWidget.id) || (builderConfig.builderPath + "/images/generic_widget_icon.gif");
		 		
                var aWidgetImg = document.createElement("div");
				aWidgetImg.innerHTML = "<img src='" + titleIcon + "' class='mumWirePaneWidgetIcon' alt=''>";
                htmlUtil.setClass(aWidgetImg, "mumWireWidgetImg");
                aWidgetDiv.appendChild(aWidgetImg);
                
                var aWidgetTitle = document.createElement("div");
                htmlUtil.setClass(aWidgetTitle, "mumWireWidgetTitle");
                aWidgetDiv.appendChild(aWidgetTitle);
                
				wireIndicator.innerHTML = 
					"<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + (this.currentType === "Send" ? "receive" : "send") + (builderConfig.isBidi ? "_arrow_rtl.png' alt=''>" : "_arrow.png' alt=''>");
                htmlUtil.setClass(wireIndicator, "mumWireIndicator" + this.currentType);
				
				//deal with the inidcator
				wireIndicator.style.display = "none";
//                wireIndicator.style.visibility = "hidden";
				if (aWidget.totalWiredEvents > 0) {
                    dojo.addClass(aWidgetDiv, "mumHasWiredEvent");
					wireIndicator.style.display = "";
					htmlUtil.setNodeTitleWithStyle(aWidget.type,aWidgetTitle,345,this.titleFontStyle);
//                    wireIndicator.style.visibility = "visible";
                }else {
					htmlUtil.setNodeTitleWithStyle(aWidget.type,aWidgetTitle,375,this.titleFontStyle);
				}
				
                var widgetDivReturnImg = document.createElement("div");
                htmlUtil.setClass(widgetDivReturnImg, "mumWidgetDivReturnImg" + this.currentType);
                dojo.connect(widgetDivReturnImg, "onclick", this, "onClickWidgetReturnImg");
				
                //A11Y-todo
                dojo.connect(widgetDivReturnImg, "onkeypress", this, "onKeyPressWidgetReturnImg");
                dojo.attr(widgetDivReturnImg, "title", cws["I_WIRING_OTHER_WIDGETS_"+this.currentType.toUpperCase()]);
				widgetDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + (this.currentType == "Send" ? "blue" : "green") + "_expand.png' alt=''>"

				
                widgetDivReturnImg.style.visibility = "hidden";
                widgetDivReturnImg.setAttribute("tabindex","0");
                aWidgetDiv.appendChild(widgetDivReturnImg);
                aWidgetDiv.appendChild(wireIndicator);
                wirePaneWidgetsContentDiv.appendChild(aWidgetDiv);
            }
        }
        this.wirePaneWidgetEventsDiv.innerHTML = "";
        //this.wirePaneWidgetsDiv.appendChild(this.wirePaneWidgetEventsDiv);
  
		//The bottom pane, only contains one round corner image
		var wirePaneWidgetsBottomDiv = this.createDivWithClass("mumWidgetsBottomDiv" + this.currentType);
		
		this.wirePaneWidgetsDiv.appendChild(widgetsTitleDiv);
		 //If there is no widget which contains event can be wired with this widget's event, show the tip
        if (matchWidgetCount == 0) {
            wirePaneWidgetsContentDiv.appendChild(this.grayTip);
        }
		
		this.wirePaneWidgetsDiv.appendChild(wirePaneWidgetsContentDiv);
		this.wirePaneWidgetsDiv.appendChild(wirePaneWidgetsBottomDiv);
		
		this.wirePaneWidgetsDiv.style.display = "";
		this.LOGGER.exiting("WirePane_createWidgetsDiv");
        return matchWidgetCount;
    },
	
    /**
     * This function will be invoked every time a new wire pane is poped up.
     * Fetch all related events' and wire data for current widget. Wrap them into Object "eventsMap".
     */
    initAllData: function(){
    
        this.eventsMap = new Object();
        var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.iwidgetId);
        var hEvents = widgetWrapper.getWidgetHandledEvents();
        var pEvents = widgetWrapper.getWidgetPublishedEvents();
        this.allHanWires = 0;
        this.allPubWires = 0;
        var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
        var layouts = themeModel.getLayouts();
		if(hEvents != null){
        for (var n = 0; n < hEvents.length; n++) {
            var hanEvent = hEvents[n];
            var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
			var widgetsArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchPubEvents(this.iwidgetId, hanEvent.name,layouts);
            var wiredEventCount = 0;
            for (var i = 0; i < widgetsArray.length; i++) {
                this.allHanWires = this.allHanWires + widgetsArray[i].wiredEvents.length;
            }
            this.eventsMap["Receive-" + hanEvent.name] = widgetsArray;
        }
		}
		
		if(pEvents != null){
		for (var n = 0; n < pEvents.length; n++) {
			var pubEvent = pEvents[n];
			var widgetsArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEvents(this.iwidgetId, pubEvent.name,layouts);
			for (var i = 0; i < widgetsArray.length; i++) {
				this.allPubWires = this.allPubWires + widgetsArray[i].wiredEvents.length;
			}
			this.eventsMap["Send-" + pubEvent.name] = widgetsArray;
		}
		}
    },
    
    /**
     * Generate the receive Events pane of current widget
     */
    createReceiveEventsDiv: function(){
    
        this.createCurrentWidgetDiv()
        
        this.wirePaneEventsDiv.innerHTML = "";
        htmlUtil.setClass(this.wirePaneEventsDiv, "mumEventsDiv");
        htmlUtil.setClass(this.grayTip, "mumWireWidgetTipSend");
		this.grayTip.innerHTML = cws.I_WIRING_NO_RECEIVE_EVENTS;
        
        var eventsTitleDiv = document.createElement("div");
        htmlUtil.setClass(eventsTitleDiv, "mumEventsTitleDivReceive");
		
		htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_EVENTS_RECEIVE,eventsTitleDiv,425,this.titleFontStyle);
		
        this.wirePaneEventsDiv.appendChild(eventsTitleDiv);
        
        var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.iwidgetId);
        var hEvents = widgetWrapper.getWidgetHandledEvents() || [];
        
		var wirePaneEventsContentDiv = this.createDivWithClass("mumEventsContentDiv" + this.currentType);
		this.wirePaneEventsDiv.appendChild(wirePaneEventsContentDiv);
		
		var hasEventToShow = false;
		
        for (var n = 0; n < hEvents.length; n++) {
            var hanEvent = hEvents[n];
            if (hanEvent.getAttribute("private") == "true")
            	continue;
            var eventDiv = document.createElement("div");
            htmlUtil.setClass(eventDiv, "mumEventDiv");
            
            wirePaneEventsContentDiv.appendChild(eventDiv);
            hasEventToShow = true;
            
            var title = this.localized.getTitle(hanEvent);
            if(!title) title = hanEvent.name;
            
            var description = this.localized.getDescription(hanEvent);
            if(!description) description = hanEvent.name;
            
			// To fix bug 3218 3228
			var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_RECEIVE,
				[
					title,
					this.getShownType(hanEvent.type),
					description
				]
			);	
			eventDiv.title = eventTitle;			
			
            var widgetsArray = this.eventsMap["Receive-" + hanEvent.name];
            var wiredEventCount = 0;
            for (var i = 0; i < widgetsArray.length; i++) {
                wiredEventCount = wiredEventCount + widgetsArray[i].totalWiredEvents;
            }
			
			var eventDivCount = document.createElement("div");
            htmlUtil.setClass(eventDivCount, "mumEventDivCount" + this.currentType);   
                    
			
            //if this event already has wired with other events
			if (wiredEventCount > 0) {
				eventDivCount.innerHTML = wiredEventCount;
				dojo.addClass(eventDiv, "mumEventDivWired");
				if (wiredEventCount == 1) 
					dojo.addClass(eventDivCount, "mumEventDivCountSingleWire" + this.currentType)
				else 
					dojo.addClass(eventDivCount, "mumEventDivCountMultiWire" + this.currentType)
			}
            
            var eventDivReturnImg = document.createElement("div");
			eventDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/blue_expand.png' alt=''>";
			
            htmlUtil.setClass(eventDivReturnImg, "mumEventDivReturnImg" + this.currentType);
            dojo.connect(eventDivReturnImg, "onclick", this, "onClickEventReturnImg");
            eventDivReturnImg.style.visibility = "hidden";
            //A11Y
            dojo.connect(eventDivReturnImg, "onkeypress", this, "onKeyPressEventReturnImg");
            eventDivReturnImg.setAttribute("tabindex","0");
			dojo.attr(eventDivReturnImg, "title", cws["I_WIRING_OTHER_EVENTS_"+this.currentType.toUpperCase()]);
            
            var eventDivVline = document.createElement("div");
            htmlUtil.setClass(eventDivVline, "grayBar");
            eventDivVline.style.visibility = "hidden";
            
            eventDiv.setAttribute("eventName",hanEvent.name);
			eventDiv.setAttribute("eventTitle",title);
            eventDiv.setAttribute("isClicked", "false");
            //A11Y
            eventDiv.setAttribute("tabindex","0");
            eventDiv.appendChild(eventDivCount);
			
			var eventDivText1 = this.createDivWithClass("mumEventDivTextReceive");
			dojo.addClass(eventDivText1, "mumEventDivText1");
			eventDivText1.title = title;
			eventDivText1.innerHTML = htmlUtil.escapeString(title);
			
            var eventDivText3 = this.createDivWithClass("mumEventDivTextReceive");
            dojo.addClass(eventDivText3, "mumEventDivText3");
			var payloadType = this.getShownType(hanEvent.type);
			eventDivText3.title = payloadType;
			eventDivText3.innerHTML = htmlUtil.escapeString(payloadType);
			
			var wrapperDiv1 = document.createElement("div");
			wrapperDiv1.appendChild(eventDivText1);
			
			var wrapperDiv3 = document.createElement("div");
			wrapperDiv3.appendChild(eventDivText3);
			
			var storeEventDivInnerHTML = eventDiv.innerHTML;
					
			//construct the event content
			var eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_RECEIVE,
				[
					wrapperDiv1.innerHTML,
					'<div class="mumEventDivText2">',
					'</div>',
					wrapperDiv3.innerHTML
				]);
			eventDiv.innerHTML = eventDiv.innerHTML + eventContent;
			
			eventDivText1 = dojo.query(".mumEventDivText1",eventDiv)[0];
			var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1,this.defaultFontStyle);
			
			eventDivText3 = dojo.query(".mumEventDivText3",eventDiv)[0];
			var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3,this.defaultFontStyle);
			
			var eventDivText2 = dojo.query(".mumEventDivText2",eventDiv)[0];
			var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2,this.italicStyle);
			eventDivText2.title = eventDivText2.innerHTML;
			
			var totalWidth = dojo.isIE ? 370 : 380;
			
			if(div1Width + div2Width + div3Width > totalWidth){
				
				var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
				var widthLeftFor3 = widthLeft - div1Width;
				var widthLeftFor1 = widthLeft - div3Width;
				
				if(widthLeftFor3 > 60){  //try to only truncate one only
					div3Width = widthLeftFor3;
					htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML,eventDivText3,div3Width,this.defaultFontStyle);
				}else if(widthLeftFor1 > 60){
					div1Width = widthLeftFor1;
					htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML,eventDivText1,div1Width,this.defaultFontStyle);
				}else {
					div1Width = widthLeft*0.6;
					div3Width = widthLeft*0.4;
					htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML,eventDivText1,div1Width,this.defaultFontStyle);
					htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML,eventDivText3,div3Width,this.defaultFontStyle);
				}
			}
            eventDiv.appendChild(eventDivReturnImg);
            dojo.connect(eventDiv, "onclick", this, "onClickEvent");
            //A11Y
            dojo.connect(eventDiv, "onkeypress", this, "onKeyPressEvent");
			this._insertEventA11yHint("Receive", eventDiv, wiredEventCount);
        }
		
		if (!hasEventToShow) {
            wirePaneEventsContentDiv.appendChild(this.grayTip);
        }
		
		var wirePaneEventsBottomDiv = this.createDivWithClass("mumEventsBottomDiv" + this.currentType);
		this.wirePaneEventsDiv.appendChild(wirePaneEventsBottomDiv);
    },
    
    /**
     * Generate the send Events pane of current widget
     */
    createSendEventsDiv: function(){
    
        this.createCurrentWidgetDiv()
		
        //reset the whole wire pane
        this.wirePaneEventsDiv.innerHTML = "";
        htmlUtil.setClass(this.wirePaneEventsDiv, "mumEventsDiv");
        htmlUtil.setClass(this.grayTip, "mumWireWidgetTipReceive");
		this.grayTip.innerHTML = cws.I_WIRING_NO_SEND_EVENTS;
        //Init the title
        var eventsTitleDiv = document.createElement("div");
		htmlUtil.setClass(eventsTitleDiv, "mumEventsTitleDivSend");
		htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_EVENTS_SEND,eventsTitleDiv,425,this.titleFontStyle);
				
//        eventsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_EVENTS_SEND,40);
       
        this.wirePaneEventsDiv.appendChild(eventsTitleDiv);
        //Fetch the send events' info
        var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.iwidgetId);
        var pEvents = widgetWrapper.getWidgetPublishedEvents() || [];

		var wirePaneEventsContentDiv = this.createDivWithClass("mumEventsContentDiv" + this.currentType);
		this.wirePaneEventsDiv.appendChild(wirePaneEventsContentDiv);
		 
		var hasEventToShow = false;
		
        //Generate the event div recuisively
        for (var n = 0; n < pEvents.length; n++) {
            var pubEvent = pEvents[n];
            if (pubEvent.getAttribute("private") == "true")
            	continue;
            
            var eventDiv = document.createElement("div");
            htmlUtil.setClass(eventDiv, "mumEventDiv");
            
            wirePaneEventsContentDiv.appendChild(eventDiv);
            hasEventToShow = true;
            
			
            var title = this.localized.getTitle(pubEvent);
            if(!title) title = pubEvent.name;
            
            var description = this.localized.getDescription(pubEvent);
            if(!description) description = pubEvent.name;
			
			// To fix bug 3218 3228
			var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_SEND,
				[
					title,
					this.getShownType(pubEvent.type),
					description
				]
			);	
			eventDiv.title = eventTitle;		
			var widgetsArray = this.eventsMap["Send-" + pubEvent.name];
            var wiredEventCount = 0;
            for (var i = 0; i < widgetsArray.length; i++) {
                wiredEventCount = wiredEventCount + widgetsArray[i].totalWiredEvents;
            }
			
			var eventDivCount = document.createElement("div");
            htmlUtil.setClass(eventDivCount, "mumEventDivCount" + this.currentType);           
			
			if (wiredEventCount > 0) {
				eventDivCount.innerHTML = wiredEventCount;
				dojo.addClass(eventDiv, "mumEventDivWired");
				if (wiredEventCount == 1) 
					dojo.addClass(eventDivCount, "mumEventDivCountSingleWire" + this.currentType);
				else 
					dojo.addClass(eventDivCount, "mumEventDivCountMultiWire" + this.currentType);
			}
			
            var eventDivReturnImg = document.createElement("div");
			
			//defect 7491
			eventDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/green_expand.png' alt=''>";
			
            htmlUtil.setClass(eventDivReturnImg, "mumEventDivReturnImg" + this.currentType);
            dojo.connect(eventDivReturnImg, "onclick", this, "onClickEventReturnImg");
            eventDivReturnImg.style.visibility = "hidden";
            //A11Y
            dojo.connect(eventDivReturnImg, "onkeypress", this, "onKeyPressEventReturnImg");
            eventDivReturnImg.setAttribute("tabindex","0");
            dojo.attr(eventDivReturnImg, "title", cws["I_WIRING_OTHER_EVENTS_"+this.currentType.toUpperCase()]);
			
            eventDiv.setAttribute("eventName", pubEvent.name);
			eventDiv.setAttribute("eventTitle",title);
            eventDiv.setAttribute("isClicked", "false");
            //A11Y
            eventDiv.setAttribute("tabindex","0");
			
			eventDiv.appendChild(eventDivCount);
			
			//init the event name and payload type div
			var eventDivText1 = this.createDivWithClass("mumEventDivTextSend");
			dojo.addClass(eventDivText1, "mumEventDivText1");
			eventDivText1.title = title;
			eventDivText1.innerHTML = htmlUtil.escapeString(title);
			
			
            var eventDivText3 = this.createDivWithClass("mumEventDivTextSend");
            dojo.addClass(eventDivText3, "mumEventDivText3");
			var payloadType = this.getShownType(pubEvent.type);
			eventDivText3.title = payloadType;
			eventDivText3.innerHTML = htmlUtil.escapeString(payloadType);
        	
			
			var wrapperDiv1 = document.createElement("div");
			wrapperDiv1.appendChild(eventDivText1);
			
			var wrapperDiv3 = document.createElement("div");
			wrapperDiv3.appendChild(eventDivText3);
			
			var storeEventDivInnerHTML = eventDiv.innerHTML;
					
			//construct the event content
			var eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_SEND,
				[
					wrapperDiv1.innerHTML,
					'<div class="mumEventDivText2">',
					'</div>',
					wrapperDiv3.innerHTML
				]);
            eventDiv.innerHTML = eventDiv.innerHTML + eventContent;
			
            eventDivText1 = dojo.query(".mumEventDivText1",eventDiv)[0];
			var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1,this.defaultFontStyle);
			
			eventDivText3 = dojo.query(".mumEventDivText3",eventDiv)[0];
			var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3,this.defaultFontStyle);
			
			var eventDivText2 = dojo.query(".mumEventDivText2",eventDiv)[0];
			var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2,this.italicStyle);
			eventDivText2.title = eventDivText2.innerHTML;
			
			var totalWidth = dojo.isIE ? 370 : 380;
			
			if(div1Width + div2Width + div3Width > totalWidth){
				
				var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
				var widthLeftFor3 = widthLeft - div1Width;
				var widthLeftFor1 = widthLeft - div3Width;
				
				if(widthLeftFor3 > 60){  //try to only truncate one only
					div3Width = widthLeftFor3;
					htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML,eventDivText3,div3Width,this.defaultFontStyle);
				}else if(widthLeftFor1 > 60){
					div1Width = widthLeftFor1;
					htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML,eventDivText1,div1Width,this.defaultFontStyle);
				}else {
					div1Width = widthLeft*0.6;
					div3Width = widthLeft*0.4;
					htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML,eventDivText1,div1Width,this.defaultFontStyle);
					htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML,eventDivText3,div3Width,this.defaultFontStyle);
				}
			}
			
			eventDiv.appendChild(eventDivReturnImg);
			
            dojo.connect(eventDiv, "onclick", this, "onClickEvent");
            //A11Y
            dojo.connect(eventDiv, "onkeypress", this, "onKeyPressEvent");
			this._insertEventA11yHint("Send", eventDiv, wiredEventCount);
        }
		if (!hasEventToShow) {
            wirePaneEventsContentDiv.appendChild(this.grayTip);
        }
		var wirePaneEventsBottomDiv = this.createDivWithClass("mumEventsBottomDiv" + this.currentType);
		this.wirePaneEventsDiv.appendChild(wirePaneEventsBottomDiv);
    },
    
    createCurrentWidgetDiv: function(){
    	
        this.wirePaneCurrentWidgetDiv.innerHTML = "";
        var currentWidgetTitleDiv;
		htmlUtil.setClass(this.wirePaneCurrentWidgetDiv, "mumPaneDiv");
		
		var currentWidgetArrow = this.createDivWithClass("mumCurrentWidgetArrow" + this.currentType);
		
		// defect 7491
		currentWidgetArrow.innerHTML = 
					"<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + this.currentType.toLowerCase() + (builderConfig.isBidi ? "_arrow_rtl.png' alt=''>" : "_arrow.png' alt=''>");
		
		// the mid centent of the current widget div
        var currentWidgetContentDiv = this.createDivWithClass("mumCurrentWidgetContentDiv" + this.currentType);
        var currentWidgetDiv = this.createDivWithClass("mumCurrentWidgetDiv" + this.currentType);
        
        //init the currentWidget div's content
        var currentWidgetIcon = this.createDivWithClass("mumCurrentWidgetIcon");
        currentWidgetIcon.innerHTML = "<img src='" + this.widgetObj.widgetIconSrc + "' class='mumWirePaneWidgetIcon' alt=''>"
        var currentWidgetName = this.createDivWithClass("mumCurrentWidgetName" + this.currentType);
		
        if (this.currentType == "Send") {
			currentWidgetTitleDiv = this.createDivWithClass("mumGreenTitleDiv");
			htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_EVENTS_SEND,currentWidgetTitleDiv,425,this.titleFontStyle);
			dojo.attr(currentWidgetTitleDiv, "title", cws.I_WIRING_CWIDGET_SEND);
			if (this.allPubWires == 0) {
				dojo.addClass(currentWidgetArrow, "mumHiddenElement");
				htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname,currentWidgetName ,375,this.titleFontStyle);
			}else {
				htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname,currentWidgetName ,345,this.titleFontStyle);
			}
				
        }
        else {
            currentWidgetTitleDiv = this.createDivWithClass("mumBlueTitleDiv");
			htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_CWIDGET_RECEIVE,currentWidgetTitleDiv,425,this.titleFontStyle);
			dojo.attr(currentWidgetTitleDiv, "title", cws.I_WIRING_CWIDGET_RECEIVE);
			if (this.allHanWires == 0) {
				dojo.addClass(currentWidgetArrow, "mumHiddenElement");
				htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname,currentWidgetName ,375,this.titleFontStyle);
			}else {
				htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname,currentWidgetName ,345,this.titleFontStyle);
			}
        }
		
        currentWidgetDiv.appendChild(currentWidgetIcon);
        currentWidgetDiv.appendChild(currentWidgetName);
        currentWidgetDiv.appendChild(currentWidgetArrow);

        var currentWidgetBottomDiv = this.createDivWithClass("mumCurrentWidgetBottom" + this.currentType);
        currentWidgetContentDiv.appendChild(currentWidgetDiv);
        this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetTitleDiv)
        this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetContentDiv)
        this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetBottomDiv)
    },
    
	createTitleDiv: function() {
		var span = document.createElement("span");
		span.innerHTML = cws.I_WIRING_TITLE_RECEIVE;
		this.receiveTextDiv.appendChild(span);
		if (builderConfig.isBidi) {
			this.recIconDiv.innerHTML = "(" + this.allHanWires + ")";
			//defect 7491
			this.receiveWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow_deselect_rtl.png' alt=''>";
		}
		else {
			this.receiveWireCountDiv.innerHTML = "(" + this.allHanWires + ")";
			//defect 7491
			this.recIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow_deselect.png' alt=''>";
		}
		var spanSend = document.createElement("span");
		spanSend.innerHTML = cws.I_WIRING_TITLE_SEND;
		this.sendTextDiv.appendChild(spanSend);
		if (builderConfig.isBidi) {
			this.sendIconDiv.innerHTML = "(" + this.allPubWires + ")";
			//defect 7491
			this.sendWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow_rtl.png' alt=''>";
		}
		else {
			this.sendWireCountDiv.innerHTML = "(" + this.allPubWires + ")";
			//defect 7491
			this.sendIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow.png' alt=''>";
		}
		dojo.connect(this.wirePaneTitleDiv,"onkeypress",this,"onKeyPresTitlePane");
		dojo.connect(this.wirePaneTitleDivLeft, "onclick", this, "onClickTitlePaneLeft");		
        dojo.connect(this.wirePaneTitleDivRight, "onclick", this, "onClickTitlePaneRight");
        //Set the correct Div Styles on creation
		this.adjustDivsStyle();
	},
	
	adjustTitleDiv: function() {
		htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivReceiveTab" + this.currentType);
        htmlUtil.setClass(this.leftDivOfReceiveTab, "mumLeftDivOfReceiveTab" + this.currentType);
        htmlUtil.setClass(this.midDivOfReceiveTab, "mumMidDivOfReceiveTab" + this.currentType);
        htmlUtil.setClass(this.rightDivOfReceiveTab, "mumRightDivOfReceiveTab" + this.currentType);
		if (builderConfig.isBidi){
			htmlUtil.setClass(this.receiveWireCountDiv, "mumReceiveIconDiv" + this.currentType);
			htmlUtil.setClass(this.recIconDiv, "mumReceiveWireCountDiv");
			this.receiveWireCountDiv.innerHTML = 
				"<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow" + (this.currentType === "Send" ? "_deselect" : "") + "_rtl.png' alt=''>";
		}
		else{
			htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDivReceive");
			this.recIconDiv.innerHTML = 
				"<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow" + (this.currentType === "Send" ? "_deselect" : "") + ".png' alt=''>";
		}
		
		
        htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivSendTab" + this.currentType);
        htmlUtil.setClass(this.leftDivOfSendTab, "mumLeftDivOfSendTab" + this.currentType);
        htmlUtil.setClass(this.midDivOfSendTab, "mumMidDivOfSendTab" + this.currentType);
        htmlUtil.setClass(this.rightDivOfSendTab, "mumRightDivOfSendTab" + this.currentType);			
		if (builderConfig.isBidi){
			htmlUtil.setClass(this.sendWireCountDiv, "mumSendIconDiv" + this.currentType);
			htmlUtil.setClass(this.sendIconDiv, "mumSendWireCountDiv");
			this.sendWireCountDiv.innerHTML = 
				"<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow" + (this.currentType === "Send" ? "" : "_deselect") + "_rtl.png' alt=''>";
		}
		else{
			htmlUtil.setClass(this.sendIconDiv, "mumSendIconDivSend");
			this.sendIconDiv.innerHTML = 
				"<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow" + (this.currentType === "Send" ? "" : "_deselect") + ".png' alt=''>";
		}
	},
	
    /**
     * This function will be invoke when user click on the "wire" icon
     * 1. Gather all widget info
     * 2. Init the wire pane
     * 3. Init the Customized Dialog to show the wire pane
     */
	display: function(iwidgetId){
		this.iwidgetId = iwidgetId;
        // Default: View send events
        this.currentType = "Send";
        this.eventsMap = new Object();
        //Clean up the current wirepane
        if (this.wirePane != null) {
			this.wirePaneDiv.innerHTML = "";
			// reconstruct the UI.
			this.buildRendering();
		}
		this.widgetObj = {};

		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		this.widgetObj["widgetIconSrc"]=widgetUtil.getWidgetInstanceIcon(this.iwidgetId);
		this.widgetObj["widgetname"]=widgetUtil.getWidgetInstanceTitle(this.iwidgetId);

        //Init work
        this.initAllData();
        this.initWirePane();
        this.createSendEventsDiv();
		
        var wrapDiv = document.createElement("div");
        
        var contentDiv = dojo.query("."+com.ibm.mm.builder.constant.iWidgetContent, this.iContext.getRootElement())[0];
        if(contentDiv)
        	contentDiv.appendChild(this.wirePaneDiv);
        else
        	this.iContext.getRootElement().appendChild(this.wirePaneDiv);
		this.displayPrompter("1")
		
    },
    
    setContext:function(context){
    	this.iContext = context;
    },
	
	_insertA11yHint: function(domNode, hint) {
	
		this._removeA11yHint(domNode);
		
		var a11yHintSpan = dojo.doc.createElement("span");
		a11yHintSpan.innerHTML = hint;
		dojo.addClass(a11yHintSpan, "access");
		domNode.insertBefore(a11yHintSpan, domNode.firstChild);
	},
	
	_removeA11yHint: function(domNode){
		var a11yHintSpans = dojo.query(".access", domNode);
		
		for (var i = 0; i < a11yHintSpans.length; i++) {
			a11yHintSpans[i].parentNode.removeChild(a11yHintSpans[i]);
		}
	},
	
	_insertEventA11yHint: function(currentType, eventDiv, count) {
		if (count> 0) {
			this._insertA11yHint(eventDiv, "This event" + (currentType == "Send" ?  " sends data to " : " receives data from " ) + count + " event" + (count == 1? "": "s"));
		} else {
			this._removeA11yHint(eventDiv);
		}
	}
});

})();

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip"] = true;
/**
 * @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip");



dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip", [dijit._Widget, dijit._Templated], {
	
	autoWiringResult: false,
	
	contentRoot: null,
	
	notificationDialog:null,
	
	widgetId: null,
	
	templateString: "<div dojoAttachPoint='autoWiringNotiDiv' class='mumAutoWiringTipDiv'>" +
						"<div class='mumAWDNIcon'>" + 
							"<img dojoAttachPoint='wiringIcon' />" +
						"</div>" + 
						"<div class='mumAWDNMiddle' >" + 
							"<div dojoAttachPoint='tipText' class='mumAWDNTip'>" + 
							"</div>" +
							"<div dojoAttachPoint='NotiCfgNode' class=''>" + 
								"<input type='checkbox' dojoAttachPoint='NotiCfgCheckNode' dojoAttachEvent='onclick: onNotNotifyMeClicked' class='mumAutoWiringNotiCfgCheck'/>" +
								"<div dojoAttachPoint='NotiCfgLabel' class='mumAutoWiringNotiCfgLable'></div>" +
							"</div>" +
						"</div>" +
						"<div dojoAttachPoint='okNode' class='mumAutoWiringOk'>" +
							"<div dojoAttachPoint='okTextHidden' class='mumAutoWiringOKTextHidden'>" + 
							"</div>"+
							"<div dojoAttachPoint='okText' class='mumAutoWiringOKText'>" + 
							"</div>"+
						"</div>" +
					"</div>",
						
	constructor:function(){
	},
	
	postCreate:function(){
		this.initContent();
	},
	
	updateContent:function(widgetId){
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		var tip = dojo.query(".mumAWDNTip", this.notificationDialog.domNode)[0];
		tip.innerHTML = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_INTERFACE_TIP,[widgetTitle,"<span class='mumAWDNTipLink'>","</span>"])
		var link = dojo.query(".mumAWDNTipLink", tip)[0];
		dojo.connect(link,"onclick", this,"onClickOpenAWProperties");
	},
	
	setOuterWirePaneContext:function(iContext) {
		this.outerContext = iContext;	
	},
	
	onNotNotifyMeClicked: function(event){
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
    		var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
	    	var user = userModel.findCurrentUser().start();
		    user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS",!this.NotiCfgCheckNode.checked);
		    userModel.commit().start();
		}
	},
	
	onClickOpenAWProperties:function(){
		this.hide();
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID()
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.outerContext.widgetId);
		com.ibm.mm.builder.commonActions.editPage(currentPageId);
	},
	
	initContent:function(){
		this.wiringIcon.alt = this.wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME;			
		dojo.attr(this.wiringIcon,"src",builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png" :
		"/images/d_wiring_icon.png"));
		this.NotiCfgLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_DISABLE_NOTI;
		this.okText.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		dojo.connect(this.okText,"onclick", this,"hide")
		this.okTextHidden.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.autoWiringNotiDiv);
		this.notificationDialog = dijit.byId("this.notificationDialog");
		if(!this.notificationDialog)
			this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog(
				{
					id: "Mashup_Auto_Wiring_Disable_Tip_Dlg",
					needUnderLay:false,
					roundCorner:true,
					modelDialog:true,
					hasRightBottomResizer: false 
					    
				},
				contentDiv
			);
	},
	
	destroy:function() {
		this.notificationDialog.destroy();
	},
	
	show:function(widgetId) {
		this.updateContent(widgetId);
		this.notificationDialog.show();
	},
	
	hide:function(){
		if(this.notificationDialog) {
			this.notificationDialog.hide();
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification"] = true;
/**
 * @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification");



dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification", [dijit._Widget, dijit._Templated], {
	
	autoWiringResult: null,
	
	contentRoot: null,
	
	notificationDialog:null,
	
	widgetId: null,
	
	location:null,
	
	templateString: "<div dojoAttachPoint='autoWiringNotiDiv' class='mumAutoWiringNotiDiv'>" +
						"<div dojoAttachPoint='autoWiringNotiDivMain' class='mumAutoWiringNotiDivMain'>"+
							"<div dojoAttachPoint='titleNode' class='mumAutoWiringTitle'>" +
								"<span dojoAttachPoint='titleIconNode' class='mumAutoWiringTitleIcon'>" + 
								"</span>" +
								"<span dojoAttachPoint='titleText' class='mumAutoWiringTitleText'>" + 
								"</span>" +
							"</div>" +
							"<div dojoAttachPoint='contentNode' class='mumAutoWiringContent'>" +
							"</div>" +
							"<div dojoAttachPoint='actionsNode' class='mumAutoWiringActions'>" +
								"<div dojoAttachPoint='openWiringNode' class='mumAutoWiringOpenWiring'>" + 
								"</div>" +
								"<div dojoAttachPoint='NotiCfgNode' class='mumAutoWiringNotiCfg'>" + 
									"<input type='checkbox' dojoAttachPoint='NotiCfgCheckNode' dojoAttachEvent='onclick: onNotifyMeClicked' class='mumAutoWiringNotiCfgCheck'/>" +
									"<div dojoAttachPoint='NotiCfgLabel' class='mumAutoWiringNotiCfgLable'></div>" +
								"</div>" +
							"</div>" +
						"</div>" +
						"<div dojoAttachPoint='okNode' class='mumAutoWiringOk'>" +
							"<div dojoAttachPoint='okTextHidden' class='mumAutoWiringOKTextHidden'>" + 
							"</div>"+
							"<div dojoAttachPoint='okText' class='mumAutoWiringOKText'>" + 
							"</div>"+
						"</div>" +
					"</div>",
						
	constructor: function(){
		
	},
	
	onNotifyMeClicked:function(event){
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {
			var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
			var user = userModel.findCurrentUser().start();
			user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS", !this.NotiCfgCheckNode.checked);
			userModel.commit().start();
		}
	},
	
	onClickOpenWiring:function(){
		var widgetId = this.autoWiringResult.widgetId;
		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		var widgetIcon =widgetUtil.getWidgetInstanceIcon(widgetId);
		var dialogParam = {
			nodeWidth: "486px",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME,
			titleIconUrl: widgetIcon,
			leftBarWidth: "18px",
			rightBarWidth: "12px",
			displayCloseButton: true,
			hasRightBottomResizer: false
		}
		var payload = {
	    	widgetTypeId: "wireInterface",
	        eventName:  "com.ibm.mashups.builder.editWire",
	        eventPayload:  widgetId,
	        dialogParam:  dialogParam,
			hasRightBottomResizer: false,
	        requestRefresh: true
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	initContent:function(){
		this.fillInText();
		if(!this.autoWiringResult) return;
		
		this.titleIconNode.innerHTML = "";
		var wiringIcon = document.createElement("img");	
		this.titleIconNode.appendChild(wiringIcon);
		wiringIcon.alt = wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME;
		dojo.attr(wiringIcon,"src",builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png":"/images/d_wiring_icon.png"));	
		
		
		var publishToWidgets = this.autoWiringResult.publishTo;
		this.contentNode.innerHTML = "";
		var receiveFromWidgets = this.autoWiringResult.receiveFrom;
		for(var i = 0; i < publishToWidgets.length; i++) {
			var wireDiv = this.createWireDiv(publishToWidgets[i],"Send");
			this.contentNode.appendChild(wireDiv);
		}
		for(var i = 0; i < receiveFromWidgets.length; i++) {
			var wireDiv = this.createWireDiv(receiveFromWidgets[i],"Receive");
			this.contentNode.appendChild(wireDiv);
		}
		dojo.connect(this.openWiringNode,"onclick", this,"onClickOpenWiring");
		dojo.connect(this.okText,"onclick", this,"hide")
	},
	
	hide:function(){
		var notificationDlg = dijit.byId("Mashup_Auto_Wiring_Notification_Dlg" + this.widgetId);
		if(notificationDlg) {
			notificationDlg.hide();
			notificationDlg.destroy();
		}
	},
	
	createWireDiv:function(widgetId,type) {
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		var widgetIconUrl = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceIcon(widgetId);
		var wireDiv = document.createElement("div");
		dojo.addClass(wireDiv,"mumAutoWiringWireDiv");
		var iconDiv = document.createElement("div");
		wireDiv.appendChild(iconDiv);
		dojo.addClass(iconDiv,"mumAWWireDivIcon");

		var widgetIcon = document.createElement("img");
		iconDiv.appendChild(widgetIcon);
		
		widgetIcon.alt = widgetIcon.title= com.ibm.mm.builder.utils.htmlUtil.unEscapeString(widgetTitle);	
		dojo.attr(widgetIcon,"src",widgetIconUrl);	
		
		var textDiv = document.createElement("div");
		wireDiv.appendChild(textDiv);
		dojo.addClass(textDiv,"mumAWWireDivText");
		
		if(type == "Send") {
			textDiv.innerHTML = textDiv.title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_SENDING_TO,[widgetTitle]);
		}
		else {
			textDiv.innerHTML = textDiv.title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_RECEIVING_FROM,[widgetTitle]);
		}
		return wireDiv;
	},
	
	fillInText:function(){
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		if(this.location.inNVA)
			this.titleText.innerHTML = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_TITLE_FOR_WIDGET, [widgetTitle]);
		else
			this.titleText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_TITLE;
		
		this.openWiringNode.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_OPEN_WIRE_INTERFACE + "</a>";
		this.NotiCfgLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_DISABLE_NOTI;
		this.okText.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		this.okTextHidden.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
	},
	
	/**
	 * show the access control reassign dialog
	 */
	showAutoWiringResult: function(id,autoWiringResult,location){
		this.widgetId = id;
		this.autoWiringResult = autoWiringResult;
		this.location = location;
		
		dojo.subscribe("widgetDeleted"+id,this,"hide");
		
		this.initContent();
		var notificationDlg = dijit.byId("Mashup_Auto_Wiring_Notification_Dlg" + this.widgetId);
		if (notificationDlg){
			notificationDlg.destroy();
		}
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.autoWiringNotiDiv);
		
		this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog(
			{
				id: "Mashup_Auto_Wiring_Notification_Dlg"+this.widgetId,
				needUnderLay:false,
				roundCorner:true,
				modelDialog:false,
				initLeftPosition:location.x+"px",
				initTopPosition:location.y+"px",
				hasRightBottomResizer: false   
			},
			contentDiv
		);
		this.notificationDialog.show();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.pagesource.PageSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.pagesource.PageSource"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 * @author Erik (bizheng@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.pagesource.PageSource")





dojo.declare("com.ibm.mm.builder.iwidget.pagesource.PageSource", null, {
	
    imgControl: null,
    
    layoutIds:null,
    
	codeEditor: null,
	
	constructor: function(params){
		this.codeEditor = params.codeEditor;
		this.layoutIds = params.layoutIds;
	},
	
	/**
     * This is the action method when user click "Go to source" in mode selector.
     * It will display the Page Source custom dialog, show the page source in source mode.
     */
    openSource: function(){
        this.getSource();
        this.setPageSourceMode("source");
        dijit.byId("pageSourceContainer").show();
        com.ibm.mm.builder.utils.htmlUtil.setUnderlayBgColor();
        dijit.byId("pageSourceContainer")._position = function(){};
        if (this.imgControl){ this.imgControl.onOutImage(); }
    },
    
    /**
     * This is the action method when user click "Edit Mode" button in Page Source source mode.
     * It will change the page source from source mode to edit mode.
     */
    editMode: function(){
        this.setPageSourceMode("edit");
        var realSource = this.getUnescapedSourceFromEditor();
        if (document.all) {
            //For IE7, we have to replace SPAN to span
            realSource = realSource.replace(/SPAN/g, "span").replace(/DIV/g, "div");
        }
        var sourceContent = realSource.replace(/(<span)(.*?)(>)/g, "&lt;span$2&gt;<br>").replace(/<\/span>/g, "&lt;/span&gt;<br>").replace(/(<div)(.*?)(>)/g, "&lt;div$2&gt;<br>").replace(/<\/div>/g, "&lt;/div&gt;<br>").replace(/(<a)/g,"&lt;a").replace(/<\/a>/g,"&lt;/a&gt;<br>")
        var pageSourceEdit = dijit.byId("pageSourceEdit")
        if (!pageSourceEdit) {
            var editNodeTmp = dojo.byId('pageEdit')
            editNodeTmp.style.fontSize = "13px"
            editNodeTmp.innerHTML = sourceContent
            var editor = new dijit.Editor({id: "pageSourceEdit",height: '443px'}, editNodeTmp);
            editor.domNode.id = 'pageEdit';
        }else{
            pageSourceEdit.editNode.innerHTML = sourceContent
        }
        this.setEditModeBgColor();
    },   
    
    /**
     * This is the action method when user click "Source Mode" button in Page Source edit mode.
     * It will change the page source from source mode to edit mode.
     */
    sourceMode: function(){
        this.setPageSourceMode("source");
        var content = dijit.byId("pageSourceEdit").getValue().replace(/<br.*?>/g, '\n');
		
		this.codeEditor.setCode(this.unescape(content));
    },
	
    /**
     * This is the action method when user click "Save" button in Page Source source mode and edit mode.
     * Argument passed in saveSource should indicate whether current Page Source is source mode or edit mode
     * It will save the content in Page Source to current page, and call navigation api to render current page again.
     */
    saveSource: function(){
        var mode = arguments[0];
        var saveContent;
        if (mode == "source") {
			// source mode, get source from real dom
            saveContent = this.getUnescapedSourceFromEditor();
        }else{
			// edit mode, get the editor's value directly
            var editor = dijit.byId("pageSourceEdit");
            saveContent = editor.getValue().replace(/<br.*?>/g, '');
            saveContent = this.unescape(saveContent);
        }
		try{
			this.saveToPage(saveContent)
		}catch(e) {
            return;
        }
        dojo.publish(com.ibm.mm.builder.eventTopics.Page_ContentChanged,[saveContent]);
		serviceManager.getService("eventService").publishEvent("/enabler/pageChanged");
        dijit.byId("pageSourceContainer").hide();
    },	

    /**
     * This method is called by this.openSource().
     * It will get the source of current page and set it to the editor of source mode dialog of Page Source
     */
    getSource: function(){
        var data;
        try {
            data = this.getIWidgetsMarkup();
            data = data.replace(/SPAN/g, "span").replace(/(<span)([^>]*)(\/>)/g, "$1$2></span>").replace(/(<LINK)([^>]*)(\/>)/g, "").replace(/>/g, ">\n").replace(/<\//g, "\n</").replace(/(\n)(\n*)(\n)/g, "\n").replace(/\n\s*/g, "\n");
        } catch (e) {
            data = "no source for this page"
        }
		this.codeEditor.setCode(data);
    },
	    
	/**
     * This method will call navigation api to save the content into current page
     * @param content(stirng): the content to save into page
     */
    saveToPage: function(content){
		if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()){
			var pageContent = content || this.getIWidgetsMarkup() || "<div class='noPageContent'>" + 
					com.ibm.mm.builder.coreWidgetsStrings.W_NO_PAGE_TO_SHOW + 
				"</div>";
			com.ibm.mm.builder.utils.pageUtil.saveCurrentPage(pageContent);
		}
    },
	
	/**
	 * get unescaped source from editor
     * replace some tags in editor to get the real html source
     * @return formatted text in editor of view source
     */
    getUnescapedSourceFromEditor: function(){
        var realSource = frame.contentWindow.editor.innerHTML;
        realSource = this.unescape(realSource);
        realSource = realSource.replace(/<font.*?>/g, "").replace(/<\/font>/g, "").replace(/<br>/g, "");
        realSource = realSource.replace(/<FONT.*?>/g, "").replace(/<\/FONT>/g, "").replace(/<BR>/g, "").replace(/<SPAN>/g, "<span>").replace(/<DIV>/g, "<div>");
        return realSource;
    },
    
    /**
     * Parse the dom node of canvas and get the iwidget source code of page
     * @return the html content of current page
     */
    getIWidgetsMarkup: function(){	
		var source = "";
        var layouts = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().getLayouts();
		var i = 0;
		var getMarkupRecur = function(node, status){
			if (node) {
				dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, node).forEach(function(widget){
				    var toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.iWidgetContent, widget);
				    if (toDel.length > 0) {
				        widget.removeChild(toDel[0]);
				    }
				    toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.iWidgetLoading, widget);
				    if (toDel.length > 0) {
				        widget.removeChild(toDel[0]);
				    }					
					var oneFragment = com.ibm.mm.builder.utils.htmlUtil.getElementString(widget);
					source += oneFragment;
				});
				source += "\n";
			}
			if (node) {
				dojo.query("." + com.ibm.mm.builder.constant.mmGGadget, node).forEach(function(widget){
					try{
				   	 	var toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetChrome, widget);
				    	if (toDel.length > 0) {
							widget.removeChild(toDel[0]);
				    	}
				    	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetUserPrefs, widget);
				    	if (toDel.length > 0) {
							widget.removeChild(toDel[0]);
				    	}
				    	toDel = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.osGadgetContent, widget);
				    	if (toDel.length > 0) {
							widget.removeChild(toDel[0]);
				    	}
					}catch(e){console.log(e)}
					var oneFragment = com.ibm.mm.builder.utils.htmlUtil.getElementString(widget);
					source += oneFragment;
				});
				source += "\n";
			}

			if(i >= layouts.length) return;
			var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(layouts[i++]);
			var getMarkupDeferred = widgetWrapper.getMarkup();
			getMarkupDeferred.setFinishedCallback(getMarkupRecur);
			getMarkupDeferred.start();
		};
		getMarkupRecur();
		while(i < layouts.length){
			//wait until all the layouts are processed
		}
    	return source;
	},

	/**
	 * This method will set the visible of the page source window according the mode.
	 * @param {String} mode Page Source, mode=source or mode=edit
	 */
	setPageSourceMode: function(mode){
		if (mode == "source") {
		    dojo.byId('pageEdit').style.visibility = "hidden";
		    dojo.byId('pageEdit').style.display = "none";
		    dojo.byId('pageSource').style.visibility = "visible";
		    dojo.byId('pageSource').style.display = "";
		    dojo.byId('editButtons').style.visibility = "hidden";
		    dojo.byId('editButtons').style.display = "none";
		    dojo.byId('sourceButtons').style.visibility = "visible";
		    dojo.byId('sourceButtons').style.display = "";
		}else if (mode == "edit") {
			dojo.byId('pageSource').style.visibility = "hidden";
			dojo.byId('pageSource').style.display = "none";
			dojo.byId('pageEdit').style.visibility = "visible";
			dojo.byId('pageEdit').style.display = "";
			dojo.byId('sourceButtons').style.visibility = "hidden";
			dojo.byId('sourceButtons').style.display = "none";
			dojo.byId('editButtons').style.visibility = "visible";
			dojo.byId('editButtons').style.display = "";
		}
    },
	
	// since the new dialog is transparent, we need to set a white background of the dijit editor
    setEditModeBgColor: function(){
        var pageEditDiv = dojo.byId("pageEdit")
        var iframes = pageEditDiv.getElementsByTagName("IFRAME");
        if (iframes.length > 0) {
            iframes[0].style.backgroundColor = "white";
        }
    },
	
	// unescape the < >	
	unescape: function(str){
		str = str.replace(/&lt;/g, "<");
		str = str.replace(/&gt;/g, ">");
		str = str.replace(/&quot;/g, "\"");
		return str;
    }
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl");






/**
 */
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl", [dijit._Widget, dijit._Templated], {

	_eventConnects: null,
	
	widgetId: null,
	
	selectedTheme: null,
	
	templateString: "<div tabindex='0'  dojoAttachEvent='onclick:selectThemeByMouse' class='themesListControl'><div dojoAttachPoint='themesList'></div></div>",
	
	/**
     * Constructor.
     */
    constructor: function(){
		this._eventConnects = [];
		this.resourceBundle = com.ibm.mm.builder.coreWidgetsStrings;
    },
	
	refresh: function(themeId) {
		this._themeIdPrefix = this.widgetId +  "_theme_list_";
		this.themesList.innerHTML = "";
		
		var themeUtil = com.ibm.mm.builder.utils.themeUtil;
		var themeModel = themeUtil.getThemeModel();
		var defaultNode = themeUtil.getDefaultThemeNode();
        var defaultNodeId = defaultNode.getID();
		
		//load all existing themes, put the default at the top
		var iterator = themeModel.iterator();
		while (iterator.hasNext()) {
			
			var themeNode = iterator.next();
			var themeNodeId = themeNode.getID();
			
			var themeDiv = dojo.doc.createElement("div");
			dojo.attr(themeDiv, "id", this._themeIdPrefix + themeNodeId);
			dojo.attr(themeDiv, "tabindex", "0");
			
			var alt = themeUtil.getThemeTitle(themeNode,builderConfig.locale);
			
			/* some a11y */
			dojo.attr(themeDiv, "title",alt);
			dojo.attr(themeDiv, "aria-label", alt);
			dojo.attr(themeDiv, "role", 'button');
			dojo.attr(themeDiv, "wairole", 'button');			
			
			dojo.connect(themeDiv, "onkeypress", this, "selectThemeByKey");
			
			dojo.addClass(themeDiv, "space_theme_unselected");
			
			var imgNode = dojo.doc.createElement("img");
			
			var previewImgName = themeNode.getMetaData("preview-url");
			if(!previewImgName || previewImgName.length == 0){
				previewImgName = "preview.png";
			}
			
			dojo.attr(imgNode, "src", com.ibm.mm.builder.utils.themeUtil.getThemeModel().findResourceUrl(themeNode, previewImgName));
			dojo.attr(imgNode, "alt", alt);
			
			themeDiv.appendChild(imgNode);
			
			var titleNode = dojo.doc.createElement("div");
			titleNode.innerHTML = alt;
			themeDiv.appendChild(titleNode);
			dojo.addClass(titleNode, "theme_title");
			
			if ((0 < this.themesList.childNodes.length) && (defaultNodeId == themeNodeId)) {
                this.themesList.insertBefore(themeDiv, this.themesList.firstChild);
            } else {
                this.themesList.appendChild(themeDiv);
            }
        }
		
		if(themeId){
			this.setSelectedTheme(themeId);
		}else{
			// Select the default theme
			this.setSelectedTheme(defaultNodeId);
		}
		
	},
	
	_themeIdDecode: function(themeId){
		//var indexS = themeId.lastIndexOf('_');
		//return(themeId.substring(indexS + 1));
		return themeId.substring(this._themeIdPrefix.length);
	},
	
	setSelectedTheme: function(themeId){
		this.selectedTheme = themeId;
		this.highlightSelectedTheme(themeId);
		
	},
	
	highlightSelectedTheme: function(themeId){
		var themeDiv = dojo.byId(this._themeIdPrefix + themeId);	
		if (themeDiv) {
			var themes = themeDiv.parentNode.childNodes;
			
			for(var i=0; i< themes.length;i++){
				if(themes[i].className.indexOf("space_theme") > -1)
					if(themes[i].id == themeDiv.id){
						dojo.removeClass(themes[i], "space_theme_unselected");
						dojo.addClass(themes[i], "space_theme_selected");
						
						var isSelected = dojo.doc.createElement("span");
						dojo.addClass(isSelected,"access")
						isSelected.appendChild(dojo.doc.createTextNode(this.resourceBundle.I_MODE_IS_SELECT));
						themes[i].appendChild(isSelected);
					}
					else{
						dojo.removeClass(themes[i], "space_theme_selected");
						dojo.addClass(themes[i], "space_theme_unselected");
						dojo.forEach(
							dojo.query(".access",themes[i]),
							function(item){
								themes[i].removeChild(item);
							}
						);
					}
			}
		}
	},
	
	selectThemeByKey: function(evt){
		
		if (evt.keyCode != dojo.keys.ENTER && evt.charCode != dojo.keys.SPACE)
			return;	  
		var themeDiv = evt.target;

		this.setSelectedTheme(this._themeIdDecode(themeDiv.id));
					                  
	},
	
	selectThemeByMouse: function(evt){
		
		var clicked = evt.target;
		
		var themeDiv = null;
		if(clicked.tagName == "IMG")
			themeDiv = clicked.parentNode;
		else
			return;

		this.setSelectedTheme(this._themeIdDecode(themeDiv.id));
	},	
	
	/**
	 * @Override
	 */
	destroy: function() {
		dojo.forEach(this._eventConnects, dojo.disconnect);
		this.inherited(arguments);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl");






/**
 */
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl", [dijit._Widget, dijit._Templated], {

	_eventConnects: null,
	
	selectedIcon: null,
	
	widgetId: null,
	
	templateString: "<div dojoAttachPoint='iconsList' id='IconsContainer' dojoAttachEvent='onclick:selectIcon' class='iconsListControl'></div>",
	
	/**
     * Constructor.
     */
    constructor: function(){
		this._eventConnects = [];
		this._iconIdPrefix = "spaceEditor_icons_";
    },
	
	postMixInProperties: function() {
		this.bundle = com.ibm.mm.builder.coreWidgetsStrings;
        dojo.mixin(this, this.bundle);
    },
	
	refresh: function() {
		
		this.iconsList.innerHTML = "";
		var iconsNumber = 41;
		var altIndexBase = "EDIT_SPACE_ICON_ALT_IMAGE";
		var iconNodeAlt = this.bundle.EDIT_SPACE_ICON_ALT;
		for (var i = 1; i <= iconsNumber; i++) {
				
				var id = i < 10 ? ("0" + i) : i;
                var iconNodeId = this._iconIdPrefix + id;
				
				var iconDiv = dojo.doc.createElement("div");
				dojo.attr(iconDiv, "id", iconNodeId);
				dojo.attr(iconDiv, "tabIndex", "0");
				dojo.connect(iconDiv, "onkeypress", this, "selectIconByKey");
				dojo.addClass(iconDiv, "icon");
				
				var alt = this.bundle[altIndexBase + i]  || dojo.string.substitute(iconNodeAlt,[id]);
				
				/* some a11y */
				dojo.attr(iconDiv, "title", alt);
				dojo.attr(iconDiv, "aria-label", alt);
				dojo.attr(iconDiv, "role", 'button');
				dojo.attr(iconDiv, "wairole", 'button');
				
				if (i == 1) {
					dojo.addClass(iconDiv, "space_icon_selected");
					this.selectedIcon = iconDiv;
				}
				
				var imgNode = dojo.doc.createElement("img");
				
				dojo.attr(imgNode, "src", "/mum/images/spaceicons/icon-" + id+".gif");
				dojo.attr(imgNode, "alt", alt);
				

				
				iconDiv.appendChild(imgNode);
		
				this.iconsList.appendChild(iconDiv);
        }
		
	},
	
	getSelectedIconId : function() {
		return dojo.attr(this.selectedIcon, "id").substring(this._iconIdPrefix.length);
	},
	
	setSelectedIcon: function(iconId){
		var node = dojo.byId(this._iconIdPrefix + iconId);	
		if (node) {
			this._makeIconSelected(node);
		}
	},
	
	_makeIconSelected : function(newSelected) {
		if (this.selectedIcon) {
			dojo.removeClass(this.selectedIcon, "space_icon_selected");
			
			dojo.forEach(
				dojo.query(".access",this.selectedIcon),
				dojo.hitch(this, function(item){
					this.selectedIcon.removeChild(item);
				})
			);
						
		}
		dojo.addClass(newSelected, "space_icon_selected");
		this.selectedIcon = newSelected;
		
		var isSelected = dojo.doc.createElement("span");
		dojo.addClass(isSelected,"access")
		isSelected.appendChild(dojo.doc.createTextNode(this.bundle.I_MODE_IS_SELECT));
		newSelected.appendChild(isSelected);
	},
	
	selectIcon: function(evt){	
		var clicked = evt.target;
		if (!dojo.hasClass(clicked, "icon") && clicked.tagName != "IMG") {
			return;
		}
			
		var iconNode = dojo.hasClass(clicked, "icon") ? clicked : clicked.parentNode;
		if (this.selectedIcon == iconNode) {
			return;
		}
		this._makeIconSelected(iconNode);		
	},
	
	selectIconByKey : function(evt){
	
		if (evt.keyCode != dojo.keys.ENTER && evt.charCode != dojo.keys.SPACE)
			return;	  
			
		var iconDiv = evt.target;

		this.setSelectedIcon(iconDiv.id.substring(this._iconIdPrefix.length));
	
	},
	
	/**
	 * @Override
	 */
	destroy: function() {
		dojo.forEach(this._eventConnects, dojo.disconnect);
		this.inherited(arguments);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");

dojo.setObject("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants", {
	ModelName : {
		"SpacesCategory" : "spaces_category",
		"RecentlyVisitedSpaces" : "recently_visited_spaces",
		"FavoriteSpaces" : "favorite_spaces",
		"AllSpaces" : "all_spaces",
		"MySpaces" : "my_spaces"
	},
	Topic : {
		"Space" : {
			"create" : "/spaceManager/space/create",
			"update" : "/spaceManager/space/update",
			"delete" : "/spaceManager/space/delete",
			"filter" : "/spaceManager/space/filter",
			"refresh" : "/spaceManager/space/refresh",
			"switch" : "/spaceManager/space/switch",
			"switchPage" : "/spaceManager/space/switchPage",
			"addToFavorite" : "/spaceManager/space/addToFavorite",
			"removeFromFavorite" : "/spaceManager/space/removeFromFavorite",
			"refreshQuickAccess" : "/spaceManager/space/refreshQuickAccess"
		},
		"Category" : {
			"change" : "/spaceManager/category/change"
		},
		"Common" : {
			"showMessage" : "/spaceManager/common/showMessage",
			"hideMessage" : "/spaceManager/common/hideMessage"
		}
	},
	Config : {
		"FavoritesQuickAccess" : {
			"MAX_LENGTH" : builderConfig.favoriteSpacesMaximumNumber,
			"INITIAL_SIZE" : builderConfig.favoriteSpacesMaximumNumber
		}
	},
	
	Action : {
		"ADD_PAGE"		:	1,
		"ADD_FAVORITE"	:	2,
		"SHOW_SPACE"		:	3,
		"HIDE_SPACE"		:	4,
		"SHOW_PAGE"		:	5,
		"HIDE_PAGE"		:	6,
		"MAKE_HOME"		:	7,
		"UNMAKE_HOME"		:	8,
		"CREATE_SPACE"	:	9,
		"DELETE_SPACE"	:	10,
		"EDIT_SPACE"	:	11,
		"CHANGE_OWNER"	:	12,
		"DELETE_PAGE"	:	13,
		"EDIT_PAGE"		:	14,
		"REMOVE_FAVORITE":	15,
		"MOVE_PAGE":	16
	},
	CookieKey: {
		FAVORITES_QUICK_ACCESS: "digest.ignore.favorites.quick.access."
	},
	
	"ALL" : "all",
	"FAVORITE" : "favorite",
	"MY" : "my"
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.ModelAutoRegisterMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.ModelAutoRegisterMixin"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.model.ModelAutoRegisterMixin");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.model.ModelAutoRegisterMixin", null, {
	constructor : function(factory) {
		if (factory && this.getName()) {
			factory.register(this.getName(), this);
		}
	},
	
	getName : function() {
		return null;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ConfirmDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ConfirmDialog"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.ConfirmDialog");



dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ConfirmDialog", com.ibm.mm.builder.widget.CustomDialog, {

    resourceBundle: null,
	
	// attach point
	confirmForm: null,
	
	templateString: null,
	
	widgetsInTemplate: true,
	
    templateString:"\t\t<div dojoAttachPoint='dialogNode' class='custom_dialog'>\n\t\t    <div dojoAttachPoint='dialogDivsNode' class='customDialogDiv'>\n\t\t\t    <div dojoAttachPoint='titleBar' class='dialog_titlebar' waiRole='dialog' title='${title}'>\n\t\t\t\t    <div dojoAttachPoint='titleIconNode' class='dialog_titleIconNoIcon'></div>\n\t\t\t    \t<div dojoAttachPoint='titleNode' class='dialog_titlebar_title'>${title}</div>\n\t\t    \t</div>\n\t\t\t   \t<img dojoAttachPoint='closeButtonNode' title='${closeIconTitle}' alt='${closeIconTitle}' \" +\n\t\t\t    \tclass='dialog_titlebar_close' dojoAttachEvent='onclick:trueHide,onkeypress:hideWithKey' tabindex='0'></img>\n\t\t\t    <div class=\"space_manager\">\n\t\t\t\t\t<div class=\"iWidgetConfig\">\n\t\t\t\t\t\t<form dojoAttachPoint=\"confirmForm\">\n\t\t\t\t\t        <div dojoAttachPoint='containerNode' class='dialog_container'></div>\n\t\t\t\t\t\t\t<div class=\"spaceDialogBottomArea\">\n\t\t\t\t\t\t\t\t<div dojoType=\"com.ibm.mm.builder.dialog.DialogFooter\" \n\t\t\t\t\t\t\t\t\tIWID=\"_IWID_\" \n\t\t\t\t\t\t\t\t\tsaveText=\"${I_COMMON_OK}\" \n\t\t\t\t\t\t\t\t\tdojoAttachEvent=\"onSave: ok, onCancel:cancel\" />\n\t\t\t\t            </div>\n\t\t\t\t\t\t</form>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t    <span dojoAttachPoint='tabEnd' ></span>\n\t\t\t    <div dojoAttachPoint='leftBar' class='dialog_leftsidebar'></div>\n\t\t\t    <div dojoAttachPoint='rightBar' class='dialog_rightsidebar'></div>\n\t\t\t    <div dojoAttachPoint='endBar' class='dialog_endbar'></div>\n\t\t\t    <div dojoAttachPoint='leftResizeHandler' class='dialog_leftResize_handler' style='display:none'></div>\n\t\t\t    <div dojoAttachPoint='rightResizeHandler' class='dialog_rightResize_handler' style='display:none'></div>\n\t\t    </div>\n\t\t    <div dojoAttachPoint='rtShadow' class='dialog_rightTopCorner'></div>\n\t\t    <div dojoAttachPoint='rightShadow' class='dialog_rightShadow'></div>\n\t\t    <div dojoAttachPoint='cornerShadow' class='dialog_cornerShadow'></div>\n\t\t    <div dojoAttachPoint='lbShadow' class='dialog_leftBottomCorner'></div>\n\t\t    <div dojoAttachPoint='bottomShadow' class='dialog_bottomShadow'></div>\n    \t</div>\n",
    
    postMixInProperties: function() {
        dojo.mixin(this, this.resourceBundle);
    },
    
	postCreate: function() {
		this.inherited(arguments);
	},
	
	ok: function() {
		this.onOk();
	},
	
	cancel: function() {
		this.onCancel();
		this.hide();
	},
	
	onOk: function() {},
	
	onCancel: function() {}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.DeleteConfirmPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.DeleteConfirmPane"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.DeleteConfirmPane");





dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.DeleteConfirmPane", [dijit._Widget, dijit._Templated], {
	templateString:"<div class=\"\">\n\t\t\t<div class=\"delete_confirm_content_container\">\n\t\t\t <span class=\"icon\"></span>\n\t\t\t <span class=\"message\"  role=\"alert\">${message}</span>\n\t\t\t</div>\n\t\t\t\t\n\t\t\t<div class=\"clearthefloats\"></div>\n\t\t\t<div class=\"spaceDialogBottomArea\">\n\t\t\t\t<div dojoType=\"com.ibm.mm.builder.dialog.DialogFooter\" \n\t\t\t\t\tIWID=\"${id}\" \n\t\t\t\t\tsaveText=\"${I_COMMON_DELETE}\" \n\t\t\t\t\tdojoAttachEvent=\"onSave: ok, onCancel:hide\" />\n\t\t\t</div>\n</div>\t\t\t\n",
	message : "",
	
	widgetsInTemplate: true,
	
	postMixInProperties : function() {
		dojo.mixin(this, com.ibm.mm.builder.coreWidgetsStrings);
	},
	
	postCreate : function() {
		setTimeout(dojo.hitch(this,function(){
			dojo.attr(dojo.query(".message",this.domNode)[0], 'role', 'alert');
		}), 1000);
	},
	
	hide : function() {
	
	},
	
	ok : function(evt) {
		if (this.onOk) {
			this.onOk(evt);
		}
		dojo.stopEvent(evt);
	},
	
	onOk : function() {
		
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil"] = true;
(function(){
	dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil");
	
	
	
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var bundle = com.ibm.mm.builder.coreWidgetsStrings;
	
	var utils = {
		_dijit : null
	};
	
	utils.ui = {
		getContextRoot : function() {
			var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
			return cs.getValue(cs.CONTEXT_ROOT_BUILDER);
		},
	
		getLoadingNodeHtml : function() {
			return [
				"<div><span><img alt='' src='",
					this.getContextRoot(), "/images/loading.gif' ></span>",
					"<span>", bundle.I_SPACE_MANAGER_LOADING, "</span>",
				"</div>"	
			].join("");
		}
	};
	utils.ui.dialog = {
		openContentDialog : function(parentNode, dijitClass, dijitOpt, dialogOpt, reference) {
			if (reference) {
				reference.show();
			}
			else {
				var dialogDiv = dojo.doc.createElement("div");
				parentNode.appendChild(dialogDiv);
				var contentDiv = dojo.doc.createElement("div");			
				dialogDiv.appendChild(contentDiv);
				var onOkFunc = function() {};
				reference = new com.ibm.mm.builder.widget.CustomDialog(dialogOpt, dialogDiv);
				var dijit = new dijitClass(dijitOpt, contentDiv);
				dijit["hide"] = function() {
					reference.hide();
				};
				dijit["onOk"] = function() {
						var func = dijit[dialogOpt["okFunc"] || "_ok"];
						if (dojo.isFunction(func)) {
							var d = func.apply(dijit);
							if(d){
								d.addCallback(function(data) {
									reference && reference.hide();
									if (dojo.isFunction(dialogOpt["okCallback"])) {
										dialogOpt["okCallback"](data);
									}
								});
							}
							
						}
					};
				reference.show();
			}
		},
		//FIXME: the logic is wierd. We need refactor this part later.
		openConfirmDialog : function(parentNode, dijitOpt, dialogOpt, reference) {
				
			if (!utils._reference) {
				
				dialogOpt = dialogOpt || {};
				dijitOpt = dojo.mixin({}, dijitOpt, {
					context : utils.ui.getContextRoot()
				});
				var dialogDiv = dojo.doc.createElement("div");
				parentNode.appendChild(dialogDiv);
				var contentDiv = dojo.doc.createElement("div");			
				dialogDiv.appendChild(contentDiv);
				var onOkFunc = function() {};
				reference = new com.ibm.mm.builder.widget.CustomDialog(dialogOpt, dialogDiv);
				var dijit = new com.ibm.mm.builder.iwidget.spacemanager.widget.DeleteConfirmPane(dijitOpt, contentDiv);				

				utils._dijit = dijit;
				utils._reference = reference;
			}
			
			reference = utils._reference;
			if (utils._dijit) {
				utils._dijit["hide"] = function(){
					reference.hide();
				};
				utils._dijit["onOk"] = function(){
					var func = dialogOpt["okFunc"];
					if (dojo.isFunction(func)) {
						var d = func();
						if (d) {
							d.addCallback(function(data){
								reference && reference.hide();
								if (dojo.isFunction(dialogOpt["okCallback"])) {
									dialogOpt["okCallback"](data);
								}
							});
						}
					}
				};
			}
			reference.show();
			dojo.query(".message", reference.domNode)[0].innerHTML = dijitOpt.message;
			reference.setTitle(dialogOpt.title);
			
			return reference;
		}
	};
	
	utils.model = {	
		getSpaceACModel : function(space) {
			if (!space) {
				return null;
			}
			return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space);
		},
		
		getSpaceOwner : function(space) {
			var acModel = this.getSpaceACModel(space);
			if (acModel) {
				var owner = acModel.getOwner();
				return (owner && owner.getDisplayName()) || "";
			}
			return "";
		},
		
		getSpacePageACModel : function(space, page) {
			if (!space || !page) {
				return null;
			}
			var navModel = navigationUtil.getNavigationModel();
			var layoutModel = navModel.getLayoutModel(page.getID());
			var layoutNode = layoutModel.getRoot().start();
			return com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(space, layoutNode);
		},
	
		getSpacePageOwner : function(space, page) {
			if (page && space) {
				var acModel = this.getSpacePageACModel(space, page);
				if (acModel) {
					var owner = acModel.getOwner();
					if (owner) {
						return owner.getDisplayName();
					}
				}
			}
			return "";
		},
		
		retrieveFavoritesQuickAccess: function() {
			var cookieKeyPrefix = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.CookieKey.FAVORITES_QUICK_ACCESS;
			var userId = com.ibm.mm.builder.utils.userUtil.getCurrentUser().getLoginName();
			return dojo.cookie(cookieKeyPrefix+userId);
		},
		
		storeFavoritesQuickAccess: function(quickAccessList) {
			var cookieKeyPrefix = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.CookieKey.FAVORITES_QUICK_ACCESS;
			var userId = com.ibm.mm.builder.utils.userUtil.getCurrentUser().getLoginName();
			dojo.cookie(cookieKeyPrefix+userId, dojo.toJson(quickAccessList));
		}
	};
	
	utils.importPage = {
		
		NLS_THEME : "//atom:link[@ext:rel='theme']",
		
		NLS_CONTENT : "//atom:entry/atom:content[@type='application/xml']",
		
		NLS_NAVIGATION_NODE : "model:navigation-node",
		
		NLS_STATIC_CONTENT_PAGE : "model:static-content-page",
		
		NLS_TITLE : "model:title",
		
		NLS_DESCRIPTION : "model:description",
		
		NLS_NLS_STRING : "base:nls-string",
		
		getNavigationNS : function() {
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_NAVIGATION);
            var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
            var ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML]);
            for (prefix in serviceJson.namespaces) {
                ns[prefix] = serviceJson.namespaces[prefix];
            }
			return ns;
		},
		
		getResourceNS : function() {
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
            var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
            var ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML]);
            for (prefix in serviceJson.namespaces) {
                ns[prefix] = serviceJson.namespaces[prefix];
            }
			return ns;
		},
		
		getResourceCollectionsUrl : function() {
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
			return serviceJson.url;
		},
		
		updateTitleAndDescription : function(node, title, description, locale) {
			locale.replace(/-/g, "_");
			var ns = this.getResourceNS();
			var xpath = com.ibm.mashups.enabler.xml.XPath;
			var utilities = com.ibm.mm.enabler.utilities;
			var dom = com.ibm.mm.enabler.dom;
			var xmlNsUri = com.ibm.mm.enabler.model.NameSpaceFactory.getNameSpaceUri("xml");
			var contents = xpath.evaluateXPath(this.NLS_CONTENT, node, ns);
			if (contents.length) {
				for (var i = 0; i < contents.length; i++) {
					var content = contents[i];
					var parentNode = null;
					var navigationNodes = xpath.evaluateXPath(this.NLS_NAVIGATION_NODE, content, ns);
					var staticContentPageNodes = xpath.evaluateXPath(this.NLS_STATIC_CONTENT_PAGE, content, ns);
					if (navigationNodes && navigationNodes.length) {
						parentNode = navigationNodes[0];
					}
					else if (staticContentPageNodes && staticContentPageNodes.length) {
						parentNode = staticContentPageNodes[0];
					}
					if (parentNode) {
						if (title != null) {
							var titles = xpath.evaluateXPath(this.NLS_TITLE, parentNode, ns);
							var titleNode = null;
							if (titles && titles.length) {
								titleNode = titles[0];
							}
							else {
								titleNode = dom.createElement(node, this.NLS_TITLE, ns.model);
								parentNode.appendChild(titleNode);
							}
							this._updateLocalizedElement(node, titleNode, title, locale);
						}
						if (description != null) {
							var descriptions = xpath.evaluateXPath(this.NLS_DESCRIPTION, parentNode, ns);
							var descriptionNode = null;
							if (descriptions && descriptions.length) {
								descriptionNode = descriptions[0];
							}
							else {
								descriptionNode = dom.createElement(node, this.NLS_DESCRIPTION, ns.model);
								parentNode.appendChild(descriptionNode);
							}
							this._updateLocalizedElement(node, descriptionNode, description, locale);
						}
					}
				}
			}
		},
		
		_updateLocalizedElement : function(xmlDoc, elementNode, text, locale) {
			var ns = this.getResourceNS();
			var xpath = com.ibm.mashups.enabler.xml.XPath;
			var utilities = com.ibm.mm.enabler.utilities;
			var dom = com.ibm.mm.enabler.dom;
			var xmlNsUri = com.ibm.mm.enabler.model.NameSpaceFactory.getNameSpaceUri("xml");
			var nlsStrings = xpath.evaluateXPath(this.NLS_NLS_STRING, elementNode, ns);
			var localeFound = false;
			if (nlsStrings && nlsStrings.length) {
				var n = nlsStrings.length;
				while (--n >= 0) {
					var lang = utilities.getAttributeWithNS(nlsStrings[n], "xml:lang", "lang", xmlNsUri);
                	if (lang !== null && lang.replace(/-/g, "_") == locale) {
                    	dom.textContent(nlsStrings[n], text);
                    	localeFound = true;
                   		break;
                	}
				}
			}
			if (!localeFound) {
				var n = dom.createElement(xmlDoc, this.NLS_NLS_STRING, ns.base);
                n.setAttribute("xml:lang", locale);
                dom.textContent(n, text);	
				elementNode.appendChild(n);	
			}
		},
	
		updateTheme: function(node,themeId){
			var ns = this.getResourceNS();
			// locate theme link
            var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(this.NLS_THEME, node, ns );
            if (nodes && nodes.length > 0) {
				var tn = nodes[0]; 
            } else {
                // create link
                var tn = com.ibm.mm.enabler.dom.createElement(node, "atom:link", ns.atom);

				// set theme relation
                com.ibm.mm.enabler.utilities.setAttributeWithNS(node, tn, "ext:rel", "rel", ns["ext"], "theme");
                node.appendChild(tn);
            }
            // set theme uri
            var urlFactory = com.ibm.mashups.enabler.model.url.ModelUrlFactory;	
			var themeUrl = urlFactory.createModelUrl(urlFactory.THEME_URL, {});
			themeUrl.setNodes([{value : themeId, isID: true}]);
			com.ibm.mm.enabler.utilities.setAttributeWithNS(node, tn, "ext:uri", "uri", ns["ext"], themeUrl.getModelURI());
			com.ibm.mm.enabler.utilities.setAttributeWithNS(node, tn, "ext:uniquename", "uniquename", ns["ext"], themeId);
			tn.setAttribute("href", themeUrl.getAbsoluteURL());
		},
		
		updateParentPage : function(node, parentPageId) {
			var urlFactory = com.ibm.mashups.enabler.model.url.ModelUrlFactory;	
			var modelUrl = urlFactory.createModelUrl(urlFactory.NAVIGATION_URL, {});
			modelUrl.setNodes([{value : parentPageId, isID: true}]);
			var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
            var ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_THR, nsf.NS_XML, nsf.NS_OPENSEARCH, nsf.NS_XHTML, nsf.NS_APP, nsf.NS_XSI]);
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
			for (prefix in serviceJson.namespaces) {
                ns[prefix] = serviceJson.namespaces[prefix];
            }
                var thr = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("//thr:in-reply-to", node, ns);
                if (thr && thr.length > 0) {
                    com.ibm.mm.enabler.utilities.setAttributeWithNS(node,
                        thr[0], "ext:uri", "uri", ns["ext"], 
                        modelUrl.getModelURI());
                    thr[0].setAttribute("href", modelUrl.getAbsoluteURL());
                    thr[0].setAttribute("ref", modelUrl.getModelURI());
                } else {
                    thr = com.ibm.mm.enabler.model.Utils.createNode("thr:in-reply-to", ns.thr);
                    com.ibm.mm.enabler.utilities.setAttributeWithNS(node,
                        thr, "ext:uri", "uri", ns["ext"], 
                        modelUrl.getModelURI());
                    node.appendChild(thr);
                    thr.setAttribute("href", modelUrl.getAbsoluteURL());
                    thr.setAttribute("ref", modelUrl.getModelURI());
                }
		},
		
		constructMultipartFormdataBody : function(textContent) {
			var boundary = "AaBbCcDdEeFf",
				content = ["--", boundary, "\r\n"];
			content.push("Content-Disposition: form-data; name=\"xmlPage\"; filename=\"test.xml\"");
				content.push("\r\n");
				content.push("Content-Type: text/xml\r\n\r\n");
				content.push(textContent);
				content.push("\r\n");
				content.push("--" + boundary + "--");
			return content.join("");	
		}
	};
	
	utils.util = {
		delayCall : function(fnObj, delay) {
			delay = delay || 0;
			return window.setTimeout(fnObj, delay);
		},
		
		parseNmIdFromResponseData : function(data){
			var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_RESOURCE);
			var nsf = com.ibm.mm.enabler.model.NameSpaceFactory;
			var ns = nsf.getNameSpaces([nsf.NS_ATOM, nsf.NS_XML]);
			for (prefix in serviceJson.namespaces) {
				ns[prefix] = serviceJson.namespaces[prefix];
			}						
			
			var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("//atom:id", dojox.xml.parser.parse(data), ns );	
			return com.ibm.mm.enabler.dom.textContent(nodes[1]).split(":")[2];
		}
	};
	
	dojo.setObject("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil", utils);
	
})();

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore");




dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore", null, {
    
    constants: com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants,
    
    spaceUtil: com.ibm.mm.builder.utils.spaceUtil,
	
	enablerUtil : com.ibm.mm.builder.utils.enablerUtil,
	
	spaceManagerUtil: com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil,
    
    LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore"),
    
    constructor: function(kwArgs) {
      this._spacesStack =  this._getSpaceStack();
    },
    
    _getSpaceStack: function() {
    	var cookieValue = this.spaceManagerUtil.model.retrieveFavoritesQuickAccess();   
		
    	if (cookieValue && cookieValue != "undefined") {
			return dojo.fromJson(cookieValue);
		} else {
			return [];
		}
    },
    
    getValue: function(item, attribute, defaultValue) {
        this._assertIsItem(item);
        this._assertIsAttribute(attribute);
        
        switch (attribute) {
            case "id":
                return item.id || defaultValue;
            case "title":
                return item.title;//this.spaceUtil.getSpaceTitle(item.getID(), builderConfig.locale);
        }   
    },
	
	setValue: function(item, attribute, value) {
        this._assertIsItem(item);
        this._assertIsAttribute(attribute);
		
        item[attribute] = value;        
    },
    
    getValues: function(item, attribute){
        this._assertIsItem(item);
        this._assertIsAttribute(attribute);
        var value = this.getValue(item, attribute);
        return value ? [value] : []; // Array
    },
    
    getAttributes: function(item){
        return ["id", "title"];
    },
    
    _assertIsItem: function(item) {
        if (!item) {
            throw new Error("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore: Invalid item");
        }
    },
    
    _assertIsAttribute: function(attribute) {
        if(!dojo.isString(attribute)){ 
            throw new Error("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore: Invalid attribute argument.");
        }
    },
    
    _fetchItems: function(keywordArgs, findCallback, errorCallback){
        try {
            findCallback(this._spacesStack, keywordArgs);
        } catch (e) {
            errorCallback(e, keywordArgs);
        }
    },
    
    addToStack: function(space) {
        if (!space) {
            return;
        }
		var spaceItem = {"id":space.getID(), "title": this.enablerUtil.getNodeTitle(space) || ""};
        
		var index = this._indexOf(spaceItem);
		
        if (index >= 0) {
			this.setValue(this._getByIndex(index), "title", spaceItem.title);
            this._moveToTop(index);
            this.spaceManagerUtil.model.storeFavoritesQuickAccess(this._spacesStack);
            return;
        }
        
        this._spacesStack.unshift(spaceItem);
        if (this._spacesStack.length > this.constants.Config.FavoritesQuickAccess.MAX_LENGTH) {
            this._spacesStack.pop();
        }
        
        this.spaceManagerUtil.model.storeFavoritesQuickAccess(this._spacesStack);
    },
	
	_getByIndex: function(index){
		if(index >= 0 && this._spacesStack[index])
			return this._spacesStack[index];
		else
			return null;
	},
    
	removeFromStackById: function(spaceId) {
        if (!spaceId) {
            return;
        }
        
		var index = -1;
		if (this._spacesStack) {
            for (var i = 0, l = this._spacesStack.length; i < l; i++) {
                if (this.getValue(this._spacesStack[i], "id") === spaceId) {
                    index = i;
                }
            }
        }
		
        if (index >= 0) {
            this._remove(index);
        }
        
        this.spaceManagerUtil.model.storeFavoritesQuickAccess(this._spacesStack);
		
    },
    
    _indexOf: function(spaceItem) {
        if (this._spacesStack) {
            for (var i = 0, l = this._spacesStack.length; i < l; i++) {
                if (this.getValue(this._spacesStack[i], "id") === this.getValue(spaceItem, "id")) {
                    return i;
                }
            }
        }
        return -1;
    },
    
    _moveToTop: function(index) {
        var tempSpace = this._spacesStack[index];
        this._remove(index);
        this._spacesStack.unshift(tempSpace);
    },
    
    _remove: function(index) {
        if (index >= 0 && index < this._spacesStack.length) {
            this._spacesStack.splice(index, 1);
        }
    }
});
// Mix in the simple fetch implementation to this class.
dojo.extend(com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore, dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.FavoriteSpacesModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.FavoriteSpacesModel"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.model.FavoriteSpacesModel");




dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.model.FavoriteSpacesModel", 
    com.ibm.mm.builder.iwidget.spacemanager.model.ModelAutoRegisterMixin
, {
    _constants: com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants,
    
    getName : function() {
        return this._constants.ModelName.FavoriteSpaces;
    },
    
    constructor: function() {
        this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
        
        this._subscriptions = [];
        this._listFavoriteSpaces();
    },
    
    _listFavoriteSpaces: function() {
        var spaceModel = this.spaceUtil.getSpaceModel();
		spaceModel.setCursorPosition(0);
        var data = new com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore({
            dataIterator: spaceModel.findFavorites()
        });
        dojo.mixin(this, data);
        
        this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space.addToFavorite, dojo.hitch(this, this.addToStack)));
        this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space.removeFromFavorite, dojo.hitch(this, this.removeFromStackById)));
		this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space["delete"], dojo.hitch(this, this.removeFromStackById)));
    }
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.ModelFactory"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.ModelFactory"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.model.ModelFactory");




dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.model.ModelFactory", null, {
	constructor : function() {
		this._registry = {};
		this._setupModels();
	},
	
	_setupModels : function() {
		new com.ibm.mm.builder.iwidget.spacemanager.model.FavoriteSpacesModel(this);
	},
	
	getModel : function(name) {
		return this._registry[name];
	},
	
	register : function(name, modelImpl) {
		this._registry[name] = modelImpl;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions");




(function() {
var spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil,
    spaceUtil = com.ibm.mm.builder.utils.spaceUtil,
	pageUtil = com.ibm.mm.builder.utils.pageUtil,
    enablerUtil = com.ibm.mm.builder.utils.enablerUtil,
    bundle = com.ibm.mm.builder.coreWidgetsStrings,
    constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants,
    messages = com.ibm.mm.builder.coreWidgetsMessages,
    eventService = com.ibm.mashups.services.ServiceManager.getService("eventService"),
    navigationUtil = com.ibm.mm.builder.utils.navigationUtil;

com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space = {
    LOGGER : com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space"),

    importNewPage : function(spaceId) {
        var payload = {
            widgetTypeId: "importWidget",
            eventName: "com.ibm.mashups.builder.importWidgetAction",
            eventPayload: {spaceId : spaceId},
			requestRefresh: true,
            dialogParam: {
				title: bundle.I_IMPORT_PAGE_TITLE,
				nodeWidth: "328px",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
                containerBackgroundColor: "white",
                hasRightBottomResizer: false
            }};
        eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
    },

    canSaveAsTemplate : function(spaceId) {
		return !com.ibm.mm.builder.commonActions.hasHub();
    },
	
	canCreateSpace : function() {
		return spaceUtil.getSpaceModel().confirmCreate();
	},
	
	canImportSpace : function() {
		return spaceUtil.getSpaceModel().confirmCreate() && com.ibm.mm.builder.commonActions.isSpaceImportExportEnabled();
	},
	
    saveAsTemplate : function(spaceId) {
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
		var title = enablerUtil.getNodeTitle(space);
        var d = space.saveAsTemplate();
		
        d.setOperationCallback(function(node, mode, statusCode) {
			if (statusCode == 201) {
	            dojo.publish(constants.Topic.Common.showMessage, [dojo.string.substitute(bundle.I_SPACE_MANAGER_SAVE_SPACE_AS_TEMPLATE_OK, [title]), "info"]);
			} else {
	            dojo.publish(constants.Topic.Common.showMessage, [dojo.string.substitute(bundle.I_SPACE_MANAGER_SAVE_SPACE_AS_TEMPLATE_FAILED, [title])]);
			}
        });
        
        d.start();
    },
    
    exportSpace : function(spaceId) {
        if (!spaceId) {
            this.LOGGER.severe("exportSpace", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        var exportSpaceIframeName = "com.ibm.mashups.builder.spacemanager.exportSpace.iframe";
        var url = space.getExportSpaceURL();
        var iframe = dojo.io.iframe.create(exportSpaceIframeName);
		dojo.attr(iframe,'title',exportSpaceIframeName);
        dojo.io.iframe.setSrc(iframe, url, true);
    },
    
    deleteSpace : function(spaceId) {		
	   if (!spaceId) {
            this.LOGGER.severe("deleteSpace", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }

        var spaceModel = spaceUtil.getSpaceModel();
		var currentSpaceId = spaceUtil.getCurrentSpaceId();
        var space = spaceModel.find(spaceId).start();
        if (!space) {
            return;
        }
		
		var message = dojo.string.substitute(bundle["I_SPACE_MANAGER_DELETE_SPACE_PROMPT"], [enablerUtil.getNodeTitle(space)]);
		
        this._deleteSpaceDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete space",
			title : dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_SPACE_TITLE, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : function() {
                if(spaceUtil.isHomeSpace(spaceId)){
					spaceUtil.setHomeSpaceId();
				}
                
                if (com.ibm.mm.builder.commonActions.isSpaceInFavorite(spaceId)) {
					com.ibm.mm.builder.commonActions.removeSpaceFromFavorite(spaceId);
				}
                
                var d = new dojo.Deferred();				
                spaceModel.remove(space);
				
                var deferred = spaceModel.commit().start();                
                d.callback({});
                return d;
            },
            okCallback : function() {
                dojo.publish(constants.Topic.Space["delete"],[spaceId]);
                dojo.publish(constants.Topic.Space.refresh,[constants.Action.DELETE_SPACE, {spaceId: spaceId}]);
				/** remove favorite quick access in 2.0, 14521 **/
				//dojo.publish(constants.Topic.Space.refreshQuickAccess);
				eventService.broadcastEvent("com.ibm.mashups.builder.deleteSpace", {spaceId: spaceId, currentSpaceId: currentSpaceId});
            }
        },this._deleteSpaceDialog);
    },
    
    addSpaceToFavorite : function(spaceId) {
        if (!spaceId) {
            this.LOGGER.severe("addSpaceToFavorite", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        if (space && !space.isFavorite()) {            
            
			dojo.publish(constants.Topic.Space.addToFavorite, [space]);
			this._toggleSpaceFavorite(space);
			dojo.publish(constants.Topic.Space.refresh,[constants.Action.ADD_FAVORITE, {spaceId: space.getID()}]);
        }
    },
    
    removeSpaceFromFavorite : function(spaceId) {
        if (!spaceId) {
            this.LOGGER.severe("removeSpaceFromFavorite", messages.E_SPACE_MANAGER_SPACE_ID_IS_NULL_0);
            return;
        }
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        if (space && space.isFavorite()) {
            
            dojo.publish(constants.Topic.Space.removeFromFavorite, [spaceId]);
			this._toggleSpaceFavorite(space);
			dojo.publish(constants.Topic.Space.refresh,[constants.Action.REMOVE_FAVORITE, {spaceId: space.getID()}]);
			
        }
    },
    
    _toggleSpaceFavorite : function(space) {
        space.setFavorite(!space.isFavorite());
        spaceUtil.getSpaceModel().commit().start();
		/** remove favorite quick access in 2.0 **/
		//dojo.publish(constants.Topic.Space.refreshQuickAccess);
        eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
    },
	
	show : function(spaceId) {
		if (!spaceId) {
			return;
		}
		var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return;
		}
		space.setHidden(false);
		spaceUtil.getSpaceModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.SHOW_SPACE, {spaceId: spaceId}]);
		eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
	},
	
	hide : function(spaceId) {
		if (!spaceId) {
			return;
		}
		var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return;
		}
		space.setHidden(true);
		spaceUtil.getSpaceModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.HIDE_SPACE, {spaceId: spaceId}]);
		eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
	},
	
	canSetHidden : function(spaceId, hide) {
		if (!spaceId) {
			return false;
		}
		var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return false;
		}
		return space.confirmSetHidden(hide);
	},
	
	isHidden : function(spaceId) {
		if (!spaceId) {
			return true;
		}
        var space = spaceUtil.getSpaceNode(spaceId);
		if (!space) {
			return true;
		}
		return space.isHidden();
	},
	
	isNotHidden : function(spaceId) {
		return !com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.isHidden(spaceId);
	},
	
	isHideActionDisplayed : function(spaceId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space;
		return action.canSetHidden(spaceId, true) && action.isNotHidden(spaceId);
	},
	
	isShowActionDisplayed : function(spaceId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space;
		return action.canSetHidden(spaceId, false) && action.isHidden(spaceId);
	},
	
	editSpaceProperties : function(spaceId) {	
		var payload = {
			widgetTypeId: "editSpace",
			eventName: "com.ibm.mashups.builder.spaceEditor",
			eventPayload: {spaceId: spaceId, editSpaceInSpaceManager: true},
			requestRefresh: true,
			dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.EDIT_SPACE_PROPERTIES, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
				nodeWidth: "975px",
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			}
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	copySpace : function(spaceId) {
		var payload = {
			widgetTypeId: "copySpace",
			eventName: "com.ibm.mashups.builder.copySpace",
			eventPayload: {spaceId:spaceId, copySpaceInSpaceManager:true},
			requestRefresh: true,
			dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.COPY_SPACE_CAPTION, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
				nodeWidth: "350px",
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			}
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	createSpace : function() {
		var payload = {
           widgetTypeId: "createSpace",
            eventName: "com.ibm.mashups.builder.createSpace",
            eventPayload: {createSpaceFromSpaceManager:true},
            dialogParam: {
				title: com.ibm.mm.builder.coreWidgetsStrings.CREATE_SPACE_CAPTION,
                nodeWidth: "675px",
                containerBackgroundColor: "white",
                hasRightBottomResizer: false
            }
		};
    	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	importSpace : function() {
		var payload = {
           widgetTypeId: "importWidget",
            eventName: "com.ibm.mashups.builder.importWidgetAction",
            eventPayload: null,
			requestRefresh: true,
            dialogParam: {
				title: com.ibm.mm.builder.coreWidgetsStrings.I_IMPORT_SPACE_TITLE,
				nodeWidth: "328px",
                containerBackgroundColor: "white",
                hasRightBottomResizer: false
            }
		};
    	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	}
};


com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page = {
    
    LOGGER : com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page"),
    
    createNewPage : function(id, type) {
        var parentPageId = id;
        var spaceId = null;
        var navMode = navigationUtil.getNavigationModel();
        var spaceModel = spaceUtil.getSpaceModel();
        if (type == "space") {
            var space = spaceModel.find(id).start();
            spaceId = id;
            
            parentPageId = space.getRootNavigation().getID();
        }
        else {
            var parentPage = navMode.find(id).start();
            var space = spaceModel.findSpaceByNavigation(parentPage).start();
            spaceId = space.getID();
        }
        var bundle = com.ibm.mm.builder.coreWidgetsStrings;
			var payload = {
				widgetTypeId: "createPage",
				eventName: "com.ibm.mashups.builder.createPage",
				eventPayload: {"spaceId":spaceId, "parentPageId":parentPageId},
				requestRefresh: true,
				dialogParam: {
					nodeWidth: "675px",
					title: (type == "space") ? bundle.I_CREATE_PAGE_IN_SPACE_TITLE : dojo.string.substitute(bundle.I_CREATE_SUBPAGE_IN_SPACE_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(parentPageId)]),
					leftBarWidth: "0px",
					rightBarWidth: "0px",
					containerBackgroundColor: "white",
					hasRightBottomResizer: false
				}
			};
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
    },
    
    editPageProperties : function(pageId) {
        var payload = {
	    	widgetTypeId: "editPage",
	        eventName:  "com.ibm.mashups.builder.editPage",
	        eventPayload: {pageId: pageId, editPageInSpaceManager: true},
			requestRefresh: true,
	        dialogParam: { 
				id: pageId + "_pageProperty",
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EDIT_PROPERTIE_PAGE, [com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
				nodeWidth: "515px",
				containerBackgroundColor: "white",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
				hasRightBottomResizer: false
			}
		};
        eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
    },
    
    sharePage : function(pageId) {
		var pageName = com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId);
		if(!pageName || (pageName == null)){
			pageName = "";
		}
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_DIALOG_TITLE, [pageName]);
		
        var payload = {
            widgetTypeId: "sharePage",
            eventName:  "com.ibm.mashups.builder.sharePage",
            eventPayload:  pageId,
			requestRefresh: true,
            dialogParam: {
				title: title,
				nodeWidth: "774px",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
				hasRightBottomResizer: false
			}
        };
        eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
    },
    
    publishPage : function(pageId) {
        var currentPageName = com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle();
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_PUBLISH_PAGE_TITLE, [currentPageName]);
		
	    var payload = {
	        widgetTypeId: "publishWidget",
	        eventName: "com.ibm.mashups.builder.publishPage",
	        eventPayload: pageId,
			requestRefresh: true,
	        dialogParam: {
				title: title,
	            nodeWidth: "480px",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
	            containerBackgroundColor: "white",
	            hasRightBottomResizer: false
	        }
	    };
        eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
    },
    
    copyPage : function(pageId) {
        if (!pageId) {
            this.LOGGER.severe("copyPage", messages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
        var navModel = navigationUtil.getNavigationModel();
        var page = navModel.find(pageId).start();
        if (!page) {
            return;
        }
        var oldName = enablerUtil.getNodeTitle(page);
        var exportUrl = page.getExportPageURL();
		
		if(!exportUrl){
			this.LOGGER.severe("copyPage", messages.E_SPACE_MANAGER_PAGE_EXPORT_URL_IS_NULL_0);
			return;
		}
		
        dojo.xhrGet({
            url : exportUrl,
            handleAs : "text",
            load : dojo.hitch(this, function(data) {
                var node = dojox.data.dom.createDocument(data);
                var locale = dojo.locale;
                var newName = dojo.string.substitute(bundle.I_SPACE_MANAGER_COPY_OF, [oldName]);
                spaceManagerUtil.importPage.updateTitleAndDescription(node, newName, null, locale);
                var text = com.ibm.mm.enabler.dom.innerXML(node);
                dojo.rawXhrPost({
                    url : spaceManagerUtil.importPage.getResourceCollectionsUrl(),
                    postData : text,
                    headers : {
                        "Content-Type" : "text/xml"
                    },
                    load : dojo.hitch(this, function(data) {
						//parse data						
						var newPageId = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil.util.parseNmIdFromResponseData(data);
						var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(newPageId);
						var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(newPageId);
						var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);
					
                        dojo.publish(constants.Topic.Common.showMessage, ["save ok", "info"]);                        
						dojo.publish(constants.Topic.Space.refresh, [constants.Action.ADD_PAGE, {spaceId: spaceId, parentPageId: parentPageId, page: newPage}]);
                    }),
                    error : dojo.hitch(this, function() {
                        dojo.publish(constants.Topic.Common.showMessage, ["save error"]);
                    })
                });
            })
        });
    },
    
    exportPage : function(pageId) {
        if (!pageId) {
            this.LOGGER.severe("exportPage", messages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
        var exportURL = null;
        var page = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId);
        if (page != null) {
            exportURL = page.getExportPageURL();
        }
		if(!exportURL){
			this.LOGGER.severe("exportPage", messages.E_SPACE_MANAGER_PAGE_EXPORT_URL_IS_NULL_0);
			return;
		}
        var exportPageIframeName = "com.ibm.mashups.builder.spacemanager.exportPage.iframe";
        var iframe = dojo.io.iframe.create(exportPageIframeName);
        dojo.io.iframe.setSrc(iframe, exportURL, true);
    },
    
    deletePage : function(pageId) {
        if (!pageId) {
            this.LOGGER.severe("deletePage", messages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
		var spaceId = spaceUtil.getSpaceIdByPageId(pageId);
		var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(pageId);
		var currentPageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
		
        var navModel = navigationUtil.getNavigationModel();
        var page = navModel.find(pageId).start();
        if (!page) {
            return;
        }
        var message = dojo.string.substitute(bundle["I_SPACE_MANAGER_DELETE_PAGE_PROMPT"], [enablerUtil.getNodeTitle(page)]);
        this._deletePageDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete page",
			title: dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_PAGE_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : dojo.hitch(this, function() {
				var d = new dojo.Deferred();        
                navModel.remove(pageId);
                var deferred = navModel.commit();
                deferred.setOperationCallback(function(data) {
                d.callback(data);
                });
                deferred.start(false);
                return d;
            }),
            okCallback : dojo.hitch(this, function() {
                dojo.publish(constants.Topic.Space.refresh,[constants.Action.DELETE_PAGE, {spaceId:spaceId, parentPageId: parentPageId, pageId: pageId}]);
				eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.deletePage", {currentPageId:currentPageId, parentPageId: parentPageId, pageId: pageId});

            })
        },this._deletePageDialog);
        
    },
	
	canSetHidden : function(pageId, hide) {
		if (!pageId) {
			return false;
		}
		var navModel = navigationUtil.getNavigationModel();
        var page = navModel.find(pageId).start();
        if (!page) {
            return false;
        }
		return page.confirmSetHidden(hide);
	},
	
	show : function(pageId) {
		if (!pageId) {
			return;
		}
		var page = pageUtil.getPageNode(pageId);
		if (!page) {
			return;
		}
		page.setHidden(false);
		navigationUtil.getNavigationModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.SHOW_PAGE, {pageId: pageId}]);
	},
	
	hide : function(pageId) {
		if (!pageId) {
			return;
		}
		var page = pageUtil.getPageNode(pageId);
		if (!page) {
			return;
		}
		page.setHidden(true);
		navigationUtil.getNavigationModel().commit().start();
		dojo.publish(constants.Topic.Space.refresh,[constants.Action.HIDE_PAGE, {pageId: pageId}]);
	},
	
	isHidden : function(pageId) {
		if (!pageId) {
			return true;
		}
		var page = pageUtil.getPageNode(pageId);
		if (!page) {
			true;
		}
		return page.isHidden();
	},
	
	isNotHidden : function(spaceId) {
		return !com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page.isHidden(spaceId);
	},
	
	isHideActionDisplayed : function(pageId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page;
		return action.canSetHidden(pageId, true) && action.isNotHidden(pageId);
	},
	
	isShowActionDisplayed : function(pageId) {
		var action = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.page;
		return action.canSetHidden(pageId, false) && action.isHidden(pageId);
	}
};
})()

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.SpaceManager"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.SpaceManager");





dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.SpaceManager", null, {
	constructor : function() {
		this._modelFactory = new com.ibm.mm.builder.iwidget.spacemanager.model.ModelFactory();
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},
	
	getModelFactory : function() {
		return this._modelFactory;
	},
	
	getConstants : function() {
		return this._constants;	
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin"] = true;

dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin");


dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin", null, {
	
	constructor : function(options) {
		var opt = dojo.mixin({ spaceManager : null }, options);
		this._spaceManager = opt.spaceManager;
	},
	
	getSpaceManager : function() {
		return this._spaceManager;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerActionBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerActionBar"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerActionBar");




dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerActionBar", [dijit._Widget, dijit._Templated], {
	templateString: "<div class='action_buttons lotusBtnContainer'></div>",
	
	postCreate: function() {
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var actionButtons = mycontextmenu.getContextMenu("ContextMenu.SpaceManager.ActionBar", null, null, null);
		
		dojo.forEach(actionButtons, function(actionButton) {
			if (!actionButton.isSeparator) {
				this._createButton(actionButton);
			}
		}, this);
	},
	
	_createButton: function(button) {
		dojo.query(dojo.create("button", {
			innerHTML: button.title
		}, this.domNode)).addClass("lotusBtn lotusBtnAction").onclick(function(event) {
            button.actionCallBackFunction();
        });
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin"] = true;

dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin");




dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin", 
    [com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin], {
	constructor : function(options) {
		var modelNames = (options && options.modelNames) || this.getAssociatedModelNames();
		if (dojo.isArray(modelNames)) {
			
		}
		else if (dojo.isString(modelNames)) {
			var sm = this.getSpaceManager();
			var mf = sm.getModelFactory();
			dojo.mixin(this, {
				_model : mf.getModel(modelNames),
				getModel : function() {
					return this._model;
				}
			});
		}
	},
	
	getAssociatedModelNames : function() {
		return [];	
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector");







dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector", 
		[dijit._Widget, dijit._Templated], 
{
	templateString:"<div class=\"lotusMenu category_selector\">\n    <div class=\"lotusBottomCorner\">\n        <div class=\"lotusInner\">\n            <ul>\n            \t<li _type='all' class='lotusSelected'>\n            \t\t<a href='javascript:;'>${I_SPACE_MANAGER_ALL_SPACES}<span class=\"access\">${I_MODE_IS_SELECT}</span></a>\n            \t</li>\n            \t<li _type='favorite'>\n            \t\t<a href='javascript:;'>${I_SPACE_MANAGER_FAVORITE_SPACES}</a>\n            \t</li> \t\n            </ul>\n        </div>\n    </div>\n</div>\n",
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
	},
	
	postMixInProperties : function() {
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		dojo.mixin(this, this._bundle);
	},
	
	postCreate : function() {
		this.inherited(arguments);
		this._render();
	},
	
	_render : function() {
		this._setupCategories();
	},
	
	_setupCategories : function() {
		this._categories = [];
		dojo.query("ul > li", this.domNode).forEach(function(li) {
			this._categories.push(li);
			dojo.connect(dojo.query("a", li)[0], "onclick", this, this._categoryClicked);
			if (dojo.hasClass(li, "lotusSelected")) {
				this._selectedCategory = li;
			}
		}, this);
	},
	
	_categoryClicked : function(event) {
		if (!event) {
			return;
		}
		var node = event.target;
		if (node && node.parentNode) {
			var liNode = node.parentNode;
			if (this._selectedCategory === liNode) {
				return;
			}
			dojo.addClass(liNode, "lotusSelected");
			var isSelected = dojo.doc.createElement("span");
			dojo.addClass(isSelected,"access")
			isSelected.appendChild(dojo.doc.createTextNode(this.I_MODE_IS_SELECT));
			node.appendChild(isSelected);
						
			dojo.removeClass(this._selectedCategory, "lotusSelected");
			dojo.forEach(
				dojo.query(".access",this._selectedCategory),
				dojo.hitch(this, function(item){
					item.parentNode.removeChild(item);
				})
			);
						
			this._selectedCategory = liNode;
			this.selectCategory(dojo.attr(liNode, "_type"));
		}
		dojo.stopEvent(event);
	},
	
	selectCategory : function(category) {
		dojo.publish(this._constants.Topic.Category.change, [category,true]);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu"] = true;

dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu");



dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu", [dijit._Widget, dijit._Templated], {
	templateString : "<div class='actions_menu'><div dojoAttachPoint='_menuTextNode'><a href='javascript:;'>${I_SPACE_MANAGER_ACTIONS}</a></div></div>",
	
	spaceId : null,
	
	pageId : null,
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
	},
	
	postCreate : function() {
		this._menu = this._createMenu();		
	},
	
	postMixInProperties : function() {
		dojo.mixin(this, this._bundle);
	},
	
	_createMenu : function() {
		var menu = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.Menu({
						targetNodeIds:[this._menuTextNode],
						leftClickToOpen:true,
						spaceId:this.spaceId,
						pageId:this.pageId
					});
						
		dojo.addClass(menu.domNode, "spaceActionMenu");
		dojo.addClass(menu.domNode, "spaceManagerActionsMenu");
		
		menu.startup();
		return menu;
	}
});


dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.Menu",
	[com.ibm.mm.builder.widget.ShadowMenu], {
	
	prepareData: function(){
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var widgetMenus = [];
		if (this.spaceId) {
			widgetMenus = mycontextmenu.getContextMenu("ContextMenu.SpaceManager.Space", this.spaceId, "space", null);
		}
		else if (this.pageId) {
			widgetMenus = mycontextmenu.getContextMenu("ContextMenu.SpaceManager.Page", this.pageId, "page", null);
		}
		for (var i = 0, n = widgetMenus.length; i < n; ++i) {
			if (widgetMenus[i].isSeparator) {
				this.addChild(new dijit.MenuSeparator())
				continue;
			}
			var mitem = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.MenuItem({
				label: widgetMenus[i].title,
				iconClass: widgetMenus[i].iconClass,
				disabled:widgetMenus[i].enabled == "disabled",
				onClick: widgetMenus[i].actionCallBackFunction
			});	
			this.addChild(mitem);
		}
	}
	
});

dojo.declare(
	"com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu.MenuItem",
	[dijit.MenuItem], {
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList");











dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList", 
		[dijit._Widget, dijit._Templated], 
{
	templateString:"<div class=\"space_list\">\n\t<div dojoType=\"dijit.layout.StackContainer\" dojoAttachPoint=\"_container\" class=\"container\"></div>\n\t<div id=\"spaces_list_bottom\"></div>\n</div>\t\n",
	
	widgetsInTemplate : true,
	
	constructor : function() {
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this._spacesLoaded = {
		};
	},
	
	postMixInProperties : function() {
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},
	
	postCreate : function() {
		dojo.subscribe(this._constants.Topic.Category.change, dojo.hitch(this, this.changeCategory));
		dojo.subscribe(this._constants.Topic.Space.filter, dojo.hitch(this, this.filterByTitle));
		dojo.subscribe(this._constants.Topic.Space.refresh, dojo.hitch(this, this.refreshSpaces));
		
		this._container.addChild(new com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList({spacesListType: this._constants.ALL}, dojo.doc.createElement("div")));
		this._container.addChild(new com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList({spacesListType: this._constants.FAVORITE}, dojo.doc.createElement("div")));
		this._container.addChild(new com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList({spacesListType: this._constants.MY}, dojo.doc.createElement("div")));
		
		this._allSpacesList = this._getSpacesListByIndex(0);
		this._favoriteSpacesList = this._getSpacesListByIndex(1);
		this._mySpacesList = this._getSpacesListByIndex(2);
		
		this._container.startup();
		
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this.changeCategory, "all", true), 200);
	},
	
	_selectCategoryByIndex : function(index) {
		var child = this._getSpacesListByIndex(index);
		if (child) {
			this._container.selectChild(child);
		}
	},
	
	_getSpacesListByIndex : function(index) {
		var children = this._container.getChildren();
		if (index >= 0 && index < children.length) {
			return children[index];
		}
	},
	
	changeCategory : function(category, isRefreshNeeded) {
		var needRefresh = isRefreshNeeded || !this._spacesLoaded[category];
		
		switch (category) {
			case this._constants.ALL:
				this.currentCategory = this._constants.ALL;
				this._selectCategoryByIndex(0);
				this._showAllSpaces(needRefresh);
				break;
			case this._constants.FAVORITE:
				this.currentCategory = this._constants.FAVORITE;
				this._selectCategoryByIndex(1);
				this._showFavoriteSpaces(needRefresh);
				break;
			case this._constants.MY :
				this.currentCategory = this._constants.MY;
				this._selectCategoryByIndex(2);
				this._showMySpaces(needRefresh);
				break;
		}
		this._category = category;
		this._spacesLoaded[category] = true;
	},
	
	_showAllSpaces : function(isRefreshNeeded) {
		if (isRefreshNeeded) {
			var containerNode = this._allSpacesList.domNode;
			var spaceModel = this.spaceUtil.getSpaceModel();
			this._allSpacesList.refresh(spaceModel);
		}
	},
	
	_showFavoriteSpaces : function(isRefreshNeeded) {
		if (isRefreshNeeded) {
			var containerNode = this._favoriteSpacesList.domNode;
			var spaceModel = this.spaceUtil.getSpaceModel();
			this._favoriteSpacesList.refresh(spaceModel.findFavorites());
		}
	},
	
	_showMySpaces : function(isRefreshNeeded) {
		if (isRefreshNeeded) {
			this._mySpacesList.refresh({hasNext : function(){return false;}});
		}
	},
	
	filterByTitle : function(title) {
		dojo.query(".space_item_wrapper", this.domNode).forEach(function(node) {
			var titleNode = dojo.query(".title", node);
			if (titleNode && titleNode.length > 0) {
				var display = (title == "" || com.ibm.mm.builder.utils.htmlUtil.unEscapeString(titleNode[0].innerHTML).toLowerCase().indexOf(title) != -1) ? "block" : "none";
				dojo.style(node, "display", display);
			}
		});
	},
	
	_refreshSpacesList : function(category) {
		this.changeCategory(category || this._constants.ALL, true);
	},
	
	refreshSpaces : function(actionType, payload) {
		
		dojo.publish(this._constants.Topic.Common.hideMessage);
		
		if(!actionType || !payload){
			this._refreshSpacesList(this._category);
			return;
		}
		
		switch (actionType){
			case this._constants.Action.ADD_PAGE:
				this.refreshWithNewPages(payload);
				break;
			case this._constants.Action.ADD_FAVORITE:
				this.refreshWithAddFavorite(payload);
				break;	
			case this._constants.Action.REMOVE_FAVORITE:
				this.refreshWithRemoveFavorite(payload);
				break;	
			case this._constants.Action.SHOW_SPACE:
				this.refreshWithShowSpace(payload);
				break;	
			case this._constants.Action.HIDE_SPACE:
				this.refreshWithHideSpace(payload);
				break;	
			case this._constants.Action.SHOW_PAGE:
				this.refreshWithShowPage(payload);
				break;	
			case this._constants.Action.HIDE_PAGE:
				this.refreshWithHidePage(payload);
				break;
			case this._constants.Action.MAKE_HOME:
				this.refreshWithMakeHomeSpace(payload);
				break;	
			case this._constants.Action.UNMAKE_HOME:
				this.refreshWithUnmakeHomeSpace(payload);
				break;
			case this._constants.Action.CREATE_SPACE:
				this.refreshWithCreateSpace(payload);
				break;
			case this._constants.Action.DELETE_SPACE:
				this.refreshWithDeleteSpace(payload);
				break;
			case this._constants.Action.EDIT_SPACE:
				this.refreshWithEditSpace(payload);
				break;
			case this._constants.Action.CHANGE_OWNER:
				this.refreshWithChangeOwner(payload);
				break;
			case this._constants.Action.DELETE_PAGE:
				this.refreshWithDeletePage(payload);
				break;
			case this._constants.Action.EDIT_PAGE:
				this.refreshWithEditPage(payload);
				break;
			case this._constants.Action.MOVE_PAGE:
				this.refreshWithMovePage(payload);
				break;
		}
	},
	
	refreshWithDeletePage : function(payload){
		var pageId = payload.pageId;
		var spaceId = payload.spaceId;
		var parentPageId = payload.parentPageId;
		
		var pageNodes = dojo.query(".dijitVisible [page_id='"+pageId+"']");
		
		if(pageNodes.length > 0){
			var pageNode = pageNodes[0];
			var pageItem = dijit.byNode(pageNode);
			pageItem.destroyRecursive();
			
			var navMode = this.navigationUtil.getNavigationModel();
			var parentPageNodes = dojo.query(".dijitVisible [page_id='"+parentPageId+"']");
			
			if(parentPageNodes.length == 0){ //remove page from space				
			
				var space = this.spaceUtil.getSpaceNode(spaceId);				
				var rootNodeId = space.getRootNavigation();		
			
				var rootPage = navMode.find(rootNodeId).start();
				if (rootPage) {
					var hasPages = navMode.hasChildren(rootPage);					
					if(!hasPages){
						var spaceNode = dojo.query(".dijitVisible [space_id='"+spaceId+"']")[0];
						
						if(dijit.byNode(spaceNode)._togglerWidget){
							dojo.create("div", {	"class":"toggler", "dojoattachpoint": "_togglerNode", innerHTML: " "},dijit.byNode(spaceNode)._togglerWidget.domNode,"before");
							dijit.byNode(spaceNode)._togglerWidget.destroyRecursive();
							dijit.byNode(spaceNode)._togglerWidget  = null;
						}
					}
					if(this._constants.showPagesCount === "true"){		
						var count = 0;	
						var iterator = navMode.getChildren(rootPage);
						count = iterator.size().start();											
						var info = dojo.string.substitute(this._bundle["I_SPACE_MANAGER_SPACE_INFO"], [com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner(spaceId).getDisplayName(), count]);
						dojo.query(".info", spaceNode)[0].innerHTML = info;
					}
				}
			}else{
				var parentPage = this.pageUtil.getPageNode(parentPageId);
				if (parentPage) {
					var iterator = this.navigationUtil.getNavigationModel().getChildren(parentPage);
					count = iterator.size().start();
					if(count == 0){
						var parentPageNode = dojo.query(".dijitVisible [page_id='"+parentPageId+"']")[0];
						if(dijit.byNode(parentPageNode)._togglerWidget){
							dojo.create("div", {	"class":"toggler", "dojoattachpoint": "_togglerNode", innerHTML: " "},dijit.byNode(parentPageNode)._togglerWidget.domNode,"before");
							dijit.byNode(parentPageNode)._togglerWidget.destroyRecursive();
							dijit.byNode(parentPageNode)._togglerWidget  = null;
						}
					}
				}
			}
		}
		
	},
	
	refreshWithEditSpace : function(payload){
		var spaceId = payload.spaceId;
		this.refreshSpaceItem(spaceId);
	},
	
	refreshSpaceItem : function(spaceId){
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		if(spaceNodes.length > 0){
			var spaceNode = spaceNodes[0];
			var spaceItem = dijit.byNode(spaceNode);
			
			var newSpaceNode = dojo.create("div", {},spaceNode, "before");			
			spaceItem.destroyRecursive();
			
			var _self = this;
			var space = this.spaceUtil.getSpaceNode(spaceId);
			var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
				spaceMeta: {
					title: _self.enablerUtil.getNodeTitle(space) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
					description: _self.enablerUtil.getNodeDescription(space) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
					iconUrl: _self.spaceUtil.getSpaceIconURL(space),
					owner: _self.spaceManagerUtil.model.getSpaceOwner(space),
					pagesNum: _self._bundle["I_SPACE_MANAGER_PAGES_NUM_COUNTING"],
					space: space
				}
			}, newSpaceNode);
			
			space.isHidden() && dojo.addClass(spaceItem.domNode, "hidden_space");
		}
	},
	
	refreshWithEditPage : function(payload){
		var pageId = payload.pageId;	
		this.refreshPageItem(pageId);
		
	},
		
	refreshPageItem : function(pageId){
		var pageNodes = dojo.query(".dijitVisible [page_id='"+pageId+"']");
		if(pageNodes.length > 0){
			var pageNode = pageNodes[0];
			var pageItem = dijit.byNode(pageNode);
			var level = pageItem.level;
			
			var newPageNode = dojo.create("div", {},pageNode, "before");			
			pageItem.destroyRecursive();
			
			var _self = this;
			var pageOwner = "";
			var page = this.pageUtil.getPageNode(pageId);
			var spaceId = this.spaceUtil.getSpaceIdByPageId(pageId);
			if(this._constants.showPageOwner === "true")
				pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.spaceUtil.getSpaceNode(spaceId), page)
				
			var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
				pageMeta: {
					title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
					description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,					
					owner: pageOwner,
					level: level,
					space: _self.spaceUtil.getSpaceNode(spaceId),
					page: page,
					pageId: page.getID()
				}
			}, newPageNode);
			
			if(page.isHidden()){
				dojo.addClass(pageItem.domNode, "hidden_page");			
				dojo.addClass(pageItem._flagNode, "hidden_flag");
			}
		}
	},
	
	removePageItem : function(pageId, parentPageId){
		
		var spaceId = this.spaceUtil.getSpaceIdByPageId(pageId);
		this.refreshWithDeletePage({pageId:pageId, parentPageId:parentPageId, spaceId:spaceId});
	},
	
	refreshWithMovePage : function(payload){

		var currentPageId = payload.currentPageId;
		var currentPageParentId = payload.currentPageParentId;
		var targetPageId = payload.targetPageId;
		var targetPageParentId = payload.targetPageParentId;
		var position = payload.position;

		this.removePageItem(currentPageId, currentPageParentId);
		this.movePageItem(currentPageId, targetPageId, position);
		
	},
	
	movePageItem : function(currentPageId, targetPageId, position){
		
		var spaceId = this.spaceUtil.getSpaceIdByPageId(targetPageId);
		
			
		var page  = this.pageUtil.getPageNode(currentPageId);
		var space = this.spaceUtil.getSpaceNode(spaceId)
		
		var pageNodes = dojo.query(".dijitVisible [page_id='"+targetPageId+"']");
		
		
		
		if(pageNodes.length > 0){
			
			var targetPageNode = pageNodes[0];
			var pageItem = dijit.byNode(targetPageNode);
			
			var level = pageItem.level;
			var _self = this;
			
			var pageOwner = "";
			if(this._constants.showPageOwner === "true")
				pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.spaceUtil.getSpaceNode(spaceId), page)
					
			if(position !=="children"){ //move to next or previous
				var newPageNode = dojo.create("div", {}, targetPageNode, position==="previous"? "before" : "after");
				var newPageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
					pageMeta: {
						title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
						description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
						owner: pageOwner,
						level: level,
						space: space,
						page: page,
						pageId: page.getID()
					}
				}, newPageNode);
				
				
				if(page.isHidden()){
					dojo.addClass(newPageItem.domNode, "hidden_page");			
					dojo.addClass(newPageItem._flagNode, "hidden_flag");
				}							
				
			}else{//move as a child
				var parentPageNode = targetPageNode;
				var pagesNode = dojo.query(".pages", parentPageNode)[0];
				console.debug(pagesNode);
				var newPageNode = dojo.create("div", {}, pagesNode);
					
				var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
					pageMeta: {
						title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
						description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
						owner: pageOwner,
						level: dijit.byNode(parentPageNode).level + 1,
						space: space,
						page: page,
						pageId: page.getID()
					}
				}, newPageNode);
				
				var parentPage = this.pageUtil.getParentPageNode(currentPageId);
							
				if(page.isHidden()){
					dojo.addClass(pageItem.domNode, "hidden_page");			
					dojo.addClass(pageItem._flagNode, "hidden_flag");
				}
				
				if(!(dijit.byNode(parentPageNode)._togglerWidget)){
					dijit.byNode(parentPageNode)._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": parentPage, "space": space, "level": dijit.byNode(parentPageNode).level}, dojo.query(".toggler", parentPageNode)[0]);
				}
				// tactical solution to get updated root node; a more general
				// invalidation framework will be in place later on
				var navMode = this.navigationUtil.getNavigationModel();			
				navMode.invalidate(parentPage);
			}		
			
		} else {
			if (position == "children") {
				var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
				var rootNode = navigationUtil.getNavigationRootNode(spaceId);
				
				if (rootNode.getID() == targetPageId) {
					
					//FIXME the ugly copy code.
					var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
					var spaceNode = spaceNodes[0];
					var pagesNode = dojo.query(".pages", spaceNode)[0];
					var newPageNode = dojo.create("div", {}, pagesNode);
					
					var pageOwner = "";
					var _self = this;
					if(this._constants.showPageOwner === "true")
						pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, page);
						var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
						pageMeta: {
							title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
							description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
							owner: pageOwner,
							level: 1,
							space: _self.spaceUtil.getSpaceNode(spaceId),
							page: page,
							pageId: page.getID()
						}
					}, newPageNode);
					
					if(page.isHidden()){
						dojo.addClass(pageItem.domNode, "hidden_page");
						dojo.addClass(pageItem._flagNode, "hidden_flag");
					}
					
			
					if(!(dijit.byNode(spaceNode)._togglerWidget)){
						dijit.byNode(spaceNode)._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": parentPage, "space": space, "level": 0}, dojo.query(".toggler", spaceNode)[0]);
					}
					
					var navMode = navigationUtil.getNavigationModel();
					
					var rootNodeId = space.getRootNavigation();
					// tactical solution to get updated root node; a more general
					// invalidation framework will be in place later on
					navMode.invalidate(rootNodeId);
					
				
					if(this._constants.showPagesCount === "true"){
						var count = 0;
						var rootPage = navMode.find(rootNodeId).start();
						if (rootPage) {
							var iterator = navMode.getChildren(rootPage);
							count = iterator.size().start();
						}
						var info = dojo.string.substitute(_self._bundle["I_SPACE_MANAGER_SPACE_INFO"], [com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner(spaceId).getDisplayName(), count]);
						dojo.query(".info", spaceNode)[0].innerHTML = info;
					}
				}
			}
		}

	},
	
	refreshWithChangeOwner : function(payload){
		var spaceId = payload.spaceId;
		
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		if(spaceNodes.length > 0){
			var spaceNode = spaceNodes[0];
			var spaceItem = dijit.byNode(spaceNode);
			
			var space = this.spaceUtil.getSpaceNode(spaceId);
			if(!this.spaceUtil.isVisiable(space)){
				spaceItem.destroyRecursive();
				return;
			}
		
			var newSpaceNode = dojo.create("div", {},spaceNode, "before");			
			spaceItem.destroyRecursive();
			
			var _self = this;
			
			var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
				spaceMeta: {
					title: _self.enablerUtil.getNodeTitle(space) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
					description: _self.enablerUtil.getNodeDescription(space) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
					iconUrl: _self.spaceUtil.getSpaceIconURL(space),
					owner: _self.spaceManagerUtil.model.getSpaceOwner(space),
					pagesNum: _self._bundle["I_SPACE_MANAGER_PAGES_NUM_COUNTING"],
					space: space
				}
			}, newSpaceNode);
			space.isHidden() && dojo.addClass(spaceItem.domNode, "hidden_space");
			
		}
	},
	
	refreshWithDeleteSpace : function(payload){
		var spaceId = payload.spaceId;
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		var spacesListNode = null;
		if(spaceNodes.length > 0){
			var spaceNode = spaceNodes[0];
			spacesListNode = spaceNode.parentNode;
			var spaceItem = dijit.byNode(spaceNode);
			spaceItem.destroyRecursive();
		}
		
		if(spacesListNode.childNodes.length == 0){
			spacesListNode.innerHTML = this._bundle["I_SPACE_MANAGER_NO_SPACES_FOUND"];
		}
		
	},
	
	refreshWithCreateSpace : function(payload){
		var spaceId = payload.spaceId;
		var _self = this;
		var space = this.spaceUtil.getSpaceNode(spaceId);
		var spacesListNode = dojo.query(".spaces_list").filter(function(item){return (dojo.style(item, "display") != "none")})[0];
		
		if(this.currentCategory == this._constants.ALL || space.isFavorite()) {
			var spacesListNode = dojo.query(".spaces_list")
									.filter(function(item){return (dojo.hasClass(item, "dijitVisible"))})[0];
			
			if(spacesListNode.childNodes.length == 1){
				if(spacesListNode.childNodes[0].nodeType == 3){
					spacesListNode.innerHTML = "";
				}
			}
			
			var bindNode = dojo.create("div",{}, spacesListNode);
			var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
				spaceMeta: {
					title: _self.enablerUtil.getNodeTitle(space) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
					description: _self.enablerUtil.getNodeDescription(space) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
					iconUrl: _self.spaceUtil.getSpaceIconURL(space),
					owner: _self.spaceManagerUtil.model.getSpaceOwner(space),
					pagesNum: _self._bundle["I_SPACE_MANAGER_PAGES_NUM_COUNTING"],
					space: space
				}
			}, bindNode);			
			space.isHidden() && dojo.addClass(spaceItem.domNode, "hidden_space");			
			
			//if there is filter keyword
			var filterDijit = dijit.findWidgets(dojo.query(".filter_spaces")[0])[0];
			if(filterDijit._userEntered && filterDijit._inputNode.value)
				dojo.publish(this._constants.Topic.Space.filter, [filterDijit._inputNode.value.toLowerCase()]);
			
			if(dojo.style(spaceItem.domNode, "display") != "none")
				dijit.scrollIntoView(dojo.byId("spaces_list_bottom"));
			
		}
				
	},
	
	refreshWithMakeHomeSpace : function(payload){
		var spaceId = payload.spaceId;
		var originalHomeSpaceId = payload.originalHomeSpaceId;
		this.refreshSpaceItem(spaceId);
		
		this.refreshSpaceItem(originalHomeSpaceId);
	},
	
	refreshWithUnmakeHomeSpace : function(payload){
		var spaceId = payload.spaceId;
		this.refreshSpaceItem(spaceId);
	},
	
	refreshWithShowPage :function(payload){
		var pageId = payload.pageId;
		this.refreshPageActionsMenu(pageId);
		
		var pageNodes = dojo.query(".dijitVisible [page_id='"+pageId+"']");
		var pageNode = pageNodes[0];
		
		dojo.removeClass(pageNode, "hidden_page");
		dojo.removeClass(dijit.byNode(pageNode)._flagNode, "hidden_flag");
	},
	
	refreshWithHidePage : function(payload){
		var pageId = payload.pageId;
		this.refreshPageActionsMenu(pageId);
		
		var pageNodes = dojo.query(".dijitVisible [page_id='"+pageId+"']");
		var pageNode = pageNodes[0];
		
		dojo.addClass(pageNode, "hidden_page");
		dojo.addClass(dijit.byNode(pageNode)._flagNode, "hidden_flag");		
	},
	
	refreshWithShowSpace : function(payload){
		var spaceId = payload.spaceId;
		this.refreshSpaceActionsMenu(spaceId);
		
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		var spaceNode = spaceNodes[0];
		dojo.removeClass(spaceNode, "hidden_space");
	},
	
	refreshWithHideSpace : function(payload){
		var spaceId = payload.spaceId;
		this.refreshSpaceActionsMenu(spaceId);
		
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		var spaceNode = spaceNodes[0];
		dojo.addClass(spaceNode, "hidden_space");
	},
	
	refreshWithAddFavorite : function(payload){
		var spaceId = payload.spaceId;
		com.ibm.mm.builder.utils.spaceUtil.getSpaceModel(true);
		this.refreshSpaceActionsMenu(spaceId);
		
	},
	
	refreshWithRemoveFavorite : function(payload){
		var spaceId = payload.spaceId;
		com.ibm.mm.builder.utils.spaceUtil.getSpaceModel(true);
		
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		var spaceNode = spaceNodes.length > 0 ? spaceNodes[0] : null;
		
		var spacesListNode = spaceNode.parentNode;
		if(dojo.hasClass(spacesListNode, "favorite")){//remove space from fav list.
			var spaceItem = dijit.byNode(spaceNode);
			spaceItem.destroyRecursive();
			if(spacesListNode.childNodes.length == 0){
				spacesListNode.innerHTML = this._bundle["I_SPACE_MANAGER_NO_SPACES_FOUND"];
			}
			return;
		}
		
		this.refreshSpaceActionsMenu(spaceId);
	},

	
	refreshSpaceActionsMenu : function(spaceId){
	
		var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
		var spaceNode = spaceNodes.length > 0 ? spaceNodes[0] : null;
		
		if(spaceNode){
			var actionsNode = dojo.query(".space_item > .actions ", spaceNode)[0];
			var actionsMenuNode = dojo.query(".actions_menu", actionsNode)[0]; //dojo can not hendle with above 2 levels selectors query, dojo.query
			
			var newActionsMenuNode = dojo.create("div",{},actionsMenuNode,"before");
			var actionsMenuDijit = dijit.byNode(actionsMenuNode);
			actionsMenuDijit.destroyRecursive();
			var spaceItem = dijit.byNode(spaceNode);
			spaceItem._actionsWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu({spaceId : spaceId}, newActionsMenuNode);
		}
	},
	
	refreshPageActionsMenu : function(pageId){
	
		var pageNodes = dojo.query(".dijitVisible [page_id='"+pageId+"']");
		var pageNode = pageNodes.length > 0 ? pageNodes[0] : null;
		if(pageNode){
			var pageItem = dijit.byNode(pageNode);			
			var actionsMenuNode = pageItem._actionsWidget.domNode;			
			var newActionsMenuNode = dojo.create("div",{},actionsMenuNode,"before");
			
			pageItem._actionsWidget.destroyRecursive();
			
			pageItem._actionsWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu({pageId : pageId}, newActionsMenuNode);
			
		}
	},
	
	refreshWithNewPages : function(payload){
		var spaceId = payload.spaceId;
		var parentPageId = payload.parentPageId;
		var page = payload.page;
		
		var parentPage = this.pageUtil.getPageNode(parentPageId);
		var space = this.spaceUtil.getSpaceNode(spaceId);
		var _self = this;
		var parentPageNodes = dojo.query(".dijitVisible [page_id='"+parentPageId+"']");
		//if parent page is not root node of space
		if(parentPageNodes.length > 0){
			var parentPageNode = parentPageNodes[0];
			var pagesNode = dojo.query(".pages", parentPageNode)[0];
			var newPageNode = dojo.create("div", {}, pagesNode);
			var pageOwner = "";
			if(this._constants.showPageOwner === "true")
				pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, page);
				
			var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
				pageMeta: {
					title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
					description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
					owner: pageOwner,
					level: dijit.byNode(parentPageNode).level + 1,
					space: _self.spaceUtil.getSpaceNode(spaceId),
					page: page,
					pageId: page.getID()
				}
			}, newPageNode);
			
			if(page.isHidden()){
				dojo.addClass(pageItem.domNode, "hidden_page");
				dojo.addClass(pageItem._flagNode, "hidden_flag");
			}
			
			if(!(dijit.byNode(parentPageNode)._togglerWidget)){
				dijit.byNode(parentPageNode)._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": parentPage, "space": space, "level": dijit.byNode(parentPageNode).level}, dojo.query(".toggler", parentPageNode)[0]);
			}
			
			// tactical solution to get updated root node; a more general
			// invalidation framework will be in place later on
			var navMode = _self.navigationUtil.getNavigationModel();			
			navMode.invalidate(parentPage);
				
			
		}else{ // add pages under space
			var spaceNodes = dojo.query(".dijitVisible [space_id='"+spaceId+"']");
			var spaceNode = spaceNodes[0];
			var pagesNode = dojo.query(".pages", spaceNode)[0];
			var newPageNode = dojo.create("div", {}, pagesNode);
			var pageOwner = "";
			if(this._constants.showPageOwner === "true")
				pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, page);
			var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
				pageMeta: {
					title: _self.enablerUtil.getNodeTitle(page) || _self._bundle.I_SPACE_MANAGER_NO_TITLE,
					description: _self.enablerUtil.getNodeDescription(page) || _self._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
					owner: pageOwner,
					level: 1,
					space: _self.spaceUtil.getSpaceNode(spaceId),
					page: page,
					pageId: page.getID()
				}
			}, newPageNode);
			
			if(page.isHidden()){
				dojo.addClass(pageItem.domNode, "hidden_page");
				dojo.addClass(pageItem._flagNode, "hidden_flag");
			}
			
			if(!(dijit.byNode(spaceNode)._togglerWidget)){
				dijit.byNode(spaceNode)._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : pagesNode, "parentPage": parentPage, "space": space, "level": 0}, dojo.query(".toggler", spaceNode)[0]);
			}
			
			var navMode = _self.navigationUtil.getNavigationModel();
			var rootNodeId = space.getRootNavigation();
			// tactical solution to get updated root node; a more general
			// invalidation framework will be in place later on
			navMode.invalidate(rootNodeId);
			
			if(this._constants.showPagesCount === "true"){
				var count = 0;
				var rootPage = navMode.find(rootNodeId).start();
				if (rootPage) {
					var iterator = navMode.getChildren(rootPage);
					count = iterator.size().start();
				}
				var info = dojo.string.substitute(_self._bundle["I_SPACE_MANAGER_SPACE_INFO"], [com.ibm.mm.builder.utils.acModelUtil.getSpaceOwner(spaceId).getDisplayName(), count]);
				dojo.query(".info", spaceNode)[0].innerHTML = info;
			}
			
		}
	},
	
	onSpaceCreated : function(space) {
		this.refreshSpaces();
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpacesList", 
		[dijit._Widget, dijit._Templated], {
	templateString : "<div class='spaces_list'></div>",
	
	constructor : function() {
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},

	postCreate : function() {
		dojo.addClass(this.domNode, this.spacesListType);
		dojo.attr(this.domNode, "spaces_list_type", this.spacesListType)
	},
	
	_isHiddenSpace : function(space) {
		return space.isHidden();
	},
	
	_canEditSpace : function(space) {
		return this.spaceUtil.canEdit(space);
	},
	
	refresh : function(spaceModel) {
		var containerNode = this.domNode;
		containerNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._loadSpaces, spaceModel));
	},
	
	_loadSpaces : function(spaceModel) {
	
		var containerNode = this.domNode;		
		var hasSpaces = false;
		spaceModel.setCursorPosition(0);
		containerNode.innerHTML = "";
		
		//disable filter field before loading spaces
		var filterDijit = dijit.findWidgets(dojo.query(".filter_spaces")[0])[0];
		dojo.attr(filterDijit._inputNode, "disabled", "true");
		
		while (spaceModel.hasNext()) {
			hasSpaces = true;
			var space = spaceModel.next();
			if (!this._isHiddenSpace(space) || this._canEditSpace(space)) {
				var node = dojo.create("div", {}, containerNode);
				
				var spaceItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem({
					spaceMeta: {
						title: this.enablerUtil.getNodeTitle(space) || this._bundle.I_SPACE_MANAGER_NO_TITLE,
						description: this.enablerUtil.getNodeDescription(space) || this._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
						iconUrl: this.spaceUtil.getSpaceIconURL(space),
						owner: this.spaceManagerUtil.model.getSpaceOwner(space),
						pagesNum: this._bundle["I_SPACE_MANAGER_PAGES_NUM_COUNTING"],
						space: space
					}
				}, node);
				if (this._isHiddenSpace(space)) {
					dojo.addClass(spaceItem.domNode, "hidden_space");
				}
				
				//if there is filter keyword
				if(filterDijit._userEntered && filterDijit._inputNode.value)
					dojo.publish(this._constants.Topic.Space.filter, [filterDijit._inputNode.value.toLowerCase()]);
			}
		}
		
		//enable filtere field after loading spaces
		dojo.removeAttr(filterDijit._inputNode, "disabled");
		
		if (!hasSpaces) {
			containerNode.innerHTML = this._bundle["I_SPACE_MANAGER_NO_SPACES_FOUND"];
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceItem", 
		[dijit._Widget, dijit._Templated], {
	spaceMeta : {},		
			
	templateString:"<div class=\"space_item_wrapper\" space_id=\"${spaceInfo.spaceId}\">\n    <div class=\"space_item\">\n        <div class=\"toggler\" dojoAttachPoint='_togglerNode'>\n        </div>\n        <div dojoAttachPoint=\"_iconNode\">\n        </div>\n        <div class=\"main\">\n            <div class='_titleDiv'>\n                <span tabindex=\"0\" class=\"title\" dojoAttachPoint='_titleNode'>${spaceInfo.title}</span>\n\t\t\t\t<span class='customInfo' dojoAttachPoint='_customInfo'></span>\n                <span class='hidden_space_hint'>${I_SPACE_MANAGER_HIDDEN}</span>\n                <span class='clear:both;'></span>\n            </div>\n\t\t    <span class=\"optionalSeparator\">|</span>\n            <div class=\"info\" dojoAttachPoint=\"_infoNode\">\n                ${spaceInfo.info}\n            </div>\n            <div class=\"description\">\n                ${spaceInfo.description}\n            </div>\n        </div>\n        <div class=\"actions\">\n            <div dojoAttachPoint='_actionsNode'>\n            </div>\n        </div>\n        <div class=\"pages\">\n        </div>\n    </div>\n",			
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		
	},
			
	postMixInProperties : function() {
		var otherInfo;
		if (this.spaceMeta.owner != null & this.spaceMeta.owner != "") {
			otherInfo = dojo.string.substitute(this._bundle["I_SPACE_MANAGER_SPACE_INFO"], [this.spaceMeta.owner, this.spaceMeta.pagesNum]);		
		} else {
			otherInfo = this._bundle.I_SPACE_MANAGER_SPACE_INFO_NO_OWNER;	
		}
				
		this.spaceInfo = {
				title: "",
				description: "",
				info: otherInfo,
				spaceId : this.spaceMeta.space.getID()
		};
		this.space = this.spaceMeta.space;
		this.iconUrl = this.spaceMeta.iconUrl;
		dojo.mixin(this, this._bundle);
	},	
	
	transformDescriptionForXss: function(){
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(this.spaceMeta.description));
		var parentNode = dojo.query(".description", this.domNode)[0];
		parentNode.appendChild(textNode);
		
		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = this.spaceMeta.description;
		parentNode.setAttributeNode(titleAttr);
		
		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateNodeText(parentNode, 420, "title", {fontSize:"12px"});
		},0);
	},
	
	transformTitleForXss: function(){	
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(this.spaceMeta.title));
		var parentNode = dojo.query(".title", this.domNode)[0];
		parentNode.appendChild(textNode);		

		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = this.spaceMeta.title;
		parentNode.setAttributeNode(titleAttr);

		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateNodeText(parentNode, 400, "title", {fontSize:"14px"});
		},0);
		
		if(com.ibm.mm.builder.utils.spaceUtil.isHomeSpace(this.space.getID())){								
			this._customInfo.innerHTML = " " + (this._bundle.I_SPACE_IS_HOME_SPACE || "Home Space");
		}
		
	},
	
	truncateNodeText : function(/* DomNode */node, widthLimit, /* String */tipField, /*obj */fontStyle){
		var	textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
		if(!tipField){
			tipField = "title";
		}
		var str = dojo.string.trim(node[textField]);
		if(str.length == 0 ){return;}
		if (widthLimit > 0) {
			var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, node, widthLimit,fontStyle);
			if(shortStr.length <= str.length + 2 && !dojo.hasAttr(node,tipField)){
				dojo.attr(node,tipField,com.ibm.mm.builder.utils.htmlUtil.unEscapeString(str));
			}		
			node[textField] = (textField === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(shortStr) : shortStr;
		}
	},
	
	postCreate : function() {
	
		this.transformTitleForXss();		
		this.transformDescriptionForXss();
		
		this._pagesNode = dojo.query(".pages", this.domNode)[0];
		this._togglerNode = dojo.query(".toggler", this.domNode)[0];
		
		if (this.space) {	
			var spaceId = this.space.getID();
			dijit.setWaiRole(this._titleNode,"link"); 
		    dojo.attr(this._titleNode,"aria-label",this._titleNode.innerHTML);
			dojo.connect(this._titleNode, "onclick",this, function() {
				dojo.publish(this._constants.Topic.Space["switch"], [spaceId]);
			});
			dojo.connect(this._titleNode, "onkeypress",this, function(evt) {
				if (evt.keyCode != dojo.keys.ENTER)
					return;	  		
				dojo.publish(this._constants.Topic.Space["switch"], [spaceId]);
			});
			
			if (this.iconUrl) {
				dojo.addClass(this._iconNode, "space_icon");
				var img = dojo.doc.createElement("img");
				dojo.attr(img, {
					"alt" : "",
					"src" : this.iconUrl
				});
				this._iconNode.appendChild(img);
			}
			
			var actionsNode = this._actionsNode;
			this._actionsWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu({spaceId : spaceId}, actionsNode);
			
			this._loadPages();
		}
	},
	
	_loadPages : function() {
	
		var navMode = this.navigationUtil.getNavigationModel();
		var rootNodeId = this.space.getRootNavigation();		
		var rootPage = navMode.find(rootNodeId).start();
		var hasPages = navMode.hasChildren(rootPage);
		
		if(this._constants.showPagesCount === "true"){
			var count = 0;			
			
			if (rootPage) {
				var iterator = navMode.getChildren(rootPage);
				count = iterator.size().start();
			}
			this._updateInfo(count);
		}else{
			this._updateInfo(-1);
		}

		
		if (hasPages) {
			this._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : this._pagesNode, "parentPage": rootPage, "space": this.space, "level": 0}, this._togglerNode);
		}
	},
	
	_updateInfo : function(pageNum) {
		var info = "";
		if (pageNum > -1) 
			info = dojo.string.substitute(this._bundle["I_SPACE_MANAGER_SPACE_INFO"], [this.spaceMeta.owner, pageNum]);
		else {
			info = dojo.string.substitute(this._bundle["I_SPACE_MANAGER_SPACE_INFO"], [this.spaceMeta.owner, 0]);
			info = info.substring(0, info.indexOf("|"));
		}
			
		if (this.spaceMeta.owner != null & this.spaceMeta.owner != "") {
			this._infoNode.innerHTML = info;
		}
		else {
			this._infoNode.innerHTML = this._bundle.I_SPACE_MANAGER_SPACE_INFO_NO_OWNER;
		}
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem", 
		[dijit._Widget, dijit._Templated], {
	pageMeta : {},		
			
	templateString:"<div class=\"page_item\" page_id=\"${pageInfo.pageId}\">\n    <div dojoAttachPoint='_intentNode' class='intent'>\n    </div>\n    <div class=\"toggler\" dojoAttachPoint='_togglerNode'>\n    </div>\n    <div class=\"icon\" dojoAttachPoint=\"_iconNode\">\n    </div>\n    <div class=\"main\"  dojoAttachPoint='_mainNode'>\n        <div dojoAttachPoint='_flagNode'>\n            <span tabindex=\"0\" class=\"title\" dojoAttachPoint='_titleNode'>${pageInfo.title}</span>\n            <span class='hidden_page_hint'>${I_SPACE_MANAGER_HIDDEN}</span>\n        </div>\n        <div class=\"info\">\n            ${pageInfo.info}\n        </div>\n        <div class=\"description\">\n            ${pageInfo.description}\n        </div>\n    </div>\n    <div class=\"actions\">\n        <div dojoAttachPoint='_actionsNode'>\n        </div>\n    </div>\n    <div class=\"pages\" dojoAttachPoint=\"_pagesNode\">\n    </div>\n</div>\n",			
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},
			
	postMixInProperties : function() {
		this.pageInfo = {
			pageId : this.pageMeta.pageId,
			title : "",
			description : "",
			info : !!this.pageMeta.owner ? dojo.string.substitute(this._bundle["I_SPACE_MANAGER_PAGE_INFO"], [this.pageMeta.owner]) : ""
		};
		dojo.mixin(this, this._bundle);
		this.space = this.pageMeta.space;
		this.page = this.pageMeta.page;
		this.level = this.pageMeta.level;
	},	
	
	truncateIfTooLong: function(str, len){
		if(str && str.length >len)
			return str.substring(0,len-(this.pageMeta.level-1)*3)+"...";
		return str;
	},
	transformDescriptionForXss: function(){
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(this.pageMeta.description));
		var parentNode = dojo.query(".description", this.domNode)[0];
		parentNode.appendChild(textNode);
		
		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = this.pageMeta.description;
		parentNode.setAttributeNode(titleAttr);
		
		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateNodeText(parentNode, 370, "title", {fontSize:"12px"});
		},0);
	},
	
	transformTitleForXss: function(){
		var textNode = dojo.doc.createTextNode(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(this.pageMeta.title));
		var parentNode = dojo.query(".title", this.domNode)[0];
		parentNode.appendChild(textNode);
		
		var titleAttr = dojo.doc.createAttribute("title");
		titleAttr.nodeValue = this.pageMeta.title;
		parentNode.setAttributeNode(titleAttr);
		
		//truncate
		var _self = this;
		setTimeout(function(){
			_self.truncateNodeText(parentNode, 370, "title", {fontSize:"14px"});
		},0);
	},
	
	truncateNodeText : function(/* DomNode */node, widthLimit, /* String */tipField, /*obj */fontStyle){
		var	textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
		if(!tipField){
			tipField = "title";
		}
		widthLimit -= 30*(this.pageMeta.level-1);
		var str = dojo.string.trim(node[textField]);
		if(str.length == 0 ){return;}
		if (widthLimit > 0) {
			var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, node, widthLimit,fontStyle);
			if(shortStr.length <= str.length + 2 && !dojo.hasAttr(node,tipField)){
				dojo.attr(node,tipField,com.ibm.mm.builder.utils.htmlUtil.unEscapeString(str));
			}		
			node[textField] = (textField === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(shortStr) : shortStr;
		}
	},
  
	postCreate : function() {
		
		this.transformTitleForXss();
		this.transformDescriptionForXss();
		if (this.page) {
			var pageId = this.page.getID();
			dijit.setWaiRole(this._titleNode,"link"); 
			dojo.attr(this._titleNode,"aria-label",this._titleNode.innerHTML);
			dojo.connect(this._titleNode, "onclick", this, function() {
				dojo.publish(this._constants.Topic.Space.switchPage, [pageId]);
			});
			dojo.connect(this._titleNode, "onkeypress", this, function(evt) {
				if (evt.keyCode != dojo.keys.ENTER)
					return;  	
				dojo.publish(this._constants.Topic.Space.switchPage, [pageId]);
			});
			this._actionsWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.ActionsMenu({pageId : pageId}, this._actionsNode);
			this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._showToggle), 100);
		}
		if (this.pageMeta.level) {
			dojo.style(this._intentNode, "width", (this.pageMeta.level * 30) + "px");
			
			var _mainNodeWidth = dojo.coords(this.domNode).w - (this.pageMeta.level * 30) - 122; //calculate the relative width of main node(including possible scrollbar)
			dojo.style(this._mainNode, "width", _mainNodeWidth + "px");
		}
		
		dojo.create("img", {"src": builderConfig.builderPath+ "/images/spacemanager/page.gif", "alt": ""}, this._iconNode);
	},

	_showToggle : function() {
		if (!this.page) {
			return;
		}
		var navMode = this.navigationUtil.getNavigationModel();
		var iterator = navMode.getChildren(this.page);
		if (iterator.hasNext()) {
			this._togglerWidget = new com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler({"boundNode" : this._pagesNode, "parentPage": this.page, "space": this.space, "level": this.pageMeta.level}, this._togglerNode);
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.spaceFilter", [dijit._Widget, dijit._Templated], {
	templateString : "<div><input style='width:200px' type='text' dojoAttachPoint='_inputNode'></div>",
	
	constructor : function() {
		this._throlt = 200;
		this._userEntered = false;
		this._timeoutId = null;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
	},
	
	postCreate : function() {
		this.hint = this._bundle["I_SPACE_MANAGER_FILTER_SPACES"];
		this._inputNode.value = this.hint;
		this._inputNode.title = this._bundle["I_SPACE_MANAGER_FILTER_SPACES_TITLE"];
		dojo.attr(this._inputNode,"aria-label",this._inputNode.title);
		dojo.connect(this._inputNode, "onfocus", this, this._inputFocus);
		dojo.connect(this._inputNode, "onblur", this, this._inputBlur);
		dojo.connect(this._inputNode, "onkeyup", this, this._keyUp);
	},
	
	_inputFocus : function(event) {
		var input = event.target;
		if (!this._userEntered) {
			input.value = "";
		}
		dojo.stopEvent(event);
	},
	
	_inputBlur : function(event) {
		var input = event.target;
		if (!this._userEntered) {
			input.value = this.hint;
		}
		dojo.stopEvent(event);
	},
	
	_keyUp : function(event) {
		var input = event.target;
		var value = dojo.trim(input.value);
		this._userEntered = !!value;
		var keyCode = event.keyCode;
		if ((keyCode !=16 && keyCode != 8 && keyCode < 32) || (keyCode >= 33 && keyCode <= 46) || (keyCode >= 112 && keyCode <= 123)) {
			dojo.stopEvent(event);
			return;
		}
		if (this._timeoutId) {
			window.clearTimeout(this._timeoutId);
		}
		this._timeoutId = window.setTimeout(dojo.hitch(this, this._notifyFilter, value), this._throlt);
	},
	
	_notifyFilter : function(value) {
		dojo.publish(this._constants.Topic.Space.filter, [value.toLowerCase()]);
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.Toggler", 
		[dijit._Widget, dijit._Templated], {
	boundNode : null,		
	
	templateString : "<div class='toggler'><div tabindex='0' class='togglerNode'><img class='togglerImg'></img></div></div>",
	loaded: false,
			
	constructor : function() {
		this._expanded = true;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
	},
	
	postCreate : function() {
		if (this.boundNode) {
			this._toggler = {
				node: this.boundNode,
				show: function() {
					dojo.style(this.node, "display", "block");
				},
				hide: function() {
					dojo.style(this.node, "display", "none");
				}
			};
		}
		this._togglerNode = dojo.query(".togglerNode", this.domNode)[0];
		this._togglerImgNode = dojo.query(".togglerImg", this.domNode)[0];
		dojo.attr(this._togglerImgNode, "alt", this._bundle.I_SPACEMANAGER_SHOW_OR_HIDE);
		dijit.setWaiRole(this._togglerNode,"button");
		dojo.attr(this._togglerNode,"aria-label",this._bundle.I_SPACEMANAGER_SHOW_OR_HIDE);
		dojo.connect(this._togglerNode, "onclick", this, this._toggle);
		dojo.connect(this._togglerNode, "onkeypress", this, this._enteredByKey);
		
		this._toggle();
	},
	
	_enteredByKey: function(evt){
		
		if (evt.keyCode != dojo.keys.ENTER)
			return;	  		
		this._toggle();
					                  
	},
	
	expanded : function() {
		dojo.attr(this. _togglerNode,"aria-pressed","true");
		dojo.addClass(this._togglerNode, "toggler_expanded");
		dojo.removeClass(this._togglerNode, "toggler_collapsed");
		dojo.attr(this._togglerImgNode, "src", builderConfig.builderPath+ "/images/spacemanager/expanded.png");
		if(!this.loaded)
			this._loadPages();
	},
	
	_isPageHidden : function(page) {
		return page.isHidden();
	},
	
	_canEditPage : function(page) {
		return this.pageUtil.canEdit(page);
	},
	
	_loadPages: function(){
		var pagesNode = this.boundNode;
		pagesNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._doLoadPages));
	},
	
	_doLoadPages : function() {
		
		var count = 0;
		var pagesNode = this.boundNode;
		var navMode = this.navigationUtil.getNavigationModel();		
		var iterator = navMode.getChildren(this.parentPage);
		
		pagesNode.innerHTML = "";
		
		while (iterator.hasNext()) {
			var page = iterator.next();
			if (!this._isPageHidden(page) || this._canEditPage(page)) {
				var pageNode = dojo.create("div", {}, pagesNode);
				var pageOwner = "";
				if(this._constants.showPageOwner === "true")
					pageOwner = this.spaceManagerUtil.model.getSpacePageOwner(this.space, page);
				
				var pageItem = new com.ibm.mm.builder.iwidget.spacemanager.widget.PageItem({
					pageMeta: {
						title: this.enablerUtil.getNodeTitle(page) || this._bundle.I_SPACE_MANAGER_NO_TITLE,
						description: this.enablerUtil.getNodeDescription(page) || this._bundle.I_SPACE_MANAGER_NO_DESCRIPTION,
						owner: pageOwner,
						level: this.level + 1,
						space: this.space,
						page: page,
						pageId: page.getID()
					}
				}, pageNode);

				if (this._isPageHidden(page)) {
					dojo.addClass(pageItem.domNode, "hidden_page");
					dojo.addClass(pageItem._flagNode, "hidden_flag");
				}
				count++;
			}
		}
		
		this.loaded = true;
	},
	
	collapsed : function() {
		dojo.attr(this. _togglerNode,"aria-pressed","false");
		dojo.removeClass(this._togglerNode, "toggler_expanded");
		dojo.addClass(this._togglerNode, "toggler_collapsed");
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);

		if (cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CLIENT_IS_BIDI)){
			dojo.attr(this._togglerImgNode, "src", builderConfig.builderPath + "/images/spacemanager/expand_rtl.png");
		} else {
			dojo.attr(this._togglerImgNode, "src", builderConfig.builderPath+ "/images/spacemanager/expand.png");
		}
	},
	
	_toggle : function() {
		var func = this._expanded ? "hide" : "show";
		var callback = this._expanded ? "collapsed" : "expanded";
		if (this._toggler) {
			this._toggler[func].apply(this._toggler);
		}
		this[callback].apply(this);
		this._expanded = !this._expanded;
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList");








dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList", 
        [dijit._Widget, dijit._Templated, 
        com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin], 
{
    templateString:"<div class=\"simple_spaces_list\">\n\t<div class=\"header\">${title}</div>\n\t<div class=\"body\" style=\"overflow:hidden\"></div>\n</div>\n",
    
    _subscriptions: null,
    _constants: com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants,
    _bundle: com.ibm.mm.builder.coreWidgetsStrings,
    
    eventService: com.ibm.mashups.services.ServiceManager.getService("eventService"),
    
    constructor : function() {
        this._subscriptions = [];
    },
    
    postMixinProperties : function() {
    },
    
    uninitialized: function() {
        dojo.forEach(this._subscriptions, dojo.unsubscribe);
    },
    
    postCreate : function() {
		/** remove favorite quick access in 2.0, 14521 **/
        //this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space.refreshQuickAccess, dojo.hitch(this, this._render)));
        
        this._render();
    },
    
    _render : function() {
        var self = this;
        var model = this.getModel();
        var bodyNode = dojo.query(".body", this.domNode)[0];
        dojo.empty(bodyNode);
        model.fetch({
            onComplete : function(items) {
				if (items && items.length > 0) {
					var ul = dojo.doc.createElement("ul");
					dojo.forEach(items, function(item) {
						ul.appendChild(self._buildSpaceLI({
							"title": model.getValue(item, "title", this._bundle.I_SPACE_MANAGER_NO_TITLE),
							"id": model.getValue(item, "id")
						}));
					}, self);
					
					bodyNode.appendChild(ul);
				}
            },
            onError : function(err) {
                console.error(err);
            }
        });
    },
    
    _buildSpaceLI : function(space) {
        var li = document.createElement("li");
        var link = dojo.create("a", {"href": "javascript:;", "spaceId": space.id, innerHTML: space.title}, li);                
        this.connect(link, "onclick", "onSpaceClick");
        return li;
    },
    
    onSpaceClick: function(event) {
        event = dojo.fixEvent(event);
        if (event && event.target) {
            var spaceId = dojo.attr(event.target, "spaceId");
            dojo.publish(this._constants.Topic.Space["switch"], [spaceId]);
        }
    },

    getAssociatedModelNames : function() {
        return this.modelNames || [];
    }
});

}

if(!dojo._hasResource["com.ibm.mm.catalog.opensearch.ResultModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.catalog.opensearch.ResultModel"] = true;
dojo.provide("com.ibm.mm.catalog.opensearch.ResultModel");

/**
 * ResultModel is used to represent the open search result.
 * @param {Object} results
 * @param {Boolean} hasMoreResults
 */
dojo.declare("com.ibm.mm.catalog.opensearch.ResultModel", null,
  {
    constructor : function(/* Object */ results, /* Object */ hasMoreResults, /* Nubmer */ totalResult) {
      var r = results || [];
	  var hmr = !!hasMoreResults;
	  var totalResult = totalResult || -1;
	  
	  /**
	   * Return whether there exists more result items.
	   * @return {Boolean} 
	   */
	  this.hasMoreResults = function() {
	  	return hmr;
	  };
	  
	  /**
	   * Return result items of current page.
	   * @return {Object} A array of result items, each item is a JSON object that contains properties of the result item,
	   * including name, description, tags, rating, author and updated time.
	   */
	  this.getResults = function() {
	  	return r;
	  };
	  /**
	   * 
	   */
	  this.getTotalResult = function() {
	  	return totalResult;
	  }
	}
  }
);


}

if(!dojo._hasResource["com.ibm.mm.catalog.opensearch.ResultParser"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.catalog.opensearch.ResultParser"] = true;
dojo.provide("com.ibm.mm.catalog.opensearch.ResultParser");


//dojo.require("com.ibm.mashups.enabler.xml.XPath");


/**
 * A parser that can be used to parse Mashup Hub's open search result.
 * The parsed result is an instance of <tt>ResultModel</tt>.
 */
dojo.declare("com.ibm.mm.catalog.opensearch.MashupHubResultParser", null, {
    constructor: function(){
        //namespaces that used in XPath expressions
		var ns = {
            "atom": "http://www.w3.org/2005/Atom",
            "catalog": "http://www.ibm.com/xmlns/atom/opensearch/feeds/1.0/",
			"os": "http://a9.com/-/spec/opensearch/1.1/"
        };
		//XPath to get all the entries' content
        var path = "/atom:feed/atom:entry";
		//XPath to get all the links of the ATOM feed document
        var linkPath = "/atom:feed/atom:link";
		//XPath to get the total result of the ATOM feed document
		var totalResultPath = "/atom:feed/os:totalResults";
		
        
		/**
		 * Return first child of <tt>parent</tt> of type <tt>nodeType</tt>
		 * @param {Object} parent the DOM node
		 * @param {Number} nodeType the type of the DOM nodes to consider, refer to W3C DOM spec.
		 * @return {Object} the DOM node
		 */
        function getFirstChildOfType(/* DOM node */parent, /* DOM node type */ nodeType){
            var childrenNodes = parent.childNodes;
            for (var i = 0, n = childrenNodes.length; i < n; i++) {
                if (childrenNodes.item(i).nodeType == nodeType) {
                    return childrenNodes.item(i);
                }
            }
        }
        
		/**
		 * Parse the <tt>content</tt> element of the feed's entry
		 * @param {Object} content A JSON object contains all the sub-elements of the <tt>content</tt> element
		 */
        function parseEntryContent(/* DOM node */ content, contentObj){
			
           var catalogNode = getFirstChildOfType(content, 1);
            var childrenNodes = catalogNode.childNodes;

            for (var i = 0, n = childrenNodes.length; i < n; i++) {
                var node = childrenNodes.item(i);
                if (node.nodeType == 1) {
                    var nodeValue;
                    if ("catalog:tags" != node.nodeName) {
                        nodeValue = dojo.trim(dojox.data.dom.textContent(node));
                    } 
                    else {
						//Flatten the tag elements into an array                 					
                        var tagsNode = node.getElementsByTagName("catalog:tag");
                        if(tagsNode.length == 0){
                            tagsNode = node.getElementsByTagName("tag"); 
                        }	
                        var tags = [];
                        dojo.forEach(tagsNode, function(tagNode){
                            tags.push(getFirstChildOfType(tagNode, 3).nodeValue);
                        });
                        nodeValue = tags;
                   }
				   var nodeName = node.nodeName;
				   if (nodeName.indexOf("catalog:") == 0) nodeName = nodeName.substring(8);
                   contentObj[nodeName] = nodeValue;
                }
            }
			
			//special treatment of the element "dateModified", need to multiply by 1000, so it can be consumed by 
			//a JavaScript Date object.
			if (contentObj["dateModified"]) {
			  contentObj["dateModified"] = parseInt(contentObj["dateModified"]) * 1000;	
			}
			
            return contentObj;
        }
        function parseEntry(/* DOM node */ entry) {
			
			var entryObj = {};
			for (var i=0, n=entry.childNodes.length; i<n; i++) {
				var node = entry.childNodes[i];
				if ("content" == node.nodeName) {
					parseEntryContent(node, entryObj);
				} else if ("category" == node.nodeName) {
					entryObj["category"] = node.getAttribute("term");
				}
				
			}
			return entryObj;
		}
		/**
		 * Parse the <tt>link</tt> elements of the feed
		 * @param {Object} link DOM node
		 * @return {Object} A JSON object contains all the attributes of the <tt>link</tt> element
		 */
        function parseLink(/* DOM node */ link){
            var attributes = link.attributes;
            var linkObj = {};
            for (var i = 0, n = attributes.length; i < n; i++) {
                var attr = attributes.item(i);
                linkObj[attr.name] = attr.value;
            }
            return linkObj;
        }
		/**
		 * parse the <tt>totalResults</tt> element of the feed
		 * @param (Object) xmlDoc An XML document
		 * @return (Number) A number which represents the total result of the searching
		 */
        function parseTotalResult(/* XML DOM Object */xmlDoc){
			var totalResultNodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(totalResultPath, xmlDoc, ns);
			if (totalResultNodes.length) {
				var totalResultNode = getFirstChildOfType(totalResultNodes[0], 3);
				var totalResult = dojo.trim(dojox.data.dom.textContent(totalResultNode));
				return totalResult;
			}
		}
		
		/**
		 * Parse the XML document to get the <tt>ResultModel</tt>.
		 * @param {Object} xmlDoc An XML document
		 * @return {Object} ResultModel
		 */
        this.parse = function(/* XML DOM Object */ xmlDoc){
			var entriesObj = [];
            var linksObj = [];
            var nodes = [];
			var linkNodes = [];

			try {
				nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(path, xmlDoc, ns);
            	linkNodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(linkPath, xmlDoc, ns);
			} catch (e) {
				throw e; // Re-throw the exception
			}
 			
			//parse the content of the entry
            dojo.forEach(nodes, function(node){
                entriesObj.push(parseEntry(node));
            });
            
			//parse the links of the feed
            dojo.forEach(linkNodes, function(node){
                linksObj.push(parseLink(node));
            });
            
			//determine whether there exists more result items
            var hasNext = false;
            for (var i = 0, n = linksObj.length; i < n; i++) {
                if (linksObj[i].rel == "next") {
                    hasNext = true;
                    break;
                }
            }
            var totalResult = parseTotalResult(xmlDoc);
			
            return new com.ibm.mm.catalog.opensearch.ResultModel(entriesObj, hasNext, totalResult);
        }
    }
});

//Create a manager that manages all the parsers
(function(){
    if (typeof com.ibm.mm.catalog.opensearch.ResultParserManager == "undefined") {
        com.ibm.mm.catalog.opensearch.ResultParserManager = {
            "mashuphub": new com.ibm.mm.catalog.opensearch.MashupHubResultParser()
        };
    }
})();

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.DialogFooter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.DialogFooter"] = true;
dojo.provide("com.ibm.mm.builder.dialog.DialogFooter");




dojo.declare("com.ibm.mm.builder.dialog.DialogFooter",
	[dijit._Widget, dijit._Templated],
	{
		templateString: 
			'<div class="${baseClass}">'+
			    '<input id="${saveId}" role="button" wairole="button" aria-label="${saveText}" title="${saveText}" type="button" class="${saveClass}" value="${saveText}" dojoAttachPoint="saveNode" dojoAttachEvent="onclick:onSave,onkeypress:_onSaveKeypress" accesskey="${saveAccessKey}"/>'+
				'<a id="${cancelId}" role="button" wairole="button" title="${cancelText}" aria-label="${cancelText}" class="${cancelClass}" href="JavaScript:void(0)" dojoAttachPoint="cancelNode" dojoAttachEvent="onclick:onCancel,onkeypress:_onCancelKeypress">${cancelText}</a>'+
			    //'<input id="${cancelId}" type="button" class="${cancelClass}" value="${cancelText}" dojoAttachPoint="cancelNode" dojoAttachEvent="onclick:onCancel,onkeypress:_onCancelKeypress" accesskey="${cancelAccessKey}"/>'+
		    '</div>',
		
		baseClass: "lotusDialogFooter",
		widgetId: "",
		IWID: "",
		
		saveId: "_${widgetId}_btn_save",
		saveClass: "lotusFormButton common_save",
		saveText: "${I_COMMON_SAVE}",
		saveAccessKey: "",
		
		cancelId: "_${widgetId}_cancel_text",
		cancelClass: "common_cancel lotusAction",
		cancelText: "${I_COMMON_CANCEL}",
		cancelAccessKey: "",
		
		resourceBundles: [com.ibm.mm.builder.coreWidgetsStrings],
		
		postMixInProperties: function() {
			this.inherited(arguments);
			if(this.IWID) this.widgetId = this.IWID.substr(1, this.IWID.length-2);
			var smashedMixin = dojo.mixin.apply(dojo, [{}, this].concat(this.resourceBundles));
			dojo.forEach(["saveId", "saveText", "cancelId", "cancelText"], function(prop){
				this[prop] = dojo.string.substitute(this[prop], smashedMixin);
			}, this);
		},
		
		postCreate: function() {
			if(!this.cancelAccessKey) this.cancelNode.removeAttribute("accesskey");
			if(!this.saveAccessKey) this.saveNode.removeAttribute("accesskey");
			this.inherited(arguments);
		},
		
		_onSaveKeypress: function(e) {
			if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
				this.onSave(e);
			}
		},
		
		_onCancelKeypress: function(e) {
			if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
				this.onCancel(e);
			}
		},
		
		onSave: function(evt) {
			
		},
		onCancel: function(evt) {
			
		}
	}
);

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget");










dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget", [dijit._Widget, dijit._Templated], {
	templateString:"<div class=\"space_dialog\">\n    <div class=\"spaceDialogMidArea\">\n        <div class=\"spaceDialogMid_inner\">\n            <div class=\"space_items\">\n                <div dojoAttachPoint=\"_messageBoxNode\">\n                </div>\n                <div>\n                \t<span class=\"isRequired\">*</span>\n                    <label id=\"${idPrefix}_page_name_label\" for=\"${idPrefix}_PageName\">\n                        ${I_CREATE_PAGE_IN_SPACE_PAGE_NAME}\n                    </label>\n                </div>\n                <div style=\"margin-top: 5px\">\n                    <input id=\"${idPrefix}_PageName\" dojoAttachPoint=\"_pageNameNode\" type=\"text\" value=\"\" style=\"width: 290px\"/>\n                </div>\n                <div style=\"margin-top: 15px\">                \t\n                    <label id=\"${idPrefix}_page_desc_label\" for=\"${idPrefix}_PageDesc\">\n                        ${I_CREATE_PAGE_IN_SPACE_PAGE_DESCRIPTION}\n                    </label>\n                </div>\n                <div style=\"margin-top: 5px\">\n                    <textarea id=\"${idPrefix}_PageDesc\" dojoAttachPoint=\"_pageDescriptionNode\" style=\"width: 290px; height: 100px\"></textarea>\n                </div>\n                <div style=\"margin-top: 15px\">\n                    <div>\n                        <input value=\"from_empty\" checked=\"checked\" name=\"page_create_type\" id=\"${idPrefix}_fromEmpty\" type=\"radio\" dojoAttachPoint='_byEmptyNode' />\n                        <label id=\"${idPrefix}_fromEmpty_label\" style=\"margin-left: 5px\" for=\"${idPrefix}_fromEmpty\">\n                            ${I_CREATE_PAGE_IN_SPACE_EMPTY_PAGE}\n                        </label>\n                    </div>\n                    <div style=\"margin-top: 10px\">\n                        <input value=\"by_duplicating\" name=\"page_create_type\" id=\"${idPrefix}_byDuplicating\" type=\"radio\" dojoAttachPoint='_byDuplicatingNode' />\n                        <label id=\"${idPrefix}_byDuplicating_label\" style=\"margin-left: 5px\" for=\"${idPrefix}_byDuplicating\">\n                            ${I_CREATE_PAGE_IN_SPACE_DUPLICATE_PAGE}\n                        </label>\n                    </div>\n                    <div dojoAttachPoint='_spacePagesListNode' style=\"margin-top: 5px;margin-left:20px\">\n                    </div>\n                    <div dojoAttachPoint=\"_addPageFromCatalog\" style=\"margin-top: 10px\">\n                        <input value=\"from_catalog\" name=\"page_create_type\" id=\"${idPrefix}_fromCatalog\" type=\"radio\" dojoAttachPoint='_fromCatalogRadioNode' />\n                        <label id=\"${idPrefix}_fromCatalog_label\" style=\"margin-left: 5px\" for=\"${idPrefix}_fromCatalog\">\n                            ${I_CREATE_PAGE_IN_SPACE_ADD_FROM_CATALOG}\n                        </label>\n                    </div>\n                    <div dojoAttachPoint='_catalogPagesListNode' style=\"margin-top: 5px;margin-left:20px\">\n                    </div>\n                </div>\n            </div>\n            <div class=\"space_themes\">\n                <div>\n                \t<span class=\"isRequired\">*</span>\n                    <label id=\"${idPrefix}_choose_theme_label\">\n                        ${EDIT_SPACE_CHOOSE_THEME}\n                    </label>\n                </div>\n                <div dojoAttachPoint=\"_themesContainerNode\">\n                </div>\n            </div>\n            <div class=\"clearthefloats\">\n            </div>\n        </div>\n    </div>\n    <div class=\"clearthefloats\">\n    </div>\n    <div dojoType=\"com.ibm.mm.builder.dialog.DialogFooter\" \n\t\tIWID=\"_IWID_\" \n\t\tsaveText=\"${I_COMMON_OK}\" \n\t\tdojoAttachEvent=\"onSave: ok, onCancel:hide\" />\n</div>\n",
	
	widgetsInTemplate: true,
	
	parentPageId : null,
	
	spaceId : null,
	
	constructor : function() {
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this.spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		this._spacePagesLoaded = false;
		this._catalogPagesLoaded = false;
		this._eventConnects = [];
		this.cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	},
	
	postMixInProperties : function() {
		var _idPrefix = "sm_createPage";
		this.idPrefix = dijit.getUniqueId(_idPrefix);
		dojo.mixin(this, this._bundle);
	},
	
	postCreate : function() {		
	
		this._themesListControl = new com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl({
			widgetId: this.widgetId
		}, this._themesContainerNode);
		
		this._eventConnects.push(dojo.connect(this._byEmptyNode, "onclick", this, this._byEmptyRadioClicked));
		this._eventConnects.push(dojo.connect(this._byDuplicatingNode, "onclick", this, this._byDuplicatingRadioClicked));
		this._eventConnects.push(dojo.connect(this._fromCatalogRadioNode, "onclick", this, this._fromCatalogRadioClicked));
		
		if(!com.ibm.mm.builder.commonActions.hasHub()){
			dojo.style(this._addPageFromCatalog,"display","none");
		}else{
			dojo.style(this._addPageFromCatalog,"display","block");
		}
	},
	
	hide : function() {
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.widgetId);
	},
	
	ok : function() {
		if (this.onOk) {
			this.onOk();
		}
	},
	
	onOk : function() {
		if(this.createPage())
			this.hide();
	},
	
	_showMessage : function(msg, type) {
		if (msg) {
			if(!this._messageControl){
				this._messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: 'error'}, this._messageBoxNode);
			}
			this._messageControl.attr({
				message : msg,
				messageType : type || "error"
			});
			this._messageControl.show();
		}
	},
	
	_hideMessage : function() {
		if(this._messageControl){
			this._messageControl.hide();
		}
	},
	
	_byEmptyRadioClicked : function() {
		this._disableDuplicatingAndCatalog();
	},
	
	_disableDuplicatingAndCatalog : function() {
		if (this._spacePagesListSelect) {
			dojo.attr(this._spacePagesListSelect, "disabled", "disabled");
		}
		if (this._catalogPagesListSelect) {
			dojo.attr(this._catalogPagesListSelect, "disabled", "disabled");
		}
	},
	
	_byDuplicatingRadioClicked : function() {
		if (!this.spaceId) {
			return;
		}
		if (this._spacePagesLoaded) {
			if (this._spacePagesListSelect) {
				dojo.removeAttr(this._spacePagesListSelect, "disabled");
			}
		}
		else {
			this._refreshPagesInSpace();
		}
		if (this._catalogPagesListSelect) {
			dojo.attr(this._catalogPagesListSelect, "disabled", "disabled");
		}
	},
	
	_fromCatalogRadioClicked : function() {
		if (this._spacePagesListSelect) {
			dojo.attr(this._spacePagesListSelect, "disabled", "disabled");
		}
		if (this._catalogPagesLoaded) {
			if (this._catalogPagesListSelect) {
				dojo.removeAttr(this._catalogPagesListSelect, "disabled");
			}
		}
		else {
			this._loadPagesFromCatalog();
		}
	},
	
	_refreshPagesInSpace : function() {
		this._spacePagesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		
		this.spaceManagerUtil.util.delayCall(dojo.hitch(this, this._doRefreshPagesInSpace));
	},
	
	_doRefreshPagesInSpace : function() {
		var spaceModel = this.spaceUtil.getSpaceModel();
		var space = spaceModel.find(this.spaceId).start();
		var navModel = this.navigationUtil.getNavigationModel();
		var rootNodeId = space.getRootNavigation().getID();
		this._spacePagesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		var select = dojo.doc.createElement("select");
		dojo.addClass(select, "page_list");
		this._loadPagesRecursive(navModel, this.enablerUtil, rootNodeId, select, 0);
		this._spacePagesListNode.innerHTML = "";
		this._spacePagesListNode.appendChild(select);
		this._spacePagesListSelect = select;
		this._spacePagesLoaded = true;
	},
	
	_createOptionForPage : function(title, id, level) {
		var option = dojo.doc.createElement("option");
		dojo.attr(option, "value", id);
		var text = [];
		if (level > 0) {
			text.push("&#8970;");
		}
		for (var i = 0; i < level; i++) {
			text.push("__");
		}
		text.push(title);
		option.innerHTML = text.join("");
		return option;
	},
	
	_loadPagesRecursive : function(navModel, enablerUtil, pageId, select, level) {
		var page = navModel.find(pageId).start();
		var iterator = navModel.getChildren(page);
		while (iterator.hasNext()) {
			var p = iterator.next();
			var title = enablerUtil.getNodeTitle(p);
			var id = p.getID();
			select.appendChild(this._createOptionForPage(title, id, level));
			arguments.callee.apply(this, [navModel, enablerUtil, id, select, level + 1]);
		}
	},
	
	_getCatalogPagesSearchUrl : function() {
		var url = null;
		try {
			url = com.ibm.mm.catalog.hubUtil.getHubOpenSearchUrl();
		}
		catch (e) {
			
		}
		if (url) {
            url = new com.ibm.mm.enabler.utilities.HttpUrl(url);
            url = url.toProxifiedString();
			var queryKeyword = builderConfig.pageQueryKeyword || "*",
				queryCount = builderConfig.pageQueryCount || "50";
			return url + "?collection=pages&searchTerms=" + queryKeyword + "&count=" + queryCount;
        }
		return null;
	},
	
	_loadPagesFromCatalog : function() {
		this._catalogPagesListNode.innerHTML = this.spaceManagerUtil.ui.getLoadingNodeHtml();
		var url = this._getCatalogPagesSearchUrl();
		dojo.xhrGet({
			url : url,
			handleAs : "text",
			load : dojo.hitch(this, function(data) {
				var doc = dojox.data.dom.createDocument(data);
				
				var select = dojo.doc.createElement("select");
				dojo.addClass(select, "page_list");
				var parser = com.ibm.mm.catalog.opensearch.ResultParserManager.mashuphub;
				var results = parser.parse(doc).getResults();
				for (var i = 0, n = results.length; i < n; i++) {
					if(results[i].downloadURL && !results[i].definitionURL)
						select.appendChild(this._createOptionForPage(results[i].name, results[i].downloadURL));
				}
				this._catalogPagesListNode.innerHTML = "";
				this._catalogPagesListNode.appendChild(select);
				this._catalogPagesListSelect = select;
				this._catalogPagesLoaded = true;
			}),
			error : dojo.hitch(this, function() {
				this._notifyError(this._bundle.E_SPACE_MANAGER_LIST_HUB_PAGES_FAILED);
				this._catalogPagesListNode.innerHTML = "";
			})
		});
	},
	
	_getPageNodeById : function(pid) {
		var navModel = this.navigationUtil.getNavigationModel();
		return navModel.find(pid).start();
	},
	
	createPage : function() {
		if (!this.parentPageId) {
			return;
		}
		var name = dojo.trim(this._pageNameNode.value);
		if (!name) {
			this._showMessage(this._bundle["E_SPACE_MANAGER_PAGE_NAME_REQUIRED"]);
			return;
		}
		if (!this.pageUtil.validatePageName(name)) {
			this._showMessage(this._bundle["E_SPACE_MANAGER_SPACE_NAME_HAS_INVALID_CHAR_0"]);
			return;
		}
		var description = dojo.trim(this._pageDescriptionNode.value);
		
		var themeId = this._themesListControl.selectedTheme;	
		
		this._hideMessage();
		var createType = dojo.query("input[name=page_create_type]", this.domNode).filter(		function(item) {
			return item.checked;
		})[0].value;
		
		switch (createType) {
			case "from_empty":
				var parentPage = this._getPageNodeById(this.parentPageId);
				return this._doCreateEmptyPage(name, description, parentPage, themeId);
			case "by_duplicating":	
				var copiedPageId = this._spacePagesListSelect.value;
				if (!copiedPageId || copiedPageId=="") {
					this._showMessage(this._bundle["E_SPACE_MANAGER_PAGE_TO_COPY_REQUIRED"]);
					return;
				}
				return this._doCreatePageByDuplicating(this.parentPageId, copiedPageId, name, description, themeId);
				break;
			case "from_catalog":
				var url = this._catalogPagesListSelect.value;
				if (!url || url=="") {
					this._showMessage(this._bundle["E_SPACE_MANAGER_PAGE_CATALOG_PAGE_REQUIRED"]);
					return;
				}
				return this._createPageFromCatalog(this.parentPageId, url, name, description, themeId);
				break;
		}	
	},
	
	_doCreateEmptyPage : function(name, description, parentPage, themeId) {
		var navModel = this.navigationUtil.getNavigationModel();
		var newPage = navModel.create(null);
		var locale1 = builderConfig.locale;
		var locale2 = this.cs.getValue("default.locale");
		newPage.setTitle(name, locale1);
		newPage.setTitle(name, locale2);
		newPage.setDescription(description, locale1);
		newPage.setDescription(description, locale2);
		newPage.setTheme(themeId);
		navModel.insert(newPage, parentPage, null);
		
		var lm = navModel.getLayoutModel(newPage.getID());
		var lmRoot = lm.create();
		lm.insert(lmRoot);		
		lmRoot.setFragment(" ");
		
		var d = new dojo.Deferred();

		var deferred = navModel.commit();
		
		deferred.addFinishedCallback(dojo.hitch(this, function(node){
			this._notifyToRefresh(node);
		}));
		deferred.start(false);
		return d;
	},
	
	_updatedCopiedPage : function(node, parentPageId, name, description, themeId) {
		var locale1 = builderConfig.locale;
		var locale2 = this.cs.getValue("default.locale");
		var importPage = this.spaceManagerUtil.importPage;
		importPage.updateTitleAndDescription(node, name, description, locale1);
		if (locale2 != locale1) {
			importPage.updateTitleAndDescription(node, name, description, locale2);
		}
		importPage.updateParentPage(node, parentPageId);	
		importPage.updateTheme(node, themeId);	
	},
	
	_doCreatePageByDuplicating : function(parentPageId, copiedPageId, name, description, themeId) {
		var copiedPage = this._getPageNodeById(copiedPageId);
		var exportUrl = copiedPage.getExportPageURL();
		
		if(!exportUrl){
			this.LOGGER.severe("createPage", messages.E_SPACE_MANAGER_PAGE_EXPORT_URL_IS_NULL_0);
			return;
		}
		
		var d = new dojo.Deferred();
		dojo.xhrGet({
			url : exportUrl,
			handleAs : "text",
			load : dojo.hitch(this, function(data) {
				var node = dojox.data.dom.createDocument(data);
				this._updatedCopiedPage(node, parentPageId, name, description, themeId);
				var text = com.ibm.mm.enabler.dom.innerXML(node);
				dojo.rawXhrPost({
					url : this.spaceManagerUtil.importPage.getResourceCollectionsUrl(),
					postData : text,
					headers : {
						"Content-Type" : "text/xml"
					},
					load : dojo.hitch(this, function(data) {
						d.callback(data);
						//parse data						
						var newPageId = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil.util.parseNmIdFromResponseData(data);
						var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);
						this._notifyToRefresh(newPage);
					}),
					error : dojo.hitch(this, function() {
						this._notifyError(this._bundle.E_SPACE_MANAGER_CREATE_NEW_PAGE_FAIL);
					})
				});
			})
		});
		return d;
	},
	
	_updateCatalogPage : function(node, parentPageId, name, description, themeId) {
		var locale1 = builderConfig.locale;
		var locale2 = this.cs.getValue("default.locale");
		var importPage = this.spaceManagerUtil.importPage;		
		importPage.updateTitleAndDescription(node, name, description, locale1);
		if (locale2 != locale1) {
			importPage.updateTitleAndDescription(node, name, description, locale2);
		}
		importPage.updateParentPage(node, parentPageId);	
		importPage.updateTheme(node, themeId);	
	},
	
	_createPageFromCatalog : function(parentPageId, downloadUrl, name, description, themeId) {
		var d = new dojo.Deferred();
		dojo.xhrGet({
			url : com.ibm.mm.enabler.utilities.rewriteURL(downloadUrl),
			handleAs : "text",
			load : dojo.hitch(this, function(data) {
				var node = null;
				try {
					node = dojox.xml.parser.parse(data);
				}
				catch (e) {
					this._notifyError(this._bundle.E_SPACE_MANAGER_CREATE_NEW_PAGE_FAIL);
					return;
				}
				this._updateCatalogPage(node, parentPageId, name, description, themeId);
				var text = com.ibm.mm.enabler.dom.innerXML(node);
				dojo.rawXhrPost({
					url : this.spaceManagerUtil.importPage.getResourceCollectionsUrl(),
					postData : text,
					headers : {
						"Content-Type" : "text/xml"
					},
					load : dojo.hitch(this, function(data) {
						d.callback(data);
						
						var newPageId = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil.util.parseNmIdFromResponseData(data);
						var newPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(newPageId);
						this._notifyToRefresh(newPage);
					}),
					error : dojo.hitch(this, function() {
						this._notifyError(this._bundle.E_SPACE_MANAGER_CREATE_NEW_PAGE_FAIL);
					})
				});
			})
		});
		return d;
	},
	
	_notifyToRefresh : function(newPage) {
		if(newPage)
			dojo.publish(this._constants.Topic.Space.refresh, [this._constants.Action.ADD_PAGE, {spaceId: this.spaceId, parentPageId: this.parentPageId, page: newPage}]);
		else
			dojo.publish(this._constants.Topic.Space.refresh);
		
		if(this.spaceId == com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId())
			com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
	},
	
	_notifyError : function(message) {
		this._showMessage(message || "");
	},
	
	destroy : function() {
		dojo.forEach(this._eventConnects, dojo.disconnect);
		this.inherited(arguments);
	},
	
	setSpaceId : function(spaceId){
		this.spaceId = spaceId;
	},
	
	setParentPageId: function(parentPageId){
		this.parentPageId = parentPageId;
	},
	
	cleanUI: function(){
		this._pageNameNode.value = "";
		this._pageDescriptionNode.value = "";
		this._byEmptyNode.checked = true;
		this._spacePagesListNode.innerHTML = "";
		this._catalogPagesListNode.innerHTML = "";
		this._spacePagesLoaded = false;
		this._catalogPagesLoaded = false;
		this._hideMessage();
		this._themesListControl.refresh(com.ibm.mm.builder.utils.themeUtil.getThemeId(this.parentPageId));
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget"] = true;



dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget");









dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget", [dijit._Widget, dijit._Templated, com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin], {
	templateString:"<div class=\"space_manager\">\n\t<div class=\"sidebar_outer\">\n\t\t<div class=\"sidebar\">\n\t\t\t<div class=\"category_selector\"></div>\n\t\t\t<!--- 14521 remove quick favorite access in 2.0<div class=\"favorites_quick_access\"></div>--->\n\t\t</div>\n\t</div>\n\t<div class=\"content_outer\">\n\t\t<div class=\"content\">\n\t\t\t<div class='message_box' dojoAttachPoint='_messageNode'></div>\n\t\t\t<div class=\"header\">\n\t\t\t\t<div dojoType='com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerActionBar'></div>\n\t\t\t\t<div class=\"filter_spaces\">\n\t\t\t\t\t<div dojoType='com.ibm.mm.builder.iwidget.spacemanager.widget.spaceFilter'></div>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t\t<div style=\"clear:both\"></div>\n\t\t\t<div class=\"space_list\"></div>\n\t\t</div>\n\t</div>\n</div>\t\n",
	widgetsInTemplate : true,
	
	constructor : function(options) {
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this._utils = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this._eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
	},
	
	postMixInProperties : function() {
		dojo.mixin(this, this._bundle);
	},
	
	postCreate : function() {
		this._setupSubComponents();
	},
	
	_setupSubComponent : function(nodeClassName, dijitClass, extraOptions) {
		var node = dojo.query("." + nodeClassName, this.domNode)[0];
		var option = dojo.mixin({}, extraOptions, {spaceManager : this.getSpaceManager()});
		return new dijitClass(option, node);
	},
	
	_setupSubComponents : function() {
		this._setupSubComponent("category_selector", com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector);
		
		/** Remove the favorite quick access in 2.0, 14521
		 this._setupSubComponent("favorites_quick_access", com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList, {
			title : this._bundle.I_SPACE_MANAGER_FAVORITES_QUICK_ACCESS,
			modelNames : this._constants.ModelName.FavoriteSpaces
		});**/
		
		this._setupSubComponent("space_list", com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList);
		
		dojo.subscribe(this._constants.Topic.Common.showMessage, this, this.showMessage);
		dojo.subscribe(this._constants.Topic.Common.hideMessage, this, this.hideMessage);
	},
	
	showMessage : function(message, type) {
		if(!this._messageControl){
			this._messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
			messageType: 'error'}, this._messageNode);
		}
		this._messageControl.attr({
			"message" : message,
			"messageType" : type || "error"
		});
		this._messageControl.show();
	},
	
	hideMessage : function() {
		if (this._messageControl) {
			this._messageControl.hide();
		}
	},
	
	onSpaceCreated : function(spaceId) {
		dojo.publish(this._constants.Topic.Space.refresh,[this._constants.Action.CREATE_SPACE, {spaceId: spaceId}]);
		/** remove favorite quick access in 2.0 **/
		//dojo.publish(this._constants.Topic.Space.refreshQuickAccess);
	},
	
	refresh : function() {
		dojo.publish(this._constants.Topic.Space.refresh);
		/** remove favorite quick access in 2.0 **/
		//dojo.publish(this._constants.Topic.Space.refreshQuickAccess);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.SpaceSelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.SpaceSelector"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.SpaceSelector");






(function(){
var maxLen = 150;
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var pageUtil = utils.pageUtil;
var navigationUtil = utils.navigationUtil;
var themeUtil = utils.themeUtil;
var spaceUtil = utils.spaceUtil;
var acModelUtil = utils.acModelUtil;
var userUtil = utils.userUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cws = com.ibm.mm.builder.coreWidgetsStrings;
var spaceSelector = null;

dojo.declare("com.ibm.mm.builder.iwidget.SpaceSelector",
	[dijit._Widget, dijit._Templated],{
	
	templateString: 
		'<div class="spaceSelector">'+
			'<div dojoAttachPoint="containerNode" class="spaceSelectorTitle" tabindex=0 '+
				'dojoAttachEvent="onmouseover:_onHover,onmouseout:_onUnHover,onkeypress:_onSelectorKeyPress"></div>'+
			'<div class="spaceSelectorAction middleImageDiv" dojoAttachPoint="spaceSelectorAction">' + 
				'<a class="spaceSelectorImageContainer" role="button" wairole="button" dojoAttachEvent="onkeypress:_onSpaceMenuKeyPress,onclick:_openSpaceMenu" dojoAttachPoint="spaceSelectorImgContainer" style="display:none;" >' +
				'<img class="spaceSelectorImage" title="" tabindex=0 '+
					'dojoAttachPoint="spaceSelectorImg" /></a>' +
			'</div>'+
		'</div>',
	
	postCreate: function(){
		spaceSelector = this;
	},
	
	_createSpaceSelectorMenu: function(){
		this.spaceSelectorMenu = new com.ibm.mm.builder.iwidget.SpaceSelectorMenu({ targetNodeIds: [this.containerNode] });
	},
	
	_createSpaceActionMenu: function(){
		
		
		dojo.attr(this.spaceSelectorImg, 'alt', cws.I_SPACE_SELECTOR_ACTION_MENU_BUTTON );
		dojo.attr(this.spaceSelectorImgContainer, 'title', cws.I_SPACE_SELECTOR_ACTION_MENU_BUTTON );
		
		if (spaceUtil.isPersonalSpace() || userUtil.isLockedDownAnonymousMode()) {
			
			dojo.addClass(this.spaceSelectorAction, "spaceSelectorActionDisabled");
			this.spaceSelectorAction.setAttribute("disabled", true);
			var title = cws.I_SPACE_SELECTOR_IN_PERSONAL_SPACE ;
			dojo.attr(this.spaceSelectorImg,'title',title);
			dojo.attr(this.spaceSelectorImg,'aria-label',title);
			
		}
		else {
			dojo.removeClass(this.spaceSelectorAction, "spaceSelectorActionDisabled");
			this.spaceSelectorAction.removeAttribute("disabled");
			var title = cws.I_SPACE_SELECTOR_OPEN_ACTION_MENU;
			dojo.attr(this.spaceSelectorImg,'title',title);
			dojo.attr(this.spaceSelectorImg,'aria-label',title);			
			
			this.spaceActionMenu = new com.ibm.mm.builder.iwidget.SpaceActionMenu({
				targetNodeIds: [this.spaceSelectorImg]
			});
		}
		this.spaceSelectorImg.src = builderConfig.builderPath + "/images/pageaction/down_triangle_white.png";
		this.spaceSelectorImgContainer.style.display = "";
		this._adjustWidthForBidiIE();
	},
	
	refresh: function(spaceId){
		this.uninitialize();
		var limitedTitle = htmlUtil.getStrWithLimit(spaceUtil.getSpaceTitle(spaceId), this.containerNode, 153);
		this.containerNode.innerHTML = limitedTitle;
		if (builderConfig.isBidi&& (dojo.isIE === 6 || dojo.isIE === 8)) {
			var w = htmlUtil.getStrWidth(limitedTitle, this.containerNode);
			this.containerNode.style.width = w + "px";
		}
		this._createSpaceSelectorMenu();
		this._createSpaceActionMenu();
	},
	
	_onHover: function(evt){
		dojo.addClass(this.containerNode, "spaceSelectorTitleHover");
	},
	
	_onUnHover: function(evt){
		if(!this.spaceSelectorMenu || (this.spaceSelectorMenu && !this.spaceSelectorMenu.isShowingNow)){
			dojo.removeClass(this.containerNode, "spaceSelectorTitleHover");
		}
	},
	
	_onSelectorKeyPress: function(evt){
		switch(evt.keyCode || evt.charCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
				this.spaceSelectorMenu._openMyself(evt);
			break;
		}
	},
	_openSpaceMenu: function(evt) {
		if(this.spaceActionMenu) this.spaceActionMenu._openMyself(evt);
	},
	_onSpaceMenuKeyPress: function(evt){
		if (spaceUtil.isPersonalSpace()) { return };
		switch(evt.keyCode || evt.charCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
				if(this.spaceActionMenu) this.spaceActionMenu._openMyself(evt);
			break;
		}
	},
	
	uninitialize: function(){
		if (this.spaceSelectorMenu) {
			if(this.spaceSelectorMenu.isShowingNow){ dijit.popup.close(this.spaceSelectorMenu); }
			this.spaceSelectorMenu.destroyRecursive();
			this.spaceSelectorMenu = null;
		}
		if (this.spaceActionMenu) {
			if(this.spaceActionMenu.isShowingNow){ dijit.popup.close(this.spaceActionMenu); }
			this.spaceActionMenu.destroyRecursive();
			this.spaceActionMenu = null;
		}
	},
	
	_adjustWidthForBidiIE: function(){
		if (builderConfig.isBidi && (dojo.isIE)) {
			setTimeout(function(){
				var selector = dojo.query(".spaceSelectorDiv")[0];			
				var title = dojo.query(".spaceSelectorTitle")[0];
				var piw = dojo.coords(title, true).w;
				selector.style.width=piw+30+"px";
			}, 0);
		}
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.SpaceSelectorMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	
	leftClickToOpen: true,
	
	postCreate: function(){
		dojo.addClass(this.domNode, "spaceSelectorMenu");
		if(!this.isLeftToRight()){ this.offset_x = -9;}
		this.inherited(arguments);
	},
	
	onClose: function(){
		spaceSelector.containerNode.blur();
		dojo.removeClass(spaceSelector.containerNode, "spaceSelectorTitleHover");
		this.inherited(arguments);
	},
	
	prepareData: function(){
		dojo.addClass(spaceSelector.containerNode, "spaceSelectorTitleHover");		
		if (!userUtil.isLockedDownAnonymousMode()) {
			this.addChild(new dijit.MenuItem({
				label: cws.I_SPACE_MANAGE_SPACES,
				postCreate: function(){
					dijit.MenuItem.prototype.postCreate.call(this);
					htmlUtil.markTruncation(this.containerNode, "153");
				},
				onClick: function(){
					var payload = {
						widgetTypeId: "spaceManager",
						eventName: "com.ibm.mashups.builder.showSpaceManager",
						eventPayload: "",
						dialogParam: {
							title: cws.I_SPACE_MANAGE_SPACES,
							nodeWidth: "910px",
							nodeHeight: "750px",
							containerBackgroundColor: "white",
							hasRightBottomResizer: false
						}
					};
					eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
				}
			}));
		}
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.spaceSelector", null, null, {
			context: this
		});
		for (var i = 0; i < widgetMenus.length; ++i) {
			var mitem = new dijit.MenuItem({
				label: spaceUtil.getPersonalSpaceTitle(),
				postCreate:function(){
					dijit.MenuItem.prototype.postCreate.call(this);
					htmlUtil.markTruncation(this.containerNode,"153");
				},
				onClick: widgetMenus[i].actionCallBackFunction
			});
			this.addChild(mitem);
		}
		
		var spaceModel = spaceUtil.getSpaceModel();
		var spaceNodes = spaceModel;
		if (!userUtil.isLockedDownAnonymousMode()) {
			spaceNodes = spaceModel.findFavorites();
		}
		if(spaceNodes.hasNext()){
			this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
		}
		var self = this;
		while (spaceNodes.hasNext()) {
			(function(){
				var node = spaceNodes.next();
				if (spaceUtil.isVisiable(node)) {
					var nodeId = node.getID();
					var rootNodeId = spaceModel.find(nodeId).start().getRootNavigation().getID();
					var c = new (nodeId === spaceUtil.getHomeSpaceId() ? com.ibm.mm.builder.iwidget.HomeSpaceMenuItem : dijit.MenuItem)({
						label: com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(node),
						postCreate: function(){
							if (this.declaredClass === "dijit.MenuItem") {
								dijit.MenuItem.prototype.postCreate.call(this);
								htmlUtil.markTruncation(this.containerNode,"153");
							} else {
								com.ibm.mm.builder.iwidget.HomeSpaceMenuItem.prototype.postCreate.call(this);
							}
						},
						_onClick: function(){
							dijit.popup.close(this.getParent());
							var callbackFun = dojo.hitch(this,function(){
								eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace",nodeId);
							});
							com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(callbackFun);
						},
						popup: new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({
							parentPageId: rootNodeId,
							dndDisable: true
						})
					});
					dojo.attr(c.domNode, "space_id", nodeId);
					self.addChild(c);
				}
			})();
		}
		//todo confirmInsert
		if (!userUtil.isLockedDownAnonymousMode() && spaceUtil.getSpaceModel().confirmCreate()) {
			this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
			this.addChild(new dijit.MenuItem({
				label: cws.I_SPACE_CREATE_NEW_SPACE,
				postCreate:function(){
					dijit.MenuItem.prototype.postCreate.call(this);
					htmlUtil.markTruncation(this.containerNode,"153");
				},
				onClick: function(){
					var callbackFun = dojo.hitch(this,function(){
						var payload = {
							widgetTypeId: "createSpace",
							eventName: "com.ibm.mashups.builder.createSpace",
							eventPayload: {createSpaceFromSpaceManager:false},	
							dialogParam: {
								nodeWidth: "675px",
								title: cws.CREATE_SPACE_CAPTION,
								containerBackgroundColor: "white",
								hasRightBottomResizer: false
							}
						};
						eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
					});
					com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(callbackFun);
				}
			}));
		}
		htmlUtil.truncateAllChildNodesText(this.domNode,null,{fontSize:"1.2em"});
	},
	
	_onKeyPress: function(evt){
		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.keyCode){
			case dojo.keys.RIGHT_ARROW:
				this.onItemHover(this.focusedChild);
				break;
			case dojo.keys.LEFT_ARROW:
				if(this.parentMenu){
					this.onCancel(false);
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},
	
	switchToPersonalSpace: function(){
		eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace");
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.SpaceActionMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	
	offset_y: 3,
	
	leftClickToOpen:true,
	
	postCreate: function(){
		dojo.addClass(this.domNode, "spaceActionMenu");
		this.inherited(arguments);
	},
	
	prepareData: function(){
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentContextMenu();
		var currentSpaceId = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.spaceAction", currentSpaceId, null, {
			context: this
		});
		for (var i = 0; i < widgetMenus.length; ++i) {
			if (widgetMenus[i].isSeparator) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
				continue;
			}
			var mitem = new dijit.MenuItem({
				label: widgetMenus[i].title,
				disabled: currentSpaceId == null ? true : widgetMenus[i].enabled == "disabled",
				onClick: widgetMenus[i].actionCallBackFunction
			});
			this.addChild(mitem);
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.HomeSpaceMenuItem",dijit.MenuItem,{
	
	templateString:
		 '<tr class="dijitReset dijitMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"' +
		 'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick">' +
		    '<td class="dijitReset" waiRole="presentation"><div class="dijitMenuItemIcon" dojoAttachPoint="iconNode"></div></td>' +
			'<td class="dijitReset dijitMenuItemLabel" colspan="2">' +
				'<img class="homeSpaceMenuItemIcon" dojoAttachPoint="spaceIconNode" alt="Home Space" title=""></img>' +
				'<span class="homeSpaceMenuItemTitle" widthLimit="134" dojoAttachPoint="containerNode"></span>' +
			'</td>' +
			'<td class="dijitReset dijitMenuArrowCell" waiRole="presentation">' +
			    '<div dojoAttachPoint="arrowWrapper" style="display: none">' +
					'<div class="dijitMenuExpand"></div>' +
					'<span class="dijitMenuExpandA11y">+</span>' +
				'</div>' +
			'</td>' +
		 '</tr>',
		
	postCreate: function(){
		this.spaceIconNode.src = builderConfig.builderPath + "/images/spacemanager/home_space_icon.gif";
		htmlUtil.truncateNodeText(this.containerNode);
		this.containerNode.innerHTML = "<span class='access'>Home Space</span>" +this.containerNode.innerHTML; 
		this.inherited(arguments);
	}
});
})()

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.MumColorPalette"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MumColorPalette"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.MumColorPalette");



dojo.declare(
	"com.ibm.mm.builder.widget.MumColorPalette",
	dijit.ColorPalette,
{
	// palette: String
	palette: "8x16",
	palette_rtl: "8x16_rtl",

	// _palettes: Map
	// 		This represents the value of the colors.
	//		The first level is a hashmap of the different arrays available
	//		The next two dimensions represent the columns and rows of colors.
	_palettes: {
		"8x16": [
			["#FFFFFF", "#DDDDDD", "#BBBBBB", "#999999", "#666666", "#444444", "#222222", "#000000"],
			["#FFEEEE", "#FFFFDD", "#FFFFEE", "#EEFFEE", "#EEFFFF", "#EEEEFF", "#FFEEFF", "#FFEEFF"],
			["#FFCCCC", "#FFFFBB", "#FFFFCC", "#CCFFCC", "#CCFFFF", "#CCCCFF", "#FFCCFF", "#FFCCFF"],
			["#FFAAAA", "#FFEE99", "#FFFFAA", "#AAFFAA", "#AAFFFF", "#AAAAFF", "#EEAAFF", "#FFAAFF"],
			["#FF8888", "#FFDD88", "#FFFF88", "#88FF88", "#88FFFF", "#8888FF", "#DD88FF", "#FF88FF"],
			["#FF6666", "#FFCC66", "#FFFF66", "#66FF66", "#66FFFF", "#6666FF", "#CC66FF", "#FF66FF"],
			["#FF4444", "#FFBB44", "#FFFF44", "#44FF44", "#44FFFF", "#4444FF", "#BB44FF", "#FF44FF"],
			["#FF2222", "#FFAA22", "#FFFF22", "#22FF22", "#22FFFF", "#2222FF", "#AA22FF", "#FF22FF"],
			["#FF0000", "#FF9900", "#FFFF00", "#00FF00", "#00FFFF", "#0000FF", "#9900FF", "#FF00FF"],
			["#DD0000", "#DD8800", "#DDDD00", "#00DD00", "#00DDDD", "#0000DD", "#8800DD", "#DD00DD"],
			["#BB0000", "#BB7700", "#BBBB00", "#00BB00", "#00BBBB", "#0000BB", "#7700BB", "#BB00BB"],
			["#990000", "#996600", "#999900", "#009900", "#009999", "#000099", "#660099", "#990099"],
			["#770000", "#774400", "#777700", "#007700", "#007777", "#000077", "#550077", "#770077"],
			["#550000", "#553300", "#555500", "#005500", "#005555", "#000055", "#440055", "#550055"],
			["#330000", "#332200", "#333300", "#003300", "#003333", "#000033", "#330033", "#330033"],
			["#110000", "#111100", "#111100", "#001100", "#001111", "#000011", "#220011", "#110011"]
		]
	},
	_firstLtrColor: "#FFFFFF",
	// _imagePaths: Map
	//		This is stores the path to the palette images
	_imagePaths: {
		"8x16": dojo.moduleUrl("com.ibm.mm.builder", "widget/templates/images/color_palette.png"),
		"8x16_rtl": dojo.moduleUrl("com.ibm.mm.builder", "widget/templates/images/color_palette_rtl.png")
	},

	// templatePath: String
	//		Path to the template of this widget.
	templateString: 
		'<div class="mumColorPalette">'+
			'<div class="dijitInline dijitColorPalette" style="position:relative">'+
				'<div class="dijitColorPaletteInner" dojoAttachPoint="divNode" waiRole="grid" tabIndex="-1">'+
					'<img class="dijitColorPaletteUnder" dojoAttachPoint="imageNode" waiRole="presentation">'+
				'</div>'+
			'</div>'+
		'</div>',
	
	// _paletteDims: Object
	//		Size of the supported palettes for alignment purposes.
	_paletteDims: {
		"8x16": {"width": "166px", "height": "326px"}
	},
	
	indicator:null,
	
	inputId:null,
	
	postCreate: function(){
		// A name has to be given to the colorMap, this needs to be unique per Palette.
		dojo.mixin(this.divNode.style, this._paletteDims[this.palette]);
		
		var choices = [];
		if (!builderConfig.isBidi) {
			this.imageNode.setAttribute("src", this._imagePaths[this.palette]);
			choices = this._palettes[this.palette];
		} else {
			this.imageNode.setAttribute("src", this._imagePaths[this.palette_rtl]);
			choices = this._palettes[this.palette][0][0] === this._firstLtrColor ? 
				dojo.map(this._palettes[this.palette], function(row){ return row.reverse(); }) : 
					this._palettes[this.palette];
		}
		
		this.domNode.style.position = "relative";
		this._cellNodes = [];	
		//this.colorNames = dojo.i18n.getLocalization("dojo", "colors", this.lang);
		var url = dojo.moduleUrl("dojo", "resources/blank.gif"),
            colorObject = new dojo.Color(),
		    coords = this._paletteCoords;
		for(var row=0; row < choices.length; row++){
			for(var col=0; col < choices[row].length; col++) {
                var imgNode = dojo.doc.createElement("img");
                imgNode.src = url;
                dojo.addClass(imgNode, "dijitPaletteImg");
                var color = choices[row][col];
                imgNode.color = color;
                
                var red = parseInt("0x" + color.substr(1, 2), 16);
                var green = parseInt("0x" + color.substr(3, 2), 16);
                var blue = parseInt("0x" + color.substr(5, 2), 16);
				imgNode.title = imgNode.alt = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR_PICKER_COLOR_TITLE, [red, green, blue]);
                var imgStyle = imgNode.style;
                imgStyle.color = imgStyle.backgroundColor = imgNode.color;
                var cellNode = dojo.doc.createElement("span");
                cellNode.appendChild(imgNode);
                dojo.forEach(["Dijitclick", "MouseEnter", "Focus", "Blur"], function(handler) {
                    this.connect(cellNode, "on" + handler.toLowerCase(), "_onCell" + handler);
                }, this);
                this.divNode.appendChild(cellNode);
                var cellStyle = cellNode.style;
                cellStyle.top = coords.topOffset + (row * coords.cHeight) + "px";
                cellStyle.left = coords.leftOffset + (col * coords.cWidth) + "px";
                dojo.attr(cellNode, "tabindex", "-1");
                dojo.addClass(cellNode, "dijitPaletteCell");
                dijit.setWaiRole(cellNode, "gridcell");
                cellNode.index = this._cellNodes.length;
                this._cellNodes.push(cellNode);
            }
		}
		this._xDim = choices[0].length;
		this._yDim = choices.length;
		this.connect(this.divNode, "onfocus", "_onDivNodeFocus");

		// Now set all events
		// The palette itself is navigated to with the tab key on the keyboard
		// Keyboard navigation within the Palette is with the arrow keys
		// Spacebar selects the color.
		// For the up key the index is changed by negative the x dimension.		

		var keyIncrementMap = {
			UP_ARROW: -this._xDim,
			// The down key the index is increase by the x dimension.	
			DOWN_ARROW: this._xDim,
			// Right and left move the index by 1.
			RIGHT_ARROW: 1,
			LEFT_ARROW: -1
		};
		for(var key in keyIncrementMap){
			this._connects.push(dijit.typematic.addKeyListener(this.domNode,
				{keyCode:dojo.keys[key], ctrlKey:false, altKey:false, shiftKey:false},
				this,
				function(){
					var increment = keyIncrementMap[key];
					return function(count){ this._navigateByKey(increment, count); };
				}(),
				this.timeoutChangeRate, this.defaultTimeout));
		}
	},

	_onBlur:function(){
		dojo.style(this.domNode.parentNode, "display", "none");	
	},
	
	onChange: function(color){
		this.indicator && dojo.style(this.indicator, "backgroundColor", color);
		this.inputId && (dojo.byId(this.inputId).value = color);
		this._onBlur();
		dojo.publish("ColorChanged",[this.indicator]);		
	},
	
	_focusFirst: function(){
		this._currentFocus = builderConfig.isBidi ? 7 : 0;
		var cellNode = this._cellNodes[this._currentFocus];
		window.setTimeout(function(){dijit.focus(cellNode)}, 0);
	}
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.mumHeightResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.mumHeightResizer"] = true;
dojo.provide("com.ibm.mm.builder.widget.mumHeightResizer");




dojo.declare("com.ibm.mm.builder.widget.mumHeightResizer", 
	[dijit._Widget, dijit._Templated],{
	
	templateString: 
		'<div dojoAttachEvent="onmousedown:_beginHeightSizing" class="mumHeightResizeHandler" style="display:none">'+
			'<img dojoAttachPoint="resizeHandlerImage" src="/mum/images/resize.png" alt="resize" title=""/>'+
		'</div>',
			
	minHeight:40,
	
	targetElmId:null,
	
	contentElmId:null,
	
	widgetBodyElmId:null,
	
	postCreate: function(){
		if(builderConfig.isBidi){
			this.resizeHandlerImage.src = "/mum/images/resize_rtl.png";
		}
		if (dojo.isIE == 6) {
			if(builderConfig.isBidi)
				dojo.style(this.domNode, { left: "-8px", bottom: "-33px" });
			else
				dojo.style(this.domNode, { right: "-8px", bottom: "-33px" });
		}
	},

	_beginHeightSizing: function(/*Event*/ e){
		if (this._isSizing){ return false; }
		if (!this.targetElmId){ return; }
		this._isSizing = true;
		if (dojo.isIE){
			this.startPointHeight  = event.clientY;
		}else{
			this.startPointHeight  =e.clientY;
		}
		var mb = dojo._getContentBox(dojo.byId(this.targetElmId));
		this.startHeight  = mb.h;

		this.eventHandles = []; 
		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeHeightSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endHeightSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endHeightSizing")); 

		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_StartHeightSizing, [this.targetElmId]);
		e.preventDefault();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
	},
	
	_changeHeightSizing: function(/*Event*/ e){
		try{
			if (dojo.isIE){
				if(!event.clientX  || !event.clientY){ return; }				
			}else{
				if(!e.clientX  || !e.clientY){ return; }				
			}
		}catch(ex){
			return;
		}

		var dy;
		if (dojo.isIE){
			dy = this.startPointHeight - event.clientY;
		}else{
			dy = this.startPointHeight - e.clientY;
		}
		
		var newH = this.startHeight - dy;
		// minimum height check
		if (this.minHeight) {
			var mb = dojo._getContentBox(dojo.byId(this.targetElmId));
			if (newH < this.minHeight) {
				newH = mb.h;
			}
		}
		dojo.style(dojo.byId(this.targetElmId),"height",newH+"px");
		
		if (this.contentElmId){
			var contentDiv = dojo.byId(this.contentElmId);			
			if (builderConfig.isBidi && 
				   com.ibm.mm.builder.iwidget.columnlayout.bidiColumnUtil.adjustHeightResizer(contentDiv,newH)) {
			} else {								
				if(!this.widgetBodyPadTop){
					this.widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(this.widgetBodyElmId),"paddingTop");
					if(this.widgetBodyPadTop)this.widgetBodyPadTop = parseInt(this.widgetBodyPadTop);
					else this.widgetBodyPadTop = 0;
				}
				var hei = newH - this.widgetBodyPadTop;				
				dojo._setMarginBox(contentDiv,0,0,-1,hei);
			}
		}
				
		// Publish to the change height sizing topic
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_ChangeHeightSizing, [dy]);
		e.preventDefault();
	},

	_endHeightSizing: function(/*Event*/ e){
		this._isSizing = false;
		this.widgetBodyPadTop = null;
		
		while(this.eventHandles.length > 0)
			dojo.disconnect(this.eventHandles.pop()); 

		// Publish to the end height sizing event topic
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_EndHeightSizing);
		var widgets = dojo.query(".iWidgetSkin[skin]", dojo.byId(this.targetElmId));
		if (widgets.length == 1) {
			// old topic
			dojo.publish(widgets[0].id + com.ibm.mm.builder.eventTopics.Resize_EndHeightSizing, [e]);
			
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			var skinDiv=dojo.byId("mm_ibm_skin_"+widgets[0].id);
		    var payload = {
				widgetId: widgets[0].id,
				height: skinDiv.style.height
			};
		    eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);

		}
		dojo.publish(com.ibm.mm.builder.eventTopics.Widget_Column_AddOrDel, []);
	},
	
	destroy : function(){
		this.targetElmId = null;
		this.targetDomNode = null;
		this.inherited(arguments);
	},
	
	show: function(){
		if(com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit")
			return;
		
		clearTimeout(this.showTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			this.domNode && (this.domNode.style.display = "");
		}), 100);
	},
	
	hide: function(){
		if(com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu 
			&& com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow)
			return;
			
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			this.domNode && (this.domNode.style.display = "none");
		}), 100);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.mumResizeHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.mumResizeHandler"] = true;
dojo.provide("com.ibm.mm.builder.widget.mumResizeHandler");




dojo.declare("com.ibm.mm.builder.widget.mumResizeHandler", [dijit._Widget, dijit._Templated], {
	
	templateString: 
		'<div dojoAttachEvent="onmousedown: _beginSizing" class="mumHtmlResizeHandler" style="display:none">'+
			'<img src="/mum/images/resize.png" alt="" dojoAttachPoint="resizeHandlerImage"/>'+
		'</div>',
		
	// targetElmId: dom node id
	targetElmId: null,
	
	// contentElmId: widget content dom node id
	contentElmId: "",	

	widgetBodyElmId: "",
	
	minWidth:20,
	
	minHeight:20,
	
	oldHeight:0,
	
	parentNode:null,
	
	intLeftRTLOrig:0,
	
	intOriginalWidth:0,
	
	isRtl: builderConfig.isBidi,
	
	postCreate: function(){
		if(this.isRtl){
			this.resizeHandlerImage.src = "/mum/images/resize_rtl.png";
		}
		if (dojo.isIE == 6) {
			if(builderConfig.isBidi)
				dojo.style(this.domNode, { left: "-8px", bottom: "-34px" });
			else
				dojo.style(this.domNode, { right: "-8px", bottom: "-34px" });
		}
	},

	_beginSizing: function(/*Event*/ e){
		this.maxSize = this.createMaxSize();
		if (this._isSizing){ 
			return false; 
		}
		this.targetDomNode = dojo.byId(this.targetElmId);
		
		intLeftRTLOrig = parseInt(this.targetDomNode.style.left);
		
		intOriginalWidth = parseInt(this.targetDomNode.style.width);
		
		if (!this.targetDomNode){ 
			return; 
		}
		
		this._isSizing = true;
		
		if (dojo.isIE){
			this.startPoint  = {'x':event.clientX, 'y':event.clientY};
		}else{
			this.startPoint  = {'x':e.clientX, 'y':e.clientY};
		}

		var mb = dojo._getContentBox(this.targetDomNode);
		this.startSize  = {'w':mb.w, 'h':mb.h};

		this.eventHandles = []; 
		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endSizing")); 

		// Publish to the start sizing topic
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_StartSizing, [this.targetElmId]);
		e.preventDefault();	
	},

	_changeSizing: function(/*Event*/ e){
		// On IE, if you move the mouse above/to the left of the object being resized,
		// sometimes clientX/Y aren't set, apparently.  Just ignore the event.
		try{
			if (dojo.isIE){
				if(!event.clientX  || !event.clientY){
					return; 
				}				
			}else{
				if(!e.clientX  || !e.clientY){
					return; 
				}				
			}
		} catch (ex){
			// sometimes you get an exception accessing above fields...
			return;
		}

		var dx,dy;
		if (dojo.isIE){
			dx = this.startPoint.x - event.clientX;
			dy = this.startPoint.y - event.clientY;
		}else{
			dx = this.startPoint.x - e.clientX;
			dy = this.startPoint.y - e.clientY;
		}
		
		if(!this.isRtl){
			var newW = this.startSize.w - dx;
		}else{
			var newW = this.startSize.w + dx;	//for rtl
		}
		
		var newH = this.startSize.h - dy;
		com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeResized(this.targetElmId, newW, dx);

		// minimum size check
		var minWidthExceeded = newW < this.minWidth;
		if (minWidthExceeded) {
			newW = this.minWidth;
		}
		if (newH < this.minHeight) {
			newH = this.minHeight;
		}
		
		// maximum size check
		var maxWidthExceeded = newW > this.maxSize.w;
		if (maxWidthExceeded) {
			newW =this.maxSize.w;
		}
		if (newH > this.maxSize.h) {
			newH = this.maxSize.h;
		}
		
		var contentDiv = dojo.byId(this.contentElmId);
		
		//In Right to Left, move the widget to the left by the same amount that the width is increased.
		if (this.isRtl) {
			if(minWidthExceeded){
				var intLeft = intLeftRTLOrig + (intOriginalWidth - this.minWidth);
			}else{
				var intLeft = maxWidthExceeded ? 0 : intLeftRTLOrig - dx;
			}
		}else{
			var intLeft = parseInt(this.targetDomNode.style.left);
		}
		
		var intTop = parseInt(this.targetDomNode.style.top);
		dojo._setBox(this.targetDomNode,intLeft,intTop,newW,newH);

		if(!this.widgetBodyPadTop){
			this.widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(this.widgetBodyElmId),"paddingTop");
			if(this.widgetBodyPadTop)this.widgetBodyPadTop = parseInt(this.widgetBodyPadTop);
			else this.widgetBodyPadTop = 0;
		}
		var hei = newH - this.widgetBodyPadTop;
		dojo._setMarginBox(contentDiv,0,0,newW,hei);
		if (dojo.isSafari && builderConfig.isBidi) {
			contentDiv.style.width = (parseInt(this.targetDomNode.style.width) - 51) + "px";
		}
		// Publish to the change sizing topic
		var sizeDelta = {x: dx, y: dy};
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_ChangeSizing, [sizeDelta]);
		
		e.preventDefault();
	},

	_endSizing: function(/*Event*/ e){
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		while(this.eventHandles.length > 0)
			dojo.disconnect(this.eventHandles.pop()); 
		
		// Publish to the end sizing event topic
		var widgets = dojo.query(".iWidgetSkin[skin]", dojo.byId(this.targetElmId));
		if (widgets.length == 1) {
			// old topic
			dojo.publish(widgets[0].id + com.ibm.mm.builder.eventTopics.Resize_EndSizing, [e]);
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			var skinDiv=dojo.byId("mm_ibm_skin_"+widgets[0].id);
		    var payload = {
				widgetId: widgets[0].id,
				width: skinDiv.style.width,
				height: skinDiv.style.height
			};
		    eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		}		
		
		com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(this.targetDomNode.id.replace(/mm_ibm_skin_/,""));
		this._isSizing = false;
		this.widgetBodyPadTop = null;
		
		// clear the max-height
		if (widgets.length == 1) {
			var content = dojo.byId(widgets[0].id + com.ibm.mm.builder.constant.widgetContent);
			if(content) content.style.maxHeight = "";
		}			
	},
	
	createMaxSize:function(){
		var curWidget = dojo.byId(this.targetElmId);
		if(curWidget && this.parentNode){
			var curLeft = parseInt(curWidget.style.left);
			var curWidth = parseInt(curWidget.style.width);
			var curTop = parseInt(curWidget.style.top);	
			var wholeWidth = dojo._getContentBox(this.parentNode).w;
			var wholeHeight = dojo._getContentBox(this.parentNode).h;
			var widgetLeftBorderWidth=dojo.style(curWidget,"borderLeftWidth"); //get the left border width of widget
			var widgetRightBorderWidth=dojo.style(curWidget,"borderRightWidth"); //get the right border width of widget
			var maxWidth = this.isRtl ? curLeft + curWidth : wholeWidth - curLeft;
            maxWidth = maxWidth -widgetLeftBorderWidth - widgetRightBorderWidth;
			return {
				w: maxWidth,
				h: wholeHeight - curTop
			}
		}
		return null;
	},
	
	destroy : function(){
		this.targetElmId = null;
		this.targetDomNode = null;
		this.inherited(arguments);
	},
	
	onKeyPress: function(evt){
		if(evt.keyCode == dojo.keys.ENTER)
			this.show();
	},
	
	show: function(){
		if(com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit")
			return;
		
		clearTimeout(this.showTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			this.domNode && (this.domNode.style.display = "");
		}), 100);
	},
	
	hide: function(){
		if(com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu 
			&& com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow)
			return;
			
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			this.domNode && (this.domNode.style.display = "none");
		}), 100);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.nvaMoveEffect"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.nvaMoveEffect"] = true;
dojo.provide("com.ibm.mm.builder.widget.nvaMoveEffect");

dojo.declare("com.ibm.mm.builder.widget.NvaMoveEffect",null,{
	snap: 20,
	time: 400,
	
	effectConstant: {HWCPane:{top:50,left:50,width:90,height:80}, 
					 HWCButton:{top:10,left:30,width:25,height:25}},
	
	callback: [],
	callbackArg: [],
	callbackContext: [],
	
	moverId:"",
	
	isNVAOpen: false,
	
	moveContainerDiv: null,
	
	constructor: function(params) {
		dojo.mixin(this, params);
		
		this.moveContainerDiv = document.createElement("div");
        dojo.style(this.moveContainerDiv, {
            position: "absolute",
            zIndex: "2000",
            backgroundColor: "azure"
        });
	},
	
	move: function(from, to) {
		document.body.appendChild(this.moveContainerDiv);
		dojo.marginBox(this.moveContainerDiv, {
			l: from.x,
            t: from.y,
            w: from.w,
            h: from.h
		});
		
        // get icon url and widget name
        var moverId = com.ibm.mm.builder.skinHelper.getWidgetIdByNvaSkinId(this.moverId);
        var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
        var widgetTitle = widgetUtil.getWidgetInstanceTitle(moverId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
        var widgetIcon = widgetUtil.getWidgetInstanceIcon(moverId);
		this.moveContainerDiv.innerHTML = dojo.string.substitute('<center><img src="${0}"/>${1}</center>', [widgetIcon, widgetTitle]);
		
		var times = this.time / this.snap;
        var topOffset = (to.y - from.y) / times;
        var leftOffset = (to.x - from.x) / times;
        var widthOffset = (to.w - from.w) / times;
        var heightOffset = (to.h - from.h) / times;
		this._startMove(topOffset, leftOffset, widthOffset, heightOffset, times);
	},
	
	_startMove: function(topOffset, leftOffset, widthOffset, heightOffset, times) {
		this.handle = setInterval(dojo.hitch(this, function(){
			var moveBox = dojo.marginBox(this.moveContainerDiv);
			moveBox.t += topOffset;
			moveBox.l += leftOffset;
			moveBox.w += widthOffset;
			moveBox.h += heightOffset;
			dojo.marginBox(this.moveContainerDiv, moveBox);
			
			if(--times <= 0){
				document.body.removeChild(this.moveContainerDiv);
				while(this.callback.length){
					var callback = this.callback.shift();
					var args = this.callbackArg.shift();
					var context = this.callbackContext.shift();
					args instanceof Array ? callback.apply(context, args) : callback.call(context, args);
				}
				clearInterval(this.handle);
			}
		}), this.snap);
	},
	
    addCallback: function(callback, arg, context){
        this.callback.push(callback);
        this.callbackArg.push(arg);
        this.callbackContext.push(context);
    },
	
	// another effect: nva skin font highlight
	highlightFont: function(params) {
		if(!params.div)	return;
		
		var div = params.div;
		var repeat = 2 * (params.repeat || 1);
		var color = params.color || "blue";
		var time = params.time || 300;
		var oldColor = div.style.color || "black";
		
		this.handle = setInterval(function(){
			div.style.color = (div.style.color == color ? oldColor : color);  
			if (--repeat <= 0)
				clearInterval(this.handle);
		}, time);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.OpenSearchPopup"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.OpenSearchPopup"] = true;
dojo.provide("com.ibm.mm.builder.widget.OpenSearchPopup");





opensearch = {};
opensearch.popup = new function(){
	// summary:
	//		This class is used to show/hide widgets as popups.
	//

	var stack = [],
		beginZIndex=1003,
		idGen = 1;

	this.prepare = function(/*DomNode*/ node){
		// summary:
		//		Prepares a node to be used as a popup
		//
		// description:
		//		Attaches node to dojo.doc.body, and
		//		positions it off screen, but not display:none, so that
		//		the widget doesn't appear in the page flow and/or cause a blank
		//		area at the bottom of the viewport (making scrollbar longer), but
		//		initialization of contained widgets works correctly
	
		dojo.body().appendChild(node);
		var s = node.style;
		if(s.display == "none"){
			s.display="";
		}
		s.visibility = "hidden";	// not needed for hiding, but used as flag that node is off-screen
		s.position = "absolute";
		s.top = "-9999px";
	};

	this.open = function(/*Object*/ args){
		// summary:
		//		Popup the widget at the specified position
		//
		// args: Object
		//		popup: Widget
		//			widget to display,
		//		parent: Widget
		//			the button etc. that is displaying this popup
		//		around: DomNode
		//			DOM node (typically a button); place popup relative to this node
		//		orient: Object
		//			structure specifying possible positions of popup relative to "around" node
		//		onCancel: Function
		//			callback when user has canceled the popup by
		//				1. hitting ESC or
		//				2. by using the popup widget's proprietary cancel mechanism (like a cancel button in a dialog);
		//				   ie: whenever popupWidget.onCancel() is called, args.onCancel is called
		//		onClose: Function
		//			callback whenever this popup is closed
		//		onExecute: Function
		//			callback when user "executed" on the popup/sub-popup by selecting a menu choice, etc. (top menu only)
		//
		// examples:
		//		1. opening at the mouse position
		//			dijit.popup.open({popup: menuWidget, x: evt.pageX, y: evt.pageY});
		//		2. opening the widget as a dropdown
		//			dijit.popup.open({parent: this, popup: menuWidget, around: this.domNode, onClose: function(){...}  });
		//
		//	Note that whatever widget called dijit.popup.open() should also listen to it's own _onBlur callback
		//	(fired from _base/focus.js) to know that focus has moved somewhere else and thus the popup should be closed.

		var widget = args.popup,
			orient = args.orient || {'BL':'TL', 'TL':'BL'},
			around = args.around,
			id = (args.around && args.around.id) ? (args.around.id+"_dropdown") : ("popup_"+idGen++);

		// make wrapper div to hold widget and possibly hold iframe behind it.
		// we can't attach the iframe as a child of the widget.domNode because
		// widget.domNode might be a <table>, <ul>, etc.
		var wrapper = dojo.doc.createElement("div");
		dijit.setWaiRole(wrapper, "presentation");
		wrapper.id = id;
		wrapper.className="dijitPopup";
		wrapper.style.zIndex = beginZIndex + stack.length;
		wrapper.style.left = wrapper.style.top = "0px";		// prevent transient scrollbar causing misalign (#5776)
		wrapper.style.visibility = "hidden";
		if(args.parent){
			wrapper.dijitPopupParent=args.parent.id;
		}
		dojo.body().appendChild(wrapper);

		var s = widget.domNode.style;
		s.display = "";
		s.visibility = "";
		s.position = "";
		wrapper.appendChild(widget.domNode);

		var iframe = new dijit.BackgroundIframe(wrapper);

		// position the wrapper node
		var best = around ?
			dijit.placeOnScreenAroundElement(wrapper, around, orient, widget.orient ? dojo.hitch(widget, "orient") : null) :
			dijit.placeOnScreen(wrapper, args, orient == 'R' ? ['TR','BR','TL','BL'] : ['TL','BL','TR','BR']);

		wrapper.style.visibility = "visible";
		// TODO: use effects to fade in wrapper

		var handlers = [];

		// Compute the closest ancestor popup that's *not* a child of another popup.
		// Ex: For a TooltipDialog with a button that spawns a tree of menus, find the popup of the button.
		var getTopPopup = function(){
			for(var pi=stack.length-1; pi > 0 && stack[pi].parent === stack[pi-1].widget; pi--){
				/* do nothing, just trying to get right value for pi */
			}
			return stack[pi];
		}

		// provide default escape and tab key handling
		// (this will work for any widget, not just menu)
		handlers.push(dojo.connect(wrapper, "onkeypress", this, function(evt){
			evt.keyChar = evt.charCode ? String.fromCharCode(evt.charCode) : '';
			evt.charOrCode = evt.keyChar || evt.keyCode;
			if(evt.charOrCode == dojo.keys.ESCAPE && args.onCancel){
				dojo.stopEvent(evt);
				args.onCancel();
			}else if(evt.charOrCode === dojo.keys.TAB){
				dojo.stopEvent(evt);
				var topPopup = getTopPopup();
				if(topPopup && topPopup.onCancel){
					topPopup.onCancel();
				}
			}
		}));

		// watch for cancel/execute events on the popup and notify the caller
		// (for a menu, "execute" means clicking an item)
		if(widget.onCancel){
			handlers.push(dojo.connect(widget, "onCancel", null, args.onCancel));
		}

		handlers.push(dojo.connect(widget, widget.onExecute ? "onExecute" : "onChange", null, function(){
			var topPopup = getTopPopup();
			if(topPopup && topPopup.onExecute){
				topPopup.onExecute();
			}
		}));

		stack.push({
			wrapper: wrapper,
			iframe: iframe,
			widget: widget,
			parent: args.parent,
			onExecute: args.onExecute,
			onCancel: args.onCancel,
 			onClose: args.onClose,
			handlers: handlers
		});

		if(widget.onOpen){
			widget.onOpen(best);
		}

		return best;
	};

	this.close = function(/*Widget*/ popup){
		// summary:
		//		Close specified popup and any popups that it parented
		while(dojo.some(stack, function(elem){return elem.widget == popup;})){
			var top = stack.pop(),
				wrapper = top.wrapper,
				iframe = top.iframe,
				widget = top.widget,
				onClose = top.onClose;
	
			if(widget.onClose){
				widget.onClose();
			}
			dojo.forEach(top.handlers, dojo.disconnect);
	
			// #2685: check if the widget still has a domNode so ContentPane can change its URL without getting an error
			if(!widget||!widget.domNode){ return; }
			
			this.prepare(widget.domNode);

			iframe.destroy();
			dojo._destroyElement(wrapper);
	
			if(onClose){
				onClose();
			}
		}
	};
}();


}

if(!dojo._hasResource["com.ibm.mm.builder.widget.OpenSearchDropdownMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.OpenSearchDropdownMenu"] = true;
dojo.provide("com.ibm.mm.builder.widget.OpenSearchDropdownMenu");





dojo.declare("com.ibm.mm.builder.widget.OpenSearchDropdownMenu",[com.ibm.mm.builder.widget.ShadowMenu],
{
	/**
	 * rewrite this function just for popup zindex set in dialog
	 */
	_openMyself: function(/*Event*/ e){
		if(this.leftClickToOpen&&e.button>0){
			return;
		}
		//TODO fix ie refresh issue..
		try {
			dojo.stopEvent(e);
		} catch (e) {
		}

		//---change the default open position begin
		var node = e.target;
		if(this.targetNodeIds && this.targetNodeIds.length == 1){
			node = this.targetNodeIds[0];
		}
		var coords = dojo.coords(node, true);
		var cbox = dojo.contentBox(node);
		var x = coords.x + (this.offset_x||0);
		var y = coords.y + cbox.h + (this.offset_y||0);
		//---change the default open position end

		var self=this;
		var savedFocus = dijit.getFocus(this);
		function closeAndRestoreFocus(){
			// user has clicked on a menu or popup
			dijit.focus(savedFocus);
			opensearch.popup.close(self);
		}
		opensearch.popup.open({
			popup: this,
			x: x,
			y: y,
			onExecute: closeAndRestoreFocus,
			onCancel: closeAndRestoreFocus,
			orient: this.isLeftToRight() ? 'L' : 'R'
		});
		this.focus();

		this._onBlur = function(){
			this.inherited('_onBlur', arguments);
			opensearch.popup.close(this);
		}
	},
	
	destroy: function(){
	    com.ibm.mm.builder.widget.OpenSearchDropdownMenu.superclass.destroy.call(this);
		
		if(this.domNode && this.domNode.id){
			dijit.registry.remove(this.domNode.id);
		}
		if (this._onBlur) {
			this._onBlur = null;
		}
		dijit.popup.close(this);
	},
	
	postCreate: function(){
		this.entrys = [];
		dojo.addClass(this.domNode,"OpenSearchDropdownMenu");
		com.ibm.mm.builder.widget.OpenSearchDropdownMenu.superclass.postCreate.apply(this);
		dojo.subscribe("com.ibm.mm.catalog.Topics.SearchType_Change",this,"changeSelected");
	},
	
	
	changeSelected: function(type){
		var self = this;
		dojo.forEach(this.entrys,function(item){
			if(type === item.type){
				self.setCurrentSearchType(item.domNode);
			}
		})
	},
	
	setCurrentSearchType : function(searchTypeDom) {
		if (this._currentSearchType) {
			if(this._currentSearchType == searchTypeDom){
				return;
			}
			var iconNode = dojo.query("td",this._currentSearchType)[0];
			dojo.removeClass(iconNode, "checked");
			var containerNode = dojo.query("td",this._currentSearchType)[1];
			dojo.removeClass(containerNode, "checked");
			var describedNode = dojo.query("span",containerNode)[0];
			describedNode.innerHTML = "";	
		}
		var td0Dom = dojo.query("td",searchTypeDom)[0];
		dojo.addClass(td0Dom, "checked");
		var td1Dom = dojo.query("td",searchTypeDom)[1];
		dojo.addClass(td1Dom, "checked");
		this._currentSearchType = searchTypeDom;
		var describedNode = dojo.query("span",td1Dom)[0];					
		describedNode.innerHTML =  " " +com.ibm.mm.builder.coreWidgetsStrings.I_MODE_IS_SELECT;		
	}
	
});

dojo.declare(
	"com.ibm.mm.builder.widget.OpenSearchDropdownMenuItem",
	[dijit.MenuItem],
{
	type:"",
	iconSrc: builderConfig.builderPath + "/images/blueCheckmark.gif", 
	
	postCreate: function(){
		this.inherited("postCreate",arguments);	
		this.iconNode.src = this.iconSrc;
		dojo.addClass(this.iconNode.parentNode,"menuItemCheckMark");
		this.domNode.setAttribute("type", this.type); 
		var dijitMenuLabelA11y = dojo.doc.createElement("span");
		dojo.addClass(dijitMenuLabelA11y,"access");
		this.containerNode.appendChild(dijitMenuLabelA11y);				
	}
});

dojo.declare(
	"com.ibm.mm.builder.widget.OpenSearchDropdownMenuSeparator",
	[dijit.MenuSeparator],
{
	templateString: '<tr class="dijitMenuSeparator"><td colspan=3>'
			+'<div class="modeSelector_seperator">'
			+'<div class="menuItemCheckMark" dojoAttachPoint="markSeparator"> </div>'
			+'<div class="modeSelector_divider""></div>'
			+'</div>'
			+'</td></tr>',
	
	
	destroy: function(){
		dijit.registry.remove(this.domNode.id)
	},
	
	postCreate: function(){
		dojo.setSelectable(this.domNode, false);
		this.domNode.style.height = "2px";
		this.domNode.style.lineHeight = "2px";
		this.markSeparator.style.background="url(/mum/images/sideBar.gif)";	
		this.domNode.style.fontSize = "1pt";
	}	
});



}

if(!dojo._hasResource["com.ibm.mm.builder.widget.moveWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.moveWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.moveWidget");








dojo.declare("com.ibm.mm.builder.widget.moveWidget",[dijit._Widget, dijit._Templated],{	
    templateString: 
    	'<div dojoAttachEvent="onkeypress: _onKeyPress" class="moveWidgetContainer">'+
			'<div class="moveWidgetDiv" dojoAttachPoint="containerNode">'+
				'<div class="moveWidgetItem" dojoAttachPoint="moveWidgetTopDiv">'+
					'<span class="moveWidget_item_label">${I_CONTEXT_MENU_WIDGET_TOP_LABEL}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" type="text" dojoAttachPoint="widgetTopInput" '+ 
						'title="${TOP_INPUT_TITLE}" invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" '+
						'class="moveWidget_inputField" required="true" tabindex=0/>'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
				'<div class="moveWidgetItem" dojoAttachPoint="moveWidgetLeftDiv">'+
					'<span class="moveWidget_item_label">${I_CONTEXT_MENU_WIDGET_LEFT_LABEL}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" type="text" dojoAttachPoint="widgetLeftInput" '+ 
						'title="${LEFT_INPUT_TITLE}" invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" '+
						'class="moveWidget_inputField" required="true" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
			'</div>'+
		'</div>',
	
	TOP_INPUT_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_TITLE2,
	LEFT_INPUT_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_TITLE1,
	
	I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE,
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	I_CONTEXT_MENU_WIDGET_TOP_LABEL: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_TOP_LABEL,
	I_CONTEXT_MENU_WIDGET_LEFT_LABEL: builderConfig.isBidi ? 
		com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_RIGHT_LABEL : 
		com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_LEFT_LABEL,
	
	widgetsInTemplate: true,
	
	postCreate: function(){	
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
		this._setA11YHint();
	},
	
	_setA11YHint: function() {
		var leftInput = dojo.query("input", this.moveWidgetLeftDiv)[0];
		dojo.attr(leftInput, "title", this.LEFT_INPUT_TITLE);
		
		var topInput = dojo.query("input", this.moveWidgetTopDiv)[0];
		dojo.attr(topInput, "title", this.TOP_INPUT_TITLE);
		
	},
	
	_onKeyPress:function(evt){
		evt.keyCode == dojo.keys.ENTER && this.save();
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		
		this.widgetTopInput.constraints = {min: 0, places: 0};
				
		var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
		var widgetWidth = com.ibm.mm.builder.utils.skinUtil.getLocationValue("width", widgetId);
		this.widgetLeftInput.constraints = {min:0,max: pageWidthRange.max-widgetWidth, places:0};
				
		var pageWidthMode = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode();
		if(pageWidthMode.mode === "fixed"){
			var maxValue = pageWidthMode.width;			
			if(maxValue > widgetWidth){
				maxValue = maxValue - widgetWidth;
			}
			this.widgetLeftInput.constraints = {"min":0,"max":maxValue,"places":0};
		}

		var top = com.ibm.mm.builder.utils.skinUtil.getLocationValue("top",widgetId);
		if (top){
			top = parseInt(top);	
			this.widgetTopInput.setValue(top);		
		}
		var left = com.ibm.mm.builder.utils.skinUtil.getLocationValue(builderConfig.isBidi ? "right" : "left",widgetId);
		if (left){
			left = parseInt(left);		
			this.widgetLeftInput.setValue(left);
		}
		this.uniDialog.show();
	},
	
	setTitle: function(title)
	{
		if(this.uniDialog)
		{
			this.uniDialog.setTitle(title);
		}
	},
		
	save: function(){
		if(!(this.widgetTopInput.isValid() && this.widgetLeftInput.isValid())) return;
		
		var widget_left_coordinate = 0;
		if(builderConfig.isBidi){
			var widget_width = com.ibm.mm.builder.utils.skinUtil.getLocationValue("width", this.widgetId);
			var page_width = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode().width;
			
			widget_left_coordinate = page_width - widget_width - this.widgetLeftInput.getValue();
			if(widget_left_coordinate < 0) widget_left_coordinate = 0;
		}else{
			widget_left_coordinate = this.widgetLeftInput.getValue();
		}
		
		this.moveWidget({
			id: this.widgetId,
			top: this.widgetTopInput.getValue()+"px", 
			left: widget_left_coordinate + "px"
		});
		dojo.publish("/freeform/internalTopics/updateContainerSize",[this.widgetId]);
		this.hide();
	},
		
	moveWidget:function(widgetInfo){
		var widgetId = widgetInfo.id;
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,this.layoutContext.widgetId)){
			var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
			var pageWidthMode = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode();
			if(pageWidthMode.mode === "dynamic"){
				com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeMoved(widgetInfo.id, parseInt(widgetInfo.left));			
			} else {
				var widgetWidth = dojo.marginBox(widgetSkinNode).w;
				if(parseInt(widgetInfo.left)> (pageWidthMode.width - widgetWidth)){
					widgetInfo.left = pageWidthMode.width - widgetWidth + "px";
				}
			}
			dojo.style(widgetSkinNode,{top:widgetInfo.top,left:widgetInfo.left});
//			var widgetContentNode = dojo.byId(widgetId+com.ibm.mm.builder.constant.widgetContent);
//			dojo.style(widgetContentNode,{top:parseInt(widgetInfo.top)-51,left:parseInt(widgetInfo.left)-62});
			this.layoutContext.iEvents.publishEvent("com.ibm.mashups.builder.widgetMoved", widgetInfo);
		}	
	},

	onDialogResize: function(width, height)
	{
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		
		dojo.marginBox(this.containerNode, containerMB);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.resizeWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.resizeWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.resizeWidget");






dojo.declare("com.ibm.mm.builder.widget.resizeWidget",[dijit._Widget, dijit._Templated],{	

	templateString:
		'<div dojoAttachEvent="onkeypress: _onKeyPress" class="resizeWidgetContainer">'+
			'<div class="resizeWidgetDiv" dojoAttachPoint="containerNode">'+
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeWidthDiv">'+
					'<span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_WIDTH}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetWidthInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_WIDTH}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeHeightDiv">'+
					'<span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_HEIGHT}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetHeightInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_HEIGHT}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
	
	I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE,
	I_CONTEXT_MENU_WIDGET_WIDTH: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_WIDTH,
	I_CONTEXT_MENU_WIDGET_HEIGHT: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_HEIGHT,
	I_CONTEXT_MENU_WIDGET_WIDTH: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_WIDTH,
	I_CONTEXT_MENU_WIDGET_HEIGHT: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_HEIGHT,
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	
	minWidth:50,
	minHeight:50,
	
	widgetsInTemplate: true,
	
	postCreate: function(){
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
		this._setA11YHint();
		
		if(dijit._masterTT){
			dijit.setWaiState(dijit._masterTT.containerNode,"live","assertive");
			dijit.setWaiRole(dijit._masterTT.containerNode,"alert");
		}
	},
	
	_setA11YHint: function() {
		var widthInput = dojo.query("input", this.resizeWidthDiv)[0];
		dojo.attr(widthInput, "title", this.I_CONTEXT_MENU_WIDGET_WIDTH);
		
		var heightInput = dojo.query("input", this.resizeHeightDiv)[0];
		dojo.attr(heightInput, "title", this.I_CONTEXT_MENU_WIDGET_HEIGHT);
		
	},
	
	_onKeyPress:function(evt){
		evt.keyCode == dojo.keys.ENTER && this.save();
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		
		this.maxSize = this.createMaxSize(widgetId);
		var pageWidthMode = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode();
		this.widgetWidthInput.constraints = {
			min: this.minWidth, 
			max: pageWidthMode.mode === "fixed" ? this.maxSize.w : this.maxSize.maxW,
			places: 0
		};
		this.widgetHeightInput.constraints = {
			min: this.minHeight, 
			max: this.maxSize.h,
			places: 0
		}

		var height = com.ibm.mm.builder.utils.skinUtil.getLocationValue("height",widgetId);
		if (height){
			height = parseInt(height);	
			this.widgetHeightInput.setValue(height);
		}
		var width = com.ibm.mm.builder.utils.skinUtil.getLocationValue("width",widgetId);
		if (width){
			width = parseInt(width);		
			this.widgetWidthInput.setValue(width);		
		}
		this.uniDialog.show();
	},
	
	setTitle: function(title){
		this.uniDialog && this.uniDialog.setTitle(title);
	},
		
	save: function(){
		if(!(this.widgetWidthInput.isValid()&&this.widgetHeightInput.isValid())) 
			return;
			
		var height = this.widgetHeightInput.getValue();
		var width = this.widgetWidthInput.getValue();
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(this.widgetId, this.layoutContext.widgetId)){
        	var payload = {
				widgetId: this.widgetId,
				width: width,
				height: height
			};
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		 }
		this.hide();
	},
	
	createMaxSize:function(widgetId){
		var curWidget = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		var containerNode = curWidget.parentNode;
		if(curWidget && containerNode){
			// defect 7486
			var curWidgetBox = dojo.marginBox(curWidget);
			var curLeft = parseInt(curWidgetBox.l);
			var curTop = parseInt(curWidgetBox.t);	
			
			var wholeWidth = dojo._getContentBox(containerNode).w;
			var wholeHeight = dojo._getContentBox(containerNode).h;
			var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
			
			return {
				maxW: pageWidthRange.max - curLeft,
				w: wholeWidth - curLeft,
				h: wholeHeight - curTop
			};
		}
		return null;		
	},
	
	onDialogResize: function(width, height)
	{
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		
		dojo.marginBox(this.containerNode, containerMB);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.columnLayoutResizeWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.columnLayoutResizeWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.columnLayoutResizeWidget");




dojo.declare("com.ibm.mm.builder.widget.columnLayoutResizeWidget", com.ibm.mm.builder.widget.resizeWidget, {	

	minHeight:40,
	
	postCreate: function(){
		this.inherited(arguments);
		this.widgetHeightInput.constraints = {min:this.minHeight, places:0};
		dojo.style(this.resizeWidthDiv, "display", "none");
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		this.maxHeight = this.getMaxHeight(widgetId);
		this.widgetHeightInput.constraints = {
			min: this.minHeight, 
			max: this.maxHeight,
			places: 0
		}
		
		var height = com.ibm.mm.builder.utils.skinUtil.getLocationValue("height", widgetId);
		if (height){
			height = parseInt(height);	
			this.widgetHeightInput.setValue(height);
		}
		this.uniDialog.show();
	},
	
	getMaxHeight : function(widgetId){
		var curWidget = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		var containerNode = curWidget.parentNode;
		if(curWidget && containerNode){
			var curWidgetBox = dojo.marginBox(curWidget);
			var curTop = parseInt(curWidgetBox.t);	
			
			var wholeHeight = dojo._getContentBox(containerNode).h;
			var maxHeight = wholeHeight - curTop + 200;
			return 	maxHeight;
		}
		return null;	
	},
	
	setTitle: function(title){
		this.uniDialog && this.uniDialog.setTitle(title);
	},
	
	save: function(){
		if (!this.widgetHeightInput.isValid()) {
			return;
		}
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(this.widgetId,this.layoutContext.widgetId)){
		 	dojo.publish(com.ibm.mm.builder.eventTopics.Widget_Column_AddOrDel, []);
		    var payload = {
				widgetId: this.widgetId,
				height: this.widgetHeightInput.getValue()
			};
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		}	
		
		this.hide();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.ViewMorePage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ViewMorePage"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 * @author ERiK (bizheng@cn.ibm.com)
 */
//todo refactory the html structure..
dojo.provide("com.ibm.mm.builder.widget.ViewMorePage");

dojo.declare("com.ibm.mm.builder.widget.ViewMorePage",
	[dijit._Widget,dijit._Templated, dijit._Container], 
{
	templateString: '<div><div dojoAttachPoint="containerNode"></div></div>',
	
	postCreate: function(){
		this.pageList = [];
		dojo.forEach(this.items, function(item){ 
			this.addChild(new com.ibm.mm.builder.widget.ViewMorePageItem({title:item.title, pid:item.pid, pre:item.pre, end:item.end}))
		},this)
	},
	
	reGenerate: function(items) {
		this.pageList = [];
		this.items = items;
		this.destroyDescendants();
		dojo.forEach(this.items, function(item){ 
			this.addChild(new com.ibm.mm.builder.widget.ViewMorePageItem({title:item.title, pid:item.pid, pre:item.pre, end:item.end}))
		},this)
	}
});

dojo.declare("com.ibm.mm.builder.widget.ViewMorePageItem",
	[dijit._Widget,dijit._Templated, dijit._Container, dijit._Contained],
{
	templateString_rtl:
			'<div style="height:25px" waiRole="presentation">' +
			'<div dojoAttachPoint="treeItemDividerTop" class="treeItemDividerTop"></div>'+
			'<div dojoAttachPoint="contentNode" class="pageItemContent" dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover" waiRole="presentation">' +
		        '<span style="float:right" dojoAttachPoint="iconNode" waiRole="presentation">' +
		        '</span>' +
		        '<span style="float:right" dojoAttachPoint="labelDescNodePre" class="treeItemDesc treeItemDescPreLoc"></span>' +
		        '<span style="float:right" dojoAttachPoint="labelNode" class="treeItemText" wairole="treeitem" tabindex="0"></span>' +
		    	'<span style="float:right" dojoAttachPoint="labelDescNode" class="treeItemDesc treeItemDescLoc"></span>' +
		    	'<span style="padding:0px 20px;float:left">' +
			    	'<input dojoAttachPoint="btnAddNode" class="sharingPageTreeButton" type="button" value="" dojoAttachEvent="onclick:_onAddClick"/>' +
			    	'<input style="display:none" class="sharingPageTreeButton" dojoAttachPoint="btnRemoveNode" type="button" value="" dojoAttachEvent="onclick:_onRemoveClick"/>' +
		    	'</span>' +
		    '</div>'+
			'<div dojoAttachPoint="treeItemDividerBottom" class="treeItemDividerBottom"></div>'+
		'</div>',

	templateString:
		'<div style="height:25px" waiRole="presentation">' +
			'<div dojoAttachPoint="treeItemDividerTop" class="treeItemDividerTop"></div>'+
			'<div dojoAttachPoint="contentNode" class="pageItemContent" dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover" waiRole="presentation">' +
		        '<span style="float:left" dojoAttachPoint="iconNode" waiRole="presentation">' +
		        '</span>' +
		        '<span style="float:left" dojoAttachPoint="labelDescNodePre" class="treeItemDesc treeItemDescPreLoc"></span>' +
		        '<span style="float:left" dojoAttachPoint="labelNode" class="treeItemText" wairole="treeitem" tabindex="0"></span>' +
		    	'<span style="float:left" dojoAttachPoint="labelDescNode" class="treeItemDesc treeItemDescLoc"></span>' +
		    	'<span style="padding:0px 20px;float:right">' +
			    	'<input dojoAttachPoint="btnAddNode" class="sharingPageTreeButton" type="button" value="" dojoAttachEvent="onclick:_onAddClick"/>' +
			    	'<input style="display:none" class="sharingPageTreeButton" dojoAttachPoint="btnRemoveNode" type="button" value="" dojoAttachEvent="onclick:_onRemoveClick"/>' +
		    	'</span>' +
		    '</div>'+
			'<div dojoAttachPoint="treeItemDividerBottom" class="treeItemDividerBottom"></div>'+
		'</div>',
		
	postMixInProperties : function(){
		if(builderConfig.isBidi){
			this.templateString = this.templateString_rtl;
		}
	},
	
	postCreate: function(){
		this.labelDescNodePre.innerHTML = this.pre;
		this.labelDescNode.innerHTML = this.end;
		this.labelNode.innerHTML = this.title;
		this.domNode.title = com.ibm.mm.builder.utils.htmlUtil.unEscapeString(this.title);
		this.btnAddNode.value = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_ADD;
		this.btnRemoveNode.value = com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_REMOVE;
		this._changeToAdd();

	},
	
	_onHover: function(){
		dojo.addClass(this.domNode,"highLightTreeItem")
		dojo.addClass(this.labelNode,"highLightTreeText")
		this.treeItemDividerTop.style.backgroundImage = "url('" + builderConfig.builderPath +"/images/divider_morepages_hover_top.png')"
	},
	
	_onUnhover: function(){	
		dojo.removeClass(this.domNode,"highLightTreeItem")
		dojo.removeClass(this.labelNode,"highLightTreeText")
		this.treeItemDividerTop.style.backgroundImage = ""
	},
	
	_changeToAdd: function(){
		this.labelNode.style.color = "#000000"
		this.labelNode.style.fontSize = "12px"
		this.labelNode.fontFamily = "Arial"
		this.btnAddNode.style.display = ""
		this.btnRemoveNode.style.display = "none"
	},
	
	_changeToRemove: function(){
		this.labelNode.style.color = "#BDBDD3"
		this.btnAddNode.style.display = "none"
		this.btnRemoveNode.style.display = ""
	},
	
	_onRemoveClick: function(){
		this._changeToAdd();
		this.removeItem(this.getParent().pageList,this.pid);
	},
	
	removeItem: function(array,value){
	    for(var i=0,n=0; i<array.length; i++)
	    {
	        if(array[i] != value)
	        {
	            array[n++] = array[i];
	        }
	    }
	    array.length -= 1;
	},
	
	_onAddClick: function(){
		this._changeToRemove();
		this.getParent().pageList.push(this.pid);
	}
});



}

if(!dojo._hasResource["com.ibm.mm.builder.widget.WidgetEditBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.WidgetEditBar"] = true;
dojo.provide("com.ibm.mm.builder.widget.WidgetEditBar");




dojo.declare("com.ibm.mm.builder.widget.WidgetEditBar",[dijit._Widget, dijit._Templated],{	

	templateString:
		'<div id="${widgetId}_dragHandler_editbar" style="display:none" class="editBar" '+
			'dojoAttachEvent="onmouseover: show">'+
			'<div id="${widgetId}_dragHandler" class="dojoDndHandle borderinHM">'+
				'<div class="${widgetDragHandlerLeft}"></div>'+
				'<div class="${widgetDragHandlerRight}"></div>'+
				'<div class="widgetDragHandlerMiddle">'+
					'<img class="widgetIconStyle">'+
					'<span class="widgetTitleShadow">${title}</span>'+
					'<span class="widgetTitle">${title}</span>'+
					'<img src="${wireIconUrl}" class="widgetInteraction" '+
						'dojoAttachEvent="onclick:_onWireIconClick,onmousedown:_onMouseDown,onkeypress:_wireIconOnKeypress" '+
						'border=0 title="${I_SKIN_WIRE_ICON_TITLE}" alt="${I_SKIN_WIRE_ICON_TITLE}" tabIndex="0"/>'+
					'<img id="${widgetId}_menu" src="${editIconUrl}" class="widgetContext" '+
						'dojoAttachEvent="onclick:_onEditIconClick,onmousedown:_onMouseDown,onkeypress:_editIconOnKeypress" '+
						'border=0 title="${I_SKIN_EDIT_ICON_TITLE}" alt="${I_SKIN_EDIT_ICON_TITLE}" tabIndex="0"/>'+	
				'</div>'+
			'</div>'+
			'<div class="widgetDragHandlerBG"></div>'+
			'<div class="widgetDragHandlerCorner"></div>'+
			'<div class="editBarRightTopCornerShadow"></div>'+	
			'<div class="editBarCornerShadow"></div>'+
		'</div>',
		
	I_SKIN_WIRE_ICON_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_WIRE_ICON_TITLE, 
	I_SKIN_EDIT_ICON_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_EDIT_ICON_TITLE,
	
	wireIconUrl: builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png" :
		"/images/d_wiring_icon.png"),
	
	editIconUrl: builderConfig.builderPath + (builderConfig.isBidi ? "/images/context_menu_rtl.png" :
		"/images/context_menu.png"),
	
	widgetDragHandlerLeft: builderConfig.isBidi ? "widgetDragHandlerLeftRtl" : "widgetDragHandlerLeft",
	widgetDragHandlerRight: builderConfig.isBidi ? "widgetDragHandlerRightRtl" : "widgetDragHandlerRight",
	
	iconUrl: null,
	title: "",
	widgetId: null,
	
	_wireIconOnKeypress: function(e){
		if (e.keyCode == dojo.keys.ENTER)
			this._onWireIconClick();
	},
	
	_editIconOnKeypress: function(e){
		if (e.keyCode == dojo.keys.ENTER)
			com.ibm.mm.builder.skinHelper.createMenu(e, this.widgetId+"_menu", this.widgetId, false);
	},
	
	_onMouseDown: function(evt){
		dojo.stopEvent(evt);
	},
	
	_onEditIconClick: function(evt){
		com.ibm.mm.builder.skinHelper.createMenu(evt, this.widgetId+"_menu", this.widgetId, false);
	},
	
	_onWireIconClick: function(evt){
		if(!this._isWidgetLoaded())
			return;
			
		this.hide();
		com.ibm.mm.builder.skinHelper.launchWiring(this.widgetId);
	},
	
	_isWidgetLoaded: function(){
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.widgetId);
		return widgetModel && widgetModel.loaded;
	},
	
	onKeyPress: function(evt){
		if (evt.keyCode == dojo.keys.ENTER) {
//			dojo.stopEvent(evt);
			this.show();
		}
	},
	
	keep: function(){
		clearTimeout(this.hideTimer);
	},
	
	show: function(evt){
		if(com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit"){
			return;
		}
		clearTimeout(this.showTimer);
		clearTimeout(this.hideTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			this.domNode && (this.domNode.style.display = "");
		}), 100);
	},
	
	hide: function(evt){
		if(com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu 
			&& com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow)
			return;
			
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			this.domNode && (this.domNode.style.display = "none");
			if (builderConfig.isBidi && dojo.isIE===6) {                	
		    	dojo.removeClass(this.widgetId + com.ibm.mm.builder.constant.widgetBody, "widgetBodyEdit");
		    	var _title = dojo.byId(this.widgetId + "_title");
		    	_title && dojo.removeClass(_title, "widgetTitleEdit");
				
		    	if (dojo.hasClass(this.widgetId + com.ibm.mm.builder.constant.widgetContent, "rtlOverride_IE_paddingTop_0px")) {
		    		dojo.byId(this.widgetId + com.ibm.mm.builder.constant.widgetContent).style.paddingTop = "0px";
		    	}			    	
	        }
		}), 100);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.ACLReassignDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.ACLReassignDialog"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.ACLReassignDialog");


/**
 * this class will create the access control reassign dialog
 */
dojo.declare("com.ibm.mm.builder.dialog.ACLReassignDialog", null, {

	aclReassignDialog:null,
	
	aclReassignRootDiv:null,
	
	constructor: function(layout,target,list){
		this.layout = layout;
		this.viewIsSource = false;
		//this.personalizeIsSource = false;
		this.editIsSource = false;
		this.target = target;	
		this.aclReassignList = list;
	},
	
	initACLReassignContent:function(){
		
		this.maxLen = dojo.isIE ? 50 : 95;
		if (ibmConfig.fontSizeEnlarged && dojo.isSafari) {
			this.maxLen = dojo.isSafari < 4 ? 65 : 60;		
		}
		this.aclReassignRootDiv = document.createElement("div");
		
		var aclReassignContentDiv  = document.createElement("div");
		dojo.addClass(aclReassignContentDiv,"accessControlReassignDiv");
		
		var aclReassignTitleSpan = document.createElement("span");
		dojo.addClass(aclReassignTitleSpan,"accessControlReassignTitle");
		aclReassignTitleSpan.innerHTML= com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INFORMATION_1 + "<br/><br/>";
		aclReassignContentDiv.appendChild(aclReassignTitleSpan);
		
		var aclReassignListSpan = document.createElement("span");
		dojo.addClass(aclReassignListSpan,"accessControlReassignList");
		aclReassignListSpan.innerHTML=this._listToHtml(this.aclReassignList);
		aclReassignContentDiv.appendChild(aclReassignListSpan);
		
		var aclReassignConfirmSpan = document.createElement("span");
		dojo.addClass(aclReassignConfirmSpan,"accessControlReassignConfirm");
		aclReassignConfirmSpan.innerHTML="<br/>" + com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INFORMATION_2 + "<br/><br/>";
		aclReassignContentDiv.appendChild(aclReassignConfirmSpan);
		
		var aclReassignButtonDiv = document.createElement("div");
		dojo.addClass(aclReassignButtonDiv,"accessControlReassignBottomDiv");
		
		var htmlUtil = com.ibm.mm.builder.utils.htmlUtil;
		var aclReassignResignBtn = document.createElement("input");
		aclReassignResignBtn.setAttribute("type","button");
		aclReassignResignBtn.setAttribute("value",htmlUtil.getStrWithLimit(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_BTN,aclReassignResignBtn,this.maxLen));
		aclReassignResignBtn.setAttribute("title",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_BTN);

		/* begin a11y fixes for truncated value */
		dojo.attr(aclReassignResignBtn,'role','button');
		dojo.attr(aclReassignResignBtn,'wai-role','button');
		dojo.attr(aclReassignResignBtn,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_BTN);	
		/* end a11y fixes for truncated value */
						
		dojo.addClass(aclReassignResignBtn,"lotusFormButton");
		dojo.addClass(aclReassignResignBtn,"lotusFormButtonReassign");
		
		//for a11y
		this._defaultFocus = aclReassignResignBtn;
		
		var aclReassignNoChangeBtn = document.createElement("input");
		aclReassignNoChangeBtn.setAttribute("type","button");
		aclReassignNoChangeBtn.setAttribute("value",htmlUtil.getStrWithLimit(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_NOT_CHANGE,aclReassignNoChangeBtn,this.maxLen));
		aclReassignNoChangeBtn.setAttribute("title",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_NOT_CHANGE);
		
		/* some a11y fixes */
		dojo.attr(aclReassignNoChangeBtn,'role','button');
		dojo.attr(aclReassignNoChangeBtn,'wai-role','button');
		dojo.attr(aclReassignNoChangeBtn,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_NOT_CHANGE);	
				
		dojo.addClass(aclReassignNoChangeBtn,"lotusFormButton");
		dojo.addClass(aclReassignNoChangeBtn,"lotusFormButtonReassignNoChange");
		
		aclReassignButtonDiv.appendChild(aclReassignResignBtn);
		aclReassignButtonDiv.appendChild(aclReassignNoChangeBtn);
		aclReassignContentDiv.appendChild(aclReassignButtonDiv);
		
		this.aclReassignRootDiv.appendChild(aclReassignContentDiv);
		
		dojo.connect(aclReassignResignBtn, "onclick", this, "reassign");
		dojo.connect(aclReassignNoChangeBtn, "onclick", this, "noChange");
		
	},
	
	_getSource:function(perm){
		switch(perm){
			case "aclView":
				this.viewIsSource = true;
				return com.ibm.mm.builder.dnd.viewSource ;
				break;
			case "aclPersonal":
				this.personalizeIsSource = true;
				return com.ibm.mm.builder.dnd.personalizeSource;
				break;
			case "aclEdit":
				this.editIsSource = true;
				return com.ibm.mm.builder.dnd.editSource;
				break;
		}
	},
	reassign:function(){
		for(var i=0;i<this.aclReassignList.length;i++){
			var source = this._getSource(this.aclReassignList[i].perm);
			this.layout.transferNode(source,this.target,this.aclReassignList[i].id,null,false);
		}
		if(this.viewIsSource){
			dojo.publish("aclView");
			this.viewIsSource = false;
		}
		if(this.personalizeIsSource){
			dojo.publish("aclPersonalize");
			this.personalizeIsSource = false;
		}
		if(this.editIsSource){
			dojo.publish("aclEdit");
			this.editIsSource = false;
		}
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateAllPageControl);
		this.hide();
	},
	noChange:function(){
		this.hide();
	},
	/**
	 * show the access control reassign dialog
	 */
	show: function(){
		this.initACLReassignContent();
		var acrId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID() + "_accessControlReassign";
		var aclReassignDialog = dijit.byId(acrId);
		if (aclReassignDialog){
			aclReassignDialog.destroy();
		}	
		var dialogWidth = (dojo.isIE)?"370px":"350px";
			
		this.aclReassignDialog = new com.ibm.mm.builder.widget.CustomDialog(
			{
				id: acrId,
				title: com.ibm.mm.builder.coreWidgetsStrings.I_ACL_CONFLICT_TITLE,
				nodeWidth: dialogWidth,
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			},
			this.aclReassignRootDiv
		);
		dojo.publish("/com/ibm/mashups/livetext/livetextchanged",[this.aclReassignDialog.domNode]);
		this.aclReassignDialog.show();
		
		//for a11y
		this._defaultFocus.focus();
	},

	/**
	 * hide the access control reassign dialog
	 */		
	hide: function(){		
		this.aclReassignDialog.hide();
	},
	_listToHtml:function(list){
		var content ="";
		for(var i=0;i<list.length;i++){
			var perm;
			switch(list[i].perm){
				case "aclView":
					perm=com.ibm.mm.builder.coreWidgetsStrings.I_ACL_PERMISSION_VIEW;
					break;
				case "aclPersonalize":
					perm="Personalize";//personalization is not supported in v1
					break;
				case "aclEdit":
					perm=com.ibm.mm.builder.coreWidgetsStrings.I_ACL_PERMISSION_EDIT;
					break;
				default:
					perm="";
			}
			
			var newItem = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INFORMATION_HAS,[list[i].name,"<span class='accessControlReassignLevel'>" + perm + "</span>"," <span class='accessControlReassignHas' > "," </span>"]);
			content = content+ "<span>"+ newItem + "</span><br/>";
		}
		return content;
	}	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.EmbeddingWidgetDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.EmbeddingWidgetDialog"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog");




/**
 * This class will launch a custom dialog to show the embed widget UI.
 */
dojo.declare("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog",null,{
	/**
	 * the root element id which the embed widget UI will be appended.
	 * @type String
	 */
	rootId:null,
	/**
	 * embed widget ID.
	 * @type String
	 */
	widgetId:null,
	
	/**
	 * widget instance ID for the widget to be embedded.
	 * @type String
	 */		
	widgetInstanceId:null,
	
	/**
	 * id of the div to host embedding dlg 
	 * @type String
	 */		
	embeddingDlg_ID:"mainEmbeddingDialog",

	/**
	 * id of the div to host embedding preview dlg 
	 * @type String
	 */	
	embeddingPreviewDlg_ID:"mainEmbeddingPreviewDialog",
	
	/**
	 * widget edit mode dlg
	 * @type Object
	 */
	editPane:null,
	
	/**
	 * open the preview by default or not
	 * @type String
	 */
	openPreviewAuto: "auto", // open preview by default
	
	openPreviewForce: "force", // user click the preview button
	
	/**
	 * Constructor
	 * set open preview as true by default, subscribe a close dlg topic
	 */	
	constructor: function(_rootId, _widgetId){
		this.widgetId = _widgetId;
		this.rootId = _rootId;
		var preview = dojo.cookie("open_embed_widget_preview") || true;
		this.openEmbedWidgetPreview = (preview == "true") ? true : false;
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog");
	},

	/**
	 * create the embedding widget dlg UI content
	 * @param {Object} stub
	 */	
	createEmbedingContent:function(widgetDef,status){
		var modes = widgetDef.getSupportedModes();
		var enableEditSetting = true;
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetInstanceId);
		
		var desc = "";
		// check the widget supported mode
		if (modes!=null && modes.length >0) {	
			if (!this._belong("edit",modes)){
				enableEditSetting = false;
				desc = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_WIDGET_DESC_NOEDITMODE;
			}else{
				desc = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_WIDGET_DESC_WITHEDITMODE;
			}
		}else{
			this.LOGGER.severe("createEmbedingContent",com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_WIDGET_ERROR_0);
		}			
		
		//update the description
		(desc !== "") && (dojo.byId("_"+this.widgetId+"_embed_desc").innerHTML = desc)
		
		var inDialog = this.dialogContainer==null?false:true;
		
		// create the preview dlg
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PAGE_PREVIEW_TITLE, [widgetTitle]);
		if (!this.previewDlg){
			this.previewDlg = new com.ibm.mm.builder.widget.CustomDialog({
				id:	this.embeddingPreviewDlg_ID,
				containerBackgroundColor: "white",
				nodeWidth:dojo.isIE?"520px":'515px',
				nodeHeight:dojo.isIE?(dojo.isIE==6?"505px":"512px"):"516px",
				initLeftPosition: "700px",
				initTopPosition: "100px",
				modelDialog:!inDialog,
				needUnderLay: false,
				scrollEnabled: true
				// 8143/9205: if bidi, CustomDialog will not add the 'custom_dialog_nomodel'
				// class which interferes with the left/right movement of the dialog
				// 9637: removed rtl version of custom_dialog_nomodel so removed param isEmbedPageBidi
			});			
		}
		this.previewDlg.setTitle(title);
		
		if(inDialog)
			this.dialogContainer.registerSubDialog(this.embeddingPreviewDlg_ID);
		
		this.previewEmbedding(this.openPreviewAuto);
		this.updateMarkup();
		// bind event
		dojo.connect(document.getElementsByName("_"+this.widgetId + "_emdPgWidth")[0], "onclick", this, function(){
			dojo.byId("_"+this.widgetId + "_width").disabled = false;
		});
		dojo.connect(document.getElementsByName("_"+this.widgetId + "_emdPgWidth")[1], "onclick", this, function(){
			dojo.byId("_"+this.widgetId + "_width").disabled = true;
		});
		dojo.connect(dojo.byId("_"+this.widgetId +"_close"), "onclick", this, "hideEmbeddingDlg");
		dojo.connect(dojo.byId("_"+this.widgetId +"_preview"), "onclick", this, "previewEmbeddingAction");	
		dojo.connect(dojo.byId("_"+this.widgetId +"_updateLink"), "onclick", this, "updateMarkup");
		var embedEditButton = dojo.byId("_"+this.widgetId +"_embedEdit");
		if (enableEditSetting){
			dojo.connect(embedEditButton, "onclick", this, "loadEditMode");
		}else{
			embedEditButton.disabled = true;
			dojo.toggleClass(embedEditButton, "lotusFormButton", false);
			dojo.toggleClass(embedEditButton, "lotusFormButtonDisabled", true);
		}		
	},

	/**
	 * show the embedding widget dlg
	 */		
	updateEmbedding: function(){
		var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.widgetInstanceId);
		var getSMDeferred = widgetWrapper.getIWidgetDefinition();
		getSMDeferred.setFinishedCallback(dojo.hitch(this, this.createEmbedingContent));
		getSMDeferred.start(false);
	},
	
	destroyEmbeddedWidget: function(){
		com.ibm.mm.builder.utils.embedUtil.destroyEmbeddedWidget(this.widgetInstanceId);
	},
	
	/**
	 * hide the embedding widget dlg
	 */		
	hideEmbeddingDlg: function(){
		this.destroyEmbeddedWidget();
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.widgetId);
	},

	/**
	 * preview action when user click the Preview button in embedding widget UI
	 */	
	previewEmbeddingAction:function(){
		this.previewEmbedding(this.openPreviewForce);
	},

	/**
	 * show the preview dlg
	 * @param {String} previewType indicate whether the preview action is from user clicking the Preview button, or from auto preview
	 */	
	previewEmbedding: function(previewType){
		if (previewType == this.openPreviewAuto){
			if (!this.openEmbedWidgetPreview){
				// user have change the default open preview to false
				return;
			}
		}
		var validInput = com.ibm.mm.builder.utils.embedUtil.validateInput("_"+this.widgetId,this.embeddingDlg_ID);
		if(!validInput) return null;		
		if (this.previewDlg){
			this.previewDlg.dynaInitialized = false;
			this.previewDlg.show();	
			var root = this.previewDlg.containerNode;
			// create the preview UI
			root.innerHTML = "";
			root.appendChild(com.ibm.mm.builder.utils.embedUtil.createCheckPreview(this.widgetInstanceId,this.openEmbedWidgetPreview));
			root.appendChild(com.ibm.mm.builder.utils.embedUtil.createClearDiv());
			var iframeUID = com.ibm.mm.builder.utils.iwidgetUtil._getUid();
			var aframe = document.createElement("iframe");
			aframe.id = iframeUID;
			aframe.name = iframeUID;
			aframe.title = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PREVIEW_FRAME;
			
			var widthValue = com.ibm.mm.builder.utils.embedUtil.getWidth("_"+this.widgetId);
			if (widthValue == "auto"){
				aframe.style.width = "100%";
			} else {
				aframe.style.width = widthValue;
			} 
			// add the height of " Widget powered by IBM Lotus Mashups"
			aframe.style.height = parseInt(com.ibm.mm.builder.utils.embedUtil.getHeight("_"+this.widgetId)) + 25 + "px";
			aframe.scrolling = "no";
			aframe.frameBorder = 0;
			aframe.marginWidth = 0;
			aframe.frameSpacing = 0;
			aframe.marginHeight = 0;
			root.appendChild(aframe);	
			dojo.byId(this.widgetInstanceId +"_checkBox").setAttribute("accesskey", "A");
			dojo.byId(this.widgetInstanceId +"_closeLink").setAttribute("accesskey", "C");
			dojo.connect(dojo.byId(this.widgetInstanceId +"_checkBox"), "onclick", this, "reverseDefaultPreview");
			dojo.connect(dojo.byId(this.widgetInstanceId +"_closeLink"), "onclick", this, "hidePreview");			
			var iframeDoc = window.frames[iframeUID].document;
			iframeDoc.open();
			var url = this.generateURL();
			if (url){
				iframeDoc.write("<html><body><scr"+"ipt src=\"" + url + "\"></scr"+"ipt></body></html>");
			}	
			if (!dojo.isIE){
				iframeDoc.close();
			}
			this.updateMarkup();					
		}else{
			this.LOGGER.severe("previewEmbedding",com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_NOPREVIEWDLG_ERROR_0);
		}			
	},

	/**
	 * call enabler embedding generator to get the embeddable url
	 */
    generateURL:function() {
		var validInput = com.ibm.mm.builder.utils.embedUtil.validateInput("_"+this.widgetId,this.embeddingDlg_ID);
		if(!validInput) return null;
		try {
			var widgetXmlUrl = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetXMLURL(this.widgetInstanceId);
		}
		catch(e){
			return null;
		}
		
		// call iWidgetInstance from enabler to get all the itemset
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var iWidgetInstance = widgetModel.find(this.widgetInstanceId).getIWidgetInstance();

        if (iWidgetInstance == null) {
            this.LOGGER.severe(
            	"generateURL",
            	dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_NOWIDGET_ERROR_1,[this.widgetInstanceId])
            );
			return null;
        }
        var instanceAttributes = iWidgetInstance.getAttributes();			
		
		var width ="auto";
		if(dojo.query("[name=" + "_"+this.widgetId + "_emdPgWidth]")[0].checked){
			width = dojo.byId("_"+this.widgetId+"_width").value;
		}
		
		var height = dojo.byId("_"+this.widgetId+"_height").value;
		
		var haveScroll = false;
		if(dojo.query("[name=" + "_"+this.widgetId + "_emdPgScroll]")[0].checked){
			haveScroll = true;
		}

        var sandboxed = false;
        
        var widgetSpan = dojo.byId(this.widgetInstanceId);
        if (widgetSpan) {
            if (widgetSpan.getAttribute("sandbox") === "true")
                sandboxed = true;
        }

		return com.ibm.mm.builder.utils.embedUtil.generateURL(widgetXmlUrl,null,width,height,haveScroll,instanceAttributes,sandboxed);
    },

	/**
	 * action method when user click "Update Markup" in embedding UI.
	 * It will update the markup in the textarea 
	 */
	updateMarkup:function(){
		var url = this.generateURL();
		if (url){
			var markup = "<scr"+"ipt src=\"" + url + "\"></scr"+"ipt>";
			var textArea = dojo.byId("_"+this.widgetId+"_markup");
			var w = dojo.coords(textArea).w; 	
			textArea.style.width = w;	
			textArea.value = markup;	
			textArea.style.width = "98%";			
		}
	},

	/**
	 * load the widget edit mode dlg
	 */			
    loadEditMode: function(){
        var _title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetInstanceId);
        this.editPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
            id: this.widgetInstanceId + "_edit",
            title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_SYSTEM_CONF_TITLE, [_title]),
            type: "config",
            nodeWidth: dojo.byId(this.widgetInstanceId).getAttribute("sandbox") === "true" ? "600px" : null,
			nodeHeight: dojo.byId(this.widgetInstanceId).getAttribute("sandbox") === "true" ? "400px" : null,
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            needModeSwitch: true,
            belongId: this.widgetInstanceId,
            containerBackgroundColor: "white",
			closeCallback: function(){
				this.destroy(); 
			}
        });
        serviceManager.getService("eventService").fireEvent(this.widgetInstanceId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: this.editPane.containerNode
        });
        this.editPane.show();
    },
	
	/**
	 * destroy the edit mode dlg
	 */	
	destroyEditPane: function(){
		if(dijit.byId(this.widgetInstanceId + "_edit")){
			dijit.byId(this.widgetInstanceId + "_edit").destroy();	
		}
	},

	/**
	 * hide the preview dlg
	 */	
	hidePreview:function(){
		if (this.previewDlg){
			this.previewDlg.hide();
		}
	},

	/**
	 * action method when check the checkbox "show preview by default"
	 */	
	reverseDefaultPreview:function(){
		this.openEmbedWidgetPreview = !this.openEmbedWidgetPreview;
		dojo.cookie("open_embed_widget_preview",this.openEmbedWidgetPreview)
	},		

	_belong:function(value, arr){
		for (var i in arr) {
			if (arr[i] == value) {
				return true;
			}
		}
	}			
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.NewPageDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.NewPageDialog"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.NewPageDialog");







/**
 * This class will create a dialog for user to change widget instance title and icon
 */
dojo.declare("com.ibm.mm.builder.dialog.NewPageDialog", [dijit._Widget, dijit._Templated], {
	
	templateString: 
		'<div>'+
			'<div class="mmDialogTopArea">'+
				'<img src="/mum/images/widget.png" alt="">'+
				'<span dojoAttachPoint="renamePrompt" class="mmDialogTopAreaTitle"></span>'+
			'</div>'+
			'<div style="margin:20px 10px 30px 20px">'+
				'<div class="pageProperty_item">'+
					'<input dojoAttachPoint="pageName" type="text" class="pageProperty_item_content"></input>'+
				'</div>'+
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
		
	widgetsInTemplate: true,

	postCreate: function(){
		this.editorTitleDiv  = document.createElement("div");
		document.body.appendChild(this.editorTitleDiv);
		this.editorTitleDiv.appendChild(this.domNode);		
		this.renamePrompt.innerHTML = "Please input your page name:"
		//this.cancelBtn.innerHTML=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL;
		//this.saveBtn.value=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE;
		
		this.dialog = new com.ibm.mm.builder.widget.WidgetEditDialog({
			belongId: this.iwidgetId,
			containerBackgroundColor: "white",
			nodeWidth: "430px"
		},this.editorTitleDiv);
		
		this._pageUtil = com.ibm.mm.builder.utils.pageUtil;
	},
	
	child: false,
	
	/**
	 * show the page property dialog
	 */
	show: function(){
		this.dialog.show();
	},

	/**
	 * hide the page property dialog
	 */		
	hide: function(){
		this.dialog.hide();
	},
		
	save: function(){
		//invoke api to do this
		var name = this.pageName.value;
		if(!this._pageUtil.validatePageName(name))return;
		name = dojo.trim(name);
		if(this.child){
			this._pageUtil.createPage(name, this._pageUtil.getCurrentPageId());
		}else{
			this._pageUtil.createPage(name);
		}
		this.hide();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.PageSaveConfirmDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.PageSaveConfirmDialog"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");





dojo.declare("com.ibm.mm.builder.dialog.PageSaveConfirmDialog", [dijit._Widget, dijit._Templated], 
{
	frameDialog: null,
	
	callbackSave: null,
	
	callbackNotSave: null,
	
	callbackCancel: null,
	
	contentWarning: null,
	
	contentQuestion: null,
	
	btnSaveText: null,
	
	btnNotSaveText: null,
	
	btnCancelText: null,
	
	frameWidth: "540px",
	
	templateString:"<div>\n    <div class=\"mmConfirmDlgTop\">\n        <div class=\"mmConfirmDlgText1\" role=\"alert\">\n            <span dojoAttachPoint=\"warningMsg\">${contentWarning}</span>\n        </div>\n        <div class=\"mmConfirmDlgText2\" role=\"alert\">\n            <span dojoAttachPoint=\"suggestMsg\">${contentQuestion}</span>\n        </div>\n    </div>\n    <div class=\"mmConfirmDlgBottomArea lotusDialogFooter\" dojoAttachPoint = \"mmConfirmFooter\">\n        <input type=\"button\" dojoAttachPoint=\"saveBtn\" style=\"margin: 0\" class=\"lotusFormButton truncatedLabel\" \n\t\t\tdojoAttachEvent=\"onclick: _onSave,onkeypress:_onSaveWithKey\" \n\t\t\trole=\"button\" wairole=\"button\" aria-label=\"${btnSaveText}\" title=\"${btnSaveText}\" value=\"${btnSaveText}\"/>\n        <input type=\"button\" dojoAttachPoint=\"notSaveBtn\" class=\"lotusFormButton truncatedLabel\" \n\t\t\tdojoAttachEvent=\"onclick: _onNotSave,onkeypress:_onNotSaveWithKey\" \n\t\t\trole=\"button\" wairole=\"button\" aria-label=\"${btnNotSaveText}\" title=\"${btnNotSaveText}\" value=\"${btnNotSaveText}\"/>\n        <a href=\"javascript:void(0);\" dojoAttachPoint=\"cancelBtn\" aria-label=\"${btnCancelText}\" \n\t\t\tdojoAttachEvent=\"onclick: _onCancel,onkeypress:_onCancelWithKey\"\n\t\t\tclass=\"common_cancel lotusAction confirm_cancel truncatedLabel\" title=\"${btnCancelText}\">${btnCancelText}</a>\n    </div>\n</div>\n",
	
	postCreate: function(){
	
		var dialogParams = {
			id: "pageSaveConfirmDialog",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_PAGE_SAVE_TITLE,
			displayCloseButton: false,
			hasRightBottomResizer: false,
			leftBarWidth: "0px",
			rightBarWidth: "0px"
		};
		
		this.frameDialog = new com.ibm.mm.builder.widget.CleanDialog(dojo.mixin(dialogParams, {
			nodeWidth: this.frameWidth,
			displayCloseButton: false,
			closeCallback: function(){
				this.destroy();
			}
		}));
		this.frameDialog.containerNode.appendChild(this.domNode);
	},
	
	_onSaveWithKey: function(e){
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this._onSave(e);
		}
	},
	
	_onSave: function(){
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.savePage");
		
		this.frameDialog.hide();
		this.callbackSave && this.callbackSave();
	},
	
	_onNotSaveWithKey: function(e){
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this._onNotSave(e);
		}
	},
	
	_onNotSave: function(){
		this.frameDialog.hide();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
		this.callbackNotSave && this.callbackNotSave();
	},
	
	_onCancelWithKey: function(e){
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this._onCancel();
		}
	},
	
	_onCancel: function(){
		this.frameDialog.hide();
		this.callbackCancel && this.callbackCancel();
	},
	
	show: function(){
		this.frameDialog && this.frameDialog.show();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.ReorderingPageDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.ReorderingPageDialog"] = true;
dojo.provide("com.ibm.mm.builder.dialog.ReorderingPageDialog");












/**
 * This class will initialize the embed page widget UI element.
 */
dojo.declare("com.ibm.mm.builder.dialog.ReorderingPageDialog", [dijit._Widget, dijit._Templated], {
    /**
     * the ID for the page to be reordered.
     * @type String
     */
	pageId:null,
	spaceId:null,
	
    widgetId:null,
	
	store: null,
	navigationTree: null,
    targetPageId: null,
	_lastSelection: null,          // last selected dom node
	
	// Attach points
	messageBox: null,
	navTree: null,
	pageTitleLabel: null,
	form: null,
	
	widgetsInTemplate : true,
	
	templateString: null,
	
	/**
     * Constructor.
     */
    constructor: function(args){
		dojo.mixin(this,args);
        this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
		this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dialog.ReorderingPageDialog");
		
		this.templateString = (new dojox.string.Builder()).append('<div class="reorder-page-dialog">')
					    .append('<form dojoAttachPoint="form" onsubmit="return false;">')
					        .append('<div class="dialog-content">')
							    .append('<div class="lotusMessage" dojoAttachPoint="messageBox" style="display:none"></div>')
					            .append('<div class="page-position-buttons-area">')
								    .append('<fieldset>')
						                .append('<legend class="title" dojoAttachPoint="pageTitleLabel"></legend>')
						                .append('<ul class="buttons-list">')
						                    .append('<li>')
						                        .append('<input id="' + this.widgetId + "above" + '" type="radio" name="position" value="previous">')
	                                            .append('<label for="' + this.widgetId + "above" + '" class="page-position-buttons">')
						                            .append('${I_ABOVE_THE_SELECTED_PAGE}')
						                        .append('</label>')
						                    .append('</li>')
						                    .append('<li>')
						                        .append('<input id="' + this.widgetId + "below" + '" type="radio" name="position" value="next">')
	                                            .append('<label for="' + this.widgetId + "below" + '" class="page-position-buttons">')
						                            .append('${I_BELOW_THE_SELECTED_PAGE}')
						                        .append('</label>')
						                    .append('</li>')
						                    .append('<li>')
						                        .append('<input id="' + this.widgetId + "children" + '" type="radio" name="position" value="children" checked>')
	                                            .append('<label for="' + this.widgetId + "children" + '" class="page-position-buttons">')
						                            .append('${I_AS_CHILD_OF_SELECTED_PAGE}')
						                        .append('</label>')
						                    .append('</li>')
						                .append('</ul>')
									.append('</fieldset>')
					            .append('</div>')
					            .append('<div class="nav-tree">')
					                .append('<div dojoAttachPoint="navTree"></div>')
					            .append('</div>')
					        .append('</div>')
					        .append('<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" ')
					        	.append('dojoAttachEvent="onSave: save, onCancel: hide">') 
					            //.append('<a class="common_cancel" href="javascript:void(0)" dojoAttachEvent="onclick:hide">${I_COMMON_CANCEL}</a>')
					            //.append('<input type="submit" value="${I_COMMON_SAVE}" class="lotusFormButton" dojoAttachEvent="onclick:save">')
					        .append('</div>')
					    .append('</form>')
					.append('</div>').toString();
    },
	
	postMixInProperties: function() {
		this.bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.messages = com.ibm.mm.builder.coreWidgetsMessages;
        dojo.mixin(this, this.bundle);
    },
	
	setPageId: function(pageId, spaceId) {
		this.pageId = pageId;
		this.spaceId = spaceId || this.spaceUtil.getSpaceIdByPageId(pageId);
		dojo.fadeOut({node: this.messageBox}).play();
	},
	
	refresh: function() {
		this.showMessage(false);
		this.targetPageId = null;

		this.currentPageId = this.pageId;
		var currentPageName = this.pageUtil.getPageTitle(this.currentPageId);

		//this.currentPageId = this.pageUtil.getCurrentPageId();
		//var currentPageName = this.pageUtil.getCurrentPageTitle();
		
		this.pageTitleLabel.innerHTML = this.bundle.I_MOVE_THE_PAGE_TO_BE;
        
        if (this.navigationTree) {
            this.navigationTree.destroy();
        }
        
		var navModel = this.navigationUtil.getNavigationModel();
		this.store = new com.ibm.mm.builder.model.NavigationStore(navModel, this.spaceId);
		var model = new dijit.tree.TreeStoreModel({
            store : this.store,
            labelAttr : "title",
            typeAttr : "type",
            childrenAttr: ["children"]
		});
		
		this.navigationTree = new dijit.Tree({
            id: "navigation_tree_" + this.widgetId,
			model: model,
            persist : false,
			showRoot : true,
			getIconClass : function(/*dojo.data.Item*/ item, /*Boolean*/ opened) {
                return (!item || item === this.model.store.rootNode) ? "rootNode" : "pageNode";
            }
        }).placeAt(this.navTree);
		this.navigationTree.startup();
        this.connect(this.navigationTree, "onClick", "onTitleClick");
		
		// #13126
		this.connect(this.navigationTree, "_expandNode", "onExpandNode");
	},
	
	/**
	 * #13126
	 * Reset DijitTeeNode width in case the background position exceed the width when the node is being expanded.
	 */
    onExpandNode: function(node) {
        var pixels = (Math.max(node.indent + 5, 0) * 19) + "px";
        dojo.style(node.domNode, "width", pixels);
    },
	
	onTitleClick: function(item, node) {
		var domNode = node.contentNode;
		if (domNode !== this._lastSelection) {
			if (this._lastSelection)
			    dojo.removeClass(this._lastSelection, "selected");
            dojo.addClass(domNode, "selected");
            this._lastSelection = domNode;
		}
		
		var inputNode = dojo.query("input[name='position']", this.form);
        inputNode.forEach(function(input) {input.disabled = false;});
		if (item === this.pageUtil.getPageNode(this.currentPageId)) {
			// Current node is not allowed
			this.showMessage(this.messages.E_DIFFERENT_LOCATION_REQUIRED_0, "error");
			inputNode.forEach(function(input){
				input.disabled = true;
			});
		} else  if (this.navigationUtil.isDescendant(this.currentPageId, item.getID())) {
			// Descendant node is not allowed
			this.showMessage(this.messages.E_NEW_PAGE_POSITION_MISSING_0, "error");
			inputNode.forEach(function(input){
				input.disabled = true;
			});
		} else {
            if (item === this.store.rootNode) {
                // Only position children is allowed for rootNode
                this.showMessage(false);
                inputNode.forEach(function(input){
                    if (input.value !== "children") {
                        input.disabled = true;
                    } else {
                        input.disabled = false;
                        input.checked = true;
                    }
                });
            }
            // Check 3 positions if operations are allowed
            inputNode.forEach(function(input) {
                if (!input.disabled) {
                    var position = input.value;
                    var context = this.navigationUtil.getReorderPageContext(item.getID(), position);
                    var currentPage = this.pageUtil.getPageNode(this.currentPageId);
                    // @Stephan #11481 Start
                    //input.disabled = !this.navigationUtil.getNavigationModel().confirmInsert(null, context.parent, null);   // FIXME: comment out this line
                    input.disabled = !this.navigationUtil.getNavigationModel().confirmInsert(currentPage, context.parent, context.next);
                    // @Stephan #11481 End
                }
            }, this);
            if (dojo.every(inputNode, function(input) {
                    return input.disabled;
                })) {
                this.showMessage(this.messages.E_MOVE_PAGE_INSUFFICIENT_ACCESS_RIGHTS_0, "error");
            } else {
                this.showMessage(false);
            }
		}
        this.targetPageId = item.getID();
	},
	
	hide: function() {
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.widgetId);
		if (this.store) {
			this.store.reset();
		}
	},
	
	save: function() {
		var position = dojo.formToObject(this.form)['position'];
		var currentPageParentId = this.pageUtil.getParentPageId(this.currentPageId);
		var targetPageParentId = this.pageUtil.getParentPageId(this.targetPageId);
		
		if (this.targetPageId && position) {
			var context = this.navigationUtil.getReorderPageContext(this.targetPageId, position);
			// @Stephan #11481 Start
			// Enable if..else below
			if (this.navigationUtil.getNavigationModel().confirmInsert(context.page, context.parent, context.next)) {
				this.navigationUtil.reorderPageNode(this.currentPageId, this.targetPageId, position);
				//update space manager UI
				var constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
				dojo.publish(constants.Topic.Space.refresh,[constants.Action.MOVE_PAGE, {currentPageId:this.currentPageId, currentPageParentId:currentPageParentId, targetPageId:this.targetPageId, targetPageParentId:targetPageParentId, position:position}]);
				this.hide();
			} else {
				this.showMessage(this.messages.E_MOVE_PAGE_INSUFFICIENT_ACCESS_RIGHTS_0, "error");
			}
			// @Stephan #11481 End
		} else {
			this.showMessage(this.messages.E_NEW_PAGE_POSITION_MISSING_0, "error");
			this.LOGGER.severe("save", this.messages.E_NEW_PAGE_POSITION_MISSING_0);
		}
	},
	
	/**
	 * Display message in message box
     * @param {Object} message
	 * @param {Object} type Optional. Type of message, includes 'info', 'error', 'warning'
	 */
	showMessage: function(message, type) {
		if (!message) {
            dojo.fadeOut({node: this.messageBox}).play();
            dojo.style(this.messageBox, "display", "none");
			return false;
		}
		
		dojo.empty(this.messageBox);
		var img = dojo.create("img", {}, this.messageBox);
		var span = dojo.create("span", {
			"innerHTML": message
		}, this.messageBox);
		
		switch(type) {
			case "info":
                dojo.attr(img, {
					"alt": "Information",
					"src": builderConfig.builderPath + "/images/info_icon.png"
				});
                dojo.toggleClass(this.messageBox, "lotusWarning", false);
                dojo.toggleClass(this.messageBox, "lotusInfo", true);
				break;
			case "warning":
			    dojo.attr(img, {
					"alt": "Warning",
					"src": builderConfig.builderPath + "/images/warning_icon.png"
				});
                dojo.toggleClass(this.messageBox, "lotusWarning", true);
                dojo.toggleClass(this.messageBox, "lotusInfo", false);
                break;
            default:       // "error" as default
                dojo.attr(img, {
					"alt": "Error",
					"src": builderConfig.builderPath + "/images/error_icon.png"
				});
                dojo.toggleClass(this.messageBox, "lotusWarning", false);
                dojo.toggleClass(this.messageBox, "lotusInfo", false);
		}
		dojo.style(this.messageBox, "display", "block");
        dojo.fadeIn({node: this.messageBox}).play();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.eventTopics"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.eventTopics"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.eventTopics");

com.ibm.mm.builder.eventTopics = {
	
	/* Hidden Widgets Correl */
	Hidden_Widgets_Correl_Display: "/builder/hwc/display",
	/* Page  start */
	Page_ModeChanged: "/builder/changeMode",
	Page_ContentChanged: "pageChanged",
	Page_OnChanged: "onChangeMode",	
	Page_Save: "/builder/page/save",
	Update_Page_With_Default_Content: "/builder/page/update",
	
	// Page_OnSave will be published when current page is saved
	// the parameter is a boolean (true: save successfully, false: save failed)
	Page_OnSave: "/builder/pageSaved",	
	/* Page  end */
	
	//change mode
	Goto_Catalog: "/builder/goto/catalog",
	Open_Catalog: "/builder/open/catalog",
	Open_Catalog_New_Window : "/builder/open/catalog_new_window",
	
	/* Wiring start */
	WirePane_OverWidget: "wirePane/moveOverWidget",
	WirePane_OutWidget: "wirePane/moveOutWidget",
	/* Wiring end */
	
	/* Banner start */
	//Banner_TitleChanged: "/builder/titleChanged",  /*deprecated since we use iEvent wires*/
	Banner_BackgroundChanged:"/builder/backgroundChanged",
	Banner_BackgroundChangedBack:"/builder/backgroundChangedBack",
	/* Banner end */
	
	/* Widget start */
	Widget_ConfigurationFinished: "/widget/action/finished",	
	Widget_Hide: "/widget/action/hide",
	Widget_Create: "/widget/action/create",
	Widget_Column_AddOrDel: "/widget/column/addOrDel",
	/* Widget end */
	
	/* Resize start */
	Resize_StartSizing: "/startSizing",
	Resize_StartHeightSizing: "/startHeightSizing",
	Resize_ChangeSizing: "/changeSizing",
	Resize_ChangeHeightSizing: "/changeHeightSizing",
	Resize_EndSizing: "/endSizing",
	Resize_EndHeightSizing: "/endHeightSizing",
	/* Resize end */

	Save_Icon_Change: "/saveIconChange",
	
	/* Widget menu start */
	WidgetMenu_Hide: "/widgetMenu/action/hide",
	/* Widget menu end */	
	
	/* ACL Page Control start */
	UpdateViewPageControl: "/ACL/pageControl/view",
	UpdatePersonalizePageControl: "/ACL/pageControl/personalize",
	UpdateEditPageControl: "/ACL/pageControl/edit",
	UpdateSearchPageControl: "/ACL/pageControl/search",
	UpdateAllPageControl: "/ACL/pageControl/all",
	AclDialogHide:"/ACL/dialogHide",
	/* ACL Page Control end */
	
	/* Publish Page start*/
	Publish_Page_Show: "/publish/page/show",
	Publish_Page_Hide: "/publish/page/hide",
	
	FreeForm_Layout_Loaded:"/freeformlayout/loaded"
};

// for v1.1 widget compatibility
com.ibm.mm.builder.Topics = com.ibm.mm.builder.eventTopics;

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.ColumnSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.ColumnSource"] = true;
/**
 * ColumnSource is the dnd source of one column in column layout page
 *
 * @Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.ColumnSource");



dojo.declare("com.ibm.mm.builder.dnd.ColumnSource", com.ibm.mm.builder.dnd.IndicatorSource, {

	accept: ["iWidgetDefinition", "iWidgetInstance"],
	withHandles: true,
	layout: null,
	
	onDndCancel: function(){
		if( this === dojo.dnd.manager().source ){ com.ibm.mm.builder.utils.htmlUtil.showNodes(dojo.dnd.manager().nodes); }
		this.inherited(arguments);
	},
	
	onDndStart: function(source, nodes, copy){
		if(this === source){ com.ibm.mm.builder.utils.htmlUtil.hideNodes(nodes); }
		this.inherited(arguments);
	},
	
	onDndDrop: function(source, nodes, copy, target){
        this.inherited(arguments);
		if(this == target){
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		}
	},
	
	onDropExternal: function(source, nodes, copy){ //this means drag wigetdef from toolbox or widgetInstance from other colun layout
		try {
			var draggedNodeId = nodes[0].id;
			var item = source.getItem(draggedNodeId);
			var type = item && item.type && item.type[0];
			if(type === "iWidgetDefinition"){
				this.layout.createWidget(item.data,this.node.id);
			} else {
				this.layout.displayWidget(item.data, this.node.id);
			}
		} catch (e) {
			var logger = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dnd.ColumnSource");
			logger.severe("onDropExternal", e.message);
		}
	},
	
	onDropInternal: function(nodes, copy){ //this means reorder
		this.layout.displayWidget((nodes[0].id).replace(com.ibm.mm.builder.constant.skinIdPrefix, ""), this.node.id);
	},
	
	removeIndicator: function(){
		if (this.dropIndicator) {
			this.node.removeChild(this.dropIndicator.domNode);
			this.dropIndicator = null;
		}
	},
	
	createIndicator: function(e){
		this.inherited(arguments);
		var _target = e.target;
		if(!(_target.parentNode)){this.removeIndicator(); return;}				
		if(_target.className == "dropIndicator"){ return; }
		this.dropIndicator = this.dropIndicator || new com.ibm.mm.builder.dnd.ColumnSourceDNDIndicator();
		if (dojo.trim(_target.parentNode.id) == "_columnLayout_container") {
			this.referenceNode = null;
			this.node.appendChild(this.dropIndicator.domNode);
			return;
		}
		while(!(_target.getAttribute("dnddata"))){
			_target = _target.parentNode;
		}
		var p = dojo.coords(_target, true);
		//insert the indicator before the hoveredNode only when the mouse is on the top-right part of the hoveredNode
		
		this.before = this.layout.disableQuickWiring ? true : (e.clientY < (p.y + p.h*0.75) && (e.clientX > (p.x + p.w*0.2)));
		var referenceNode = this.before? _target:(this.getNextWidget(_target)); //_target.nextSibling;
		if (referenceNode) {
			this.node.insertBefore(this.dropIndicator.domNode, referenceNode);
		} else {
			this.node.appendChild(this.dropIndicator.domNode)
		}
	},
	
	getNextWidget:function(oDom){
		var next = oDom.nextSibling;
		if(next){
			return (next.className == "dropIndicator") ? next.nextSibling : next;
		}
	}
});



dojo.declare("com.ibm.mm.builder.dnd.ColumnSourceDNDIndicator", [dijit._Widget, dijit._Templated], {
	templateString: '<div dojoAttachPoint="dropIndicator" class="dropIndicator"><div class="dropIndicatorInner"></div></div>', 
	
	postCreate: function(){
		this.dropIndicator.style.height = dojo.coords(dojo.dnd.manager().avatar.node, true).h + "px";
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.columnUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.columnUtil"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.columnlayout.columnUtil");







com.ibm.mm.builder.iwidget.columnlayout.columnUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.columnlayout.columnUtil");

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosX = 0;
com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosY = dojo.isIE < 8 ? -4 : 20;

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.getColNumberFromLayoutData = function(layoutdata) {
	var colPos = layoutdata.indexOf("column:");
	var valueStr = layoutdata.substr(colPos+7,layoutdata.length);
	var colValue = valueStr.substr(0,valueStr.indexOf(";"));
	return colValue;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.moveWidget = function(widgetId,targetColumn,targetRow,columnWidgetId){
    // widget span should have the attribute layoutdata, sample value: "layout:columnlayout;column:2;row:2;"
	var widgetSpan = dojo.byId(widgetId);
	var curWidgetLayoutData = widgetSpan.getAttribute("layoutdata");
	if (!curWidgetLayoutData) return;
	
	var targetCol = dojo.byId("_" + columnWidgetId + "_Column"+targetColumn);
	var targetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,targetCol);
	var len = targetColWidgets.length;
	
	var movingNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	if (curWidgetLayoutData.indexOf("column:"+targetColumn)== -1){// target column is a different column
	
		//update the previous column widget layout data	
		var oldColumn = curWidgetLayoutData.substr(curWidgetLayoutData.indexOf("column:") + 7, 1);
		var oldRow = curWidgetLayoutData.substr(curWidgetLayoutData.indexOf("row:") + 4, 1);
		var oldTargetCol = dojo.byId("_" + columnWidgetId + "_Column"+oldColumn);
		var oldTargetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,oldTargetCol);
		var oldLen = oldTargetColWidgets.length;
		if(oldLen == 1 || oldRow == oldLen){
		   
		}else{
			for (var i=oldRow;i<oldLen;i++){
				var layoutAttr = oldTargetColWidgets[i].getAttribute("layoutdata");
				if (layoutAttr){
					var rowNum = layoutAttr.substr(layoutAttr.indexOf("row:") + 4,1);
					oldTargetColWidgets[i].setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(layoutAttr,rowNum - 1));					
				}
			}
		}
		
		// insert the iwidget instance
		if((len == 0) || (len +1 == targetRow)){
			targetCol.appendChild(movingNode);
		}else{
			var beforeNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + targetColWidgets[targetRow - 1].id);
			targetCol.insertBefore(movingNode,beforeNode);
		}
		// update the previous widget layout data
		for (var i=targetRow;i<=len;i++){
			var layoutAttr = targetColWidgets[i-1].getAttribute("layoutdata");
			if (layoutAttr) {
				targetColWidgets[i-1].setAttribute("layoutdata", com.ibm.mm.builder.iwidget.columnlayout.columnUtil._increaseRow(layoutAttr));
			}
		}

		widgetSpan.setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getLayoutData(targetColumn,targetRow));
	}else{// target column is the same column
		// if the row is the same, do nothing
		if (curWidgetLayoutData.indexOf("row:"+targetRow) == -1){
			// update the upper widgets row number
			var count = 1;
			for (var i=0;i<len;i++){
				if (targetColWidgets[i].id != widgetId) {
					var layoutAttr = targetColWidgets[i].getAttribute("layoutdata");
					if (layoutAttr) {
						targetColWidgets[i].setAttribute("layoutdata", com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(layoutAttr, count));
						count = count + 1;
					}
				}
			}
			if((len == 0) || (len == targetRow)){
				targetCol.appendChild(movingNode);
			}else{
				var beforeNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + targetColWidgets[targetRow - 1].id);
				targetCol.insertBefore(movingNode,beforeNode);
				// update the below widgets row number
				for (var i=targetRow;i<=len-1;i++){
					var layoutAttr = targetColWidgets[i-1].getAttribute("layoutdata");
					if (layoutAttr) {
						targetColWidgets[i - 1].setAttribute("layoutdata", com.ibm.mm.builder.iwidget.columnlayout.columnUtil._increaseRow(layoutAttr));
					}
				}				
			}
			widgetSpan.setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(curWidgetLayoutData,targetRow));
		}
	} 
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._increaseRow = function(layoutdata){
	var rowPos = layoutdata.indexOf("row:");
	var prefix = layoutdata.substr(0,rowPos);
	var suffix = layoutdata.substr(rowPos+4,layoutdata.length);
	var oldRowValue = parseInt(suffix);
	var newRow = oldRowValue + 1;
	return prefix + "row:" + newRow + ";";
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._decreaseRow = function(layoutdata){
	var rowPos = layoutdata.indexOf("row:");
	var prefix = layoutdata.substr(0,rowPos);
	var suffix = layoutdata.substr(rowPos+4,layoutdata.length);
	var oldRowValue = parseInt(suffix);
	var newRow = oldRowValue - 1;
	return prefix + "row:" + newRow + ";";
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow = function(layoutdata,row){
	var rowPos = layoutdata.indexOf("row:");
	var prefix;
	if(rowPos != -1){
	    prefix = layoutdata.substr(0,rowPos);
	}else{
		prefix = layoutdata + ";";
	}
	return prefix + "row:" + row + ";";
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getRow = function(layoutdata){
	var rowPos = layoutdata.indexOf("row:");
	if (rowPos != -1) {
		return parseInt(layoutdata.substr(rowPos + 4,layoutdata.length));
	}
	return -1;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getLayoutData = function(targetColumn,targetRow){
	return "layout:columnlayout;column:"+targetColumn+";row:"+targetRow+";";
}

// to refresh other widget layout data since current widget is to be removed, specifically for column layout
com.ibm.mm.builder.iwidget.columnlayout.columnUtil.refreshLayoutData = function(widgetId){
	var widgetSpan = dojo.byId(widgetId);
	var curWidgetLayoutData = widgetSpan.getAttribute("layoutdata");
	if (!curWidgetLayoutData) return;
	var col = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.getColNumberFromLayoutData(curWidgetLayoutData);
	var layoutId = null;
	var layouts = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().getLayouts();
	for(var i = 0; i < layouts.length; i++) {
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,layouts[i])){
			layoutId =  layouts[i];
		}
    }
	if (layoutId){
		var colDiv = dojo.byId("_"+ layoutId + "_Column" + col);
		if (colDiv){
			var existingWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,colDiv);
			var row = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getRow(curWidgetLayoutData);
			if (row > 0){
				for (var i=0;i<existingWidgets.length;i++){
					if (existingWidgets[i].id != widgetId){
						var existingWidgetLayoutdata = dojo.byId(existingWidgets[i].id).getAttribute("layoutdata");
						if (existingWidgetLayoutdata){
							if (com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getRow(existingWidgetLayoutdata) > row){
								var newLayoutData = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._decreaseRow(existingWidgetLayoutdata);
								dojo.byId(existingWidgets[i].id).setAttribute("layoutdata",newLayoutData);
							}
						}

					}
				}
			}
		}
	}
}

/**
 * this method is called to change the view or edit mode of column width resizer
 * @param {String} mode "view" or "edit"
 */
com.ibm.mm.builder.iwidget.columnlayout.columnUtil._changeColumnResizerStatus = function(mode){
    var resizers = dijit.registry.byClass(com.ibm.mm.builder.widget.ColumnWidthResizer);
    var resizer_len = resizers.length;
    for (var x = 0; x < resizer_len; x++) {
        var oneResizer = resizers[x];
        if (mode == "view") {
            oneResizer.toViewMode();
        }
        else {
            oneResizer.toEditMode();
        }
    }
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.createSkinConfigUI = function(skinDivId, wid){
    var skinConfig = dojo.byId(skinDivId);
    com.ibm.mm.builder.utils.layoutUtil.removeAllChildren(skinConfig);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
    if (skins.length > 0) {
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil.skinObjects = new Array();
		dojo.forEach(skins, function(skin){
            var skinTitle = skin.getTitle(dojo.locale);
            if (ibmConfig["default.locale"] != dojo.locale && (null == skinTitle || "" == skinTitle)) {
                skinTitle = skin.getTitle(ibmConfig["default.locale"]);
            }
            if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
                com.ibm.mm.builder.iwidget.columnlayout.columnUtil.skinObjects.push(skin);
                var fathDiv = document.createElement("div");
                skinConfig.appendChild(fathDiv);
                dojo.addClass(fathDiv, "skinPreviewDiv");
                var funcName = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin(\"" + skin.getID() + "\",\"" + wid + "\")";
                var funcNameWithKey = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkinWithKey(event,\"" + skin.getID() + "\",\"" + wid + "\")";
                var inner = "<DIV align='center' id='" + wid + "_" + skin.getID();
                inner = inner + "' style='margin-top:4px;' onclick='";
                inner = inner + "eval(" + funcName + ");' onkeypress='";
                inner = inner + "eval(" + funcNameWithKey + ");'>";
                inner = inner + "<IMG tabindex='0' src='" + skin.getPreviewUrl() + "' title='" + skinTitle + "' alt='" + skinTitle + "' /></DIV>";
                fathDiv.innerHTML = inner;
            }
	    });
    } else {
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil.LOGGER.severe("createSkinConfigUI",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CHOOSE_SKIN_0);
    }
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkinWithKey = function(event, skinvalue, wid){
    var keyCode = event.keyCode;
    if (keyCode != dojo.keys.ENTER) 
        return true;
    com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin(skinvalue, wid);
}

/**
 * chooseSkin is called when click the different skin type in configuration pane
 * @param {Object} skinvalue
 */
com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin = function(skinvalue, wid){
    com.ibm.mm.builder.columnLayoutBean.setSelectedSkin(skinvalue);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
    if (skins.length > 0) {
		dojo.forEach(skins, function(skin){
	        if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
	            var skinUIDiv = dojo.byId(wid + "_" + skin.getID());
	            if (skinvalue == skin.getID()) {
	                skinUIDiv.parentNode.style.border = "1px solid";
	                skinUIDiv.parentNode.style.borderColor = "#739DD7";
	                skinUIDiv.parentNode.style.backgroundColor = "#BED2EE";
	            } else {
	                skinUIDiv.parentNode.style.border = "1px dotted";
	                skinUIDiv.parentNode.style.borderColor = "#F3F3F3";
	                skinUIDiv.parentNode.style.backgroundColor = "";
	            }
	        }
	    });
    } else {
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil.LOGGER.severe("chooseSkin",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CHOOSE_SKIN_0);
    }
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._toShowColorPicker = function(iwid, wid, adjustX, adjustY, indicatorId, colorDivId){
    var indicatorX = dojo._abs(dojo.byId(iwid + indicatorId)).x;
    var indicatorY = dojo._abs(dojo.byId(iwid + indicatorId)).y;
    var relativeX = indicatorX - dojo._abs(dojo.byId(wid + "_edit")).x + parseInt(adjustX);
    var relativeY = indicatorY - dojo._abs(dojo.byId(wid + "_edit")).y + parseInt(adjustY);
    com.ibm.mm.builder.iwidget.columnlayout.columnUtil._showColorPalette(iwid, iwid + indicatorId, iwid + colorDivId, relativeX, relativeY);
}

/**
 * this method will show the color palette, by default the palete is "7x10"
 * @param {string} indicatorId: indicatorId is the indicator dom node id, which will display the user selected color
 * @param {string} inputId: inputId is the input dom id, which will hold the color value and save it back to server
 */
com.ibm.mm.builder.iwidget.columnlayout.columnUtil._showColorPalette = function(wid, indicatorId, inputId, posX, posY){
    var father = dojo.byId(wid + "ColorPaletteContainer");
    var indicator = dojo.byId(indicatorId);
    var colorPaletteX = posX;
    var colorPaletteY = posY;
    if (this.colorPicker != null) {
        this.colorPicker.destroy();
        var colorPalette = document.createElement("div");
        colorPalette.id = wid + "ColorPalette";
        father.appendChild(colorPalette);
    }
    var palette = "8x16";
    this.colorPicker = new com.ibm.mm.builder.widget.MumColorPalette({
        palette: palette,
        indicator: indicatorId,
        inputId: inputId
    }, dojo.byId(wid + "ColorPalette"));
    var rtlColorPaletteAdjust = 0;
	if(builderConfig.isBidi){
	    var str = this.colorPicker._paletteDims[palette].width;
	    str=str.replace(/px/,"");
	    rtlColorPaletteAdjust = new Number(str)-19;//18 is size of preview color div box width + a pixel more for looks
	    //prevent dialog container from adding vertical scrollbar
	    var dialog = father.parentNode;
	    dialog = dialog.parentNode;
	    dialog.style.overflow="visible";	    
	}   
	father.style.left = colorPaletteX-rtlColorPaletteAdjust + "px";
    father.style.top = colorPaletteY + "px";
    father.style.zIndex = 888;
    father.style.display = "";
    this.colorPicker.focus();
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnSetting = function(icontext, columnNum, columnAttrJSONObj){
    var wid = "_" + icontext.widgetId + "_";
    dojo.byId(wid + "eachColCheckBox").innerHTML = "";
    dojo.byId(wid + "eachColumnBgColor").innerHTML = "";
    dojo.byId(wid + "eachColumnBgColorIndicator").innerHTML = "";
    dojo.byId(wid + "eachColumnBorderStyle").innerHTML = "";
    dojo.byId(wid + "eachColumnBorderColor").innerHTML = "";
    dojo.byId(wid + "eachColumnBorderColorIndicator").innerHTML = "";
    
    var eachCheckBoxStr = "";
    var eachColumnBgColorStr = "";
    var eachColumnBorderStyleStr = "";
    var checked, colorValue, bgcolor, borderColor, border;
    var indicatorDiv;
    for (var i = 1; i <= columnNum; i++) {
		var ii = i;
		if (builderConfig.isBidi) {
			ii = columnNum-i+1;
		}    	
        if (columnAttrJSONObj[ii].enabled == "1") {
            checked = "checked";
        }
        else {
            checked = "";
        }
        colorValue = columnAttrJSONObj[ii].bgcolor;
        borderColor = columnAttrJSONObj[ii].bordercolor;
        border = columnAttrJSONObj[ii].border;
        var inputTitle = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_COLOR;
        eachColumnBgColorStr = eachColumnBgColorStr +
        "<input type='hidden' id='" +
        wid +
        "eachColumnBgColor" +
        i +
        "' name='columnBgColor' value='" +
        colorValue +
        "'>";
        eachColumnBorderStyleStr = eachColumnBorderStyleStr +
        "<input type='hidden' id='" +
        wid +
        "eachColumnBorderColor" +
        i +
        "' name='columnBorderColor' value='" +
        borderColor +
        "'>";
        if (i > 1) {
            eachCheckBoxStr = eachCheckBoxStr +
            "<input id='" +
            wid +
            "eachColumnBgColorIndicator" +
            i +
            "_checkBox' type='checkbox'" +
            checked +
            " title=" +
            inputTitle +
            " style='display:none;'>";
            dojo.byId(wid + "eachColumnBgColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnColorIndicator(icontext.widgetId, "eachColumnBgColorIndicator" + i, "eachColumnBgColor" + i, colorValue, "none"));
            dojo.byId(wid + "eachColumnBorderStyle").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderStyleSelection(icontext.widgetId, "columnBorderSelection" + i, border, "none"));
            dojo.byId(wid + "eachColumnBorderColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createColumnBorderColorIndicator(icontext.widgetId, "columnBorderColorIndicator" + i, "eachColumnBorderColor" + i, borderColor, "none"));
        }
        else {
            eachCheckBoxStr = eachCheckBoxStr +
            "<input id='" +
            wid +
            "eachColumnBgColorIndicator" +
            i +
            "_checkBox' type='checkbox' " +
            checked +
            " title='" +
            inputTitle +
            "'>";
            
            dojo.byId(wid + "eachColumnBgColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnColorIndicator(icontext.widgetId, "eachColumnBgColorIndicator" + i, "eachColumnBgColor" + i, colorValue, ""));
            dojo.byId(wid + "eachColumnBorderStyle").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderStyleSelection(icontext.widgetId, "columnBorderSelection" + i, border, ""));
            dojo.byId(wid + "eachColumnBorderColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createColumnBorderColorIndicator(icontext.widgetId, "columnBorderColorIndicator" + i, "eachColumnBorderColor" + i, borderColor, ""));
        }
        var eachColumnBorderColorIndicatorNode = dojo.byId(wid + "columnBorderColorIndicator" + i);
        var eachColumnBgColorIndicatorNode = dojo.byId(wid + "eachColumnBgColorIndicator" + i);
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(eachColumnBorderColorIndicatorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_COLUMN_BORDER_COLOR);
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(eachColumnBgColorIndicatorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_COLOR);
    }
    dojo.byId(wid + "eachColCheckBox").innerHTML = eachCheckBoxStr;
    dojo.byId(wid + "eachColumnBgColor").innerHTML = eachColumnBgColorStr;
    dojo.byId(wid + "eachColumnBorderColor").innerHTML = eachColumnBorderStyleStr;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderStyleSelection = function(widgetId, id, border, display){
    var select = document.createElement("select");
    dojo.attr(select, "title", com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_COLUMN_PROP_BORDER);
    var iwid = "_" + widgetId + "_";
    select.id = iwid + id;
    select.className = "eidtGridSelectorStyle";
    select.style.display = display;
    select.style.width = "110px";
    if (dojo.isIE) {
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("none"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px solid"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px solid"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px solid"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px dotted"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px dotted"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px dotted"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px double"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("6px double"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("9px double"));
    }
    else {
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("none"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px solid"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px solid"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px solid"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px dotted"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px dotted"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px dotted"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px double"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("6px double"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("9px double"), null);
    }
    select.options[com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex(border)].selected = true;
    var index = 0;
    select.options[index++].innerHTML = com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_NONE;
    var widths = [1, 2, 3];
    var styles = [com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_SOLID, com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOTTED, com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOUBLE];
    for (var i = 0; i < styles.length; i++) {
        for (var j = 0; j < widths.length; j++) {
            select.options[index++].innerHTML = widths[j] + "px " + styles[i];
        }
    }
    return select;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption = function(val){
    var option = document.createElement("option");
    option.value = val;
    return option;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnColorIndicator = function(widgetId, id, colorDivId, bgcolor, display){
    var div = document.createElement("div");
    var iwid = "_" + widgetId + "_";
    div.id = iwid + id;
    var funName = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil._toShowColorPicker('" + iwid + "','";
    funName = funName + widgetId + "','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosX+"','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosY+"','";
    funName = funName + id + "','" + colorDivId + "')";
	dojo.connect(div,"onclick",null,function(){eval(funName)});
	dojo.connect(div,"onkeypress",null,function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) 
            return true;
        eval(funName)
    });
    div.className = "columnbgcolorpickerbox";
    div.style.backgroundColor = bgcolor;
    div.style.display = display;
    dojo.attr(div, "tabindex", "0");
    return div;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode = function(node,prefixTitle){
    var color = dojo.style(node, "backgroundColor");
    var titleSubstuite = com.ibm.mm.builder.coreWidgetsStrings["I_COLUMN_CONF_COLOUR"];
    var title;
    if (color.indexOf("rgb") != -1) {
        var rgb = color.substring(4, color.length - 1);
        var rgbArray = rgb.split(",");
        title = dojo.string.substitute(titleSubstuite, [rgbArray[0], rgbArray[1], rgbArray[2]]);
    }
    else {
        var inHexStr = color.substring(color.length - 6);
        var red = parseInt("0x" + inHexStr.substr(0, 2), 16);
        var green = parseInt("0x" + inHexStr.substr(2, 2), 16);
        var blue = parseInt("0x" + inHexStr.substr(4, 2), 16);
        title = dojo.string.substitute(titleSubstuite, [red, green, blue]);
    }
    
    if (prefixTitle.indexOf(":") == -1) {
		dojo.attr(node, "title", prefixTitle + ":" + title);
	}
	else{
		dojo.attr(node, "title", prefixTitle + title);
	}
}



com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createColumnBorderColorIndicator = function(widgetId, id, colorDivId, bgcolor, display){
    var div = document.createElement("div");
    var iwid = "_" + widgetId + "_";
    div.id = iwid + id;
    var funName = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil._toShowColorPicker('" + iwid + "','";
    funName = funName + widgetId + "','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosX+"','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosY+"','";
    funName = funName + id + "','" + colorDivId + "')";
    
	dojo.connect(div,"onclick",null,function(){
        var selectedColumn = dojo.byId(iwid + "columnConfigTargetSelection").value;
		if(dojo.byId(iwid + "columnBorderSelection" + selectedColumn).selectedIndex == 0)
			return;
			
		eval(funName)
    });
	dojo.connect(div,"onkeypress",null,function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) 
            return true;
        eval(funName)
    });
    div.className = "columnbordercolorpickerbox";
    div.style.backgroundColor = bgcolor;
    div.style.display = display;
    dojo.attr(div, "tabindex", "0");
    return div;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._isDefaultSetting = function(singleColSetting){
    var defaultsetting = com.ibm.mm.builder.columnLayoutBean.getSingleColumnDefaultSetting();
    if (singleColSetting) {
        if ((defaultsetting.bgcolor == singleColSetting.bgcolor) &&
        (defaultsetting.border == singleColSetting.border) &&
        (defaultsetting.bordercolor == singleColSetting.bordercolor) &&
        (defaultsetting.enabled == singleColSetting.enabled)) {
            return true;
        }
    }
    return false;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.validatePageMetaData = function(metadata){
    if (metadata.columnattributes && metadata.columns && metadata.pageattributes && metadata["skin"]) {
        var columnAttrObj = dojo.fromJson(metadata.columnattributes);
        var columnsObj = metadata.columns;
        var pageAttrObj = dojo.fromJson(metadata.pageattributes);
        var skin = metadata["skin"];
        
        if (!pageAttrObj["applyDefaultSkinToAll"]) {
            var newObj = new Object();
            newObj["skin"] = skin;
            newObj["columns"] = columnsObj;
            
            var newPageAttrObj = new Object();
            newPageAttrObj = pageAttrObj;
            newPageAttrObj["applyDefaultSkinToAll"] = com.ibm.mm.builder.columnLayoutBean.getPageAttrSetting().applyDefaultSkinToAll;
            newObj["pageattributes"] = dojo.toJson(newPageAttrObj);
            
            var allColumn = columnAttrObj["all"];
            if (!allColumn["enabled"]) {
                var newColumnAttrObj = new Object();
                newColumnAttrObj["all"] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(allColumn);
                if (columnAttrObj["one"]) {
                    newColumnAttrObj["1"] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj["one"]);
                }
                if (columnAttrObj["two"]) {
                    newColumnAttrObj["2"] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj["two"]);
                }
                if (columnAttrObj["three"]) {
                    newColumnAttrObj["3"] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj["three"]);
                }
                if (columnAttrObj["four"]) {
                    newColumnAttrObj["4"] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj["four"]);
                }
                newObj["columnattributes"] = dojo.toJson(newColumnAttrObj);
            }
            return newObj;
        }
        else {
            return metadata;
        }
    }
	else {
		var defaultItemSet = new com.ibm.mm.builder.iwidget.columnlayout.defaultSettings();
		return dojo.mixin(metadata, {
			skin: defaultItemSet.getSelectedSkin(),
			columns: dojo.toJson(defaultItemSet.getColumnSetting()),
			columnattributes: dojo.toJson(defaultItemSet.getColumnAttrSetting()),
			pageattributes: dojo.toJson(dojo.mixin(defaultItemSet.getPageAttrSetting(), dojo.fromJson(metadata.pageattributes)))
		});
	}
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert = function(oldFormat){
    var obj = new Object();
    obj.bgcolor = oldFormat.bgcolor;
    obj.border = oldFormat.border;
    obj.bordercolor = oldFormat.bordercolor;
    obj.enabled = "0";
    return obj;
}

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.createColumnSource = function(domNode, layout){
	return new com.ibm.mm.builder.dnd.ColumnSource(domNode,{
		layout: layout,
		creator: function(item, hint){
			if (hint === "avatar") {
				//create avatar
				var n = dojo.doc.createElement("div");
				n.id = dojo.dnd.getUniqueId();
				n.setAttribute("widgetId", item);
				n.className = "dojoDndItem";
				var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + item);
				var node = widgetSkinNode.cloneNode(true);
				dojo.removeAttr(node, "id");	//to avoid duplicate node id
				com.ibm.mm.builder.utils.htmlUtil.removeIframe(node);
				node.style.width = domNode.style.width;
				node.style.position = "relative";
				node.style.top = "20px";
				node.style.left = "0";
				n.appendChild(node);
				return { node: n, data: item, type: ["iWidgetInstance"] };
			}
		}
	});
}

}

if(!dojo._hasResource["com.ibm.mashups.builder.personalize"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.personalize"] = true;
dojo.provide("com.ibm.mashups.builder.personalize");

dojo.declare( "com.ibm.mashups.builder.personalize", null, {

    constructor:function () {
    },
    
    /**
     * set current widget's size into navigation state.
     * @param {String} widgetId widget's Id never <code>null</code>
     * @param {Object} size widget's size object, never <code>null</code>
     * @type void
     */
	setPersonalizeSize:function(widgetId, size) {},
	
	 /**
     * Returns  the widget's size in navigation state for the current user.
     * @param {String} widgetId widget's Id never <code>null</code>
     * @type Object 
     * @return size object, never <code>null</code>.
     */
	getPersonalizeSize:function(widgetId) {},
	
    /**
     * set current widget's state into navigation state.
     * @param {String} widgetId widget's Id never <code>null</code>
     * @param {String} state widget's state, never <code>null</code>
     * @type void
     */
	setPersonalizeWidgetState:function(widgetId, state) {},
	
	 /**
     * Returns  the widget's state in navigation state for the current user.
     * @param {String} widgetId widget's Id never <code>null</code>
     * @type Object 
     * @return state, never <code>null</code>.
     */
	getPersonalizeWidgetState:function(widgetId) {},
	
	 /**
     * Returns the boolean value if the widget is in layout widget or not.
     * @param {String} widgetId widget's Id, never <code>null</code>
     * @param {String} layoutWidgetId layout widget's Id, never <code>null</code>
     * @type boolean 
     * @return {boolean} true/false, never <code>null</code>.
     */
	isWidgetInLayout:function(widgetId, layoutWidgetId) {},
	
	 /**
     * Returns the node of the widget skin.
     * @param {String} widgetId widget's Id, never <code>null</code>
     * @type Object 
     * @return {Object} The widget Skin HTML DOM node.
     */
	getWidgetSkinNode: function(widgetId){
    },
    
	/**
     * Returns the node of the widget content.
     * @param {String} widgetId widget's Id, never <code>null</code>
     * @type Object 
     * @return {Object} The widget Skin HTML DOM content.
     */
    getWidgetContentNode: function(widgetId){
    },
    
	/**
     * Set the widget's skin node size.
     * @param {String} widgetId widget's Id, never <code>null</code>
     * @param {Object} size new widget skin size, never <code>null</code>
     * @type void
     */
    resetWidgetSkin: function(widgetId, size){
    },
    
	/**
     * Publish the resize event to enabler for resizing the content by widget itself.
     * @param {String} widgetId widget's Id, never <code>null</code>
     * @type void
     */
    publicResizeEvent: function(widgetId){
    },
    
	/**
     * Set the widget's content node size.
     * @param {String} widgetId widget's Id, never <code>null</code>
     * @param {Object} size new widget content size, never <code>null</code>
     * @type void
     */
    resetWidgetContent: function(widgetId, size){
    }
});

}

if(!dojo._hasResource["com.ibm.mm.builder.personalize"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.personalize"] = true;
/**
 * @author Michael Duan (duanyg@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.personalize");



dojo.declare("com.ibm.mm.builder.personalizeImpl", com.ibm.mashups.builder.personalize, {
    constructor: function(){
    },
    
    getWidgetAccessor: function(widgetId){
        return com.ibm.mashups.enabler.model.state.AccessorFactory.getWidgetAccessor(
			com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel(), widgetId);
    },
    
    setPersonalizeSize: function(widgetId, size){
        this.getWidgetAccessor(widgetId).setSize(size.w, size.h);
        var location = new Object();
        location.x = parseInt(size.l);
        location.y = parseInt(size.t);
        this.getWidgetAccessor(widgetId).setWidgetState("l", location);
        
        this.commit();
    },
    
    getPersonalizeSize: function(widgetId){
		var widgetSize = this.getWidgetAccessor(widgetId).getSize();
        var location = this.getWidgetAccessor(widgetId).getWidgetState("l");
        
        if (widgetSize == null) 
            return null;
        
        var size = new Object();
        size.w = widgetSize.w;
        size.h = widgetSize.h;
        if (location == null) {
            size.l = 0;
            size.t = 0;
        }
        else {
            size.l = location.x;
            size.t = location.y;
        }
        
        return size;
    },
    
    setPersonalizeWidgetState: function(widgetId, state){
        this.getWidgetAccessor(widgetId).setWindowState(state);
        
        this.commit();
    },
    
    getPersonalizeWidgetState: function(widgetId){
        return this.getWidgetAccessor(widgetId).getWindowState();
    },
    
    commit: function(){
        com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel().commit().start();
    },
    
    isWidgetInLayout: function(widgetId, layoutWidgetId){
        return com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId, layoutWidgetId);
    },
    
    getWidgetSkinNode: function(widgetId){
        return dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
    },
    
    _getWidgetBodyPadTop: function(widgetId){
        var widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(widgetId +
        com.ibm.mm.builder.constant.widgetBody), "paddingTop");
        widgetBodyPadTop = widgetBodyPadTop ? parseInt(widgetBodyPadTop) : 0;
        return widgetBodyPadTop;
    },
    
    getWidgetContentNode: function(widgetId){
        return dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetContent);
    },
    
    resetWidgetSkin: function(widgetId, size){
        // resize the skin of widget.	  
        dojo.contentBox(this.getWidgetSkinNode(widgetId), {
            l: parseInt(size.l),
            t: parseInt(size.t),
            w: parseInt(size.w),
            h: parseInt(size.h)
        });
    },
    
    publicResizeEvent: function(widgetId){
        // publish the resize event to enabler
        var widgetContentBox = dojo.contentBox(this.getWidgetContentNode(widgetId));
        var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        var payload = {
            "newWidth": widgetContentBox.w,
            "newHeight": widgetContentBox.h
        };
        eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + widgetId, payload);
    },
    
    resetWidgetContent: function(widgetId, size){
        // resize the content of widget
        var widgetContentNode = this.getWidgetContentNode(widgetId);
        var widgetBodyPadTop = this._getWidgetBodyPadTop(widgetId);
        dojo.marginBox(widgetContentNode, {
            l: 0,
            t: 0,
            w: parseInt(size.w),
            h: parseInt(size.h) - widgetBodyPadTop
        });
    }
});

com.ibm.mashups.builder.Personalize = new com.ibm.mm.builder.personalizeImpl();

}

if(!dojo._hasResource["com.ibm.mm.builder.widgetLoader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widgetLoader"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */	
dojo.provide("com.ibm.mm.builder.widgetLoader");






dojo.declare("com.ibm.mm.builder.widgetLoader",null,{

	// summary: widgetLoader is a utility class, it is used to load widgets from string format. 
	// The string format of widgets are load from a persisted file. 
	
	namespaces: {
		"thr":"http://purl.org/syndication/thread/1.0",
		"atom":"http://www.w3.org/2005/Atom",
		"xhtml":"http://www.w3.org/1999/xhtml",
		"xsi":"http://www.w3.org/2001/XMLSchema-instance",
		"portal":"http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model",
		"model":"http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements",
		"base":"http://www.ibm.com/xmlns/prod/websphere/portal/v6.0/ibm-portal-composite-base"
	},
	
	/**
	 * load widgets inside a container node.
	 * @param {DomNode} node: a container node
	 * @param {String} data: all the widget microformats string value
	 */
	loadWidgets: function(/*DomNode*/node,/*String*/data) {
		node.innerHTML = data;

		//OpenSocial Support		
		var ss1 = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget, node);

		var ss2 = dojo.query("." + com.ibm.mm.builder.constant.mmGGadget, node);
		var spans = ss1.concat(ss2);


		//var spans = dojo.query("."+com.ibm.mm.builder.constant.mmIWidget, node);
		var len = spans.length;
		for(var i=0; i<len; i++) {
			var span = spans[i];
			if(span.className.indexOf(com.ibm.mm.builder.constant.skinClass)!=-1) {
				var widgetId = span.id;
				com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(span);
				var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
				if (skinDiv) dojo.addClass(skinDiv,"dojoDndItem");
				// reload the widget's size from navigation state.
				var widgetSize = com.ibm.mashups.builder.Personalize.getPersonalizeSize(widgetId);
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				if (widgetSize) {
					if (com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId).loaded) {
						com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, "normal");
						var payload = {
							widgetId: widgetId,
							width: widgetSize.w,
							height: widgetSize.h
						};
						eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
					} else {
						var callBackftn = function(){
							com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgetId, "normal");
							var payload = {
								widgetId: widgetId,
								width: widgetSize.w,
								height: widgetSize.h
							};
							eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
						};
						eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetId, this, callBackftn);
					}
				}
			}
		}
	},

	/**
	 * This method is used to get all the visible widget and separate the widget fragments into different column
	 * @param {String} pagecontent: the page content which contains the widget fragments
	 * @param {Number} num: the column number of this column layout
	 */
	getColumnWidgets: function(pagecontent,num) {
		var filteredContent = this.filterWidgets(pagecontent,"true");
		var columnWidgets =  new Object();
		var widgetsString = "";	
        for (var i = 1; i <= num; i++) {
            columnWidgets[i + ""] = "";
        }
		var tmp = document.createElement("div");
		tmp.innerHTML = filteredContent;	
		var nodes = dojo.query("."+com.ibm.mm.builder.constant.mmIWidget,tmp);	
		var len = nodes.length;
        for (var x = 0; x < len; x++) {
            var achild = nodes[x];
            if (achild.tagName != null && (achild.tagName == "DIV" || achild.tagName == "SPAN")) {
				if (achild.getAttribute("layoutdata")){
					var numStr = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.getColNumberFromLayoutData(achild.getAttribute("layoutdata"));
					columnWidgets[numStr+""] = columnWidgets[numStr+""] + com.ibm.mm.builder.utils.htmlUtil.getElementString(achild);					
				}
            }				
        }	
		return columnWidgets;
	},

	/**
	 * This method is used to get the free form layout widget fragments
	 * @param {String} pagecontent: the page content which contains the widget fragments
	 */
	getFreeFormWidgets: function(pagecontent){
		return this.filterWidgets(pagecontent,"true");
	},

	/**
	 * This method is used to get the hidden widget corral widget fragments
	 * @param {String} pagecontent: the page content which contains the widget fragments
	 */	
	getInnerNVA: function(pagecontent){
		return this.filterWidgets(pagecontent,"false");
	},
	
	/**
	 * This method is used to separate the widget into visible or invisible widget fragments
	 * @param {String} pcontent
	 * @param {boolean} visible
	 */
	filterWidgets:function(pcontent,visible){
		var tmp = document.createElement("div");
		tmp.innerHTML = pcontent;
		var widgets = dojo.query("."+com.ibm.mm.builder.constant.mmIWidget,tmp);
		//OpenSocial support
		var gadgets = dojo.query("." + com.ibm.mm.builder.constant.mmGGadget, tmp);
		var nodes = widgets.concat(gadgets);

		var len = nodes.length;
		var defaultNvaSkin = null;
		
		if (len>0){
			defaultNvaSkin = com.ibm.mm.builder.utils.skinUtil.getNVANode().getID();
		}
        for (var x = 0; x < len; x++) {
            var achild = nodes[x];
            if (achild.tagName != null && (achild.tagName == "DIV" || achild.tagName == "SPAN")) {
				if (visible != achild.getAttribute("visible")){
					tmp.removeChild(achild);
				}
				// fix bug 11905 - provide fallback support for nva skin.
				if (visible === "false") {
					var skin_tag_name = com.ibm.mm.builder.constant.widget_span_attr_skin;
					var nvaSkin = achild.getAttribute(skin_tag_name);
					if (nvaSkin) {
						if (nvaSkin !== defaultNvaSkin) {
							achild.setAttribute(skin_tag_name, defaultNvaSkin);
						}
					}
				}
            }				
        }	
		var flitered = tmp.innerHTML;
		delete tmp;
		return flitered; 
	},
	
	filter: function(str) {
		str = str.replace(/&lt;/g,"<");
		str = str.replace(/&gt;/g,">");
		return str;
	},
	
	getContentUrl: function(doc) {
		var links = com.ibm.mm.enabler.xpath.evaluateXPath("atom:feed/atom:entry/atom:link",doc,this.namespaces);
		for(var i=0; i<links.length; i++) {
			var link = com.ibm.mm.enabler.xslt.loadXmlString(com.ibm.mm.builder.utils.htmlUtil.getElementString(links[i]));
			if(link.firstChild.getAttribute("portal:rel")=="fragment") {
				return link.firstChild.getAttribute("href");
			}		
		}
		return "#";
	},
	
	getContent: function(doc) {
		var contents = com.ibm.mm.enabler.xpath.evaluateXPath("atom:feed/atom:entry/atom:content",doc,this.namespaces);
		return com.ibm.mm.builder.utils.htmlUtil.getElementString(contents[0].firstChild);
	},
	
	getRealContent: function(url, root) {
		var content = "";
		var bindArgs = {
			url: url,
			sync: true,
			handle: function(type,data,evt) {
				var xmlDoc = com.ibm.mm.enabler.xslt.loadXmlString(data);
				var contents = com.ibm.mm.enabler.xpath.evaluateXPath(
					"atom:feed/atom:entry/atom:content",xmlDoc, root.namespaces);
				content = com.ibm.mm.builder.utils.htmlUtil.getElementString(contents[0].firstChild)
			}
		}
		dojo.xhrGet(bindArgs)
		return content;
	}	
			
});

com.ibm.mm.builder.widgetsLoaderObject = null;

com.ibm.mm.builder.initWidgetLoader = function(){
	if(!com.ibm.mm.builder.widgetsLoaderObject){
		com.ibm.mm.builder.widgetsLoaderObject = new com.ibm.mm.builder.widgetLoader();
	}
	return com.ibm.mm.builder.widgetsLoaderObject;
};

}

if(!dojo._hasResource["dojox.encoding.base64"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.encoding.base64"] = true;
dojo.provide("dojox.encoding.base64");

(function(){
	var p="=";
	var tab="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	var dxe=dojox.encoding;

	dxe.base64.encode=function(/* byte[] */ba){
		//	summary
		//	Encode an array of bytes as a base64-encoded string
		var s=[], l=ba.length;
		var rm=l%3;
		var x=l-rm;
		for (var i=0; i<x;){
			var t=ba[i++]<<16|ba[i++]<<8|ba[i++];
			s.push(tab.charAt((t>>>18)&0x3f)); 
			s.push(tab.charAt((t>>>12)&0x3f));
			s.push(tab.charAt((t>>>6)&0x3f));
			s.push(tab.charAt(t&0x3f));
		}
		//	deal with trailers, based on patch from Peter Wood.
		switch(rm){
			case 2:{
				var t=ba[i++]<<16|ba[i++]<<8;
				s.push(tab.charAt((t>>>18)&0x3f));
				s.push(tab.charAt((t>>>12)&0x3f));
				s.push(tab.charAt((t>>>6)&0x3f));
				s.push(p);
				break;
			}
			case 1:{
				var t=ba[i++]<<16;
				s.push(tab.charAt((t>>>18)&0x3f));
				s.push(tab.charAt((t>>>12)&0x3f));
				s.push(p);
				s.push(p);
				break;
			}
		}
		return s.join("");	//	string
	};

	dxe.base64.decode=function(/* string */str){
		//	summary
		//	Convert a base64-encoded string to an array of bytes
		var s=str.split(""), out=[];
		var l=s.length;
		while(s[--l]==p){ }	//	strip off trailing padding
		for (var i=0; i<l;){
			var t=tab.indexOf(s[i++])<<18;
			if(i<=l){ t|=tab.indexOf(s[i++])<<12 };
			if(i<=l){ t|=tab.indexOf(s[i++])<<6 };
			if(i<=l){ t|=tab.indexOf(s[i++]) };
			out.push((t>>>16)&0xff);
			out.push((t>>>8)&0xff);
			out.push(t&0xff);
		}
		//	strip off any null bytes
		while(out[out.length-1]==0){ out.pop(); }
		return out;	//	byte[]
	};
})();

}

if(!dojo._hasResource["com.ibm.mm.catalog.CatalogPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.catalog.CatalogPane"] = true;
dojo.provide("com.ibm.mm.catalog.CatalogPane");



dojo.declare("com.ibm.mm.catalog.CatalogPane", null, {
	constructor: function() {
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.catalog.CatalogPane");
		this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
		this.dlg = {};
	},
	
	show: function(option, newWindow) {
		var hubServerUrl = "", paletteId = "";
		try {
			//get the hub server address
			hubServerUrl = this.getCatalogURL(option) || com.ibm.mm.catalog.hubUtil.getHubSecuredUrl();
			hubServerUrl = this._addOpenedInSuffix(hubServerUrl, newWindow);
		} catch (error) {
			if (this.LOGGER && this.LOGGER.isLoggable(this.LOG_LEVEL)) {
				this.LOGGER.severe("show", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_MODE_SELECTOR_GET_CATALOG_1, [error.message]));
			}
			// com.ibm.mm.enabler.debug.error(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_MODE_SELECTOR_GET_CATALOG_1,[error.message]));
			return;
		}
		//get the url to invoke MashupHub, it contains a parameter "serverUrl" for Mashups address
		if (hubServerUrl) {
			if (!newWindow) {
				if (!this.dlg[hubServerUrl]) {
					this.dlg[hubServerUrl] = com.ibm.mashups.builder.displayLMDialog(dojo.create("div"), {
						title: com.ibm.mm.builder.coreWidgetsStrings.I_CATALOG_PANE_TITLE,
						containerBackgroundColor: "white",
						nodeWidth: (0.9 * screen.availWidth + "px"),
						nodeHeight: (0.8 * screen.availHeight + "px"),
						displayCloseButton: true,
						closeCallback: dojo.hitch(this, function(){
							var iframes = dojo.query("iframe", this.dlg[hubServerUrl].domNode);
							
							if(iframes.length > 0) {
								var thisIframe = iframes[0];
								thisIframe.src = "";
								if (thisIframe.attachEvent) {
									thisIframe.attachEvent("onload", function() {
										thisIframe.outerHTML = "";
										thisIframe = null;
									});
								}
                                
							}
						})
					});
				} else {
					this.dlg[hubServerUrl].show();
				}
                dojo.query(dojo.create("iframe", {
                    src: hubServerUrl
                }, this.dlg[hubServerUrl].containerNode, "only")).style({
                    width: "99.5%",
                    height: "99%",
                    border: "0 none"
                });
			}
			else {
				window.open(hubServerUrl);
			}
		}
	},
	_addOpenedInSuffix: function(url, newWindow) {		
		var hubServerUrl = url;
		if (!newWindow) {
			
			if (hubServerUrl.indexOf("?") != -1) {
				hubServerUrl = [hubServerUrl, "&"].join("");
			} 
			
			hubServerUrl = [hubServerUrl, "openedIn=dialog"].join("");
		}
		return hubServerUrl;
	},
	getCatalogURL: function(option) {
        var mumUrl = ([window.location.protocol, "//", window.location.host, builderConfig.enablerPath].join("")),
            chars = [];
        for (var i = 0, l = mumUrl.length; i < l; i++) {
            chars.push(mumUrl.charCodeAt(i))
        }
        var mumUrl64 = dojox.encoding.base64.encode(chars);
		switch (option) {
			case com.ibm.mm.catalog.CATALOGCREATEFEEDUI: 
				return encodeURI([com.ibm.mm.catalog.hubUtil.getHubFeedCreationUrl(), "&serverUrl=", mumUrl64].join(""));
			case com.ibm.mm.catalog.CATALOGCREATEFEEDMASHUPUI:
				return encodeURI([com.ibm.mm.catalog.hubUtil.getHubFeedMashupCreationUrl(), "&serverUrl=", mumUrl64].join(""));
			default:
				var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
				var anonymousUser = cs.getValue("anonymousUser");
				var securityOff = cs.getValue("securityOff");
				if (anonymousUser || securityOff){
					return encodeURI([com.ibm.mm.catalog.hubUtil.getHubAnonymousUrl(), "?serverUrl=", mumUrl64].join(""));									
				} else {
					return encodeURI([com.ibm.mm.catalog.hubUtil.getHubSecuredUrl(), "?serverUrl=", mumUrl64].join(""));					
				}
		}
	}
});

com.ibm.mm.catalog.CatalogPane = new com.ibm.mm.catalog.CatalogPane();

com.ibm.mm.catalog.CATALOGUI = 0;
com.ibm.mm.catalog.CATALOGUI_NEW_WINDOW = 3;
com.ibm.mm.catalog.CATALOGCREATEFEEDUI = 1;
com.ibm.mm.catalog.CATALOGCREATEFEEDMASHUPUI = 2;

}

if(!dojo._hasResource["com.ibm.mashups.builder.api"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.api"] = true;
/**
 * Please note, the following builder JavaScript API are not public in Lotus Mashups v1.1.
 * The APIs are not stable and subject to change before they go public in v2.
 * 
 * @author EriK (bizheng@cn.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mashups.builder.api");



com.ibm.mashups.builder.builderTopicHandlers = null;

com.ibm.mashups.builder.createLMDialog = function(contentDiv, params){
    return new com.ibm.mm.builder.widget.CustomDialog(params, contentDiv);
}

com.ibm.mashups.builder.displayLMDialog = function(contentDiv, params){
    var dlg = com.ibm.mashups.builder.createLMDialog(contentDiv, params);
    dlg.show();	
    return dlg;
}

/**
 * when user wants to open the widget configuration mode,
 * this method should be called to create the widget config dialog and switch to edit mode
 * @param {String} widgetId widget instance id 
 */
com.ibm.mashups.builder.showWidgetConfigDialog=function(widgetId){
	var menu = new com.ibm.mm.builder.widget.WidgetMenu({
		iwidgetId: widgetId
	});
	menu.showEditPane();
}

/**
 * when user finishes configuring the widget and clicks the save button,
 * this method should be called to close the widget config dialog and switch to view mode
 * @param {String} widgetId widget instance id 
 */
com.ibm.mashups.builder.closeWidgetConfigDialog=function(widgetId){
	dojo.publish(com.ibm.mm.builder.eventTopics.Widget_ConfigurationFinished, [widgetId]);
}

/**
 * in case production widget need to subscribe the topic published from builder framework.
 * @param {String} topicName
 * @param {Object} obj
 * @param {Object} callback
 */
com.ibm.mashups.builder.subscribeBuilderTopics = function(topicName,obj,callback){
	var oneHandler = dojo.subscribe(topicName, obj, callback);
	if (com.ibm.mashups.builder.builderTopicHandlers == null){
		com.ibm.mashups.builder.builderTopicHandlers = new Array();
	}
	com.ibm.mashups.builder.builderTopicHandlers.push(oneHandler);
}

/**
 * builder api to unsubscribe all the topic handlers
 */	
com.ibm.mashups.builder.clearBuilderTopicHandlers = function(){
	dojo.forEach(com.ibm.mashups.builder.builderTopicHandlers, dojo.unsubscribe);
	com.ibm.mashups.builder.builderTopicHandlers = new Array();	
}

}

if(!dojo._hasResource["com.ibm.mm.builder.commonActions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.commonActions"] = true;
/**
 * Common Action class
 * Provides the global public functions
 @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */



dojo.provide("com.ibm.mm.builder.commonActions");

com.ibm.mm.builder.commonActions.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.commonActions");

com.ibm.mm.builder.commonActions.isAnonymous = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	var anonymousUser = cs.getValue("anonymousUser");
	return anonymousUser;
}

com.ibm.mm.builder.commonActions.isSecurityOff = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	var securityOff = cs.getValue("securityOff");
	return securityOff;
}

com.ibm.mm.builder.commonActions.isAnonymousCreate = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	var value = cs.getValue("com.ibm.mashups.anonymous.mode.locked.on");
	var anonymous = com.ibm.mm.builder.commonActions.isAnonymous();
	var securityOff = com.ibm.mm.builder.commonActions.isSecurityOff();	
	if (securityOff) return true;

	return !anonymous ? true : value;
}

com.ibm.mm.builder.commonActions.hasHub = function(){
	return builderConfig.hasHub;
}

com.ibm.mm.builder.commonActions.changePageMode = function(mode, callbackFunc){
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.changePageMode", mode);
	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setPageMode(mode);
	var navigationStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
	var pageModeAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageModeAccessor(navigationStateModel);
	pageModeAccessor.setPageMode(mode);
	var deferred = navigationStateModel.commit();
	if(callbackFunc)
		deferred.setFinishedCallback(callbackFunc);
	deferred.start(false);
}

com.ibm.mm.builder.commonActions.viewPageSource = function() {
	var dialogParam = {
		title: com.ibm.mm.builder.coreWidgetsStrings.I_PAGE_SOURCE_TITLE,
		type: "source",
		sharedWidget: true,
		nodeWidth:"900px",
		//nodeHeight:"500px",
		containerBackgroundColor: "white",
		hasRightBottomResizer:false
	}
	var payload = {
	    	widgetTypeId: "pageSource",
	        eventName:  "com.ibm.mashups.builder.loadPageSource",
	        eventPayload:  "",
	        dialogParam:  dialogParam
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
}

com.ibm.mm.builder.commonActions.canViewMorePage = function(){
	return !!com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().findDefaultAcceptParent();
}

com.ibm.mm.builder.commonActions.viewMorePage = function(){
	var dialogParam = {
		title: com.ibm.mm.builder.coreWidgetsStrings.I_MORE_PAGE_TITLE,
		nodeWidth: "600px",
		containerBackgroundColor: "white",
		hasLeftBottomResizer: false,
		hasRightBottomResizer: false 
	};

	var payload = {
	    	widgetTypeId: "viewMorePage",
	        eventName:  "com.ibm.mashups.builder.viewMorePage",
	        eventPayload:  "",
	        dialogParam:  dialogParam,
	        requestRefresh: true
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
}

com.ibm.mm.builder.commonActions.widgetCreation = function(){
	var dialogParam = {
		title : com.ibm.mm.builder.coreWidgetsStrings.I_WIDGET_BUILDER,
		nodeWidth: "350px",
		containerBackgroundColor: "white",
		hasLeftBottomResizer: false,
		hasRightBottomResizer: false
	};

	var payload = {
	    	widgetTypeId: "createNewWidget",
	        eventName:  "com.ibm.mashups.builder.createNewWidget",
	        eventPayload:  "",
	        dialogParam:  dialogParam,
	        requestRefresh: true
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
};

com.ibm.mm.builder.commonActions.viewCatalog = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGUI);
}

com.ibm.mm.builder.commonActions.catalogNewWindow = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGUI_NEW_WINDOW, true);
}

com.ibm.mm.builder.commonActions.catalogFeedCreation = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGCREATEFEEDUI);
}

com.ibm.mm.builder.commonActions.catalogFeedMashupCreation = function() {
	com.ibm.mm.catalog.CatalogPane.show(com.ibm.mm.catalog.CATALOGCREATEFEEDMASHUPUI);
}

com.ibm.mm.builder.commonActions.savePage = function(){
	if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()){
		
		com.ibm.mashups.services.ServiceManager.getService("eventService")
			.broadcastEvent("com.ibm.mashups.builder.savePage");
		
		this.LOGGER.info(
			"savePage",
			dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.I_TOOLBOX_PAGE_SAVED_1,
				[com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle()])
		);
	}
}

com.ibm.mm.builder.commonActions.hwdDialogID = null;
com.ibm.mm.builder.commonActions.showHWC = function(){
	var hwdDialog = dijit.byId(com.ibm.mm.builder.commonActions.hwdDialogID);
	if(!hwdDialog) {
		var scroll = dojo._docScroll();
		var leftValue = scroll.x + 730;
		if (builderConfig.isBidi) {
			leftValue = dojo.isIE===6 ? 230 : 180;
		}
		var left = leftValue + "px";
		var top = (scroll.y + 100) + "px";
		com.ibm.mm.builder.commonActions.hwdDialogID = dojo.dnd.getUniqueId();
		var dialogParam = {
            id: com.ibm.mm.builder.commonActions.hwdDialogID,
            nodeWidth: "375px",
            nodeHeight: "360px",
            nodeStyle: "overflowY:auto",
            title: com.ibm.mm.builder.coreWidgetsStrings.I_NVA_TITLE,
            displayCloseButton: true,
            hasRightBottomResizer: false,
            modelDialog: false,
            titleBarHeight: 25,
            endBarHeight: 18,
            sharedWidget: true,
			initLeftPosition: left,
			initTopPosition: top,
			alwaysCenter: false,
			needUnderLay: false
        };
		var payload = {
		    	widgetTypeId: "hiddenWidgetCorral",
		        eventName:  null,
		        eventPayload:  null,
		        dialogParam:  dialogParam
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService")
			.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	}
	else {
		hwdDialog.open ? hwdDialog.hide() : hwdDialog.show();
	}
}

com.ibm.mm.builder.commonActions.accountSettings = function(){
	var payload = {
    	widgetTypeId: "editPage",
        eventName:  "com.ibm.mashups.builder.editPage",
        eventPayload: null,
		requestRefresh: true,
        dialogParam: { 
			id: "accountSettings",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_EDIT_PROPERTIE_ACCOUNT,
			nodeWidth: "420px",
			containerBackgroundColor: "white",
			hasRightBottomResizer: false
		}
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
}

com.ibm.mm.builder.commonActions.publishPage = function(pageId){
	if(!pageId) {
		com.ibm.mm.builder.commonActions.LOGGER.severe("com.ibm.mm.builder.commonActions.publishPage", "can not get the page id")
		return;
	}
	var changed = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty();
	//if the page is just changed but not saved, show a dialog to let user to save and publish, or publish without save
	if (changed) {
		new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
			contentWarning: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_TEXT1,
			contentQuestion: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_TEXT2,
			btnSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_SAP,
			btnNotSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_PWOS,
			btnCancelText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_PUBPAGE_CON_RETURN,
			charLimit: 22,
			frameWidth: (dojo.isIE || dojo.isSafari == 3.2) ? "690px" : "680px",
			callbackSave: function(){
				com.ibm.mm.builder.commonActions.loadPublish(pageId);
			},
			callbackNotSave: function(){
				com.ibm.mm.builder.commonActions.loadPublish(pageId);
			}
		}).show();
	}else {
		com.ibm.mm.builder.commonActions.loadPublish(pageId);
	}
}

com.ibm.mm.builder.commonActions.canSharePage = function(pageId){
    if (!pageId) { return false; }
    var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
    var pageNode = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId);
    if (!navigationModel.hasLayoutModel(pageNode)) return false;
    return com.ibm.mm.builder.utils.acModelUtil.getPageAC(pageId).confirmGetRoleModel();
}

com.ibm.mm.builder.commonActions.sharePage = function(pageId){
	var pageName = com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId);
	if(!pageName || (pageName == null)){
		pageName = "";
	}
	var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_DIALOG_TITLE, [pageName]);
	
	var payload = {
    	widgetTypeId: "sharePage",
        eventName:  "com.ibm.mashups.builder.sharePage",
        eventPayload:  pageId,
		requestRefresh: true,
        dialogParam: {
			title: title,
			nodeWidth: "774px",
			hasRightBottomResizer: false
		}
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
}

com.ibm.mm.builder.commonActions.embedPage = function(pageId){
	var changed = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty();
	if (changed) {
		new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
			contentWarning: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_TEXT1,
			contentQuestion: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_TEXT2,
			btnSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_SAP,
			btnNotSaveText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_PWOS,
			btnCancelText: com.ibm.mm.builder.coreWidgetsStrings.PAGE_MENU_EMBPAGE_CON_RETURN,
			charLimit: 28,
			frameWidth: "800px",
			callbackSave: function(){
				com.ibm.mm.builder.commonActions.loadEmbedding(pageId);
			},
			callbackNotSave: function(){
				com.ibm.mm.builder.commonActions.loadEmbedding(pageId);
			}
		}).show();
	}else {
		com.ibm.mm.builder.commonActions.loadEmbedding(pageId);			
	}
}

com.ibm.mm.builder.commonActions.canCreateSubPage = function(pageId) {
	if (!com.ibm.mm.builder.commonActions.isAnonymousCreate()){
		return false;
	}
	
	if (!pageId) {
		return false;
	}
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var pageUtil = com.ibm.mm.builder.utils.pageUtil;
	var navModel = navigationUtil.getNavigationModel();
	return navModel.confirmInsert(null, pageUtil.getPageNode(pageId));
};

com.ibm.mm.builder.commonActions.canEditPage = function(pageId) {
	return com.ibm.mm.builder.utils.pageUtil.canEdit(com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId));	
};

com.ibm.mm.builder.commonActions.canReorderPage = function(pageId) {
	var pageUtil = com.ibm.mm.builder.utils.pageUtil;
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var pageNode = pageUtil.getPageNode(pageId);
	var navigationModel = navigationUtil.getNavigationModel();
	var canMove = navigationModel.confirmInsert(null, pageNode, null);
	return canMove;	
};
com.ibm.mm.builder.commonActions.editPage = function(pageId){
	
	var payload = {
    	widgetTypeId: "editPage",
        eventName:  "com.ibm.mashups.builder.editPage",
        eventPayload: pageId,
		requestRefresh: true,
        dialogParam: {
			id: pageId + "_pageProperty",
			title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EDIT_PROPERTIE_PAGE, [com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
			nodeWidth: "515px",
			containerBackgroundColor: "white",
			hasRightBottomResizer: false
		}
	};
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
}

// To be implemented by portal
com.ibm.mm.builder.commonActions.getSpaceId = function() {
	return null;
}

com.ibm.mm.builder.commonActions.reorderPage = function(pageId) {
	var currentPageName = com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle();
	var eventPayload = {
		pageId: pageId,
		spaceId: com.ibm.mm.builder.commonActions.getSpaceId()
	};
	var payload = {
        widgetTypeId: "reorderPage",
        eventName: "com.ibm.mashups.builder.reorderPage",
        eventPayload: eventPayload,
		requestRefresh: true,
        dialogParam: {
			id: pageId + "_reorderPane",
			title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_REORDER_PAGE_DIALOG_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
            nodeWidth: "420px",
            containerBackgroundColor: "white",
            hasRightBottomResizer: false
        }
    };
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
}


com.ibm.mm.builder.commonActions.canDeletePage = function(pageId) {
	if (!pageId) {
		return false;
	}
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var pageUtil = com.ibm.mm.builder.utils.pageUtil;
	var navModel = navigationUtil.getNavigationModel();
	return navModel.confirmRemove(pageUtil.getPageNode(pageId));
};

com.ibm.mm.builder.commonActions.deletePage= function(pageId){
	
        if (!pageId) {
            this.LOGGER.severe("deletePage", com.ibm.mm.builder.coreWidgetsMessages.E_SPACE_MANAGER_PAGE_ID_IS_NULL_0);
            return;
        }
		var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId);
		var parentPageId = com.ibm.mm.builder.utils.pageUtil.getParentPageId(pageId);
		var currentPageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
		
        var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
        var page = navModel.find(pageId).start();
        if (!page) {
            return;
        }
		var bundle = com.ibm.mm.builder.coreWidgetsStrings;
		var enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		var spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
        var constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
        var message = dojo.string.substitute(bundle["I_SPACE_MANAGER_DELETE_PAGE_PROMPT"], [enablerUtil.getNodeTitle(page)]);
        this._deletePageDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete page",
			title: dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_PAGE_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(pageId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : dojo.hitch(this, function() {
				com.ibm.mm.builder.utils.pageUtil.deletePage();				
                var d = new dojo.Deferred();        
				d.callback();
                return d;
            }),
            okCallback : dojo.hitch(this, function() {
				if(com.ibm.mm.builder.utils.pageUtil.isRoot(parentPageId)) {
					parentPageId = com.ibm.mm.builder.utils.pageUtil.getFirstRootPageId();
				}
				//refresh navigation
				var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchPage", parentPageId);
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.spacemanager.deletePage", {currentPageId:currentPageId, parentPageId: parentPageId, pageId: pageId});
            })
        },this._deletePageDialog);
}

com.ibm.mm.builder.commonActions.newChildPage = function(){
	var dialog = new com.ibm.widgets.NewPageDialog({
		showMakePrivate:false,
		showFriendlyURL: false,
		blankImg: ibmConfig.themeBasePath + "css/images/blank.gif",
		onChange: function(value){
			com.ibm.mm.builder.navigationHelper.treeModel.newItem(value,com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode());
		}
	});
	dialog.focus();
}

com.ibm.mm.builder.commonActions.canCopyPageInSpace = function(pageId) {
	if (!pageId) {
		return false;
	}
	var pageUtil = com.ibm.mm.builder.utils.pageUtil;
	var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
	var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
	var spaceId = spaceUtil.getSpaceIdByPageId(pageId);
	
	return pageUtil.canEdit(navigationUtil.getNavigationRootNode(spaceId));
};

com.ibm.mm.builder.commonActions.loadEmbedding = function(pageId){ 
	com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog(pageId, "page");
}

com.ibm.mm.builder.commonActions.canPublishPage = function(pageId){
    if (!pageId) { return false; }
    var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
    var pageNode = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId);
    if (!navigationModel.hasLayoutModel(pageNode)) return false;
    return navigationModel.confirmExport(pageNode)
}

com.ibm.mm.builder.commonActions.loadPublish = function(pageId){
    var currentPageName = com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle();
	var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_PUBLISH_PAGE_TITLE, [currentPageName]);
	
    var payload = {
        widgetTypeId: "publishWidget",
        eventName: "com.ibm.mashups.builder.publishPage",
        eventPayload: pageId,
		requestRefresh: true,
        dialogParam: {
			title: title,
            nodeWidth: "480px",
			needUnderLay: true,
            containerBackgroundColor: "white",
            hasRightBottomResizer: false
        }
    };
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
}


//************* widget context menu call back functions

com.ibm.mm.builder.commonActions.showEditPane = function(widgetId){
	// temp fix for old widget spec
	var oldWidgetConfigId = "";
	var oldWidgetConfigParentNode = null;
	// end temp fix
	
	var widgetSpan = dojo.byId(widgetId);
	var configNodeId = "";
	
    var items = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.mmItem, widgetSpan);
    dojo.forEach(items, function(item){
    	var str = com.ibm.mm.builder.utils.iWidgetSpecUtil.getKeyFromHref(item)
        if (str == com.ibm.mm.builder.constant.configPannelNode)
            configNodeId = "_" + widgetId + "_" + item.innerHTML.replace(/\n/g, "");
    });
	
	if (configNodeId){
		// temp fix for old widget spec
		oldWidgetConfigId = configNodeId;
		oldWidgetConfigParentNode = dojo.byId(configNodeId).parentNode;
		// end temp fix
//		var editnode = dojo.byId(configNodeId);
//		editnode.style.display = "";
//		this.editorDiv.appendChild(editnode);
	}	
	var _title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
	var editPane = new com.ibm.mm.builder.widget.CustomDialog({
		id: widgetId+"_edit",
		title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_SYSTEM_CONF_TITLE,[_title]),
		type: "config",
		nodeWidth: dojo.byId(widgetId).getAttribute("sandbox") === "true" ? "400px" : null,
		needModeSwitch: true,
		belongId: widgetId,
		containerBackgroundColor: "white"
	});	
	
	var editActionHandle = dojo.subscribe(com.ibm.mm.enabler.iw.iEvents.Constants.modeChanged, editPane, editPane.hide);
	
	editPane.closeCallback = function(){ 
			dojo.unsubscribe(editActionHandle);
			editPane.destroy(); 
	}
	
	if (!configNodeId) {
        serviceManager.getService("eventService").fireEvent(widgetId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: editPane.containerNode
        });
    }
	// temp fix for old widget spec
	if (oldWidgetConfigId != ""){
		var _oldWidgetConfigId = oldWidgetConfigId;
		var _oldWidgetConfigParentNode = oldWidgetConfigParentNode;
		editPane.oldWidgetSpecHitch = function(){
			if ((_oldWidgetConfigId!="") && (_oldWidgetConfigParentNode)){
				dojo.byId(_oldWidgetConfigId).style.display = "none";
				_oldWidgetConfigParentNode.appendChild(dojo.byId(_oldWidgetConfigId));
			}
		}
	}
	// end temp fix
	editPane.show();
//	var editActionHandle = dojo.subscribe(com.ibm.mm.enabler.iw.iEvents.Constants.modeChanged, this.editPane, this.editPane.hide);
}

com.ibm.mm.builder.commonActions.renameWidget = function(widgetId){
	var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
	var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_RENAME_WIDGET_PROMPT, [widgetTitle]);
	var dialogParam = {
		title: title,
		nodeWidth: "400px",
		containerBackgroundColor: "white",
		hasRightBottomResizer: false
	}
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", {
	    widgetTypeId: "renameWidget",
	    eventName:  "com.ibm.mashups.builder.renameAction",
	    eventPayload:  widgetId,
	    dialogParam:  dialogParam,
		requestRefresh: true
	});
}

com.ibm.mm.builder.commonActions.resizeWidget = function(widgetId){
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.resizeAction", {iwidgetId: widgetId});
}

com.ibm.mm.builder.commonActions.moveWidget = function(widgetId){
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.moveAction", {iwidgetId: widgetId});
}

com.ibm.mm.builder.commonActions.editWiring = function(widgetId) {
	com.ibm.mm.builder.skinHelper.launchWiring(widgetId);
}

com.ibm.mm.builder.commonActions.viewWiringGraph = function(widgetId) {
	com.ibm.mm.builder.skinHelper.launchWireGraph(widgetId);
}

//lable provider function
com.ibm.mm.builder.commonActions.displayOrHideLabel = function(widgetId) {
	var inNVA = com.ibm.mm.builder.commonActions.isWidgetHidden(widgetId);
	return inNva ? com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_DISPLAY : com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_HIDE;
}

com.ibm.mm.builder.commonActions.isWidgetHidden = function(widgetId) {
	
}

com.ibm.mm.builder.commonActions.displayOrHideWidget = function(widgetId) {
	com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent(
		com.ibm.mm.builder.commonActions.isWidgetHidden(widgetId) ? "com.ibm.mashups.builder.hideWidget" : "com.ibm.mashups.builder.displayWidget", 
		widgetId
	);
}

com.ibm.mm.builder.commonActions.removeWidget = function(widgetId){
	// this method is used only to remove the end user widget instance
	var resizeHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHandlerExt);
	resizeHandler && resizeHandler.destroy();
	
	var resizeHeightHandler = dijit.byId(widgetId + com.ibm.mm.builder.constant.resizeHeightExt);
	resizeHeightHandler && resizeHeightHandler.destroy();

	var quickWireTarget = com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
	if(quickWireTarget){
		quickWireTarget.destroy();
		delete com.ibm.mm.builder.dnd.QuickWireTargetMap[widgetId];
	}

	var editBar = dijit.byId(widgetId + com.ibm.mm.builder.constant.editbarDragHandler);
	editBar && editBar.destroy();

	var widgetSkin = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	if(dojo.attr(widgetId, "visible") === "false"){
		var wireIcon = dojo.byId(widgetId + "_wireIcon");
    	var editIcon = dojo.byId(widgetId + "_editIcon");
		editIcon && (editIcon.onclick = editIcon.onkeypress = null);
		wireIcon && (wireIcon.onclick = wireIcon.onkeypress = null);
	}
	if(dojo.isIE || dojo.isSafari){
		var widgetBody = dojo.query(".widgetBody", widgetSkin)[0];
		widgetBody && (widgetBody.onselectstart = null);
	}
	
	com.ibm.mm.builder.utils.layoutUtil.refreshLayoutData(widgetId);

	com.ibm.mashups.services.ServiceManager.getService("eventService").publishEvent(
		com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS, widgetId);

	setTimeout(function(){
		dojo._destroyElement(widgetSkin);
	    com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeRemoved();
	}, 50);
}

//*******************  callback function for space action menu **************************
				
com.ibm.mm.builder.commonActions.publishSpace = function(spaceId){
	if(!spaceId) {return;}
	var cb = function(){
		var payload = {
	        widgetTypeId: "publishWidget",
	        eventName: "com.ibm.mashups.builder.publishSpace",
	        eventPayload: spaceId,
			requestRefresh: true,
	        dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.PUBLISH_SPACE_CAPTION, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
	            nodeWidth: "450px",
	            containerBackgroundColor: "white",
	            hasRightBottomResizer: false
	        }
	    };
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	};
	com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
}

com.ibm.mm.builder.commonActions.canEditSpaceProperties = function(spaceId){
	var s = com.ibm.mm.builder.utils.spaceUtil;
	return s.canEdit(s.getSpaceNode(spaceId));
}

com.ibm.mm.builder.commonActions.canPublishAsTemplate = function(){
	return com.ibm.mm.builder.commonActions.hasHub() && com.ibm.mm.builder.commonActions.isAnonymousCreate();
}

com.ibm.mm.builder.commonActions.canCreateNewFeed = function(){
	return com.ibm.mm.builder.commonActions.hasHub() && com.ibm.mm.builder.commonActions.isAnonymousCreate();
}

com.ibm.mm.builder.commonActions.canCreateDataMashup = function(){
	return com.ibm.mm.builder.commonActions.canCreateNewFeed();
}

com.ibm.mm.builder.commonActions.editSpaceProperties = function(spaceId) {	
    var payload = {
        widgetTypeId: "editSpace",
        eventName: "com.ibm.mashups.builder.spaceEditor",
        eventPayload: spaceId,
		requestRefresh: true,
        dialogParam: {
			title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.EDIT_SPACE_PROPERTIES, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
            nodeWidth: "975px",
            containerBackgroundColor: "white",
            hasRightBottomResizer: false
        }
	};
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
}

com.ibm.mm.builder.commonActions.isSpaceInFavorite = function(spaceId) {
	if (spaceId) {
		space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId)
		if (space) return space.isFavorite();
	}
	return false;
}

com.ibm.mm.builder.commonActions.addSpaceToFavorite = function(spaceId){
	if (spaceId) {
		com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.addSpaceToFavorite(spaceId);
	}
}

com.ibm.mm.builder.commonActions.isSpaceNotInFavorite = function(spaceId) {
	if(spaceId) return !com.ibm.mm.builder.commonActions.isSpaceInFavorite(spaceId);
}

com.ibm.mm.builder.commonActions.removeSpaceFromFavorite = function(spaceId){
    if (spaceId) {
		com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.removeSpaceFromFavorite(spaceId);
	}
}

com.ibm.mm.builder.commonActions.canExportSpace = function(spaceId) {
    var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    return spaceUtil.getSpaceModel().confirmExport(spaceUtil.getSpaceNode(spaceId));
}

com.ibm.mm.builder.commonActions.exportSpace = function(spaceId){
	if (spaceId) {
		var cb = function(){
			com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.exportSpace(spaceId);
		};
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
	}
}
	
com.ibm.mm.builder.commonActions.canCopySpace = function(spaceId) {
    var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    return spaceUtil.getSpaceModel().confirmCopy(spaceUtil.getSpaceNode(spaceId));
}

com.ibm.mm.builder.commonActions.copySpace = function(spaceId) {
	var cb = function(){
		var payload = {
			widgetTypeId: "copySpace",
			eventName: "com.ibm.mashups.builder.copySpace",
			eventPayload: spaceId,
			requestRefresh: true,
			dialogParam: {
				title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.COPY_SPACE_CAPTION, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
				nodeWidth: "350px",
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			}
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	};
	com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
}

com.ibm.mm.builder.commonActions.canShareSpace = function(spaceId) {
	if (!spaceId) { return false; }
	return com.ibm.mm.builder.utils.acModelUtil.getSpaceAC(spaceId).confirmGetRoleModel();
}

com.ibm.mm.builder.commonActions.shareSpace = function(spaceId) {
	var cb = function(){
		var currentSpaceName = com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId);
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_SHARESPACE_DIALOG_TITLE, [currentSpaceName]);
		
		var payload = {
	        widgetTypeId: "sharePage",
	        eventName:  "com.ibm.mashups.builder.shareSpace",
	        eventPayload:  spaceId,
			requestRefresh: true,
	        dialogParam: {
				title: title,
				nodeWidth: "774px",
				hasRightBottomResizer: false
			}
	    };
	    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
	};
	com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb);
}
com.ibm.mm.builder.commonActions.canDeleteSpace = function(spaceId) {
	var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
    return spaceUtil.getSpaceModel().confirmRemove(spaceUtil.getSpaceNode(spaceId));
}

com.ibm.mm.builder.commonActions.deleteSpace = function(spaceId) {
	if (spaceId) {
		var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		var enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		var spaceManagerUtil = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
        var spaceModel = spaceUtil.getSpaceModel();
        var space = spaceModel.find(spaceId).start();
        if (!space) {
            return;
        }
		var bundle = com.ibm.mm.builder.coreWidgetsStrings;
		var message = dojo.string.substitute(bundle["I_SPACE_MANAGER_DELETE_SPACE_PROMPT"], [enablerUtil.getNodeTitle(space)]);
		
        var _deleteSpaceDialog = spaceManagerUtil.ui.dialog.openConfirmDialog(dojo.body(), {message : message}, {
            type: "delete space",
			title : dojo.string.substitute(bundle.I_SPACE_MANAGER_DELETE_SPACE_TITLE, [com.ibm.mm.builder.utils.spaceUtil.getSpaceTitle(spaceId)]),
            nodeWidth : "400px",
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            containerBackgroundColor: "white",
            displayCloseButton: true,
            hasRightBottomResizer: false,
            resourceBundle: bundle,
            okFunc : function() {
                if(spaceUtil.isHomeSpace(spaceId)){
					spaceUtil.setHomeSpaceId();
				}
                
                if (com.ibm.mm.builder.commonActions.isSpaceInFavorite(spaceId)) {
					com.ibm.mm.builder.commonActions.removeSpaceFromFavorite(spaceId);
				}
				
                spaceModel.remove(space);
				spaceModel.commit().start();
				if(spaceUtil.isWelcomeSpace(spaceId)){
					spaceModel = spaceUtil.getSpaceModel(true);
				}
                var d = new dojo.Deferred();
                var deferred = function(){};
                d.callback({});
                return d;
            },
            okCallback : function() {
				dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space["delete"],[spaceId]);
                dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.DELETE_SPACE, {spaceId: spaceId}]);
				/** remove favorite quick access in 2.0, 14521 **/
				//dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refreshQuickAccess);
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				var sid = com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId();
				if(!spaceModel.find(sid).start()){
					sid = null;
				}
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchSpace", sid);
            }
        }, _deleteSpaceDialog);
	}
}

com.ibm.mm.builder.commonActions.canCreatePageInSpace = function(spaceId){
	var u = com.ibm.mm.builder.utils;
	return u.pageUtil.canEdit(u.navigationUtil.getNavigationRootNode(spaceId)) &&
		com.ibm.mm.builder.commonActions.isAnonymousCreate();
}

com.ibm.mm.builder.commonActions.createSpaceCopy = function(spaceId){
	var payload = {
		widgetTypeId: "copySpace",
		eventName: "com.ibm.mashups.builder.copySpace",
		eventPayload: spaceId,
		requestRefresh: true,
		dialogParam: {
			title: com.ibm.mm.builder.coreWidgetsStrings.COPY_SPACE_CAPTION,
			nodeWidth: "350px",
			containerBackgroundColor: "white",
			hasRightBottomResizer: false
		}
	};
    com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
}

com.ibm.mm.builder.commonActions.isEmbeddingAvailable = function(){
	// This is a sample method for Portal to customize.
	return true;
}

com.ibm.mm.builder.commonActions.isWidgetBuilderAvailable = function(){
	var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
	return cs.getValue(com.ibm.mm.enabler.services.CONFIG_SERVICE.WIDGET_BUILDER_ENABLED);
}

com.ibm.mm.builder.commonActions.isPersonalSpaceAvailable = function(){
	// This is a sample method for Portal to customize.
	return true;	
}

com.ibm.mm.builder.commonActions.isSpaceImportExportEnabled = function(){
	return ibmConfig["enable_import_export_space"];	
}

com.ibm.mm.builder.commonActions.isHomeSpace = function(spaceId){
	return com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.DEFAULT_SPACE") && com.ibm.mm.builder.utils.spaceUtil.isHomeSpace(spaceId);
}
	
com.ibm.mm.builder.commonActions.makeHomeSpace = function(spaceId){
	var originalHomeSpaceId = com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId();
	com.ibm.mm.builder.utils.spaceUtil.setHomeSpaceId(spaceId);
	dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.MAKE_HOME, {originalHomeSpaceId: originalHomeSpaceId, spaceId: spaceId}]);
}
	
com.ibm.mm.builder.commonActions.isNotHomeSpace = function(spaceId){
	return com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.DEFAULT_SPACE") && !com.ibm.mm.builder.commonActions.isHomeSpace(spaceId);
}
	
com.ibm.mm.builder.commonActions.unmakeHomeSpace =  function(spaceId){
	com.ibm.mm.builder.utils.spaceUtil.setHomeSpaceId();
	dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.UNMAKE_HOME, {spaceId: spaceId}]);
}

com.ibm.mm.builder.commonActions.canEmbedPage = function(){
	if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID()) return true;
	return false;
}

}

if(!dojo._hasResource["com.ibm.mm.builder.builderCompatibleProxy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.builderCompatibleProxy"] = true;
dojo.provide("com.ibm.mm.builder.builderCompatibleProxy");

dojo.provide("com.ibm.mm.builder.widgetAttributes");
dojo.provide("com.ibm.mm.builder.widget.baseWidget");
dojo.provide("com.ibm.mm.builder.eventUtil");
dojo.provide("com.ibm.mm.builder.mmHtmlUtils");
dojo.provide("com.ibm.mm.builder.dataViewerUtil");

dojo.declare("com.ibm.mm.builder.widgetAttributes",null,{
	deserializeAttributes:function() {
	}
});

dojo.declare("com.ibm.mm.builder.widget.baseWidget", null, {
});


dojo.declare("com.ibm.mm.builder.eventUtil",null,{

	publishEvent: function(id,eventName,payload) {
		serviceManager.getService("eventService").fireEvent(id,eventName,payload)
	},
	
	publishWireEvent: function(id,eventName,type,payload) {
		serviceManager.getService("eventService").publishWire(id,eventName,payload);
	}
	
});

dojo.declare("com.ibm.mm.builder.mmHtmlUtils", null, {
	
	getElementsByClass: function(
		/* string */classStr, 
		/* HTMLElement? */parent, 
		/* string? */nodeType, 
		/* integer? */classMatchType, 
		/* boolean? */useNonXpath
	){
		
		useNonXpath = false;
		var _document = dojo.doc;
		parent = dojo.byId(parent) || _document;
		var classes = classStr.split(/\s+/g);
		var nodes = [];
		if( classMatchType != 1 && classMatchType != 2 ) classMatchType = 0; // make it enum
		var reClass = new RegExp("(\\s|^)((" + classes.join(")|(") + "))(\\s|$)");
		var srtLength = classes.join(" ").length;
		var candidateNodes = [];
		
		if(!useNonXpath && _document.evaluate) { // supports dom 3 xpath
		
			var xpath = ".//" + (nodeType || "*") + "[contains(";
			if(classMatchType != this.classMatchType.ContainsAny){
				xpath += "concat(' ',@class,' '), ' " +
				classes.join(" ') and contains(concat(' ',@class,' '), ' ") +
				" ')";
				if (classMatchType == 2) {
					xpath += " and string-length(@class)="+srtLength+"]";
				}else{
					xpath += "]";
				}
			}else{
				xpath += "concat(' ',@class,' '), ' " +
				classes.join(" ') or contains(concat(' ',@class,' '), ' ") +
				" ')]";
			}
			var xpathResult = _document.evaluate(xpath, parent, null, XPathResult.ANY_TYPE, null);
			var result = xpathResult.iterateNext();
			while(result){
				try{
					candidateNodes.push(result);
					result = xpathResult.iterateNext();
				}catch(e){ break; }
			}
			return candidateNodes;	//	NodeList
		}else{
			if(!nodeType){
				nodeType = "*";
			}
			candidateNodes = parent.getElementsByTagName(nodeType);
			var node, i = 0;
			outer:
			while(node = candidateNodes[i++]){
				var nodeClasses = this.getClasses(node);
				if(nodeClasses.length == 0){ continue outer; }
				var matches = 0;
				for(var j = 0; j < nodeClasses.length; j++){
					if(reClass.test(nodeClasses[j])){
						if(classMatchType == this.classMatchType.ContainsAny){
							nodes.push(node);
							continue outer;
						}else{
							matches++;
						}
					}else{
						if(classMatchType == this.classMatchType.IsOnly){
							continue outer;
						}
					}
				}
		
				if(matches == classes.length){
					if(	(classMatchType == this.classMatchType.IsOnly)&&
						(matches == nodeClasses.length)){
						nodes.push(node);
					}else if(classMatchType == this.classMatchType.ContainsAll){
						nodes.push(node);
					}
				}
			}
			return nodes;	//	NodeList
		}
	}
});

com.ibm.mm.builder.htmlUtil = new com.ibm.mm.builder.mmHtmlUtils();


dojo.provide("com.ibm.mm.builder.dataViewerUtil");

com.ibm.mm.builder.dataViewerUtil.encodeCSVCell = function(cell){
	return com.ibm.mashups.data.Util.encodeCSVCell(cell);
}

com.ibm.mm.builder.dataViewerUtil.JSONObject2CSV = function(json){
	return com.ibm.mashups.data.Util.JSONObject2CSV(json);
}

com.ibm.mm.builder.dnd.MumManager = dojo.dnd.manager;
com.ibm.mm.builder.Topics.DnD_Drop = "/dnd/drop"

}

if(!dojo._hasResource["com.ibm.mm.builder.bootstrap"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.bootstrap"] = true;
/**
 * KickerPage class
 * @author Jarod (zhangpy@cn.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.bootstrap");
























dojo.declare("com.ibm.mm.builder.KickerPage",null, {
	
	/**
	 * when login, find first page
	 * 	- according to pid in location
	 *  - or first page of user's root directory
	 * load first page's theme
	 */
	initPage: function(){
		try {
			var fp = com.ibm.mm.builder.utils.navigationUtil.getFirstPageNode();
			if(fp){
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(fp.getID());
			}

			com.ibm.mm.builder.utils.themeUtil.loadTheme();
		} catch(e) {
			alert(dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_MAIN_LOAD_PAGE_FAIL_2,[e.name,e.message]));
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mashups.builder.ievent"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.ievent"] = true;
dojo.provide("com.ibm.mashups.builder.ievent");

/**
 * com.ibm.mashups.builder.iEvent defines all the public builder iEvents.<br/>
 * Usage: call com.ibm.mashups.builder.iEvents.SWITCH_PAGE to retreive the ievent name "com.ibm.mashups.builder.switchPage".<br/>
 * <br/>
 * 1. IEvent naming convention.<br/>
 * IEvent name such as <code>SWITCH_PAGE</code> and <code>PAGE_SWITCHED</code> followed the basic rules:<br/> 
 * (1) Verb + Noun:  the iEvent is broadcast before the action happen.<br/>
 * (2) Noun + Past Tense Verb:  the iEvent is broadcast after the action happen.<br/>
 * <br/>
 * 2. Terminology<br/>
 * (1) System iWidget: iWidget defined in theme.<br/>
 * (2) User iWidget: iWidget which user can add to a mashup page.<br/>
 * (3) Layout iWidget: a kind of system iWidget that manages user iWidget instances.<br/>
 * (4) None visible area: a kind of system iWidget that contains user iWidget instances in a hidden area.<br/>
 * (5) iWidget definition id: unique id of the iWidget metadata in enabler catalog API.<br/>
 * (6) iWidget instance id: unique id of the iWidget instance.<br/>
 * @ibm-api
 */

dojo.declare("com.ibm.mashups.builder.iEvent", null, {

	/**
	* <b>Description</b>: System iWidget should broadcast SWITCH_PAGE iEvent to switch to a given page.<br/>
	* Navigation iWidget must handle SWITCH_PAGE iEvent to switch page; 
	* after page is switched, iEvent <code>"com.ibm.mashups.builder.pageSwitched"</code> must be broadcast. <br/>
	* <b>Value</b>: "com.ibm.mashups.builder.switchPage"<br/>
	* <b>Payload</b>: id of page which will be switched to. Could be <code>null</code>. If null, Navigation iWidget will load current user's first page.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	SWITCH_PAGE: "com.ibm.mashups.builder.switchPage",
	
	/**
	* <b>Description</b>: Navigation iWidget must broadcast PAGE_SWITCHED iEvent after page is switched. <br/>
	* System iWidget can handle PAGE_SWITCHED iEvent to do follow-up work.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.pageSwitched"<br/>
	* <b>Payload</b>: id of page switched to. Could be <code>null</code> which means no page available for current user.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	PAGE_SWITCHED: "com.ibm.mashups.builder.pageSwitched",
	
	/**
	* <b>Description</b>: System iWidget should broadcast SWITCH_SPACE iEvent to switch to a given space.<br/>
	* SpaceSelector iWidget must handle SWITCH_PAGE iEvent to switch space.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.switchSpace"<br/>
	* <b>Payload</b>: id of space which will be switched to. Could be <code>null</code>. If null, SpaceSelector iWidget will switch to personal space.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	SWITCH_SPACE: "com.ibm.mashups.builder.switchSpace",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REFRESH_SPACE_SELECTOR iEvent to announce the space model has been changed.<br/>
	* SpaceSelector iWidget must handle REFRESH_SPACE_SELECTOR iEvent to retrieve the latest space model and re-render the UI.<br/>
	* For example, when user creates space within space manager, REFRESH_SPACE_SELECTOR iEvent must be broadcast to refresh Space Selector iWidget UI.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.refreshSpaceSelector"<br/>
	* <b>Payload</b>: id of space which title will be shown up in space selector. Could be <code>null</code>. If null, current space title will be used.<br/>
	* <b>Payload type</b>: text <br/> 
	* @type String
	*/
	REFRESH_SPACE_SELECTOR: "com.ibm.mashups.builder.refreshSpaceSelector",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REFRESH_NAVIGATION iEvent to announce the navigation model has been changed.<br/>
	* Navigation iWidget must handle REFRESH_NAVIGATION iEvent to retrieve the latest navigation model and re-render the UI.<br/>
	* For example, when user changes the page title, REFRESH_NAVIGATION iEvent must be broadcast to refresh Navigation iWidget UI.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.refreshNavigation"<br/>
	* <b>Payload</b>: N/A<br/> 
	* @type String
	*/
	REFRESH_NAVIGATION: "com.ibm.mashups.builder.refreshNavigation",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REFRESH_PALETTE iEvent to announce the catalog model has been changed.<br/>
	* Palette iWidget must handle this iEvent to retrieve the latest catalog model and re-render the UI.<br/>
	* For example, when a new iWidget is added to Palette, REFRESH_PALETTE iEvent must be broadcast to refresh Palette.<br/>
	* <b>Value</b>: "com.ibm.mashups.builder.refreshPalette"<br/>
	* <b>Payload</b>: N/A<br/> 
	* @type String
	*/
	REFRESH_PALETTE: "com.ibm.mashups.builder.refreshPalette",
	
	/**
	* <b>Description</b>: CHANGE_PAGE_MODE iEvent will be broadcast when page mode is changed. <br/>
	* System iWidgets can define CHANGE_PAGE_MODE iEvent as handled iEvent to update their UI accordingly. In current Lotus Mashups it only has 2 modes
	* ("view"/"edit"), but it's not limited to. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.changePageMode"<br/>
	* <b>Payload</b>: new page mode. Either "view" or "edit". Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/		
	CHANGE_PAGE_MODE: "com.ibm.mashups.builder.changePageMode",

	/**
	* <b>Deprecated</b>: ADD_WIDGET_FROM_TOOLBOX iEvent is replaced witch ADD_WIDGET.<br/>
	* <b>Description</b>: System iWidget can broadcast ADD_WIDGET_FROM_TOOLBOX iEvent to create a user iWidget instance.<br/>
	* Layout iWidget must define ADD_WIDGET_FROM_TOOLBOX iEvent as handled iEvent to create the user iWidget instance according to the payload<br/>
	* Base on the enabler CatalogModel API, system iWidget developer can get the user iWidget metadata according to user iWidget definition id.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.addWidgetFromToolbox"<br/>
	* <b>Payload</b>: this event could accept three kinds of payload.<br/>
	* &nbsp;-&nbsp;<b>Text</b>: It is the iWidget definition id. The definition id must a valid value in enabler CatalogModel API. Must not be <code>null</code>.<br/>. 
	* &nbsp;&nbsp;&nbsp;For example: "feedReader".<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition id and itemset as preference. The itemset enable developer set/change preference of widget instance during widget rendering.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{id: "feedReader", itemset: {feedUrl:"http://www.ibm.com/feed.rss"} }.<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition metadata and itemset as preference. The keys in widgetMetadata should be same as enabler API.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetMetadata: <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;id:"feedReader", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;definition:"/feedReader/feedReader.xml", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;icon: "/feedReader/feedreader.png", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;title:{en:"FeedReader", zh_CN:"yueduqi"},<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;onNewWire: "",<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetParam: "[]"<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;itemset: {feedURL:"http://www.ibm.com/feed.rss"} <br/>
	* &nbsp;&nbsp;&nbsp;}<br/>
	* <b>Payload type</b>: text or json<br/> 
	* @type String
	*/
	ADD_WIDGET_FROM_TOOLBOX: "com.ibm.mashups.builder.addWidgetFromToolbox",
	
	/**
	* <b>Description</b>: System iWidget can broadcast ADD_WIDGET iEvent to create a user iWidget instance.<br/>
	* Layout iWidget must define ADD_WIDGET iEvent as handled iEvent to create the user iWidget instance according to the payload<br/>
	* Base on the enabler CatalogModel API, system iWidget developer can get the user iWidget metadata according to user iWidget definition id.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.addWidget"<br/>
	* <b>Payload</b>: this event could accept three kinds of payload.<br/>
	* &nbsp;-&nbsp;<b>Text</b>: It is the iWidget definition id. The definition id must a valid value in enabler CatalogModel API. Must not be <code>null</code>.<br/>. 
	* &nbsp;&nbsp;&nbsp;For example: "feedReader".<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition id and itemset as preference. The itemset enable developer set/change preference of widget instance during widget rendering.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{id: "feedReader", itemset: {feedUrl:"http://www.ibm.com/feed.rss"} }.<br/>
	* &nbsp;-&nbsp;<b>Json Object</b>: It includes widget definition metadata and itemset as preference. The keys in widgetMetadata should be same as enabler API.<br/>
	* &nbsp;&nbsp;&nbsp;For example:<br/>
	* &nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetMetadata: <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;id:"feedReader", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;definition:"/feedReader/feedReader.xml", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;icon: "/feedReader/feedreader.png", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;title:{en:"FeedReader", zh_CN:"yueduqi"},<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;onNewWire: "",<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;widgetParam: "[]"<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;itemset: {feedURL:"http://www.ibm.com/feed.rss"} <br/>
	* &nbsp;&nbsp;&nbsp;}<br/>
	* <b>Payload type</b>: text or json<br/> 
	* @type String
	*/
	ADD_WIDGET: "com.ibm.mashups.builder.addWidget",
	
	/**
	* <b>Description</b>: RESET_STYLE iEvent is broadcast to recreate a empty style of layout iWidget.<br/> 
	* Layout iWidget can define RESET_STYLE iEvent as handled iEvent to recreate style of itself.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.resetStyle"<br/>
	* <b>Payload</b>: N/A<br/>
	* @type String
	*/	
	RESET_STYLE: "com.ibm.mashups.builder.resetStyle",

	/**
	* <b>Description</b>: DISPLAY_WIDGET iEvent is broadcast to move a user iWidget instance from none visible area to layout iWidgets.<br/> 
	* Layout iWidget must define DISPLAY_WIDGET iEvent as handled iEvent to show a user iWidget instance in itself.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.displayWidget"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	DISPLAY_WIDGET: "com.ibm.mashups.builder.displayWidget",

	/**
	* <b>Description</b>: HIDE_WIDGET iEvent is broadcast to move a user iWidget instance from layout iWidget to none visible area. <br/>
	* None visible area must define HIDE_WIDGET iEvent as handled iEvent to hide a user iWidget instance into itself.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.hideWidget"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	HIDE_WIDGET: "com.ibm.mashups.builder.hideWidget",

	/**
	* <b>Description</b>: RENAME_WIDGET iEvent is broadcast to rename a user iWidget instance. <br/>
	* Layout iWidget must define RENAME_WIDGET iEvent as handled iEvent to update the user iWidget instance name.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.renameWidget"<br/>
	* <b>Payload</b>: data of the updated user iWidget name. Must not be <code>null</code>. <br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;id: user iWidget instance id,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;name: new name of the user iWidget instance<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;locale(optional): locale of the name<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	RENAME_WIDGET: "com.ibm.mashups.builder.renameWidget",

	/**
	* <b>Description</b>: RENAME_ACTION iEvent is broadcast from iWidget context menu to inform another system iWidget to handle rename iWidget action. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.renameAction"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	RENAME_ACTION: "com.ibm.mashups.builder.renameAction",

	/**
	* <b>Description</b>: MOVE_ACTION iEvent is broadcast from iWidget context menu to inform another system iWidget to handle move iWidget action. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.moveAction"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	MOVE_ACTION: "com.ibm.mashups.builder.moveAction",
	
	/**
	* <b>Description</b>: RESIZE_ACTION iEvent is broadcast from iWidget context menu to inform another system iWidget to handle resize iWidget action. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.resizeAction"<br/>
	* <b>Payload</b>: user iWidget instance id. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	RESIZE_ACTION: "com.ibm.mashups.builder.resizeAction",
	
	/**
	* <b>Description</b>: CHANGE_SKIN iEvent is broadcast to change the skin of a user iWidget instance. <br/>
	* Layout iWidget must define CHANGE_SKIN iEvent as handled iEvent to update the skin of user iWidget instance. <br/>
	* Enabler ThemeModel will provide all the Skin available in current theme. Builder runtime model API will provide current theme Id. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.changeSkin"<br/>
	* <b>Payload</b>: user iWidget instance and the new skin id. The new skin id must be a valid skin id in enabler ThemeModel api.
	* Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;id: user iWidget instance id<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;skin: new skin name<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	CHANGE_SKIN: "com.ibm.mashups.builder.changeSkin",

	/**
	* <b>Description</b>: Mashup skin service broadcasts SKIN_LOADED iEvent when skin is loaded. <br/>
	* Layout iWidget could define SKIN_LOADED iEvent as handled iEvent if it needs to
	* initialize some additional handlers in user iWidget skin, such as drag and drop handler, resize handler. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.skinLoaded"<br/>
	* <b>Payload</b>: skin parameters. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: user iWidget instance id,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;skinNodeId: user iWidget skin node,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;skinParam: skin parameters defined in skin.js in the skin resource directory, json<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	SKIN_LOADED: "com.ibm.mashups.builder.skinLoaded",

	/**
	* <b>Description</b>: RESIZE_WIDGET iEvent should be broadcast to adjust the width or height of user iWidget instance. <br/>
	* Layout iWidget can define RESIZE_WIDGET iEvent as handled iEvent to update the size of user iWidget instance. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.resizeWidget"<br/>
	* <b>Payload</b>: size of user iWidget instance. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: id of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;width: new width of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;height: new height of user iWidget instance<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	RESIZE_WIDGET: "com.ibm.mashups.builder.resizeWidget",

	/**
	* <b>Description</b>: WIDGET_RESIZED iEvent should be broadcast after the size of user iWidget instance is changed. <br/>
	* User iWidget can define WIDGET_RESIZED iEvent as handled iEvent to do some follow up work if necessary. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.widgetResized"<br/>
	* <b>Payload</b>: size of user iWidget instance. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: id of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;width: new width of user iWidget instance,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;height: new height of user iWidget instance<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	WIDGET_RESIZED: "com.ibm.mashups.builder.widgetResized",	

	/**
	* <b>Description</b>: System iWidget should broadcast EMBED_PAGE iEvent to embed a mashup page. <br/>
	* System iWidget (e.g EmbedPage) can define EMBED_PAGE iEvent as handled iEvent to accept to create the embedding UI for the page. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.embedPage"<br/>
	* <b>Payload</b>: page id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	EMBED_PAGE: "com.ibm.mashups.builder.embedPage",

	/**
	* <b>Description</b>: System iWidget broadcasts EMBED_WIDGET iEvent to embed a user iWidget. <br/>
	* System iWidget (e.g EmbedWidget) can define EMBED_WIDGET iEvent as handled iEvent to create the embedding UI for the user iWidget. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.embedWidget"<br/>
	* <b>Payload</b>: user iWidget definition id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	EMBED_WIDGET: "com.ibm.mashups.builder.embedWidget",
	
	/**
	* <b>Description</b>: System iWidget broadcasts LOAD_PAGESOURCE iEvent to load the page source. <br/>
	* System iWidget (e.g PageSource) can define LOAD_PAGESOURCE iEvent as handled iEvent to load the mashup page user iWidget markups into its source container. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.loadPageSource"<br/>
	* <b>Payload</b>: N/A<br/> 
	* @type String
	*/
	LOAD_PAGESOURCE: "com.ibm.mashups.builder.loadPageSource",

	/**
	* <b>Description</b>: System iWidget broadcasts SAVE_PAGE iEvent to save page source. <br/>
	* System iWidget (e.g PageSource) must define SAVE_PAGE iEvent as handled iEvent to persist the user iWidget markups in current page.<br/>
	* System iWidget developer can call enabler Navigation Model API to persist current page. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.savePage"<br/>
	* <b>Payload</b>: page id. Must not be <code>null</code>. <br/> 
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	SAVE_PAGE: "com.ibm.mashups.builder.savePage",

	/**
	* <b>Description</b>: System iWidget broadcasts EDIT_PAGE iEvent to load page property. <br/>
	* System iWidget (e.g PagePropertyEditor) can define EDIT_PAGE iEvent as handled iEvent to load the page properties, for example, page theme and page title. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.editPage"<br/>
	* <b>Payload</b>: page id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	EDIT_PAGE: "com.ibm.mashups.builder.editPage",

	/**
	* <b>Description</b>: System iWidget broadcasts UPDATE_PAGE_TITLE iEvent to update page title. <br/>
	* System iWidget (e.g PageTitle) can define UPDATE_PAGE_TITLE iEvent as handled iEvent to update the title in its displaying area. <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.updatePageTitle"<br/>
	* <b>Payload</b>: page title. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;title: page title,<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;locale(optional): locale of the title<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	UPDATE_PAGE_TITLE: "com.ibm.mashups.builder.updatePageTitle",
	
	/**
	* <b>Description</b>: System iWidgets broadcasts HIGHLIGHT_WIDGET iEvent to make Layout iWidget highlight a specific user iWidget.<br/>
	* Layout iWidget should define HIGHLIGHT_WIDGET iEvent as handled iEvent in case it wants to highlight a user iWidget instance.  <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.highlightWidget"<br/>
	* <b>Payload</b>: id of user iWidget instance. Must not be <code>null</code>. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	HIGHLIGHT_WIDGET: "com.ibm.mashups.builder.highlightWidget",
	
	/**
	* <b>Description</b>: System iWidgets broadcasts REMOVE_WIDGET_HIGHTLIGHT iEvent to make Layout iWidget remove highlight of a specific user iWidget.<br/>
	* Layout iWidget should define REMOVE_WIDGET_HIGHTLIGHT iEvent as handled iEvent in case it wants to remove the highlight on a user iWidget instance.  <br/>
    * <b>Value</b>: "com.ibm.mashups.builder.removeWidgetHighlight"<br/>
	* <b>Payload</b>: id of user iWidget instance. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	REMOVE_WIDGET_HIGHTLIGHT: "com.ibm.mashups.builder.removeWidgetHighlight",
	
	/**
	* <b>Description</b>: System iWidget broadcasts ADD_NEW_WIRE iEvent to inform layout iWidget to add a new wire. <br/>
	* Layout iWidget must define ADD_NEW_WIRE iEvent as handled iEvent, update the iWidget markup to add the new wire.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.addNewWire"<br/>
	* <b>Payload</b>: context information used to create new wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceEvent: published event name of the source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetEvent: handled event name of the target iWidget<br/>
	* } <br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	ADD_NEW_WIRE: "com.ibm.mashups.builder.addNewWire",
	
	/**
	* <b>Description</b>: System iWidget broadcasts REMOVE_NEW_WIRE iEvent to inform layout iWidget to remove an existing wire.<br/>
	* Layout iWidget must define REMOVE_NEW_WIRE iEvent as handled iEvent, update the iWidget markup to remove the wire.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.removeWire"<br/>
	* <b>Payload</b>: context information used to remove the wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceEvent: published event name of the source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetEvent: handled event name of the target iWidget<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/	
	REMOVE_WIRE: "com.ibm.mashups.builder.removeWire",
	
	/**
	* <b>Description</b>: CREATE_AUTO_WIRE iEvent can be broadcast to add auto wire between the specified widget with other iWidget instances on the page. <br/>
	* Auto wire: Auto wire happens when<br/>
	* 1. Auto-wiring is enabled for the page;<br/>
	* 2. Specified iWidget is auto-wiring enabled;<br/>
	* 3. The wired-to iWidget is auto-wiring enabled;<br/>
	* 4. Wire the specified iWidget's iEvent to other iWidget's iEvent when the two iEvent have exactly same event name and payload type.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createAutoWire"<br/>
	* <b>Payload</b>: iWidget instance id. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	CREATE_AUTO_WIRE: "com.ibm.mashups.builder.createAutoWire",
	
	/**
	* <b>Description</b>: AUTO_WIRE_CREATED iEvent will be broadcast to after a auto wire is added between two iWidget instances. <br/>
	* Auto wire: refer to the iEvent CREATE_AUTO_WIRE.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.autoWireCreated"<br/>
	* <b>Payload</b>: Created auto-wires information. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: instance id of the new added iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;publishTo: Array, contains all instance id of the widgets which the new added iWidget is wired with as source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;receiveFrom: Array, contains all instance id of the widgets which the new added iWidget is wired with as target iWidget<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	AUTO_WIRE_CREATED: "com.ibm.mashups.builder.autoWireCreated",
	
	/**
	* <b>Description</b>: CREATE_QUICK_WIRE iEvent can be broadcast to add a wire between two iWidget instances automatically. <br/>
	* Quick wire: Check the two iWidget's first iEvent, if they can be wired together(payload type is compatible), wire them. 
	* QUICK_WIRE_CREATED iEvent must be broadcast after the wire is created<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createQuickWire"<br/>
	* <b>Payload</b>: context information used to add the wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* }<br/>
	* 
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	CREATE_QUICK_WIRE: "com.ibm.mashups.builder.createquickWire",
	
	/**
	* <b>Description</b>: QUICK_WIRE_CREATED iEvent will be broadcast to after a quick wire is added between two iWidget instances. <br/>
	* Quick wire: refer to the iEvent CREATE_QUICK_WIRE.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.quickWireCreated"<br/>
	* <b>Payload</b>: context information of the added wire. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;sourceWidgetId: id of the wire's source iWidget<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetWidgetId: id of the wire's target iWidget<br/>
	* }<br/>
	* 
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	QUICK_WIRE_CREATED: "com.ibm.mashups.builder.quickWireCreated",
	
	/**
	* <b>Description</b>: EDIT_WIRE iEvent can be broadcast to launch the wiring interface of a iWidget instance.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.editWire"<br/>
	* <b>Payload</b>: id of the user iWidget instance. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	EDIT_WIRE: "com.ibm.mashups.builder.editWire",
	
	/**
	* <b>Description</b>: DISPLAY_WIRE_GRAPH iEvent can be broadcast to display the wire graph of a iWidget instance.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.displayWireGraph"<br/>
	* <b>Payload</b>: id of the user iWidget instance. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/	
	DISPLAY_WIRE_GRAPH: "com.ibm.mashups.builder.displayWireGraph",
	
	/**
	* <b>Description</b>: System iWidget broadcasts SHARE_PAGE iEvent to notice other iWidgets to start the sharing work.
	* System iWidget (e.g SharePage iWidget) which implements the sharing function should define this iEvent as handled iEvent<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.sharePage"<br/>
	* <b>Payload</b>: id of the shared page. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	SHARE_PAGE: "com.ibm.mashups.builder.sharePage",

	/**
	* <b>Description</b>: System iWidget broadcasts SHARE_SPACE iEvent to notice other iWidgets to start the sharing work.
	* System iWidget (e.g SharePage iWidget) which implements the sharing function should define this iEvent as handled iEvent<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.shareSpace"<br/>
	* <b>Payload</b>: id of the shared space. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	SHARE_SPACE: "com.ibm.mashups.builder.shareSpace",

	/**
	* <b>Description</b>: System iWidget broadcasts PUBLISH_PAGE iEvent to notice other iWidgets to start the publishing page work.
	* System iWidget (e.g PublishPage iWidget) which implements the publish function must define this iEvent as handled iEvent<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.publishPage"<br/>
	* <b>Payload</b>: id of the published page. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	PUBLISH_PAGE: "com.ibm.mashups.builder.publishPage",
	
	/**
	* <b>Description</b>: System iWidget broadcasts VIEW_MORE_PAGE iEvent to notice other iWidgets it wants to accept pages from other users.
	* System iWidget (e.g viewMorePage iWidget) which implements that function should define this iEvent as handled iEvent.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.viewMorePage"<br/>
	* <b>Payload</b>: N/A<br/>
	* @type String
	*/
	VIEW_MORE_PAGE: "com.ibm.mashups.builder.viewMorePage",
	
	/**
	* <b>Description</b>: DISPLAY_IN_MASHUP_DIALOG iEvent can be broadcast to display system iWidget in a configurable mashup dialog.<br/>
	* The system iWidget need to be linked to a type id in "dialogDisplayer" iWidget's itemset. <br/>
	* Current supported type id: 
	* <ul>
	* 	<li>sharePage</li>
	*   <li>publishPage</li>
	*   <li>viewMorePage</li>
	*   <li>renameWidget</li>
	*   <li>wireInteface</li>
	*   <li>pageSource</li>
	*   <li>embedPage</li>
	*   <li>embedWidget</li>
	*   <li>editPage</li>
	*   <li>hiddenWidgetCorral</li>
	*   <li>editSpace</li>
	*   <li>spaceManager</li>
	*   <li>createPage</li>
	*   <li>createSpace</li>
	*   <li>copySpace</li>
	*   <li>changeSpaceOwnerWidget</li>
	*   
	* </ul>
    * <b>Value</b>: "com.ibm.mashups.builder.displayInMashupDialog"<br/>
	* <b>Payload</b>: <br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetTypeId: type id. Must not be <code>null</code>.<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventName(optional): name of the iEvent of target iWidget which will be invoked <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventPayloa(optional): payload which will be passed to the handled iEvent<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;dialogParam(optional): parameters used to configure the dialog<br/>
	* }<br/>
	* Example: show wire interface iWidget in a dialog:<br/>
	* We have below definition in theme.html. <br/>
	* &lt;div class="mm_iWidget" id="dialogDisplayer"> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&lt;a class="mm_Definition" href="/mum/widget-catalog/displayHelper.xml">&lt;/a> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&lt;span class="mm_ItemSet" title="attributes" style="visibility: hidden; display: none;"> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;a class="mm_Item" style="visibility: hidden; display: none;" href="#wireInterface">wireInterface&lt;/a> <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;....... <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&lt;/span><br/>
	* &lt;/div> <br/>
	* Call following javascript code to display wire iWidget in dialog and invoke <code>EDIT_WIRE<code> iEvent.<br/>
	* var dialogParam = <br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;nodeWidth: "486px", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;...... <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;displayCloseButton: false, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;hasRightBottomResizer: false <br/>
	* } <br/>
	* var payload = <br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetTypeId: "pageSoure", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventName:  "com.ibm.mashups.builder.loadPageSource", <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventPayload:  ..., <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;dialogParam:  dialogParam <br/>
	* }<br/>
	* var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService"); <br/>
	* eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	DISPLAY_IN_MASHUP_DIALOG: "com.ibm.mashups.builder.displayInMashupDialog",
	
	/**
	* <b>Description</b>: CLOSE_MASHUP_DIALOG iEvent can be broadcast with a system iWidget id. 
	* If that system iWidget is displayed in a mashup dialog, then the dialog will be closed.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.closeMashupDialog"<br/>
	* <b>Payload</b>: id of the system iWidget instance which is displayed in the mashup style dialog. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
	CLOSE_MASHUP_DIALOG: "com.ibm.mashups.builder.closeMashupDialog",
		
	/**
	* <b>Description</b>: STATE_CHANGED iEvent can be broadcast to change the widget's state, restore/max/min the current widget by layout widget.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.stateChanged"<br/>
	* <b>Payload</b>: id of the iWidget instance, and widget's state. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;widgetId: iwidgetId, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;state:  "max"/"min"/"normal" <br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
	STATE_CHANGED: "com.ibm.mashups.builder.stateChanged",
	
	/**
	* <b>Description</b>: Broadcast OPEN_PAGE iEvent to open a given page and optionally broadcast widget events to it.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.openPage"<br/>
	* <b>Payload</b>: This event can accept two kinds of payload, id of the page to be opened or a json object in the follow format. Must not be <code>null</code>.<br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;pid: id of the page to be opened<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;eventsArray: an array of events to be broadcast to the widgets on the page<br/>
	* }<br/>
	* The "eventsArray" should include one or more event objects in this format <br/>
	* { <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;targetEvent: targetEvent<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;payload: payload<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;payloadType: payloadType<br/>
	* }<br/>
	* <b>Payload type</b>: text or json<br/>
	* @type String
	*/
	OPEN_PAGE:"com.ibm.mashups.builder.openPage",
	
	/**
	* <b>Description</b>: Broadcast CLOSE_PAGE iEvent to close a given page that was opened using the OPEN_PAGE iEvent. If CLOSE_PAGE is broadcast multiple times, 
	* the actual close page action only happen once.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.closePage"<br/>
	* <b>Payload</b>: id of the page to be closed. <br/>
	* <b>Payload type</b>: text<br/> 
	* @type String
	*/
    CLOSE_PAGE:"com.ibm.mashups.builder.closePage",
	
	/**
	* <b>Description</b>: System iWidget broadcasts CREATE_PAGE iEvent to initiate Create Page widget, which allows to create a new page.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createPage"<br/>
	* <b>Payload</b>: <code>spaceId</code> refers to under which space new page will be created, <code>parentPageId</code> refers to new page's parent page. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;spaceId: space id, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;parentPageId: parent page id<br/>
	* }<br/>	
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
    CREATE_PAGE:"com.ibm.mashups.builder.createPage",

	/**
	* <b>Description</b>: System iWidget broadcasts CREATE_SPACE iEvent to initiate Create Space widget, which allows to create a new space.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.createSpace"<br/>
	* <b>Payload</b>: <code>createSpaceFromSpaceManager</code> should be set as <code>true</code> if CREATE_SPACE is broadcast inside Space Manager, otherwise <code>false</code>. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;createSpaceFromSpaceManager: a boolean value to indicate whether the create space action is launched from space manager<br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
    CREATE_SPACE:"com.ibm.mashups.builder.createSpace",

	/**
	* <b>Description</b>: System iWidget broadcasts EDIT_SPACE iEvent to initiate Edit Space widget, which allows to edit existing space.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.editSpace"<br/>
	* <b>Payload</b>: id of space to be edited. Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/>
	* @type String	
	*/
    EDIT_SPACE:"com.ibm.mashups.builder.editSpace",

	/**
	* <b>Description</b>: System iWidget broadcasts COPY_SPACE iEvent to initiate Copy Space widget, which allows to clone given space.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.copySpace"<br/>
	* <b>Payload</b>: <code>spaceId</code> is the id of space to be cloned, and <code>copySpaceInSpaceManager</code> should be set as <code>true</code> if COPY_SPACE is broadcast inside Space Manager, otherwise <code>false</code>. Must not be <code>null</code>.<br/>
	* {<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;spaceId: id of the space, <br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;copySpaceInSpaceManager: a boolean value to indicate whether the copy space action is launched from space manager <br/>
	* }<br/>
	* <b>Payload type</b>: json<br/> 
	* @type String
	*/
    COPY_SPACE:"com.ibm.mashups.builder.copySpace",		
	
	/**
	* <b>Description</b>: System iWidget broadcasts CHANGE_SPACE_OWNER iEvent to initiate Change Space Owner widget, which allows to change space owner. After space owner is changed, two dojo events will be published:<br/>
	* <code>dojo.publish("com.ibm.mm.builder.spaceEditorWidget.OwnerName", [username]);</code><br/>
	* <code>dojo.publish("com.ibm.mm.builder.spaceEditorWidget.OwnerId", [userid]);</code><br/>
	* These two dojo events should be subscribed to get new owner id and owner name.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.changeSpaceOwner"<br/>
	* <b>Payload</b>: original space owner id, Must not be <code>null</code>.<br/>
	* <b>Payload type</b>: text<br/>
	* @type String
	*/
    CHANGE_SPACE_OWNER:"com.ibm.mashups.builder.changeSpaceOwner",
	
	/**
	* <b>Description</b>: System iWidget broadcasts MANAGE_SPACES iEvent to initiate Space Manager widget, which allows to manage spaces.<br/>
    * <b>Value</b>: "com.ibm.mashups.builder.manageSpaces"<br/>
	* <b>Payload</b>: N/A<br/>
	* @type String
	*/
    MANAGE_SPACES:"com.ibm.mashups.builder.manageSpaces"	
});

com.ibm.mashups.builder.iEvents = new com.ibm.mashups.builder.iEvent();

}

